import java.util.Vector;

public class JDPAlphaSender {
   JDPUser user;
   // $FF: renamed from: s JDPSaveProps
   JDPSaveProps field_0;
   JDPJagg jaggSQL;
   Vector messageVector;
   static final String[] serviceProviders = new String[]{"AirNote", "AirTouch", "AirTouch Northern CA", "Ameritech", "AT&T Wireless", "MobilComm-MobilMedia", "PageMart", "PageMart(Roam)", "PageNet", "SWiMS", "SkyTel", "SkyTel Two-Way Paging", "Sprint Spectrum"};
   static final String[] serviceProviderNumbers = new String[]{"18007208398", "18007934549", "18006625742", "18006777454", "18004459511", "18009464644", "18008649499", "18003244533", "18007208398", "18007913090", "18007596366", "18006792778", "18002726505"};

   public void setServiceProvider(String var1) {
      this.field_0.saveObject("serviceProvider", var1);
   }

   public String getServiceProviderNumber(String var1) {
      for(int var2 = 0; var2 < serviceProviders.length; ++var2) {
         if (serviceProviders[var2].equals(var1)) {
            return serviceProviderNumbers[var2];
         }
      }

      return "";
   }

   public void setPWD(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setPWD(var1);
   }

   public void setCommPort(int var1) {
      this.field_0.saveObject("commPort", var1);
   }

   public void setJdbcPrefix(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setJdbcPrefix(var1);
   }

   public JDPAlphaSender(JDPUser var1) {
      this.user = var1;
      this.field_0 = new JDPSaveProps(var1);
   }

   public JDPAlphaSender(JDPUser var1, JDPJagg var2) {
      this.user = var1;
      this.jaggSQL = var2;
      this.field_0 = new JDPSaveProps(var1);
   }

   public void setMessage(String var1) {
      this.field_0.saveObject("message", var1);
   }

   public void setFromWhereClause(String var1) {
      this.field_0.saveObject("whereClause", var1);
   }

   public void sendSingleMessage() {
      this.field_0.saveObject("messageFunction", "sendSingleAlphaPage");
      new JDPSubmitJob(this.user, this.jaggSQL, "JDPMessageSvr", this.field_0, (Object)null);
      this.user.mainmsg.setStatusMsg("Paging job submitted.", 5);
   }

   public void setSQL(String var1) {
      this.field_0.saveObject("SQL", var1);
   }

   public void sendMultipleMessage() {
      this.field_0.saveObject("messageFunction", "sendBulkAlphaPage");
      if (this.jaggSQL != null) {
         new JDPSubmitJob(this.user, this.jaggSQL, "JDPMessageSvr", this.field_0, (Object)null);
         this.user.mainmsg.setStatusMsg("Alpha Paging job submitted", 5);
      } else {
         this.user.mainmsg.setStatusMsg("Cannot submit Paging job. Jagg instance is null", 15);
      }
   }

   public void setBaudRate(int var1) {
      this.field_0.saveObject("baudRate", var1);
   }

   public void setPagerPINNumber(String var1) {
      this.field_0.saveObject("pagerPINNumber", var1);
   }

   public void setJdbcDriver(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setJdbcDriver(var1);
   }

   public void setCSTR(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setCSTR(var1);
   }

   public void setUID(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setUID(var1);
   }

   public void addMessage(String var1, String var2, String var3) {
      if (this.messageVector == null) {
         this.messageVector = new Vector();
      }

      String[] var4 = new String[]{var1, var2, var3};
      this.messageVector.addElement(var4);
   }

   public void setMergeColumns(String[] var1) {
      this.field_0.saveObject("columns", var1);
   }

   public void sendLoadedMessages() {
      this.unloadMessageArray();
      this.field_0.saveObject("messageFunction", "sendLoadedAlphaPages");
      new JDPSubmitJob(this.user, this.jaggSQL, "JDPMessageSvr", this.field_0, (Object)null);
      this.user.mainmsg.setStatusMsg("Paging job submitted.", 5);
   }

   void unloadMessageArray() {
      // $FF: Couldn't be decompiled
   }

   public String[] getServiceProviders() {
      return serviceProviders;
   }

   public void setDSN(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setDSN(var1);
   }

   public void setJdbcSuffix(String var1) {
      if (this.jaggSQL == null) {
         this.jaggSQL = new JDPJagg(this.user.jaggPath);
      }

      this.jaggSQL.setJdbcSuffix(var1);
   }
}
