import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.PrintJob;
import java.awt.Rectangle;
import java.awt.Scrollbar;
import java.awt.image.ImageObserver;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;
import java.util.Date;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPBrowser extends JDPClassLayout {
   Dimension Bounds;
   static boolean activated;
   Vector byteLine;
   boolean centerOff;
   int currXpos;
   int currYpos;
   String currentDoc;
   int currentFontLevel;
   int currentLevel;
   boolean displayErrors = true;
   String docName;
   Vector docTags;
   byte[] docText;
   boolean dropEvent;
   // $FF: renamed from: fm java.awt.FontMetrics
   FontMetrics field_0;
   // $FF: renamed from: gr java.awt.Graphics
   Graphics field_1;
   Vector imageArray;
   int imageBottomPos;
   Vector imageLocArray;
   int indent;
   int[] intArray;
   int ipos;
   String[] keyWords;
   Vector lastDoc;
   String lastDocPath;
   Vector lastDocPos;
   Vector lastFont;
   int lastYpos;
   long lastredraw;
   int lineCount;
   int[] lineWidths;
   Vector linkDoc;
   Vector linkPos;
   Vector links;
   boolean matchCompleteWords = true;
   int maxWidth;
   Image offscreen;
   Rectangle offscreensize;
   Font preFont;
   int rightBlockIndent;
   int rightIndent;
   Color saveColor;
   Font[] saveFont;
   Scrollbar scrollEast;
   String tString;
   char thisChar;
   int thisLength;
   String thisString;
   JDPHtmlTag thisTag;
   JDPHtmlTagRef thisTagRef;
   Date timenow;
   int totalImages;
   int totalLinks;
   int[] widths;
   String wwwPath;
   int defaultFontSize = 14;
   Color textHighlightText;
   Color textHighlight;
   Dimension paintDimension;

   public void paint(Graphics var1) {
      this.update(var1);
   }

   public void printPages() {
      PrintJob var1 = ((Component)this).getToolkit().getPrintJob(super.user.jdpMainWindow, "JDP Help Print", (Properties)null);
      if (var1 != null) {
         Dimension var2 = var1.getPageDimension();
         var2 = new Dimension(780, 1015);
         this.setDimension(var2);
         int var4 = this.lastYpos;
         this.lastYpos = 0;

         for(this.currYpos = 1; this.currYpos > this.lastYpos; this.lastYpos += var2.height - 15) {
            Graphics var3 = var1.getGraphics();
            this.update(var3);
            var3.dispose();
         }

         this.setDimension((Dimension)null);
         var1.end();
         this.lastYpos = var4;
         ((Component)this).repaint();
      }

   }

   public String getFullDocname() {
      return this.currentDoc;
   }

   public boolean setFullDocname(String var1) {
      return this.setDocname(var1);
   }

   public void setFontSize(int var1) {
      this.defaultFontSize = var1;
      ((Component)this).setFont(new Font("TimesRoman", 0, this.defaultFontSize));
      this.lastFont.setElementAt(((Component)this).getFont(), 0);
      ((Component)this).repaint();
   }

   public int getFontSize() {
      return this.defaultFontSize;
   }

   public void setKeywords(String[] var1) {
      this.keyWords = var1;
   }

   public Dimension minimumSize() {
      Dimension var1 = new Dimension(10, 10);
      return var1;
   }

   public void update(Graphics var1) {
      Rectangle var2 = ((Component)this).bounds();
      this.Bounds = ((Component)this).size();
      if (this.paintDimension != null) {
         var2.width = this.paintDimension.width;
         var2.height = this.paintDimension.height;
         this.Bounds.width = this.paintDimension.width;
         this.Bounds.height = this.paintDimension.height;
      }

      if (this.offscreen == null || var2.width != this.offscreensize.width || var2.height != this.offscreensize.height) {
         try {
            if (var2.width < 10) {
               var2.width = 10;
            }

            if (var2.height < 10) {
               var2.height = 10;
            }

            this.offscreen = ((Component)this).createImage(var2.width, var2.height);
         } catch (Exception var39) {
            return;
         }

         this.offscreensize = var2;
         if (this.offscreen == null) {
            return;
         }

         this.field_1 = this.offscreen.getGraphics();
         this.field_1.setFont(((Component)this).getFont());
      }

      Color var3 = ((Component)this).getBackground();
      this.field_1.setFont((Font)this.lastFont.elementAt(0));
      this.field_0 = this.field_1.getFontMetrics();
      this.indent = 8;
      byte var4 = 25;
      int var5 = this.field_0.getHeight() - 1;
      this.rightIndent = 0;
      this.rightBlockIndent = 0;
      int var6 = var5;
      if (this.lastYpos < 0) {
         this.lastYpos = 0;
      }

      this.currYpos = 5 - this.lastYpos + var5;
      int var7 = 0;
      int var8 = -this.lastYpos;
      this.currXpos = 8;
      this.field_1.setColor(var3);
      this.field_1.fillRect(0, 0, var2.width, var2.height);
      this.field_1.setColor(Color.black);
      this.widths = this.field_0.getWidths();
      this.centerOff = true;
      boolean var9 = false;
      boolean var10 = true;
      byte var11 = 5;
      if (this.scrollEast != null && this.scrollEast.isVisible()) {
         var11 = 15;
      }

      this.maxWidth = this.Bounds.width - var11 - this.indent;
      int var12 = 0;
      int[] var13 = new int[20];
      int[] var14 = new int[20];
      Color var15 = Color.black;
      Color var16 = Color.blue;
      Color var17 = Color.magenta;
      Color var18 = Color.yellow;
      this.links = new Vector(300, 300);
      this.linkDoc = new Vector(300, 300);
      this.linkPos = new Vector(300, 300);
      this.totalLinks = 0;
      this.totalImages = 0;
      boolean var19 = true;
      boolean var20 = false;
      int var21 = 0;
      boolean var22 = false;
      this.imageBottomPos = 0;
      short var23 = 32;
      if (this.docTags == null) {
         if (this.scrollEast != null) {
            this.scrollEast.hide();
         }

         this.field_1.setColor(Color.black);
      } else {
         for(int var24 = 0; var24 < this.docTags.size(); ++var24) {
            this.thisTagRef = (JDPHtmlTagRef)this.docTags.elementAt(var24);
            this.thisTag = this.thisTagRef.tag;
            if (this.thisTag.id != 44) {
               this.thisString = new String(this.docText, 0, var7, this.thisTagRef.pos - var7);
               if (this.currYpos > -var2.height) {
                  var22 = true;
               }

               if (this.currYpos > var2.height + this.lastYpos) {
                  var22 = false;
               }

               if (this.currXpos < 8 || this.indent < 8) {
                  this.indent = 8;
                  this.currXpos = 8;
               }

               if (var20) {
                  this.field_1.setFont(this.preFont);
                  this.field_0 = this.field_1.getFontMetrics();
                  int var25 = super.user.u.StringWidth(this.field_1, " ");
                  var5 = this.field_0.getHeight();
                  StringTokenizer var26 = new StringTokenizer(this.thisString, "\n\t", true);

                  while(var26.hasMoreTokens()) {
                     this.tString = var26.nextToken();
                     if (this.tString.equals("\n")) {
                        this.currXpos = 8;
                        this.currYpos += var5;
                     } else if (this.tString.equals("\t")) {
                        this.currXpos += 4 * var25;
                     } else {
                        if (var22) {
                           var12 = super.user.u.StringWidth(this.field_1, this.tString);
                           if (!this.isKeyword(this.tString)) {
                              this.field_1.drawString(this.tString, this.currXpos, this.currYpos);
                           } else {
                              this.saveColor = this.field_1.getColor();
                              this.field_1.setColor(this.textHighlight);
                              this.field_1.fillRect(this.currXpos, this.currYpos - var5 + 5, var12, var5);
                              this.field_1.setColor(this.textHighlightText);
                              this.field_1.drawString(this.tString, this.currXpos, this.currYpos);
                              this.field_1.setColor(this.saveColor);
                           }

                           if (var9) {
                              this.links.addElement(new Rectangle());
                              ((Rectangle)this.links.elementAt(this.totalLinks++)).reshape(this.currXpos, this.currYpos - var5 + 3, var12, var5);
                              this.linkDoc.addElement(this.linkDoc.elementAt(this.totalLinks - 1));
                              if (this.field_1.getFont().isBold()) {
                                 this.field_1.drawLine(this.currXpos, this.currYpos + 2, this.currXpos + var12, this.currYpos + 2);
                              }

                              this.field_1.drawLine(this.currXpos, this.currYpos + 1, this.currXpos + var12, this.currYpos + 1);
                           }
                        }

                        this.currXpos += var12;
                     }
                  }

                  this.field_1.setFont((Font)this.lastFont.elementAt(this.currentFontLevel));
                  this.field_0 = this.field_1.getFontMetrics();
                  var5 = this.field_0.getHeight();
               } else {
                  var12 = this.bytesWidth(this.docText, var7, this.thisTagRef.pos - var7);
                  if (!this.centerOff && var21 != 0) {
                     this.currXpos = (this.maxWidth - var21) / 2;
                     if (this.currXpos < this.indent) {
                        this.currXpos = this.indent;
                     }
                  }

                  if (var10 && this.thisTagRef.pos > var7) {
                     if (this.field_0.getHeight() != var5 && var19) {
                        this.currYpos = this.currYpos + (int)(0.6 * (double)this.field_0.getHeight()) - var5;
                     }

                     var19 = false;
                     var5 = this.field_0.getHeight();

                     for(int var42 = 0; var42 <= this.lineCount; ++var42) {
                        if (var22) {
                           this.tString = (String)this.byteLine.elementAt(var42);
                           if (!this.isKeyword(this.tString)) {
                              this.field_1.drawString(this.tString, this.currXpos, this.currYpos);
                           } else {
                              this.saveColor = this.field_1.getColor();
                              this.field_1.setColor(this.textHighlight);
                              this.field_1.fillRect(this.currXpos, this.currYpos - var5 + 5, this.lineWidths[var42], var5);
                              this.field_1.setColor(this.textHighlightText);
                              this.field_1.drawString(this.tString, this.currXpos, this.currYpos);
                              this.field_1.setColor(this.saveColor);
                           }

                           if (var9) {
                              this.links.addElement(new Rectangle());
                              ((Rectangle)this.links.elementAt(this.totalLinks++)).reshape(this.currXpos, this.currYpos - var5 + 3, this.lineWidths[var42], var5);
                              this.linkDoc.addElement(this.linkDoc.elementAt(this.totalLinks - 1));
                              if (this.field_1.getFont().isBold()) {
                                 this.field_1.drawLine(this.currXpos, this.currYpos + 2, this.currXpos + this.lineWidths[var42], this.currYpos + 2);
                              }

                              this.field_1.drawLine(this.currXpos, this.currYpos + 1, this.currXpos + this.lineWidths[var42], this.currYpos + 1);
                           }
                        }

                        if (var42 < this.lineCount) {
                           this.currYpos += var5;
                           this.currXpos = this.indent;
                        }
                     }

                     var8 = this.currYpos + var6;
                     this.currXpos += var12;
                  }
               }

               var21 = 0;
               var7 = this.thisTagRef.pos;
               switch (this.thisTag.id) {
                  case 1:
                     if (!this.thisTagRef.isEnd) {
                        if (this.thisTagRef.getAttribute("href") != null) {
                           this.field_1.setColor(var16);
                           var9 = true;
                           if (this.linkDoc.size() > this.totalLinks) {
                              this.linkDoc.setElementAt(this.thisTagRef.getAttribute("href"), this.totalLinks);
                           } else {
                              this.linkDoc.addElement(this.thisTagRef.getAttribute("href"));
                           }
                        }

                        if (this.thisTagRef.getAttribute("name") != null) {
                           Vector var58 = new Vector();
                           var58.addElement(this.thisTagRef.getAttribute("name"));
                           var58.addElement(Integer.toString(this.currYpos + this.lastYpos - 40));
                           this.linkPos.addElement(var58);
                        }
                     } else {
                        this.field_1.setColor(var15);
                        var9 = false;
                     }
                     break;
                  case 3:
                  case 35:
                     Font var57 = this.field_1.getFont();
                     if (!this.thisTagRef.isEnd) {
                        if (this.lastFont.size() > this.currentFontLevel) {
                           this.lastFont.setElementAt(var57, this.currentFontLevel++);
                        } else {
                           ++this.currentFontLevel;
                           this.lastFont.addElement(var57);
                        }

                        if (!var57.isBold()) {
                           this.field_1.setFont(new Font(var57.getName(), var57.getStyle() + 1, var57.getSize()));
                        }
                     } else {
                        this.field_1.setFont((Font)this.lastFont.elementAt(this.currentFontLevel += -1));
                     }

                     this.field_0 = this.field_1.getFontMetrics();
                     this.widths = this.field_0.getWidths();
                     break;
                  case 5:
                     Color var48 = this.parseColors(this.thisTagRef.getAttribute("bgcolor"));
                     if (var48 != null) {
                        Color var56 = this.field_1.getColor();
                        this.field_1.setColor(var48);
                        this.field_1.fillRect(1, 1, this.Bounds.width - 2, this.Bounds.height - 2);
                        this.field_1.setColor(var56);
                     }

                     var48 = this.parseColors(this.thisTagRef.getAttribute("text"));
                     if (var48 != null) {
                        this.field_1.setColor(var48);
                        var15 = var48;
                     }

                     var48 = this.parseColors(this.thisTagRef.getAttribute("link"));
                     if (var48 != null) {
                        var16 = var48;
                     }

                     var48 = this.parseColors(this.thisTagRef.getAttribute("vlink"));
                     if (var48 != null) {
                        ;
                     }

                     var48 = this.parseColors(this.thisTagRef.getAttribute("alink"));
                     if (var48 != null) {
                        ;
                     }
                     break;
                  case 6:
                     if (this.currXpos != this.indent) {
                        this.currYpos += var6;
                        this.currXpos = this.indent;
                     }

                     if (!this.centerOff) {
                        var21 = this.calcTotalWidth(var24);
                     } else {
                        var21 = 0;
                     }
                     break;
                  case 9:
                     if (!this.thisTagRef.isEnd) {
                        var13[(this.indent - 5) / var4] = this.thisTag.id;
                        var14[(this.indent - 5) / var4] = 1;
                     } else {
                        for(this.currYpos += var5; this.currYpos < var8 && var6 > 0; this.currYpos += var6) {
                        }

                        var8 = this.currYpos;
                     }

                     this.currXpos = this.indent;
                     break;
                  case 10:
                     for(this.currYpos += var6; this.currYpos < var8 && var6 > 0; this.currYpos += var6) {
                     }

                     this.currXpos = this.indent + var4;
                     this.maxWidth = this.Bounds.width - var11 - this.currXpos;
                     break;
                  case 13:
                     while(this.currYpos <= var8 && var6 > 0) {
                        this.currYpos += var6;
                     }

                     this.currXpos = this.indent;
                     this.maxWidth = this.Bounds.width - var11 - this.currXpos;
                     break;
                  case 15:
                  case 16:
                  case 17:
                  case 18:
                  case 19:
                  case 20:
                     int var63 = this.defaultFontSize;
                     if (this.thisTag.id == 15) {
                        var63 = this.defaultFontSize + 14;
                     }

                     if (this.thisTag.id == 16) {
                        var63 = this.defaultFontSize + 8;
                     }

                     if (this.thisTag.id == 17) {
                        var63 = this.defaultFontSize + 6;
                     }

                     if (this.thisTag.id == 18) {
                        var63 = this.defaultFontSize + 1;
                     }

                     if (this.thisTag.id == 19) {
                        var63 = this.defaultFontSize - 2;
                     }

                     if (this.thisTag.id == 20) {
                        var63 = this.defaultFontSize - 4;
                     }

                     Font var55 = this.field_1.getFont();
                     if (!this.thisTagRef.isEnd) {
                        this.currYpos -= var6;
                        if (this.lastFont.size() > this.currentFontLevel) {
                           this.lastFont.setElementAt(var55, this.currentFontLevel++);
                        } else {
                           ++this.currentFontLevel;
                           this.lastFont.addElement(var55);
                        }

                        this.field_1.setFont(new Font(var55.getName(), 1, var63));
                        this.field_0 = this.field_1.getFontMetrics();
                        var5 = this.field_0.getHeight();
                        this.currYpos += var5;
                        if (this.currXpos != this.indent) {
                           while(this.currYpos < var8) {
                              this.currYpos += var5;
                           }
                        }

                        if (this.centerOff) {
                           this.currXpos = this.indent;
                        }
                     } else {
                        this.field_1.setFont((Font)this.lastFont.elementAt(this.currentFontLevel += -1));
                        this.field_0 = this.field_1.getFontMetrics();
                        var5 = this.field_0.getHeight();
                        if (this.currXpos != this.indent) {
                           while(this.currYpos < var8) {
                              this.currYpos += var5;
                           }
                        }

                        this.indent = 8;

                        for(this.rightIndent = 0; this.imageBottomPos != 0 && this.currYpos < this.imageBottomPos && var6 > 0; this.currYpos += var6) {
                        }

                        this.imageBottomPos = 0;
                        this.currXpos = this.indent;
                     }

                     this.widths = this.field_0.getWidths();
                     break;
                  case 22:
                     while(this.imageBottomPos != 0 && this.currYpos < this.imageBottomPos && var6 > 0) {
                        this.currYpos += var6;
                     }

                     if (this.currXpos != this.indent) {
                        this.imageBottomPos = 0;
                        this.currYpos += 8;
                        this.currXpos = this.indent;
                     }

                     if (var22) {
                        Color var66 = this.field_1.getColor();
                        Color var44 = JDPUtils.darker(var3);
                        var44 = JDPUtils.darker(var44);
                        this.field_1.setColor(var44);
                        this.field_1.drawLine(this.currXpos, this.currYpos, this.maxWidth, this.currYpos);
                        this.field_1.drawLine(this.currXpos, this.currYpos, this.currXpos, this.currYpos + 2);
                        var44 = JDPUtils.brighter(var3);
                        var44 = JDPUtils.brighter(var44);
                        this.field_1.setColor(var44);
                        this.field_1.drawLine(this.maxWidth, this.currYpos, this.maxWidth, this.currYpos + 2);
                        this.field_1.drawLine(this.currXpos, this.currYpos + 2, this.maxWidth, this.currYpos + 2);
                        this.field_1.setColor(var66);
                     }

                     this.currYpos = this.currYpos + var6 + 4;
                     var8 = this.currYpos;
                     this.currXpos = this.indent;
                     break;
                  case 24:
                     Font var54 = this.field_1.getFont();
                     if (!this.thisTagRef.isEnd) {
                        if (this.lastFont.size() > this.currentFontLevel) {
                           this.lastFont.setElementAt(var54, this.currentFontLevel++);
                        } else {
                           ++this.currentFontLevel;
                           this.lastFont.addElement(var54);
                        }

                        this.field_1.setFont(new Font(var54.getName(), var54.getStyle() + 2, var54.getSize()));
                     } else {
                        this.field_1.setFont((Font)this.lastFont.elementAt(this.currentFontLevel += -1));
                     }

                     this.field_0 = this.field_1.getFontMetrics();
                     this.widths = this.field_0.getWidths();
                     break;
                  case 25:
                     String var27 = this.thisTagRef.getAttribute("src");
                     String var59 = this.thisTagRef.getAttribute("align");
                     int var29 = 0;
                     int var30 = 0;
                     if (this.thisTagRef.getAttribute("width") != null) {
                        var29 = Integer.parseInt(this.thisTagRef.getAttribute("width"));
                     }

                     if (this.thisTagRef.getAttribute("width") != null) {
                        var30 = Integer.parseInt(this.thisTagRef.getAttribute("height"));
                     }

                     if (var59 == null) {
                        var59 = "";
                     }

                     String var31 = this.lastDocPath.substring(super.user.wwwroot.length()) + var27;
                     var31 = super.user.u.replace(var31, "/", File.separator);
                     if (!JDesignerPro.executable) {
                        if (var27.substring(0, 4).compareTo("http") != 0) {
                           if (var27.substring(0, 1).equals("/")) {
                              var27 = this.wwwPath + var27;
                           } else {
                              var27 = this.lastDocPath + var27;
                           }
                        }
                     } else {
                        var27 = var31;
                     }

                     try {
                        try {
                           Image var62 = null;
                           int var64 = this.imageLocArray.indexOf(var27);
                           if (var64 >= 0) {
                              var62 = (Image)this.imageArray.elementAt(var64);
                           } else {
                              this.imageLocArray.addElement(var27);
                              var64 = this.imageLocArray.size() - 1;
                              this.imageArray.addElement((Object)null);
                              JDPImageLoader var68 = new JDPImageLoader(super.user, this, var27, var64);
                              (new Thread(var68)).start();
                           }

                           if (var62 != null) {
                              if (var29 == 0) {
                                 var29 = var62.getWidth((ImageObserver)null);
                              }

                              if (var30 == 0) {
                                 var30 = var62.getHeight((ImageObserver)null);
                              }
                           }

                           var12 = var29;
                           if (var62 != null && var22) {
                              if (var59.compareTo("right") != 0 && var59.compareTo("RIGHT") != 0) {
                                 this.field_1.drawImage(var62, this.currXpos, this.currYpos - var5, var29, var30, (ImageObserver)null);
                              } else {
                                 this.field_1.drawImage(var62, this.maxWidth - var29, this.currYpos - var5, var29, var30, (ImageObserver)null);
                              }
                           }

                           String var69 = this.thisTagRef.getAttribute("border");
                           if (var22 && var69 != null && var69.compareTo("0") != 0) {
                              this.field_1.setColor(var16);
                              if (var59.compareTo("right") != 0 && var59.compareTo("RIGHT") != 0) {
                                 this.field_1.drawRect(this.currXpos, this.currYpos - var5, var29, var30);
                              } else {
                                 this.field_1.drawRect(this.maxWidth - var29, this.currYpos - var5, var29, var30);
                              }

                              this.field_1.setColor(var15);
                           }

                           if (var22 && var9) {
                              this.links.addElement(new Rectangle());
                              if (var59.compareTo("right") != 0 && var59.compareTo("RIGHT") != 0) {
                                 ((Rectangle)this.links.elementAt(this.totalLinks++)).reshape(this.currXpos, this.currYpos - var5, var29, var30);
                              } else {
                                 ((Rectangle)this.links.elementAt(this.totalLinks++)).reshape(this.maxWidth - var29, this.currYpos - var5, var29, var30);
                              }

                              this.linkDoc.addElement(this.linkDoc.elementAt(this.totalLinks - 1));
                           }

                           if (var59.equals("")) {
                              this.currYpos = this.currYpos - var6 + var30;
                              this.currXpos += var29 + 5;
                              var8 = this.currYpos + var6;
                           } else if (var59.compareTo("right") != 0 && var59.compareTo("RIGHT") != 0) {
                              if (var59.compareTo("left") != 0 && var59.compareTo("LEFT") != 0) {
                                 if (var59.compareTo("top") != 0 && var59.compareTo("TOP") != 0) {
                                    this.currXpos = this.indent;
                                    this.currYpos = this.currYpos - var6 + var30;
                                    var8 = this.currYpos + var30;
                                 } else {
                                    this.currYpos = this.currYpos - var6 + var30;
                                    this.currXpos = this.indent;
                                 }
                              } else {
                                 this.currXpos = this.indent + var29;
                              }
                           } else {
                              this.rightIndent = var29 + 10;
                              var8 = this.currYpos + var6 - 10;
                              this.imageBottomPos = this.currYpos - var5 + var30;
                           }
                        } catch (Exception var37) {
                           var12 = var29;
                           ((Throwable)var37).printStackTrace();
                        }
                     } catch (Exception var38) {
                        var12 = var29;
                        ((Throwable)var38).printStackTrace();
                     }
                     break;
                  case 28:
                     while(this.currYpos < var8 && var6 > 0) {
                        this.currYpos += var6;
                     }

                     this.currXpos = this.indent;
                     if (var13[(this.indent - 5) / var4] == 31) {
                        String var61 = Integer.toString(var14[(this.indent - 5) / var4]++) + ".";
                        this.field_1.drawString(var61, this.currXpos - super.user.u.StringWidth(this.field_1, var61) - 2, this.currYpos);
                     } else if (var13[(this.indent - 5) / var4] == 39 || var13[(this.indent - 5) / var4] == 29) {
                        this.field_1.fillArc(this.currXpos - 13, this.currYpos - 7, 6, 6, 0, 360);
                     }
                     break;
                  case 29:
                  case 31:
                  case 39:
                  case 54:
                     if (this.thisTagRef.isEnd) {
                        this.indent -= var4;
                        this.currYpos += var5;
                        this.maxWidth += var4;
                        var8 = this.currYpos;
                     } else {
                        if (this.currXpos != this.indent) {
                           while(this.currYpos < var8) {
                              this.currYpos += var6;
                           }
                        }

                        this.indent += var4;
                        var13[(this.indent - 5) / var4] = this.thisTag.id;
                        var14[(this.indent - 5) / var4] = 1;
                        this.maxWidth -= var4;
                     }

                     this.currXpos = this.indent;
                     break;
                  case 32:
                     if (!this.thisTagRef.isEnd && var23 != 32) {
                        String var28 = this.thisTagRef.getAttribute("align");
                        if (var28 != null && var28.equals("center")) {
                           this.centerOff = false;
                           this.calcTotalWidth(var24);
                        }

                        if (this.currXpos != this.indent) {
                           this.currYpos += var6;
                        } else {
                           while(this.currYpos < var8) {
                              this.currYpos += var6;
                           }
                        }

                        if (!this.centerOff) {
                           var21 = this.calcTotalWidth(var24);
                        } else {
                           var21 = 0;
                        }

                        this.rightIndent = 0;
                        this.currXpos = this.indent;

                        for(this.currYpos += var6; this.imageBottomPos != 0 && this.currYpos < this.imageBottomPos && var6 > 0; this.currYpos += var6) {
                        }

                        this.imageBottomPos = 0;
                     } else if (this.thisTagRef.isEnd) {
                        this.currXpos = this.indent;
                        this.centerOff = true;
                        var21 = 0;
                     }
                     break;
                  case 33:
                     if (!this.thisTagRef.isEnd) {
                        var20 = true;
                        this.currXpos = 8;
                        this.currYpos += var5;
                     } else {
                        var20 = false;
                        this.currXpos = 8;
                        this.currYpos += var5;
                     }
                     break;
                  case 36:
                     var10 = this.thisTagRef.isEnd;
                     break;
                  case 40:
                     while(this.currYpos < var8 && var6 > 0) {
                        this.currYpos += var6;
                     }

                     if (!this.thisTagRef.isEnd) {
                        this.indent += var4;
                        this.currXpos = this.indent;
                        this.rightBlockIndent += var4;
                        this.maxWidth = this.Bounds.width - var11 - this.currXpos;
                     } else if (this.indent >= var4) {
                        this.indent -= var4;
                        this.currXpos = this.indent;
                        this.rightBlockIndent -= var4;
                        this.maxWidth = this.Bounds.width - var11 - this.currXpos;
                     }
                     break;
                  case 50:
                     this.centerOff = this.thisTagRef.isEnd;
                     if (this.centerOff) {
                        var21 = 0;
                     } else {
                        var21 = this.calcTotalWidth(var24);
                     }
                     break;
                  case 51:
                     Font var53 = this.field_1.getFont();
                     if (this.thisTagRef.isEnd) {
                        this.field_1.setFont((Font)this.lastFont.elementAt(this.currentFontLevel += -1));
                     } else {
                        if (this.lastFont.size() > this.currentFontLevel) {
                           this.lastFont.setElementAt(var53, this.currentFontLevel++);
                        } else {
                           ++this.currentFontLevel;
                           this.lastFont.addElement(var53);
                        }

                        String var32 = this.thisTagRef.getAttribute("name");

                        String var33;
                        for(var33 = this.thisTagRef.getAttribute("size"); this.currYpos < var8 && var6 > 0 && this.currXpos == this.indent; this.currYpos += var6) {
                        }

                        int var34 = this.defaultFontSize;
                        if (var33 != null) {
                           if (var33.substring(0, 1).compareTo("+") == 0) {
                              var34 += Integer.parseInt(var33.substring(1)) * 2;
                           } else if (var33.substring(0, 1).compareTo("-") == 0) {
                              var34 -= Integer.parseInt(var33.substring(1)) * 2;
                           } else {
                              var34 = Integer.parseInt(var33);
                              if (var34 < 6) {
                                 var34 = 8 + var34 * 2;
                              }

                              var34 = var34 * this.defaultFontSize / 14;
                           }
                        }

                        if (var32 != null) {
                           Font var35 = new Font(var32, var53.getStyle(), var34);
                           this.field_1.setFont(var35);
                        } else {
                           Font var70 = new Font(var53.getName(), var53.getStyle(), var34);
                           this.field_1.setFont(var70);
                        }
                     }

                     this.field_0 = this.field_1.getFontMetrics();
                     this.widths = this.field_0.getWidths();
                     break;
                  case 55:
                     if (!this.thisTagRef.isEnd) {
                        Color var43 = this.parseColors(this.thisTagRef.getAttribute("text"));
                        if (var43 != null) {
                           this.field_1.setColor(var43);
                        }
                     } else {
                        this.field_1.setColor(var15);
                     }
                     break;
                  case 56:
                     if (!this.thisTagRef.isEnd) {
                        this.currYpos -= 3;
                     } else {
                        this.currYpos += 3;
                     }
               }

               if (this.thisTag.id != 5) {
                  var23 = this.thisTag.id;
               } else {
                  var23 = 32;
               }
            }
         }

         this.currYpos += this.lastYpos;
         if (this.currYpos <= this.Bounds.height && this.lastYpos == 0) {
            if (this.scrollEast != null) {
               this.scrollEast.hide();
            }
         } else {
            if (this.scrollEast == null) {
               this.scrollEast = new Scrollbar(1, this.lastYpos, this.Bounds.height, 0, this.currYpos);
               ((Container)this).add("East", this.scrollEast);
            }

            this.scrollEast.move(this.Bounds.width - 14, 2);
            this.scrollEast.resize(12, this.Bounds.height - 4);
            this.scrollEast.show();
            int var41 = 0;
            if (System.getProperty("java.vendor").startsWith("Netscape") && System.getProperty("java.version").compareTo("1.1.5") < 0 || System.getProperty("java.vendor").startsWith("Microsoft") && System.getProperty("java.version").compareTo("1.1.4") < 0) {
               var41 = this.Bounds.height;
            }

            this.scrollEast.setValues(this.lastYpos, this.Bounds.height, 0, this.currYpos - var41);
         }

         this.field_1.setColor(JDPUtils.darker(var3));
         this.field_1.drawLine(0, 0, this.Bounds.width, 0);
         this.field_1.drawLine(0, 0, 0, this.Bounds.height);
         this.field_1.setColor(Color.black);
         this.field_1.drawLine(1, 1, this.Bounds.width - 1, 1);
         this.field_1.drawLine(1, 1, 1, this.Bounds.height - 1);
         this.field_1.setColor(JDPUtils.brighter(var3));
         this.field_1.drawLine(this.Bounds.width - 1, 0, this.Bounds.width - 1, this.Bounds.height - 1);
         this.field_1.drawLine(0, this.Bounds.height - 1, this.Bounds.width - 1, this.Bounds.height - 1);
         this.field_1.setColor(var3);
         this.field_1.drawLine(this.Bounds.width - 2, 1, this.Bounds.width - 2, this.Bounds.height - 2);
         this.field_1.drawLine(1, this.Bounds.height - 2, this.Bounds.width - 2, this.Bounds.height - 2);
         this.field_1.setColor(Color.black);
         var1.drawImage(this.offscreen, 0, 0, this.Bounds.width, this.Bounds.height, (ImageObserver)null);
      }
   }

   int bytesWidth(byte[] var1, int var2, int var3) {
      this.lineCount = -1;
      int var4 = 0;
      int var5 = var2;
      int var7 = 0;
      int var8 = this.currXpos;
      boolean var9 = false;
      this.byteLine = new Vector(10, 5);

      int var6;
      for(var6 = 0; var6 < var3; ++var6) {
         byte var10 = var1[var2 + var6];
         if (var10 >= 0 && var10 < this.widths.length) {
            var4 += this.widths[var10];
         }

         if (var4 > this.maxWidth - 5 - (var8 - this.indent) - this.rightIndent - this.rightBlockIndent) {
            int var11 = var2 + var6;
            this.checkLineWidth();

            for(this.lineWidths[this.lineCount + 1] = var4; var11 > var5 && var1[var11] != 32; --var11) {
               if (var1[var11] >= 0 && var1[var5] < this.widths.length) {
                  this.lineWidths[this.lineCount + 1] = var4 - this.widths[var1[var11]];
               }
            }

            if (var11 == var5) {
               ++this.lineCount;
               this.byteLine.addElement(new String(var1, 0, var5, var2 + var6 - var5));
            } else {
               ++this.lineCount;
               this.byteLine.addElement(new String(var1, 0, var5, var11 - var5));

               while(var11 < var2 + var3 && var1[var11] == 32) {
                  ++var11;
               }

               var6 = var11 - var2;
            }

            var5 = var2 + var6;
            if (var1[var5] >= 0 && var1[var5] < this.widths.length) {
               var4 = this.widths[var1[var5]];
            }

            var7 = var6 + 1;
            var8 = this.indent;
            var9 = true;
         }
      }

      if (var6 - var7 > 0) {
         if (var1.length > var5 + var6 - var7 + 1 && var9) {
            ++this.lineCount;
            this.byteLine.addElement(new String(var1, 0, var5, var6 - var7 + 1));
         } else {
            ++this.lineCount;
            this.byteLine.addElement(new String(var1, 0, var5, var6 - var7));
         }

         this.lineWidths[this.lineCount] = var4;
      }

      return var4;
   }

   int calcTotalWidth(int var1) {
      JDPHtmlTagRef var2 = (JDPHtmlTagRef)this.docTags.elementAt(var1);
      JDPHtmlTag var3 = var2.tag;
      int var4 = 0;
      int var5 = var2.pos;
      int var6 = 0;
      this.saveFont[var6] = this.field_1.getFont();
      ++var1;

      for(; var1 < this.docTags.size(); ++var1) {
         var2 = (JDPHtmlTagRef)this.docTags.elementAt(var1);
         var3 = var2.tag;
         this.bytesWidth(this.docText, var5, var2.pos - var5);
         var4 += this.bytesWidth(this.docText, var5, var2.pos - var5);
         if (var3.id == 3) {
            Font var7 = this.field_1.getFont();
            if (!var2.isEnd) {
               this.saveFont[var6++] = var7;
               this.field_1.setFont(new Font(var7.getName(), var7.getStyle() + 1, var7.getSize()));
            } else {
               --var6;
               this.field_1.setFont(this.saveFont[var6]);
            }

            this.field_0 = this.field_1.getFontMetrics();
            this.widths = this.field_0.getWidths();
         }

         if (var3.id == 51) {
            Font var15 = this.field_1.getFont();
            if (!var2.isEnd) {
               this.saveFont[var6++] = var15;
               String var8 = var2.getAttribute("name");
               String var9 = var2.getAttribute("size");
               int var10 = this.defaultFontSize;
               if (var9 != null) {
                  if (var9.substring(0, 1).compareTo("+") == 0) {
                     var10 += Integer.parseInt(var9.substring(1)) * 2;
                  } else if (var9.substring(0, 1).compareTo("-") == 0) {
                     var10 -= Integer.parseInt(var9.substring(1)) * 2;
                  } else {
                     var10 = Integer.parseInt(var9);
                     if (var10 < 6) {
                        var10 = 8 + var10 * 2;
                     }

                     var10 = var10 * this.defaultFontSize / 14;
                  }
               }

               if (var8 != null) {
                  Font var11 = new Font(var8, var15.getStyle(), var10);
                  this.field_1.setFont(var11);
               } else {
                  Font var19 = new Font(var15.getName(), var15.getStyle(), var10);
                  this.field_1.setFont(var19);
               }
            } else {
               if (var6 > 0) {
                  --var6;
               }

               this.field_1.setFont(this.saveFont[var6]);
            }

            this.field_0 = this.field_1.getFontMetrics();
            this.widths = this.field_0.getWidths();
         }

         if (var3.id == 15 || var3.id == 16 || var3.id == 17 || var3.id == 18 || var3.id == 19 || var3.id == 20) {
            int var16 = this.defaultFontSize;
            if (var3.id == 15) {
               var16 = this.defaultFontSize + 14;
            }

            if (var3.id == 16) {
               var16 = this.defaultFontSize + 8;
            }

            if (var3.id == 17) {
               var16 = this.defaultFontSize + 6;
            }

            if (var3.id == 18) {
               var16 = this.defaultFontSize + 1;
            }

            if (var3.id == 19) {
               var16 = this.defaultFontSize - 2;
            }

            if (var3.id == 20) {
               var16 = this.defaultFontSize - 4;
            }

            Font var17 = this.field_1.getFont();
            if (!var2.isEnd) {
               this.saveFont[var6++] = var17;
               this.field_1.setFont(new Font(var17.getName(), 1, var16));
            } else {
               --var6;
               this.field_1.setFont(this.saveFont[var6]);
            }

            this.field_0 = this.field_1.getFontMetrics();
            this.widths = this.field_0.getWidths();
         }

         var5 = var2.pos;
         if (var3.id == 50) {
            var1 = this.docTags.size();
         }

         if (var3.id == 6) {
            var1 = this.docTags.size();
         }

         if (var3.id == 32) {
            var1 = this.docTags.size();
         }
      }

      this.field_1.setFont(this.saveFont[0]);
      return var4;
   }

   void checkLineWidth() {
      if (this.lineCount + 5 > this.lineWidths.length) {
         int[] var1 = this.lineWidths;
         this.lineWidths = new int[this.lineCount + 100];
         System.arraycopy(var1, 0, this.lineWidths, 0, this.lineCount);
      }

   }

   Color parseColors(String var1) {
      if (var1 == null) {
         return null;
      } else {
         if (var1.startsWith("#") || var1.startsWith("x") || var1.startsWith("X")) {
            var1 = var1.substring(1);
         }

         try {
            int var2 = 0;

            do {
               this.intArray[var2] = var1.charAt(var2);
               if (this.intArray[var2] < 58) {
                  int[] var10000 = this.intArray;
                  var10000[var2] -= 48;
               } else if (this.intArray[var2] < 71) {
                  int[] var5 = this.intArray;
                  var5[var2] -= 55;
               } else {
                  int[] var6 = this.intArray;
                  var6[var2] -= 87;
               }

               ++var2;
            } while(var2 < 6);
         } catch (Exception var4) {
            System.out.println(var1);
            ((Throwable)var4).printStackTrace();
         }

         return new Color(this.intArray[0] * 16 + this.intArray[1], this.intArray[2] * 16 + this.intArray[3], this.intArray[4] * 16 + this.intArray[5]);
      }
   }

   public boolean forward() {
      if (this.currentLevel + 1 < this.lastDoc.size()) {
         this.lastYpos = 0;
         ++this.currentLevel;

         try {
            this.lastYpos = Integer.parseInt((String)this.lastDocPos.elementAt(this.currentLevel));
         } catch (Exception var1) {
         }

         this.lastDocPath = null;
         return this.loadHtmlDoc((String)this.lastDoc.elementAt(this.currentLevel));
      } else {
         return false;
      }
   }

   public String getDocname() {
      return this.docName;
   }

   public boolean setDocname(String var1) {
      this.lastYpos = 0;
      this.displayErrors = true;
      return this.loadHtmlDoc(var1);
   }

   public boolean setDocname(String var1, boolean var2) {
      this.lastYpos = 0;
      this.displayErrors = var2;
      return this.loadHtmlDoc(var1);
   }

   public void setDimension(Dimension var1) {
      this.paintDimension = var1;
   }

   public boolean getMatchCompleteWords() {
      return this.matchCompleteWords;
   }

   public void setMatchCompleteWords(boolean var1) {
      this.matchCompleteWords = var1;
   }

   public boolean back() {
      if (this.currentLevel > 0) {
         if (this.lastDocPos.size() > this.currentLevel) {
            this.lastDocPos.setElementAt(Integer.toString(this.lastYpos), this.currentLevel);
         } else {
            this.lastDocPos.addElement(Integer.toString(this.lastYpos));
         }

         --this.currentLevel;
         this.lastYpos = Integer.parseInt((String)this.lastDocPos.elementAt(this.currentLevel));
         this.lastDocPath = null;
         return this.loadHtmlDoc((String)this.lastDoc.elementAt(this.currentLevel));
      } else {
         return false;
      }
   }

   public boolean handleEvent(Event var1) {
      int var2 = this.lastYpos;
      switch (var1.id) {
         case 202:
         case 205:
            ((Component)this).repaint();
            this.dropEvent = false;
            return false;
         case 502:
            for(int var3 = 0; var3 < this.totalLinks; ++var3) {
               if (this.links.elementAt(var3) != null && ((Rectangle)this.links.elementAt(var3)).inside(var1.x, var1.y)) {
                  if (((String)this.linkDoc.elementAt(var3)).toLowerCase().equals("back")) {
                     if (!this.back()) {
                        return true;
                     }
                  } else {
                     ++this.currentLevel;
                     if (this.lastDocPos.size() > this.currentLevel) {
                        this.lastDocPos.setElementAt(Integer.toString(this.lastYpos), this.currentLevel - 1);
                     } else {
                        this.lastDocPos.addElement(Integer.toString(this.lastYpos));
                     }

                     if (!this.loadHtmlDoc((String)this.linkDoc.elementAt(var3))) {
                        return true;
                     }
                  }

                  this.lastYpos = 0;
                  ((Component)this).repaint();
                  return true;
               }
            }

            this.keyWords = null;
            ((Component)this).repaint();
            return false;
         case 601:
            this.dropEvent = true;
            this.lastYpos -= 20;
            if (this.lastYpos < 0) {
               this.lastYpos = 0;
            }

            if (var2 != this.lastYpos) {
               ((Component)this).repaint(1, 1, this.Bounds.width - 2, this.Bounds.height - 2);
            }

            return true;
         case 602:
            this.dropEvent = true;
            this.lastYpos += 20;
            if (this.lastYpos > this.currYpos - this.Bounds.height) {
               this.lastYpos = this.currYpos - this.Bounds.height + 10;
            }

            if (var2 != this.lastYpos) {
               ((Component)this).repaint(1, 1, this.Bounds.width - 2, this.Bounds.height - 2);
            }

            return true;
         case 603:
            this.dropEvent = true;
            this.lastYpos = this.lastYpos - this.Bounds.height + 10;
            if (this.lastYpos < 0) {
               this.lastYpos = 0;
            }

            if (var2 != this.lastYpos) {
               ((Component)this).repaint(1, 1, this.Bounds.width - 2, this.Bounds.height - 2);
            }

            return true;
         case 604:
            this.dropEvent = true;
            this.lastYpos = this.lastYpos + this.Bounds.height - 10;
            if (this.lastYpos > this.currYpos - this.Bounds.height) {
               this.lastYpos = this.currYpos - this.Bounds.height + 10;
            }

            if (var2 != this.lastYpos) {
               ((Component)this).repaint(1, 1, this.Bounds.width - 2, this.Bounds.height - 2);
            }

            return true;
         case 605:
            if (this.dropEvent) {
               this.dropEvent = false;
               return true;
            }

            if (this.scrollEast != null) {
               this.lastYpos = this.scrollEast.getValue();
            }

            if (this.lastYpos > this.currYpos - this.Bounds.height) {
               this.lastYpos = this.currYpos - this.Bounds.height + 10;
            }

            if (var2 != this.lastYpos) {
               ((Component)this).repaint(1, 1, this.Bounds.width - 2, this.Bounds.height - 2);
            }

            return true;
         default:
            this.dropEvent = false;
            if (super.user.jdpMainWindow != null) {
               if (super.user.jdpMainWindow.getCursorType() == 3) {
                  return false;
               }

               for(int var4 = 0; var4 < this.totalLinks; ++var4) {
                  if (this.links.elementAt(var4) != null && ((Rectangle)this.links.elementAt(var4)).inside(var1.x, var1.y)) {
                     super.user.jdpMainWindow.setCursor(12);
                     return false;
                  }
               }

               super.user.jdpMainWindow.setCursor(0);
            }

            return false;
      }
   }

   public void layout() {
      ((Component)this).repaint();
   }

   public Dimension preferredSize() {
      return this.minimumSize();
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      activated = JDPUser.classactivated;
      if (!activated) {
         System.out.println("Software Violation - this class may only be used in conjunction with JDesignerPro.");
      } else {
         super.user = var1;
         if (var1.plainFontSize > 0) {
            this.defaultFontSize = var1.plainFontSize + 3;
         } else {
            this.defaultFontSize = 14;
         }

         this.textHighlightText = JDPUtils.getTextHighlightText();
         this.textHighlight = JDPUtils.getTextHighlight();
         ((Component)this).setFont(new Font("TimesRoman", 0, this.defaultFontSize));
         ((Container)this).setLayout(new BorderLayout());
         super.user = var1;
         super.targetPanel = var2;
         this.preFont = new Font("Courier", 0, this.defaultFontSize - 2);
         this.byteLine = new Vector(10, 20);
         this.lineWidths = new int[5000];
         this.lastDoc = new Vector(10, 5);
         this.lastDocPos = new Vector(10, 5);
         this.lastFont = new Vector(10, 5);
         this.lastFont.addElement(((Component)this).getFont());
         this.saveFont = new Font[1000];
         this.intArray = new int[6];
         this.imageArray = new Vector(20, 50);
         this.imageLocArray = new Vector(20, 50);
         if (this.loadHtmlDoc(var3)) {
            ;
         }
      }
   }

   boolean loadHtmlDoc(String var1) {
      if (var1.length() == 0) {
         return false;
      } else if (this.docName != null && this.docName.equals(var1)) {
         return true;
      } else {
         this.docName = var1;
         var1 = var1.replace('\\', '/');
         String var4 = var1;
         String var5 = var1;
         int var6 = var1.indexOf("#");
         if (var6 >= 0) {
            String var7 = var1.substring(var6 + 1);
            if (var6 == 0) {
               for(int var19 = 0; var19 < this.linkPos.size(); ++var19) {
                  Vector var9 = (Vector)this.linkPos.elementAt(var19);
                  if (((String)var9.elementAt(0)).equals(var7)) {
                     this.lastYpos = Integer.parseInt((String)var9.elementAt(1));
                     ((Component)this).repaint();
                     return false;
                  }
               }

               return false;
            }

            var1 = var1.substring(0, var6);
            var4 = var1;
         }

         try {
            if (super.user.mainmsg != null) {
               super.user.mainmsg.setStatusMsg("Loading document...", 0);
            }

            if (!var1.startsWith("http")) {
               if (var1.startsWith("/")) {
                  var1 = super.user.wwwroot + var1.substring(1);
               } else {
                  if (this.lastDocPath == null || !this.lastDocPath.startsWith(super.user.wwwroot)) {
                     this.lastDocPath = super.user.wwwroot;
                     this.wwwPath = super.user.wwwroot;
                  }

                  if (var1.indexOf("/") > 0) {
                     String var10001 = this.lastDocPath;
                     this.lastDocPath = var10001 + var1.substring(0, var1.lastIndexOf("/") + 1);
                     var1 = var1.substring(var1.lastIndexOf("/") + 1);
                     var4 = var1;
                  }

                  var1 = this.lastDocPath + var1;
               }
            }

            if (JDesignerPro.executable && var5.indexOf(File.separator) < 0) {
               if (!var5.startsWith("\\") && !var5.startsWith("/")) {
                  var5 = this.lastDocPath.substring(super.user.wwwroot.length()) + var4;
               } else {
                  var5 = var5.substring(1);
                  var1 = super.user.JDesignerPro.wwwroot + var5.replace('\\', '/');
               }

               var5 = super.user.u.replace(var5, "/", File.separator);
            }

            this.lastDocPath = var1.substring(0, var1.lastIndexOf("/") + 1);
            int var15 = var1.indexOf("/");
            var15 = var1.indexOf("/", var15 + 1);
            var15 = var1.indexOf("/", var15 + 1);
            this.wwwPath = var1.substring(0, var15);
            InputStream var3;
            if (JDesignerPro.executable && !var4.substring(0, 4).equals("http")) {
               FileInputStream var8 = new FileInputStream(var5);
               var3 = (InputStream)var8;
               this.currentDoc = var5;
            } else {
               URL var2 = new URL(var1);
               var3 = var2.openStream();
               this.currentDoc = var1;
            }

            JDPHtmlDoc var18 = new JDPHtmlDoc();

            try {
               new JDPHtmlParser(var3, var18);
            } catch (Exception var10) {
               System.out.println("Could not open document " + var1);
               super.user.mainmsg.setStatusMsg("Could not open document " + var1, 20);
            }

            this.docText = var18.getText();
            this.docTags = var18.getTags();
            var3.close();
            Object var13 = null;
         } catch (Exception var11) {
            if (this.displayErrors) {
               if (super.user.mainmsg != null) {
                  if (JDesignerPro.executable && (var4 == null || var4.length() <= 4 || !var4.substring(0, 4).equals("http"))) {
                     super.user.mainmsg.setStatusMsg("Could not locate file " + var5, 20);
                     System.out.println("Could not locate file " + var5);
                  } else {
                     super.user.mainmsg.setStatusMsg("Could not locate document " + var1, 20);
                     System.out.println("Could not locate document " + var1);
                  }
               }
            } else {
               super.user.mainmsg.clearStatusMsg();
            }

            return false;
         }

         if (super.user.mainmsg != null) {
            super.user.mainmsg.clearStatusMsg();
         }

         ((Component)this).repaint();
         if (this.lastDoc.size() > this.currentLevel) {
            this.lastDoc.setElementAt(this.currentDoc, this.currentLevel);
         } else {
            this.lastDoc.addElement(this.currentDoc);
         }

         return true;
      }
   }

   boolean isKeyword(String var1) {
      if (this.keyWords == null) {
         return false;
      } else {
         var1 = var1.toLowerCase();
         this.thisLength = var1.length();

         for(int var2 = 0; var2 < this.keyWords.length; ++var2) {
            this.ipos = var1.indexOf(this.keyWords[var2]);
            if (this.ipos >= 0) {
               if (!this.matchCompleteWords) {
                  return true;
               }

               if (this.ipos > 0) {
                  this.thisChar = var1.charAt(this.ipos - 1);
               }

               if (this.ipos == 0 || (this.thisChar < 'A' || this.thisChar > 'Z') && (this.thisChar < 'a' || this.thisChar > 'z')) {
                  if (this.ipos + this.keyWords[var2].length() >= this.thisLength) {
                     return true;
                  }

                  this.thisChar = var1.charAt(this.ipos + this.keyWords[var2].length());
                  if ((this.thisChar < 'A' || this.thisChar > 'Z') && (this.thisChar < 'a' || this.thisChar > 'z')) {
                     return true;
                  }
               }
            }
         }

         return false;
      }
   }
}
