import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Panel;

public class JDPButtons extends Panel {
   public static int VERTICAL;
   public static int HORIZONTAL = 1;
   public static String[] alignmentValues = new String[]{"Vertical", "Horizontal"};
   public JDPButton[] button;
   boolean stayOn;
   private JDPUser user;
   private String[] buttons;
   private int[] icons;
   private String[] returnValue;
   private int balignment;
   private int alignment;
   private String layout;
   private boolean iconsOnly;
   Panel mainPanel;
   Panel mainCenterPanel;

   public JDPButtons(JDPUser var1, String[] var2, int var3) {
      int[] var4 = new int[var2.length];

      for(int var5 = 0; var5 < var4.length; ++var5) {
         var4[var5] = -1;
      }

      this.drawButtons(var1, var2, var4, var2, 0, var3, (String)null);
   }

   public JDPButtons(JDPUser var1, String[] var2, int[] var3, int var4) {
      this.drawButtons(var1, var2, var3, var2, 1, var4, (String)null);
   }

   public JDPButtons(JDPUser var1, int[] var2, String[] var3, int var4) {
      this.drawButtons(var1, (String[])null, var2, var3, 1, var4, (String)null);
   }

   public JDPButtons(JDPUser var1, String[] var2, int var3, String var4) {
      int[] var5 = new int[var2.length];

      for(int var6 = 0; var6 < var5.length; ++var6) {
         var5[var6] = -1;
      }

      this.drawButtons(var1, var2, var5, var2, 0, var3, var4);
   }

   public JDPButtons(JDPUser var1, String[] var2, int[] var3, int var4, String var5) {
      this.drawButtons(var1, var2, var3, var2, 1, var4, var5);
   }

   public JDPButtons(JDPUser var1, int[] var2, String[] var3, int var4, String var5) {
      this.drawButtons(var1, (String[])null, var2, var3, 1, var4, var5);
   }

   public JDPButtons(JDPUser var1, int var2) {
      String[] var3 = new String[2];
      if (var2 == HORIZONTAL) {
         var3[0] = "Left";
         var3[1] = "Right";
      }

      if (var2 == VERTICAL) {
         var3[0] = "Up";
         var3[1] = "Down";
      }

      this.drawButtons(var1, (String[])null, (int[])null, var3, -1, var2, (String)null);
   }

   public String[] getLabels() {
      return this.returnValue;
   }

   public boolean getIconsOnly() {
      return this.iconsOnly;
   }

   public void setIconsOnly(boolean var1) {
      if (this.button != null) {
         for(int var2 = 0; var2 < this.button.length; ++var2) {
            this.button[var2].setIconOnly(var1);
         }
      }

      if (this.iconsOnly != var1) {
         this.iconsOnly = var1;
         ((Container)this).removeAll();
         if (var1) {
            this.drawButtons(this.user, (String[])null, this.icons, this.returnValue, this.balignment, this.alignment, this.layout);
         } else {
            this.drawButtons(this.user, this.returnValue, this.icons, this.returnValue, this.balignment, this.alignment, this.layout);
         }
      }
   }

   public void disable() {
      if (this.button != null) {
         for(int var1 = 0; var1 < this.button.length; ++var1) {
            if (this.button[var1] != null) {
               this.button[var1].disable();
               this.button[var1].repaint();
            }
         }

      }
   }

   public void enable() {
      if (this.button != null) {
         for(int var1 = 0; var1 < this.button.length; ++var1) {
            if (this.button[var1] != null) {
               this.button[var1].enable();
               this.button[var1].repaint();
            }
         }

      }
   }

   public Insets insets() {
      return new Insets(0, 3, 0, 3);
   }

   public int getButtonCount() {
      return this.button.length;
   }

   public void setPressed(String var1) {
      for(int var2 = 0; var2 < this.button.length; ++var2) {
         if ((var1 == null || this.button[var2] == null || this.button[var2].getLabel() == null || !this.button[var2].getLabel().equals(var1)) && (var1 == null || this.returnValue[var2] == null || !this.returnValue[var2].equals(var1))) {
            this.button[var2].setPressed(false);
         } else {
            this.button[var2].setPressed(true);
         }
      }

   }

   public String getPressed() {
      for(int var1 = 0; var1 < this.button.length; ++var1) {
         if (this.button[var1].isPressed()) {
            if (this.button[var1].getLabel() != null) {
               return this.button[var1].getLabel();
            }

            return this.returnValue[var1];
         }
      }

      return null;
   }

   public void setButtonCount(int var1) {
      if (this.button.length != var1) {
         this.mainCenterPanel.removeAll();
         JDPButton[] var2 = this.button;
         this.button = new JDPButton[var1];
         int var3 = var1;
         if (var2.length < var1) {
            var3 = var2.length;
         }

         System.arraycopy(var2, 0, this.button, 0, var3);

         for(int var4 = var3; var4 < this.button.length; ++var4) {
            this.button[var4] = new JDPButton("JDPButtons" + Integer.toString(var4 + 1), this.balignment);
         }

         this.returnValue = new String[this.button.length];

         for(int var5 = 0; var5 < this.button.length; ++var5) {
            this.mainCenterPanel.add(this.button[var5]);
            this.returnValue[var5] = this.button[var5].getLabel();
         }

      }
   }

   public void setIconImagePath(String var1) {
      for(int var2 = 0; var2 < this.button.length; ++var2) {
         this.button[var2].setIconImagePath(this.user, var1);
      }

   }

   public String getIconImagePath() {
      return this.button[0].getIconImagePath();
   }

   public void setBackground(Color var1) {
      if (this.button != null) {
         for(int var2 = 0; var2 < this.button.length; ++var2) {
            if (this.button[var2] != null) {
               this.button[var2].setBackground(var1);
               this.button[var2].repaint();
            }
         }

      }
   }

   public void paint(Graphics var1) {
      if (this.button != null) {
         for(int var2 = 0; var2 < this.button.length; ++var2) {
            if (this.button[var2] != null) {
               this.button[var2].layout();
            }
         }

      }
   }

   public int getIcon(int var1) {
      return this.button[var1].getIcon();
   }

   public void setIcon(int var1, int var2) {
      if (var1 < this.button.length) {
         this.button[var1].setIcon(var2);
      }

   }

   public void setIcon(int var1, String var2) {
      if (var1 < this.button.length) {
         this.button[var1].setIcon(var2);
      }

   }

   public void setFont(Font var1) {
      if (this.button != null) {
         for(int var2 = 0; var2 < this.button.length; ++var2) {
            if (this.button[var2] != null) {
               this.button[var2].setFont(var1);
            }
         }

      }
   }

   public Font getFont() {
      if (((Component)this).getParent() != null) {
         return ((Component)this).getParent().getFont();
      } else if (this.button != null && this.button.length >= 1 && this.button[0] != null) {
         return this.button[0].getFont();
      } else {
         return ((Component)this).getParent() != null ? ((Component)this).getParent().getFont() : null;
      }
   }

   public boolean isIconsOnly() {
      return this.iconsOnly;
   }

   void drawButtons(JDPUser var1, String[] var2, int[] var3, String[] var4, int var5, int var6, String var7) {
      this.user = var1;
      this.buttons = var2;
      this.icons = var3;
      this.returnValue = var4;
      this.balignment = var5;
      this.alignment = var6;
      this.layout = var7;
      this.iconsOnly = false;
      if (var2 == null && var3 != null) {
         this.iconsOnly = true;
      }

      String var8 = var7;
      if (var6 == VERTICAL && var7 == null) {
         var8 = "North";
      }

      if (var6 == HORIZONTAL && var7 == null) {
         var8 = "West";
      }

      this.mainPanel = new Panel();
      this.mainCenterPanel = new Panel();
      int var9 = var4.length;
      if (var6 == VERTICAL) {
         ((Container)this).setLayout(new BorderLayout());
         this.mainPanel.setLayout(new BorderLayout(2, 2));
         this.mainCenterPanel.setLayout(new GridLayout(var9, 1));
      } else {
         ((Container)this).setLayout(new BorderLayout());
         this.mainPanel.setLayout(new BorderLayout(2, 2));
         this.mainCenterPanel.setLayout(new GridLayout(1, var9, 0, 0));
      }

      if (this.button == null) {
         this.button = new JDPButton[var9];
         this.returnValue = var4;

         for(int var10 = 0; var10 < var9; ++var10) {
            if (var4[var10] != null && var4[var10].length() > 0) {
               if (var2 != null) {
                  this.returnValue[var10] = var2[var10];
                  this.button[var10] = new JDPButton(var2[var10], var3[var10], var5);
                  this.button[var10].setIconOnly(this.iconsOnly);
               } else if (var3 != null) {
                  this.button[var10] = new JDPButton(var3[var10], var4[var10], var5);
                  this.button[var10].setIconOnly(this.iconsOnly);
               } else if (var6 == VERTICAL) {
                  this.button[var10] = new JDPButton(var10 + 3);
               } else {
                  this.button[var10] = new JDPButton(var10 + 1);
               }

               this.mainCenterPanel.add(this.button[var10]);
            } else {
               this.mainCenterPanel.add(new Panel());
            }
         }
      } else {
         for(int var11 = 0; var11 < var9; ++var11) {
            this.button[var11].setIconOnly(this.iconsOnly);
            if (var4[var11] != null && var4[var11].length() > 0) {
               this.mainCenterPanel.add(this.button[var11]);
            } else {
               this.mainCenterPanel.add(new Panel());
            }
         }
      }

      this.mainPanel.add(var8, this.mainCenterPanel);
      ((Container)this).add("Center", this.mainPanel);
      this.setFont(var1.plainFont);
      ((Component)this).show();
      ((Component)this).paintAll(((Component)this).getGraphics());
   }

   public JDPButton getButton(int var1) {
      return var1 < this.button.length ? this.button[var1] : null;
   }

   public void setStayOn(boolean var1) {
      this.stayOn = var1;

      for(int var2 = 0; var2 < this.button.length; ++var2) {
         this.button[var2].setStayOn(true);
      }

      this.setPressed(this.button[0].getLabel());
   }

   public boolean getStayOn() {
      return this.stayOn;
   }

   public int getAlignment() {
      return this.alignment;
   }

   public void setAlignment(int var1) {
      if (this.alignment != var1) {
         this.alignment = var1;
         ((Container)this).removeAll();
         this.drawButtons(this.user, this.buttons, this.icons, this.returnValue, this.balignment, this.alignment, this.layout);
      }
   }

   public static int getAlignmentValue(String var0) {
      for(int var1 = 0; var1 < alignmentValues.length; ++var1) {
         if (var0.equals(alignmentValues[var1])) {
            return var1;
         }
      }

      return -1;
   }

   public void setForeground(Color var1) {
      if (this.button != null) {
         for(int var2 = 0; var2 < this.button.length; ++var2) {
            if (this.button[var2] != null) {
               this.button[var2].setForeground(var1);
               this.button[var2].repaint();
            }
         }

      }
   }

   public void setEnabled(boolean var1) {
      if (this.button != null) {
         for(int var2 = 0; var2 < this.button.length; ++var2) {
            if (this.button[var2] != null) {
               if (var1) {
                  this.button[var2].enable();
               } else {
                  this.button[var2].disable();
               }

               this.button[var2].repaint();
            }
         }

      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 1001:
            if (var1.target instanceof Button && this.stayOn) {
               String var2 = (String)var1.arg;
               this.setPressed(var2);
            }

            if (var1.target instanceof JDPButton && this.stayOn) {
               String var3 = (String)var1.arg;
               this.setPressed(var3);
            }

            return false;
         default:
            return false;
      }
   }

   public void setLabel(int var1, String var2) {
      if (var1 >= 0 && var1 < this.button.length && var2 != null) {
         this.button[var1].setLabel(var2);
         this.returnValue[var1] = var2;
      }
   }
}
