import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPFilePicker extends JDPClassLayout implements Runnable {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPDragItem dragPanel;
   JDPSplitPanel Main;
   JDPList List1;
   JDPTreePicker TreeStructure1;
   JDPStatusMessage mainmsg;
   String lastDir = "";
   String filter = "";
   Label fileLabel;
   Label fileTypeLabel;
   TextField fileName;
   JDPChoice fileType;
   JDPButtons JDPButtons1;
   JDPButtons JDPButtons2;
   JDPButtons JDPButtonsF;
   JDPButton newFolderButton;
   Panel buttonPanel;
   static Vector dirCache;
   String dragKey;
   String dropMessage;
   String serverSeparator;
   JDPTreeBranch lastSelectedBranch;
   String saveFileName;
   public static final int LOAD = 0;
   public static final int SAVE = 1;
   public static final int NEWFOLDER = 2;
   int mode;
   int prevMode;

   public String getFileName(JDPTreeBranch var1) {
      JDPTreeBranch[] var2 = this.List1.getTreeBranch(var1);
      if (var2 == null) {
         return null;
      } else {
         String var3 = var1.name;
         int var4 = var3.indexOf("|");
         if (var4 >= 0) {
            var3 = var3.substring(0, var4);
         }

         return var3;
      }
   }

   public void clearFilter() {
      this.fileType.clear();
   }

   public String getSelectedFile() {
      String var1 = this.fileName.getText();
      if (!var1.equals("") && this.fileType.getItemCount() > 0) {
         String var2 = this.user.u.replace(this.filter, "*", "");
         if (var1.indexOf(var2) < 0) {
            var1 = this.user.u.replace(this.filter, "*", var1);
         }
      }

      StringTokenizer var4 = new StringTokenizer(var1, ",~!@#$%^&*()+=|\\`'\":;{}[]?/<>");

      for(var1 = ""; var4.hasMoreTokens(); var1 = var1 + var4.nextToken()) {
      }

      this.fileName.setText(var1);
      return var1;
   }

   Vector retrieveDir(String var1) {
      if (dirCache == null) {
         dirCache = new Vector();
      }

      for(int var2 = 0; var2 < dirCache.size(); ++var2) {
         Vector var3 = (Vector)dirCache.elementAt(var2);
         String var4 = (String)var3.elementAt(0);
         if (var4.equals(this.jaggSQL.getServer() + var1)) {
            return (Vector)var3.elementAt(1);
         }
      }

      this.user.mainmsg.setStatusMsg("Retrieving directory listing...", 0);
      this.jaggSQL.setDSN(this.user.jaggDSN);
      this.jaggSQL.setFCTN("ListFiles");
      this.jaggSQL.setFCTNP(var1 + ";");
      Vector var5 = new Vector();
      this.jaggSQL.execSQL("", var5);
      Vector var6 = new Vector();
      var6.addElement(this.jaggSQL.getServer() + var1);
      var6.addElement(var5);
      dirCache.addElement(var6);
      return var5;
   }

   void clearCachedFiles(String var1) {
      if (dirCache != null) {
         for(int var2 = 0; var2 < dirCache.size(); ++var2) {
            Vector var3 = (Vector)dirCache.elementAt(var2);
            String var4 = (String)var3.elementAt(0);
            if (var4.equals(this.jaggSQL.getServer() + var1)) {
               dirCache.removeElementAt(var2);
            }
         }

      }
   }

   public String getSelectedItem() {
      return this.List1.getSelectedKey();
   }

   public void setDropMessage(String var1) {
      this.dropMessage = var1;
   }

   public String getDropMessage() {
      return this.dropMessage;
   }

   public JDPTreePicker getFolderTree() {
      return this.TreeStructure1;
   }

   public String getSelectedDirectory() {
      return this.lastDir;
   }

   public void setSelectedDirectory(String var1) {
      this.lastDir = var1;
      this.loadFiles(var1, true);
   }

   public String getSeparator() {
      if (this.serverSeparator != null) {
         return this.serverSeparator;
      } else {
         if (!JDPJagg.useJaggServer) {
            this.serverSeparator = "\\";
         } else {
            this.jaggSQL.setFCTN("GetPlatform");
            this.jaggSQL.setFCTNP("");
            Vector var1 = new Vector();
            int var2 = this.jaggSQL.execSQL("", var1);
            if (var2 >= 1) {
               this.serverSeparator = (String)var1.elementAt(0);
            } else {
               this.serverSeparator = "\\";
            }

            this.jaggSQL.setFCTN("");
         }

         return this.serverSeparator;
      }
   }

   public String getSelectedFullPath() {
      return this.getSelectedDirectory() + this.getSeparator() + this.getSelectedFile();
   }

   public void setAutoScroll(boolean var1) {
      this.TreeStructure1.autoScrollOn = var1;
      this.List1.autoScrollOn = var1;
   }

   public boolean getAutoScroll() {
      return this.TreeStructure1.autoScrollOn;
   }

   public void loadAllDrives() {
      int[] var1 = new int[]{4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
      String[] var2 = new String[32];
      boolean[] var3 = new boolean[32];
      String[] var4 = new String[32];
      String[] var5 = new String[32];
      this.TreeStructure1.setDropKeys(var4);
      this.TreeStructure1.setDragAndDrop((boolean[])null);
      this.TreeStructure1.setDropMessages(var5);
      var3[1] = false;
      this.TreeStructure1.setExpanded(var3);
      var1[1] = 9;
      JDPJagg var6 = new JDPJagg(this.user.jaggPath);
      var6.setDSN(this.user.jaggDSN);
      var6.setFCTN("GetDrives");
      var6.setFCTNP("");
      Vector var7 = new Vector();
      int var8 = var6.execSQL("", var7);

      for(int var9 = 0; var9 < var8; ++var9) {
         var2[0] = (String)var7.elementAt(var9);
         this.TreeStructure1.addEntry(var2, var1, var2[0], false);
      }

   }

   public String[] getFiles() {
      return this.List1.getItemKeys(8);
   }

   public void addFilter(String var1, String var2) {
      this.fileType.addItem(var1, var2);
      this.setFilter(this.fileType.getSelectedKey());
      this.fileType.layoutChoice();
   }

   public void setMultipleSelections(boolean var1) {
      this.List1.setMultipleSelections(var1);
   }

   public String getDirectoryPath(JDPTreeBranch var1) {
      String var2 = null;
      JDPTreeBranch[] var3 = this.TreeStructure1.getTreeBranch(var1);
      if (var3 != null) {
         var2 = "";

         for(int var4 = 0; var4 < var3.length; ++var4) {
            if (var4 > 1) {
               var2 = var2 + this.getSeparator() + var3[var4].name;
            } else {
               var2 = var2 + var3[var4].name;
            }
         }
      } else {
         var3 = this.List1.getTreeBranch(var1);
         if (var3 != null) {
            String var7 = var1.name;
            int var5 = var7.indexOf("|");
            if (var5 >= 0) {
               var7 = var7.substring(0, var5);
            }

            var2 = this.getSelectedDirectory() + this.getSeparator() + var7;
         }
      }

      return var2;
   }

   public void setMode(int var1) {
      if (var1 == 1) {
         this.fileLabel.setText("File name:     ");
         this.fileTypeLabel.show();
         this.fileType.show();
         ((CardLayout)this.buttonPanel.getLayout()).show(this.buttonPanel, "Save");
      } else if (var1 == 0) {
         this.fileLabel.setText("File name:     ");
         this.fileTypeLabel.show();
         this.fileType.show();
         ((CardLayout)this.buttonPanel.getLayout()).show(this.buttonPanel, "Load");
      } else if (var1 == 2) {
         if (this.mode != 2) {
            this.prevMode = this.mode;
         }

         this.fileLabel.setText("New Directory:");
         this.fileTypeLabel.hide();
         this.fileType.hide();
         ((CardLayout)this.buttonPanel.getLayout()).show(this.buttonPanel, "NewFolder");
      }

      this.mode = var1;
   }

   public void reloadSelectedDirectory() {
      this.clearCachedFiles(this.getSelectedDirectory());
      this.loadFiles(this.getSelectedDirectory(), false);
   }

   void loadSelectedDirectory(JDPTreeBranch var1, boolean var2) {
      String[] var3 = this.TreeStructure1.getTreeBranchNames(var1);
      if (var3 != null) {
         this.loadFiles(var3, var2);
      }

   }

   public void selectFilter(String var1) {
      this.fileType.select(var1);
      this.setFilter(this.fileType.getSelectedKey());
   }

   void setFilter(String var1) {
      this.filter = var1;
      if (var1 == null) {
         this.List1.hide();
         this.List1.clear();
      } else {
         this.List1.show();
      }
   }

   public String getFilter() {
      return this.filter;
   }

   public void loadFiles(String var1, boolean var2) {
      int var3 = 0;
      String[] var4 = new String[32];

      for(StringTokenizer var5 = new StringTokenizer(var1, this.getSeparator()); var5.hasMoreTokens(); var4[var3++] = var5.nextToken()) {
      }

      this.loadFiles(var4, var2);
   }

   public void setDragKey(String var1) {
      this.dragKey = var1;
   }

   public String getDragKey() {
      return this.dragKey;
   }

   public void loadFiles(String[] var1, boolean var2) {
      int[] var3 = new int[]{4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
      int var4 = 0;
      String[] var5 = new String[32];
      String var6 = "";
      boolean[] var7 = new boolean[32];
      String[] var8 = new String[32];
      String[] var9 = new String[32];
      if (!var2 || !var6.equals(this.lastDir)) {
         this.List1.clear();
      }

      if (this.getSeparator().equals("\\")) {
         var3[1] = 9;
      }

      if (this.getSeparator().equals("\\") && (var1[0] == null || var1[0].indexOf(":") < 0) && (var1.length <= 1 || var1[1] == null || var1[1].indexOf(":") < 0)) {
         String[] var10 = new String[var1.length + 1];
         var10[0] = "C:";
         System.arraycopy(var1, 0, var10, 1, var1.length);
         var1 = var10;
      }

      for(int var25 = 0; var25 < var1.length; ++var25) {
         if (var1[var25] != null && !var1[var25].equals("")) {
            var7[var25] = true;
            var5[var4++] = var1[var25];
            if (var1[var25].indexOf(":") < 0) {
               var6 = var6 + this.getSeparator() + var1[var25];
            } else {
               var6 = var6 + var1[var25];
            }

            var8[var25] = this.dragKey;
            var9[var25] = this.dropMessage;
         }
      }

      var8[var4] = this.dragKey;
      var9[var4] = this.dropMessage;
      var8[var4 + 1] = this.dragKey;
      var9[var4 + 1] = this.dropMessage;
      var8[var4 + 2] = this.dragKey;
      var9[var4 + 2] = this.dropMessage;
      this.TreeStructure1.setDropKeys(var8);
      this.TreeStructure1.setDragAndDrop((boolean[])null);
      this.TreeStructure1.setDropMessages(var9);
      var5[var4 + 1] = "";
      var7[var4] = false;
      this.TreeStructure1.setExpanded(var7);
      if (var6.length() == 0) {
         var6 = this.getSeparator();
         this.TreeStructure1.treeRoot.expanded = true;
      }

      if (!var6.startsWith(this.getSeparator()) && var6.indexOf(":") < 0) {
         var6 = this.getSeparator() + var6;
      }

      this.lastDir = var6;
      Vector var26 = this.retrieveDir(var6);
      int var11 = var26.size();
      String var12 = JDPDate.getDefaultFormat() + " hh:mm AM";
      int var15 = 0;
      int var16 = 0;
      Long var17 = new Long(0L);
      if (var11 > 0) {
         var5[var4] = null;
         this.TreeStructure1.addEntry(var5, var3, var5[0], true);

         for(int var18 = 0; var18 < var26.size(); ++var18) {
            StringTokenizer var19 = new StringTokenizer((String)var26.elementAt(var18), this.jaggSQL.getSEP());
            var5[var4] = var19.nextToken();
            String var20 = var19.nextToken();
            if (var20.equals("D")) {
               this.TreeStructure1.addEntry(var5, var3, var5[0], false);
               if (var2) {
                  ++var15;
               } else {
                  this.List1.setDragKey(this.dragKey);
                  this.List1.setDropMessage(this.dropMessage);
                  Long var13 = Long.valueOf(var19.nextToken());
                  Long var14 = Long.valueOf(var19.nextToken());
                  Object[] var21 = new Object[]{" " + var5[var4], var17, var14};
                  Long.toString((var13 + 512L) / 1024L);
                  Date var22 = new Date(var14);
                  String[] var23 = new String[]{var5[var4], "", JDPDate.format(var22, var12)};
                  this.List1.addItem(var23, var5[var4], 0, var21);
                  ++var16;
               }
            } else if (!var2 && (this.filter == null || this.filter.length() == 0 || var5[var4].endsWith(this.filter.substring(1)))) {
               this.List1.setDragKey(this.dragKey);
               this.List1.setDropMessage((String)null);
               Long var27 = Long.valueOf(var19.nextToken());
               Long var28 = Long.valueOf(var19.nextToken());
               Object[] var31 = new Object[]{var5[var4], var27, var28};
               String var32 = Long.toString((var27 + 512L) / 1024L);
               Date var33 = new Date(var28);
               String[] var24 = new String[]{var5[var4], var32 + "KB", JDPDate.format(var33, var12)};
               this.List1.addItem(var24, var5[var4], 8, var31);
               ++var15;
            }
         }
      }

      String var29 = "";
      if (var2) {
         var29 = Integer.toString(var15) + " directories found.";
         if (var15 == 1) {
            var29 = "1 directory found.";
         }

         if (var15 == 0) {
            this.loadFiles(var1, false);
            return;
         }
      } else {
         if (var16 > 0) {
            var29 = Integer.toString(var16) + " directories found.   ";
            if (var15 == 1) {
               var29 = "1 directory found.   ";
            }
         }

         if (var15 == 1) {
            var29 = var29 + "1 file found.";
         } else {
            var29 = var29 + Integer.toString(var15) + " files found.";
         }
      }

      this.mainmsg.setInfoMsg(var29, 0);
      this.TreeStructure1.sortTree(this.TreeStructure1.treeRoot, true);
      this.TreeStructure1.select(var1);
      this.user.mainmsg.clearStatusMsg();
   }

   public JDPTreePicker getFileList() {
      return this.List1;
   }

   public void setDragPanel(JDPDragItem var1) {
      this.dragPanel = var1;
      if (this.TreeStructure1 != null) {
         this.TreeStructure1.setDragPanel(var1);
      }

      if (this.List1 != null) {
         this.List1.setDragPanel(var1);
      }

   }

   public JDPDragItem getDragPanel() {
      return this.dragPanel;
   }

   public void createNewFolder(String var1) {
      var1 = this.user.u.replace(var1, ".", "");
      this.user.mainmsg.setStatusMsg("Creating new folder...", 0);
      this.jaggSQL.setFCTN("CreateFolder");
      this.jaggSQL.setFCTNP(var1 + ";");
      Vector var2 = new Vector();
      this.jaggSQL.execSQL("", var2);
      this.reloadSelectedDirectory();
   }

   public void clear() {
      this.TreeStructure1.clear();
      this.List1.clear();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPList) {
               if (this.List1.getSelectedIcon() != 0) {
                  this.fileName.setText(this.List1.getSelectedKey());
                  Event var10 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers);
                  super.postEvent(var10);
                  return true;
               }

               return true;
            } else {
               if (var1.target instanceof JDPTreePicker) {
                  String var9 = (String)var1.arg;
                  if (var1.target.equals(this.TreeStructure1) && var9.equals("BranchOpen")) {
                     this.loadSelectedDirectory(this.TreeStructure1.getCurrentBranch(), true);
                     return true;
                  }

                  if (var1.target.equals(this.TreeStructure1) && (var9.equals("BranchSelect") || var9.equals("LeafSelect"))) {
                     JDPTreeBranch var3 = this.TreeStructure1.getCurrentBranch();
                     if (this.lastSelectedBranch != null && this.lastSelectedBranch.equals(var3)) {
                        this.reloadSelectedDirectory();
                     } else {
                        this.loadSelectedDirectory(this.TreeStructure1.getCurrentBranch(), false);
                        this.lastSelectedBranch = var3;
                     }

                     return true;
                  }
               }

               return false;
            }
         case 1001:
            if (!var1.target.equals(this.TreeStructure1)) {
               if (var1.target instanceof JDPList) {
                  if (this.List1.getSelectedIcon() == 0) {
                     this.loadFiles(this.getSelectedDirectory() + this.getSeparator() + this.List1.getSelectedKey(), false);
                  } else {
                     this.fileName.setText(this.List1.getSelectedKey());
                     Event var8 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers, "");
                     super.postEvent(var8);
                  }

                  return true;
               }

               if (var1.target.equals(this.JDPButtons1.button[0])) {
                  Event var7 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers, var1.arg);
                  super.postEvent(var7);
                  return true;
               }

               if (var1.target.equals(this.JDPButtons2.button[0])) {
                  Event var6 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers, var1.arg);
                  super.postEvent(var6);
                  return true;
               }

               if (var1.target.equals(this.JDPButtons1.button[1])) {
                  Event var5 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers, var1.arg);
                  super.postEvent(var5);
                  return true;
               }

               if (var1.target.equals(this.JDPButtons2.button[1])) {
                  Event var4 = new Event(this, var1.when, var1.id, var1.x, var1.y, var1.key, var1.modifiers, var1.arg);
                  super.postEvent(var4);
                  return true;
               }

               if (var1.target.equals(this.newFolderButton)) {
                  this.saveFileName = this.fileName.getText();
                  this.fileName.setText("");
                  this.setMode(2);
                  return true;
               }

               if (var1.target.equals(this.JDPButtonsF.button[0])) {
                  if (this.fileName.getText().equals("")) {
                     this.mainmsg.setStatusMsg("You must first enter a Folder name.", 10);
                     return true;
                  }

                  this.createNewFolder(this.getSelectedDirectory() + this.getSeparator() + this.fileName.getText());
                  this.setMode(this.prevMode);
                  if (this.saveFileName != null) {
                     this.fileName.setText(this.saveFileName);
                  }

                  return true;
               }

               if (var1.target.equals(this.JDPButtonsF.button[1])) {
                  this.setMode(this.prevMode);
                  return true;
               }

               if (var1.target instanceof JDPChoice) {
                  this.setFilter(this.fileType.getSelectedKey());
                  this.loadSelectedDirectory(this.TreeStructure1.getCurrentBranch(), false);
                  this.fileName.setText("");
                  return true;
               }

               return false;
            }

            JDPTreeBranch var2 = this.TreeStructure1.getCurrentBranch();
            if (this.lastSelectedBranch != null && this.lastSelectedBranch.equals(var2)) {
               this.reloadSelectedDirectory();
            } else {
               this.loadSelectedDirectory(this.TreeStructure1.getCurrentBranch(), true);
               this.loadSelectedDirectory(this.TreeStructure1.getCurrentBranch(), false);
               this.lastSelectedBranch = var2;
            }

            return true;
         default:
            return false;
      }
   }

   public void run() {
      this.loadAllDrives();
   }

   public String getFilePath(JDPTreeBranch var1) {
      return this.getSelectedDirectory() + this.getSeparator() + this.getFileName(var1);
   }

   public String[] getSelectedItems() {
      return this.List1.getSelectedKeys();
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.Main = new JDPSplitPanel(var1);
      this.List1 = new JDPList(var1, var2, this.dragPanel);
      this.TreeStructure1 = new JDPTreePicker(var1, var2, this.dragPanel);
      int[] var4 = new int[]{4, 0, 0, 0, 0, 0, 0};
      this.TreeStructure1.setIcons(var4);
      this.TreeStructure1.setRoot("", true);
      this.TreeStructure1.setMinWidth(200);
      this.TreeStructure1.setResizingAllowed(false);
      this.mainmsg = new JDPStatusMessage(var1);
      this.mainmsg.remove(this.mainmsg.eastMessage);
      this.fileName = new TextField("", 18);
      this.fileType = new JDPChoice();
      JDPScrollPanel var5 = new JDPScrollPanel();
      String[] var6 = new String[]{"Open", "Cancel"};
      int[] var7 = new int[]{JDPButton.getIconValue("Load"), JDPButton.getIconValue("Undo")};
      this.JDPButtons1 = new JDPButtons(var1, var6, var7, JDPButtons.getAlignmentValue("Vertical"));
      String[] var8 = new String[]{"Save", "Cancel"};
      int[] var9 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("Undo")};
      this.JDPButtons2 = new JDPButtons(var1, var8, var9, JDPButtons.getAlignmentValue("Vertical"));
      String[] var10 = new String[]{"Create", "Cancel"};
      int[] var11 = new int[]{JDPButton.getIconValue("Save"), JDPButton.getIconValue("Undo")};
      this.JDPButtonsF = new JDPButtons(var1, var10, var11, JDPButtons.getAlignmentValue("Vertical"));
      this.Main.add("Left", this.TreeStructure1);
      this.Main.add("Right", this.List1);
      this.fileLabel = new Label("File name:     ", 0);
      this.fileTypeLabel = new Label("File type:     ", 0);
      ((Container)var5).add("Left", this.fileLabel);
      ((Container)var5).add("Right", this.fileName);
      ((Container)var5).add("Left", this.fileTypeLabel);
      ((Container)var5).add("Right", this.fileType);
      Panel var12 = new Panel();
      ((Container)var12).setLayout(new JDPLineLayout(2));
      ((Container)var12).add("Left", var5);
      this.buttonPanel = new Panel();
      this.buttonPanel.setLayout(new CardLayout());
      this.buttonPanel.add("Load", this.JDPButtons1);
      this.buttonPanel.add("Save", this.JDPButtons2);
      this.buttonPanel.add("NewFolder", this.JDPButtonsF);
      this.buttonPanel.add("Blank", new Panel());
      this.newFolderButton = new JDPButton(45, "NewFolder", 0);
      ((Container)var12).add("Left", this.buttonPanel);
      ((Container)var12).add("Left", this.newFolderButton);
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new BorderLayout(1, 1));
      ((Container)var13).add("South", var12);
      ((Container)var13).add("Center", this.Main);
      ((Container)this).add("Center", var13);
      ((Container)this).add("South", this.mainmsg);
      this.List1.setColumns(3);
      this.List1.setColumnHeader(0, "Name");
      this.List1.setColumnHeader(1, "Size");
      this.List1.setColumnHeader(2, "Modified");
      this.List1.setColumnWidth(0, 180);
      this.List1.setColumnWidth(1, 60);
      this.List1.setColumnWidth(2, 100);
      this.List1.setRightJustify(1, true);
      this.TreeStructure1.setBackground(var1.u._cvtcolor("White"));
      this.popuppanel.addComponent(this.newFolderButton, "New Folder", "Create a new Folder in the current Directory");
      var1.gParm.addElement(this);
      (new Thread(this)).start();
   }

   public void setSelectedFile(String var1) {
      this.fileName.setText(var1);
      int var2 = this.List1.getKeyItem(var1);
      if (var2 >= 0) {
         this.List1.select(var2);
         this.List1.makeVisible(var2);
      }

   }
}
