import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.LayoutManager;
import java.awt.Panel;
import java.awt.TextComponent;
import java.net.URL;
import java.util.Vector;

public class JDPFormatDoc {
   JDPUser user;
   public static final int HTML = 0;
   public static final int CSV = 1;
   public static final int PLAIN = 2;
   public static final int EXCEL = 3;
   Vector closingStack;
   StringBuffer output;
   int docType;
   // $FF: renamed from: NL java.lang.String
   static String field_0 = "\r\n";
   static String TAB = "\t";
   static int docNumber;

   public void initDocument(int var1) {
      this.docType = var1;
      this.output = new StringBuffer();
      this.closingStack = new Vector();
      switch (var1) {
         case 0:
            this.output.append("<html>");
            this.output.append(field_0);
            this.closingStack.addElement("</html>");
            return;
         case 1:
         case 2:
         case 3:
         default:
      }
   }

   public void setBody(String var1) {
      switch (this.docType) {
         case 0:
            this.output.append("<body " + var1 + ">");
            this.output.append(field_0);
            this.closingStack.addElement("</body>");
            return;
         case 1:
         case 2:
         case 3:
         default:
      }
   }

   String createFinishOutput(int var1) {
      StringBuffer var2 = new StringBuffer();

      for(int var3 = this.closingStack.size() - 1; var3 >= var1; --var3) {
         String var4 = (String)this.closingStack.elementAt(var3);
         var2.append(var4);
         var2.append(field_0);
         this.closingStack.removeElementAt(var3);
      }

      return var2.toString();
   }

   public void loadDocument() {
      this.user.mainmsg.setStatusMsg("Loading document to external viewer...", 0);
      String var1 = this.user.toString();
      if (this.user.cust != null) {
         var1 = this.user.cust.getUsername();
      }

      String var2 = "";
      switch (this.docType) {
         case 0:
            var2 = ".html";
            break;
         case 1:
            var2 = ".txt";
            break;
         case 2:
            var2 = ".txt";
            break;
         case 3:
            var2 = ".xls";
      }

      String var3 = this.user.JDesignerPro.JDPDirectory + "temp" + JDesignerPro.serverSeparator + var1 + var2;
      if (!this.user.u.writeToFile(var3, this.getFinishedDocument(), "w+")) {
         this.user.mainmsg.setStatusMsg("Failed to create temporary file", 10);
      } else {
         if (JDesignerPro.executable) {
            String var4 = this.user.u.getRelatedAppPath(var2, "Please locate the application to open this " + var2 + " file", false);
            String var5 = var4 + " " + var3;

            try {
               Runtime var6 = Runtime.getRuntime();
               var6.exec(var5);
            } catch (Exception var9) {
               ((Throwable)var9).printStackTrace();
            }
         } else {
            try {
               String var10 = this.user.getWWWroot() + "temp/" + var1 + var2;
               this.user.JDesignerPro.getAppletContext().showDocument(new URL(var10));
            } catch (Exception var8) {
               ((Throwable)var8).printStackTrace();
            }
         }

         this.user.mainmsg.clearStatusMsg();
      }
   }

   public void addComponent(Component var1) {
      this.output.append(this.addNextComponent(var1));
   }

   public String createDetailLine(String[] var1) {
      StringBuffer var2 = new StringBuffer();
      boolean var3 = false;
      switch (this.docType) {
         case 0:
            var2.append(TAB);
            var2.append("<tr>");

            for(int var10 = 0; var10 < var1.length; ++var10) {
               if (var1[var10] != null && !var1[var10].equals("")) {
                  var3 = true;
               }

               var2.append("<td>");
               if (var1[var10] != null) {
                  var2.append(var1[var10]);
               }

               var2.append("  </td>");
            }

            var2.append("</tr>");
            var2.append(field_0);
            if (!var3) {
               var2.setLength(0);
            }
            break;
         case 1:
            for(int var9 = 0; var9 < var1.length; ++var9) {
               if (var1[var9] != null && !var1[var9].equals("")) {
                  var3 = true;
               }

               if (var9 > 0) {
                  var2.append(",");
               }

               var2.append("\"");
               if (var1[var9] != null) {
                  var2.append(var1[var9]);
               }

               var2.append("\"");
            }

            var2.append(field_0);
            break;
         case 2:
            for(int var8 = 0; var8 < var1.length; ++var8) {
               if (var1[var8] != null && !var1[var8].equals("")) {
                  var3 = true;
               }

               if (var8 > 0) {
                  var2.append(TAB);
               }

               if (var1[var8] != null) {
                  var2.append(var1[var8]);
               }
            }

            var2.append(field_0);
            break;
         case 3:
            for(int var4 = 0; var4 < var1.length; ++var4) {
               if (var1[var4] != null && !var1[var4].equals("")) {
                  var3 = true;
               }

               if (var4 > 0) {
                  var2.append(TAB);
               }

               if (var1[var4] != null) {
                  var2.append(var1[var4]);
               }
            }

            var2.append(field_0);
      }

      return var2.toString();
   }

   String addPanel(Panel var1) {
      StringBuffer var2 = new StringBuffer();
      LayoutManager var3 = ((Container)var1).getLayout();
      if (!(var3 instanceof JDPLineLayout) && !(var3 instanceof FlowLayout) && !(var3 instanceof CardLayout)) {
         if (var3 instanceof BorderLayout) {
            int var14 = this.closingStack.size();
            String[] var17 = new String[0];
            var2.append(this.createDetailHeader(var17, 0, 2, 0));
            String[] var20 = new String[1];

            for(int var23 = 0; var23 < ((Container)var1).countComponents(); ++var23) {
               var20[0] = this.addNextComponent(((Container)var1).getComponent(var23));
               var2.append(this.createDetailLine(var20));
            }

            var2.append(this.createFinishOutput(var14));
         } else if (var3 instanceof GridLayout) {
            GridLayout var15 = (GridLayout)var3;
            int var18 = this.closingStack.size();
            int var21 = 2;

            try {
               if (!System.getProperty("java.version").startsWith("1.0") && !System.getProperty("java.vendor").startsWith("Netscape")) {
                  var21 = var15.getRows();
               }
            } catch (Exception var13) {
            }

            int var24 = (int)Math.ceil((double)((Container)var1).countComponents() / (double)var21);
            String[] var8 = new String[0];
            var2.append(this.createDetailHeader(var8, 0, 2, 0, "\"100%\""));
            String[] var9 = new String[var24];
            int var10 = 0;

            for(int var11 = 0; var11 < var21; ++var11) {
               for(int var12 = 0; var12 < var24; ++var12) {
                  if (var10 < ((Container)var1).countComponents()) {
                     var9[var12] = this.addNextComponent(((Container)var1).getComponent(var10));
                  } else {
                     var9[var12] = "";
                  }

                  ++var10;
               }

               var2.append(this.createDetailLine(var9));
            }

            var2.append(this.createFinishOutput(var18));
         } else if (var3 instanceof JDPRowLayout) {
            int var16 = this.closingStack.size();
            String[] var19 = new String[0];
            var2.append(this.createDetailHeader(var19, 0, 2, 0));
            JDPRowLayout var22 = (JDPRowLayout)var3;

            for(int var25 = 0; var25 < var22.leftc.length; ++var25) {
               String[] var26 = new String[]{"", ""};
               if (var22.leftc[var25] != null) {
                  var26[0] = this.addNextComponent(var22.leftc[var25]);
               }

               if (var22.rightc[var25] != null) {
                  var26[1] = this.addNextComponent(var22.rightc[var25]);
               }

               var2.append(this.createDetailLine(var26));
            }

            var2.append(this.createFinishOutput(var16));
         }
      } else {
         int var4 = this.closingStack.size();
         String[] var5 = new String[0];
         var2.append(this.createDetailHeader(var5, 0, 0, 0));
         String[] var6 = new String[((Container)var1).countComponents()];

         for(int var7 = 0; var7 < ((Container)var1).countComponents(); ++var7) {
            var6[var7] = this.addNextComponent(((Container)var1).getComponent(var7));
         }

         var2.append(this.createDetailLine(var6));
         var2.append(this.createFinishOutput(var4));
      }

      return var2.toString();
   }

   String addTextComponent(TextComponent var1) {
      StringBuffer var2 = new StringBuffer();
      this.closingStack.size();
      switch (this.docType) {
         case 0:
            var2.append("<font size=" + Integer.toString(((Component)var1).getFont().getSize() - 8));
            if (!((Component)var1).getForeground().equals(Color.black)) {
               var2.append(" color=\"" + JDPUtils._cvtbcolor(((Component)var1).getForeground()) + "\"");
            }

            var2.append(" name=\"" + ((Component)var1).getFont().getName() + "\"");
            var2.append(">");
            var2.append(var1.getText());
            var2.append("</font>");
            break;
         case 1:
            var2.append(var1.getText());
            break;
         case 2:
            var2.append(var1.getText());
            break;
         case 3:
            var2.append(var1.getText());
      }

      return var2.toString();
   }

   String addCheckbox(Checkbox var1) {
      StringBuffer var2 = new StringBuffer();
      this.closingStack.size();
      switch (this.docType) {
         case 0:
            var2.append("<font size=" + Integer.toString(((Component)var1).getFont().getSize() - 8));
            if (!((Component)var1).getForeground().equals(Color.black)) {
               var2.append(" color=\"" + JDPUtils._cvtbcolor(((Component)var1).getForeground()) + "\"");
            }

            var2.append(" name=\"" + ((Component)var1).getFont().getName() + "\"");
            var2.append(">");
            var2.append("[");
            if (var1.getState()) {
               var2.append("x");
            } else {
               var2.append(" ");
            }

            var2.append("] ");
            var2.append(var1.getLabel());
            var2.append("</font>");
            break;
         case 1:
            var2.append("[");
            if (var1.getState()) {
               var2.append("x");
            } else {
               var2.append(" ");
            }

            var2.append("] ");
            var2.append(var1.getLabel());
            break;
         case 2:
            var2.append("[");
            if (var1.getState()) {
               var2.append("x");
            } else {
               var2.append(" ");
            }

            var2.append("] ");
            var2.append(var1.getLabel());
            break;
         case 3:
            var2.append("[");
            if (var1.getState()) {
               var2.append("x");
            } else {
               var2.append(" ");
            }

            var2.append("] ");
            var2.append(var1.getLabel());
      }

      return var2.toString();
   }

   public void addReport(JDPTextGrid var1) {
      this.addGrid(var1, 0);
   }

   public String createHeader(String var1, String var2) {
      StringBuffer var3 = new StringBuffer();
      switch (this.docType) {
         case 0:
            var3.append("<" + var2 + ">");
            var3.append(var1);
            var3.append("</" + var2 + ">");
            var3.append(field_0);
         case 1:
         case 2:
         case 3:
         default:
            return var3.toString();
      }
   }

   public JDPFormatDoc(JDPUser var1) {
      this.user = var1;
   }

   public String createDetailHeader(String[] var1, int var2, int var3, int var4) {
      return this.createDetailHeader(var1, var2, var3, var4, (String)null);
   }

   public String createDetailHeader(String[] var1, int var2, int var3, int var4, String var5) {
      StringBuffer var6 = new StringBuffer();
      switch (this.docType) {
         case 0:
            var6.append("<table border=" + Integer.toString(var2) + " cellpadding=" + Integer.toString(var3) + " cellspacing=" + Integer.toString(var4));
            if (var5 != null) {
               var6.append(" width=" + var5);
            }

            var6.append(">");
            var6.append(field_0);
            this.closingStack.addElement("</table>");
            var6.append(TAB);
            var6.append("<tr>");

            for(int var10 = 0; var10 < var1.length; ++var10) {
               var6.append("<td>");
               var6.append(var1[var10]);
               var6.append("  </td>");
            }

            var6.append("</tr>");
            var6.append(field_0);
            break;
         case 1:
            for(int var9 = 0; var9 < var1.length; ++var9) {
               if (var9 > 0) {
                  var6.append(",");
               }

               var6.append(var1[var9]);
            }

            if (var1.length > 0) {
               var6.append(field_0);
            }
            break;
         case 2:
            for(int var8 = 0; var8 < var1.length; ++var8) {
               if (var8 > 0) {
                  var6.append(TAB);
               }

               var6.append(var1[var8]);
            }

            if (var1.length > 0) {
               var6.append(field_0);
            }
            break;
         case 3:
            for(int var7 = 0; var7 < var1.length; ++var7) {
               if (var7 > 0) {
                  var6.append(TAB);
               }

               var6.append(var1[var7]);
            }

            if (var1.length > 0) {
               var6.append(field_0);
            }
      }

      return var6.toString();
   }

   String addScroll(JDPScrollPanel var1) {
      StringBuffer var2 = new StringBuffer();
      int var3 = this.closingStack.size();
      String[] var4 = new String[0];
      var2.append(this.createDetailHeader(var4, 0, 2, 0));

      for(int var5 = 0; var5 < var1.getLineCount(); ++var5) {
         String[] var6 = new String[]{"", ""};
         if (var1.getLeftComp(var5) != null) {
            var6[0] = this.addNextComponent(var1.getLeftComp(var5));
         }

         if (var1.getRightComp(var5) != null) {
            var6[1] = this.addNextComponent(var1.getRightComp(var5));
         }

         var2.append(this.createDetailLine(var6));
      }

      var2.append(this.createFinishOutput(var3));
      return var2.toString();
   }

   public void addDetailLine(String[] var1) {
      this.output.append(this.createDetailLine(var1));
   }

   public void finishOutput() {
      this.finishOutput(0);
   }

   public void finishOutput(int var1) {
      this.output.append(this.createFinishOutput(var1));
   }

   public void addGrid(JDPTextGrid var1) {
      this.addGrid(var1, 1);
   }

   public void addGrid(JDPTextGrid var1, int var2) {
      StringBuffer var3 = new StringBuffer();
      int var4 = this.closingStack.size();
      String[] var5 = new String[var1.getTableColumns()];

      for(int var6 = 0; var6 < var5.length; ++var6) {
         if (var2 > 0) {
            switch (this.docType) {
               case 0:
                  var5[var6] = "<font size=" + Integer.toString(((Component)var1).getFont().getSize() - 8);
                  if (!var1.getColumnHeaderColor(var6).equals(Color.black)) {
                     var5[var6] = var5[var6] + " color=\"" + JDPUtils._cvtbcolor(var1.getColumnHeaderColor(var6)) + "\"";
                  }

                  var5[var6] = var5[var6] + ">";
                  if (var1.columnHeaderStyle[var6] == 1) {
                     var5[var6] = var5[var6] + "<b>";
                  }

                  var5[var6] = var5[var6] + var1.getColumnHeader(var6);
                  if (var1.columnHeaderStyle[var6] == 1) {
                     var5[var6] = var5[var6] + "</b>";
                  }

                  var5[var6] = var5[var6] + "</font>";
                  break;
               case 1:
                  var5[var6] = var1.getColumnHeader(var6);
                  break;
               case 2:
                  var5[var6] = var1.getColumnHeader(var6);
                  break;
               case 3:
                  var5[var6] = var1.getColumnHeader(var6);
            }
         } else {
            var5[var6] = "";
         }
      }

      var3.append(this.createDetailHeader(var5, var2, 2, 0));
      String[] var9 = new String[var1.getTableColumns()];

      for(int var7 = 0; var7 < var1.getTableRows(); ++var7) {
         for(int var8 = 0; var8 < var9.length; ++var8) {
            var9[var8] = var1.getText(var8, var7);
         }

         var3.append(this.createDetailLine(var9));
      }

      var3.append(this.createFinishOutput(var4));
      this.output.append(var3.toString());
   }

   String addLabel(Label var1) {
      StringBuffer var2 = new StringBuffer();
      this.closingStack.size();
      switch (this.docType) {
         case 0:
            var2.append("<font size=" + Integer.toString(((Component)var1).getFont().getSize() - 8));
            if (!((Component)var1).getForeground().equals(Color.black)) {
               var2.append(" color=\"" + JDPUtils._cvtbcolor(((Component)var1).getForeground()) + "\"");
            }

            var2.append(" name=\"" + ((Component)var1).getFont().getName() + "\"");
            var2.append(">");
            var2.append(var1.getText());
            var2.append("</font>");
            break;
         case 1:
            var2.append(var1.getText());
            break;
         case 2:
            var2.append(var1.getText());
            break;
         case 3:
            var2.append(var1.getText());
      }

      return var2.toString();
   }

   public void setTitle(String var1) {
      switch (this.docType) {
         case 0:
            this.output.append("<head>");
            this.output.append(field_0);
            this.output.append("<title>");
            this.output.append(var1);
            this.output.append("</title>");
            this.output.append(field_0);
            this.output.append("</head>");
            this.output.append(field_0);
            return;
         case 1:
         case 2:
         case 3:
         default:
      }
   }

   public void addHeader(String var1, String var2) {
      this.output.append(this.createHeader(var1, var2));
   }

   public void addDetailHeader(String[] var1) {
      this.output.append(this.createDetailHeader(var1, 0, 0, 0));
   }

   public String getFinishedDocument() {
      return this.output == null ? "" : this.output.toString();
   }

   String addNextComponent(Component var1) {
      StringBuffer var2 = new StringBuffer();
      if (var1 instanceof JDPTextGrid) {
         this.addGrid((JDPTextGrid)var1);
      } else if (var1 instanceof JDPScrollPanel) {
         var2.append(this.addScroll((JDPScrollPanel)var1));
      } else if (var1 instanceof Label) {
         var2.append(this.addLabel((Label)var1));
      } else if (var1 instanceof TextComponent) {
         var2.append(this.addTextComponent((TextComponent)var1));
      } else if (var1 instanceof Choice) {
         var2.append(this.addChoice((Choice)var1));
      } else if (var1 instanceof Checkbox) {
         var2.append(this.addCheckbox((Checkbox)var1));
      } else if (var1 instanceof JDPComboBox) {
         var2.append(this.addTextComponent(((JDPComboBox)var1).text));
      } else if (var1 instanceof JDPSpinner) {
         var2.append(this.addTextComponent(((JDPSpinner)var1).text));
      } else if (var1 instanceof JDPDate) {
         var2.append(this.addTextComponent(((JDPDate)var1).text));
      } else if (var1 instanceof Panel) {
         var2.append(this.addPanel((Panel)var1));
      }

      return var2.toString();
   }

   String addChoice(Choice var1) {
      StringBuffer var2 = new StringBuffer();
      this.closingStack.size();
      switch (this.docType) {
         case 0:
            var2.append("<font size=" + Integer.toString(((Component)var1).getFont().getSize() - 8));
            if (!((Component)var1).getForeground().equals(Color.black)) {
               var2.append(" color=\"" + JDPUtils._cvtbcolor(((Component)var1).getForeground()) + "\"");
            }

            var2.append(" name=\"" + ((Component)var1).getFont().getName() + "\"");
            var2.append(">");
            var2.append(var1.getSelectedItem());
            var2.append("</font>");
            break;
         case 1:
            var2.append(var1.getSelectedItem());
            break;
         case 2:
            var2.append(var1.getSelectedItem());
            break;
         case 3:
            var2.append(var1.getSelectedItem());
      }

      return var2.toString();
   }
}
