import java.awt.Checkbox;
import java.awt.Component;
import java.awt.Window;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPGenerateSource extends JDPClassLayout {
   JDPLayoutMgr target;
   JDPLayoutGenerator targetGenerator;
   String[] templateSource;
   Vector linePosVector;
   Thread thisThread;
   StringBuffer sourceBuffer;
   int lastLineVectorPos;
   int mainSourceLines;
   int eventLines;
   boolean usingNewEventModel;
   String listenerInterfaces = "";
   String objectListeners = "";

   String switchField(String var1, JDPSelectTable var2) {
      if (var1.indexOf(".") > 0) {
         for(int var3 = 0; var3 < var2.joinConditions.countItems(); ++var3) {
            String var4 = var2.joinConditions.getItem(var3);
            int var5 = var4.indexOf(var1 + " ");
            if (var5 >= 0 || var4.endsWith(var1)) {
               var5 = var4.indexOf(var1);
               int var6 = var4.indexOf(".");
               if (var6 == var5 + 1) {
                  var6 = var4.substring(var5 + 2).indexOf(".") + var5 + 2;
                  var1 = var4.substring(var6 - 1);
               } else {
                  int var7 = var4.indexOf(" ");
                  var1 = var4.substring(0, var7);
               }
               break;
            }
         }
      }

      return var1;
   }

   Component findRelatedComp(JDPTreeBranch var1, String var2) {
      if (var1.relatedComps == null) {
         return null;
      } else {
         for(int var3 = 0; var3 < var1.relatedComps.length; ++var3) {
            if (var1.relatedComps[var3].getClass().getName().equals(var2)) {
               return var1.relatedComps[var3];
            }
         }

         return null;
      }
   }

   String getProp(JDPTreeBranch var1, String var2) {
      if (var1.properties == null) {
         return "";
      } else if (var1.properties.length <= 0) {
         return "";
      } else if (var1.properties[0].length <= 0) {
         return "";
      } else if (var1.properties[0][0] == null) {
         return "";
      } else {
         for(int var3 = 0; var3 < var1.properties[0].length; ++var3) {
            if (var1.properties[0][var3].equals(var2)) {
               return var1.properties[1][var3];
            }
         }

         return "";
      }
   }

   String wrapEventSource(String var1) {
      if (var1.equals("")) {
         return "";
      } else if (this.usingNewEventModel) {
         return var1;
      } else {
         String var2 = "";
         var2 = var2 + "\t//\r\n\t//  Handle screen events\r\n\t//\r\n";
         var2 = var2 + "\tpublic boolean handleEvent(Event e) {\r\n\r\n";
         var2 = var2 + "\t\tswitch (e.id) {\r\n";
         var2 = var2 + var1;
         var2 = var2 + "\t\tcase Event.MOUSE_MOVE:\r\n";
         var2 = var2 + "\t\tcase Event.MOUSE_ENTER:\r\n";
         var2 = var2 + "\t\tcase Event.MOUSE_EXIT:\r\n";
         var2 = var2 + "\t\t\tpopuppanel.postEvent(e);\r\n";
         var2 = var2 + "\t\t\treturn false;\r\n\r\n";
         var2 = var2 + "\t\tdefault:\r\n";
         var2 = var2 + "\t\t\treturn false;\r\n\r\n";
         var2 = var2 + "\t\t}\r\n\t}\r\n";
         return var2;
      }
   }

   void constructMethod(JDPTreeBranch var1, String var2) {
      this.constructMethodSource(var1, var2, "Replace");
   }

   JDPTreeBranch getErrorComponent(int var1) {
      int var2 = 0;
      int var3 = 0;
      Vector var4 = null;
      JDPTreeBranch var5 = null;
      if (var1 <= this.mainSourceLines) {
         return null;
      } else {
         if (this.linePosVector == null) {
            this.target.sourcePanel2.setText(this.addLineNumbers(this.composeSource(this.target.compTree), 1));
         }

         while(var3 < var1 && var2 < this.linePosVector.size()) {
            var4 = (Vector)this.linePosVector.elementAt(var2);
            var5 = (JDPTreeBranch)var4.elementAt(1);
            var3 = Integer.parseInt((String)var4.elementAt(0)) - 2;
            ++var2;
         }

         if (var4 != null) {
            var5 = (JDPTreeBranch)var4.elementAt(1);
         }

         return var5;
      }
   }

   int getErrorSourceLine(int var1) {
      int var2 = 0;
      int var3 = 0;
      int var4 = 0;
      Object var5 = null;
      if (var1 <= this.mainSourceLines) {
         return -1;
      } else {
         while(var3 < var1 && var2 < this.linePosVector.size()) {
            Vector var6 = (Vector)this.linePosVector.elementAt(var2);
            var4 = var3 + 2;
            var3 = Integer.parseInt((String)var6.elementAt(0)) - 2;
            ++var2;
         }

         return var4;
      }
   }

   synchronized String buildMainSource(JDPTreeBranch var1) {
      String var2 = this.templateSource[0];
      var2 = super.user.u.replace(var2, "<JDPModule>", this.target.appName);
      var2 = super.user.u.replace(var2, "<Description>", this.target.appName);
      this.sourceBuffer = null;
      this.sourceBuffer = new StringBuffer();
      this.constructSource(var1, "Components");
      var2 = super.user.u.replace(var2, "<Components>", this.sourceBuffer.toString());
      this.sourceBuffer.setLength(0);
      this.constructSource(var1, "InitClassBody");
      String var3 = this.createCheckBoxGroups();
      this.sourceBuffer.insert(0, var3);
      var2 = super.user.u.replace(var2, "<InitClassBody>", this.sourceBuffer.toString());
      this.sourceBuffer.setLength(0);
      this.constructSource(var1, "Layout");
      var2 = super.user.u.replace(var2, "<Layout>", this.sourceBuffer.toString());
      this.sourceBuffer.setLength(0);
      this.constructSource(var1, "Properties");
      var2 = super.user.u.replace(var2, "<Properties>", this.sourceBuffer.toString());
      this.sourceBuffer = null;
      return var2;
   }

   String constructEventSource(JDPTreeBranch[] var1) {
      String var2 = "";
      if (var1 == null) {
         return "";
      } else {
         JDPTreeBranch var3 = var1[var1.length - 1];
         if (var3.treeVector == null || var3.treeVector.size() == 0) {
            var3.treeVector = new Vector();
            JDPTreeBranch var4 = new JDPTreeBranch();
            var3.treeVector.addElement(var4);
         }

         JDPTreeBranch var15 = (JDPTreeBranch)var3.treeVector.elementAt(0);
         if (var3.text == null) {
            var3.text = new String[1];
         }

         if (var3.compPosition == null || !var3.compPosition.equals("Local Methods")) {
            var2 = var2 + var1[var1.length - 2].name + ".";
         }

         int var5 = var3.name.indexOf("(");
         if (var5 > 0) {
            var2 = var2 + var3.name.substring(0, var5);
         } else {
            var2 = var2 + var3.name;
         }

         var2 = var2 + "(";
         if (var15 != null && var15.leaves != null) {
            for(int var6 = 0; var6 < var15.leaves.size(); ++var6) {
               if (var6 > 0) {
                  var2 = var2 + ", ";
               }

               JDPTreeBranch var7 = (JDPTreeBranch)var15.leaves.elementAt(var6);
               if (var7.leaves != null && var7.leaves.size() > 0) {
                  JDPTreeBranch var8 = (JDPTreeBranch)var7.leaves.elementAt(0);
                  if (var8.leaves != null && var8.leaves.size() > 0) {
                     JDPTreeBranch var9 = (JDPTreeBranch)var8.leaves.elementAt(0);
                     JDPTreeBranch var10 = this.target.interactionMgr.getMethodParameters(var9, this.target.interactionMgr.parameterTree);
                     String var11 = this.createSourceSnippet(this.target.interactionMgr.parameterTree.getTreeBranch(var9), var10, 2);
                     var2 = var2 + var11;
                  } else {
                     var2 = var2 + var8.name.trim();
                  }
               } else {
                  var2 = var2 + "<" + var7.name.trim() + ">";
               }
            }
         }

         var2 = var2 + ");\r\n";
         var3.text[0] = var2;
         return var2;
      }
   }

   int getErrorSourceComponent(int var1) {
      int var2 = 0;
      int var3 = 0;
      int var4 = -1;
      Vector var5 = null;
      if (var1 <= this.mainSourceLines + this.eventLines) {
         return -1;
      } else {
         while(var3 < var1 && var2 < this.linePosVector.size()) {
            var5 = (Vector)this.linePosVector.elementAt(var2);
            var3 = Integer.parseInt((String)var5.elementAt(0)) - 2;
            ++var2;
         }

         if (var5 != null) {
            String var6 = (String)var5.elementAt(2);
            if (!var6.equals("Event")) {
               var4 = Integer.parseInt(var6);
            }
         }

         return var4;
      }
   }

   int insertEventVector(int var1, String var2, Vector var3) {
      var3.elementAt(1);
      if (var3.size() == 3) {
         Vector var4 = (Vector)var3.elementAt(2);

         for(int var5 = 0; var5 < var4.size(); var5 += 3) {
            int var6 = Integer.parseInt((String)var4.elementAt(var5));
            Vector var7 = new Vector(3);
            var7.addElement(Integer.toString(var1 + var6 + 2));
            var7.addElement(var4.elementAt(var5 + 2));
            var7.addElement("Event");
            var7.addElement(var4.elementAt(var5 + 1));
            this.linePosVector.insertElementAt(var7, this.lastLineVectorPos++);
         }
      }

      var1 += this.countSourceLines(var2);
      return var1;
   }

   String createSourceSnippet(JDPTreeBranch[] var1, JDPTreeBranch var2, int var3) {
      String var4 = "";
      if (var1 == null) {
         return "";
      } else {
         JDPTreeBranch var5 = var1[var1.length - 1];
         if (var1[var1.length - 1].compPosition == null || !var1[var1.length - 1].compPosition.equals("Local Methods")) {
            var4 = var4 + var1[var1.length - var3].name + ".";
         }

         int var6 = var5.name.indexOf("(");
         if (var6 > 0) {
            var4 = var4 + var5.name.substring(0, var6);
         } else {
            var4 = var4 + var5.name;
         }

         if (!var1[var1.length - 2].name.equals("Properties")) {
            var4 = var4 + "(";
            if (var2 != null && var2.leaves != null) {
               for(int var7 = 0; var7 < var2.leaves.size(); ++var7) {
                  if (var7 > 0) {
                     var4 = var4 + ", ";
                  }

                  JDPTreeBranch var8 = (JDPTreeBranch)var2.leaves.elementAt(var7);
                  var4 = var4 + "<" + var8.name.trim() + ">";
               }
            }

            var4 = var4 + ")";
         }

         return var4;
      }
   }

   String composeSource(JDPTreeBranch var1) {
      String var2 = "";
      String var3 = "";
      String var4 = "";
      boolean var6 = false;
      int var7 = 0;
      if (this.linePosVector != null && this.linePosVector.size() != 0) {
         Vector var8 = (Vector)this.linePosVector.elementAt(this.linePosVector.size() - 1);
         var7 = Integer.parseInt((String)var8.elementAt(0));
      } else {
         this.linePosVector = new Vector();
      }

      if (var1.text != null) {
         for(int var26 = 0; var26 < var1.text.length; ++var26) {
            if (var1.text[var26] != null) {
               int var9 = var1.text[var26].length() - 1;
               if (var9 > 0) {
                  for(char var10 = var1.text[var26].charAt(var9); var9 > 0 && (var10 == '\r' || var10 == '\n'); var10 = var1.text[var26].charAt(var9)) {
                     --var9;
                  }

                  ++var9;
                  var1.text[var26] = var1.text[var26].substring(0, var9) + "\r\n\r\n";
               }

               var4 = var1.text[var26];
               int var5 = var4.indexOf("|");
               var5 = var4.indexOf("|", var5 + 1);
               if (var4.indexOf("<CodeBody>") > 0) {
                  var6 = true;
                  this.linePosVector = new Vector();
                  var7 = 0;
                  var2 = var2 + var4.substring(var5 + 1);
               } else if (var6) {
                  var2 = super.user.u.replace(var2, "<CodeBody>", var4.substring(var5 + 1) + "<CodeBody>");
               } else {
                  var2 = var2 + var4.substring(var5 + 1);
               }

               Vector var33 = new Vector(3);
               var7 += this.countSourceLines(var4.substring(var5 + 1));
               var33.addElement(Integer.toString(var7));
               var33.addElement(var1);
               var33.addElement(Integer.toString(var26));
               this.linePosVector.addElement(var33);
            }
         }
      }

      for(int var27 = 0; var27 < var1.leaves.size(); ++var27) {
         JDPTreeBranch var30 = (JDPTreeBranch)var1.leaves.elementAt(var27);
         var3 = var3 + this.composeSource(var30);
      }

      if (var6) {
         var7 = this.countSourceLines(var2.substring(0, var2.indexOf("InitComponents();"))) + 9;
         this.mainSourceLines = var7 - 1;
         var2 = super.user.u.replace(var2, "<CodeBody>", var3);
         Vector var28 = new Vector();
         this.listenerInterfaces = "";
         this.objectListeners = "";
         this.composeEventSource(var1, var28);
         String var31 = "";
         boolean var34 = true;
         this.lastLineVectorPos = 0;

         for(int var11 = 0; var11 < var28.size(); ++var11) {
            Vector var12 = (Vector)var28.elementAt(var11);
            String[] var13 = (String[])var12.elementAt(0);
            if (var13[1].length() > 0 && (var13[0].equals("TAB_FORWARD") || var13[0].equals("TAB_BACK"))) {
               String var14 = "";
               if (var34) {
                  var14 = var14 + "\t\tcase Event.KEY_PRESS:\r\n";
                  var34 = false;
               }

               if (var13[0].equals("TAB_FORWARD")) {
                  var14 = var14 + "\t\t\tif (e.key == '\\t' && e.modifiers != Event.SHIFT_MASK) {\r\n";
               } else {
                  var14 = var14 + "\t\t\tif (e.key == '\\t' && e.modifiers == Event.SHIFT_MASK) {\r\n";
               }

               var14 = var14 + var13[1];
               var14 = var14 + "\t\t\t}\r\n";
               var31 = var31 + var14;
               var13[1] = "";
               var7 = this.insertEventVector(var7, var14, var12);
            }
         }

         for(int var35 = 0; var35 < var28.size(); ++var35) {
            Vector var37 = (Vector)var28.elementAt(var35);
            String[] var40 = (String[])var37.elementAt(0);
            if (var40[1].length() > 0 && var40[0].equals("KEY_PRESS")) {
               String var46 = "";
               if (var34) {
                  var46 = var46 + "\t\tcase Event.KEY_PRESS:\r\n";
                  var34 = false;
               }

               var46 = var46 + var40[1];
               var31 = var31 + var46;
               var40[1] = "";
               var7 = this.insertEventVector(var7, var46, var37);
            }
         }

         if (!var34) {
            var31 = var31 + "\t\t\treturn false;\r\n\r\n";
            var7 += 2;
         }

         this.usingNewEventModel = false;
         String var36 = "";

         for(int var38 = 0; var38 < var28.size(); ++var38) {
            Vector var41 = (Vector)var28.elementAt(var38);
            String[] var48 = (String[])var41.elementAt(0);
            var41.elementAt(1);
            if (var48[1].length() > 0) {
               String var15 = "";
               if (var48[0].equals(var48[0].toUpperCase())) {
                  var15 = "\t\tcase Event." + var48[0] + ":\r\n";
                  var15 = var15 + var48[1];
                  var15 = var15 + "\t\t\treturn false;\r\n\r\n";
               } else {
                  if (!this.usingNewEventModel) {
                     var7 -= 3;
                     this.mainSourceLines -= 3;
                  }

                  this.usingNewEventModel = true;
                  if (var36.indexOf(var48[0] + ",") < 0) {
                     var15 = "\tpublic void " + var48[0] + " {\r\n";
                     if (!var48[1].equals("\tEmpty Method")) {
                        var15 = var15 + super.user.u.replace(var48[1], "\n\t", "\n").substring(1);
                     } else {
                        var15 = var15 + "\r\n";
                     }

                     var15 = var15 + "\t}\r\n\r\n";
                     var36 = var36 + var48[0] + ",";
                  }
               }

               var31 = var31 + var15;
               var7 = this.insertEventVector(var7, var15, var41);
            }
         }

         int var39 = 0;
         if (!this.listenerInterfaces.equals("")) {
            this.listenerInterfaces = "implements " + this.listenerInterfaces.substring(9, this.listenerInterfaces.length() - 1);
            var39 = this.countSourceLines(this.listenerInterfaces);
            var7 += var39;
         }

         var2 = super.user.u.replace(var2, "<Listeners>", this.listenerInterfaces);
         int var42 = 0;
         if (!this.objectListeners.equals("")) {
            var42 = this.countSourceLines(this.objectListeners);
            int var10000 = var7 + var42;
         }

         var2 = super.user.u.replace(var2, "<ObjectListeners>", this.objectListeners);
         var31 = this.wrapEventSource(var31);
         this.eventLines = this.countSourceLines(var31) + var39 + var42;
         var2 = super.user.u.replace(var2, "<Events>", var31);

         for(int var49 = 0; var49 < this.linePosVector.size(); ++var49) {
            Vector var54 = (Vector)this.linePosVector.elementAt(var49);
            if (!((String)var54.elementAt(2)).equals("Event")) {
               int var16 = Integer.parseInt((String)var54.elementAt(0)) + this.eventLines;
               var54.setElementAt(Integer.toString(var16), 0);
            }
         }
      } else {
         var2 = var2 + var3;
      }

      Object var21 = null;
      Object var23 = null;
      return var2;
   }

   synchronized void constructMethodSource(JDPTreeBranch var1, String var2, String var3) {
      if (!this.target.projectLoading || this.target.loadingWizardApp) {
         String var5 = "";
         String var6 = var1.compType;
         String[] var4;
         if (var1 == this.target.compTree) {
            var4 = new String[]{this.buildSource(var1)};
         } else {
            this.target.refreshRelatedComps(var1);
            if (var2.equals("Main")) {
               if ((var6.equals("JDPColumns") || var6.equals("JDPGridDetail") || var6.equals("JDPReportDetail") || var6.equals("JDPChartDetail") || var6.equals("JDPChoice") || var6.equals("JDPComboBox") || var6.equals("JDPList") || var6.startsWith("JDPWiz")) && var1.relatedComps != null && var1.relatedComps[0] != null) {
                  JDPSelectDSN var7 = (JDPSelectDSN)var1.relatedComps[0];
                  int var8 = 0;
                  byte var9 = 0;
                  if (var6.equals("JDPColumns")) {
                     var8 = ((JDPScreenSettings)var1.relatedComps[3]).columns.countItems();
                     var9 = 11;
                  }

                  if (var6.equals("JDPGridDetail")) {
                     var8 = ((JDPGridLayout)var1.thisObject).columnCount;
                     var9 = 12;
                  }

                  if (var6.equals("JDPReportDetail")) {
                     var8 = ((JDPGridLayout)var1.thisObject).columnCount;
                     var9 = 14;
                  }

                  if (var6.equals("JDPChartDetail")) {
                     var8 = ((JDPSelectChartDef)var1.relatedComps[3]).columns.countItems();
                     if (var8 == 0) {
                        var8 = 1;
                     }

                     var9 = 15;
                  }

                  if (var6.equals("JDPChoice")) {
                     var9 = 16;
                     var8 = 1;
                  }

                  if (var6.equals("JDPList")) {
                     var9 = 17;
                     var8 = 1;
                  }

                  if (var6.equals("JDPComboBox")) {
                     var9 = 18;
                     var8 = 1;
                  }

                  if (var6.equals("JDPWizForm")) {
                     var9 = 21;
                     var8 = 1;
                  }

                  if (var6.equals("JDPWizGrid")) {
                     var9 = 22;
                     var8 = 1;
                  }

                  if (var6.equals("JDPWizMasterDetail")) {
                     var9 = 23;
                     var8 = 1;
                  }

                  if (var6.equals("JDPWizReport")) {
                     var9 = 24;
                     var8 = 1;
                  }

                  if (var6.equals("JDPWizChart")) {
                     var9 = 25;
                     var8 = 1;
                  }

                  if (var8 > 0) {
                     if (this.templateSource[var9 - 10] == null) {
                        this.loadSource(var9);
                     }

                     var5 = this.templateSource[var9 - 10];
                     var5 = super.user.u.replace(var5, "<compName>", var1.name);
                     var5 = super.user.u.replace(var5, "<jaggPrefs>", this.createJaggPrefs(var7, "\t\t"));

                     for(int var10 = 0; var10 < var1.relatedComps.length; ++var10) {
                        this.targetGenerator.setHandle((JDPClassLayout)var1.relatedComps[var10]);
                     }

                     if (var1.thisObject instanceof JDPClassLayout) {
                        this.targetGenerator.setHandle((JDPClassLayout)var1.thisObject);
                     }

                     this.targetGenerator.setLayoutName("JDPLayout" + Integer.toString(var9));
                     if (this.targetGenerator.readyToBuild()) {
                        var5 = this.targetGenerator.parseSource(var5);
                     } else {
                        var5 = "";
                     }
                  }
               }

               if (var6.equals("JDPWhereClause") || var6.startsWith("JDPWiz")) {
                  String var80 = "";
                  Component var86 = this.findRelatedComp(var1, "JDPSearchLayout");
                  if (var86 != null) {
                     String var90 = "";
                     if (var6.startsWith("JDPWiz")) {
                        var90 = "SP1";
                     }

                     boolean var93 = false;
                     JDPSearchLayout var11 = (JDPSearchLayout)var86;
                     JDPSelectDSN var12 = (JDPSelectDSN)var1.relatedComps[0];
                     var5 = var5 + "\\*R" + this.createComment("Create and load the Search Panel");
                     var5 = var5 + "\tpublic void " + var1.name;
                     if (var6.startsWith("JDPWiz")) {
                        var5 = var5 + "WhereClause";
                     }

                     var5 = var5 + "Main() {\r\n\r\n";
                     if (var11.pchooseFr != null && var11.columns.getSelectedIndexes().length > 0) {
                        var5 = var5 + "\t\tString[] " + var1.name + "cf = new String[" + Integer.toString(var11.pchooseFr.length) + "];\r\n";
                        var5 = var5 + "\t\tString[] " + var1.name + "acf = new String[" + Integer.toString(var11.pchooseFr.length) + "];\r\n";
                        var5 = var5 + "\t\tVector " + var1.name + "mu = new Vector();\r\n";
                        var5 = var5 + "\t\tVector " + var1.name + "amu = new Vector();\r\n";

                        for(int var13 = 0; var13 < var11.pchooseFr.length; ++var13) {
                           var5 = var5 + "\t\t" + var1.name + "cf[" + Integer.toString(var13) + "] = \"" + var11.pchooseFr[var13] + "\";\r\n";
                           var5 = var5 + "\t\t" + var1.name + "acf[" + Integer.toString(var13) + "] = \"" + var11.pactualchooseFr[var13] + "\";\r\n";
                        }

                        for(int var99 = 0; var99 < var11.pmatchUsing.size(); ++var99) {
                           var5 = var5 + "\t\t" + var1.name + "mu.addElement(new Vector());\r\n";
                           var5 = var5 + "\t\t" + var1.name + "amu.addElement(new Vector());\r\n";
                        }

                        for(int var100 = 0; var100 < var11.pchooseFromindex.length; ++var100) {
                           if (var11.thisChoicePanel.valuesFrom[var11.pchooseFromindex[var100]].equals("Fields entered here")) {
                              for(int var14 = 0; var14 < ((Vector)var11.pmatchUsing.elementAt(var100)).size(); ++var14) {
                                 var5 = var5 + "\t\t((Vector)" + var1.name + "mu.elementAt(" + Integer.toString(var100) + ")).addElement(\"" + (String)((Vector)var11.pmatchUsing.elementAt(var100)).elementAt(var14) + "\");\r\n";
                                 var5 = var5 + "\t\t((Vector)" + var1.name + "amu.elementAt(" + Integer.toString(var100) + ")).addElement(\"" + (String)((Vector)var11.pactualmatchUsing.elementAt(var100)).elementAt(var14) + "\");\r\n";
                              }
                           } else {
                              if (!var93) {
                                 var5 = var5 + this.createJaggPrefs(var12, "\t\t");
                                 var5 = var5 + "\t\tJDPLoadChoice lc = new JDPLoadChoice(user,jaggSQL,null,\"\",\"\",\"\",\"\",-1);\r\n";
                              }

                              var93 = true;
                              if (var11.thisChoicePanel.columnDataType[var11.pchooseFromindex[var100]].equals("")) {
                                 var11.thisChoicePanel.columnDataType[var11.pchooseFromindex[var100]] = "12";
                              }

                              var5 = var5 + "\t\tlc.loadChoice((Vector)" + var1.name + "mu.elementAt(" + Integer.toString(var100) + "), \"" + var11.thisChoicePanel.textChoiceSql[var11.pchooseFromindex[var100]] + "\" ,\"" + var11.thisChoicePanel.columnActualList[var11.pchooseFromindex[var100]] + "\" ,\"" + var11.thisChoicePanel.tableList[var11.pchooseFromindex[var100]] + "\" ,\"" + var11.thisChoicePanel.tableWhereClause[var11.pchooseFromindex[var100]] + "\" ,(Vector)" + var1.name + "amu.elementAt(" + Integer.toString(var100) + ")," + var11.thisChoicePanel.columnDataType[var11.pchooseFromindex[var100]] + ");\r\n";
                           }
                        }

                        var5 = var5 + "\t\tint[] " + var1.name + "cl = new int[" + Integer.toString(var11.constantL.length) + "];\r\n";
                        var5 = var5 + "\t\tboolean[] " + var1.name + "cis = new boolean[" + Integer.toString(var11.constantL.length) + "];\r\n";

                        for(int var101 = 0; var101 < var11.constantL.length; ++var101) {
                           var5 = var5 + "\t\t" + var1.name + "cl[" + Integer.toString(var101) + "] = " + Integer.toString(var11.constantL[var101]) + ";\r\n";
                           var5 = var5 + "\t\t" + var1.name + "cis[" + Integer.toString(var101) + "] = ";
                           if (var11.constantIS[var101]) {
                              var5 = var5 + "true;\r\n";
                           } else {
                              var5 = var5 + "false;\r\n";
                           }
                        }

                        var80 = var11.pinitChoice;
                        var5 = var5 + "\t\t" + var1.name + var90 + " = new JDPWhereClause(";
                        var5 = var5 + "user, targetPanel, \"\", true, \"" + var80 + "\", ";
                        var5 = var5 + var1.name + "cf, ";
                        var5 = var5 + var1.name + "acf, ";
                        var5 = var5 + var1.name + "mu, ";
                        var5 = var5 + var1.name + "amu, null, null, ";
                        var5 = var5 + var1.name + "cl, ";
                        var5 = var5 + var1.name + "cis, ";
                        var5 = var5 + "\"" + var11.fromWhereClause + "\"";
                        var5 = var5 + ");";
                        var5 = var5 + "\r\n";
                        var5 = var5 + "\t\t" + var1.name + var90 + ".setDSNType(\"" + var12.dsnType + "\");";

                        for(int var102 = 0; var102 < var11.constantL.length; ++var102) {
                           var5 = var5 + "\r\n";
                           var5 = var5 + "\t\t" + var1.name + var90 + ".setDataType(" + Integer.toString(var102) + "," + var11.odbcType[var11.pchooseFromindex[var102]] + ");";
                        }
                     }

                     var5 = var5 + "\r\n";
                     var5 = var5 + "\t}\r\n\r\n";
                  }
               }

               if (var6.equals("JDPSearchResults") || var6.startsWith("JDPWiz")) {
                  String var82 = "";
                  Component var87 = this.findRelatedComp(var1, "JDPListLayout");
                  if (var87 != null) {
                     String var91 = "";
                     if (var6.startsWith("JDPWiz")) {
                        var91 = "RL1";
                     }

                     JDPListLayout var94 = (JDPListLayout)var87;
                     JDPSelectDSN var96 = (JDPSelectDSN)var1.relatedComps[0];
                     JDPSelectTable var98 = (JDPSelectTable)var1.relatedComps[1];
                     var5 = var5 + "\\*R" + this.createComment("Create and load the Result List Panel");
                     var5 = var5 + "\tpublic void " + var1.name;
                     if (var6.startsWith("JDPWiz")) {
                        var5 = var5 + "SearchResults";
                     }

                     var5 = var5 + "Main() {\r\n\r\n";
                     if (var94.psdisplayFields != null && var94.columns.getSelectedItems().length > 0) {
                        var5 = var5 + "\t\tString " + var1.name + "sf = \"" + var94.pselectFields + "\";\r\n";
                        var5 = var5 + "\t\tString[] " + var1.name + "df = {";

                        for(int var103 = 0; var103 < var94.psdisplayFields.length; ++var103) {
                           if (var103 > 0) {
                              var5 = var5 + ",";
                           }

                           var5 = var5 + "\"" + var94.psdisplayFields[var103] + "\"";
                        }

                        var5 = var5 + "};\r\n";
                        var5 = var5 + "\t\tString " + var1.name + "wc = \"" + var94.pfromwhereclause.getText() + "\";\r\n";
                        var5 = var5 + "\t\tString[] " + var1.name + "sct = {";

                        for(int var104 = 0; var104 < var94.psortCh.length; ++var104) {
                           if (var104 > 0) {
                              var5 = var5 + ",";
                           }

                           var5 = var5 + "\"" + var94.psortCh[var104] + "\"";
                        }

                        var5 = var5 + "};\r\n";
                        String[] var105 = var94.psortChSql;
                        var5 = var5 + "\t\tString[] " + var1.name + "sc = {";

                        for(int var106 = 0; var106 < var105.length; ++var106) {
                           if (var106 > 0) {
                              var5 = var5 + ",";
                           }

                           var5 = var5 + "\"" + var105[var106] + "\"";
                        }

                        var5 = var5 + "};\r\n";
                        var5 = var5 + "\t\tJDPJagg jaggSQL = new JDPJagg(user.jaggPath);\r\n";
                        var5 = var5 + this.createJaggPrefs(var96, "\t\t");
                        var82 = var94.pinitChoice;
                        var5 = var5 + "\t\t" + var1.name + var91 + " = new JDPSearchResults(";
                        var5 = var5 + "user, targetPanel, ";
                        if (var94.useTree.getSelectedIndex() == 0) {
                           var5 = var5 + "true";
                        } else {
                           var5 = var5 + "false";
                        }

                        var5 = var5 + ", jaggSQL, false, ";
                        var5 = var5 + var1.name + "sf, ";
                        var5 = var5 + var1.name + "df, ";
                        var5 = var5 + var1.name + "wc, ";
                        var5 = var5 + var1.name + "sct, ";
                        var5 = var5 + var1.name + "sc, ";
                        var5 = var5 + var1.name + "sc, ";
                        var5 = var5 + "\"" + var82 + "\", ";
                        if (var94.displayCount.getSelectedIndex() == 0) {
                           var5 = var5 + "true, ";
                        } else {
                           var5 = var5 + "false, ";
                        }

                        var5 = var5 + "\"" + var94.pcounttext.getText() + "\"";
                        var5 = var5 + ");\r\n";
                        var5 = var5 + "\t\tint[] " + var1.name + "icons = new int[" + Integer.toString(var94.iconList.length + 2) + "];\r\n";
                        var5 = var5 + "\t\t" + var1.name + "icons[0] = " + Integer.toString(var94.mainBranchIcon.getSelectedIndex()) + ";\r\n";
                        var5 = var5 + "\t\t" + var1.name + "icons[1] = " + Integer.toString(var94.mainIcon.getSelectedIndex()) + ";\r\n";

                        for(int var107 = 0; var107 < var94.iconList.length; ++var107) {
                           if (var94.iconList[var107] != 0) {
                              var5 = var5 + "\t\t" + var1.name + "icons[" + Integer.toString(var107 + 2) + "] = " + Integer.toString(var94.iconList[var107]) + ";\r\n";
                           }
                        }

                        var5 = var5 + "\t\t" + var1.name + var91 + ".setMinWidth(" + var94.treeMinWidth.getText() + ");\r\n";
                        var5 = var5 + "\t\t" + var1.name + var91 + ".setIcons(" + var1.name + "icons);\r\n";
                        var5 = var5 + "\t\t" + var1.name + var91 + ".setFromWhereClause(\"" + this.createFromWhereClause(var96, var98, var94) + "\");\r\n";
                        var5 = var5 + "\t\t" + var1.name + var91 + ".clearList(\"" + var94.mainBranchText.getText() + "\");\r\n";
                        var5 = var5 + "\t\t" + var1.name + var91 + ".loadList();\r\n";
                     }

                     var5 = var5 + "\t}\r\n\r\n";
                  }
               }
            }

            if (!var5.equals("") && var5.indexOf("\\*") >= 0) {
               int var84 = 0;

               for(int var88 = 0; (var88 = var5.indexOf("\\*", var88 + 2)) >= 0; ++var84) {
               }

               var4 = new String[var84 + 1];
               int var92 = 0;
               int var89 = 0;

               for(int var97 = var5.indexOf("\\*", var89 + 2); var84-- >= 0; var97 = var5.indexOf("\\*", var97 + 2)) {
                  String var95;
                  if (var97 >= 0) {
                     var95 = var5.substring(var89 + 2, var97);
                  } else {
                     var95 = var5.substring(var89 + 2);
                  }

                  if (var95.length() > 0) {
                     var4[var92++] = var95;
                  }

                  var89 = var97;
               }
            } else {
               var4 = new String[]{""};
            }
         }

         if (var3.equals("Replace")) {
            this.target.replaceChangedSource(var1, var4, true);
            this.target.setProperties(var1);
         } else {
            int var85 = this.target.saveSource(var1, var4);
            if (this.target.buttonPanel == null || this.target.buttonPanel.getPressed() == null || this.target.buttonPanel.getPressed().equals("Source")) {
               this.target.loadSource(var1, var85);
            }

         }
      }
   }

   String createJaggPrefs(JDPSelectDSN var1, String var2) {
      String var3 = "";
      String var4 = super.user.u.replace(var1.connectstring.getText(), "\\", "\\\\");
      if (var1 != null && var1.usernameChoice != null && var1.usernameChoice.getSelectedIndex() == 1) {
         var4 = super.user.u.replace(var4, "UID=" + var1.userid.getText(), "UID=\" + user.cust.username + \"");
         var4 = super.user.u.replace(var4, "PWD=" + var1.password.getText(), "PWD=\" + user.cust.password + \"");
      }

      if (JDPJagg.useJaggServer) {
         var3 = var3 + var2 + "jaggSQL.loadJdbcSettings(\"" + super.user.u.replace(var1.datasource.getText(), "\\", "\\\\") + "\");\r\n";
         if (var1 != null && var1.usernameChoice != null && var1.usernameChoice.getSelectedIndex() == 1) {
            var3 = var3 + var2 + "jaggSQL.setUID(user.cust.getUsername());\r\n";
            var3 = var3 + var2 + "jaggSQL.setPWD(user.cust.password);\r\n";
         } else {
            var3 = var3 + var2 + "jaggSQL.setUID(\"" + super.user.u.replace(var1.userid.getText(), "\\", "\\\\") + "\");\r\n";
            var3 = var3 + var2 + "jaggSQL.setPWD(\"" + super.user.u.replace(var1.password.getText(), "\\", "\\\\") + "\");\r\n";
         }
      } else {
         var3 = var3 + var2 + "jaggSQL.setDSN(\"" + super.user.u.replace(var1.datasource.getText(), "\\", "\\\\") + "\");\r\n";
         var3 = var3 + var2 + "jaggSQL.setCSTR(\"" + var4 + "\");\r\n";
      }

      var3 = var3 + var2 + "jaggSQL.setMRW(\"" + var1.maxRows.getText() + "\");\r\n";
      var3 = var3 + var2 + "jaggSQL.setTOUT(\"" + var1.timeOut.getText() + "\");\r\n";
      return var3;
   }

   String constructSourceLine(JDPTreeBranch var1, String var2) {
      String var3 = "";
      String var4 = var1.compType;
      if (var2.equals("Components")) {
         var3 = var3 + "\t";
         if (var4.equals("CheckboxGroup")) {
            var3 = var3 + "Checkbox " + var1.name + ";\r\n";
         } else if (!var4.equals("JDPColumns") && !var4.startsWith("JDPWiz")) {
            if (!var4.equals("JDPGridDetail") && !var4.equals("JDPGridLayout")) {
               if (var4.equals("JDPReportDetail")) {
                  var3 = var3 + "JDPTextGrid " + var1.name + ";\r\n";
               } else if (!var4.equals("JDPChartDetail") && !var4.equals("JDPChartLayout")) {
                  if (var4.equals("Choice")) {
                     var3 = var3 + var4 + " " + var1.name + ";\r\n";
                     var3 = var3 + "\tVector value" + var1.name + ";\r\n";
                  } else if (var4.equals("JDPChoice")) {
                     var3 = var3 + var4 + " " + var1.name + ";\r\n";
                     var3 = var3 + "\tVector value" + var1.name + ";\r\n";
                  } else if (var4.equals("JDPComboBox")) {
                     var3 = var3 + var4 + " " + var1.name + ";\r\n";
                  } else {
                     var3 = var3 + var4 + " " + var1.name + ";\r\n";
                  }
               } else {
                  var3 = var3 + "JDPChart " + var1.name + ";\r\n";
               }
            } else {
               var3 = var3 + "JDPTextGrid " + var1.name + ";\r\n";
            }
         } else {
            var3 = var3 + "Panel " + var1.name + ";\r\n";
            if (var4.equals("JDPColumns") || var4.equals("JDPWizForm")) {
               JDPScreenSettings var5 = (JDPScreenSettings)this.findRelatedComp(var1, "JDPScreenSettings");
               String var6 = var5.lockingColumn.getSelectedItem();
               if (var6 != null && !var6.equals("")) {
                  var3 = var3 + "\tString " + var1.name + super.user.u.strip(var6) + "Lock;\r\n";
               }
            }
         }
      }

      if (var2.equals("InitClassBody")) {
         if (var4.equals("JDPTabSelectPanel")) {
            int var36 = ((JDPTabSelectPanel)var1.thisObject).getTabcount();
            String[] var41 = ((JDPTabSelectPanel)var1.thisObject).getTabnames();
            var3 = var3 + "\t\tString[] " + var1.name + "t = new String[" + Integer.toString(var36) + "];\r\n";
            var3 = var3 + "\t\tPanel[] " + var1.name + "p = new Panel[" + Integer.toString(var36) + "];\r\n";

            for(int var7 = 0; var7 < var36; ++var7) {
               var3 = var3 + "\t\t" + var1.name + "p[" + Integer.toString(var7) + "] = new Panel();\r\n";
               var3 = var3 + "\t\t" + var1.name + "p[" + Integer.toString(var7) + "].setLayout(new BorderLayout());\r\n";
               var3 = var3 + "\t\t" + var1.name + "t[" + Integer.toString(var7) + "] = \"" + var41[var7] + "\";\r\n";
            }
         }

         boolean var37 = false;
         var3 = var3 + "\t\t";
         if (var1.compPosition != null && var1.compPosition.equals("MenuAccess")) {
            var3 = var3 + var1.name + " = (" + var1.compType + ")user.u.getInstanceHandle(\"" + var1.compType + "\",false";
         } else if (var1.compPosition != null && var1.compPosition.equals("MenuAutoLoad")) {
            var3 = var3 + var1.name + " = (" + var1.compType + ")user.u.getInstanceHandle(\"" + var1.compType + "\",true";
         } else if (!var4.equals("JDPWhereClause") && !var4.equals("JDPSearchResults") && !var4.equals("JDPGridDetail") && !var4.equals("JDPReportDetail") && !var4.equals("JDPChartDetail") && !var4.equals("JDPChoice") && !var4.equals("JDPComboBox") && !var4.equals("JDPList")) {
            if (!var4.equals("JDPChartLayout")) {
               if (var4.equals("JDPServerListener")) {
                  var3 = var3 + var1.name + " = user.serverListener;\r\n";
               } else if (var4.equals("JDPButtons")) {
                  var3 = var3 + "String[] " + var1.name + "btns = {";
                  int var44 = Integer.parseInt(this.getProp(var1, "# Btns:"));

                  for(int var50 = 0; var50 < var44; ++var50) {
                     if (var50 > 0) {
                        var3 = var3 + ",";
                     }

                     var3 = var3 + "\"" + this.getProp(var1, "Btn#" + Integer.toString(var50) + ":") + "\"";
                  }

                  var3 = var3 + "};\r\n";
                  var3 = var3 + "\t\tint[] " + var1.name + "icns = {";

                  for(int var51 = 0; var51 < var44; ++var51) {
                     if (var51 > 0) {
                        var3 = var3 + ",";
                     }

                     var3 = var3 + "JDPButton.getIconValue(\"" + this.getProp(var1, "Icon#" + Integer.toString(var51) + ":") + "\")";
                  }

                  var3 = var3 + "};\r\n";
                  var3 = var3 + "\t\t" + var1.name + " = new JDPButtons(";
                  var3 = var3 + "user, ";
                  if (this.getProp(var1, "Labels:").equals("No")) {
                     var3 = var3 + var1.name + "icns, " + var1.name + "btns, ";
                  } else {
                     var3 = var3 + var1.name + "btns, " + var1.name + "icns, ";
                  }

                  var3 = var3 + "JDPButtons.getAlignmentValue(\"" + this.getProp(var1, "Align:") + "\")";
               } else {
                  boolean var43 = false;
                  if (!var4.equals("JDPColumns") && !var4.startsWith("JDPWiz")) {
                     if (var4.equals("CheckboxGroup")) {
                        var3 = var3 + var1.name + " = new Checkbox(";
                     } else if (var4.equals("JDPGridLayout")) {
                        var3 = var3 + var1.name + " = new JDPTextGrid(";
                     } else if (var1.relatedComps == null || !var1.relatedComps[0].equals(this.target.instanceMgr)) {
                        var43 = true;
                        var3 = var3 + var1.name + " = new " + var4 + "(";
                     }
                  } else {
                     var3 = var3 + var1.name + " = new Panel(";
                  }

                  if (var4.equals("Label")) {
                     var3 = var3 + "\"" + this.getProp(var1, "Label:") + "\", Label.LEFT";
                  } else if (!var4.equals("TextField") && !var4.equals("JDPTextField")) {
                     if (!var4.equals("JDPSpinner") && !var4.equals("JDPDate")) {
                        if (var4.equals("TextArea")) {
                           var3 = var3 + "\"" + super.user.u.replace(super.user.u.replace(this.getProp(var1, "Dft:"), "\n", "\\n"), "\r", "\\r") + "\", " + this.getProp(var1, "Rows:") + "," + this.getProp(var1, "Cols:");
                        } else if (var4.equals("Button")) {
                           if (this.getProp(var1, "Label:") != null && !this.getProp(var1, "Label:").equals("")) {
                              var3 = var3 + "\"" + this.getProp(var1, "Label:") + "\"";
                           }
                        } else if (var4.equals("CheckboxGroup")) {
                           var3 = var3 + "\"" + this.getProp(var1, "Label:") + "\", ";
                           var3 = var3 + "cb" + this.getProp(var1, "Group:") + ", ";
                           int var49 = Integer.parseInt(this.getProp(var1, "Group:").substring(5));
                           if (this.target.cbgroup[var49] != null && this.target.cbgroup[var49].getCurrent() == null) {
                              ((Checkbox)var1.thisObject).setState(true);
                           }

                           if (((Checkbox)var1.thisObject).getState()) {
                              var3 = var3 + "true";
                           } else {
                              var3 = var3 + "false";
                           }
                        } else if (var4.equals("Checkbox")) {
                           var3 = var3 + "\"" + this.getProp(var1, "Label:") + "\"";
                           if (((Checkbox)var1.thisObject).getState()) {
                              var3 = var3 + ");\r\n\t\t" + var1.name + ".setState(true";
                           }
                        } else if (var4.equals("Scrollbar")) {
                           String var48 = this.getProp(var1, "Align:");
                           if (var48.equals("Horizontal")) {
                              var3 = var3 + "Scrollbar.HORIZONTAL,";
                           } else {
                              var3 = var3 + "Scrollbar.VERTICAL,";
                           }

                           var3 = var3 + this.getProp(var1, "Value:") + "," + this.getProp(var1, "Vis:") + "," + this.getProp(var1, "Min:") + "," + this.getProp(var1, "Max:");
                        } else if (var4.equals("JDPButton")) {
                           if (this.getProp(var1, "Labels:").equals("No")) {
                              var3 = var3 + "JDPButton.getIconValue(\"" + this.getProp(var1, "Icon:") + "\"), \"" + this.getProp(var1, "Label:") + "\"";
                           } else if (this.getProp(var1, "Icon:").equals("")) {
                              var3 = var3 + "\"" + this.getProp(var1, "Label:") + "\"";
                           } else {
                              var3 = var3 + "\"" + this.getProp(var1, "Label:") + "\", JDPButton.getIconValue(\"" + this.getProp(var1, "Icon:") + "\")";
                           }

                           var3 = var3 + ", JDPButton.getAlignmentValue(\"" + this.getProp(var1, "Align:") + "\")";
                        } else if (!var4.equals("JDPButtons")) {
                           if (var4.equals("JDPChiselFramePanel")) {
                              var3 = var3 + "user, \"" + this.getProp(var1, "Title:") + "\"";
                           } else if (var4.equals("JDPTabSelectPanel")) {
                              var3 = var3 + "user, " + var1.name + "t, " + var1.name + "p, \"North\"";

                              try {
                                 for(int var47 = 0; var47 < Integer.parseInt(this.getProp(var1, "# Tabs:")); ++var47) {
                                    Object var54 = null;
                                    String var55;
                                    if (!(var55 = this.getProp(var1, "Icon#" + Integer.toString(var47) + ":")).equals("")) {
                                       var3 = var3 + ");\r\n\t\t" + var1.name + ".setTabIcon(" + Integer.toString(var47) + ",\"" + var55 + "\"";
                                    }
                                 }
                              } catch (Exception var16) {
                              }
                           } else if (!var4.equals("JDPTextGrid") && !var4.equals("JDPGridLayout") && !var4.equals("JDPSplitPanel")) {
                              if (var4.equals("JDPTreePicker")) {
                                 var3 = var3 + "user);\r\n\t\t" + var1.name + ".setRoot(\"" + this.getProp(var1, "Title:") + "\", true";
                              } else if (var4.equals("JDPRichText")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPServerSender")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPRMIConnection")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPImage")) {
                                 var3 = var3 + "user, \"" + super.user.u.replace(this.getProp(var1, "Path:"), "\\", "\\\\") + "\"";
                                 var3 = var3 + ");\r\n\t\t" + var1.name + ".setDimension(" + this.getProp(var1, "Width:") + "," + this.getProp(var1, "Height:");
                              } else if (var4.equals("JDPBrowser")) {
                                 var3 = var3 + ");\r\n\t\t" + var1.name + ".InitClass(user, targetPanel, \"" + super.user.u.replace(this.getProp(var1, "Doc path:"), "\\", "\\\\") + "\"";
                              } else if (var4.equals("JDPBrowserCtl")) {
                                 var3 = var3 + ");\r\n\t\t" + var1.name + ".InitClass(user, targetPanel, \"" + super.user.u.replace(this.getProp(var1, "Doc path:"), "\\", "\\\\") + "\"";
                              } else if (var4.equals("JDPEmailSender")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPAlphaSender")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPPopupComponent")) {
                                 var3 = var3 + "user, this";
                              } else if (var4.equals("JDPCommandExecuter")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPDate")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPDialog")) {
                                 var3 = var3 + "user, this";
                              } else if (var4.equals("JDPMessageDialog")) {
                                 var3 = var3 + "user, this";
                              } else if (var4.equals("JDPFormatDoc")) {
                                 var3 = var3 + "user";
                              } else if (var4.equals("JDPJagg")) {
                                 var3 = var3 + "user.jaggPath";
                              } else if (var1.thisObject instanceof JDPClassLayout) {
                                 if (!var43) {
                                    var3 = var3 + var1.name + " = new " + var4 + "(";
                                 }

                                 var3 = var3 + ");\r\n\t\t" + var1.name + ".InitClass(user, targetPanel, moduleParameter";
                              } else if (var1.relatedComps != null && var1.relatedComps[0].equals(this.target.instanceMgr)) {
                                 this.target.instanceMgr.setComponentName(var1.name);
                                 this.target.instanceMgr.setThisBranch(var1);
                                 this.target.instanceMgr.refresh();
                                 JDPTreeBranch var46 = this.target.instanceMgr.Parameters.treeRoot;
                                 JDPTreeBranch var8 = null;
                                 if (var46 != null && var46.leaves != null && var46.leaves.size() > 0) {
                                    var8 = (JDPTreeBranch)var46.leaves.elementAt(0);
                                 }

                                 if (var8 != null && var8.name.equals("Create from other object")) {
                                    var3 = var3 + var1.name + " = ";
                                 } else {
                                    var3 = var3 + var1.name + " = new " + var4 + "(";
                                 }

                                 if (var46 != null && var46.leaves != null) {
                                    for(int var9 = 0; var9 < var46.leaves.size(); ++var9) {
                                       if (var9 > 0) {
                                          var3 = var3 + ", ";
                                       }

                                       var8 = (JDPTreeBranch)var46.leaves.elementAt(var9);
                                       JDPTreeBranch var10 = null;
                                       if (var8.leaves != null && var8.leaves.size() > 0) {
                                          var10 = (JDPTreeBranch)var8.leaves.elementAt(0);
                                       }

                                       if (var10 == null) {
                                          var3 = var3 + "null";
                                       } else if (!var10.name.startsWith("String (") && !var10.name.startsWith("int (") && !var10.name.startsWith("boolean (") && !var10.name.startsWith("char (") && !var10.name.startsWith("byte (") && !var10.name.startsWith("short (") && !var10.name.startsWith("long (") && !var10.name.startsWith("float (") && !var10.name.startsWith("double (")) {
                                          if (var10.leaves != null && var10.leaves.size() != 0) {
                                             JDPTreeBranch var11 = (JDPTreeBranch)var10.leaves.elementAt(0);
                                             var3 = var3 + var10.name + "." + var11.name.substring(0, var11.name.length() - 2) + "(";
                                             if (var11.leaves != null) {
                                                for(int var12 = 0; var12 < var11.leaves.size(); ++var12) {
                                                   JDPTreeBranch var13 = (JDPTreeBranch)var11.leaves.elementAt(var12);
                                                   JDPTreeBranch var14 = null;
                                                   if (var13.leaves != null && var13.leaves.size() > 0) {
                                                      var14 = (JDPTreeBranch)var13.leaves.elementAt(0);
                                                   }

                                                   if (var12 > 0) {
                                                      var3 = var3 + ",";
                                                   }

                                                   if (var14 == null) {
                                                      var3 = var3 + "null";
                                                   } else if (!var14.name.startsWith("String (") && !var14.name.startsWith("int (") && !var14.name.startsWith("boolean (")) {
                                                      var3 = var3 + var14.name;
                                                   } else {
                                                      var3 = var3 + var14.name.substring(var14.name.indexOf("(") + 1, var14.name.length() - 1);
                                                   }
                                                }
                                             }

                                             if (!var8.name.equals("Create from other object")) {
                                                var3 = var3 + ")";
                                             }
                                          } else {
                                             var3 = var3 + var10.name;
                                          }
                                       } else {
                                          var3 = var3 + var10.name.substring(var10.name.indexOf("(") + 1, var10.name.length() - 1);
                                       }
                                    }
                                 } else {
                                    var3 = var3 + var1.name + " = new " + var4 + "(";
                                 }
                              }
                           } else {
                              var3 = var3 + "user";
                           }
                        }
                     } else {
                        var3 = var3 + "user,\"" + this.getProp(var1, "Dft:") + "\", " + this.getProp(var1, "Cols:");
                     }
                  } else {
                     var3 = var3 + "\"" + this.getProp(var1, "Dft:") + "\", " + this.getProp(var1, "Cols:");
                  }
               }
            }
         } else {
            if (var1.text != null) {
               for(int var42 = 0; var42 < var1.text.length && var1.text[var42] != null; ++var42) {
                  if (var1.text[var42].indexOf(var1.name + "Main()") >= 0) {
                     var37 = true;
                     break;
                  }
               }
            }

            if (var37) {
               var3 = var3 + var1.name + "Main(";
            } else if (!var4.equals("JDPWhereClause") && !var4.equals("JDPSearchResults")) {
               var3 = var3 + var1.name + " = new " + var4 + "(";
               if (var4.equals("JDPComboBox")) {
                  var3 = var3 + "user";
               }
            }
         }

         if (var37) {
            var3 = var3 + ");\r\n";
         } else if (!var4.equals("JDPWhereClause") && !var4.equals("JDPSearchResults") && !var4.equals("JDPChartLayout") && !var4.equals("JDPServerListener")) {
            var3 = var3 + ");\r\n";
         }
      }

      if (var2.equals("Properties")) {
         if (var1.thisObject != null && var1.thisObject instanceof Component) {
            if (this.getProp(var1, "Editable:").equals("No") || this.getProp(var1, "Editable:").equals("false")) {
               var3 = var3 + "\t\t" + var1.name + ".setEditable(false);\r\n";
            }

            if (this.getProp(var1, "Enabled:").equals("No") || this.getProp(var1, "Enabled:").equals("false")) {
               var3 = var3 + "\t\t" + var1.name + ".disable();\r\n";
            }

            if (this.getProp(var1, "Visible:").equals("No") || this.getProp(var1, "Visible:").equals("false")) {
               var3 = var3 + "\t\t" + var1.name + ".hide();\r\n";
            }

            if (!this.getProp(var1, "Popup:").equals("") || !this.getProp(var1, "Status:").equals("")) {
               var3 = var3 + "\t\tpopuppanel.addComponent(" + var1.name + " ,\"" + this.getProp(var1, "Popup:") + "\" ,\"" + this.getProp(var1, "Status:") + "\");\r\n";
            }

            if (var1.compType.equals("JDPButtons")) {
               for(int var38 = 0; var38 < Integer.parseInt(this.getProp(var1, "# Btns:")); ++var38) {
                  if (!this.getProp(var1, "Popup" + Integer.toString(var38) + ":").equals("") || !this.getProp(var1, "Status" + Integer.toString(var38) + ":").equals("")) {
                     var3 = var3 + "\t\tpopuppanel.addComponent(" + var1.name + ".button[" + Integer.toString(var38) + "] ,\"" + this.getProp(var1, "Popup" + Integer.toString(var38) + ":") + "\" ,\"" + this.getProp(var1, "Status" + Integer.toString(var38) + ":") + "\");\r\n";
                  }
               }
            }

            if (var1.compType.equals("JDPTabSelectPanel")) {
               try {
                  for(int var39 = 0; var39 < Integer.parseInt(this.getProp(var1, "# Tabs:")); ++var39) {
                     var3 = var3 + "\t\t" + var1.name + ".setTabcolor(" + Integer.toString(var39) + ",user.u._cvtcolor(\"" + this.getProp(var1, "FCol#" + Integer.toString(var39) + ":") + "\"), user.u._cvtcolor(\"" + this.getProp(var1, "BCol#" + Integer.toString(var39) + ":") + "\"));\r\n";
                  }
               } catch (Exception var15) {
               }
            }
         }

         for(int var40 = 0; var40 < var1.properties[0].length; ++var40) {
            if (!var1.properties[0][var40].equals("")) {
               String var45 = var1.properties[0][var40].substring(0, var1.properties[0][var40].length() - 1);
               String[] var52 = new String[0];
               String[] var56 = new String[0];
               if (var1.properties[2][var40] != null) {
                  StringTokenizer var57 = new StringTokenizer(var1.properties[2][var40], "|");
                  var52 = new String[var57.countTokens()];

                  for(int var60 = 0; var57.hasMoreTokens(); var52[var60++] = var57.nextToken()) {
                  }

                  var57 = new StringTokenizer(var1.properties[1][var40], ",");
                  var56 = new String[var57.countTokens()];

                  for(int var61 = 0; var57.hasMoreTokens(); var56[var61++] = var57.nextToken()) {
                  }
               }

               if (var52.length > 0 && var52.length == var56.length && !var52[0].equals("") && !var45.equals("Dft") && !var45.equals("Pos") && !var45.equals("Layout") && !var45.equals("Popup") && !var45.equals("Status") && !var45.equals("Tab to") && !var45.equals("Back to") && !var45.equals("Font") && !var45.equals("FColor") && !var45.equals("BColor") && !var45.equals("Color") && !var45.equals("Style") && !var45.equals("Size") && !var45.equals("Visible")) {
                  if (var45.equals("Enabled")) {
                     if (var1.properties[1][var40].equals("false")) {
                        var3 = var3 + "\t\t" + var1.name + ".disable();\r\n";
                     }
                  } else {
                     var3 = var3 + "\t\t" + var1.name + ".set" + var45 + "(";

                     for(int var59 = 0; var59 < var52.length; ++var59) {
                        if (var59 > 0) {
                           var3 = var3 + ",";
                        }

                        if (!var52[var59].equals("int") && !var52[var59].equals("boolean") && !var52[var59].equals("short") && !var52[var59].equals("long") && !var52[var59].equals("double") && !var52[var59].equals("float")) {
                           if (!var52[var59].equals("char") && !var52[var59].equals("byte")) {
                              if (var52[var59].equals("java.lang.String")) {
                                 var3 = var3 + "\"" + var56[var59] + "\"";
                              }
                           } else {
                              var3 = var3 + "'" + var56[var59] + "'";
                           }
                        } else {
                           var3 = var3 + var56[var59];
                        }
                     }

                     var3 = var3 + ");\r\n";
                  }
               }
            }
         }
      }

      return var3;
   }

   JDPTreeBranch getErrorEvent(int var1) {
      int var2 = 0;
      int var3 = 0;
      Vector var4 = null;
      if (var1 <= this.mainSourceLines) {
         return null;
      } else {
         while(var3 < var1 && var2 < this.linePosVector.size()) {
            var4 = (Vector)this.linePosVector.elementAt(var2);
            var3 = Integer.parseInt((String)var4.elementAt(0)) - 2;
            ++var2;
         }

         if (var4 != null) {
            String var5 = (String)var4.elementAt(2);
            if (var5.equals("Event")) {
               return (JDPTreeBranch)var4.elementAt(3);
            }
         }

         return null;
      }
   }

   int getErrorEventLine(int var1) {
      int var2 = 0;
      int var3 = 0;
      Object var4 = null;
      if (var1 <= this.mainSourceLines) {
         return -1;
      } else {
         while(var3 < var1 && var2 < this.linePosVector.size()) {
            Vector var5 = (Vector)this.linePosVector.elementAt(var2);
            var3 = Integer.parseInt((String)var5.elementAt(0)) - 2;
            ++var2;
         }

         return var3;
      }
   }

   String loadFont(JDPTreeBranch var1) {
      String var2 = var1.name + ".setFont(new Font(\"" + this.getProp(var1, "Font:") + "\", Font.";
      if (this.getProp(var1, "Style:").equals("Plain")) {
         var2 = var2 + "PLAIN";
      } else if (this.getProp(var1, "Style:").equals("Bold")) {
         var2 = var2 + "BOLD";
      } else if (this.getProp(var1, "Style:").equals("Italic")) {
         var2 = var2 + "ITALIC";
      } else if (this.getProp(var1, "Style:").equals("Bold Italic")) {
         var2 = var2 + "BOLD+Font.ITALIC";
      }

      var2 = var2 + ", " + this.getProp(var1, "Size:") + "))";
      return var2;
   }

   String insertErrorMarker(String var1, int var2, String var3) {
      StringBuffer var4 = new StringBuffer();
      int var5 = var1.indexOf("\n") + 1;
      int var6 = 0;

      for(int var7 = 0; var5 >= 0 && var6 >= 0 && var5 > var6; var5 = var1.indexOf("\n", var5) + 1) {
         if (var7++ == var2) {
            var4.append(var3);
            var4.append("\r\n");
         }

         var4.append(var1.substring(var6, var5));
         var6 = var5;
      }

      var4.append(var1.substring(var6));
      return var4.toString();
   }

   void constructNewMethod(JDPTreeBranch var1, String var2) {
      this.constructMethodSource(var1, var2, "Save");
   }

   String createFromWhereClause(JDPSelectDSN var1, JDPSelectTable var2, Object var3) {
      JDPListLayout var4 = null;
      JDPSelectColumns var5 = null;
      if (var3 != null) {
         if (var3 instanceof JDPListLayout) {
            var4 = (JDPListLayout)var3;
         }

         if (var3 instanceof JDPSelectColumns) {
            var5 = (JDPSelectColumns)var3;
         }
      }

      String var6 = " FROM ";
      String var7 = "";
      if (var4 != null) {
         var7 = var4.pselectFields + " ";
      }

      if (var5 != null) {
         String[] var8 = var5.columns.getSelectedItems();

         for(int var9 = 0; var9 < var8.length; ++var9) {
            if (var9 > 0) {
               var7 = var7 + ",";
            }

            var7 = var7 + var8[var9];
         }

         var7 = var7 + " ";
      }

      int[] var21 = var2.stables.getSelectedIndexes();
      boolean var22 = true;
      if (var4 != null) {
         int[] var10 = var4.columns.getSelectedIndexes();

         for(int var11 = 0; var11 < var10.length; ++var11) {
            if (var10[var11] < var4.psortChoiceSql.length) {
               var7 = var7 + this.switchField(var4.psortChoiceSql[var10[var11]], var2) + " ";
            }
         }

         for(int var26 = 0; var26 < var4.includeTree.countItems(); ++var26) {
            var7 = var7 + this.switchField(var4.includeTree.getItem(var26), var2) + " ";
         }
      }

      String var25 = null;
      String var27 = "";

      for(int var12 = 0; var12 < var2.joinConditions.countItems(); ++var12) {
         if (var2.joinConditions.getItem(var12).indexOf("*=") > 0) {
            var25 = "left";
            var27 = var2.joinConditions.getItem(var12);
         }

         if (var2.joinConditions.getItem(var12).indexOf("=*") > 0) {
            var25 = "right";
            var27 = var2.joinConditions.getItem(var12);
         }
      }

      String var28 = "";
      String var13 = "";
      if (var21.length == 0 || var7.indexOf("a.") >= 0) {
         var28 = var28 + var2.tables.getSelectedItem();
         if (var21.length > 0) {
            var28 = var28 + " a";
         }

         if (var1.dsnType.compareTo(JDPJagg.MSSQLSERVER) == 0) {
            var28 = var28 + " (NOLOCK)";
         }

         var22 = false;
      }

      for(int var14 = 0; var14 < var21.length; ++var14) {
         if (var2.stableAlias[var21[var14]].equals("") || var7.indexOf(var2.stableAlias[var21[var14]] + ".") >= 0) {
            if (var25 == null) {
               var13 = var13 + ",";
            }

            var13 = var13 + var2.stables.getItem(var21[var14]);
            var13 = var13 + " " + var2.stableAlias[var21[var14]];
            if (var1.dsnType.compareTo(JDPJagg.MSSQLSERVER) == 0) {
               var13 = var13 + " (NOLOCK)";
            }

            var22 = false;
         }
      }

      StringBuffer var30 = new StringBuffer();
      if (var25 == null) {
         var30.append(var28);
         var30.append(var13);
      } else if (var25.equals("left")) {
         var30.append("{oj ");
         var30.append(var28);
         var30.append(" LEFT OUTER JOIN ");
         var30.append(var13);
         var30.append(" ON ");
         var30.append(super.user.u.replace(var27, "*", ""));
         var30.append("}");
      } else if (var25.equals("right")) {
         var30.append("{oj ");
         var30.append(var13);
         var30.append(" LEFT OUTER JOIN ");
         var30.append(var28);
         var30.append(" ON ");
         var30.append(super.user.u.replace(var27, "*", ""));
         var30.append("}");
      }

      var6 = var6 + var30.toString();
      var6 = var6 + " WHERE ";
      if (var2.joinConditions.countItems() != 0) {
         for(int var15 = 0; var15 < var2.joinConditions.countItems(); ++var15) {
            if (!var2.joinConditions.getItem(var15).equals(var27)) {
               String var16 = var2.joinConditions.getItem(var15);
               int var17 = var16.substring(2).indexOf(".") + 1;
               if (var7.indexOf(var16.substring(0, 2)) >= 0 && var7.indexOf(var16.substring(var17, var17 + 2)) >= 0) {
                  var6 = var6 + var16 + " AND ";
               }
            }
         }
      }

      if (var4 != null && var4.pfromwhereclause.getText().length() != 0) {
         var6 = var6 + var4.pfromwhereclause.getText();
      } else {
         var6 = var6 + "(1=1)";
      }

      return var6;
   }

   String addLineNumbers(String var1, int var2) {
      StringBuffer var3 = new StringBuffer();
      var3.append(super.user.u.str((float)(var2++), 5, 0));
      var3.append("\t");
      int var4 = var1.indexOf("\n") + 1;
      int var5 = 0;

      while(var4 >= 0 && var5 >= 0 && var4 > var5) {
         var3.append(var1.substring(var5, var4));
         var5 = var4;
         var4 = var1.indexOf("\n", var4) + 1;
         var3.append(super.user.u.str((float)(var2++), 5, 0));
         var3.append("\t");
      }

      var3.append(var1.substring(var5));
      return var3.toString();
   }

   int countSourceLines(String var1) {
      int var2 = 0;

      for(int var3 = var1.indexOf("\n"); var3 >= 0; var3 = var1.indexOf("\n", var3 + 1)) {
         ++var2;
      }

      return var2;
   }

   boolean loadSource(int var1) {
      if (this.templateSource == null) {
         this.templateSource = new String[20];
      }

      if (var1 == 13) {
         ++var1;
      }

      String var2 = super.user.JDesignerPro.JDPDirectory + "Applications/Layouts/" + "JDPLayout" + Integer.toString(var1) + ".java";
      super.user.mainmsg.setStatusMsg("Loading template source file #" + Integer.toString(var1) + "...", 0);
      this.templateSource[var1 - 10] = super.user.u.readFromFile(var2);
      if (this.templateSource[var1 - 10] == null) {
         super.user.mainmsg.setStatusMsg("Could not open template source file: " + var2, 20);
         System.out.println("Could not open template source file: " + var2);
         return false;
      } else {
         super.user.mainmsg.clearStatusMsg();
         return true;
      }
   }

   String buildSource(JDPTreeBranch var1) {
      String var2 = "";
      if (var1.equals(this.target.compTree)) {
         super.user.mainmsg.setStatusMsg("Building complete source...", 0);
         var2 = this.buildMainSource(var1);
         super.user.mainmsg.clearStatusMsg();
      }

      return var2;
   }

   void constructSource(JDPTreeBranch var1, String var2) {
      String var3 = var1.compType;
      this.sourceBuffer.append(this.constructSourceLine(var1, var2));
      if (var1.leaves != null) {
         if (var2.equals("Layout") && var1.thisObject != null && var1.thisObject instanceof Component) {
            String var4 = this.getProp(var1, "Layout:");
            if (var4 != null && (!var4.equals("") || var1.equals(this.target.compTree))) {
               if (var4.equals("")) {
                  var4 = "BorderLayout";
               }

               this.sourceBuffer.append("\t\t" + var1.name + ".setLayout(new " + var4 + "(");
               if (var4.equals("GridLayout")) {
                  this.sourceBuffer.append(this.getProp(var1, "Rows:") + ",");
                  this.sourceBuffer.append(this.getProp(var1, "Cols:"));
               }

               this.sourceBuffer.append("));\r\n");
            }

            if (var1.equals(this.target.compTree)) {
               if (!this.getProp(var1, "Font:").equals("") && !((Component)var1.thisObject).getFont().equals(super.user.plainFont)) {
                  this.sourceBuffer.append("\t\t" + this.loadFont(var1) + ";\r\n");
               }

               if (!this.getProp(var1, "FColor:").equals("") && !((Component)var1.thisObject).getForeground().equals(((Component)var1.thisObject).getParent().getForeground())) {
                  this.sourceBuffer.append("\t\t" + var1.name + ".setForeground(user.u._cvtcolor(\"" + this.getProp(var1, "FColor:") + "\"));\r\n");
               }

               if (!this.getProp(var1, "BColor:").equals("") && !((Component)var1.thisObject).getForeground().equals(((Component)var1.thisObject).getParent().getForeground())) {
                  this.sourceBuffer.append("\t\t" + var1.name + ".setBackground(user.u._cvtcolor(\"" + this.getProp(var1, "BColor:") + "\"));\r\n");
               }

               this.sourceBuffer.append("\t\tadd(\"Center\", " + var1.name + ");\r\n");
            }

            if (var3.equals("JDPColumns") || var3.startsWith("JDPWiz") && !var3.equals("JDPWizEmail") && !var3.equals("JDPWizAlphaPaging")) {
               this.sourceBuffer.append("\t\t" + var1.name + "Main();\r\n");
            }
         }

         for(int var7 = 0; var7 < var1.leaves.size(); ++var7) {
            JDPTreeBranch var5 = (JDPTreeBranch)var1.leaves.elementAt(var7);
            if (var2.equals("Layout") && var5.thisObject != null && var5.thisObject instanceof Component) {
               if (var3.equals("JDPTabSelectPanel")) {
                  this.sourceBuffer.append("\t\t" + var1.name + "p[" + Integer.toString(var7) + "].add(\"Center\", " + var5.name + ");\r\n");
               } else {
                  String var6 = this.getProp(var1, "Layout:");
                  if ((var6 == null || !var6.equals("CardLayout")) && !var1.compType.equals("JDPCardPanel")) {
                     if (var5.compPosition != null && !var5.compPosition.equals("") && !var5.compPosition.equals("null")) {
                        this.sourceBuffer.append("\t\t" + var1.name + ".add(\"" + var5.compPosition + "\", " + var5.name + ");\r\n");
                     } else if (!(var5.thisObject instanceof Window)) {
                        this.sourceBuffer.append("\t\t" + var1.name + ".add(" + var5.name + ");\r\n");
                     }
                  } else {
                     this.sourceBuffer.append("\t\t" + var1.name + ".add(\"" + var5.name + "\", " + var5.name + ");\r\n");
                  }
               }
            }

            if (var2.equals("Properties") && var5.thisObject != null && var5.thisObject instanceof Component) {
               if (!this.getProp(var5, "Font:").equals("") && !this.getProp(var5, "Style:").equals("") && !this.getProp(var5, "Size:").equals("") && (!this.getProp(var5, "Font:").equals(this.getProp(var1, "Font:")) || !this.getProp(var5, "Style:").equals(this.getProp(var1, "Style:")) || !this.getProp(var5, "Size:").equals(this.getProp(var1, "Size:")))) {
                  this.sourceBuffer.append("\t\t" + this.loadFont(var5) + ";\r\n");
               }

               if (!this.getProp(var5, "FColor:").equals("") && !this.getProp(var5, "FColor:").equals(this.getProp(var1, "FColor:"))) {
                  this.sourceBuffer.append("\t\t" + var5.name + ".setForeground(user.u._cvtcolor(\"" + this.getProp(var5, "FColor:") + "\"));\r\n");
               }

               if (!this.getProp(var5, "BColor:").equals("") && !this.getProp(var5, "BColor:").equals(this.getProp(var1, "BColor:"))) {
                  this.sourceBuffer.append("\t\t" + var5.name + ".setBackground(user.u._cvtcolor(\"" + this.getProp(var5, "BColor:") + "\"));\r\n");
               }
            }

            this.constructSource(var5, var2);
         }
      }

   }

   void composeEventSource(JDPTreeBranch var1, Vector var2) {
      if (var2 == null) {
         var2 = new Vector();
      }

      if (var1.treeVector != null) {
         JDPTreeBranch var3 = (JDPTreeBranch)var1.treeVector.elementAt(0);
         if (var3.leaves != null) {
            for(int var4 = 0; var4 < var3.leaves.size(); ++var4) {
               JDPTreeBranch var5 = (JDPTreeBranch)var3.leaves.elementAt(var4);
               if (var5.leaves != null) {
                  int var6 = 0;
                  String[] var7 = null;
                  Object var8 = null;
                  String var9 = var5.name;
                  if (var5.name.startsWith("ACTION_BTN_")) {
                     var9 = "ACTION_EVENT";
                  }

                  if (var5.name.equals("HOME") || var5.name.equals("END") || var5.name.equals("PGUP") || var5.name.equals("PGDN") || var5.name.equals("UP") || var5.name.equals("DOWN") || var5.name.equals("LEFT") || var5.name.equals("RIGHT") || var5.name.equals("F1") || var5.name.equals("F2") || var5.name.equals("F3") || var5.name.equals("F4") || var5.name.equals("F5") || var5.name.equals("F6") || var5.name.equals("F7") || var5.name.equals("F8") || var5.name.equals("F9") || var5.name.equals("F10") || var5.name.equals("F11") || var5.name.equals("F12") || var5.name.equals("ESC")) {
                     var9 = "KEY_ACTION_RELEASE";
                  }

                  for(var6 = 0; var6 < var2.size(); ++var6) {
                     Vector var10 = (Vector)var2.elementAt(var6);
                     var7 = (String[])var10.elementAt(0);
                     if (var7[0].equals(var9)) {
                        break;
                     }

                     var7 = null;
                  }

                  boolean var39 = false;
                  boolean var11 = false;
                  if (!var5.name.equals(var5.name.toUpperCase())) {
                     var11 = true;
                     var39 = true;
                  }

                  if (var7 == null) {
                     var7 = new String[]{var9, ""};
                     Vector var12 = new Vector();
                     Vector var32 = new Vector();
                     var12.addElement(var7);
                     var12.addElement(var1);
                     var12.addElement(var32);
                     var2.addElement(var12);
                     var39 = true;
                  }

                  if (var5.leaves.size() > 0) {
                     if (var39 && !var5.name.equals(var5.name.toUpperCase())) {
                        if (this.listenerInterfaces.indexOf(var5.compType.substring(3) + ",") < 0) {
                           String var10001 = this.listenerInterfaces;
                           this.listenerInterfaces = var10001 + "\r\n\t\t\t\t\t\t\t" + var5.compType.substring(3) + ",";
                        }

                        if (this.objectListeners.indexOf(var1.name + "." + var5.compType) < 0) {
                           String var46 = this.objectListeners;
                           this.objectListeners = var46 + "\t\t" + var1.name + "." + var5.compType + "(this);\r\n";
                        }

                        for(int var40 = 0; var40 < var5.text.length; ++var40) {
                           if (!var5.text[var40].equals(var9)) {
                              String[] var13 = new String[]{var5.text[var40], "\tEmpty Method"};
                              Vector var14 = new Vector();
                              Vector var15 = new Vector();
                              var14.addElement(var13);
                              var14.addElement(var1);
                              var14.addElement(var15);
                              var2.addElement(var14);
                           }
                        }
                     }

                     Vector var41 = (Vector)var2.elementAt(var6);
                     if (var41.size() < 3) {
                        Vector var33 = new Vector();
                        var41.addElement(var33);
                     }

                     Vector var34 = (Vector)var41.elementAt(2);
                     if (var7[1].indexOf("Empty Method") >= 0) {
                        var7[1] = "";
                     }

                     if (var9.equals("KEY_ACTION_RELEASE")) {
                        if (!var5.name.equals("ESC") && !var5.name.startsWith("F")) {
                           var7[1] = var7[1] + "\t\t\tif (e.target.equals(" + var1.name + ") && e.key == Event." + var5.name + ") {\r\n\t\t\t\t";
                        } else {
                           var7[1] = var7[1] + "\t\t\tif (e.key == Event." + var5.name + ") {\r\n\t\t\t\t";
                        }
                     } else if (var5.name.startsWith("ACTION_BTN_")) {
                        var7[1] = var7[1] + "\t\t\tif (e.target.equals(" + var1.name + ".button[" + Integer.toString(var4) + "])) {\r\n\t\t\t\t";
                     } else if (var5.name.startsWith("GOT_FOCUS") && var1.name.equals("Main")) {
                        var7[1] = var7[1] + "\t\t\tif (e.target.equals(" + var1.name + ") || e.target.equals(this)) {\r\n\t\t\t\t";
                     } else if (!var11) {
                        var7[1] = var7[1] + "\t\t\tif (e.target.equals(" + var1.name + ")) {\r\n\t\t\t\t";
                     } else {
                        var7[1] = var7[1] + "\t\t\tif (e.getSource().equals(" + var1.name + ")) {\r\n\t\t\t\t";
                     }

                     for(int var42 = 0; var42 < var5.leaves.size(); ++var42) {
                        JDPTreeBranch var43 = (JDPTreeBranch)var5.leaves.elementAt(var42);
                        if (var43.leaves != null && var43.leaves.size() > 0) {
                           for(int var44 = 0; var44 < var43.leaves.size(); ++var44) {
                              JDPTreeBranch var16 = (JDPTreeBranch)var43.leaves.elementAt(var44);
                              if (var16.text != null && var16.text.length > 0) {
                                 int var17 = var16.text[0].length() - 1;
                                 if (var17 > 0) {
                                    for(char var18 = var16.text[0].charAt(var17); var17 > 0 && (var18 == '\r' || var18 == '\n'); var18 = var16.text[0].charAt(var17)) {
                                       --var17;
                                    }

                                    ++var17;
                                    var16.text[0] = var16.text[0].substring(0, var17) + "\r\n";
                                 }

                                 if (!var11) {
                                    var7[1] = var7[1] + super.user.u.replace(var16.text[0], "\n", "\n\t\t\t\t");
                                 } else {
                                    var7[1] = var7[1] + super.user.u.replace(var16.text[0], "\n", "\n\t\t\t\t");
                                 }

                                 var34.addElement(Integer.toString(this.countSourceLines(var7[1]) + 1));
                                 var34.addElement(var16);
                                 var34.addElement(var1);
                              }
                           }
                        }
                     }

                     if (!var11) {
                        if (var5.name.startsWith("KEY_PRESS")) {
                           var7[1] = var7[1] + "return false;\r\n\t\t\t}\r\n";
                        } else {
                           var7[1] = var7[1] + "return true;\r\n\t\t\t}\r\n";
                        }
                     } else {
                        var7[1] = var7[1].substring(0, var7[1].length() - 1) + "}\r\n";
                     }
                  }
               }
            }
         }
      }

      String var19 = this.getProp(var1, "Tab to:");
      String var20 = this.getProp(var1, "Back to:");
      if (!var19.equals("") && !var19.equals("?")) {
         boolean var21 = false;
         String[] var27 = null;
         String var30 = "TAB_FORWARD";

         for(int var22 = 0; var22 < var2.size(); ++var22) {
            Vector var35 = (Vector)var2.elementAt(var22);
            var27 = (String[])var35.elementAt(0);
            if (var27[0].equals(var30)) {
               break;
            }

            var27 = null;
         }

         if (var27 == null) {
            var27 = new String[]{var30, ""};
            Vector var36 = new Vector();
            var36.addElement(var27);
            var36.addElement(var1);
            var2.addElement(var36);
         }

         var27[1] = var27[1] + "\t\t\t\tif (e.target.equals(" + var1.name + ")) { user.u.cursor(" + var19 + "); }\r\n";
      }

      if (!var20.equals("") && !var20.equals("?")) {
         boolean var23 = false;
         String[] var28 = null;
         String var31 = "TAB_BACK";

         for(int var24 = 0; var24 < var2.size(); ++var24) {
            Vector var37 = (Vector)var2.elementAt(var24);
            var28 = (String[])var37.elementAt(0);
            if (var28[0].equals(var31)) {
               break;
            }

            var28 = null;
         }

         if (var28 == null) {
            var28 = new String[]{var31, ""};
            Vector var38 = new Vector();
            var38.addElement(var28);
            var38.addElement(var1);
            var2.addElement(var38);
         }

         var28[1] = var28[1] + "\t\t\t\tif (e.target.equals(" + var1.name + ")) { user.u.cursor(" + var20 + "); return true; }\r\n";
      }

      for(int var25 = 0; var25 < var1.leaves.size(); ++var25) {
         JDPTreeBranch var29 = (JDPTreeBranch)var1.leaves.elementAt(var25);
         this.composeEventSource(var29, var2);
      }

   }

   int getStartingLine(JDPTreeBranch var1, int var2, JDPTreeBranch var3, int var4) {
      int var5 = 0;
      int var6 = 0;
      int var8 = 0;
      int var9 = 0;
      Object var10 = null;
      if (this.linePosVector == null) {
         this.target.sourcePanel2.setText(this.addLineNumbers(this.composeSource(this.target.compTree), 1));
      }

      while(var5 < this.linePosVector.size()) {
         Vector var17 = (Vector)this.linePosVector.elementAt(var5);
         String var11 = (String)var17.elementAt(2);
         if (var9 != 0) {
            var8 = Integer.parseInt((String)var17.elementAt(0));
            var8 += var9;
            var17.setElementAt(Integer.toString(var8), 0);
         } else if (!var11.equals("Event")) {
            int var7 = Integer.parseInt(var11);
            if (var17.elementAt(1).equals(var1) && var2 == var7) {
               var6 = var8;
               var8 = Integer.parseInt((String)var17.elementAt(0)) - 2;
               if (var8 - var8 == var4) {
                  return var8;
               }

               var9 = var4 - (var8 - var8);
               var8 = Integer.parseInt((String)var17.elementAt(0));
               var8 += var9;
               var17.setElementAt(Integer.toString(var8), 0);
            }
         } else if (var3 != null && var17.elementAt(3).equals(var3)) {
            return Integer.parseInt((String)var17.elementAt(0)) - 2;
         }

         var8 = Integer.parseInt((String)var17.elementAt(0)) - 2;
         ++var5;
      }

      return var6;
   }

   String createComment(String var1) {
      return "\t/**\n\t * " + var1 + "\n\t */\n";
   }

   String createCheckBoxGroups() {
      String var1 = "";
      if (this.target.cbgroup == null) {
         return "";
      } else {
         for(int var2 = 0; var2 < this.target.cbgroup.length; ++var2) {
            if (this.target.cbgroup[var2] != null && this.target.cbgroup[var2].getCurrent() != null) {
               var1 = var1 + "\t\tCheckboxGroup cbGroup" + Integer.toString(var2) + " = new CheckboxGroup();\r\n";
            }
         }

         return var1;
      }
   }

   public void InitClass(JDPUser var1, JDPLayoutMgr var2, String var3) {
      super.user = var1;
      this.target = var2;
      this.sourceBuffer = new StringBuffer();
      this.loadSource(10);
      this.targetGenerator = new JDPLayoutGenerator(var1, (String)null, (String)null);
   }
}
