import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.List;
import java.awt.Panel;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPGridLayout extends JDPClassLayout {
   Panel targetPanel;
   String moduleParameter;
   JDPSelectDSN targetDSN;
   JDPSelectTable targetTable;
   JDPSelectColumns targetColumns;
   JDPSelectReportDef targetDefinition;
   JDPGridSettings targetSettings;
   JDPLayoutMgr targetLayoutMgr;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   JDPTextGrid tableContents;
   Vector indexes;
   String[] maskEdit;
   String[] maskType;
   JDPJagg jaggSQL;
   String prevSQL = "";
   Vector gParmObject;
   int[] dataType;
   int columnCount;
   JDPTabSelectPanel tabPanel;

   void loadChoices() {
      this.jaggSQL.loadSettings(this.targetTable.targetDSN);
      this.tableContents.fieldTypeCol = new int[this.columnCount];
      this.tableContents.isPullDownCol = new boolean[this.columnCount];
      this.tableContents.pullDownColType = new int[this.columnCount];
      this.tableContents.pullDownList = new List[this.columnCount][1];
      int var1 = 0;

      for(int var2 = 0; var2 < this.targetSettings.fieldType.length; ++var2) {
         if (this.targetSettings.fieldActive[var2]) {
            this.tableContents.fieldTypeCol[var1] = 0;
            if (!this.targetSettings.fieldType[var2].equals("JDPChoice") && !this.targetSettings.fieldType[var2].equals("JDPComboBox")) {
               if (this.targetSettings.fieldType[var2].equals("Checkbox")) {
                  this.tableContents.setFieldTypeCol(var1, 3);
               } else if (this.targetSettings.fieldType[var2].equals("JDPSpinner")) {
                  this.tableContents.setFieldTypeCol(var1, 2);
               } else if (this.targetSettings.fieldType[var2].equals("JDPDate")) {
                  this.tableContents.setFieldTypeCol(var1, 1);
                  this.tableContents.isPullDownCol[var1] = true;
                  this.tableContents.pullDownList[var1][0] = null;
                  this.tableContents.pullDownColType[var1] = 1;
               }
            } else {
               this.tableContents.setFieldTypeCol(var1, 1);
               this.tableContents.isPullDownCol[var1] = true;
               this.tableContents.pullDownList[var1][0] = new List();
               this.tableContents.pullDownColType[var1] = 0;
               if (this.targetSettings.thisChoicePanel.valuesFrom[var2].equals("Fields entered here")) {
                  for(int var3 = 0; var3 < JDPChoiceLayout.maxChoices; ++var3) {
                     if (this.targetSettings.thisChoicePanel.textChoiceValue[var2][var3] != null && this.targetSettings.thisChoicePanel.textChoiceValue[var2][var3].trim().length() > 0) {
                        this.tableContents.pullDownList[var1][0].addItem(this.targetSettings.thisChoicePanel.textChoiceValue[var2][var3]);
                     }
                  }
               }

               if (this.targetSettings.thisChoicePanel.valuesFrom[var2].equals("Database table/columns")) {
                  new JDPLoadChoice(super.user, this.jaggSQL, this.tableContents.pullDownList[var1][0], this.targetSettings.thisChoicePanel.textChoiceSql[var2], this.targetSettings.thisChoicePanel.columnActualList[var2], this.targetSettings.thisChoicePanel.tableList[var2], this.targetSettings.thisChoicePanel.tableWhereClause[var2], (Vector)null);
               }
            }

            ++var1;
         }
      }

   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPGridLayout" + super.componentName;
      int[] var3 = new int[0];
      int[] var4 = new int[0];
      var3 = (int[])var1.restoreObject(var3, var2, "columnWidth");
      var4 = (int[])var1.restoreObject(var4, var2, "columnOrder");
      boolean var5 = false;

      for(int var6 = 0; var6 < var3.length; ++var6) {
         if (var3[var6] != 100) {
            var5 = true;
            break;
         }
      }

      if (var3 != null && var5) {
         for(int var9 = 0; var9 < var3.length; ++var9) {
            if (this.tableContents.columnWidth.length > var9) {
               this.tableContents.columnWidth[var9] = var3[var9];
               this.tableContents.columnOrder[var9] = var4[var9];
            }
         }
      }

      this.tableContents.newTable();
      return true;
   }

   void loadLayoutComponent() {
      this.refresh();
      if (this.targetLayoutMgr != null) {
         this.targetLayoutMgr.gSource.targetGenerator.setHandle(this);
      }

   }

   String setModuleParameter(String var1) {
      int var2 = var1.indexOf("JDPLayoutMgr:");
      if (var2 >= 0) {
         super.componentName = var1.substring(var2 + 13);
         if (super.componentName.endsWith("GL1")) {
            super.componentName = super.componentName.substring(0, super.componentName.length() - 3);
         }

         if (var2 > 0) {
            this.moduleParameter = var1.substring(0, var2);
         } else if (super.componentName.startsWith("Report")) {
            this.moduleParameter = "Report";
         } else {
            this.moduleParameter = "";
         }

         var1 = this.moduleParameter;
      }

      return var1;
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPGridLayout" + super.componentName;
      var1.saveObject(this.tableContents.columnWidth, var2, "columnWidth");
      var1.saveObject(this.tableContents.columnOrder, var2, "columnOrder");
      return true;
   }

   void refresh() {
      this.prevSQL = "";
      this.retrieveColumns();
      this.loadGrid();
      this.restoreSelections();
   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.targetTable = (JDPSelectTable)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.targetColumns = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectReportDef" + super.componentName) == 0) {
               this.targetDefinition = (JDPSelectReportDef)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("GridSettings" + super.componentName) == 0) {
               this.targetSettings = (JDPGridSettings)var2.elementAt(1);
               if (this.targetSettings.getComponentName().equals(((JDPClassLayout)this).getComponentName())) {
                  ((JDPClassLayout)this).setThisBranch(this.targetSettings.thisBranch);
               }
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target instanceof Button) {
               String var2 = (String)var1.arg;
               if (var2 != null && var2.trim().compareTo("Accept") == 0) {
                  this.saveSelections();
                  super.user.mainmsg.setStatusMsg("Selections accepted.", 10);
                  if (super.componentName.equals("")) {
                     super.user.jdpMenuPanel.loadNextTab();
                  }

                  return true;
               }

               if (var2.trim().compareTo("Reset") == 0) {
                  return true;
               }
            }

            return false;
         default:
            return false;
      }
   }

   void loadGrid() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      int var5 = 0;
      int var7 = 0;
      this.columnCount = 0;
      if (this.targetTable != null && this.targetTable.datasource.getText().compareTo("") != 0) {
         if (this.targetTable.tables.getSelectedIndex() < 0) {
            if (super.componentName.equals("")) {
               super.user.mainmsg.setStatusMsg("You must first select a Table.", 5);
            }

         } else {
            if (this.moduleParameter.equals("Report")) {
               if (this.targetDefinition == null) {
                  super.user.mainmsg.setStatusMsg("You must first specify the Report Definition.", 5);
                  return;
               }

               if ((this.targetSettings == null || this.targetSettings.columns.countItems() == 0) && super.componentName.equals("")) {
                  super.user.mainmsg.setStatusMsg("You must first specify Column settings.", 5);
                  return;
               }
            } else if (this.targetSettings == null || this.targetSettings.columns.countItems() == 0) {
               super.user.mainmsg.setStatusMsg("You must first specify Grid settings.", 5);
               return;
            }

            this.dataType = new int[this.targetSettings.columns.countItems()];
            this.indexes = new Vector();
            String var10 = "SELECT ";
            if (this.moduleParameter.equals("Report")) {
               int var11 = 0;
               String var12 = "";

               for(int var13 = 0; var13 < this.targetSettings.columns.countItems(); ++var13) {
                  if (this.targetSettings.fieldActive[var13] && var12.indexOf(this.targetSettings.fieldSql[var13] + ",") < 0) {
                     int var14 = this.targetSettings.columnIndexes[var13];
                     this.dataType[var11] = this.targetColumns.columnDatatype[var14];
                     ++var11;
                     if (var10.length() > 8) {
                        var10 = var10 + ",";
                     }

                     var10 = var10 + this.targetSettings.fieldSql[var13];
                     var12 = var12 + this.targetSettings.fieldSql[var13] + ",";
                     this.indexes.addElement(Integer.toString(var13));
                     ++this.columnCount;
                  }
               }
            } else {
               for(int var34 = 0; var34 < this.targetSettings.columns.countItems(); ++var34) {
                  if (this.targetSettings.fieldActive[var34]) {
                     if (var10.length() > 8) {
                        var10 = var10 + ",";
                     }

                     var10 = var10 + this.targetSettings.fieldSql[var34];
                     this.indexes.addElement(Integer.toString(var34));
                     ++this.columnCount;
                  }
               }
            }

            if (!var10.equals("SELECT ")) {
               var10 = var10 + " FROM ";
               String var35 = null;
               String var36 = "";

               for(int var37 = 0; var37 < this.targetTable.joinConditions.countItems(); ++var37) {
                  if (this.targetTable.joinConditions.getItem(var37).indexOf("*=") > 0) {
                     var35 = "left";
                     var36 = this.targetTable.joinConditions.getItem(var37);
                  }

                  if (this.targetTable.joinConditions.getItem(var37).indexOf("=*") > 0) {
                     var35 = "right";
                     var36 = this.targetTable.joinConditions.getItem(var37);
                  }
               }

               String var38 = "";
               String var40 = "";
               int[] var15 = this.targetTable.stables.getSelectedIndexes();
               var38 = this.targetTable.tables.getSelectedItem();
               if (var15.length > 0) {
                  var38 = var38 + " a";
               }

               if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                  var38 = var38 + " (NOLOCK)";
               }

               for(int var16 = 0; var16 < var15.length; ++var16) {
                  if (var35 == null) {
                     var40 = var40 + ",";
                  }

                  var40 = var40 + this.targetTable.stables.getItem(var15[var16]);
                  var40 = var40 + " " + this.targetTable.stableAlias[var15[var16]];
                  if (this.targetDSN.dsnType.equals(JDPJagg.MSSQLSERVER)) {
                     var40 = var40 + " (NOLOCK)";
                  }
               }

               StringBuffer var42 = new StringBuffer();
               if (var35 == null) {
                  var42.append(var38);
                  var42.append(var40);
               } else if (var35.equals("left")) {
                  var42.append("{oj ");
                  var42.append(var38);
                  var42.append(" LEFT OUTER JOIN ");
                  var42.append(var40);
                  var42.append(" ON ");
                  var42.append(super.user.u.replace(var36, "*", ""));
                  var42.append("}");
               } else if (var35.equals("right")) {
                  var42.append("{oj ");
                  var42.append(var40);
                  var42.append(" LEFT OUTER JOIN ");
                  var42.append(var38);
                  var42.append(" ON ");
                  var42.append(super.user.u.replace(var36, "*", ""));
                  var42.append("}");
               }

               var10 = var10 + var42.toString();
               if (this.targetTable.joinConditions.countItems() > 0) {
                  boolean var17 = true;

                  for(int var18 = 0; var18 < this.targetTable.joinConditions.countItems(); ++var18) {
                     if (!this.targetTable.joinConditions.getItem(var18).equals(var36)) {
                        if (var17) {
                           var10 = var10 + " WHERE ";
                        } else {
                           var10 = var10 + " AND ";
                        }

                        var10 = var10 + this.targetTable.joinConditions.getItem(var18);
                        var17 = false;
                     }
                  }
               }

               if (this.moduleParameter.equals("Report")) {
                  var7 = this.targetDefinition.groupBy.countItems();

                  for(int var43 = 0; var43 < var7; ++var43) {
                     if (var43 == 0) {
                        if (var10.toUpperCase().indexOf("SUM(") <= 0 && var10.toUpperCase().indexOf("AVG(") <= 0 && var10.toUpperCase().indexOf("MIN(") <= 0 && var10.toUpperCase().indexOf("MAX(") <= 0) {
                           var10 = var10 + " ORDER BY ";
                        } else {
                           var10 = var10 + " GROUP BY ";
                        }
                     }

                     if (var43 > 0) {
                        var10 = var10 + ",";
                     }

                     var10 = var10 + this.targetDefinition.groupBy.getItem(var43);
                  }

                  this.tableContents.gridColor = Color.white;
                  if (var7 == 0) {
                     super.user.mainmsg.setStatusMsg("You must choose a column by which to order your report.", 5);
                     return;
                  }
               }

               if (!var10.equals(this.prevSQL)) {
                  this.prevSQL = var10;
                  super.user.mainmsg.setStatusMsg("Accessing database...", 0);
                  this.jaggSQL.loadSettings(this.targetTable.targetDSN);
                  this.jaggSQL.setMRW("40");
                  var2 = this.jaggSQL.execSQL(var10, var3);
                  if (var2 == -1) {
                     super.user.u.setSqlMessage(this.jaggSQL, var10);
                     return;
                  }

                  if (super.user.DEBUG) {
                     System.out.println("JDPSelectTable/loadList COL: " + Integer.toString(this.jaggSQL.getColumnCount()));
                  }

                  if (var2 > 0) {
                     this.columnCount = this.jaggSQL.getColumnCount();
                  }

                  var5 = this.jaggSQL.getRowCount();
                  if (this.moduleParameter.equals("Report")) {
                     this.tableContents.currentText = new String[this.columnCount][var5 * (var7 + 1) + 10];
                     this.tableContents.cellFont = new Font[this.columnCount][var5 * (var7 + 1) + 10];
                     this.tableContents.lockedColumns = this.targetDefinition.groupBy.countItems();
                  } else {
                     this.tableContents.currentText = new String[this.columnCount][var5];
                  }

                  String[] var44 = new String[this.columnCount];
                  int var46 = 0;
                  float[][] var8 = new float[1][1];
                  float[][] var9 = new float[1][1];
                  this.maskEdit = new String[this.columnCount];
                  this.maskType = new String[this.columnCount];
                  if (this.moduleParameter.equals("Report")) {
                     int var19 = this.columnCount / 2 - 1;
                     if (var19 < 0) {
                        var19 = 0;
                     }

                     this.tableContents.currentText[var19][1] = this.targetDefinition.reportTitle.getText();
                     this.tableContents.cellFont[var19][1] = new Font(super.user.plainFont.getName(), 1, super.user.plainFont.getSize() + 4);

                     for(int var20 = 0; var20 < this.columnCount; ++var20) {
                        int var21 = Integer.parseInt((String)this.indexes.elementAt(var20));
                        this.tableContents.currentText[var20][3] = this.targetSettings.fieldLText[var21];
                        this.tableContents.cellFont[var20][3] = super.user.boldFont;
                     }

                     var46 = 4;
                     var8 = new float[var7][this.columnCount];
                     var9 = new float[var7][this.columnCount];
                  }

                  int var48;
                  for(var48 = 0; var48 < var5; ++var48) {
                     String var6 = (String)var3.elementAt(var48);
                     if (var6 != null && var6.trim().compareTo("") != 0) {
                        StringTokenizer var1 = new StringTokenizer(var6);

                        for(int var51 = 0; var51 < this.columnCount; ++var51) {
                           int var22 = Integer.parseInt((String)this.indexes.elementAt(var51));
                           String var50 = var1.nextToken(var4).trim();
                           this.tableContents.currentText[var51][var48 + var46] = var50;
                           if (this.targetSettings.fieldType[var22].equals("JDPDate")) {
                              try {
                                 this.tableContents.currentText[var51][var48 + var46] = JDPDate.format(new Date(Long.valueOf(var50)));
                              } catch (Exception var25) {
                              }
                           }

                           if (!this.targetSettings.fieldEditMask[var22].equals("")) {
                              this.maskEdit[var51] = this.targetSettings.fieldEditMask[var22];
                              if (JDPUtils.isOdbcNum(this.targetColumns.columnDatatype[this.targetSettings.columnIndexes[var22]])) {
                                 this.tableContents.currentText[var51][var48 + var46] = this.JDPMaskEditMain.formatFloat(this.tableContents.currentText[var51][var48 + var46], this.targetSettings.fieldEditMask[var22]);
                                 this.maskType[var51] = "Float";
                              } else {
                                 this.tableContents.currentText[var51][var48 + var46] = this.JDPMaskEditMain.formatString(this.tableContents.currentText[var51][var48 + var46], this.targetSettings.fieldEditMask[var22]);
                                 this.maskType[var51] = "String";
                              }
                           }
                        }

                        if (this.moduleParameter.equals("Report")) {
                           for(int var52 = this.columnCount - 1; var52 >= 0; --var52) {
                              String var57 = this.tableContents.currentText[var52][var48 + var46];
                              if (var7 > var52 && var48 > 0) {
                                 if (var57.equals(var44[var52])) {
                                    this.tableContents.currentText[var52][var48 + var46] = "";
                                 } else {
                                    if (this.targetDefinition.subTotal[var52]) {
                                       for(int var23 = 0; var23 < this.columnCount; ++var23) {
                                          this.tableContents.currentText[var23][var48 + var46 + 1] = this.tableContents.currentText[var23][var48 + var46];
                                          this.tableContents.currentText[var23][var48 + var46] = "";
                                          this.tableContents.cellFont[var23][var48 + var46 + 1] = this.tableContents.cellFont[var23][var48 + var46];
                                          this.tableContents.cellFont[var23][var48 + var46] = null;
                                       }

                                       this.tableContents.currentText[var52][var48 + var46] = "Subtotal";
                                       this.tableContents.cellFont[var52][var48 + var46] = super.user.boldFont;

                                       for(int var62 = var52 + 1; var62 < this.columnCount; ++var62) {
                                          int var24 = Integer.parseInt((String)this.indexes.elementAt(var62));
                                          if (this.targetSettings.fieldTotal[var24]) {
                                             this.tableContents.currentText[var62][var48 + var46] = this.JDPMaskEditMain.formatFloat(var8[var52][var62], this.targetSettings.fieldEditMask[var24]);
                                             this.tableContents.cellFont[var62][var48 + var46] = super.user.boldFont;
                                          }

                                          var8[var52][var62] = 0.0F;
                                       }

                                       ++var46;
                                    }

                                    this.tableContents.currentText[var52][var48 + var46] = var57;
                                 }
                              }

                              if (var7 > 0 && var48 > 0) {
                                 try {
                                    float var63 = Float.valueOf(this.JDPMaskEditMain.stripFloat(var44[var52]));

                                    for(int var68 = 0; var68 < var7; ++var68) {
                                       var8[var68][var52] += var63;
                                       var9[var68][var52] += var63;
                                    }
                                 } catch (Exception var27) {
                                 }
                              }

                              var44[var52] = var57;
                           }
                        }
                     }
                  }

                  if (this.moduleParameter.equals("Report")) {
                     for(int var53 = 0; var53 < this.columnCount; ++var53) {
                        try {
                           float var58 = Float.valueOf(this.JDPMaskEditMain.stripFloat(var44[var53]));

                           for(int var64 = 0; var64 < var7; ++var64) {
                              var8[var64][var53] += var58;
                              var9[var64][var53] += var58;
                           }
                        } catch (Exception var26) {
                        }
                     }

                     for(int var54 = this.columnCount - 1; var54 >= 0; --var54) {
                        if (var7 > var54 && this.targetDefinition.subTotal[var54]) {
                           this.tableContents.currentText[var54][var48 + var46] = "Subtotal";
                           this.tableContents.cellFont[var54][var48 + var46] = super.user.boldFont;

                           for(int var59 = var54 + 1; var59 < this.columnCount; ++var59) {
                              int var65 = Integer.parseInt((String)this.indexes.elementAt(var59));
                              if (this.targetSettings.fieldTotal[var65]) {
                                 this.tableContents.currentText[var59][var48 + var46] = this.JDPMaskEditMain.formatFloat(var8[var54][var59], this.targetSettings.fieldEditMask[var65]);
                                 this.tableContents.cellFont[var59][var48 + var46] = super.user.boldFont;
                              }
                           }

                           ++var46;
                        }
                     }

                     for(int var55 = this.columnCount - 1; var55 >= 0; --var55) {
                        if (var7 > var55 && this.targetDefinition.grandTotal[var55]) {
                           this.tableContents.currentText[var55][var48 + var46] = "Total";
                           this.tableContents.cellFont[var55][var48 + var46] = super.user.boldFont;

                           for(int var60 = var55 + 1; var60 < this.columnCount; ++var60) {
                              int var66 = Integer.parseInt((String)this.indexes.elementAt(var60));
                              if (this.targetSettings.fieldTotal[var66]) {
                                 this.tableContents.currentText[var60][var48 + var46] = this.JDPMaskEditMain.formatFloat(var9[var55][var60], this.targetSettings.fieldEditMask[var66]);
                                 this.tableContents.cellFont[var60][var48 + var46] = super.user.boldFont;
                              }
                           }

                           ++var46;
                        }
                     }
                  }

                  var2 = this.indexes.size();
                  if (var5 < 1) {
                     this.tableContents.currentText = new String[var2][50];
                  }

                  if (!this.moduleParameter.equals("Report")) {
                     this.tableContents.columnHeader = new String[var2];
                  } else {
                     this.tableContents.columnHeader = null;
                  }

                  this.tableContents.columnHeaderStyle = new int[var2];
                  this.tableContents.columnStyle = new int[var2];
                  this.tableContents.columnHeaderColor = new Color[var2];
                  this.tableContents.columnColor = new Color[var2];
                  this.tableContents.columnBGColor = new Color[var2];
                  this.tableContents.columnProtected = new boolean[var2];
                  this.tableContents.rowHeader = null;
                  this.tableContents.columnWidth = new int[var2];
                  this.tableContents.rightJustify = new boolean[var2];

                  for(int var56 = 0; var56 < this.indexes.size(); ++var56) {
                     var48 = Integer.parseInt((String)this.indexes.elementAt(var56));
                     if (!this.moduleParameter.equals("Report")) {
                        this.tableContents.columnHeader[var56] = this.targetSettings.fieldLText[var48];
                     }

                     this.tableContents.columnHeaderStyle[var56] = this.targetSettings.fieldLStyle[var48];
                     this.tableContents.columnStyle[var56] = this.targetSettings.fieldStyle[var48];
                     this.tableContents.columnHeaderColor[var56] = this.targetSettings.fieldLabelColor[var48];
                     this.tableContents.columnColor[var56] = this.targetSettings.fieldTextColor[var48];
                     this.tableContents.columnBGColor[var56] = this.targetSettings.fieldBackColor[var48];
                     this.tableContents.columnProtected[var56] = !this.targetSettings.fieldEditable[var48];
                     if (this.targetSettings.fieldAlignment[var48].equals("Right")) {
                        this.tableContents.rightJustify[var56] = true;
                     }

                     this.tableContents.columnWidth[var56] = this.targetSettings.fieldWidth[var48] * 7;
                     int var61 = super.user.u.StringWidth(this.targetLayoutMgr.getGraphics(), this.targetSettings.fieldLText[var48]) + 15;
                     int var67 = super.user.u.StringWidth(this.targetLayoutMgr.getGraphics(), this.tableContents.currentText[var56][0]) + 15;
                     if (var67 > var61) {
                        var61 = var67;
                     }

                     this.tableContents.columnWidth[var56] = var61;
                     if (this.tableContents.columnWidth[var56] < 30) {
                        this.tableContents.columnWidth[var56] = 30;
                     }

                     if (this.tableContents.columnWidth[var56] > 150) {
                        this.tableContents.columnWidth[var56] = 150;
                     }
                  }
               } else {
                  for(int var45 = 0; var45 < this.indexes.size(); ++var45) {
                     int var47 = Integer.parseInt((String)this.indexes.elementAt(var45));
                     if (!this.moduleParameter.equals("Report")) {
                        this.tableContents.columnHeader[var45] = this.targetSettings.fieldLText[var47];
                     }

                     this.tableContents.columnHeaderStyle[var45] = this.targetSettings.fieldLStyle[var47];
                     this.tableContents.columnStyle[var45] = this.targetSettings.fieldStyle[var47];
                     this.tableContents.columnHeaderColor[var45] = this.targetSettings.fieldLabelColor[var47];
                     this.tableContents.columnColor[var45] = this.targetSettings.fieldTextColor[var47];
                     this.tableContents.columnBGColor[var45] = this.targetSettings.fieldBackColor[var47];
                     this.tableContents.columnProtected[var45] = !this.targetSettings.fieldEditable[var47];
                  }
               }

               if (!this.moduleParameter.equals("Report")) {
                  this.loadChoices();
               }

               this.tableContents.newTable();
               this.restoreSelections();
               super.user.mainmsg.clearStatusMsg();
            }
         }
      } else {
         if (super.componentName.equals("")) {
            super.user.mainmsg.setStatusMsg("You must first select a Data Source.", 5);
         }

      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPGridLayout" + super.componentName;
      var1.removeObject(this.tableContents.columnWidth, var2, "columnWidth");
      var1.removeObject(this.tableContents.columnOrder, var2, "columnOrder");
      return true;
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.targetPanel = var2;
      this.moduleParameter = var3;
      var3 = this.setModuleParameter(var3);
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.JDPMaskEditMain = new JDPMaskEdit();
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      this.tableContents = new JDPTextGrid(var1);
      ((Container)var4).add("Center", this.tableContents);
      if (!var3.equals("Combo") && super.componentName.equals("")) {
         String[] var5 = new String[]{"Accept"};
         int[] var6 = new int[]{5};
         JDPButtons var7 = new JDPButtons(var1, var5, var6, JDPButtons.HORIZONTAL);
         ((Container)var4).add("South", var7);
         this.popuppanel.addComponent(var7.button[0], "Accept Settings", "Accept settings and proceed to build process");
         if (var3.equals("Report")) {
            ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Construct the Report layout", var4, "North"));
         } else {
            ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Construct the Grid layout", var4, "North"));
         }
      } else {
         ((Container)this).add("Center", var4);
      }

      this.loadLayoutComponent();
      this.gParmObject = new Vector();
      this.gParmObject.addElement("GridLayout" + super.componentName);
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
