import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Vector;

public class JDPGridSettings extends JDPClassLayout {
   JDPSelectColumns target;
   String moduleParameter;
   JDPSelectDSN targetDSN;
   JDPSelectTable tableTarget;
   JDPSelectReportDef targetReportDef;
   JDPGridLayout targetGrid;
   JDPListLayout targetList;
   JDPLayoutMgr targetLayoutMgr;
   Panel targetPanel;
   JDPPopupMessage popuppanel;
   JDPChoiceLayout thisChoicePanel;
   Panel cardPanel;
   int[] columnIndexes;
   JDPList columns;
   TextField maxRows;
   TextField fieldltext;
   TextField fieldsql;
   JDPComboBox includeinupdatesql;
   JDPComboBox fieldeditable;
   JDPComboBox fieldlstyle;
   JDPComboBox fieldstyle;
   JDPComboBox fieldlabelcolor;
   JDPComboBox fieldtextcolor;
   JDPComboBox fieldbackcolor;
   JDPComboBox fieldalignment;
   JDPComboBox fieldtotal;
   TextField pfromwhereclause;
   JDPComboBox fieldtype;
   JDPComboBox fielddefault;
   JDPComboBox fieldeditmask;
   JDPWrapLabel editLabel;
   TextField checkedvalue;
   TextField uncheckedvalue;
   JDPComboBox lockingColumn;
   JDPRichText lockingText;
   Label listCount;
   boolean[] fieldActive;
   String[] fieldLText;
   String[] fieldSql;
   String[] includeInUpdateSql;
   boolean[] fieldEditable;
   int[] fieldLStyle;
   int[] fieldStyle;
   Color[] fieldLabelColor;
   Color[] fieldTextColor;
   Color[] fieldBackColor;
   String[] fieldAlignment;
   boolean[] fieldTotal;
   int[] fieldWidth;
   String[] fieldType;
   String[] fieldDefault;
   String[] fieldEditMask;
   String[] checkedValue;
   String[] uncheckedValue;
   Vector gParmObject;
   int currentSelection = -1;
   JDPTabSelectPanel tabPanel;
   static String lockingTextString = "Select the Integer column that is to be used for the record locking mechanism.\n\n" + "When a row is selected from the table the current value of this Integer column is stored. " + "When an update or delete is made a check will be made to ensure that the row still has the " + "same value for this column. If not the update will fail and a prompt will be shown to ask the " + "user whether to update anyway or reload the record.\n\nIf the update is successful the column " + "value will be incremented thereby stopping some other user from accidently updating over the " + "changes without being aware of it.";

   void updateArrays() {
      if (this.currentSelection >= 0) {
         if (this.fieldSql[this.currentSelection].indexOf(".") > 0 && this.fieldSql[this.currentSelection].indexOf("a.") < 0 && (this.fieldtype.getSelectedItem().equals("JDPChoice") || this.fieldtype.getSelectedItem().equals("JDPComboBox") || this.fieldtype.getSelectedItem().equals("JDPSpinner"))) {
            this.fieldtype.select("TextField");
         }

         this.fieldActive[this.currentSelection] = this.columns.isSelected(this.currentSelection);
         this.fieldTotal[this.currentSelection] = this.fieldtotal.getSelectedItem().equals("Yes");
         this.fieldLText[this.currentSelection] = this.fieldltext.getText();
         this.fieldSql[this.currentSelection] = this.fieldsql.getText();
         this.includeInUpdateSql[this.currentSelection] = this.includeinupdatesql.getSelectedItem();
         if (this.fieldlstyle.getSelectedItem().equals("Bold")) {
            this.fieldLStyle[this.currentSelection] = 1;
         } else {
            this.fieldLStyle[this.currentSelection] = 0;
         }

         if (this.fieldstyle.getSelectedItem().equals("Bold")) {
            this.fieldStyle[this.currentSelection] = 1;
         } else {
            this.fieldStyle[this.currentSelection] = 0;
         }

         this.fieldEditable[this.currentSelection] = this.fieldeditable.getSelectedItem().equals("Yes");
         this.fieldLabelColor[this.currentSelection] = super.user.u._cvtcolor(this.fieldlabelcolor.getSelectedItem());
         this.fieldTextColor[this.currentSelection] = super.user.u._cvtcolor(this.fieldtextcolor.getSelectedItem());
         this.fieldBackColor[this.currentSelection] = super.user.u._cvtcolor(this.fieldbackcolor.getSelectedItem());
         this.fieldAlignment[this.currentSelection] = this.fieldalignment.getSelectedItem();
         this.fieldType[this.currentSelection] = this.fieldtype.getSelectedItem();
         this.fieldDefault[this.currentSelection] = this.fielddefault.getText();
         this.fieldEditMask[this.currentSelection] = this.fieldeditmask.getText();
         this.checkedValue[this.currentSelection] = this.checkedvalue.getText();
         this.uncheckedValue[this.currentSelection] = this.uncheckedvalue.getText();
         if (this.fieldtype.getSelectedItem().equals("JDPChoice")) {
            this.thisChoicePanel.updateArrays(this.currentSelection);
         }

         String var1 = this.fieldType[this.currentSelection];
         if (this.fieldType[this.currentSelection].equals("JDPComboBox")) {
            var1 = "JDPChoice";
         }

         ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, var1);
      }
   }

   void clearList() {
      while(this.columns.countItems() > 0) {
         this.columns.delItem(0);
      }

   }

   void loadList() {
      this.clearList();
      if (this.target != null && this.target.columnName != null && this.target.columns.getSelectedIndexes().length != 0) {
         if (this.moduleParameter.equals("Report") && this.targetReportDef == null) {
            super.user.mainmsg.setStatusMsg("You must first define report settings.", 10);
         } else {
            String[] var1 = this.target.columns.getSelectedItems();
            this.columnIndexes = this.target.columns.getSelectedIndexes();
            this.listCount.setText(Integer.toString(var1.length));
            if (this.moduleParameter.equals("Report")) {
               String var2 = "";
               int var3 = 0;

               for(int var4 = 0; var4 < this.targetReportDef.groupBy.countItems(); ++var4) {
                  var2 = var2 + this.targetReportDef.groupBy.getItem(var4) + ",";
                  var1[var4] = this.targetReportDef.groupBy.getItem(var4);

                  for(int var5 = 0; var5 < this.target.columns.countItems(); ++var5) {
                     if (var1[var4] == this.target.columns.getItem(var5)) {
                        this.columnIndexes[var4] = var5;
                     }
                  }

                  var3 = var4 + 1;
               }

               String[] var10 = this.target.columns.getSelectedItems();
               int[] var12 = this.target.columns.getSelectedIndexes();

               for(int var6 = 0; var6 < var10.length; ++var6) {
                  if (var2.indexOf(var10[var6] + ",") < 0) {
                     var1[var3] = var10[var6];
                     this.columnIndexes[var3] = var12[var6];
                     ++var3;
                  }
               }
            }

            int var7 = 0;
            var7 = var1.length;
            this.fieldActive = new boolean[var7];
            this.fieldTotal = new boolean[var7];
            this.fieldLText = new String[var7];
            this.fieldSql = new String[var7];
            this.includeInUpdateSql = new String[var7];
            this.fieldLStyle = new int[var7];
            this.fieldStyle = new int[var7];
            this.fieldEditable = new boolean[var7];
            this.fieldLabelColor = new Color[var7];
            this.fieldTextColor = new Color[var7];
            this.fieldBackColor = new Color[var7];
            this.fieldAlignment = new String[var7];
            this.fieldWidth = new int[var7];
            this.fieldType = new String[var7];
            this.fieldDefault = new String[var7];
            this.fieldEditMask = new String[var7];
            this.checkedValue = new String[var7];
            this.uncheckedValue = new String[var7];
            this.thisChoicePanel.initList(var7);
            this.lockingColumn.clear();
            this.lockingColumn.addItem("");

            for(int var9 = 0; var9 < var1.length; ++var9) {
               if ((!this.moduleParameter.equals("Combo") || var1[var9].indexOf(".") >= 0 && var1[var9].indexOf("a.") != 0 || this.targetList != null && this.targetList.uniqueTree.isSelected(this.targetList.uniqueTree.getItem(var1[var9]))) && this.moduleParameter.equals("Combo")) {
                  this.fieldActive[var9] = false;
               } else {
                  this.fieldActive[var9] = false;
               }

               this.fieldType[var9] = "TextField";
               if (this.target.useRemarks.getSelectedItem().equals("Yes") && !this.target.columnRemarks[var9].equals("")) {
                  this.fieldLText[var9] = this.target.columnRemarks[var9];
               } else {
                  this.fieldLText[var9] = super.user.u.makeLabel(var1[var9]);
               }

               this.fieldSql[var9] = var1[var9];
               this.includeInUpdateSql[var9] = "Yes";
               this.fieldLStyle[var9] = 1;
               this.fieldStyle[var9] = 0;
               this.fieldAlignment[var9] = "Left";
               int var11 = this.columnIndexes[var9];
               int var13 = this.target.columnDatatype[var11];
               if (JDPUtils.isOdbcNum(var13)) {
                  this.fieldAlignment[var9] = "Right";
                  this.fieldTotal[var9] = true;
               }

               if (JDPUtils.isOdbcDate(var13)) {
                  this.fieldType[var9] = "JDPDate";
               }

               this.fieldEditable[var9] = true;
               if (this.moduleParameter.equals("Report")) {
                  this.fieldEditable[var9] = false;
               }

               if (this.fieldSql[var9].indexOf(".") > 0 && this.fieldSql[var9].indexOf("a.") < 0) {
                  this.fieldEditable[var9] = false;
               } else if (JDPUtils.isOdbcInt(var13)) {
                  this.lockingColumn.addItem(this.fieldSql[var9]);
               }

               this.fieldLabelColor[var9] = Color.black;
               this.fieldTextColor[var9] = Color.black;
               this.fieldBackColor[var9] = Color.white;
               this.fieldWidth[var9] = Integer.parseInt(this.target.columnLength[var11]);
               this.columns.addItem(var1[var9], 8);
               if (this.fieldActive[var9]) {
                  this.columns.select(var9);
               } else {
                  this.columns.deselect(var9);
               }

               this.fieldDefault[var9] = "";
               this.fieldEditMask[var9] = "";
               this.checkedValue[var9] = "Y";
               this.uncheckedValue[var9] = "N";
               this.thisChoicePanel.loadList(var9);
            }

            this.lockingColumn.layoutChoice();
            this.thisChoicePanel.loadTableList();
         }
      } else {
         if (super.componentName.equals("")) {
            super.user.mainmsg.setStatusMsg("You must first select a Table.", 10);
         }

      }
   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPGridSettings" + super.componentName;
      boolean[] var3 = (boolean[])var1.restoreObject(this.fieldActive, var2, "fieldActive");
      String[] var4 = (String[])var1.restoreObject(this.fieldLText, var2, "fieldLText");
      String[] var5 = (String[])var1.restoreObject(this.fieldSql, var2, "fieldSql");
      String[] var6 = (String[])var1.restoreObject(this.includeInUpdateSql, var2, "includeInUpdateSql");
      boolean[] var7 = (boolean[])var1.restoreObject(this.fieldEditable, var2, "fieldEditable");
      int[] var8 = (int[])var1.restoreObject(this.fieldLStyle, var2, "fieldLStyle");
      int[] var9 = (int[])var1.restoreObject(this.fieldStyle, var2, "fieldStyle");
      Color[] var10 = (Color[])var1.restoreObject(this.fieldLabelColor, var2, "fieldLabelColor");
      Color[] var11 = (Color[])var1.restoreObject(this.fieldTextColor, var2, "fieldTextColor");
      Color[] var12 = (Color[])var1.restoreObject(this.fieldBackColor, var2, "fieldBackColor");
      String[] var13 = (String[])var1.restoreObject(this.fieldAlignment, var2, "fieldAlignment");
      boolean[] var14 = (boolean[])var1.restoreObject(this.fieldTotal, var2, "fieldTotal");
      int[] var15 = (int[])var1.restoreObject(this.fieldWidth, var2, "fieldWidth");
      String[] var16 = (String[])var1.restoreObject(this.fieldType, var2, "fieldType");
      String[] var17 = (String[])var1.restoreObject(this.fieldDefault, var2, "fieldDefault");
      String[] var18 = (String[])var1.restoreObject(this.fieldEditMask, var2, "fieldEditMask");
      String[] var19 = (String[])var1.restoreObject(this.checkedValue, var2, "checkedValue");
      String[] var20 = (String[])var1.restoreObject(this.uncheckedValue, var2, "uncheckedValue");
      var1.restoreObject(this.pfromwhereclause, var2, "pfromwhereclause");
      var1.restoreObject(this.maxRows, var2, "maxRows");
      var1.restoreObject(this.lockingColumn, var2, "lockingColumn");
      if (var16 != null) {
         if (this.fieldActive.length < var3.length) {
            this.fieldActive = new boolean[var3.length];
         }

         if (this.fieldLText.length < var4.length) {
            this.fieldLText = new String[var4.length];
         }

         if (this.fieldSql.length < var5.length) {
            this.fieldSql = new String[var5.length];
         }

         if (this.includeInUpdateSql.length < var6.length) {
            this.includeInUpdateSql = new String[var6.length];
         }

         if (this.fieldEditable.length < var7.length) {
            this.fieldEditable = new boolean[var7.length];
         }

         if (this.fieldLStyle.length < var8.length) {
            this.fieldLStyle = new int[var8.length];
         }

         if (this.fieldStyle.length < var9.length) {
            this.fieldStyle = new int[var9.length];
         }

         if (this.fieldLabelColor.length < var10.length) {
            this.fieldLabelColor = new Color[var10.length];
         }

         if (this.fieldTextColor.length < var11.length) {
            this.fieldTextColor = new Color[var11.length];
         }

         if (this.fieldBackColor.length < var12.length) {
            this.fieldBackColor = new Color[var12.length];
         }

         if (this.fieldAlignment.length < var13.length) {
            this.fieldAlignment = new String[var13.length];
         }

         if (this.fieldTotal.length < var14.length) {
            this.fieldTotal = new boolean[var14.length];
         }

         if (this.fieldWidth.length < var15.length) {
            this.fieldWidth = new int[var15.length];
         }

         if (this.fieldType.length < var16.length) {
            this.fieldType = new String[var16.length];
         }

         if (this.fieldDefault.length < var17.length) {
            this.fieldDefault = new String[var17.length];
         }

         if (this.fieldEditMask.length < var18.length) {
            this.fieldEditMask = new String[var18.length];
         }

         if (this.checkedValue.length < var19.length) {
            this.checkedValue = new String[var19.length];
         }

         if (this.uncheckedValue.length < var20.length) {
            this.uncheckedValue = new String[var20.length];
         }

         for(int var21 = 0; var21 < var16.length; ++var21) {
            this.fieldActive[var21] = var3[var21];
            this.fieldLText[var21] = var4[var21];
            this.fieldSql[var21] = var5[var21];
            this.includeInUpdateSql[var21] = var6[var21];
            this.fieldEditable[var21] = var7[var21];
            this.fieldLStyle[var21] = var8[var21];
            this.fieldStyle[var21] = var9[var21];
            this.fieldLabelColor[var21] = var10[var21];
            this.fieldTextColor[var21] = var11[var21];
            this.fieldBackColor[var21] = var12[var21];
            this.fieldAlignment[var21] = var13[var21];
            this.fieldTotal[var21] = var14[var21];
            this.fieldWidth[var21] = var15[var21];
            this.fieldType[var21] = var16[var21];
            this.fieldDefault[var21] = var17[var21];
            this.fieldEditMask[var21] = var18[var21];
            this.checkedValue[var21] = var19[var21];
            this.uncheckedValue[var21] = var20[var21];
            if (this.fieldActive[var21]) {
               this.columns.select(var21);
            } else {
               this.columns.deselect(var21);
            }

            if (this.fieldType[var21] != null && this.fieldType[var21].equals("Choice")) {
               this.fieldType[var21] = "JDPChoice";
            }
         }
      }

      this.thisChoicePanel.setComponentName(super.componentName);
      this.thisChoicePanel.restoreSelections();
      if (this.targetGrid != null) {
         this.targetGrid.restoreSelections();
      }

      return true;
   }

   void clearFields() {
      if (this.moduleParameter.equals("Report")) {
         this.maxRows.setText("5000");
         this.fieldeditable.select("No");
      } else {
         this.maxRows.setText("1000");
      }

      this.fieldltext.setText("");
      this.fieldsql.setText("");
      this.includeinupdatesql.select("Yes");
      this.fieldlstyle.select("Bold");
      this.fieldstyle.select("Plain");
      this.fieldeditable.select("Yes");
      this.fieldlabelcolor.select("Black");
      this.fieldtextcolor.select("Black");
      this.fieldbackcolor.select("White");
      this.fieldalignment.select("Left");
      this.pfromwhereclause.setText("(1=1)");
      this.fielddefault.setText("");
      this.fieldeditmask.setText("");
      this.checkedvalue.setText("Y");
      this.uncheckedvalue.setText("N");
      this.fieldtype.select("TextField");
      this.thisChoicePanel.clearFields();
   }

   void loadLayoutComponent() {
      boolean var1 = false;
      boolean var2 = false;
      if (!super.thisBranch.compType.startsWith("JDPWiz")) {
         if (this.targetLayoutMgr != null && this.targetGrid != null) {
            this.targetGrid.refresh();
            if (!this.targetLayoutMgr.projectLoading) {
               this.targetLayoutMgr.gSource.constructMethod(this.targetLayoutMgr.currentBranch, "Main");
               this.targetLayoutMgr.setButton("Layout");
               this.targetLayoutMgr.reDraw();
               return;
            }
         }
      } else if (this.targetLayoutMgr != null && (!this.targetLayoutMgr.projectLoading || this.targetLayoutMgr.loadingWizardApp)) {
         if (super.thisBranch.leaves.size() > 0) {
            this.targetLayoutMgr.lView.removeSelectedBranch();
         }

         JDPTreeBranch[] var3 = new JDPTreeBranch[1];
         JDPJagg var5 = new JDPJagg(super.user.jaggPath);
         var5.loadSettings(this.targetDSN);
         var5.setMRW("100");
         new JDPLoadChoice(super.user, var5, (Object)null, "", "", "", "", -1);
         JDPTreeBranch[] var6 = this.targetLayoutMgr.layoutTree.getTreeBranch(super.thisBranch.thisObject);
         JDPTreeBranch[] var7 = var6;
         JDPTreeBranch var8 = var6[var6.length - 1];
         if (this.columns.getSelectedIndexes().length > 0) {
            Component var9 = this.targetLayoutMgr.gSource.findRelatedComp(super.thisBranch, "JDPSearchLayout");
            Component var10 = this.targetLayoutMgr.gSource.findRelatedComp(super.thisBranch, "JDPListLayout");
            JDPTreeBranch var11 = null;
            if (var9 != null && ((JDPSearchLayout)var9).columns.getSelectedIndexes().length > 0) {
               var1 = true;
            }

            if (var10 != null && ((JDPListLayout)var10).columns.getSelectedItems().length > 0) {
               var2 = true;
            }

            boolean var12 = this.targetLayoutMgr.projectLoading;
            this.targetLayoutMgr.projectLoading = true;
            if (var1 || var2) {
               var3[0] = new JDPTreeBranch();
               var3[0].name = "Panel";
               var3[0].compType = "Panel";
               var3[0].icon = 24;
               this.targetLayoutMgr.checkDragNDrop(var3, var6);
               var11 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               var6 = this.targetLayoutMgr.layoutTree.getTreeBranch(var11);
               var7 = var6;
            }

            if (var2) {
               var3[0] = new JDPTreeBranch();
               var3[0].name = "Panel";
               var3[0].compType = "Panel";
               var3[0].icon = 24;
               this.targetLayoutMgr.checkDragNDrop(var3, this.targetLayoutMgr.layoutTree.getTreeBranch(super.thisBranch.thisObject));
               var11 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            }

            JDPTreeBranch var13 = null;
            JDPTreeBranch var14 = null;
            JDPTreeBranch var15 = null;
            if (var1) {
               this.targetLayoutMgr.setButton("Blank");
               this.targetLayoutMgr.layoutTree.addBranch(var11, super.thisBranch.name + "SP1", 7);
               ((JDPSearchLayout)var9).thisBranch = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               ((JDPSearchLayout)var9).thisBranch.compType = "JDPWhereClause";
               ((JDPSearchLayout)var9).thisBranch.compPosition = "North";
               ((JDPSearchLayout)var9).thisBranch.thisObject = new Panel();
               ((Container)super.thisBranch.thisObject).add(((JDPSearchLayout)var9).thisBranch.compPosition, (Component)((JDPSearchLayout)var9).thisBranch.thisObject);
               ((JDPSearchLayout)var9).loadLayoutComponent();
               this.targetLayoutMgr.setProperties(((JDPSearchLayout)var9).thisBranch);
               var13 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            }

            if (var2) {
               this.targetLayoutMgr.setButton("Blank");
               this.targetLayoutMgr.layoutTree.addBranch(var11, super.thisBranch.name + "RL1", 26);
               ((JDPListLayout)var10).thisBranch = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               ((JDPListLayout)var10).thisBranch.compType = "JDPSearchResults";
               ((JDPListLayout)var10).thisBranch.compPosition = "Center";
               ((JDPListLayout)var10).thisBranch.thisObject = new Panel();
               ((Container)super.thisBranch.thisObject).add(((JDPListLayout)var10).thisBranch.compPosition, (Component)((JDPListLayout)var10).thisBranch.thisObject);
               ((JDPListLayout)var10).loadLayoutComponent();
               this.targetLayoutMgr.setProperties(((JDPListLayout)var10).thisBranch);
               var14 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            }

            var3[0] = new JDPTreeBranch();
            var3[0].name = super.thisBranch.name + "GL1";
            var3[0].compType = "JDPGridLayout";
            var3[0].icon = 27;
            JDPGridLayout var4 = new JDPGridLayout();
            ((JDPClassLayout)var4).InitClass(super.user, (Panel)var7[var7.length - 1].thisObject, this.moduleParameter + "JDPLayoutMgr:" + super.componentName);
            this.targetLayoutMgr.checkDragNDrop(var3, var7, var4);
            this.targetLayoutMgr.gSource.targetGenerator.setHandle((JDPClassLayout)var4);
            String[] var16 = new String[0];
            if (!this.moduleParameter.equals("Report")) {
               var3[0] = new JDPTreeBranch();
               var3[0].name = "Panel";
               var3[0].compType = "Panel";
               var3[0].icon = 24;
               Panel var28 = new Panel();
               this.targetLayoutMgr.checkDragNDrop(var3, var7, var28);
               JDPTreeBranch var17 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               var3[0] = new JDPTreeBranch();
               var3[0].name = "JDPButtons";
               var3[0].compType = "JDPButtons";
               var3[0].icon = 17;
               JDPButtons var29;
               if (this.targetLayoutMgr.loadingWizardApp) {
                  int var18 = 0;
                  if (this.targetLayoutMgr.wizAllowInserts.equals("Yes") || this.targetLayoutMgr.wizAllowUpdates.equals("Yes")) {
                     var18 += 2;
                  }

                  if (this.targetLayoutMgr.wizAllowDeletes.equals("Yes")) {
                     ++var18;
                  }

                  String[] var19 = new String[var18];
                  int[] var20 = new int[var18];
                  var16 = new String[var18];
                  var18 = 0;
                  if (this.targetLayoutMgr.wizAllowUpdates.equals("Yes") || this.targetLayoutMgr.wizAllowInserts.equals("Yes")) {
                     var19[var18] = "Apply";
                     var16[var18] = "UpdateRows";
                     var20[var18++] = 0;
                     var19[var18] = "Refresh";
                     var16[var18] = "LoadGrid";
                     var20[var18++] = 6;
                  }

                  if (this.targetLayoutMgr.wizAllowDeletes.equals("Yes")) {
                     var19[var18] = "Remove";
                     var16[var18] = "DeleteRows";
                     var20[var18++] = 8;
                  }

                  var29 = new JDPButtons(super.user, var19, var20, JDPButtons.HORIZONTAL);
               } else {
                  String[] var34 = new String[]{"Apply", "Refresh", "Remove"};
                  int[] var38 = new int[]{0, 6, 8};
                  var29 = new JDPButtons(super.user, var34, var38, JDPButtons.HORIZONTAL);
                  String[] var42 = new String[]{"UpdateRows", "LoadGrid", "DeleteRows"};
                  var16 = var42;
               }

               this.targetLayoutMgr.checkDragNDrop(var3, var7, var29);
               var15 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var17));
               this.targetLayoutMgr.lView.removeSelectedLeaf();
            }

            if (var14 != null) {
               var14.treeVector = new Vector();
               JDPTreePicker var35 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
               int[] var39 = new int[]{4, 1, 2, 1};
               var35.setIcons(var39);
               var35.setRoot("Component Events", true);
               JDPTreeBranch var43 = var35.treeRoot;
               Object[] var21 = new Object[]{null, "Methods"};
               String[] var22 = new String[]{null, "Drop here to attach this component/method to this Event"};
               var35.setDropKeys(var21);
               var35.setDragAndDrop((boolean[])null);
               var35.setDropMessages(var22);
               String[] var23 = new String[]{"ACTION_EVENT", null, null, null};
               boolean[] var24 = new boolean[]{true, true, true, false};
               var35.setIcons(var39);
               var35.setExpanded(var24);
               var35.addEntry(var23, var39, var23[0]);
               var14.treeVector.addElement(var43);
               var39[2] = super.thisBranch.icon;
               var23[1] = super.thisBranch.name;
               var23[2] = super.thisBranch.name + "LoadGrid";
               var35.addEntry(var23, var39, var23[2]);
               JDPTreeBranch var25 = var35.getLastAddedBranch();
               var25.text = new String[1];
               var25.text[0] = var23[2] + "(" + super.thisBranch.name + "RL1.getSelectedKey());";
               String[] var26 = new String[]{"String[]"};
               this.loadParameters(var25, var26);
            }

            if (var13 != null) {
               var13.treeVector = new Vector();
               JDPTreePicker var36 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
               int[] var40 = new int[]{4, 1, 2, 1};
               var36.setIcons(var40);
               var36.setRoot("Component Events", true);
               JDPTreeBranch var44 = var36.treeRoot;
               Object[] var46 = new Object[]{null, "Methods"};
               String[] var48 = new String[]{null, "Drop here to attach this component/method to this Event"};
               var36.setDropKeys(var46);
               var36.setDragAndDrop((boolean[])null);
               var36.setDropMessages(var48);
               String[] var50 = new String[]{"ACTION_EVENT", null, null, null};
               boolean[] var52 = new boolean[]{true, true, true, false};
               var36.setIcons(var40);
               var36.setExpanded(var52);
               var36.addEntry(var50, var40, var50[0]);
               var13.treeVector.addElement(var44);
               if (var14 != null) {
                  var40[2] = var14.icon;
                  var50[1] = super.thisBranch.name + "RL1";
                  var50[2] = "clearList()";
                  var36.addEntry(var50, var40, var50[2]);
                  JDPTreeBranch var55 = var36.getLastAddedBranch();
                  var55.text = new String[1];
                  var55.text[0] = var50[1] + "." + var50[2] + ";";
                  String[] var61 = new String[0];
                  this.loadParameters(var55, var61);
                  var50[2] = "setFromWhereClause(String)";
                  var36.addEntry(var50, var40, var50[2]);
                  var55 = var36.getLastAddedBranch();
                  var55.text = new String[1];
                  var55.text[0] = var50[1] + ".setFromWhereClause(" + super.thisBranch.name + "SP1.getFromWhereClause());";
                  String[] var27 = new String[]{"String"};
                  this.loadParameters(var55, var27);
                  var50[2] = "loadList()";
                  var36.addEntry(var50, var40, var50[2]);
                  var55 = var36.getLastAddedBranch();
                  var55.text = new String[1];
                  var55.text[0] = var50[1] + "." + var50[2] + ";";
                  this.loadParameters(var55, var61);
               } else if (var13 != null) {
                  ((JDPWhereClause)var13.thisObject).setHorizontalLayout(true);
                  this.addProp(var13, "HorizontalLayout", "true", "boolean");
                  var40[2] = 27;
                  var50[1] = super.thisBranch.name + "GL1";
                  var50[2] = "LoadGridFromWhereClause(String)";
                  var36.addEntry(var50, var40, var50[2]);
                  JDPTreeBranch var58 = var36.getLastAddedBranch();
                  var58.text = new String[1];
                  var58.text[0] = super.thisBranch.name + "LoadGridFromWhereClause(" + super.thisBranch.name + "SP1.getFromWhereClause());";
                  String[] var62 = new String[0];
                  this.loadParameters(var58, var62);
               }
            }

            if (!this.moduleParameter.equals("Report")) {
               var15.treeVector = new Vector();
               JDPTreePicker var37 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
               int[] var41 = new int[]{4, 1, 2, 1};
               var37.setIcons(var41);
               var37.setRoot("Component Events", true);
               JDPTreeBranch var45 = var37.treeRoot;
               Object[] var47 = new Object[]{null, "Methods"};
               String[] var49 = new String[]{null, "Drop here to attach this component/method to this Event"};
               var37.setDropKeys(var47);
               var37.setDragAndDrop((boolean[])null);
               var37.setDropMessages(var49);
               String[] var51 = new String[]{null, null, null, null};
               int var53 = 0;

               do {
                  var51[0] = "ACTION_BTN_" + Integer.toString(var53);
                  boolean[] var59 = new boolean[]{true, true, true, false};
                  var37.setIcons(var41);
                  var37.setExpanded(var59);
                  var37.addEntry(var51, var41, "ACTION_BTN_" + Integer.toString(var53));
                  ++var53;
               } while(var53 < 3);

               var15.treeVector.addElement(var45);
               String var54 = "(new String[0]";
               if (var13 != null) {
                  var54 = "FromWhereClause(" + super.thisBranch.name + "SP1.getFromWhereClause()";
               }

               if (var14 != null) {
                  var54 = "(" + super.thisBranch.name + "RL1.getSelectedKey()";
               }

               for(int var60 = 0; var60 < var16.length; ++var60) {
                  var51[0] = "ACTION_BTN_" + Integer.toString(var60);
                  var41[2] = super.thisBranch.icon;
                  var51[1] = super.thisBranch.name;
                  var51[2] = super.thisBranch.name + var16[var60];
                  var37.addEntry(var51, var41, var51[2]);
                  JDPTreeBranch var63 = var37.getLastAddedBranch();
                  var63.text = new String[1];
                  var63.text[0] = var51[2] + var54 + ");";
                  String[] var64 = new String[]{"String[]"};
                  this.loadParameters(var63, var64);
               }
            }

            this.targetLayoutMgr.projectLoading = var12;
            var8.expanded = false;
            this.targetLayoutMgr.setProperties(var8);
            if (var8.thisObject instanceof Component) {
               ((Component)var8.thisObject).layout();
               ((Component)var8.thisObject).paintAll(((Component)var8.thisObject).getGraphics());
            }

            this.targetLayoutMgr.interactionMgr.loadMethodTree(var8, false);
            this.targetLayoutMgr.currentBranch = super.thisBranch;
            this.targetLayoutMgr.gSource.constructMethod(super.thisBranch, "Main");
            if (!this.targetLayoutMgr.projectLoading) {
               this.targetLayoutMgr.setButton("Blank");
               this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var8));
               if (var9 != null || var10 != null) {
                  this.targetLayoutMgr.refreshLayout(super.thisBranch);
               }

               this.targetLayoutMgr.setButton("Layout");
               this.targetLayoutMgr.reDraw();
            }
         }
      }

   }

   void addProp(JDPTreeBranch var1, String var2, String var3, String var4) {
      int var5;
      for(var5 = 0; var5 < var1.properties[0].length && !var1.properties[0][var5].equals(var2 + ":") && (!var1.properties[0][var5].equals("") || !var1.properties[1][var5].equals("")); ++var5) {
      }

      if (var5 >= var1.properties[0].length) {
         String[][] var6 = var1.properties;
         var1.properties = new String[3][var1.properties[0].length + 1];

         for(int var7 = 0; var7 < var6[0].length; ++var7) {
            var1.properties[0][var7] = var6[0][var7];
            var1.properties[1][var7] = var6[1][var7];
            var1.properties[2][var7] = var6[2][var7];
         }
      }

      var1.properties[0][var5] = var2 + ":";
      var1.properties[1][var5] = var3;
      var1.properties[2][var5] = var4;
   }

   void checkLockingColumns() {
      String var1 = this.lockingColumn.getSelectedItem();
      if (var1 != null && !var1.equals("")) {
         for(int var2 = 0; var2 < this.includeInUpdateSql.length; ++var2) {
            if (this.fieldSql[var2].equals(var1)) {
               this.includeInUpdateSql[var2] = "No";
            }
         }
      }

   }

   void loadParameters(JDPTreeBranch var1, String[] var2) {
      this.targetLayoutMgr.interactionMgr.loadParameterTree(var1, var2);
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPGridSettings" + super.componentName;
      var1.saveObject(this.fieldActive, var2, "fieldActive");
      var1.saveObject(this.fieldLText, var2, "fieldLText");
      var1.saveObject(this.fieldSql, var2, "fieldSql");
      var1.saveObject(this.includeInUpdateSql, var2, "includeInUpdateSql");
      var1.saveObject(this.fieldEditable, var2, "fieldEditable");
      var1.saveObject(this.fieldLStyle, var2, "fieldLStyle");
      var1.saveObject(this.fieldStyle, var2, "fieldStyle");
      var1.saveObject(this.fieldLabelColor, var2, "fieldLabelColor");
      var1.saveObject(this.fieldTextColor, var2, "fieldTextColor");
      var1.saveObject(this.fieldBackColor, var2, "fieldBackColor");
      var1.saveObject(this.fieldAlignment, var2, "fieldAlignment");
      var1.saveObject(this.fieldTotal, var2, "fieldTotal");
      var1.saveObject(this.fieldWidth, var2, "fieldWidth");
      var1.saveObject(this.fieldType, var2, "fieldType");
      var1.saveObject(this.fieldDefault, var2, "fieldDefault");
      var1.saveObject(this.fieldEditMask, var2, "fieldEditMask");
      var1.saveObject(this.checkedValue, var2, "checkedValue");
      var1.saveObject(this.uncheckedValue, var2, "uncheckedValue");
      var1.saveObject(this.pfromwhereclause, var2, "pfromwhereclause");
      var1.saveObject(this.maxRows, var2, "maxRows");
      var1.saveObject(this.lockingColumn, var2, "lockingColumn");
      this.thisChoicePanel.setComponentName(super.componentName);
      this.thisChoicePanel.saveSelections();
      this.retrieveColumns();
      if (this.targetGrid != null) {
         this.targetGrid.saveSelections();
      }

      return true;
   }

   void refresh() {
      this.clearFields();
      this.currentSelection = -1;
      this.retrieveColumns();
      this.loadList();
      this.restoreSelections();
      if (this.targetGrid != null) {
         this.targetGrid.refresh();
      }

   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.tableTarget = (JDPSelectTable)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectReportDef" + super.componentName) == 0) {
               this.targetReportDef = (JDPSelectReportDef)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("GridLayout" + super.componentName) == 0) {
               this.targetGrid = (JDPGridLayout)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("ListLayout" + super.componentName) == 0) {
               this.targetList = (JDPListLayout)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

      this.thisChoicePanel.retrieveColumns();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (!this.moduleParameter.equals("Report")) {
                  if (var1.target.equals(this.maxRows)) {
                     super.user.u.cursor(this.fieldtotal);
                     return true;
                  }

                  if (var1.target.equals(this.fieldtotal)) {
                     super.user.u.cursor(this.fieldlstyle);
                     return true;
                  }

                  if (var1.target.equals(this.fieldltext)) {
                     super.user.u.cursor(this.fieldlstyle);
                     return true;
                  }

                  if (var1.target.equals(this.fieldlstyle)) {
                     super.user.u.cursor(this.fieldlabelcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fieldlabelcolor)) {
                     super.user.u.cursor(this.fieldstyle);
                     return true;
                  }

                  if (var1.target.equals(this.fieldstyle)) {
                     super.user.u.cursor(this.fieldeditable);
                     return true;
                  }

                  if (var1.target.equals(this.fieldeditable)) {
                     super.user.u.cursor(this.fieldtextcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fieldtextcolor)) {
                     super.user.u.cursor(this.fieldbackcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fieldbackcolor)) {
                     super.user.u.cursor(this.fieldalignment);
                     return true;
                  }

                  if (var1.target.equals(this.fieldalignment)) {
                     super.user.u.cursor(this.fieldsql);
                     return true;
                  }

                  if (var1.target.equals(this.fieldsql)) {
                     super.user.u.cursor(this.includeinupdatesql);
                     return true;
                  }

                  if (var1.target.equals(this.includeinupdatesql)) {
                     super.user.u.cursor(this.maxRows);
                     return true;
                  }

                  if (!this.fieldtype.getSelectedItem().equals("Checkbox")) {
                     if (var1.target.equals(this.fieldtype)) {
                        super.user.u.cursor(this.fielddefault);
                        return true;
                     }

                     if (var1.target.equals(this.fielddefault)) {
                        super.user.u.cursor(this.fieldeditmask);
                        return true;
                     }

                     if (var1.target.equals(this.fieldeditmask)) {
                        super.user.u.cursor(this.fieldtype);
                        return true;
                     }
                  } else {
                     if (var1.target.equals(this.fieldtype)) {
                        super.user.u.cursor(this.checkedvalue);
                        return true;
                     }

                     if (var1.target.equals(this.checkedvalue)) {
                        super.user.u.cursor(this.uncheckedvalue);
                        return true;
                     }

                     if (var1.target.equals(this.uncheckedvalue)) {
                        super.user.u.cursor(this.fieldtype);
                        return true;
                     }
                  }
               } else {
                  if (var1.target.equals(this.fieldtotal)) {
                     super.user.u.cursor(this.fieldltext);
                     return true;
                  }

                  if (var1.target.equals(this.fieldltext)) {
                     super.user.u.cursor(this.fieldlstyle);
                     return true;
                  }

                  if (var1.target.equals(this.fieldlstyle)) {
                     super.user.u.cursor(this.fieldlabelcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fieldlabelcolor)) {
                     super.user.u.cursor(this.fieldstyle);
                     return true;
                  }

                  if (var1.target.equals(this.fieldstyle)) {
                     super.user.u.cursor(this.fieldtextcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fieldtextcolor)) {
                     super.user.u.cursor(this.fieldbackcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fieldbackcolor)) {
                     super.user.u.cursor(this.fieldalignment);
                     return true;
                  }

                  if (var1.target.equals(this.fieldalignment)) {
                     super.user.u.cursor(this.fieldsql);
                     return true;
                  }

                  if (var1.target.equals(this.fieldsql)) {
                     super.user.u.cursor(this.includeinupdatesql);
                     return true;
                  }

                  if (var1.target.equals(this.includeinupdatesql)) {
                     super.user.u.cursor(this.fieldeditmask);
                     return true;
                  }

                  if (var1.target.equals(this.fieldeditmask)) {
                     super.user.u.cursor(this.fieldtotal);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
         case 702:
            if (var1.target instanceof JDPList) {
               this.updateArrays();
               if (!var1.target.equals(this.columns)) {
                  return true;
               }

               int var4 = (Integer)var1.arg;
               this.loadItem(var4);
               this.currentSelection = var4;
               ((Container)this).layout();
               ((Component)this).paintAll(((Component)this).getGraphics());
            }

            return false;
         case 1001:
            if (var1.target instanceof TextField) {
               this.updateArrays();
               return true;
            } else if (var1.target instanceof JDPComboBox) {
               if (var1.target.equals(this.lockingColumn)) {
                  this.checkLockingColumns();
                  return true;
               } else {
                  this.updateArrays();
                  this.loadItem(this.columns.getSelectedIndex());
                  return true;
               }
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Accept") == 0) {
                     if (this.columns.getSelectedItems().length < 1) {
                        super.user.mainmsg.setStatusMsg("You must select at least one column to be included in the grid.", 7);
                        return true;
                     }

                     super.user.mainmsg.setStatusMsg("Saving selections...", 0);
                     this.updateArrays();
                     this.retrieveColumns();
                     this.checkLockingColumns();
                     this.saveSelections();
                     if (super.componentName.equals("")) {
                        super.user.jdpMenuPanel.loadNextTab();
                     } else {
                        this.tabPanel = JDPUtils.getTabPanel(this);
                        if (this.tabPanel != null) {
                           int var5 = this.tabPanel.getSelectedIndex();
                           this.tabPanel.loadNextTab();
                           if (var5 == this.tabPanel.getSelectedIndex() || !super.thisBranch.compType.startsWith("JDPWiz")) {
                              this.loadLayoutComponent();
                           }
                        } else {
                           this.loadLayoutComponent();
                        }
                     }

                     super.user.mainmsg.setStatusMsg("Selections accepted.", 10);
                     return true;
                  }

                  if (var2.trim().compareTo("Select All") == 0) {
                     for(int var3 = 0; var3 < this.columns.countItems(); ++var3) {
                        this.columns.select(var3);
                        this.fieldActive[var3] = true;
                     }

                     return true;
                  }

                  if (var2.trim().compareTo("Reset") == 0) {
                     this.loadList();
                     return true;
                  }
               }

               return false;
            }
         default:
            return false;
      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPGridSettings" + super.componentName;
      var1.removeObject(this.fieldActive, var2, "fieldActive");
      var1.removeObject(this.fieldLText, var2, "fieldLText");
      var1.removeObject(this.fieldSql, var2, "fieldSql");
      var1.removeObject(this.includeInUpdateSql, var2, "includeInUpdateSql");
      var1.removeObject(this.fieldEditable, var2, "fieldEditable");
      var1.removeObject(this.fieldLStyle, var2, "fieldLStyle");
      var1.removeObject(this.fieldStyle, var2, "fieldStyle");
      var1.removeObject(this.fieldLabelColor, var2, "fieldLabelColor");
      var1.removeObject(this.fieldTextColor, var2, "fieldTextColor");
      var1.removeObject(this.fieldBackColor, var2, "fieldBackColor");
      var1.removeObject(this.fieldAlignment, var2, "fieldAlignment");
      var1.removeObject(this.fieldTotal, var2, "fieldTotal");
      var1.removeObject(this.fieldWidth, var2, "fieldWidth");
      var1.removeObject(this.fieldType, var2, "fieldType");
      var1.removeObject(this.fieldDefault, var2, "fieldDefault");
      var1.removeObject(this.fieldEditMask, var2, "fieldEditMask");
      var1.removeObject(this.checkedValue, var2, "checkedValue");
      var1.removeObject(this.uncheckedValue, var2, "uncheckedValue");
      var1.removeObject(this.pfromwhereclause, var2, "pfromwhereclause");
      var1.removeObject(this.maxRows, var2, "maxRows");
      var1.removeObject(this.lockingColumn, var2, "lockingColumn");
      this.thisChoicePanel.setComponentName(super.componentName);
      this.thisChoicePanel.removeSelections();
      this.retrieveColumns();
      if (this.targetGrid != null) {
         this.targetGrid.removeSelections();
      }

      return true;
   }

   void loadItem(int var1) {
      if (var1 >= 0) {
         if (this.moduleParameter.equals("Report")) {
            for(int var2 = 0; var2 < this.targetReportDef.groupBy.countItems(); ++var2) {
               if (this.targetReportDef.groupBy.getItem(var2).equals(this.columns.getItem(var1))) {
                  this.columns.select(var1);
                  break;
               }
            }
         }

         if (this.fieldTotal[var1]) {
            this.fieldtotal.select("Yes");
         } else {
            this.fieldtotal.select("No");
         }

         if (JDPUtils.isOdbcNum(this.target.columnDatatype[this.columnIndexes[var1]])) {
            this.fieldtotal.enable();
         } else {
            this.fieldtotal.disable();
         }

         this.fieldltext.setText(this.fieldLText[var1]);
         this.fieldsql.setText(this.fieldSql[var1]);
         this.includeinupdatesql.select(this.includeInUpdateSql[var1]);
         if (this.fieldLStyle[var1] == 1) {
            this.fieldlstyle.select("Bold");
         } else {
            this.fieldlstyle.select("Plain");
         }

         if (this.fieldStyle[var1] == 1) {
            this.fieldstyle.select("Bold");
         } else {
            this.fieldstyle.select("Plain");
         }

         if (this.fieldEditable[var1]) {
            this.fieldeditable.select("Yes");
         } else {
            this.fieldeditable.select("No");
         }

         this.fieldeditable.enable();
         this.fielddefault.enable();
         this.fieldeditmask.clear();
         if (JDPUtils.isOdbcInt(this.target.columnDatatype[this.columnIndexes[var1]])) {
            this.fieldeditmask.addItem("999,999,999,999");
            this.fieldeditmask.addItem("$999,999,999,999");
            this.fieldeditmask.addItem("999.999.999.999");
            this.fieldeditmask.addItem("$999.999.999.999");
            this.fieldeditmask.addItem("99%");
         }

         if (JDPUtils.isOdbcFloat(this.target.columnDatatype[this.columnIndexes[var1]])) {
            this.fieldeditmask.addItem("999,999,999,999.00");
            this.fieldeditmask.addItem("$999,999,999,999.00");
            this.fieldeditmask.addItem("999.999.999.999,00");
            this.fieldeditmask.addItem("$999.999.999.999,00");
            this.fieldeditmask.addItem("99.00%");
            this.fieldeditmask.addItem("99,00%");
         }

         if (JDPUtils.isOdbcChar(this.target.columnDatatype[this.columnIndexes[var1]])) {
            this.fieldeditmask.addItem("___-___-____");
            this.fieldeditmask.addItem("(___)___-____");
         }

         if (this.fieldSql[var1].indexOf(".") > 0 && this.fieldSql[var1].indexOf("a.") < 0 || this.target.columnIsIdentity[this.columnIndexes[var1]]) {
            this.fieldeditable.disable();
            this.fieldeditable.select("No");
            this.fielddefault.disable();
         }

         this.fieldlabelcolor.select(JDPUtils._cvtbcolor(this.fieldLabelColor[var1]));
         this.fieldtextcolor.select(JDPUtils._cvtbcolor(this.fieldTextColor[var1]));
         this.fieldbackcolor.select(JDPUtils._cvtbcolor(this.fieldBackColor[var1]));
         this.fieldalignment.select(this.fieldAlignment[var1]);
         String var4 = this.columns.getSelectedItem();
         if (var4 != null && var4.indexOf(".") >= 0 && var4.indexOf("a.") < 0) {
            this.fieldtype.disable();
         } else {
            this.fieldtype.enable();
         }

         if (this.moduleParameter.equals("Report")) {
            this.fieldtype.disable();
         }

         this.fieldtype.select(this.fieldType[var1]);
         this.fielddefault.clear();
         this.fielddefault.addItem("");
         this.fielddefault.setText(this.fieldDefault[var1]);
         this.fieldeditmask.setText(this.fieldEditMask[var1]);
         if (this.fieldtype.getSelectedItem().equals("JDPChoice")) {
            this.fieldeditable.select("No");
            this.fieldeditable.disable();
            this.fielddefault.disable();
            this.fielddefault.setText("");
            this.fieldeditmask.setText("");
            this.thisChoicePanel.loadItem(var1);
            this.thisChoicePanel.setDisplayType(this.fieldtype.getSelectedItem());
         } else if (this.fieldtype.getSelectedItem().equals("JDPComboBox")) {
            this.fieldeditable.select("Yes");
            this.fieldeditable.disable();
            this.fielddefault.enable();
            this.fielddefault.setText("");
            this.thisChoicePanel.loadItem(var1);
            this.thisChoicePanel.setDisplayType(this.fieldtype.getSelectedItem());
         } else if (this.fieldtype.getSelectedItem().equals("JDPDate")) {
            this.editLabel.hide();
            this.fieldeditmask.hide();
         } else {
            this.editLabel.show();
            this.fieldeditmask.show();
         }

         this.checkedvalue.setText(this.checkedValue[var1]);
         this.uncheckedvalue.setText(this.uncheckedValue[var1]);
         String var3 = this.fieldType[var1];
         if (this.fieldType[var1].equals("JDPComboBox")) {
            var3 = "JDPChoice";
         }

         ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, var3);
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.targetPanel = var2;
      this.moduleParameter = var3;
      super.moduleName = "GridSettings";
      int var4 = var3.indexOf("JDPLayoutMgr:");
      if (var4 >= 0) {
         super.componentName = var3.substring(var4 + 13);
         if (var4 > 0) {
            this.moduleParameter = var3.substring(0, var4);
         } else {
            this.moduleParameter = "";
         }

         var3 = var3.substring(var4);
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      JDPScrollPanel var8 = new JDPScrollPanel();
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new JDPRowLayout(1, 1));
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new BorderLayout());
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new BorderLayout());
      Panel var12 = new Panel();
      ((Container)var12).setLayout(new BorderLayout());
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new JDPRowLayout(1, 1));
      this.cardPanel = new Panel();
      this.cardPanel.setLayout(new CardLayout());
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new BorderLayout());
      JDPScrollPanel var15 = new JDPScrollPanel();
      Panel var16 = new Panel();
      ((Container)var16).setLayout(new BorderLayout());
      Panel var17 = new Panel();
      ((Container)var17).setLayout(new BorderLayout());
      if (this.moduleParameter.equals("Report")) {
         String[] var18 = new String[]{"General", "SQL"};
         Panel[] var19 = new Panel[]{var7, var14};
         JDPTabSelectPanel var20 = new JDPTabSelectPanel(var1, var18, var19, "North");
         ((Container)var17).add("Center", var20);
      } else {
         String[] var28 = new String[]{"General", "Field Type", "SQL", "Record Locking"};
         Panel[] var30 = new Panel[]{var7, var12, var14, var16};
         JDPTabSelectPanel var32 = new JDPTabSelectPanel(var1, var28, var30, "North");
         ((Container)var17).add("Center", var32);
      }

      ((Container)var7).add("Center", new JDPChiselFramePanel(var1, "General Settings", var8, "North"));
      ((Container)var14).add("Center", new JDPChiselFramePanel(var1, "SQL Settings", var15, "North"));
      this.maxRows = new TextField("100", 6);
      this.fieldltext = new TextField("", 25);
      this.fieldsql = new TextField("", 25);
      this.includeinupdatesql = new JDPComboBox(var1, "", 5);
      this.includeinupdatesql.setEditable(false);
      this.includeinupdatesql.addItem("Yes");
      this.includeinupdatesql.addItem("No");
      this.fieldeditable = new JDPComboBox(var1, "", 5);
      this.fieldeditable.setEditable(false);
      this.fieldeditable.addItem("Yes");
      this.fieldeditable.addItem("No");
      this.fieldlstyle = new JDPComboBox(var1, "", 7);
      this.fieldlstyle.setEditable(false);
      this.fieldlstyle.addItem("Plain");
      this.fieldlstyle.addItem("Bold");
      this.fieldstyle = new JDPComboBox(var1, "", 7);
      this.fieldstyle.setEditable(false);
      this.fieldstyle.addItem("Plain");
      this.fieldstyle.addItem("Bold");
      this.fieldlabelcolor = new JDPComboBox(var1, "", 10);
      this.fieldlabelcolor.setEditable(false);
      this.fieldlabelcolor.addItem("Black");
      this.fieldlabelcolor.addItem("Gray");
      this.fieldlabelcolor.addItem("Blue");
      this.fieldlabelcolor.addItem("Cyan");
      this.fieldlabelcolor.addItem("DarkGray");
      this.fieldlabelcolor.addItem("Green");
      this.fieldlabelcolor.addItem("LightGray");
      this.fieldlabelcolor.addItem("Magenta");
      this.fieldlabelcolor.addItem("Orange");
      this.fieldlabelcolor.addItem("Pink");
      this.fieldlabelcolor.addItem("Red");
      this.fieldlabelcolor.addItem("White");
      this.fieldlabelcolor.addItem("Yellow");
      this.fieldtextcolor = new JDPComboBox(var1, "", 10);
      this.fieldtextcolor.setEditable(false);
      this.fieldtextcolor.addItem("Black");
      this.fieldtextcolor.addItem("Gray");
      this.fieldtextcolor.addItem("Blue");
      this.fieldtextcolor.addItem("Cyan");
      this.fieldtextcolor.addItem("DarkGray");
      this.fieldtextcolor.addItem("Green");
      this.fieldtextcolor.addItem("LightGray");
      this.fieldtextcolor.addItem("Magenta");
      this.fieldtextcolor.addItem("Orange");
      this.fieldtextcolor.addItem("Pink");
      this.fieldtextcolor.addItem("Red");
      this.fieldtextcolor.addItem("White");
      this.fieldtextcolor.addItem("Yellow");
      this.fieldbackcolor = new JDPComboBox(var1, "", 10);
      this.fieldbackcolor.setEditable(false);
      this.fieldbackcolor.addItem("Black");
      this.fieldbackcolor.addItem("Gray");
      this.fieldbackcolor.addItem("Blue");
      this.fieldbackcolor.addItem("Cyan");
      this.fieldbackcolor.addItem("DarkGray");
      this.fieldbackcolor.addItem("Green");
      this.fieldbackcolor.addItem("LightGray");
      this.fieldbackcolor.addItem("Magenta");
      this.fieldbackcolor.addItem("Orange");
      this.fieldbackcolor.addItem("Pink");
      this.fieldbackcolor.addItem("Red");
      this.fieldbackcolor.addItem("White");
      this.fieldbackcolor.addItem("Yellow");
      this.fieldalignment = new JDPComboBox(var1, "", 7);
      this.fieldalignment.setEditable(false);
      this.fieldalignment.addItem("Left");
      this.fieldalignment.addItem("Right");
      this.fieldtotal = new JDPComboBox(var1, "", 5);
      this.fieldtotal.setEditable(false);
      this.fieldtotal.addItem("Yes");
      this.fieldtotal.addItem("No");
      this.pfromwhereclause = new TextField("(1=1)", 30);
      if (this.moduleParameter.equals("Report")) {
         ((Container)var8).add("Left", new JDPWrapLabel(var1, "Total this column:"));
         ((Container)var8).add("Right", this.fieldtotal);
      }

      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Column Header Text:"));
      ((Container)var8).add("Right", this.fieldltext);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Column Header Style:"));
      ((Container)var8).add("Right", this.fieldlstyle);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Column Header Color:"));
      ((Container)var8).add("Right", this.fieldlabelcolor);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Column Style:"));
      ((Container)var8).add("Right", this.fieldstyle);
      if (!this.moduleParameter.equals("Report")) {
         ((Container)var8).add("Left", new JDPWrapLabel(var1, "Editable:"));
         ((Container)var8).add("Right", this.fieldeditable);
      }

      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Column Text Color:"));
      ((Container)var8).add("Right", this.fieldtextcolor);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Column Background Color:"));
      ((Container)var8).add("Right", this.fieldbackcolor);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Text Alignment:"));
      ((Container)var8).add("Right", this.fieldalignment);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "SQL Select:"));
      ((Container)var8).add("Right", this.fieldsql);
      ((Container)var8).add("Left", new JDPWrapLabel(var1, "Include in update SQL:"));
      ((Container)var8).add("Right", this.includeinupdatesql);
      this.fieldtype = new JDPComboBox(var1, "", 10);
      this.fieldtype.setEditable(false);
      this.fieldtype.addItem("TextField");
      this.fieldtype.addItem("JDPChoice");
      this.fieldtype.addItem("JDPComboBox");
      this.fieldtype.addItem("Checkbox");
      this.fieldtype.addItem("JDPSpinner");
      this.fieldtype.addItem("JDPDate");
      this.fielddefault = new JDPComboBox(var1, "", 30);
      this.fieldeditmask = new JDPComboBox(var1, "", 30);
      this.checkedvalue = new TextField("Y", 5);
      this.uncheckedvalue = new TextField("N", 5);
      JDPScrollPanel var29 = new JDPScrollPanel();
      ((Container)var29).add("Left", new JDPWrapLabel(var1, "Field Type:"));
      ((Container)var29).add("Right", this.fieldtype);
      ((Container)var12).add("North", var29);
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Default value:"));
      ((Container)var9).add("Right", this.fielddefault);
      ((Container)var13).add("Left", new JDPWrapLabel(var1, "Database value for checked:   "));
      ((Container)var13).add("Right", this.checkedvalue);
      ((Container)var13).add("Left", new JDPWrapLabel(var1, "Database value for unchecked:   "));
      ((Container)var13).add("Right", this.uncheckedvalue);
      this.editLabel = new JDPWrapLabel(var1, "Edit mask:   ");
      if (!this.moduleParameter.equals("Report")) {
         ((Container)var9).add("Left", this.editLabel);
         ((Container)var9).add("Right", this.fieldeditmask);
      } else if (this.moduleParameter.equals("Report")) {
         ((Container)var8).add("Left", this.editLabel);
         ((Container)var8).add("Right", this.fieldeditmask);
      }

      this.thisChoicePanel = new JDPChoiceLayout();
      String var31 = var3;
      if (super.thisBranch.compType.startsWith("JDPWiz")) {
         var31 = var3 + ":GS1";
      }

      this.thisChoicePanel.InitClass(var1, var2, var31);
      this.cardPanel.add("TextField", var9);
      this.cardPanel.add("JDPChoice", this.thisChoicePanel);
      this.cardPanel.add("Checkbox", var13);
      this.cardPanel.add("JDPSpinner", new Panel());
      this.cardPanel.add("JDPDate", new Panel());
      ((Container)var12).add("Center", new JDPChiselFramePanel(var1, "Field Attributes", this.cardPanel, "North"));
      if (super.componentName.equals("")) {
         ((Container)var15).add("Left", new JDPWrapLabel(var1, "Maximum Table rows to load:"));
         ((Container)var15).add("Right", this.maxRows);
      }

      ((Container)var15).add("Left", new JDPWrapLabel(var1, "Special Where Clause:"));
      ((Container)var15).add("Right", this.pfromwhereclause);
      Panel var33 = new Panel();
      ((Container)var33).setLayout(new BorderLayout());
      JDPScrollPanel var21 = new JDPScrollPanel();
      ((Container)var21).add("Left", new JDPWrapLabel(var1, "Record Locking Column:"));
      this.lockingColumn = new JDPComboBox(var1, "", 15);
      this.lockingColumn.setEditable(false);
      ((Container)var21).add("Right", this.lockingColumn);
      ((Container)var33).add("North", var21);
      this.lockingText = new JDPRichText(var1);
      this.lockingText.setText(lockingTextString);
      this.lockingText.setEditable(false);
      ((Container)var33).add("Center", this.lockingText);
      ((Container)var16).add("Center", new JDPChiselFramePanel(var1, "Record Locking Settings", var33, "North"));
      String[] var22 = new String[]{"Accept", "Select All", "Reset"};
      int[] var23 = new int[]{5, 7, 6};
      JDPButtons var24 = new JDPButtons(var1, var22, var23, JDPButtons.HORIZONTAL);
      ((Container)var17).add("South", var24);
      this.popuppanel.addComponent(var24.button[0], "Accept Selections", "Accept selections and proceed to next screen.");
      this.popuppanel.addComponent(var24.button[1], "Select All", "Select all the columns to be included in the Grid.");
      this.popuppanel.addComponent(var24.button[2], "Reset Selections", "Reset selections back to default settings.");
      ((Container)var5).add("Center", var17);
      this.columns = new JDPList(var1);
      this.columns.setSelectionsCheckboxes(true);
      this.columns.allowMultipleSelections(true);
      this.columns.setMinWidth(160);
      Panel var25 = new Panel();
      ((Container)var25).setLayout(new BorderLayout());
      ((Container)var25).add("Center", this.columns);
      ((Container)var5).add("West", var25);
      Panel var26 = new Panel();
      ((Container)var26).setLayout(new BorderLayout(4, 1));
      ((Container)var26).add("West", new Label("Columns:", 0));
      this.listCount = new Label("0      ", 0);
      Panel var27 = new Panel();
      ((Container)var27).setLayout(new BorderLayout(4, 1));
      ((Container)var27).add("West", this.listCount);
      ((Container)var27).add("Center", new Label(" ", 0));
      ((Container)var26).add("Center", var27);
      ((Container)var25).add("North", var26);
      if (!this.moduleParameter.equals("Report")) {
         ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Grid Column Settings", var5, "North"));
      } else {
         ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Report Layout Settings", var5, "North"));
      }

      this.gParmObject = new Vector();
      this.gParmObject.addElement(super.moduleName + super.componentName);
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
