import java.applet.Applet;
import java.awt.Component;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.io.File;
import java.net.URL;

public class JDPImageLoader extends Applet implements Runnable {
   JDPUser user;
   Component target;
   MediaTracker tracker;
   String ImageURL;
   Image thisImage;
   int imageIndex;
   boolean imageReady;
   JDesignerPro thisJDP;

   public JDPImageLoader(JDPUser var1, Component var2, String var3) {
      if (var2 instanceof JDPButton) {
         this.thisJDP = JDPButton.thisJDP;
      }

      if (var2 instanceof JDPTreePicker) {
         this.thisJDP = JDPTreePicker.thisJDP;
      }

      this.loadImage(var1, var2, var3, -1);
   }

   public JDPImageLoader(JDPUser var1, JDPBrowser var2, String var3, int var4) {
      this.loadImage(var1, var2, var3, var4);
   }

   void loadImage(JDPUser var1, Component var2, String var3, int var4) {
      this.user = var1;
      this.target = var2;
      this.ImageURL = var3;
      this.imageIndex = var4;
   }

   public void run() {
      this.tracker = new MediaTracker(this);
      if (this.thisJDP == null) {
         if (this.target instanceof JDesignerPro) {
            this.thisJDP = (JDesignerPro)this.target;
         } else if (this.user != null) {
            this.thisJDP = this.user.JDesignerPro;
         }
      }

      try {
         String var2 = this.ImageURL;
         if (this.user != null) {
            var2 = this.user.u.replace(this.ImageURL, "/", File.separator);
         }

         try {
            if (!JDesignerPro.executable) {
               URL var7 = new URL(this.ImageURL);
               if (var7 != null) {
                  this.thisImage = this.thisJDP.getImage(var7);
                  this.tracker.addImage(this.thisImage, 0);
               }
            } else {
               this.thisImage = Toolkit.getDefaultToolkit().getImage(var2);
               this.tracker.addImage(this.thisImage, 0);
            }
         } catch (Exception var5) {
            try {
               if (!JDesignerPro.executable) {
                  URL var1 = new URL(this.thisJDP.getCodeBase(), this.ImageURL);
                  if (var1 != null) {
                     this.thisImage = this.thisJDP.getImage(var1);
                     this.tracker.addImage(this.thisImage, 0);
                  }
               } else {
                  this.thisImage = Toolkit.getDefaultToolkit().getImage(var2);
                  this.tracker.addImage(this.thisImage, 0);
               }
            } catch (Exception var4) {
               this.thisImage = null;
            }
         }
      } catch (Exception var6) {
         this.thisImage = null;
      }

      try {
         this.tracker.waitForID(0);
         if (this.thisImage != null) {
            this.imageReady = true;
            if (this.target instanceof JDesignerPro) {
               ((JDesignerPro)this.target).JDPIconImage = this.thisImage;
            } else if (this.target instanceof JDPBrowser) {
               ((JDPBrowser)this.target).imageArray.setElementAt(this.thisImage, this.imageIndex);
               ((JDPBrowser)this.target).repaint();
            } else {
               this.target.layout();
            }
         }
      } catch (InterruptedException var3) {
      }
   }

   public boolean getImageReady() {
      return this.imageReady;
   }
}
