import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPJobQueueMgr extends Thread {
   JDPSubsystemMgr manager;
   JDPJagg jaggSQL;
   Vector results;
   Vector queues;
   boolean waiting = false;

   public JDPJobQueueMgr(JDPSubsystemMgr var1) {
      super(var1.mainThreadGroup, "JDPJobQueueMgr");
      this.manager = var1;
      this.setupJaggConnection();
      this.createQueues();
      this.createJobs();
   }

   public void run() {
      for(; !this.manager.shutdownRequested; this.waiting = false) {
         this.checkSubsystems();

         try {
            if (!this.waiting) {
               this.waiting = true;
               Thread.sleep(30000L);
            }
         } catch (Exception var1) {
         }
      }

   }

   void checkSubsystems() {
      boolean var1 = true;

      while(var1) {
         Vector var2 = new Vector();
         Vector var3 = new Vector();
         Vector var4 = new Vector();
         Vector var5 = new Vector();

         for(int var6 = 0; var6 < this.queues.size(); ++var6) {
            JDPJobQueue var7 = (JDPJobQueue)this.queues.elementAt(var6);
            var7.reOrderQueue();
            if (!var7.getQueueHeld()) {
               JDPJob var8 = var7.getNextJob();
               if (var8 != null) {
                  String var9 = var7.getSubsystem();
                  int var10 = var2.indexOf(var9);
                  if (var10 < 0) {
                     var2.addElement(var9);
                     var3.addElement(new Integer(var8.getJobQueuePriority()));
                     var4.addElement(new Integer(var8.getJobNumber()));
                     var5.addElement(var8);
                  } else {
                     int var11 = (Integer)var3.elementAt(var10);
                     int var12 = (Integer)var4.elementAt(var10);
                     if (var8.getJobQueuePriority() < var11 || var8.getJobQueuePriority() == var11 && var8.getJobNumber() < var12) {
                        var5.setElementAt(var8, var10);
                        var3.setElementAt(new Integer(var8.getJobQueuePriority()), var10);
                        var4.setElementAt(new Integer(var8.getJobNumber()), var10);
                     }
                  }
               }
            }
         }

         var1 = false;

         for(int var13 = 0; var13 < var2.size(); ++var13) {
            String var14 = (String)var2.elementAt(var13);
            JDPSubsystem var15 = this.manager.getSubsystem(var14);
            if ((var15.getMaxJobs() == 0 || var15.getMaxJobs() > var15.getActiveJobCount()) && !var15.getSubsystemHeld()) {
               JDPJob var16 = (JDPJob)var5.elementAt(var13);
               JDPJobQueue var17 = this.getJobQueue(var16.getJobQueue());
               if (!var17.getQueueHeld() && var15.submitJob(var16)) {
                  var1 = true;
                  var17.reOrderQueue();
               }
            }
         }
      }

   }

   void createQueues() {
      String var2 = this.jaggSQL.getSEP();
      this.results = new Vector();
      String var3 = "SELECT QueueName, QueueDesc, SubSysName, QueueHeld FROM JDPQueue";
      int var4 = this.jaggSQL.execSQL(var3, this.results);
      this.queues = new Vector();

      for(int var5 = 0; var5 < var4; ++var5) {
         StringTokenizer var1 = new StringTokenizer((String)this.results.elementAt(var5), var2);
         JDPJobQueue var6 = new JDPJobQueue(this, var1.nextToken().trim());
         var6.setJobQueueDesc(var1.nextToken().trim());
         var6.setSubsystem(var1.nextToken().trim());
         String var7 = var1.nextToken().trim();
         var6.setQueueHeld(var7.equals("Y"));
         this.queues.addElement(var6);
      }

   }

   void createJobs() {
      String var2 = this.jaggSQL.getSEP();
      Date var3 = new Date();
      long var4 = var3.getTime();
      var3.setHours(0);
      var3.setMinutes(0);
      var3.setSeconds(0);
      var4 -= var3.getTime();
      Date var6 = var3;
      long var7 = var4;
      this.results = new Vector();
      String var9 = "SELECT JDPSystem, JobName, JobNumber, EventType, JobOwner, QueueName, SubSysName, JobStatus, JobPriorty, QuePriorty, ObjectType, Object, ObjectParm, ObjectCons, NotifyUser, NotifyVia, NotifyOn, LogEvent, QueueDate, QueueTime, StartDate, StartTime, EndDate, EndTime, JobLog FROM JDPJobA ORDER BY JobNumber";
      int var10 = this.jaggSQL.execSQL(var9, this.results);

      for(int var11 = 0; var11 < var10; ++var11) {
         StringTokenizer var1 = new StringTokenizer((String)this.results.elementAt(var11), var2);
         if (var1.countTokens() == 25) {
            String var12 = var1.nextToken().trim();
            JDPJob var13 = new JDPJob(this.manager, var1.nextToken().trim(), Integer.parseInt(var1.nextToken().trim()));
            var13.setJDPSystem(var12);
            var13.setEventType(var1.nextToken().trim());
            var13.setJobOwner(var1.nextToken().trim());
            var13.setJobQueue(var1.nextToken().trim());
            var13.setSubsystem(var1.nextToken().trim());
            int var14 = Integer.parseInt(var1.nextToken().trim());
            var13.setJobPriority(Integer.parseInt(var1.nextToken().trim()));
            var13.setJobQueuePriority(Integer.parseInt(var1.nextToken().trim()));
            var13.setObjectType(var1.nextToken().trim());
            var13.setObject(var1.nextToken().trim());
            var13.setObjectParm(var1.nextToken().trim());
            var13.setObjectConstructor(var1.nextToken().trim());
            var13.setNotifyUser(Integer.parseInt(var1.nextToken().trim()));
            var13.setNotifyVia(var1.nextToken().trim());
            var13.setNotifyOn(var1.nextToken().trim());
            var13.setLogEvent(var1.nextToken().trim());
            var13.setQueuedDate(new Date(Long.valueOf(var1.nextToken().trim())));
            var13.setQueuedTime(Long.valueOf(var1.nextToken().trim()));
            var13.setStartDate(new Date(Long.valueOf(var1.nextToken().trim())));
            var13.setStartTime(Long.valueOf(var1.nextToken().trim()));
            var13.setEndDate(new Date(Long.valueOf(var1.nextToken().trim())));
            var13.setEndTime(Long.valueOf(var1.nextToken().trim()));
            var13.appendJobLog(var1.nextToken().trim());
            if (var13.getJobName().equals("JDPSubsystemMgr")) {
               var6 = var13.getQueuedDate();
               var7 = var13.getQueuedTime();
               var13.setQueuedDate(var13.getStartDate());
               var13.setQueuedTime(var13.getStartTime());
               var13.setEndDate(var6);
               var13.setEndTime(var7);
            }

            var13.setJobStatus(var14);
            var13.setJobChanged(false);
            if (var14 != 4 && var14 != 5) {
               if (var14 != 2 && var14 != 3) {
                  if (var14 == 9) {
                     var13.setJobChanged(true);
                  }
               } else {
                  JDPJobQueue var20 = this.getJobQueue(var13.getJobQueue());
                  if (var20 == null) {
                     var13.setJobStatus(9);
                     var13.appendJobLog("Job Queue not found: " + var13.getJobQueue() + "\r\n");
                  } else {
                     var20.submitJob(var13);
                     var20.reOrderQueue();
                  }
               }
            } else {
               var14 = 9;
               var13.setEndDate(var6);
               var13.setEndTime(var7);
               var13.appendJobLog("Job ended when Enterprise Server was terminated.");
               var13.setJobStatus(var14);
               String var15 = var13.getLogEvent();
               if (var15.equals("F") || var15.equals("B")) {
                  var13.setLogEventNow(true);
               }

               int var16 = var13.getNotifyUser();
               String var17 = var13.getNotifyOn();
               if (var16 >= 0 && (var17.equals("F") || var17.equals("B"))) {
                  var13.setNotifyNow(true);
               }

               var13.setJobChanged(true);
            }

            this.manager.registerJob(var13);
         }
      }

   }

   JDPJob submitJob(String var1, String var2, String var3, String var4, String var5, String var6, String var7, String var8, String var9, int var10, int var11, boolean var12, int var13, String var14, String var15, String var16) {
      JDPJob var17 = new JDPJob(this.manager, var3);
      var17.setJDPSystem(var2);
      var17.setJobOwner(var5);
      var17.setEventType(var4);
      var17.setJobPriority(var10);
      var17.setJobQueuePriority(var11);
      if (var12) {
         var17.setJobStatus(3);
      }

      var17.setNotifyUser(var13);
      var17.setNotifyVia(var14);
      var17.setNotifyOn(var15);
      var17.setLogEvent(var16);
      var17.setObjectType(var6);
      var17.setObject(var7);
      var17.setObjectParm(var9);
      var17.setObjectConstructor(var8);
      JDPJobQueue var18 = this.getJobQueue(var1);
      if (var18 != null) {
         var18.submitJob(var17);
         this.manager.registerJob(var17);
         return var17;
      } else {
         var17.setJobStatus(9);
         var17.appendJobLog("Job Queue not found: " + var1 + "\r\n");
         this.manager.registerJob(var17);
         return null;
      }
   }

   public void reOrderQueue() {
      if (this.waiting) {
         ((Thread)this).interrupt();
      } else {
         this.waiting = true;
      }
   }

   public JDPJobQueue getJobQueue(String var1) {
      for(int var2 = 0; var2 < this.queues.size(); ++var2) {
         JDPJobQueue var3 = (JDPJobQueue)this.queues.elementAt(var2);
         if (var3.getJobQueueName().equals(var1)) {
            return var3;
         }
      }

      return null;
   }

   public String getJobQueues() {
      StringBuffer var1 = new StringBuffer();

      try {
         String var2 = " " + this.jaggSQL.getSEP();
         if (this.queues != null) {
            for(int var3 = 0; var3 < this.queues.size(); ++var3) {
               JDPJobQueue var4 = (JDPJobQueue)this.queues.elementAt(var3);
               String var5 = var4.getJobQueueDesc();
               if (var5 == null || var5.equals("")) {
                  var5 = " ";
               }

               var1.append(var4.getJobQueueName());
               var1.append(var2);
               var1.append(var5);
               var1.append(var2);
               var1.append(var4.getQueueHeld() ? "Y" : "N");
               var1.append(var2);
               var1.append(var4.getSubsystem());
               var1.append(var2);
            }
         }
      } catch (Exception var6) {
         this.manager.logException(var6);
      }

      return var1.toString();
   }

   public String getQueuedJobs() {
      String var1 = this.jaggSQL.getSEP();
      StringBuffer var2 = new StringBuffer();

      try {
         if (this.queues != null) {
            for(int var3 = 0; var3 < this.queues.size(); ++var3) {
               JDPJobQueue var4 = (JDPJobQueue)this.queues.elementAt(var3);

               for(int var5 = 0; var5 < var4.queue.size(); ++var5) {
                  JDPJob var6 = (JDPJob)var4.queue.elementAt(var5);
                  if (var6.getJobStatus() == 2 || var6.getJobStatus() == 3) {
                     var2.append(var6.getJobName());
                     var2.append(var1);
                     var2.append(var6.getJobQueue());
                     var2.append(var1);
                     var2.append(var6.getJDPSystem());
                     var2.append(var1);
                     var2.append(Integer.toString(var6.getJobNumber()));
                     var2.append(var1);
                     var2.append(var6.getJobOwner());
                     var2.append(var1);
                     var2.append((String)this.manager.eventTypeDesc.elementAt(this.manager.eventTypeCode.indexOf(var6.getEventType())));
                     var2.append(var1);
                     var2.append(Long.toString(var6.getQueuedDate().getTime() + var6.getQueuedTime()));
                     var2.append(var1);
                     var2.append(Integer.toString(var6.getJobStatus()));
                     var2.append(var1);
                     var2.append(Integer.toString(var6.getJobQueuePriority()));
                     var2.append(var1);
                  }
               }
            }
         }
      } catch (Exception var7) {
         this.manager.logException(var7);
      }

      return var2.toString();
   }

   void setupJaggConnection() {
      this.jaggSQL = new JDPJagg(this.manager.JDPJaggPath);
      this.jaggSQL.setDSN(this.manager.JDPJaggDSN);
      this.jaggSQL.setCSTR(this.manager.JDPJaggCSTR);
      this.jaggSQL.setJdbcDriver(this.manager.JDPJaggJdbcDriver);
      this.jaggSQL.setJdbcPrefix(this.manager.JDPJaggJdbcPrefix);
      this.jaggSQL.setJdbcSuffix(this.manager.JDPJaggJdbcSuffix);
      this.jaggSQL.setUID(this.manager.JDPJaggJdbcUserid);
      this.jaggSQL.setPWD(this.manager.JDPJaggJdbcPassword);
   }
}
