import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPLanguageMaint extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPTextGrid GridPanel1;
   JDPScrollPanel ScrollPanel1;
   Label Label1;
   JDPComboBox languageCountry;
   Vector valuelanguageCountry;
   JDPButtons JDPButtons1;
   String currentLanguage;
   String currentCountry;
   Properties mainLangProps;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Language Maintenance");
      this.Panel1 = new Panel();
      this.GridPanel1 = new JDPTextGrid(var1);
      this.ScrollPanel1 = new JDPScrollPanel();
      this.Label1 = new Label("Language/Country:", 0);
      this.languageCountryMain();
      String[] var4 = new String[]{"Apply"};
      int[] var5 = new int[]{JDPButton.getIconValue("Save")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("Center", this.GridPanel1);
      this.Panel1.add("North", this.ScrollPanel1);
      this.ScrollPanel1.add("Left", this.Label1);
      this.ScrollPanel1.add("Right", this.languageCountry);
      this.Panel1.add("South", this.JDPButtons1);
      this.GridPanel1.setScrollSouthDisabled(true);
      this.Label1.setFont(new Font("Helvetica", 1, 11));
      this.InitComponents();
      var1.gParm.addElement(this);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.languageCountry)) {
               this.loadLanguage(this.languageCountry.getText());
               return true;
            } else {
               if (var1.target.equals(this.JDPButtons1.button[0])) {
                  this.saveLanguageGrid(this.languageCountry.getText());
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.setGridSettings();
      this.currentLanguage = JDPLang.language;
      this.currentCountry = JDPLang.country;
      this.getLanguages();
      this.loadLanguage(this.languageCountry.getText());
   }

   public void getLanguages() {
      this.languageCountry.clear();
      this.jaggSQL.setFCTN("ListFiles");
      this.jaggSQL.setFCTNP(this.user.JDesignerPro.JDPDirectory + JDesignerPro.serverSeparator + "System" + JDesignerPro.serverSeparator + "Language;");
      Vector var1 = new Vector();
      this.jaggSQL.execSQL("", var1);

      for(int var4 = 0; var4 < var1.size(); ++var4) {
         StringTokenizer var3 = new StringTokenizer((String)var1.elementAt(var4), this.jaggSQL.getSEP());
         String var2 = var3.nextToken();
         if (var2.indexOf(".lang") > 0) {
            var2 = var2.substring(0, var2.indexOf(".lang"));
            this.languageCountry.addItem(var2);
         }
      }

   }

   public boolean loadLanguage(String var1) {
      var1 = var1 + "    ";
      String var2 = var1.substring(0, 2).toLowerCase().trim();
      String var3 = var1.substring(2, 4).toUpperCase().trim();
      this.languageCountry.setText(var2 + var3);
      JDPLang.load(this.user, var2, var3);
      this.loadLanguageGrid();
      return true;
   }

   public void loadLanguageGrid() {
      Properties var1 = JDPLang.p;
      int var2 = ((Hashtable)var1).size();
      boolean var3 = false;
      if (this.mainLangProps == null) {
         this.mainLangProps = new Properties();
         var3 = true;
      } else {
         var2 = this.mainLangProps.size();
      }

      this.GridPanel1.setTableDimensions(1, var2);
      int var4 = 0;

      String var6;
      for(Enumeration var5 = ((Hashtable)var1).keys(); var5.hasMoreElements(); this.GridPanel1.currentText[0][var4++] = (String)((Hashtable)var1).get(var6)) {
         var6 = (String)var5.nextElement();
         if (var3) {
            this.mainLangProps.put(var6, (String)((Hashtable)var1).get(var6));
         }

         this.GridPanel1.setRowHeader(var4, var6 + ":");
      }

      if (!var3) {
         Enumeration var8 = this.mainLangProps.keys();

         while(var8.hasMoreElements()) {
            String var7 = (String)var8.nextElement();
            if (((Hashtable)var1).get(var7) == null) {
               this.GridPanel1.setRowHeader(var4, var7 + ":");
               this.GridPanel1.currentText[0][var4++] = (String)this.mainLangProps.get(var7);
            }
         }
      }

      this.GridPanel1.newTable();
   }

   public void saveLanguageGrid(String var1) {
      for(int var3 = 0; var3 < this.GridPanel1.getTableRows(); ++var3) {
         String var2 = this.GridPanel1.getRowHeader(var3);
         var2 = var2.substring(0, var2.length() - 1);
         JDPLang.p.put(var2, this.GridPanel1.getText(0, var3));
      }

      var1 = var1 + "    ";
      String var4 = var1.substring(0, 2).toLowerCase().trim();
      String var5 = var1.substring(2, 4).toUpperCase().trim();
      JDPLang.language = var4;
      JDPLang.country = var5;
      JDPLang.save();
      if (this.languageCountry.getItem(var4 + var5) < 0) {
         this.languageCountry.addItem(var4 + var5);
      }

   }

   public void setGridSettings() {
      this.GridPanel1.setTableDimensions(1, 50);
      this.GridPanel1.rowHeadJustify = "Left";
      this.GridPanel1.setRowHeaderWidth(100);
      this.GridPanel1.setColumnWidth(0, 2000);
      this.GridPanel1.setColumnHeader(0, "Value");
      this.GridPanel1.newTable();
   }

   public void languageCountryMain() {
      if (this.languageCountry == null) {
         this.languageCountry = new JDPComboBox(this.user);
      }

      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.setDSN("Test JDP");
      var1.setUID("");
      var1.setPWD("");
      var1.setMRW("1000");
      var1.setTOUT("60");
      String[] var2 = new String[]{"en", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
      this.languageCountry.loadChoice(var2);
   }
}
