import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Event;
import java.awt.Panel;
import java.awt.Window;
import java.util.Vector;

public class JDPLayoutView extends JDPClassLayout {
   JDPLayoutMgr target;
   Panel targetPanel;
   JDPTreePicker tree;
   JDPPopupMessage popuppanel;
   JDPDragItem dragPanel;
   JDPPopupMenu popup;
   JDPTreeBranch lastSelectedBranch;

   void resetComponentTree() {
      if (this.target.compTree != null) {
         this.tree.selectRoot();
         this.removeSelectedBranch();
         this.target.interactionMgr.removeMethod(this.tree.treeRoot);
         this.tree.removeBranch(this.target.compTree);
      }

      this.lastSelectedBranch = null;
      this.target.lastSelectedBranch = null;
      Object[] var1 = new Object[]{"Components"};
      String[] var2 = new String[]{"Drop here to add this component to the Panel"};
      this.tree.setDropKeys(var1);
      this.tree.setDropMessages(var2);
      int[] var3 = new int[]{24};
      this.tree.setIcons(var3);
      this.target.compTree = this.tree.setRoot("Main", true);
      this.target.centerPanel.setForeground(Color.black);
      this.target.centerPanel.setFont(super.user.plainFont);
      this.target.centerPanel.setLayout(new BorderLayout());
      this.target.compTree.thisObject = this.target.centerPanel;
      this.target.compTree.compType = "Panel";
      this.target.compTree.compPosition = "Center";
      this.target.compTree.properties = null;
      this.target.setProperties(this.target.compTree);
      this.target.interactionMgr.setProperties(this.target.compTree);
      this.target.compTree.text = new String[1];
      this.target.saveSource(this.target.compTree, this.target.gSource.buildSource(this.target.compTree));
      this.target.saveSource(this.target.compTree, this.target.gSource.createComment("Initialise other components by calling their methods") + "\tpublic void InitComponents() {\r\n\r\n\t\tjaggSQL.setKeepConnectionOpen(false);\r\n\r\n\t}\r\n");
      this.target.interactionMgr.clearEventTree();
      this.target.interactionMgr.clearMethodTree();
      this.target.interactionMgr.loadMethodTree(this.target.compTree, false);
      this.tree.nothingChanged = false;
      this.tree.repaint();
   }

   void removeBranch(JDPTreeBranch[] var1) {
      int var2 = var1.length - 1;
      String[] var3 = new String[var2 + 1];

      for(int var4 = 0; var4 <= var2; ++var4) {
         var3[var4] = var1[var4].name;
      }

      this.tree.removeBranch(var3);
      super.user.JDesignerPro.gc();
   }

   void removeSelectedBranch() {
      boolean var1 = false;
      if (this.target.lastButton != null && this.target.lastButton.equals("Layout")) {
         this.target.setButton("Blank");
         var1 = true;
      }

      JDPTreeBranch var2 = this.tree.getCurrentBranch();
      if (var2 != null) {
         Component var3 = null;
         if (var2.thisObject instanceof Component) {
            var3 = (Component)var2.thisObject;
         }

         if (var3 != null && var3 instanceof JDPTabSelectPanel) {
            String[] var4 = new String[]{"Tab 1"};
            Panel[] var5 = new Panel[1];
            ((JDPTabSelectPanel)var3).loadNewTabs(var4, var5, "North");
         } else if (var2.thisObject instanceof Container) {
            ((Container)var2.thisObject).removeAll();
         }

         for(int var6 = 0; var6 < var2.leaves.size(); ++var6) {
            JDPTreeBranch var7 = (JDPTreeBranch)var2.leaves.elementAt(var6);
            this.target.removeDefinitionHandle(var7);
            this.target.interactionMgr.removeMethod(var7);
         }

         this.tree.removeBranch(var2);
         super.user.JDesignerPro.gc();
         if (var1) {
            this.target.reLoadComponents(var2);
         }

      }
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectTopPanel) {
               return true;
            }

            return false;
         case 501:
            this.dragPanel.postEvent(var1);
            if (this.popup.isVisible()) {
               this.popup.hideMenu();
               return true;
            }

            return false;
         case 502:
            if (this.dragPanel.isVisible()) {
               this.dragPanel.postEvent(var1);
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 506:
            this.dragPanel.postEvent(var1);
            return true;
         case 701:
            if (var1.when - this.target.lastEventTime < 500L) {
               return true;
            } else {
               if (var1.target instanceof JDPTreePicker) {
                  String var4 = (String)var1.arg;
                  if (!var4.equals("BranchOpen")) {
                     JDPTreeBranch var3 = this.tree.getCurrentBranch();
                     if (!var3.equals(this.lastSelectedBranch)) {
                        this.target.setProperties(var3);
                        if (this.target.buttonPanel != null && this.target.buttonPanel.getPressed() != null && this.target.buttonPanel.getPressed().equals("Events")) {
                           this.target.interactionMgr.setProperties(var3);
                        }

                        if (this.target.buttonPanel != null && this.target.buttonPanel.getPressed() != null && this.target.buttonPanel.getPressed().equals("Define")) {
                           this.target.setRelatedComps(var3);
                        }
                     }

                     if (this.lastSelectedBranch != null && this.lastSelectedBranch.equals(var3)) {
                        return false;
                     }

                     this.lastSelectedBranch = var3;
                  }
               }

               return true;
            }
         case 1001:
            if (var1.target instanceof JDPTreePicker) {
               JDPTreeBranch var2 = this.tree.getCurrentBranch();
               if (!var2.equals(this.lastSelectedBranch)) {
                  this.target.setProperties(var2);
                  if (this.target.buttonPanel != null && this.target.buttonPanel.getPressed() != null && this.target.buttonPanel.getPressed().equals("Events")) {
                     this.target.interactionMgr.setProperties(var2);
                  }

                  if (this.target.buttonPanel != null && this.target.buttonPanel.getPressed() != null && this.target.buttonPanel.getPressed().equals("Define")) {
                     this.target.setRelatedComps(var2);
                  }
               }

               this.lastSelectedBranch = var2;
               return true;
            } else {
               if (var1.target instanceof Button) {
                  return true;
               }

               return false;
            }
         default:
            return false;
      }
   }

   void initComponentTree() {
      if (this.tree != null) {
         this.target.leftMarginWidth = this.tree.getMinWidth();
      }

      this.tree = new JDPTreePicker(super.user, this.targetPanel, this.dragPanel);
      this.tree.setMinWidth(this.target.leftMarginWidth);
      this.tree.setResizingAllowed(false);
      this.tree.showCompPosition = true;
   }

   boolean addEntry(String[] var1, int[] var2, Component var3, Object var4, String var5, String var6, String[] var7, String[][] var8, Vector var9) {
      boolean[] var10 = new boolean[var2.length];
      var10[var2.length - 1] = true;
      Object[] var11 = new Object[var2.length];
      var11[var2.length - 1] = "Components";
      String[] var12 = new String[var2.length];
      var12[var2.length - 1] = "Drop here to add this component to the Panel";
      Component var13 = null;
      if (var4 instanceof Component) {
         var13 = (Component)var4;
      } else if (var6 == null || !var6.equals("MenuAccess") && !var6.equals("MenuAutoLoad")) {
         var6 = null;
      }

      if (var4 instanceof Dialog) {
         var6 = null;
      }

      this.tree.setDragAndDrop(var10);
      this.tree.setDropKeys(var11);
      this.tree.setDropMessages((String[])null);
      if (var3 != null && var13 != null) {
         Container var14 = (Container)var3;
         if (var3 instanceof JDPScrollPanel) {
            JDPScrollPanel var19 = (JDPScrollPanel)var3;
            if (var6 != null && !var6.equals("")) {
               ((Container)var19).add(var6, var13);
            } else {
               ((Container)var19).add(var13);
            }
         } else if (var3 instanceof JDPTabSelectPanel) {
            JDPTabSelectPanel var18 = (JDPTabSelectPanel)var3;
            var18.add(var13, var1[var1.length - 1]);
         } else if (var3 instanceof JDPChiselFramePanel) {
            if (var14.countComponents() != 4) {
               super.user.mainmsg.setStatusMsg("You may only add one panel to the Chisel Panel", 15);
               return false;
            }

            JDPChiselFramePanel var17 = (JDPChiselFramePanel)var3;
            ((Container)var17).add("Center", var13);
         } else if (var3 instanceof Container && !(var13 instanceof Window)) {
            Container var15 = (Container)var3;
            if (var6 != null && !var6.equals("")) {
               var15.add(var6, var13);
               if (var3 instanceof JDPCardPanel) {
                  ((JDPCardPanel)var3).setSelectedComp(var6);
               }
            } else if (var15.getLayout() instanceof CardLayout) {
               var15.add(var1[var1.length - 1], var13);
            } else {
               var15.add(var13);
            }
         }

         if (var13 instanceof Container || var13 instanceof JDPScrollPanel || var13 instanceof JDPTabSelectPanel || var13 instanceof JDPChiselFramePanel) {
            if (!(var13 instanceof JDPTextGrid) && !(var13 instanceof JDPButton) && !(var13 instanceof JDPButtons) && !(var13 instanceof JDPTreePicker) && !(var13 instanceof JDPPopupMenu) && !(var13 instanceof JDPPopupMenu) && !(var13 instanceof JDPBrowser) && !(var13 instanceof JDPRichText) && !(var13 instanceof JDPImage) && !(var13 instanceof JDPChart) && !(var13 instanceof JDPFilePicker) && !(var13 instanceof JDPSpinner) && !(var13 instanceof JDPCalendarPicker) && !(var13 instanceof JDPChoice) && !(var13 instanceof JDPComboBox) && !(var13 instanceof JDPClassLayout)) {
               if (var13 instanceof Container) {
                  this.dragPanel.addDropComponent(var13, (Container)var3, var11[var2.length - 1], "Drop here to add component to Panel");
               }

               this.tree.setDragAndDrop(var10);
               this.tree.setDropKeys(var11);
               this.tree.setDropMessages(var12);
            } else {
               this.tree.setDragAndDrop(var10);
               this.tree.setDropKeys(var11);
            }
         }
      }

      if (var7 == null || var7.length == 0) {
         var7 = new String[]{""};
      }

      JDPTreeBranch var16 = this.tree.addEntry(var1, var2, var4, var5, var6, var7, var8, var9);
      this.tree.select(var1);
      if (var16 != null) {
         this.target.cMgr.currentBranch = var16;
         if (var16.properties != null && var16.thisObject != null) {
            this.target.cMgr.updateProperties(0);
         }

         this.target.setProperties(var16);
         this.target.interactionMgr.setProperties(var16);
         if (!this.target.projectLoading) {
            this.lastSelectedBranch = var16;
         }
      }

      this.tree.nothingChanged = false;
      this.tree.repaint();
      return true;
   }

   void removeSelectedLeaf() {
      boolean var1 = false;
      if (this.target.lastButton != null && this.target.lastButton.equals("Layout")) {
         this.target.setButton("Blank");
         var1 = true;
      }

      JDPTreeBranch var2 = null;
      JDPTreeBranch var3 = this.tree.getCurrentBranch();
      Object var4 = null;
      if (var3.thisObject instanceof Component) {
         Container var7 = ((Component)var3.thisObject).getParent();
         JDPTreeBranch[] var5 = this.tree.getTreeBranch(var3);
         if (var5 != null && var5.length > 1) {
            var2 = var5[var5.length - 2];
         }

         if (var7 != null) {
            if (var2 != null && var2.thisObject != null && var2.thisObject instanceof JDPTabSelectPanel) {
               ((JDPTabSelectPanel)var2.thisObject).removeTab((Component)var3.thisObject);
            } else {
               var7.remove((Component)var3.thisObject);
            }
         }
      }

      this.target.removeDefinitionHandle(var3);
      this.target.interactionMgr.clearEventTree();
      this.target.interactionMgr.removeMethod(var3);
      this.tree.removeBranch(this.tree.getTreeBranchNames(var3));
      if (var3.relatedComps != null) {
         for(int var8 = 0; var8 < var3.relatedComps.length; ++var8) {
            ((JDPClassLayout)var3.relatedComps[var8]).setComponentName(var3.name);
            ((JDPClassLayout)var3.relatedComps[var8]).setThisBranch(var3);
            ((JDPClassLayout)var3.relatedComps[var8]).removeSelections();
         }
      }

      Object var6 = null;
      super.user.JDesignerPro.gc();
      if (var1 && var2 != null) {
         this.target.reLoadComponents(var2);
      }

   }

   public void InitClass(JDPUser var1, JDPLayoutMgr var2, String var3) {
      super.user = var1;
      this.target = var2;
      this.targetPanel = var2.targetPanel;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.dragPanel = var2.dragPanel;
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      this.popup = new JDPPopupMenu(var1, this);
      this.targetPanel.add(this.popup);
      this.initComponentTree();
      ((Container)var4).add("Center", this.tree);
      this.popuppanel.addComponent(this.tree, "", "Drag an object to move it to another container. Click on an Object or Main for other options.");
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Layout View", var4, "North"));
      this.targetPanel.paintAll(this.targetPanel.getGraphics());
      var1.gParm.addElement(this);
      var1.JDesignerPro.gc();
   }
}
