import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.util.Vector;

public class JDPList extends JDPTreePicker {
   Vector actualVector;
   Vector sortKeyVector;
   int currentIcon = -1;
   String dragKey;
   String dropMessage;
   boolean[] sortDirection;

   public String[] getSelectedKeys() {
      int[] var1 = ((JDPTreePicker)this).getSelectedIndexes();
      String[] var2 = new String[var1.length];

      for(int var3 = 0; var3 < var1.length; ++var3) {
         var2[var3] = (String)this.actualVector.elementAt(var1[var3]);
      }

      return var2;
   }

   public JDPList(JDPUser var1) {
      if (var1 != null) {
         super.dragPanel = new JDPDragItem(var1, this);
         ((Container)this).add(super.dragPanel);
      }

      ((JDPTreePicker)this).createTree(var1, this, super.dragPanel);
      ((JDPTreePicker)this).setRoot("", true);
      super.listOnly = true;
      this.actualVector = new Vector();
      this.sortKeyVector = new Vector();
   }

   public JDPList(JDPUser var1, Panel var2) {
      ((JDPTreePicker)this).createTree(var1, var2, (JDPDragItem)null);
      ((JDPTreePicker)this).setRoot("", true);
      super.listOnly = true;
      this.actualVector = new Vector();
      this.sortKeyVector = new Vector();
   }

   public JDPList(JDPUser var1, Panel var2, JDPDragItem var3) {
      ((JDPTreePicker)this).createTree(var1, var2, var3);
      ((JDPTreePicker)this).setRoot("", true);
      super.listOnly = true;
      this.actualVector = new Vector();
      this.sortKeyVector = new Vector();
   }

   public void loadList(JDPUser var1, JDPJagg var2, String var3, String var4, String var5, String var6) {
      this.clear();
      Vector var7 = new Vector();
      new JDPLoadChoice(var1, var2, this, var3, var4, var5, var6, var7);
      this.actualVector = var7;
   }

   public void loadList(String[] var1, String[] var2) {
      if (var1 != null && var2 != null && var1.length == var2.length) {
         for(int var3 = 0; var3 < var1.length; ++var3) {
            if (var1[var3] != null && var1[var3].length() > 0 && var2[var3] != null && var2[var3].length() > 0) {
               this.addItem(var1[var3], var2[var3]);
            }
         }

      }
   }

   public void sortList() {
      this.sortList(false, 0);
   }

   public void sortList(int var1) {
      this.sortList(false, var1);
   }

   public void sortList(boolean var1, int var2) {
      String var5 = null;
      int var6 = 0;
      JDPTreeBranch var9 = super.treeRoot;
      Object var11 = null;
      String var12 = null;
      Object var13 = null;
      int var14 = -9999999;
      int var15 = 0;
      long var16 = -9999999L;
      long var18 = 0L;
      boolean var21 = false;
      if (this.sortDirection != null) {
         var21 = this.sortDirection[var2];
      }

      int var22 = this.countItems();

      for(int var23 = 0; var23 < var22; ++var23) {
         for(int var24 = var23; var24 < var22; ++var24) {
            JDPTreeBranch var4 = (JDPTreeBranch)var9.leaves.elementAt(var24);
            if (this.sortKeyVector.size() > 0) {
               Object var10 = ((Object[])this.sortKeyVector.elementAt(var24))[var2];
               if (var10 instanceof String) {
                  String var26 = (String)var10;
                  if (var1) {
                     var26 = var26.toLowerCase();
                  }

                  if (var12 == null || !var21 && var26.compareTo(var12) < 0 || var21 && var26.compareTo(var12) > 0) {
                     var12 = var26;
                     var6 = var24;
                  }
               } else if (var10 instanceof Integer) {
                  var15 = (Integer)var10;
                  if (var14 == -9999999 || !var21 && var15 < var14 || var21 && var15 > var14) {
                     var14 = var15;
                     var6 = var24;
                  }
               } else if (var10 instanceof Long) {
                  var18 = (Long)var10;
                  if (var16 == -9999999L || !var21 && var18 < var16 || var21 && var18 > var16) {
                     var16 = var18;
                     var6 = var24;
                  }
               }
            } else {
               String var20 = var4.name;
               if (var1) {
                  var20 = var20.toLowerCase();
               }

               if (var5 == null || !this.sortDirection[var2] && var20.compareTo(var5) < 0 || this.sortDirection[var2] && var20.compareTo(var5) > 0) {
                  var5 = var20;
                  var6 = var24;
               }
            }
         }

         if (var23 < var6 || var6 != 0) {
            JDPTreeBranch var3 = (JDPTreeBranch)var9.leaves.elementAt(var23);
            var9.leaves.setElementAt(var9.leaves.elementAt(var6), var23);
            var9.leaves.setElementAt(var3, var6);
            ((JDPTreeBranch)var9.leaves.elementAt(var23)).branchIndex = var23;
            ((JDPTreeBranch)var9.leaves.elementAt(var6)).branchIndex = var6;
            String var7 = (String)this.actualVector.elementAt(var23);
            this.actualVector.setElementAt(this.actualVector.elementAt(var6), var23);
            this.actualVector.setElementAt(var7, var6);
            if (this.sortKeyVector.size() > 0) {
               Object[] var8 = this.sortKeyVector.elementAt(var23);
               this.sortKeyVector.setElementAt(this.sortKeyVector.elementAt(var6), var23);
               this.sortKeyVector.setElementAt(var8, var6);
            }
         }

         var5 = null;
         var11 = null;
         var12 = null;
         var14 = -9999999;
         var16 = -9999999L;
         var6 = 0;
      }

   }

   public int countItems() {
      return this.getItemCount();
   }

   public void select(String var1) {
      int var2 = this.getItem(var1);
      if (var2 >= 0) {
         ((JDPTreePicker)this).select(var2);
      }

   }

   public void setDropMessage(String var1) {
      this.dropMessage = var1;
   }

   public String getDropMessage() {
      return this.dropMessage;
   }

   public String[] getItemKeys(int var1) {
      int var2 = 0;
      String[] var3 = new String[this.countItems()];

      for(int var4 = 0; var4 < super.treeRoot.leaves.size(); ++var4) {
         JDPTreeBranch var5 = (JDPTreeBranch)super.treeRoot.leaves.elementAt(var4);
         if (var5.icon == var1) {
            var3[var2++] = (String)this.actualVector.elementAt(var5.branchIndex);
         }
      }

      String[] var6 = new String[var2];
      System.arraycopy(var3, 0, var6, 0, var2);
      return var6;
   }

   public int getItemCount() {
      return this.actualVector.size();
   }

   void checkVector() {
      if (this.actualVector == null || this.countItems() == 0) {
         this.actualVector = new Vector();
         this.sortKeyVector = new Vector();
      }

   }

   public void allowMultipleSelections(boolean var1) {
      super.allowMultiple = var1;
   }

   public void setMultipleSelections(boolean var1) {
      super.allowMultiple = var1;
   }

   public boolean getMultipleSelections() {
      return super.allowMultiple;
   }

   public void remove(int var1) {
      this.delItem(var1);
   }

   public void remove(String var1) {
      this.remove(this.getItem(var1));
   }

   public void removeAll() {
      this.clear();
   }

   public void deselect(int var1) {
      if (var1 < super.treeRoot.leaves.size()) {
         JDPTreeBranch var2 = (JDPTreeBranch)super.treeRoot.leaves.elementAt(var1);
         var2.selected = false;
         ((JDPTreePicker)this).reDraw();
      }

   }

   public String getItem(int var1) {
      JDPTreeBranch var2 = ((JDPTreePicker)this).getBranch(new Integer(var1));
      return var2 == null ? null : var2.name;
   }

   public int getItem(String var1) {
      JDPTreeBranch var2 = ((JDPTreePicker)this).getBranch(var1);
      return var2 == null ? -1 : var2.branchIndex;
   }

   public boolean isSelected(int var1) {
      if (var1 < 0) {
         return false;
      } else {
         JDPTreeBranch var2 = (JDPTreeBranch)super.treeRoot.leaves.elementAt(var1);
         return var2.selected;
      }
   }

   public void setIcon(int var1) {
      this.currentIcon = var1;
   }

   public void setIcon(int var1, int var2) {
      JDPTreeBranch[] var3 = ((JDPTreePicker)this).getTreeBranch(new Integer(var1));
      if (var3 != null) {
         var3[var3.length - 1].icon = var2;
         ((JDPTreePicker)this).reDraw();
      }

   }

   public void replaceItemKey(int var1, String var2) {
      if (this.actualVector.size() > var1 && var1 >= 0) {
         this.actualVector.setElementAt(var2, var1);
      }

   }

   public void setDragKey(String var1) {
      this.dragKey = var1;
   }

   public String getDragKey() {
      return this.dragKey;
   }

   public String getItemKey(int var1) {
      return (String)this.actualVector.elementAt(var1);
   }

   public void addItem(String var1) {
      this.addItem((String)var1, var1, this.currentIcon, (Object[])null);
   }

   public void addItem(String[] var1) {
      this.addItem((String[])var1, var1[0], this.currentIcon, (Object[])null);
   }

   public void addItem(String var1, String var2) {
      this.addItem((String)var1, var2, this.currentIcon, (Object[])null);
   }

   public void addItem(String[] var1, String var2) {
      this.addItem((String[])var1, var2, this.currentIcon, (Object[])null);
   }

   public void addItem(String var1, int var2) {
      this.addItem(var1, var1, var2);
   }

   public void addItem(String[] var1, int var2) {
      this.addItem(var1, var1[0], var2);
   }

   public void addItem(String var1, String var2, int var3) {
      this.addItem((String)var1, var2, var3, (Object[])null);
   }

   public void addItem(String[] var1, String var2, int var3) {
      this.addItem((String[])var1, var2, var3, (Object[])null);
   }

   public void addItem(String var1, String var2, int var3, Object[] var4) {
      this.checkVector();
      ((JDPTreePicker)this).addBranch(super.treeRoot, var1, var3, this.dragKey, this.dropMessage);
      this.actualVector.addElement(var2);
      if (var4 != null) {
         this.sortKeyVector.addElement(var4);
         if (this.sortDirection == null || var4.length > this.sortDirection.length) {
            this.sortDirection = new boolean[var4.length];
         }
      } else if (this.sortDirection == null || this.sortDirection.length != 1) {
         this.sortDirection = new boolean[1];
      }

      ((JDPTreePicker)this).reDraw();
   }

   public void setAllowChangeOrder(boolean var1) {
      super.allowChangeOrder = var1;
      if (var1 && super.dragPanel == null) {
         var1 = false;
      } else {
         super.dragAndDrops = new boolean[3];
         super.dragAndDrops[0] = true;
         super.dragAndDrops[1] = true;
         super.dragAndDrops[2] = true;
         this.dragKey = Integer.toString(this.hashCode());
         this.dropMessage = "Drop here to change the position of this item";
      }
   }

   public boolean getAllowChangeOrder() {
      return super.allowChangeOrder;
   }

   public void addItem(String[] var1, String var2, int var3, Object[] var4) {
      this.checkVector();
      String var5 = "";

      for(int var6 = 0; var6 < var1.length; ++var6) {
         if (var1[var6] != null && !var1[var6].equals("")) {
            var5 = var5 + var1[var6] + "|";
         } else {
            var5 = var5 + " |";
         }
      }

      ((JDPTreePicker)this).addBranch(super.treeRoot, var5, var3, this.dragKey, this.dropMessage);
      this.actualVector.addElement(var2);
      if (var4 != null) {
         this.sortKeyVector.addElement(var4);
         if (this.sortDirection == null || var4.length > this.sortDirection.length) {
            this.sortDirection = new boolean[var4.length];
         }
      } else if (this.sortDirection == null || this.sortDirection.length != 1) {
         this.sortDirection = new boolean[1];
      }

      ((JDPTreePicker)this).reDraw();
   }

   public void delItem(int var1) {
      if (var1 < super.treeRoot.leaves.size()) {
         int var2 = var1;
         super.treeRoot.leaves.removeElementAt(var1);

         while(var2 < super.treeRoot.leaves.size()) {
            JDPTreeBranch var3 = (JDPTreeBranch)super.treeRoot.leaves.elementAt(var2);
            var3.branchIndex += -1;
            ++var2;
         }

         super.nextIndex += -1;
         ((Component)this).repaint();
         super.user.JDesignerPro.gc();
         if (var1 < this.actualVector.size()) {
            this.actualVector.removeElementAt(var1);
         }

         if (var1 < this.sortKeyVector.size()) {
            this.sortKeyVector.removeElementAt(var1);
         }

         ((JDPTreePicker)this).reDraw();
      }
   }

   public int getKeyItem(String var1) {
      return this.actualVector.indexOf(var1);
   }

   public void clear() {
      this.actualVector = new Vector();
      this.sortKeyVector = new Vector();
      ((JDPTreePicker)this).setRoot("", true);
      ((JDPTreePicker)this).reDraw();
   }

   public String[] getItems(int var1) {
      int var2 = 0;
      String[] var3 = new String[this.countItems()];

      for(int var4 = 0; var4 < super.treeRoot.leaves.size(); ++var4) {
         JDPTreeBranch var5 = (JDPTreeBranch)super.treeRoot.leaves.elementAt(var4);
         if (var5.icon == var1) {
            var3[var2++] = var5.name;
         }
      }

      String[] var6 = new String[var2];
      System.arraycopy(var3, 0, var6, 0, var2);
      return var6;
   }

   public String getSelectedKey() {
      int var1 = ((JDPTreePicker)this).getSelectedIndex();
      return var1 >= 0 ? (String)this.actualVector.elementAt(((JDPTreePicker)this).getSelectedIndex()) : null;
   }

   public String[] getSelectedKeyValue() {
      String[] var1 = new String[]{(String)this.actualVector.elementAt(((JDPTreePicker)this).getSelectedIndex())};
      return var1;
   }

   public boolean handleEvent(Event var1) {
      if (var1.id == 10003) {
         int var2 = (Integer)var1.arg;
         this.sortDirection[var2] = !this.sortDirection[var2];
         this.sortList(true, var2);
         ((JDPTreePicker)this).reDraw();
         return false;
      } else {
         return super.handleEvent(var1);
      }
   }
}
