import java.awt.Component;
import java.io.PrintStream;
import java.net.Socket;

class JDPLoaderProcessThread implements Runnable {
   JDPUser user;
   JDPPanelLoader target;
   String panelName;
   String moduleParameter;
   boolean[] panelLoaded;
   int panelIndex;
   String[] panelNames;
   Socket thisSocket;
   PrintStream serverResponse;
   // $FF: renamed from: NL java.lang.String
   static String field_0 = "\u0002";
   static String EOT = "\u0001";

   void loadServerJob() {
      try {
         this.serverResponse = new PrintStream(this.thisSocket.getOutputStream());
         JDPServerJob var1 = (JDPServerJob)Class.forName(this.panelName).newInstance();
         var1.InitClass(this.panelName, this.moduleParameter, this.serverResponse);
         this.thisSocket.close();
         Runtime var2 = Runtime.getRuntime();
         var2.gc();
      } catch (Exception var7) {
         ((Throwable)var7).printStackTrace();

         try {
            this.writeLn("Job " + this.panelName + " failed to run to completion. Contact the System Administrator", 10);
            this.writeLn(field_0);
            this.writeLn(EOT);
         } catch (Exception var6) {
            ((Throwable)var6).printStackTrace();
         }
      }
   }

   private void writeLn(String var1) throws Exception {
      this.writeLn(var1, -1);
   }

   private void writeLn(String var1, int var2) throws Exception {
      if (var1 != null && var1.length() != 0) {
         if (var2 >= 0) {
            var1 = Integer.toString(var2) + "\u0003" + var1;
         }

         int var3 = var1.length();

         for(int var4 = 0; var4 < var3; ++var4) {
            this.serverResponse.write(var1.charAt(var4));
         }

      } else {
         this.serverResponse.write(32);
      }
   }

   void nullVariables() {
      this.user = null;
      this.target = null;
      this.panelName = null;
      this.moduleParameter = null;
      this.panelLoaded = null;
      this.panelNames = null;
      this.thisSocket = null;
      this.serverResponse = null;
   }

   public void run() {
      if (this.panelNames != null) {
         byte var10 = 0;

         try {
            for(int var11 = 0; var11 < this.panelNames.length; ++var11) {
               Class.forName(this.panelNames[var11]);
            }
         } catch (Exception var8) {
            ((Throwable)var8).printStackTrace();
            this.user.mainmsg.setStatusMsg("Class " + this.panelNames[var10] + " failed to load. Contact the System Administrator", 10);
         }

         this.nullVariables();
      } else if (this.target != null) {
         JDPPopupMessage var2 = null;

         try {
            String var3 = "Loading " + this.panelName + " screen...";
            this.user.mainmsg.setStatusMsg(var3, 0);
            JDPClassLayout var1 = (JDPClassLayout)Class.forName(this.panelName).newInstance();
            var1.InitClass(this.user, this.target, this.moduleParameter);
            Component[] var4 = this.target.getComponents();
            boolean var5 = false;

            for(int var6 = 0; var6 < var4.length; ++var6) {
               if (var4[var6].equals(var1)) {
                  var5 = true;
               }

               if (var4[var6] instanceof JDPPopupMessage) {
                  var2 = (JDPPopupMessage)var4[var6];
               }
            }

            Object var15 = null;
            if (!var5) {
               this.target.add("Center", var1);
               this.target.paintAll(this.target.getGraphics());
               if (var2 != null) {
               }
            }

            if (var3.equals(this.user.mainmsg.getStatusMsg()) || this.user.mainmsg.getStatusMsg().startsWith("Loading")) {
               this.user.mainmsg.clearStatusMsg();
            }

            if (this.user.JDesignerPro.installing && !JDesignerPro.executable) {
               this.user.mainmsg.clearStatusMsg();
               this.user.mainmsg.setStatusMsg("Please clear your browser cache before you reload JDesignerPro", 20);
               this.user.JDesignerPro.installing = false;
            }

            ((Component)var1).requestFocus();
            Object var13 = null;
            Object var12 = null;
         } catch (Exception var9) {
            if (this.panelLoaded != null) {
            }

            ((Throwable)var9).printStackTrace();
            this.user.mainmsg.setStatusMsg("Class " + this.panelName + " failed to load. Contact the System Administrator", 10);
         }

         this.nullVariables();
         Runtime var14 = Runtime.getRuntime();
         var14.gc();
         System.runFinalization();
         System.gc();
      } else {
         if (this.thisSocket != null) {
            this.loadServerJob();
         }

         this.nullVariables();
      }
   }

   JDPLoaderProcessThread(JDPUser var1, JDPPanelLoader var2, String var3, String var4, boolean[] var5, int var6) {
      this.user = var1;
      this.target = var2;
      this.panelName = var3;
      this.moduleParameter = var4;
      this.panelLoaded = var5;
      this.panelIndex = var6;
      this.panelNames = null;
   }

   JDPLoaderProcessThread(String[] var1) {
      this.panelNames = var1;
   }

   JDPLoaderProcessThread(String var1, String var2, Socket var3) {
      this.user = null;
      this.panelNames = null;
      this.target = null;
      this.panelName = var1;
      this.moduleParameter = var2;
      this.thisSocket = var3;
   }
}
