import java.applet.AppletContext;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.Window;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPMainWindow extends Frame {
   JDPUser user;
   AppletContext context;
   Panel statusPanel;

   void displayMessage(JDPUser var1, String var2, String var3, String var4, String var5) {
      new JDPSvrMsgDialog(var1, var2, this, false, var3, var4, var5);
   }

   public JDPMainWindow(JDPUser var1, String var2) {
      super(var2);
      this.user = var1;
      if (!System.getProperty("java.version").startsWith("1.0") && System.getProperty("os.name").startsWith("Win")) {
         ((Frame)this).setIconImage(var1.JDesignerPro.JDPIconImage);
      }

      if (!System.getProperty("java.version").startsWith("1.0") && JDesignerPro.executable) {
         var1.JDesignerPro.consoleDialog = new JDPConsoleDialog(var1, this);
      }

      ((Component)this).setBackground(JDPUtils.getControlColor());
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      var1.popup = new JDPPopupComponent(var1, this);
      ((Container)this).add(var1.popup);
      if (var1.loginMessage != null) {
         var1.loginMessage.setStatusMsg(JDPLang.get("JDPMain1"), 0);
      }

      boolean var3 = false;
      boolean var4 = false;
      float var5 = 1.0F;
      var1.mainmsg = new JDPStatusMessage(var1);
      if (var1.JDesignerPro.JDPClassName == null) {
         MenuBar var6 = new MenuBar();
         Menu var7 = new Menu(JDPLang.get("Menu0"));
         var7.add(new MenuItem(JDPLang.get("Menu1")));
         var7.addSeparator();
         var7.add(new MenuItem(JDPLang.get("Menu2")));
         var7.add(new MenuItem(JDPLang.get("Menu3")));
         var6.add(var7);
         Menu var8 = new Menu(JDPLang.get("Menu4"));
         if (!System.getProperty("java.version").startsWith("1.0") && JDesignerPro.executable) {
            var8.add(new MenuItem(JDPLang.get("Menu5")));
            var8.addSeparator();
         }

         var8.add(new MenuItem(JDPLang.get("Menu6")));
         var6.add(var8);
         ((Frame)this).setMenuBar(var6);
         var1.jdpMenuPanel = new JDPTabSelectPanel(var1, var1.menu, "North");
         ((Container)this).add("Center", var1.jdpMenuPanel);
      } else {
         ((Component)this).setFont(var1.plainFont);
         ((Container)this).add("Center", new JDPPanelLoader(var1, var1.JDesignerPro.JDPClassName, "", (boolean[])null, 0));
         var3 = true;
         var4 = true;
         var5 = 0.85F;
      }

      this.statusPanel = new Panel();
      this.statusPanel.setLayout(new GridLayout(1, 1));
      this.statusPanel.add(var1.mainmsg);
      ((Container)this).add("South", this.statusPanel);
      if (!JDesignerPro.JDPLicensed) {
         var1.mainmsg.eastMessage.setText("(Unlicensed)");
         var1.mainmsg.eastMessage.setForeground(Color.red);
      }

      ((Window)this).pack();
      Dimension var12 = Toolkit.getDefaultToolkit().getScreenSize();
      if (var1.cust.winx1 != 0 || var1.cust.winy1 != 0 || (var1.cust.winx2 != 640 || var1.cust.winy2 != 480) && (var1.cust.winx2 != 2000 || var1.cust.winy2 != 2000)) {
         if (System.getProperty("os.name").startsWith("Win") && var1.cust.winx1 < 0 && var1.cust.winy1 < 0) {
            if (var1.cust.winx2 > var12.width) {
               var1.cust.winx2 = var12.width + 1;
               var1.cust.winy2 = var12.height - 27;
            }

            var1.cust.winx1 = 0;
            var1.cust.winy1 = 0;
         }

         ((Component)this).reshape(var1.cust.winx1, var1.cust.winy1, var1.cust.winx2, var1.cust.winy2);
      } else {
         var1.cust.winx1 = 0;
         var1.cust.winy1 = 0;
         var1.cust.winx2 = var12.width + 1;
         var1.cust.winy2 = var12.height - 27;
         ((Component)this).reshape(var1.cust.winx1, var1.cust.winy1, var1.cust.winx2, var1.cust.winy2);
      }

      ((Window)this).show();
      var1.serverListener.registerForRequest("JDPSystemMessage", this);
   }

   boolean savePreferences() {
      if (!this.closeOtherApplications()) {
         return false;
      } else {
         if (this.user.JDesignerPro.JDPClassName == null && this.user.cust.status.compareTo("D") != 0 && this.user.cust.status.compareTo("G") != 0 && ((Component)this).bounds().x > -100 && ((Component)this).bounds().y > -100) {
            int var1 = ((Component)this).bounds().height;
            if (this.user.cust.winy2 - ((Component)this).bounds().height == 19) {
               var1 = this.user.cust.winy2;
            }

            this.user.mainmsg.setStatusMsg(JDPLang.get("JDPMain0"), 0);
            Vector var2 = new Vector();
            String var3;
            if (this.user.JDesignerPro.NDSPath == null) {
               var3 = "UPDATE JDPUser SET winx1 = " + Integer.toString(((Component)this).bounds().x) + ",winy1 = " + Integer.toString(((Component)this).bounds().y) + ",winx2 = " + Integer.toString(((Component)this).bounds().width) + ",winy2 = " + Integer.toString(var1) + " WHERE userid = " + this.user.cust.suserid;
               this.user.jaggSQL.setFCTN("");
               this.user.jaggSQL.setFCTNP("");
               this.user.jaggSQL.loadSettings(this.user);
            } else {
               var3 = "UPDATE User SET JDP:winx1 = " + Integer.toString(((Component)this).bounds().x) + ",JDP:winy1 = " + Integer.toString(((Component)this).bounds().y) + ",JDP:winx2 = " + Integer.toString(((Component)this).bounds().width) + ",JDP:winy2 = " + Integer.toString(var1) + " WHERE JDP:userid = " + this.user.cust.suserid;
               this.user.jaggSQL.setFCTN("NDSexecSQL");
            }

            this.user.jaggSQL.execSQL(var3, var2);
            this.user.mainmsg.clearStatusMsg();
         }

         this.user.jaggSQL.setFCTN("Logout");
         this.user.jaggSQL.setFCTNP("");
         Vector var4 = new Vector();
         this.user.jaggSQL.execSQL("", var4);
         return true;
      }
   }

   boolean closeOtherApplications() {
      for(int var1 = 0; var1 < this.user.gParm.size(); ++var1) {
         if (this.user.gParm.elementAt(var1) instanceof JDPClassLayout) {
            JDPClassLayout var2 = (JDPClassLayout)this.user.gParm.elementAt(var1);
            if (!var2.shutDown()) {
               return false;
            }
         }
      }

      return true;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 201:
            int var9 = 0;

            for(int var14 = 0; var14 < this.user.JDesignerPro.userCount; ++var14) {
               if (this.user.JDesignerPro.user[var14] != null) {
                  ++var9;
               }

               if (this.user.JDesignerPro.user[var14] == this.user) {
                  this.user.JDesignerPro.user[var14] = null;
               }
            }

            if (var9 <= 1) {
               if (!this.savePreferences()) {
                  return true;
               }

               this.user.JDesignerPro.destroy();
               JDPJagg.cleanUp();
               this.user.JDesignerPro.gc();
               if (this.user.JDesignerPro.JDPClassName == null && JDesignerPro.executable) {
                  System.exit(0);
               }
            }

            ((Frame)this).dispose();
            return true;
         case 1001:
            if (var1.target instanceof MenuItem) {
               String var8 = (String)var1.arg;
               if (var8.equals(JDPLang.get("Menu1"))) {
                  this.user.JDesignerPro.user[this.user.JDesignerPro.userCount++] = new JDPUser();
                  JDPUser var10 = this.user.JDesignerPro.initUser(this.user.JDesignerPro.userCount - 1);
                  this.user.copyUser(var10);
                  var10.JDesignerPro = this.user.JDesignerPro;
                  var10.jdpMainWindow = new JDPMainWindow(var10, this.user.JDesignerPro.wintitle);
                  var10.jaggSQL = new JDPJagg(this.user.jaggPath);
                  var10.jaggSQL.loadSettings(this.user);
               }

               if (var8.equals(JDPLang.get("Menu5"))) {
                  Rectangle var11 = ((Component)this).bounds();
                  this.user.JDesignerPro.consoleDialog.showAt(var11);
               }

               if (var8.equals(JDPLang.get("Menu6"))) {
                  this.user.startProcess(1, this.user.mainmsg);
               }

               if (var8.equals(JDPLang.get("Menu2"))) {
                  int var12 = 0;

                  for(int var15 = 0; var15 < this.user.JDesignerPro.userCount; ++var15) {
                     if (this.user.JDesignerPro.user[var15] != null) {
                        ++var12;
                     }

                     if (this.user.JDesignerPro.user[var15] == this.user) {
                        this.user.JDesignerPro.user[var15] = null;
                     }
                  }

                  if (var12 <= 1) {
                     if (!this.savePreferences()) {
                        return true;
                     }

                     this.user.JDesignerPro.destroy();
                  }

                  ((Frame)this).dispose();
               }

               if (var8.equals(JDPLang.get("Menu3")) && this.savePreferences()) {
                  for(int var13 = 0; var13 < this.user.JDesignerPro.userCount; ++var13) {
                     if (this.user.JDesignerPro.user[var13] != null) {
                        this.user.JDesignerPro.user[var13].jdpMainWindow.dispose();
                        this.user.JDesignerPro.user[var13] = null;
                     }
                  }

                  this.user.JDesignerPro.destroy();
                  ((Frame)this).dispose();
                  JDPJagg.cleanUp();
                  this.user.JDesignerPro.gc();
                  if (JDesignerPro.executable) {
                     System.exit(0);
                  }
               }

               return true;
            } else if (var1.target.equals(this.user.serverListener)) {
               String var2 = (String)var1.arg;
               StringTokenizer var3 = new StringTokenizer(var2, "|");
               var3.nextToken();
               String var4 = var3.nextToken();
               String var5 = var3.nextToken();
               String var6 = var3.nextToken();
               String var7 = var3.nextToken();
               this.displayMessage(this.user, "Message from " + var4, var5, var6, var7);
               return true;
            } else {
               return false;
            }
         default:
            return false;
      }
   }
}
