import java.awt.BorderLayout;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPProjectMgr extends JDPClassLayout implements Runnable {
   JDPJagg jaggSQL;
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   JDPPopupMessage popuppanel;
   JDPPopupMenu popup;
   JDPTreeBranch popupMain;
   JDPTreeBranch popupFile;
   JDPSelectDSN targetDSN;
   Vector eventVector;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   boolean copyRequested;
   boolean deleteRequested;
   String pfromWhereClause;
   String projectType;
   String appDir;
   TextField ClassName;
   TextField ClassDesc;
   TextField owner;
   TextField lastmod;
   Choice Status;
   Vector valueStatus;
   TextArea notes;
   JDPButtons btns;

   boolean createPopupMenus() {
      String[] var10000 = new String[1];
      this.popup.addEntry("New Project...");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupMain = this.popup.getMenuTree();
      this.popup.clear();
      this.popup.addEntry("New Project...");
      this.popup.addEntry("Edit Project...");
      this.popup.addEntry("Copy Project...");
      this.popup.addEntry("Remove Project...");
      this.popup.addEntry("");
      this.popup.addEntry("Refresh");
      this.popupFile = this.popup.getMenuTree();
      return true;
   }

   void loadChoices() {
      this.valueStatus = new Vector();
      this.Status.addItem("In Progress");
      this.valueStatus.addElement("P");
      this.Status.addItem("Active");
      this.valueStatus.addElement("A");
      this.Status.addItem("Inactive");
      this.valueStatus.addElement("I");
   }

   void saveProject() {
      super.user.saveProperties.save(this.appDir + this.ClassName.getText() + ".jdp");
      if (this.insertRequested) {
         this.saveData();
         this.newSearch();
      } else {
         this.saveData();
      }

      this.selectProject();
   }

   void selectProject() {
      String[] var1 = new String[]{super.user.JDPSystemDesc, super.user.cust.username, this.ClassName.getText()};
      this.searchResults.tree.select(var1, 3);
   }

   void newSearch() {
      String var1 = this.pfromWhereClause;
      if (this.jdpWhereClause != null) {
         var1 = var1 + " AND " + this.jdpWhereClause.whereClause;
      }

      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList(super.user.JDesignerPro.JDPSystemDesc);
      this.searchResults.loadList();
      if (this.searchResults.treeRoot.leaves.size() > 0) {
         JDPTreeBranch var2 = (JDPTreeBranch)this.searchResults.treeRoot.leaves.elementAt(0);
         var2.expanded = true;
      }

   }

   void clearFields() {
      this.ClassName.setText("");
      this.ClassDesc.setText("");
      this.Status.select(0);
      Date var1 = new Date();
      this.lastmod.setText(var1.toLocaleString());
      this.owner.setText(super.user.cust.username);
      this.notes.setText("");
   }

   void loadData() {
      JDPJagg var2 = new JDPJagg(super.user.jaggPath);
      var2.setNULL("space");
      var2.setMRW("1000");
      var2.loadSettings(super.user);
      int var3 = 0;
      Vector var4 = new Vector();
      String var5 = var2.getSEP();
      if ((this.itemIndex = this.searchResults.getSelectedIndex()) < 0) {
         this.clearFields();
      } else {
         String var8 = "SELECT ClassName," + "ClassDesc," + "Status," + "lastmod," + "owner," + "notes" + " FROM JDPClassDef" + " WHERE projtype = '" + this.projectType + "' AND JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'" + " AND ClassName='" + this.searchResults.recordKey1[this.itemIndex] + "'";
         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var3 = var2.execSQL(var8, var4);
         if (var3 == -1) {
            super.user.u.setSqlMessage(var2, var8);
         } else if (var3 >= 1) {
            String var6 = (String)var4.elementAt(0);
            if (var6 != null && var6.trim().compareTo("") != 0) {
               StringTokenizer var1 = new StringTokenizer(var6);
               this.ClassName.setText(var1.nextToken(var5).trim());
               this.ClassDesc.setText(var1.nextToken(var5).trim());
               String var7 = var1.nextToken(var5).trim();
               if (this.valueStatus.indexOf(var7) >= 0) {
                  this.Status.select(this.valueStatus.indexOf(var7));
               }

               this.lastmod.setText(var1.nextToken(var5).trim());
               this.owner.setText(var1.nextToken(var5).trim());
               this.notes.setText(var1.nextToken(var5).trim());
            }

            if (var3 > 1) {
               super.user.mainmsg.setStatusMsg("Multiple records found - first match only displayed.", 10);
            } else {
               super.user.mainmsg.clearStatusMsg();
            }
         } else {
            super.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
            this.clearFields();
         }
      }
   }

   boolean saveData() {
      JDPJagg var1 = new JDPJagg(super.user.jaggPath);
      var1.setNULL("space");
      var1.setMRW("1000");
      var1.loadSettings(super.user);
      int var2 = 0;
      Vector var3 = new Vector();
      var1.getSEP();
      String var4 = "";
      Date var5 = new Date();
      this.lastmod.setText(var5.toLocaleString());
      if (this.insertRequested) {
         var4 = "SELECT * FROM JDPClassDef " + " WHERE JDPSystem='" + super.user.JDPSystem + "'" + " AND ClassName='" + super.user.u.replace(this.ClassName.getText(), "'", "''") + "'";
         var2 = var1.execSQL(var4, var3);
         if (var2 > 0) {
            return true;
         }

         var3 = new Vector();
         var4 = "INSERT INTO JDPClassDef (JDPSystem, ClassName, " + "ClassDesc, " + "Status, " + "projtype, " + "lastmod, " + "owner, " + "notes) VALUES('" + super.user.u.replace(super.user.JDPSystem, "'", "''") + "', " + "'" + super.user.u.replace(this.ClassName.getText(), "'", "''") + "', " + "'" + super.user.u.replace(this.ClassDesc.getText(), "'", "''") + "', " + "'" + (String)this.valueStatus.elementAt(this.Status.getSelectedIndex()) + "', " + "'" + this.projectType + "', " + "'" + super.user.u.replace(this.lastmod.getText(), "'", "''") + "', " + "'" + super.user.u.replace(this.owner.getText(), "'", "''") + "', " + "'" + super.user.u.replace(this.notes.getText(), "'", "''") + "')";
      } else {
         this.itemIndex = this.searchResults.getSelectedIndex();
         if (this.ClassName.getText().equals("")) {
            super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         if (this.itemIndex < 0) {
            return false;
         }

         if (this.deleteRequested) {
            var4 = "DELETE FROM JDPClassDef" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'" + " AND ClassName='" + this.searchResults.recordKey1[this.itemIndex] + "'";
         } else {
            var4 = "UPDATE JDPClassDef SET ClassDesc = '" + super.user.u.replace(this.ClassDesc.getText(), "'", "''") + "', " + "Status = '" + (String)this.valueStatus.elementAt(this.Status.getSelectedIndex()) + "', " + "lastmod = '" + super.user.u.replace(this.lastmod.getText(), "'", "''") + "', " + "notes = '" + super.user.u.replace(this.notes.getText(), "'", "''") + "'" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'" + " AND ClassName='" + this.searchResults.recordKey1[this.itemIndex] + "'";
         }
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var2 = var1.execSQL(var4, var3);
      if (var2 == -1) {
         super.user.u.setSqlMessage(var1, var4);
         return false;
      } else {
         if (var2 == 1) {
            if (this.insertRequested) {
               super.user.mainmsg.setStatusMsg("Record successfully added.", 3);
            } else if (this.deleteRequested) {
               super.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
            } else {
               super.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
            }
         } else {
            super.user.u.setSqlMessage(var1, var4);
         }

         this.insertRequested = false;
         this.deleteRequested = false;
         return true;
      }
   }

   boolean checkFields() {
      if (!super.user.u.ischaracter(this.ClassName, super.user.mainmsg, "Please enter a Project name")) {
         return false;
      } else if (!super.user.u.ischaracter(this.ClassDesc, super.user.mainmsg, "Please enter a Project description")) {
         return false;
      } else {
         String var1 = this.ClassName.getText();
         var1 = super.user.u.replace(var1, " ", "");
         var1 = super.user.u.replace(var1, "'", "");
         this.ClassName.setText(var1);
         return true;
      }
   }

   public synchronized boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               return true;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.modifiers != 1) {
                  if (var1.target.equals(this.ClassName)) {
                     super.user.u.cursor(this.ClassDesc);
                     return true;
                  }

                  if (var1.target.equals(this.ClassDesc)) {
                     super.user.u.cursor(this.owner);
                     return true;
                  }

                  if (var1.target.equals(this.owner)) {
                     super.user.u.cursor(this.lastmod);
                     return true;
                  }

                  if (var1.target.equals(this.lastmod)) {
                     super.user.u.cursor(this.Status);
                     return true;
                  }

                  if (var1.target.equals(this.Status)) {
                     super.user.u.cursor(this.notes);
                     return true;
                  }

                  if (var1.target.equals(this.notes)) {
                     super.user.u.cursor(this.ClassName);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.ClassDesc)) {
                     super.user.u.cursor(this.ClassName);
                     return true;
                  }

                  if (var1.target.equals(this.owner)) {
                     super.user.u.cursor(this.ClassDesc);
                     return true;
                  }

                  if (var1.target.equals(this.lastmod)) {
                     super.user.u.cursor(this.owner);
                     return true;
                  }

                  if (var1.target.equals(this.Status)) {
                     super.user.u.cursor(this.lastmod);
                     return true;
                  }

                  if (var1.target.equals(this.notes)) {
                     super.user.u.cursor(this.Status);
                     return true;
                  }

                  if (var1.target.equals(this.ClassName)) {
                     super.user.u.cursor(this.notes);
                     return true;
                  }
               }

               return true;
            }

            return false;
         case 501:
            if (this.popup.isVisible()) {
               this.popup.hideMenu();
               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPTreePicker) {
               String var3 = (String)var1.arg;
               if (var3.equals("BranchSelect")) {
                  if (var1.target.equals(this.searchResults.tree)) {
                     this.popup.setMenuTree(this.popupMain);
                     this.popup.display(var1.x, var1.y);
                     return true;
                  }
               } else if (var3.equals("LeafSelect") && var1.target.equals(this.searchResults.tree)) {
                  this.popup.setMenuTree(this.popupFile);
                  this.popup.display(var1.x, var1.y);
                  return true;
               }
            }

            return false;
         case 1001:
            this.eventVector.addElement(var1);
            Thread var2 = new Thread(this);
            var2.start();
            return true;
         default:
            if (super.user.jdpMainWindow != null) {
               if (super.user.jdpMainWindow.getCursorType() == 3) {
                  return false;
               }

               super.user.jdpMainWindow.setCursor(0);
            }

            return false;
      }
   }

   public void run() {
      Event var1 = (Event)this.eventVector.elementAt(0);
      this.eventVector.removeElementAt(0);
      if (var1.target instanceof JDPTreePicker && var1.target.equals(this.searchResults.tree)) {
         this.loadData();
      } else if (var1.target instanceof JDPButton) {
         String var3 = (String)var1.arg;
         if (var3.trim().compareTo("Apply") == 0) {
            if (this.checkFields()) {
               this.saveProject();
            }

            this.ClassName.setEditable(false);
         } else if (var3.trim().compareTo("Reset") == 0) {
            this.loadData();
         } else if (var3.trim().compareTo("Edit") == 0) {
            if (this.checkFields()) {
               if (!this.copyRequested && !this.insertRequested && !super.user.saveProperties.load(this.appDir + this.ClassName.getText() + ".jdp")) {
                  return;
               }

               if (this.insertRequested) {
                  this.saveData();
                  super.user.saveProperties.save(this.appDir + this.ClassName.getText() + ".jdp");
                  this.newSearch();
               } else {
                  this.saveData();
               }

               this.selectProject();
               this.copyRequested = false;
               this.ClassName.setEditable(false);
               super.user.jdpMenuPanel.loadNextTab();
               this.retrieveDSN();
            }

         } else if (var3.trim().compareTo("New") == 0) {
            this.insertRequested = true;
            super.user.saveProperties.clear();
            this.clearFields();
            this.ClassName.setEditable(true);
            this.ClassName.requestFocus();
         } else if (var3.trim().compareTo("Copy") == 0) {
            super.user.saveProperties.load(this.appDir + this.ClassName.getText() + ".jdp");
            this.ClassName.setText("");
            this.ClassName.requestFocus();
            this.ClassName.setEditable(true);
            this.insertRequested = true;
            this.copyRequested = true;
         } else if (var3.trim().compareTo("Remove") == 0) {
            this.insertRequested = false;
            this.deleteRequested = true;
            this.ClassName.setEditable(false);
            this.saveData();
            this.newSearch();
         } else if (var3.trim().compareTo("Search") == 0) {
            this.insertRequested = false;
            this.deleteRequested = false;
            this.newSearch();
         }
      } else if (!(var1.target instanceof Choice)) {
         if (var1.target instanceof TextField) {
            this.checkFields();
         } else if (var1.target instanceof JDPPopupMenu) {
            String[] var2 = this.popup.getSelectedBranch();
            this.popup.hideMenu();
            if (var2[0].equals("New Project...")) {
               this.insertRequested = true;
               super.user.saveProperties.clear();
               this.ClassName.setEditable(true);
               this.clearFields();
               this.ClassName.requestFocus();
            } else if (var2[0].equals("Copy Project...")) {
               super.user.saveProperties.load(this.appDir + this.ClassName.getText() + ".jdp");
               this.ClassName.setText("");
               this.ClassName.requestFocus();
               this.ClassName.setEditable(true);
               this.insertRequested = true;
               this.copyRequested = true;
            } else if (var2[0].equals("Edit Project...")) {
               if (this.checkFields()) {
                  if (!this.copyRequested && !this.insertRequested && !super.user.saveProperties.load(this.appDir + this.ClassName.getText() + ".jdp")) {
                     return;
                  }

                  if (this.insertRequested) {
                     this.saveData();
                     super.user.saveProperties.save(this.appDir + this.ClassName.getText() + ".jdp");
                     this.newSearch();
                  } else {
                     this.saveData();
                  }

                  this.copyRequested = false;
                  this.ClassName.setEditable(false);
                  super.user.jdpMenuPanel.loadNextTab();
                  this.retrieveDSN();
               }

            } else if (var2[0].equals("Remove Project...")) {
               this.insertRequested = false;
               this.deleteRequested = true;
               this.ClassName.setEditable(false);
               this.saveData();
               this.newSearch();
            } else if (var2[0].equals("Refresh")) {
               this.insertRequested = false;
               this.deleteRequested = false;
               this.ClassName.setEditable(false);
               this.newSearch();
            }
         }
      }
   }

   void checkDevelopers() {
      super.user.jaggSQL.setFCTN("CheckDevelopers");
      super.user.jaggSQL.setFCTNP("");
      Vector var1 = new Vector();
      int var2 = super.user.jaggSQL.execSQL("", var1);
      this.jaggSQL.setFCTN("");
      boolean var3 = false;
      if (var2 > this.searchResults.tree.treeRoot.leaves.size()) {
         var3 = true;
      } else {
         for(int var4 = 0; var4 < var2; ++var4) {
            if (this.searchResults.tree.treeRoot.leaves.size() > var4) {
               JDPTreeBranch var5 = (JDPTreeBranch)this.searchResults.tree.treeRoot.leaves.elementAt(var4);
               if (var5.name.equals(super.user.cust.username)) {
                  var3 = true;
               }
            }
         }
      }

      if (!var3) {
         String var6 = "";
         if (var2 > 1) {
            var6 = "s";
         }

         super.user.mainmsg.setStatusMsg("Your developer license only allows " + Integer.toString(var2) + " developer" + var6 + ". Contact BulletProof for extra licenses.", 60);
         this.searchResults.tree.disable();

         for(int var7 = 0; var7 < this.btns.button.length; ++var7) {
            this.btns.button[var7].disable();
         }

         this.ClassName.setEditable(false);
         this.ClassDesc.setEditable(false);
      }

      super.user.jaggSQL.setFCTN("");
      super.user.jaggSQL.setFCTNP("");
   }

   void retrieveDSN() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN") == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
               this.targetDSN.refresh();
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr) {
            ((JDPLayoutMgr)super.user.gParm.elementAt(var1)).restoreSelections();
         }
      }

   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.projectType = "W";
      if (var3.length() > 0) {
         this.projectType = var3.substring(0, 1);
      }

      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.setNULL("space");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.loadSettings(var1);
      this.appDir = var1.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator + "Wizard" + JDesignerPro.serverSeparator;
      this.eventVector = new Vector();
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      String var9 = "b.JDPSystem,a.ClassName";
      String[] var10 = new String[]{"a.ClassName"};
      this.pfromWhereClause = "FROM JDPClassDef a, JDPSystemDef b WHERE a.projtype = '" + this.projectType + "' AND a.JDPSystem = b.JDPSystem AND a.JDPSystem = '" + var1.JDPSystem + "'";
      this.psortChoice = new String[1];
      this.psortChoice[0] = "a.owner";
      String[] var11 = new String[]{"Jdpsystem"};
      this.pdisplayChoice = this.psortChoice;
      boolean var12 = false;
      String var13 = "Total Entries:";
      if (var1.saveProperties == null) {
         var1.saveProperties = new JDPSaveProps(var1);
      }

      this.popup = new JDPPopupMenu(var1, this);
      ((Container)var2).add(this.popup);
      this.createPopupMenus();
      this.ClassName = new TextField("", 22);
      this.ClassDesc = new TextField("", 40);
      this.owner = new TextField("", 22);
      this.lastmod = new TextField("", 22);
      this.Status = new Choice();
      this.notes = new TextArea("", 8, 45);
      this.loadChoices();
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Project Name:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Description:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Owner:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Last Modified:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Status:", Color.black));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Notes:", Color.black));
      Panel var14 = new Panel();
      ((Container)var14).setLayout(new JDPLineLayout(3));
      ((Container)var14).add("Left", this.ClassName);
      ((Container)var7).add("Right", var14);
      Panel var15 = new Panel();
      ((Container)var15).setLayout(new JDPLineLayout(3));
      ((Container)var15).add("Left", this.ClassDesc);
      ((Container)var7).add("Right", var15);
      Panel var16 = new Panel();
      ((Container)var16).setLayout(new JDPLineLayout(3));
      ((Container)var16).add("Left", this.owner);
      ((Container)var7).add("Right", var16);
      Panel var17 = new Panel();
      ((Container)var17).setLayout(new JDPLineLayout(3));
      ((Container)var17).add("Left", this.lastmod);
      ((Container)var7).add("Right", var17);
      Panel var18 = new Panel();
      ((Container)var18).setLayout(new JDPLineLayout(3));
      ((Container)var18).add("Left", this.Status);
      ((Container)var7).add("Right", var18);
      Panel var19 = new Panel();
      ((Container)var19).setLayout(new JDPLineLayout(3));
      ((Container)var19).add(new Label("", 0));
      ((Container)var7).add("Right", var19);
      ((Container)var6).add("North", var7);
      ((Container)var6).add("Center", this.notes);
      this.ClassName.setForeground(Color.black);
      this.ClassDesc.setForeground(Color.black);
      this.Status.setForeground(Color.black);
      this.lastmod.setForeground(Color.black);
      this.owner.setForeground(Color.black);
      this.notes.setForeground(Color.black);
      this.ClassName.setBackground(Color.white);
      this.ClassDesc.setBackground(Color.white);
      this.Status.setBackground(Color.white);
      this.popuppanel.addComponent(this.ClassName, "Project Name", "Enter the name for the Project");
      this.popuppanel.addComponent(this.ClassDesc, "Description", "Enter the description of the Project");
      this.popuppanel.addComponent(this.Status, "Status", "The current status of the project");
      this.popuppanel.addComponent(this.lastmod, "Last modified", "Date that the Project was last modified");
      this.popuppanel.addComponent(this.owner, "Owner", "Project Owner");
      this.popuppanel.addComponent(this.notes, "Notes", "Enter any notes for this Project");
      this.lastmod.setEditable(false);
      this.owner.setEditable(false);
      String[] var20 = new String[]{"Apply", "Reset", "Edit", "New", "Copy", "Remove"};
      int[] var21 = new int[]{0, 6, 1, 9, 10, 8};
      this.btns = new JDPButtons(var1, var20, var21, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", this.btns);
      this.popuppanel.addComponent(this.btns.button[0], "Apply Changes", "Save changes to the database");
      this.popuppanel.addComponent(this.btns.button[1], "Undo Changes", "Undo changes by reloading the record");
      this.popuppanel.addComponent(this.btns.button[2], "Edit Project", "Edit this project");
      this.popuppanel.addComponent(this.btns.button[3], "New Entry", "Create a new project");
      this.popuppanel.addComponent(this.btns.button[4], "Copy Entry", "Copy this project");
      this.popuppanel.addComponent(this.btns.button[5], "Remove record", "Remove the current project");
      ((Container)var4).add("Center", var6);
      String[] var22 = new String[0];
      String[] var23 = new String[0];
      String[][] var24 = new String[0][0];
      String[][] var25 = new String[0][0];
      boolean[] var26 = new boolean[0];
      int[] var27 = new int[0];
      if (var22.length > 0) {
         this.jdpWhereClause = new JDPWhereClause(var1, var2, "JDPProjManager", true, " ", var22, var23, var24, var25, (String[][])null, (String[][])null, var27, var26);
         ((Container)var8).add("North", this.jdpWhereClause);
      }

      if (this.psortChoice.length > 0) {
         this.searchResults = new JDPSearchResults(var1, var2, true, this.jaggSQL, false, var9, var10, this.pfromWhereClause, var11, this.psortChoice, this.pdisplayChoice, "", var12, var13);
         int[] var28 = new int[]{4, 5, 1};
         this.searchResults.setIcons(var28);
         this.searchResults.setMinWidth(185);
         ((Container)var8).add("Center", this.searchResults);
         ((Container)var4).add("West", var8);
      }

      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Project Manager", var4, "North"));
      if (this.psortChoice.length > 0) {
         this.newSearch();
      }

      ((Component)var2).paintAll(((Component)var2).getGraphics());
      var1.gParm.addElement(this);
      this.checkDevelopers();
   }
}
