import java.awt.BorderLayout;
import java.awt.Choice;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.Vector;

public class JDPScreenBuild extends JDPClassLayout implements Runnable {
   JDPProjectMgr targetProject;
   JDPSearchResults searchResults;
   Panel targetPanel;
   String moduleParameter;
   String layoutName;
   Vector eventVector;
   TextField className;
   TextField classDesc;
   TextField frameTitle;
   Choice allowUpdates;
   Choice allowInserts;
   Choice allowDeletes;
   Choice confirmDeletes;
   TextArea compileResults;
   Panel centerTopPanel;
   Panel centerMainPanel;
   JDPPanelLoader testPanel;
   JDPPopupMessage popuppanel;
   String pfromWhereClause;
   String[] psortChoice;
   String[] pdisplayChoice;
   Vector gParmObject;
   int thisScreenIndex;
   JDPLayoutGenerator blg;
   boolean sourceDisplayed;
   String choice;
   String appDir;

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPScreenBuild";
      var1.restoreObject(this.classDesc, var2, "classDesc");
      var1.restoreObject(this.frameTitle, var2, "frameTitle");
      var1.restoreObject(this.allowUpdates, var2, "allowUpdates");
      var1.restoreObject(this.allowInserts, var2, "allowInserts");
      var1.restoreObject(this.allowDeletes, var2, "allowDeletes");
      var1.restoreObject(this.confirmDeletes, var2, "confirmDeletes");
      return true;
   }

   void newSearch() {
      String var1 = this.pfromWhereClause;
      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
      if (this.searchResults.treeRoot.leaves.size() > 0) {
         JDPTreeBranch var2 = (JDPTreeBranch)this.searchResults.treeRoot.leaves.elementAt(0);
         var2.expanded = true;
      }

   }

   void retrieveTargets() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof JDPProjectMgr) {
            this.targetProject = (JDPProjectMgr)super.user.gParm.elementAt(var1);
            if (this.targetProject.projectType.equals("W")) {
               String var2 = "";
               if (this.targetProject != null) {
                  var2 = this.targetProject.ClassDesc.getText();
               }

               this.classDesc.setText(var2);
               this.frameTitle.setText(var2);
            } else {
               this.targetProject = null;
            }
         }
      }

   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPScreenBuild";
      var1.saveObject(this.classDesc, var2, "classDesc");
      var1.saveObject(this.frameTitle, var2, "frameTitle");
      var1.saveObject(this.allowUpdates, var2, "allowUpdates");
      var1.saveObject(this.allowInserts, var2, "allowInserts");
      var1.saveObject(this.allowDeletes, var2, "allowDeletes");
      var1.saveObject(this.confirmDeletes, var2, "confirmDeletes");
      return true;
   }

   void loadSource() {
      this.compileResults.setText("");
      super.user.mainmsg.setStatusMsg("Loading source file...", 0);
      String var1 = super.user.u.readFromFile(this.appDir + this.className.getText() + ".java");
      if (var1 != null) {
         this.compileResults.setText(var1);
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               if (this.targetProject == null) {
                  this.retrieveTargets();
               }

               return true;
            }

            return false;
         case 401:
            if (var1.key == 9) {
               if (var1.target.equals(this.className)) {
                  super.user.u.cursor(this.classDesc);
                  return true;
               }

               if (var1.target.equals(this.classDesc)) {
                  super.user.u.cursor(this.frameTitle);
                  return true;
               }

               if (var1.target.equals(this.frameTitle)) {
                  super.user.u.cursor(this.allowUpdates);
                  return true;
               }

               if (var1.target.equals(this.allowUpdates)) {
                  super.user.u.cursor(this.allowInserts);
                  return true;
               }

               if (var1.target.equals(this.allowInserts)) {
                  super.user.u.cursor(this.allowDeletes);
                  return true;
               }

               if (var1.target.equals(this.allowDeletes)) {
                  super.user.u.cursor(this.confirmDeletes);
                  return true;
               }

               if (var1.target.equals(this.confirmDeletes)) {
                  super.user.u.cursor(this.className);
                  return true;
               }
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            this.eventVector.addElement(var1);
            Thread var2 = new Thread(this);
            var2.start();
            return true;
         default:
            return false;
      }
   }

   public void run() {
      Event var1 = (Event)this.eventVector.elementAt(0);
      this.eventVector.removeElementAt(0);
      switch (var1.id) {
         case 1001:
            if (var1.target instanceof JDPTreePicker && var1.target.equals(this.searchResults.tree)) {
               this.className.setText(this.searchResults.recordKey1[this.searchResults.getSelectedIndex()]);
               this.loadSource();
               this.sourceDisplayed = true;
               return;
            } else if (var1.target instanceof JDPButton) {
               String var2 = (String)var1.arg;
               if (var2.trim().equals("Build") || var2.trim().equals("Final Build")) {
                  this.choice = var2;
                  this.buildProject();
                  return;
               } else if (var2.trim().compareTo("Load Source") == 0) {
                  if (this.targetProject != null) {
                     this.className.setText(this.targetProject.ClassName.getText());
                  }

                  this.loadSource();
                  this.sourceDisplayed = true;
                  return;
               } else if (var2.trim().compareTo("Save") == 0) {
                  if (!this.sourceDisplayed) {
                     super.user.mainmsg.setStatusMsg("You must load the source before you can save it.", 7);
                     return;
                  } else {
                     if (this.blg == null) {
                        this.blg = new JDPLayoutGenerator(super.user, this.layoutName, this.className.getText());
                     }

                     if (this.blg != null) {
                        super.user.mainmsg.setStatusMsg("Saving source...", 0);
                        this.blg.outputText = this.compileResults.getText();
                        if (super.user.u.writeToFile(this.appDir + this.className.getText().trim() + ".java", this.blg.outputText, "w+")) {
                           super.user.mainmsg.setStatusMsg("Source file successfully saved.", 5);
                           return;
                        }

                        super.user.mainmsg.setStatusMsg("Could not save source file.", 10);
                     }

                     return;
                  }
               } else if (var2.trim().compareTo("Compile") == 0) {
                  String var3 = "-d " + super.user.JDesignerPro.JDPDirectory + " ";
                  String var4 = super.user.JDesignerPro.JDPCompiler + " -classpath " + super.user.JDesignerPro.JDPClasses + JDesignerPro.pathDelimiter + super.user.JDesignerPro.JDPDirectory + " " + var3 + this.appDir + this.className.getText().trim() + ".java";
                  if (super.user.JDesignerPro.JDPCompiler.toUpperCase().indexOf("JVC") >= 0 && JDPJagg.useJaggServer) {
                     var4 = super.user.JDesignerPro.JDPCompiler + " " + var3 + this.appDir + this.className.getText().trim() + ".java";
                  }

                  JDPCommandExecuter var5 = new JDPCommandExecuter(super.user, var4, "Compiling source code...", "Screen compiled successfully.", "Compile failed.");
                  String var6 = "";
                  if (var5.success) {
                     if (this.testPanel != null) {
                        this.testPanel.removeAll();
                        super.user.JDPBuildTestPanel[this.thisScreenIndex].remove(this.testPanel);
                        this.testPanel = null;
                     } else {
                        this.thisScreenIndex = super.user.JDPBuildTestPanelIndex++;
                     }

                     super.user.JDPBuildTestPanel[this.thisScreenIndex].setLayout(new BorderLayout());
                     this.testPanel = new JDPPanelLoader(super.user, this.className.getText());
                     super.user.JDPBuildTestPanel[this.thisScreenIndex].add("Center", this.testPanel);
                     super.user.JDPBuildTestPanel[this.thisScreenIndex].paintAll(super.user.JDPBuildTestPanel[this.thisScreenIndex].getGraphics());
                     super.user.jdpMenuPanel.loadNextTab();
                     return;
                  }

                  for(int var7 = 0; var7 < var5.results.size(); ++var7) {
                     var6 = var6 + var5.results.elementAt(var7) + "\n";
                  }

                  this.sourceDisplayed = false;
                  this.compileResults.setText(var6);
                  return;
               }
            }
         default:
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.targetPanel = var2;
      int var4 = var3.indexOf(" ");
      if (var4 > 0) {
         this.layoutName = "JDPLayout" + var3.substring(0, var4);
         var3 = var3.substring(var4 + 1);
      } else {
         this.layoutName = "JDPLayout" + var3;
         var3 = "";
      }

      this.moduleParameter = var3;
      this.appDir = var1.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator + "Wizard" + JDesignerPro.serverSeparator;
      this.eventVector = new Vector();
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      this.centerMainPanel = new Panel();
      this.centerMainPanel.setLayout(new BorderLayout());
      this.centerTopPanel = new Panel();
      this.centerTopPanel.setLayout(new JDPRowLayout(1, 1));
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      String var10 = "b.JDPSystem,a.ClassName";
      String[] var11 = new String[]{"ClassName"};
      this.pfromWhereClause = "FROM JDPClassDef a, JDPSystemDef b WHERE a.JDPSystem = b.JDPSystem AND a.JDPSystem = '" + var1.JDPSystem + "' AND a.projtype = 'W'";
      this.psortChoice = new String[1];
      this.psortChoice[0] = "b.JDPSystemD";
      String[] var12 = new String[]{"Jdpsystem"};
      this.pdisplayChoice = this.psortChoice;
      boolean var13 = false;
      String var14 = "Total Entries:";
      this.className = new TextField("DemoClass", 20);
      this.classDesc = new TextField("", 40);
      this.frameTitle = new TextField("", 30);
      this.allowUpdates = new Choice();
      this.allowUpdates.addItem("Yes");
      this.allowUpdates.addItem("No");
      this.allowInserts = new Choice();
      this.allowInserts.addItem("Yes");
      this.allowInserts.addItem("No");
      this.allowDeletes = new Choice();
      this.allowDeletes.addItem("Yes");
      this.allowDeletes.addItem("No");
      this.confirmDeletes = new Choice();
      this.confirmDeletes.addItem("Yes");
      this.confirmDeletes.addItem("No");
      this.compileResults = new TextArea("", 2, 60);
      this.compileResults.setFont(new Font("Courier", 0, 12));
      if (var3.compareTo("") != 0 && var3.compareTo("IDE") != 0) {
         this.allowUpdates.select(1);
         this.allowUpdates.disable();
         this.allowInserts.select(1);
         this.allowInserts.disable();
         this.allowDeletes.select(1);
         this.allowDeletes.disable();
         this.confirmDeletes.select(1);
         this.confirmDeletes.disable();
         String var15 = Long.toString(System.currentTimeMillis());
         var15 = var3 + var15.substring(var15.length() - 6);
         this.className.setText(var15);
         this.className.setEditable(false);
      }

      if (var3.compareTo("IDE") != 0) {
         this.centerMainPanel.add("North", this.centerTopPanel);
         this.centerTopPanel.add("Left", new JDPWrapLabel(var1, "Class Description:"));
         this.centerTopPanel.add("Right", this.classDesc);
         this.centerTopPanel.add("Left", new JDPWrapLabel(var1, "Frame Text Title:"));
         this.centerTopPanel.add("Right", this.frameTitle);
         this.centerTopPanel.add("Left", new JDPWrapLabel(var1, "Allow Updates:"));
         Panel var21 = new Panel();
         ((Container)var21).setLayout(new JDPLineLayout(3));
         if (this.layoutName.equals("JDPLayout1") || this.layoutName.equals("JDPLayout2") || this.layoutName.equals("JDPLayout3")) {
            this.centerTopPanel.add("Right", var21);
            ((Container)var21).add("Left", this.allowUpdates);
            ((Container)var21).add("Left", new JDPWrapLabel(var1, "Allow Inserts:"));
            ((Container)var21).add("Left", this.allowInserts);
            ((Container)var21).add("Left", new JDPWrapLabel(var1, "Allow Deletes:"));
            ((Container)var21).add("Left", this.allowDeletes);
            ((Container)var21).add("Left", new JDPWrapLabel(var1, "Confirm:"));
            ((Container)var21).add("Left", this.confirmDeletes);
         }

         this.restoreSelections();
      }

      ((Container)var8).add("Center", this.compileResults);
      if (var3.compareTo("IDE") != 0) {
         ((Container)var7).add("Center", new JDPChiselFramePanel(var1, "Compile Results", var8, "North"));
      } else {
         ((Container)var7).add("Center", var8);
      }

      this.centerMainPanel.add("Center", var7);
      String var22 = "Build the class file";
      this.popuppanel = new JDPPopupMessage(var1, var2);
      if (var3.compareTo("IDE") != 0) {
         String[] var16 = new String[]{"Build", "Final Build", "Load Source", "Save", "Compile"};
         int[] var17 = new int[]{3, 3, 1, 0, 2};
         JDPButtons var18 = new JDPButtons(var1, var16, var17, JDPButtons.HORIZONTAL);
         this.centerMainPanel.add("South", var18);
         this.popuppanel.addComponent(var18.button[0], "Save, Build, Compile and Load new class", "Generate a preliminary Build to prior to running the final build finished product");
         this.popuppanel.addComponent(var18.button[1], "Final Build", "Run a final Build if the preliminary build is complete and requires no more changes");
         this.popuppanel.addComponent(var18.button[2], "Load Source", "Load the source file specified in the Name field");
         this.popuppanel.addComponent(var18.button[3], "Save Source", "Save the source file specified in the Name field");
         this.popuppanel.addComponent(var18.button[4], "Compile and Load Source", "Compile the source file specified in the Name field and load the result");
         if (var3.compareTo("") != 0) {
            var18.button[1].disable();
            var18.button[2].disable();
            var18.button[3].disable();
            var18.button[4].disable();
         }
      } else {
         var22 = "Source editor and compiler";
         String[] var23 = new String[]{"Save", "Compile"};
         int[] var25 = new int[]{0, 2};
         JDPButtons var26 = new JDPButtons(var1, var23, var25, JDPButtons.HORIZONTAL);
         this.centerMainPanel.add("South", var26);
         this.popuppanel.addComponent(var26.button[0], "Save Source", "Save the source file specified in the Name field");
         this.popuppanel.addComponent(var26.button[1], "Compile and Load Source", "Compile the source file specified in the Name field and load the result");
      }

      ((Container)var2).add(this.popuppanel);
      ((Container)var5).add("Center", this.centerMainPanel);
      if (var3.equals("IDE")) {
         this.searchResults = new JDPSearchResults(var1, var2, true, var1.jaggSQL, false, var10, var11, this.pfromWhereClause, var12, this.psortChoice, this.pdisplayChoice, "", var13, var14);
         int[] var24 = new int[]{4, 2, 1};
         this.searchResults.setIcons(var24);
         this.searchResults.setMinWidth(160);
         ((Container)var9).add("Center", this.searchResults);
         ((Container)var5).add("West", var9);
         this.newSearch();
      }

      ((Container)this).add("Center", new JDPChiselFramePanel(var1, var22, var5, "North"));
      this.retrieveTargets();
      this.gParmObject = new Vector();
      this.gParmObject.addElement("ScreenBuild");
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }

   void buildProject() {
      this.saveSelections();
      if (this.targetProject != null) {
         this.targetProject.saveData();
      }

      super.user.saveProperties.save(this.appDir + this.targetProject.ClassName.getText() + ".jdp");
      String var1 = "DEL ";
      if (JDesignerPro.pathDelimiter.equals(":")) {
         var1 = "rm ";
      }

      if (!JDPJagg.useJaggServer) {
         new JDPCommandExecuter(super.user, var1 + this.appDir + this.className.getText().trim() + ".java", "", "", "");
         new JDPCommandExecuter(super.user, var1 + this.appDir + this.className.getText().trim() + ".class", "", "", "");
      }

      String var2 = this.appDir;
      if (this.choice.trim().equals("Build")) {
         String var3 = Long.toString(System.currentTimeMillis());
         var3 = "Prelim" + var3.substring(var3.length() - 6);
         this.className.setText(var3);
         var2 = super.user.JDesignerPro.JDPDirectory + "Temp" + JDesignerPro.serverSeparator;
      } else {
         this.className.setText(this.targetProject.ClassName.getText());
      }

      super.user.mainmsg.setStatusMsg("Loading JDPLayoutGenerator...", 0);
      this.blg = new JDPLayoutGenerator(super.user, this.layoutName, this.className.getText());
      if (this.blg != null && this.blg.readyToBuild() && this.blg.buildJava()) {
         String var9 = "-d " + super.user.JDesignerPro.JDPDirectory + " ";
         String var4 = super.user.JDesignerPro.JDPCompiler + " -classpath " + super.user.JDesignerPro.JDPClasses + JDesignerPro.pathDelimiter + super.user.JDesignerPro.JDPDirectory + " " + var9 + var2 + this.className.getText().trim() + ".java";
         if (super.user.JDesignerPro.JDPCompiler.indexOf("JVC") >= 0 && JDPJagg.useJaggServer) {
            var4 = super.user.JDesignerPro.JDPCompiler + " " + var9 + " " + var2 + this.className.getText().trim() + ".java";
         }

         JDPCommandExecuter var5 = new JDPCommandExecuter(super.user, var4, "Compiling source code...", "Screen compiled successfully.", "Compile failed.");
         String var6 = "";
         if (var5.success) {
            this.sourceDisplayed = false;
            this.compileResults.setText("");
            if (this.testPanel != null) {
               this.testPanel.removeAll();
               super.user.JDPBuildTestPanel[this.thisScreenIndex].remove(this.testPanel);
               this.testPanel = null;
            } else {
               this.thisScreenIndex = super.user.JDPBuildTestPanelIndex++;
            }

            super.user.JDPBuildTestPanel[this.thisScreenIndex].setLayout(new BorderLayout());
            this.testPanel = new JDPPanelLoader(super.user, this.className.getText());
            super.user.JDPBuildTestPanel[this.thisScreenIndex].add("Center", this.testPanel);
            super.user.JDPBuildTestPanel[this.thisScreenIndex].paintAll(super.user.JDPBuildTestPanel[this.thisScreenIndex].getGraphics());
            if (this.moduleParameter.compareTo("IDE") != 0) {
               super.user.jdpMenuPanel.loadNextTab();
               return;
            }
         } else {
            for(int var7 = 0; var7 < var5.results.size(); ++var7) {
               var6 = var6 + var5.results.elementAt(var7) + "\n";
            }

            this.compileResults.setText(var6);
            this.sourceDisplayed = false;
         }
      }

   }
}
