import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPScreenLayout extends JDPClassLayout {
   Panel targetPanel;
   String moduleParameter;
   JDPLayoutMgr targetLayoutMgr;
   JDPSelectDSN targetDSN;
   JDPSelectColumns target;
   JDPScreenSettings targetSettings;
   JDPGridLayout targetGrid;
   JDPPopupMessage popuppanel;
   JDPList columns;
   Label listCount;
   int[] columnIndexes;
   int[] screenOrderL;
   int[][] screenOrder;
   String[] fieldLabel;
   int[] radioIndex;
   int maxfields = 300;
   int maxcolumns = 30;
   Component[] componentL;
   Component[] component;
   int lastLine = -1;
   int lastItem;
   CheckboxGroup[] cbgroup;
   CheckboxGroup[] cbgroup1;
   Panel[] fieldLLine;
   Panel[] fieldRLine;
   Panel centerTopWrapPanel;
   JDPScrollPanel[] centerTopPanel;
   Panel centerMainPanel;
   Panel gridPanel;
   JDPComboBox addChoice;
   String[] titles;
   JDPTabSelectPanel tabPanel;
   int cPanel;
   String prevTabs = "";
   int[] panelPos;
   Vector gParmObject;

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      this.cPanel = 0;
      String var2 = "JDPScreenLayout" + super.componentName;
      int[] var3 = new int[0];
      int[][] var4 = new int[0][0];
      String[] var5 = new String[0];
      int[] var6 = new int[0];
      int[] var7 = new int[0];
      this.screenOrderL = new int[var3.length + 20];
      this.maxfields = this.target.columns.countItems() + 20;
      this.fieldLLine = new Panel[this.maxfields];
      this.fieldRLine = new Panel[this.maxfields];
      this.screenOrderL = new int[this.maxfields];
      this.screenOrder = new int[this.maxfields][this.maxcolumns];

      for(int var8 = 0; var8 < this.maxfields; ++var8) {
         this.screenOrderL[var8] = -2;

         for(int var9 = 0; var9 < this.maxcolumns; ++var9) {
            this.screenOrder[var8][var9] = -2;
         }
      }

      this.component = new Component[this.maxfields];
      this.columnIndexes = this.target.columns.getSelectedIndexes();
      var1.restoreObject(this.columns, var2, "columns");
      var3 = (int[])var1.restoreObject(var3, var2, "screenOrderL");
      var4 = (int[][])var1.restoreObject(var4, var2, "screenOrder");
      var5 = (String[])var1.restoreObject(var5, var2, "fieldLabel");
      var6 = (int[])var1.restoreObject(var6, var2, "panelPos");
      var7 = (int[])var1.restoreObject(var7, var2, "radioIndex");
      if (var3 != null && var3.length > 0) {
         this.screenOrderL = new int[var3.length + 20];

         for(int var15 = 0; var15 < this.screenOrderL.length; ++var15) {
            this.screenOrderL[var15] = -2;
         }

         System.arraycopy(var3, 0, this.screenOrderL, 0, var3.length);
      }

      if (var4 != null && var4.length > 0) {
         this.screenOrder = new int[this.screenOrderL.length + 20][var4[0].length];

         for(int var16 = 0; var16 < this.screenOrder.length; ++var16) {
            for(int var19 = 0; var19 < this.screenOrder[0].length; ++var19) {
               this.screenOrder[var16][var19] = -2;
            }
         }

         System.arraycopy(var4, 0, this.screenOrder, 0, var4.length);
      }

      if (var5 != null && var5.length > 0) {
         this.fieldLabel = new String[var5.length + 20];
         if (var5.length > 0) {
            System.arraycopy(var5, 0, this.fieldLabel, 0, var5.length);
         }
      }

      if (this.componentL != null && var5 != null && var5.length > 0) {
         this.componentL = new Component[var5.length + 20];

         for(int var17 = 0; var17 < this.componentL.length; ++var17) {
            TextField var20 = (TextField)this.componentL[var17];
            if (var20 != null && this.fieldLabel.length > var17) {
               ((TextComponent)var20).setText(this.fieldLabel[var17]);
            }
         }
      }

      if (var6 != null && var6.length > 0) {
         this.panelPos = new int[var6.length + 20];
         if (var6.length > 0) {
            System.arraycopy(var6, 0, this.panelPos, 0, var6.length);
         }
      }

      if (var7 != null && var7.length > 0) {
         this.radioIndex = new int[var7.length + 20];
         if (var7.length > 0) {
            System.arraycopy(var7, 0, this.radioIndex, 0, var7.length);
         }
      }

      if (this.screenOrder == null) {
         return true;
      } else if (this.target.columns.countItems() == 0) {
         return true;
      } else {
         for(int var18 = 0; var18 < this.screenOrder.length; ++var18) {
            for(int var21 = 0; var21 < this.screenOrder[0].length; ++var21) {
               if (this.screenOrder[var18][var21] >= 0) {
                  this.addChoice.select("Add on a new line");
                  if (var21 > 0) {
                     this.addChoice.select("Append to line");
                  }

                  this.cPanel = this.panelPos[this.screenOrder[var18][var21]];
                  if (this.screenOrder[var18][var21] == this.screenOrder[var18][var21 + 1]) {
                     this.addChoice.select("Append to line with Label");
                     this.loadItem(this.screenOrder[var18][var21]);
                     ++var21;
                  } else {
                     this.loadItem(this.screenOrder[var18][var21]);
                  }
               }
            }
         }

         this.cPanel = 0;
         this.addChoice.select("Add on a new line");
         return true;
      }
   }

   void clearList() {
      this.columns.clear();
      this.clearMainPanel();
   }

   void loadList() {
      this.clearList();
      this.componentL = null;
      if (this.target != null && this.target.columnName != null && this.target.columns.getSelectedIndexes().length != 0) {
         if (this.targetSettings != null && this.targetSettings.fieldType != null) {
            this.maxfields = this.target.columns.countItems() + 20;
            this.fieldLLine = new Panel[this.maxfields];
            this.fieldRLine = new Panel[this.maxfields];
            this.screenOrderL = new int[this.maxfields];
            this.screenOrder = new int[this.maxfields][this.maxcolumns];

            for(int var1 = 0; var1 < this.maxfields; ++var1) {
               this.screenOrderL[var1] = -2;

               for(int var2 = 0; var2 < this.maxcolumns; ++var2) {
                  this.screenOrder[var1][var2] = -2;
               }
            }

            this.componentL = new Component[this.maxfields];
            this.component = new Component[this.maxfields];
            this.panelPos = new int[this.maxfields];
            this.radioIndex = new int[this.target.columns.countItems() + 20];
            int var6 = 0;
            if (this.moduleParameter.equals("Combo")) {
               for(int var7 = 0; var7 < this.target.columns.countItems(); ++var7) {
                  String var3 = this.target.columns.getItem(var7);
                  if (this.target.columns.isSelected(var7) && var3.indexOf(".") > 0 && var3.indexOf("a.") < 0 || this.target.keys.isSelected(this.target.keys.getItem(var3))) {
                     ++var6;
                  }
               }
            }

            String[] var8;
            if (this.moduleParameter.equals("Combo")) {
               var8 = new String[var6];
               this.columnIndexes = new int[var6];
               int var9 = 0;
               this.listCount.setText(Integer.toString(var6));

               for(int var4 = 0; var4 < this.target.columns.countItems(); ++var4) {
                  String var5 = this.target.columns.getItem(var4);
                  if (this.target.columns.isSelected(var4) && var5.indexOf(".") > 0 && var5.indexOf("a.") < 0 || this.target.keys.isSelected(this.target.keys.getItem(var5))) {
                     var8[var9] = var5;
                     this.columnIndexes[var9] = var4;
                     this.columns.addItem(var5, this.getThisIcon(var4));
                     ++var9;
                  }
               }
            } else {
               var8 = this.target.columns.getSelectedItems();
               this.columnIndexes = this.target.columns.getSelectedIndexes();
               this.listCount.setText(Integer.toString(var8.length));

               for(int var10 = 0; var10 < var8.length; ++var10) {
                  this.columns.addItem(var8[var10], this.getThisIcon(var10));
               }
            }

            for(int var11 = 0; var11 < this.targetSettings.fieldType.length; ++var11) {
               if (this.targetSettings.fieldType[var11].equals("RadioButtons")) {
                  for(int var13 = 1; var13 < JDPChoiceLayout.maxChoices; ++var13) {
                     if (this.targetSettings.thisChoicePanel.textChoiceValue[var11][var13].length() > 0 && this.targetSettings.thisChoicePanel.actualChoiceValue[var11][var13].length() > 0) {
                        this.columns.addItem(this.targetSettings.columns.getItem(var11) + Integer.toString(var13), this.getThisIcon(var11));
                        this.radioIndex[this.columns.countItems() - 1] = var13;
                     }
                  }
               }
            }

            this.fieldLabel = new String[var8.length + 20];

            for(int var12 = 0; var12 < var8.length; ++var12) {
               if (this.target.useRemarks.getSelectedItem().equals("Yes") && !this.target.columnRemarks[var12].equals("")) {
                  this.fieldLabel[var12] = this.target.columnRemarks[var12] + ":";
               } else {
                  this.fieldLabel[var12] = super.user.u.makeLabel(var8[var12] + ":");
               }

               TextField var14 = (TextField)this.componentL[var12];
               if (var14 != null) {
                  ((TextComponent)var14).setText(this.fieldLabel[var12]);
               }
            }

         }
      }
   }

   void loadLayoutComponent() {
      boolean var1 = false;
      boolean var2 = false;
      boolean var3 = false;
      if (this.targetLayoutMgr != null && (!this.targetLayoutMgr.projectLoading || this.targetLayoutMgr.loadingWizardApp)) {
         if (super.thisBranch.leaves.size() > 0) {
            this.targetLayoutMgr.lView.removeSelectedBranch();
         }

         JDPTreeBranch[] var4 = new JDPTreeBranch[1];
         JDPJagg var6 = new JDPJagg(super.user.jaggPath);
         var6.loadSettings(this.targetDSN);
         var6.setMRW("100");
         JDPLoadChoice var7 = new JDPLoadChoice(super.user, var6, (Object)null, "", "", "", "", -1);
         JDPTreeBranch var8 = null;
         String[] var9 = null;
         JDPTreeBranch[] var10 = this.targetLayoutMgr.layoutTree.getTreeBranch(super.thisBranch.thisObject);
         JDPTreeBranch[] var11 = var10;
         if (var10 == null) {
            return;
         }

         JDPTreeBranch var12 = var10[var10.length - 1];
         int var13 = 1;
         if (this.columns.getSelectedIndexes().length > 0) {
            Component var14 = this.targetLayoutMgr.gSource.findRelatedComp(super.thisBranch, "JDPSearchLayout");
            Component var15 = this.targetLayoutMgr.gSource.findRelatedComp(super.thisBranch, "JDPListLayout");
            Component var16 = this.targetLayoutMgr.gSource.findRelatedComp(super.thisBranch, "JDPGridSettings");
            JDPTreeBranch var17 = null;
            if (var14 != null && ((JDPSearchLayout)var14).columns.getSelectedIndexes().length > 0) {
               var1 = true;
            }

            if (var15 != null && ((JDPListLayout)var15).columns.getSelectedItems().length > 0) {
               var2 = true;
            }

            if (var16 != null) {
               var3 = true;
            }

            if (var1 || var2) {
               var4[0] = new JDPTreeBranch();
               var4[0].name = "Panel";
               var4[0].compType = "Panel";
               var4[0].icon = 24;
               this.targetLayoutMgr.checkDragNDrop(var4, var10);
               var17 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               var10 = this.targetLayoutMgr.layoutTree.getTreeBranch(this.targetLayoutMgr.layoutTree.getLastAddedBranch());
               var11 = var10;
               this.targetLayoutMgr.checkDragNDrop(var4, var10);
               var10 = this.targetLayoutMgr.layoutTree.getTreeBranch(this.targetLayoutMgr.layoutTree.getLastAddedBranch());
               if (var3) {
                  var10[var10.length - 1].compPosition = "North";
                  ((Container)var10[var10.length - 1].thisObject).remove((Component)var10[var10.length - 1].thisObject);
                  ((Container)var10[var10.length - 1].thisObject).add("North", (Component)var10[var10.length - 1].thisObject);
               }
            }

            if (this.targetSettings != null && this.targetSettings.useTabs.getSelectedItem().equals("Yes")) {
               StringTokenizer var18 = new StringTokenizer(this.targetSettings.tabNames.getText(), "\n");
               var9 = new String[50];

               int var19;
               for(var19 = 0; var18.hasMoreTokens(); var9[var19++] = var18.nextToken().trim()) {
               }

               var13 = var19;
               var4[0] = new JDPTreeBranch();
               var4[0].name = "Tab Panel";
               var4[0].compType = "JDPTabSelectPanel";
               var4[0].icon = 25;
               this.targetLayoutMgr.checkDragNDrop(var4, var10);
               JDPTreeBranch var20 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               var8 = var20;
               var10 = this.targetLayoutMgr.layoutTree.getTreeBranch(var20);
            }

            boolean var44 = this.targetLayoutMgr.projectLoading;
            this.targetLayoutMgr.projectLoading = true;
            JDPTreeBranch var45 = null;
            JDPTreeBranch var46 = null;

            for(int var21 = 0; var21 < var13; ++var21) {
               var4[0] = new JDPTreeBranch();
               var4[0].name = "Scroll Panel";
               var4[0].compType = "JDPScrollPanel";
               var4[0].icon = 24;
               Object var5 = new JDPScrollPanel(true);
               this.targetLayoutMgr.saveBranchName = null;
               this.targetLayoutMgr.checkDragNDrop(var4, var10, var5);
               JDPTreeBranch var22 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               JDPTreeBranch[] var23 = this.targetLayoutMgr.layoutTree.getTreeBranch(var22);
               JDPTreeBranch var24 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               JDPTreeBranch[] var25 = this.targetLayoutMgr.layoutTree.getTreeBranch(var22);

               for(int var26 = 0; var26 < this.screenOrderL.length; ++var26) {
                  if (this.screenOrderL[var26] >= 0 && this.panelPos[this.screenOrderL[var26]] == var21) {
                     TextField var27 = (TextField)this.componentL[this.screenOrderL[var26]];
                     if (var27 != null) {
                        int var28 = this.screenOrderL[var26];
                        String var29 = super.user.u.strip(this.columns.getItem(var28));
                        if (var29.substring(1, 2).equals("_")) {
                           var29 = var29.substring(2);
                        }

                        var4[0] = new JDPTreeBranch();
                        var4[0].name = var29 + "Label";
                        var4[0].compType = "Label";
                        var4[0].icon = 14;
                        var5 = new Label(((TextComponent)var27).getText(), 0);
                        this.targetLayoutMgr.saveBranchName = null;
                        this.targetLayoutMgr.checkDragNDrop(var4, var23, var5);
                        JDPTreeBranch var30 = this.targetLayoutMgr.lView.tree.getLastAddedBranch();
                        if (var28 < this.targetSettings.fieldLabelColor.length && !this.targetSettings.fieldLabelColor[var28].equals("Black")) {
                           this.addProp(var30, "FColor", this.targetSettings.fieldLabelColor[var28], "java.lang.String");
                           ((Label)var30.thisObject).setForeground(super.user.u._cvtcolor(this.targetSettings.fieldLabelColor[var28]));
                        }

                        Label var31 = (Label)var30.thisObject;
                        Font var32 = ((Component)var31).getFont();
                        var32 = new Font(var32.getName(), 1, var32.getSize());
                        ((Component)var31).setFont(var32);
                        var30.properties = null;
                        this.targetLayoutMgr.cMgr.setProperties(var30);
                     }
                  }

                  for(int var60 = 0; var60 < this.screenOrder[0].length; ++var60) {
                     int var62 = this.screenOrder[var26][var60];
                     if (var60 == 0) {
                        if (var62 >= 0 && this.screenOrder[var26][var60 + 1] >= 0 && this.panelPos[var62] == var21) {
                           String var69 = super.user.u.strip(this.columns.getItem(var62));
                           if (var69.substring(1, 2).equals("_")) {
                              var69 = var69.substring(2);
                           }

                           var4[0] = new JDPTreeBranch();
                           var4[0].name = var69 + "Line";
                           var4[0].compType = "Panel";
                           var4[0].icon = 24;
                           var5 = new Panel();
                           ((Panel)var5).setLayout(new JDPLineLayout(3, true));
                           this.targetLayoutMgr.saveBranchName = null;
                           this.targetLayoutMgr.checkDragNDrop(var4, var23, var5);
                           var24 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
                           var25 = this.targetLayoutMgr.layoutTree.getTreeBranch(var24);
                        } else {
                           var25 = var23;
                        }
                     }

                     if (var62 >= 0 && var62 != this.screenOrder[var26][var60 + 1] && this.panelPos[var62] == var21) {
                        String var71 = super.user.u.strip(this.columns.getItem(var62));
                        if (var71.substring(1, 2).equals("_")) {
                           var71 = var71.substring(2);
                        }

                        var4[0] = new JDPTreeBranch();
                        var4[0].name = super.user.u.strip(this.columns.getItem(var62));
                        int var81 = var62;
                        if (var62 < this.targetSettings.fieldType.length && !this.targetSettings.fieldType[var62].equals("RadioButtons")) {
                           var4[0].compType = this.targetSettings.fieldType[var62];
                           if (this.targetSettings.fieldType[var62].equals("TextField")) {
                              var4[0].icon = 15;
                              var5 = new TextField(this.columns.getItem(var62), this.getFSize(var62));
                           } else if (this.targetSettings.fieldType[var62].equals("TextArea")) {
                              var4[0].icon = 15;
                              var5 = new TextArea(this.columns.getItem(var62), Integer.parseInt(this.targetSettings.textAreaRows[var62]), this.getFSize(var62));
                           } else if (this.targetSettings.fieldType[var62].equals("JDPChoice")) {
                              var4[0].compType = "JDPChoice";
                              var4[0].icon = 20;
                              var5 = new JDPChoice();
                              if (this.targetSettings.thisChoicePanel.valuesFrom[var62].equals("Fields entered here")) {
                                 for(int var92 = 0; var92 < this.targetSettings.thisChoicePanel.textChoiceValue[var62].length; ++var92) {
                                    if (!this.targetSettings.thisChoicePanel.textChoiceValue[var62][var92].equals("")) {
                                       ((JDPChoice)var5).addItem(this.targetSettings.thisChoicePanel.textChoiceValue[var62][var92]);
                                    }
                                 }
                              } else {
                                 var7.loadChoice(var5, this.targetSettings.thisChoicePanel.textChoiceSql[var62], this.targetSettings.thisChoicePanel.columnActualList[var62], this.targetSettings.thisChoicePanel.tableList[var62], this.targetSettings.thisChoicePanel.tableWhereClause[var62], new Vector(), 12);
                              }
                           } else if (this.targetSettings.fieldType[var62].equals("JDPComboBox")) {
                              var4[0].compType = "JDPComboBox";
                              var4[0].icon = 20;
                              var5 = new JDPComboBox(super.user, this.getFSize(var62));
                              if (this.targetSettings.thisChoicePanel.valuesFrom[var62].equals("Fields entered here")) {
                                 for(int var93 = 0; var93 < this.targetSettings.thisChoicePanel.textChoiceValue[var62].length; ++var93) {
                                    if (!this.targetSettings.thisChoicePanel.textChoiceValue[var62][var93].equals("")) {
                                       ((JDPComboBox)var5).addItem(this.targetSettings.thisChoicePanel.textChoiceValue[var62][var93]);
                                    }
                                 }
                              } else {
                                 var7.loadChoice(var5, this.targetSettings.thisChoicePanel.textChoiceSql[var62], this.targetSettings.thisChoicePanel.columnActualList[var62], this.targetSettings.thisChoicePanel.tableList[var62], this.targetSettings.thisChoicePanel.tableWhereClause[var62], new Vector(), 12);
                              }
                           } else if (this.targetSettings.fieldType[var62].equals("Checkbox")) {
                              var4[0].icon = 18;
                              var5 = new Checkbox(this.targetSettings.checkboxLabel[var62]);
                           } else if (this.targetSettings.fieldType[var62].equals("JDPSpinner")) {
                              var4[0].icon = 31;
                              var5 = new JDPSpinner(super.user, this.columns.getItem(var62), this.getFSize(var62));
                           } else if (this.targetSettings.fieldType[var62].equals("JDPDate")) {
                              var4[0].icon = 37;
                              var5 = new JDPDate(super.user, this.columns.getItem(var62), this.getFSize(var62));
                           }
                        } else {
                           if (var62 >= this.targetSettings.fieldType.length) {
                              int var90 = 0;

                              for(var90 = 0; var90 < this.columns.countItems() && this.columns.getItem(var81) != null && this.columns.getItem(var90) != null && !this.columns.getItem(var81).startsWith(this.columns.getItem(var90)); ++var90) {
                              }

                              var81 = var90;
                              var4[0].name = super.user.u.replace(var4[0].name, super.user.u.strip(this.columns.getItem(var90)), this.targetSettings.actualCompName[var90]);
                           }

                           var4[0].compType = "CheckboxGroup";
                           var4[0].icon = 19;
                           var5 = new Checkbox(this.targetSettings.thisChoicePanel.textChoiceValue[var81][this.radioIndex[var62]].trim(), this.targetLayoutMgr.cbgroup[var81], true);
                        }

                        this.targetLayoutMgr.saveBranchName = null;
                        this.targetLayoutMgr.checkDragNDrop(var4, var25, var5);
                        JDPTreeBranch var94 = this.targetLayoutMgr.lView.tree.getLastAddedBranch();
                        if (var45 == null) {
                           var45 = var94;
                        }

                        if (var46 != null) {
                           this.addProp(var46, "Tab to", var94.name, "");
                           this.addProp(var94, "Back to", var46.name, "");
                        }

                        var46 = var94;
                        if (var62 >= this.targetSettings.fieldType.length || this.targetSettings.fieldType[var62].equals("JDPChoice") || this.targetSettings.fieldType[var62].equals("JDPComboBox")) {
                           var94.relatedComps = null;
                        }

                        if (var4[0].compType.equals("CheckboxGroup")) {
                           var94.properties[1][2] = "Group" + Integer.toString(var81);
                        }

                        this.addProp(var94, "Popup", this.targetSettings.mousePtrText[var81], "java.lang.String");
                        this.addProp(var94, "Status", this.targetSettings.statusBarText[var81], "java.lang.String");
                        if (!this.targetSettings.fieldTextColor[var81].equals("Black")) {
                           this.addProp(var94, "FColor", this.targetSettings.fieldTextColor[var81], "java.lang.String");
                           ((Component)var94.thisObject).setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var81]));
                        }

                        if (!this.targetSettings.fieldBackColor[var81].equals("White")) {
                           this.addProp(var94, "BColor", this.targetSettings.fieldBackColor[var81], "java.lang.String");
                           ((Component)var94.thisObject).setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var81]));
                        }

                        if (!this.targetSettings.fieldDefault[var81].equals("")) {
                           this.addProp(var94, "Dft", this.targetSettings.fieldDefault[var81], "java.lang.String");
                           if (var94.thisObject instanceof TextComponent) {
                              ((TextComponent)var94.thisObject).setText(this.targetSettings.fieldDefault[var81]);
                           }
                        }

                        if (this.targetSettings.fieldEditable[var81].equals("No")) {
                           this.addProp(var94, "Editable", "false", "boolean");
                           if (var94.thisObject instanceof TextComponent) {
                              ((TextComponent)var94.thisObject).setEditable(false);
                           }

                           if (var94.thisObject instanceof JDPDate) {
                              ((JDPDate)var94.thisObject).setEditable(false);
                              this.addProp(var94, "Enabled", "false", "boolean");
                              ((JDPDate)var94.thisObject).setEnabled(false);
                           }
                        }

                        if (var62 < this.targetSettings.fieldType.length) {
                           this.targetSettings.actualCompName[var62] = this.targetLayoutMgr.layoutTree.getLastAddedBranch().name;
                           if ((this.targetSettings.fieldType[var62].equals("TextField") || this.targetSettings.fieldType[var62].equals("TextArea") || this.targetSettings.fieldType[var62].equals("JDPComboBox") || this.targetSettings.fieldType[var62].equals("JDPSpinner")) && !this.targetSettings.fieldEditMask[var62].equals("")) {
                              JDPTreePicker var103 = this.targetLayoutMgr.interactionMgr.addEvent(var94, "KEY_RELEASE");
                              String[] var108 = new String[]{"TextField", "String"};
                              if (JDPUtils.isOdbcNum(this.target.columnDatatype[var81])) {
                                 String var34 = "JDPMaskEditMain.formatFloat(" + var94.name + ",\"" + this.targetSettings.fieldEditMask[var62] + "\");";
                                 this.targetLayoutMgr.interactionMgr.addEventEntry(var103, "KEY_RELEASE", "JDPMaskEditMain", 15, "formatFloat(TextField,String)", var108, var34);
                              } else {
                                 String var112 = "JDPMaskEditMain.formatString(" + var94.name + ",\"" + this.targetSettings.fieldEditMask[var62] + "\");";
                                 this.targetLayoutMgr.interactionMgr.addEventEntry(var103, "KEY_RELEASE", "JDPMaskEditMain", 15, "formatString(TextField,String)", var108, var112);
                              }
                           }
                        }
                     } else if (var62 >= 0 && this.panelPos[var62] == var21) {
                        String var70 = super.user.u.strip(this.columns.getItem(var62));
                        if (var70.substring(1, 2).equals("_")) {
                           var70 = var70.substring(2);
                        }

                        var4[0].name = var70 + "Label";
                        var4[0].compType = "Label";
                        var4[0].icon = 14;
                        TextField var80 = (TextField)this.componentL[var62];
                        var5 = new Label(((TextComponent)var80).getText(), 0);
                        this.targetLayoutMgr.saveBranchName = null;
                        this.targetLayoutMgr.checkDragNDrop(var4, var25, var5);
                        JDPTreeBranch var89 = this.targetLayoutMgr.lView.tree.getLastAddedBranch();
                        if (!this.targetSettings.fieldLabelColor[var62].equals("Black")) {
                           this.addProp(var89, "FColor", this.targetSettings.fieldLabelColor[var62], "java.lang.String");
                           ((Label)var89.thisObject).setForeground(super.user.u._cvtcolor(this.targetSettings.fieldLabelColor[var62]));
                        }

                        Label var102 = (Label)var89.thisObject;
                        Font var33 = ((Component)var102).getFont();
                        var33 = new Font(var33.getName(), 1, var33.getSize());
                        ((Component)var102).setFont(var33);
                        var89.properties = null;
                        this.targetLayoutMgr.cMgr.setProperties(var89);
                     }
                  }
               }
            }

            if (var46 != null && var45 != null) {
               this.addProp(var46, "Tab to", var45.name, "");
               this.addProp(var45, "Back to", var46.name, "");
            }

            if (var8 != null) {
               JDPTabSelectPanel var47 = (JDPTabSelectPanel)var8.thisObject;

               for(int var49 = 1; var49 < var8.properties[0].length; ++var49) {
                  var8.properties[0][var49] = "";
                  var8.properties[1][var49] = "";
               }

               this.addProp(var8, "# Tabs", Integer.toString(var13), "");

               for(int var50 = 0; var50 < var13; ++var50) {
                  var47.setTabname(var50, var9[var50]);
                  this.addProp(var8, "Tab#" + Integer.toString(var50), var9[var50], "");
               }

               for(int var51 = 0; var51 < var13; ++var51) {
                  this.addProp(var8, "FCol#" + Integer.toString(var51), "Black", "");
                  this.addProp(var8, "BCol#" + Integer.toString(var51), "LightGray", "");
               }

               for(int var52 = 0; var52 < var13; ++var52) {
                  this.addProp(var8, "Icon#" + Integer.toString(var52), "", "");
               }
            }

            if (var1 || var2) {
               var4[0] = new JDPTreeBranch();
               var4[0].name = "Panel";
               var4[0].compType = "Panel";
               var4[0].icon = 24;
               this.targetLayoutMgr.checkDragNDrop(var4, this.targetLayoutMgr.layoutTree.getTreeBranch(super.thisBranch.thisObject));
               var17 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            }

            JDPTreeBranch var48 = null;
            JDPTreeBranch var53 = null;
            Object var54 = null;
            if (var1 && var2) {
               this.targetLayoutMgr.setButton("Blank");
               this.targetLayoutMgr.layoutTree.addBranch(var17, super.thisBranch.name + "SP1", 7);
               ((JDPSearchLayout)var14).thisBranch = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               ((JDPSearchLayout)var14).thisBranch.compType = "JDPWhereClause";
               ((JDPSearchLayout)var14).thisBranch.compPosition = "North";
               ((JDPSearchLayout)var14).thisBranch.thisObject = new Panel();
               ((Container)super.thisBranch.thisObject).add(((JDPSearchLayout)var14).thisBranch.compPosition, (Component)((JDPSearchLayout)var14).thisBranch.thisObject);
               ((JDPSearchLayout)var14).loadLayoutComponent();
               this.targetLayoutMgr.setProperties(((JDPSearchLayout)var14).thisBranch);
               var48 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            }

            if (var2) {
               this.targetLayoutMgr.setButton("Blank");
               this.targetLayoutMgr.layoutTree.addBranch(var17, super.thisBranch.name + "RL1", 26);
               ((JDPListLayout)var15).thisBranch = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               ((JDPListLayout)var15).thisBranch.compType = "JDPSearchResults";
               ((JDPListLayout)var15).thisBranch.compPosition = "Center";
               ((JDPListLayout)var15).thisBranch.thisObject = new Panel();
               ((Container)super.thisBranch.thisObject).add(((JDPListLayout)var15).thisBranch.compPosition, (Component)((JDPListLayout)var15).thisBranch.thisObject);
               ((JDPListLayout)var15).loadLayoutComponent();
               this.targetLayoutMgr.setProperties(((JDPListLayout)var15).thisBranch);
               var53 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
            }

            if (var3) {
               var4[0] = new JDPTreeBranch();
               var4[0].name = super.thisBranch.name + "GL1";
               var4[0].compType = "JDPGridLayout";
               var4[0].icon = 27;
               JDPGridLayout var40 = new JDPGridLayout();
               ((JDPClassLayout)var40).InitClass(super.user, (Panel)var11[var11.length - 1].thisObject, "JDPLayoutMgr:" + super.componentName);
               ((JDPGridLayout)var40).loadLayoutComponent();
               this.targetLayoutMgr.checkDragNDrop(var4, var11, var40);
               this.targetLayoutMgr.gSource.targetGenerator.setHandle((JDPClassLayout)var40);
            }

            if (super.thisBranch.compType.startsWith("JDPWiz")) {
               var4[0] = new JDPTreeBranch();
               var4[0].name = "Panel";
               var4[0].compType = "Panel";
               var4[0].icon = 24;
               Panel var41 = new Panel();
               this.targetLayoutMgr.checkDragNDrop(var4, var11, var41);
               JDPTreeBranch var61 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               var4[0] = new JDPTreeBranch();
               var4[0].name = "JDPButtons";
               var4[0].compType = "JDPButtons";
               var4[0].icon = 17;
               JDPButtons var42;
               String[] var57;
               String[] var58;
               String[] var59;
               if (this.targetLayoutMgr.loadingWizardApp) {
                  int var63 = 0;
                  if (this.targetLayoutMgr.wizAllowInserts.equals("Yes")) {
                     ++var63;
                  }

                  if (this.targetLayoutMgr.wizAllowUpdates.equals("Yes")) {
                     ++var63;
                  }

                  if (this.targetLayoutMgr.wizAllowDeletes.equals("Yes")) {
                     ++var63;
                  }

                  String[] var73 = new String[var63];
                  int[] var82 = new int[var63];
                  var58 = new String[var63];
                  var59 = new String[var63];
                  var63 = 0;
                  if (this.targetLayoutMgr.wizAllowUpdates.equals("Yes")) {
                     var73[var63] = "Apply";
                     if (var3) {
                        var58[var63] = "UpdateRows";
                     } else {
                        var58[var63] = "updateRow";
                     }

                     var59[var63] = super.thisBranch.name + "RL1.getSelectedKey()";
                     var82[var63++] = 0;
                  }

                  if (this.targetLayoutMgr.wizAllowInserts.equals("Yes")) {
                     var73[var63] = "Add";
                     if (var2) {
                        if (var3) {
                           var58[var63] = "LoadGrid";
                        } else {
                           var58[var63] = "insertRow";
                        }

                        var59[var63] = super.thisBranch.name + "RL1.getSelectedKey()";
                     } else {
                        var73[var63] = "Submit";
                        var58[var63] = "insertRow";
                        var59[var63] = "null";
                     }

                     var82[var63++] = 9;
                  }

                  if (this.targetLayoutMgr.wizAllowDeletes.equals("Yes")) {
                     var73[var63] = "Remove";
                     if (var3) {
                        var58[var63] = "DeleteRows";
                     } else {
                        var58[var63] = "removeRow";
                     }

                     var59[var63] = super.thisBranch.name + "RL1.getSelectedKey()";
                     var82[var63++] = 8;
                  }

                  var42 = new JDPButtons(super.user, var73, var82, JDPButtons.HORIZONTAL);
                  var57 = var73;
               } else if (var3) {
                  String[] var66 = new String[]{"Apply", "Refresh", "Remove"};
                  int[] var74 = new int[]{0, 6, 8};
                  var42 = new JDPButtons(super.user, var66, var74, JDPButtons.HORIZONTAL);
                  var57 = var66;
                  String[] var83 = new String[]{"UpdateRows", "LoadGrid", "DeleteRows"};
                  var58 = var83;
                  String[] var95 = new String[]{super.thisBranch.name + "RL1.getSelectedKey()", super.thisBranch.name + "RL1.getSelectedKey()", super.thisBranch.name + "RL1.getSelectedKey()"};
                  var59 = var95;
               } else if (var2) {
                  String[] var67 = new String[]{"Apply", "Add", "Remove"};
                  int[] var75 = new int[]{0, 9, 8};
                  var42 = new JDPButtons(super.user, var67, var75, JDPButtons.HORIZONTAL);
                  var57 = var67;
                  String[] var84 = new String[]{"updateRow", "insertRow", "removeRow"};
                  var58 = var84;
                  String[] var96 = new String[]{super.thisBranch.name + "RL1.getSelectedKey()", super.thisBranch.name + "RL1.getSelectedKey()", super.thisBranch.name + "RL1.getSelectedKey()"};
                  var59 = var96;
               } else {
                  String[] var68 = new String[]{"Submit"};
                  int[] var76 = new int[]{0};
                  var42 = new JDPButtons(super.user, var68, var76, JDPButtons.HORIZONTAL);
                  var57 = var68;
                  String[] var85 = new String[]{"insertRow"};
                  var58 = var85;
                  String[] var97 = new String[]{"null"};
                  var59 = var97;
               }

               this.targetLayoutMgr.checkDragNDrop(var4, var11, var42);
               JDPTreeBranch var55 = this.targetLayoutMgr.layoutTree.getLastAddedBranch();
               this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var61));
               this.targetLayoutMgr.lView.removeSelectedLeaf();
               if (var53 != null) {
                  var53.treeVector = new Vector();
                  JDPTreePicker var77 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
                  int[] var86 = new int[]{4, 1, 2, 1};
                  var77.setIcons(var86);
                  var77.setRoot("Component Events", true);
                  JDPTreeBranch var98 = var77.treeRoot;
                  Object[] var104 = new Object[]{null, "Methods"};
                  String[] var109 = new String[]{null, "Drop here to attach this component/method to this Event"};
                  var77.setDropKeys(var104);
                  var77.setDragAndDrop((boolean[])null);
                  var77.setDropMessages(var109);
                  String[] var113 = new String[]{"ACTION_EVENT", null, null, null};
                  boolean[] var35 = new boolean[]{true, true, true, false};
                  var77.setIcons(var86);
                  var77.setExpanded(var35);
                  var77.addEntry(var113, var86, var113[0]);
                  var53.treeVector.addElement(var98);
                  var86[2] = super.thisBranch.icon;
                  var113[1] = super.thisBranch.name;
                  var113[2] = super.thisBranch.name + "Load";
                  var77.addEntry(var113, var86, var113[2]);
                  JDPTreeBranch var36 = var77.getLastAddedBranch();
                  var36.text = new String[1];
                  var36.text[0] = var113[2] + "(" + super.thisBranch.name + "RL1.getSelectedKey());";
                  String[] var37 = new String[]{"String[]"};
                  this.loadParameters(var36, var37);
                  if (var3) {
                     var113[2] = super.thisBranch.name + "LoadGrid";
                     var77.addEntry(var113, var86, var113[2]);
                     var36 = var77.getLastAddedBranch();
                     var36.text = new String[1];
                     var36.text[0] = var113[2] + "(" + super.thisBranch.name + "RL1.getSelectedKey());";
                     this.loadParameters(var36, var37);
                  }
               }

               if (var48 != null && var53 != null) {
                  var48.treeVector = new Vector();
                  JDPTreePicker var78 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
                  int[] var87 = new int[]{4, 1, 2, 1};
                  var78.setIcons(var87);
                  var78.setRoot("Component Events", true);
                  JDPTreeBranch var99 = var78.treeRoot;
                  Object[] var105 = new Object[]{null, "Methods"};
                  String[] var110 = new String[]{null, "Drop here to attach this component/method to this Event"};
                  var78.setDropKeys(var105);
                  var78.setDragAndDrop((boolean[])null);
                  var78.setDropMessages(var110);
                  String[] var114 = new String[]{"ACTION_EVENT", null, null, null};
                  boolean[] var116 = new boolean[]{true, true, true, false};
                  var78.setIcons(var87);
                  var78.setExpanded(var116);
                  var78.addEntry(var114, var87, var114[0]);
                  var48.treeVector.addElement(var99);
                  var87[2] = var53.icon;
                  var114[1] = super.thisBranch.name + "RL1";
                  var114[2] = "clearList()";
                  var78.addEntry(var114, var87, var114[2]);
                  JDPTreeBranch var119 = var78.getLastAddedBranch();
                  var119.text = new String[1];
                  var119.text[0] = var114[1] + "." + var114[2] + ";";
                  String[] var123 = new String[0];
                  this.loadParameters(var119, var123);
                  var114[2] = "setFromWhereClause(String)";
                  var78.addEntry(var114, var87, var114[2]);
                  var119 = var78.getLastAddedBranch();
                  var119.text = new String[1];
                  var119.text[0] = var114[1] + ".setFromWhereClause(" + super.thisBranch.name + "SP1.getFromWhereClause());";
                  String[] var38 = new String[]{"String"};
                  this.loadParameters(var119, var38);
                  var114[2] = "loadList()";
                  var78.addEntry(var114, var87, var114[2]);
                  var119 = var78.getLastAddedBranch();
                  var119.text = new String[1];
                  var119.text[0] = var114[1] + "." + var114[2] + ";";
                  this.loadParameters(var119, var123);
               }

               byte var79 = 3;
               if (var53 == null && !var3) {
                  var79 = 1;
               }

               var55.treeVector = new Vector();
               JDPTreePicker var88 = new JDPTreePicker(super.user, this.targetLayoutMgr, this.targetLayoutMgr.dragPanel);
               int[] var100 = new int[]{4, 1, 2, 1};
               var88.setIcons(var100);
               var88.setRoot("Component Events", true);
               JDPTreeBranch var106 = var88.treeRoot;
               Object[] var111 = new Object[]{null, "Methods"};
               String[] var115 = new String[]{null, "Drop here to attach this component/method to this Event"};
               var88.setDropKeys(var111);
               var88.setDragAndDrop((boolean[])null);
               var88.setDropMessages(var115);
               String[] var117 = new String[]{null, null, null, null};
               boolean[] var122 = new boolean[]{true, true, true, false};

               for(int var124 = 0; var124 < var79; ++var124) {
                  var117[0] = "ACTION_BTN_" + Integer.toString(var124);
                  var88.setIcons(var100);
                  var88.setExpanded(var122);
                  var88.addEntry(var117, var100, "ACTION_BTN_" + Integer.toString(var124));
               }

               var55.treeVector.addElement(var106);

               for(int var125 = 0; var125 < var57.length; ++var125) {
                  var117[0] = "ACTION_BTN_" + Integer.toString(var125);
                  var100[2] = super.thisBranch.icon;
                  var117[1] = super.thisBranch.name;
                  var117[2] = super.thisBranch.name + var58[var125];
                  var88.addEntry(var117, var100, var117[2]);
                  JDPTreeBranch var126 = var88.getLastAddedBranch();
                  var126.text = new String[1];
                  var126.text[0] = var117[2] + "(" + var59[var125] + ");";
                  if ((var58[var125].equals("DeleteRows") || var58[var125].equals("removeRow")) && this.targetLayoutMgr.loadingWizardApp && this.targetLayoutMgr.wizConfirmDeletes.equals("Yes")) {
                     var126.text[0] = "String removeMsg = \"Press again to confirm removal\";\r\nif (user.mainmsg.getStatusMsg().equals(removeMsg)) {\r\n\t" + var126.text[0];
                     String[] var10000 = var126.text;
                     var10000[0] = var10000[0] + "\r\n} else {\r\n\tuser.mainmsg.setStatusMsg(removeMsg,15);\r\n}\r\n";
                  }

                  String[] var39 = new String[]{"String[]"};
                  this.loadParameters(var126, var39);
               }
            }

            this.targetLayoutMgr.projectLoading = var44;
            var12.expanded = false;
            this.targetLayoutMgr.setProperties(var12);
            if (var12.thisObject instanceof Component) {
               ((Component)var12.thisObject).layout();
               ((Component)var12.thisObject).paintAll(((Component)var12.thisObject).getGraphics());
            }

            this.targetLayoutMgr.interactionMgr.loadMethodTree(var12, false);
            this.targetLayoutMgr.currentBranch = super.thisBranch;
            this.targetLayoutMgr.gSource.constructMethod(super.thisBranch, "Main");
            if (!this.targetLayoutMgr.projectLoading) {
               this.targetLayoutMgr.setButton("Blank");
               this.targetLayoutMgr.layoutTree.select(this.targetLayoutMgr.layoutTree.getTreeBranchNames(var12));
               if (var14 != null || var15 != null) {
                  this.targetLayoutMgr.refreshLayout(super.thisBranch);
               }

               this.targetLayoutMgr.setButton("Layout");
               this.targetLayoutMgr.reDraw();
            }
         }
      }

   }

   void clearMainPanel() {
      if (this.centerTopPanel != null) {
         for(int var1 = 0; var1 < this.centerTopPanel.length; ++var1) {
            this.centerTopPanel[var1].removeAll();
         }
      }

      this.centerMainPanel.layout();
      this.centerMainPanel.paintAll(this.centerMainPanel.getGraphics());
   }

   void setupTabs() {
      this.cPanel = 0;
      if (this.targetSettings != null && this.targetSettings.useTabs.getSelectedItem().equals("Yes")) {
         if (this.targetSettings.tabNames.getText().equals(this.prevTabs)) {
            return;
         }

         this.centerTopWrapPanel.removeAll();
         this.prevTabs = this.targetSettings.tabNames.getText();
         StringTokenizer var1 = new StringTokenizer(this.targetSettings.tabNames.getText(), "\n");
         String[] var2 = new String[50];

         int var3;
         for(var3 = 0; var1.hasMoreTokens(); var2[var3++] = var1.nextToken().trim()) {
         }

         this.titles = new String[var3];
         this.centerTopPanel = new JDPScrollPanel[var3];

         for(int var4 = 0; var4 < var3; ++var4) {
            this.titles[var4] = var2[var4];
            this.centerTopPanel[var4] = new JDPScrollPanel();
         }

         this.tabPanel = new JDPTabSelectPanel(super.user, this.titles, this.centerTopPanel, "North");
         this.centerTopWrapPanel.add("Center", this.tabPanel);
      } else {
         this.prevTabs = "";
         this.centerTopWrapPanel.removeAll();
         this.centerTopPanel = new JDPScrollPanel[1];
         this.centerTopPanel[0] = new JDPScrollPanel();
         this.centerTopWrapPanel.add("Center", this.centerTopPanel[0]);
      }

      this.centerMainPanel.layout();
      this.centerMainPanel.paintAll(this.centerMainPanel.getGraphics());
   }

   void removeItem(int var1) {
      boolean var2 = false;
      boolean var3 = false;

      for(int var7 = 0; var7 <= this.lastLine; ++var7) {
         for(int var8 = this.maxcolumns - 1; var8 >= 0; --var8) {
            if (this.screenOrder[var7][var8] == var1) {
               this.fieldRLine[var7].remove(this.component[var1]);
               if (this.componentL[var1] != null) {
                  this.fieldRLine[var7].remove(this.componentL[var1]);
               }

               if (this.fieldRLine[var7].countComponents() == 0) {
                  if (this.componentL[var1] != null && this.fieldLLine[var7] != null) {
                     this.fieldLLine[var7].remove(this.componentL[var1]);
                  }

                  this.centerTopPanel[this.cPanel].remove(this.fieldLLine[var7]);
                  this.centerTopPanel[this.cPanel].remove(this.fieldRLine[var7]);

                  for(int var9 = var7 + 1; var9 <= this.lastLine; ++var9) {
                     for(int var5 = 0; var5 < this.maxcolumns; ++var5) {
                        this.screenOrder[var9 - 1][var5] = this.screenOrder[var9][var5];
                     }

                     this.screenOrderL[var9 - 1] = this.screenOrderL[var9];
                     this.fieldLLine[var9 - 1] = this.fieldLLine[var9];
                     this.fieldRLine[var9 - 1] = this.fieldRLine[var9];
                  }

                  this.screenOrderL[this.lastLine] = -2;

                  for(int var10 = 0; var10 < this.maxcolumns; ++var10) {
                     try {
                        this.screenOrder[this.lastLine][var10] = -2;
                     } catch (Exception var6) {
                        break;
                     }
                  }

                  this.lastLine += -1;
                  this.lastItem = 0;
                  if (this.lastLine >= 0) {
                     this.lastItem = this.fieldRLine[this.lastLine].countComponents() - 1;
                  }
               } else {
                  for(int var4 = var8; var4 < this.maxcolumns - 1; ++var4) {
                     this.screenOrder[var7][var4] = this.screenOrder[var7][var4 + 1];
                  }

                  this.lastItem += -1;
               }
            }
         }
      }

      for(int var11 = 0; var11 < this.centerTopPanel.length; ++var11) {
         this.centerTopPanel[var11].layout();
         this.centerTopPanel[var11].paintAll(this.centerTopPanel[this.cPanel].getGraphics());
      }

      if (this.tabPanel != null) {
         this.tabPanel.layout();
      }

      if (this.tabPanel != null) {
         this.tabPanel.paintAll(this.tabPanel.getGraphics());
      }

      this.centerTopWrapPanel.layout();
      this.centerMainPanel.layout();
      this.centerMainPanel.paintAll(this.centerMainPanel.getGraphics());
   }

   void addProp(JDPTreeBranch var1, String var2, String var3, String var4) {
      int var5;
      for(var5 = 0; var5 < var1.properties[0].length && !var1.properties[0][var5].equals(var2 + ":") && (!var1.properties[0][var5].equals("") || !var1.properties[1][var5].equals("")); ++var5) {
      }

      if (var5 >= var1.properties[0].length) {
         String[][] var6 = var1.properties;
         var1.properties = new String[3][var1.properties[0].length + 1];

         for(int var7 = 0; var7 < var6[0].length; ++var7) {
            var1.properties[0][var7] = var6[0][var7];
            var1.properties[1][var7] = var6[1][var7];
            var1.properties[2][var7] = var6[2][var7];
         }
      }

      var1.properties[0][var5] = var2 + ":";
      var1.properties[1][var5] = var3;
      var1.properties[2][var5] = var4;
   }

   void loadParameters(JDPTreeBranch var1, String[] var2) {
      this.targetLayoutMgr.interactionMgr.loadParameterTree(var1, var2);
   }

   void resetSelections() {
      this.addChoice.select(0);
      if (this.columns != null && this.screenOrder != null) {
         for(int var1 = 0; var1 < this.maxfields; ++var1) {
            this.screenOrderL[var1] = -2;

            for(int var2 = 0; var2 < this.maxcolumns; ++var2) {
               this.screenOrder[var1][var2] = -2;
            }
         }

         for(int var3 = 0; var3 < this.columns.countItems(); ++var3) {
            this.columns.deselect(var3);
         }

         this.clearMainPanel();
         this.lastLine = -1;
         this.lastItem = 0;

         for(int var4 = 0; var4 < this.centerTopPanel.length; ++var4) {
            this.centerTopPanel[var4].layout();
            this.centerTopPanel[var4].paintAll(this.centerTopPanel[this.cPanel].getGraphics());
         }

         if (this.tabPanel != null) {
            this.tabPanel.layout();
         }

         if (this.tabPanel != null) {
            this.tabPanel.paintAll(this.tabPanel.getGraphics());
         }

         this.centerTopWrapPanel.layout();
         this.centerMainPanel.layout();
         this.centerMainPanel.paintAll(this.centerMainPanel.getGraphics());
         this.saveSelections();
      }
   }

   int getFSize(int var1) {
      int var2 = 10;
      int var3 = -1;
      String var4 = "-1";

      try {
         var3 = this.columnIndexes[var1];
         var4 = this.target.columnLength[var3];
         var2 = Integer.parseInt(var4);
      } catch (Exception var7) {
         System.out.println("Indexing error: " + var1 + " " + this.target.columns.countItems() + " " + this.columnIndexes.length + " " + this.target.columnLength.length + " " + var3 + " " + var4);
         ((Throwable)var7).printStackTrace();
      }

      return var2;
   }

   int getThisIcon(int var1) {
      byte var2 = 8;
      if (this.targetSettings != null && this.targetSettings.fieldType != null) {
         if (var1 >= this.targetSettings.fieldType.length) {
            return var2;
         } else {
            if (!this.targetSettings.fieldType[var1].equals("JDPChoice") && !this.targetSettings.fieldType[var1].equals("JDPComboBox")) {
               if (this.targetSettings.fieldType[var1].equals("JDPSpinner")) {
                  var2 = 31;
               } else if (this.targetSettings.fieldType[var1].equals("JDPDate")) {
                  var2 = 37;
               } else if (!this.targetSettings.fieldType[var1].equals("TextField") && !this.targetSettings.fieldType[var1].equals("TextArea")) {
                  if (this.targetSettings.fieldType[var1].equals("RadioButtons")) {
                     var2 = 19;
                  } else if (this.targetSettings.fieldType[var1].equals("Checkbox")) {
                     var2 = 18;
                  } else if (this.targetSettings.fieldType[var1].equals("TextField")) {
                     var2 = 15;
                  }
               } else {
                  var2 = 15;
               }
            } else {
               var2 = 20;
            }

            return var2;
         }
      } else {
         return var2;
      }
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPScreenLayout" + super.componentName;
      if (this.componentL != null) {
         for(int var3 = 0; var3 < this.componentL.length; ++var3) {
            TextField var4 = (TextField)this.componentL[var3];
            if (var4 != null) {
               this.fieldLabel[var3] = ((TextComponent)var4).getText();
            }
         }
      } else {
         this.fieldLabel = new String[0];
      }

      if (this.screenOrderL == null) {
         return true;
      } else {
         int[] var5 = new int[this.lastLine + 1];
         System.arraycopy(this.screenOrderL, 0, var5, 0, this.lastLine + 1);
         int[][] var6 = new int[this.lastLine + 1][this.screenOrder[0].length];
         System.arraycopy(this.screenOrder, 0, var6, 0, this.lastLine + 1);
         var1.saveObject(this.columns, var2, "columns");
         var1.saveObject(var5, var2, "screenOrderL");
         var1.saveObject(var6, var2, "screenOrder");
         var1.saveObject(this.fieldLabel, var2, "fieldLabel");
         var1.saveObject(this.panelPos, var2, "panelPos");
         var1.saveObject(this.radioIndex, var2, "radioIndex");
         if (this.targetGrid != null) {
            this.targetGrid.saveSelections();
         }

         return true;
      }
   }

   void refresh() {
      this.lastLine = -1;
      this.lastItem = 0;
      this.retrieveColumns();
      this.loadList();
      this.setupTabs();
      this.restoreSelections();
   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("ScreenSettings" + super.componentName) == 0) {
               this.targetSettings = (JDPScreenSettings)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            if (var1.target instanceof JDPTabSelectPanel) {
               if (var1.target.equals(this.tabPanel)) {
                  this.cPanel = this.tabPanel.getSelectedIndex();
                  if (this.cPanel >= this.centerTopPanel.length) {
                     this.cPanel = 0;
                  }
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
         case 702:
            if (var1.target instanceof JDPList) {
               String var4 = var1.arg.toString();
               int var5 = Integer.parseInt(var4);
               if (this.columns.isSelected(var5)) {
                  this.loadItem(var5);
               }

               if (!this.columns.isSelected(var5)) {
                  this.removeItem(var5);
               }

               return true;
            }

            return true;
         case 1001:
            if (var1.target instanceof TextField) {
               return true;
            } else if (var1.target instanceof JDPComboBox) {
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Accept") == 0) {
                     this.saveSelections();
                     super.user.mainmsg.setStatusMsg("Selections accepted.", 10);
                     if (super.componentName.equals("")) {
                        super.user.jdpMenuPanel.loadNextTab();
                     }

                     this.loadLayoutComponent();
                     return true;
                  }

                  if (var2.trim().compareTo("Reset") == 0) {
                     String var3 = "Press again to clear all components from the layout";
                     if (super.user.mainmsg.getStatusMsg().equals(var3)) {
                        this.resetSelections();
                     } else {
                        super.user.mainmsg.setStatusMsg(var3, 10);
                     }

                     return true;
                  }
               }

               return true;
            }
         default:
            return false;
      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPScreenLayout" + super.componentName;
      var1.removeObject(this.columns, var2, "columns");
      var1.removeObject(this.screenOrderL, var2, "screenOrderL");
      var1.removeObject(this.screenOrder, var2, "screenOrder");
      var1.removeObject(this.fieldLabel, var2, "fieldLabel");
      var1.removeObject(this.panelPos, var2, "panelPos");
      var1.removeObject(this.radioIndex, var2, "radioIndex");
      this.componentL = null;
      if (this.targetGrid != null) {
         this.targetGrid.removeSelections();
      }

      return true;
   }

   void loadItem(int var1) {
      for(int var2 = 0; var2 <= this.lastLine; ++var2) {
         for(int var3 = 0; var3 <= this.lastItem; ++var3) {
            if (this.screenOrder[var2][var3] == var1 || this.screenOrderL[var2] == var1) {
               return;
            }
         }
      }

      if (this.addChoice.getSelectedItem().compareTo("Append to line") != 0) {
         if (this.fieldLabel[var1] == null) {
            this.fieldLabel[var1] = "";
         }

         this.componentL[var1] = new TextField(this.fieldLabel[var1], this.fieldLabel[var1].length());
         if (this.targetSettings.fieldLabelColor != null && var1 < this.targetSettings.fieldLabelColor.length) {
            this.componentL[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldLabelColor[var1]));
         }

         Color var4 = ((Component)this).getBackground();
         if (var4 == null) {
            var4 = this.targetPanel.getBackground();
         }

         if (var4 == null) {
            var4 = JDPUtils.getControlColor();
         }

         this.componentL[var1].setBackground(JDPUtils.darker(var4));
         this.componentL[var1].setFont(super.user.boldFont);
      }

      if (var1 < this.targetSettings.fieldType.length && this.targetSettings.fieldType[var1].compareTo("RadioButtons") != 0) {
         if (this.targetSettings.fieldType[var1].compareTo("TextField") == 0) {
            this.component[var1] = new TextField(this.columns.getItem(var1), this.getFSize(var1));
            TextField var6 = (TextField)this.component[var1];
            ((TextComponent)var6).setEditable(false);
            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            this.component[var1].setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var1]));
         } else if (this.targetSettings.fieldType[var1].compareTo("TextArea") == 0) {
            this.component[var1] = new TextArea(this.columns.getItem(var1), Integer.parseInt(this.targetSettings.textAreaRows[var1]), this.getFSize(var1));
            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            if (!this.targetSettings.fieldBackColor[var1].equals("White")) {
               this.component[var1].setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var1]));
            }
         } else if (this.targetSettings.fieldType[var1].compareTo("JDPChoice") == 0) {
            this.component[var1] = new JDPChoice();
            JDPChoice var7 = (JDPChoice)this.component[var1];
            if (this.targetSettings.thisChoicePanel.valuesFrom[var1].compareTo("Fields entered here") == 0) {
               for(int var11 = 0; var11 < JDPChoiceLayout.maxChoices; ++var11) {
                  if (this.targetSettings.thisChoicePanel.textChoiceValue[var1][var11] != null && this.targetSettings.thisChoicePanel.textChoiceValue[var1][var11].length() > 0 && this.targetSettings.thisChoicePanel.actualChoiceValue[var1][var11].length() > 0) {
                     var7.addItem(this.targetSettings.thisChoicePanel.textChoiceValue[var1][var11].trim());
                  }
               }
            } else if (this.targetSettings.thisChoicePanel.valuesFrom[var1].compareTo("Database table/columns") == 0) {
               var7.addItem("Values from " + this.targetSettings.thisChoicePanel.tableList[var1]);
            }

            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            if (!this.targetSettings.fieldBackColor[var1].equals("White")) {
               this.component[var1].setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var1]));
            }
         } else if (this.targetSettings.fieldType[var1].compareTo("JDPComboBox") == 0) {
            this.component[var1] = new JDPComboBox(super.user, "", this.getFSize(var1));
            JDPComboBox var8 = (JDPComboBox)this.component[var1];
            if (this.targetSettings.thisChoicePanel.valuesFrom[var1].compareTo("Fields entered here") == 0) {
               for(int var12 = 0; var12 < JDPChoiceLayout.maxChoices; ++var12) {
                  if (this.targetSettings.thisChoicePanel.textChoiceValue[var1][var12] != null && this.targetSettings.thisChoicePanel.textChoiceValue[var1][var12].trim().length() > 0) {
                     var8.addItem(this.targetSettings.thisChoicePanel.textChoiceValue[var1][var12].trim());
                  }
               }
            } else if (this.targetSettings.thisChoicePanel.valuesFrom[var1].compareTo("Database table/columns") == 0) {
               var8.addItem("Values from " + this.targetSettings.thisChoicePanel.tableList[var1]);
            }

            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            if (!this.targetSettings.fieldBackColor[var1].equals("White")) {
               this.component[var1].setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var1]));
            }
         } else if (this.targetSettings.fieldType[var1].compareTo("Checkbox") == 0) {
            this.component[var1] = new Checkbox(this.targetSettings.checkboxLabel[var1]);
            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            this.component[var1].setFont(super.user.boldFont);
         } else if (this.targetSettings.fieldType[var1].compareTo("JDPSpinner") == 0) {
            this.component[var1] = new JDPSpinner(super.user, this.columns.getItem(var1), this.getFSize(var1));
            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            this.component[var1].setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var1]));
         } else if (this.targetSettings.fieldType[var1].compareTo("JDPDate") == 0) {
            this.component[var1] = new JDPDate(super.user, this.columns.getItem(var1), this.getFSize(var1));
            this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var1]));
            if (!this.targetSettings.fieldBackColor[var1].equals("White")) {
               this.component[var1].setBackground(super.user.u._cvtcolor(this.targetSettings.fieldBackColor[var1]));
            }
         }
      } else {
         int var5 = var1;
         if (var1 >= this.targetSettings.fieldType.length) {
            int var9 = 0;

            for(var9 = 0; var9 < this.columns.countItems() && this.columns.getItem(var1) != null && this.columns.getItem(var9) != null && !this.columns.getItem(var1).startsWith(this.columns.getItem(var9)); ++var9) {
            }

            var5 = var9;
         }

         if (this.cbgroup == null) {
            this.cbgroup = new CheckboxGroup[this.columns.countItems()];
         }

         if (this.cbgroup[var5] == null) {
            this.cbgroup[var5] = new CheckboxGroup();
         }

         this.component[var1] = new Checkbox(this.targetSettings.thisChoicePanel.textChoiceValue[var5][this.radioIndex[var1]].trim(), this.cbgroup[var5], true);
         this.component[var1].setForeground(super.user.u._cvtcolor(this.targetSettings.fieldTextColor[var5]));
         this.component[var1].setFont(super.user.boldFont);
      }

      if (this.lastLine == -1) {
         this.addChoice.select(0);
      }

      if (this.addChoice.getSelectedItem().compareTo("Add on a new line") == 0) {
         this.lastItem = 0;
         ++this.lastLine;
         this.screenOrderL[this.lastLine] = var1;
         this.screenOrder[this.lastLine][this.lastItem] = var1;
         this.fieldLLine[this.lastLine] = new Panel();
         this.fieldRLine[this.lastLine] = new Panel();
         this.fieldLLine[this.lastLine].setLayout(new JDPLineLayout(3));
         this.fieldRLine[this.lastLine].setLayout(new JDPLineLayout(3));
         this.fieldLLine[this.lastLine].add("Left", this.componentL[var1]);
         this.fieldRLine[this.lastLine].add("Left", this.component[var1]);
         if (this.cPanel >= this.centerTopPanel.length) {
            this.cPanel = 0;
         }

         this.centerTopPanel[this.cPanel].add("Left", this.fieldLLine[this.lastLine]);
         this.centerTopPanel[this.cPanel].add("Right", this.fieldRLine[this.lastLine]);
      } else if (this.addChoice.getSelectedItem().compareTo("Append to line") == 0 && this.lastLine >= 0) {
         ++this.lastItem;
         this.screenOrder[this.lastLine][this.lastItem] = var1;
         this.fieldRLine[this.lastLine].add("Left", this.component[var1]);
      } else if (this.addChoice.getSelectedItem().compareTo("Append to line with Label") == 0 && this.lastLine >= 0) {
         ++this.lastItem;
         this.screenOrder[this.lastLine][this.lastItem] = var1;
         this.fieldRLine[this.lastLine].add("Left", this.componentL[var1]);
         ++this.lastItem;
         this.screenOrder[this.lastLine][this.lastItem] = var1;
         this.fieldRLine[this.lastLine].add("Left", this.component[var1]);
      }

      this.panelPos[var1] = this.cPanel;
      this.centerTopPanel[this.cPanel].layout();
      this.centerTopPanel[this.cPanel].paintAll(this.centerTopPanel[this.cPanel].getGraphics());
      if (this.tabPanel != null) {
         this.tabPanel.layout();
      }

      if (this.tabPanel != null) {
         this.tabPanel.paintAll(this.tabPanel.getGraphics());
      }

      this.centerTopWrapPanel.layout();
      this.centerMainPanel.layout();
      this.centerMainPanel.paintAll(this.centerMainPanel.getGraphics());
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.targetPanel = var2;
      this.moduleParameter = var3;
      super.moduleName = "ScreenLayout";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
         this.moduleParameter = "";
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      this.centerMainPanel = new Panel();
      if (var3.equals("Combo")) {
         this.centerMainPanel.setLayout(new GridLayout(2, 1, 1, 1));
      } else {
         this.centerMainPanel.setLayout(new BorderLayout());
      }

      this.centerTopWrapPanel = new Panel();
      this.centerTopWrapPanel.setLayout(new BorderLayout());
      ((Container)var4).add("Center", this.centerMainPanel);
      this.columns = new JDPList(var1);
      this.columns.allowMultipleSelections(true);
      this.columns.setMinWidth(160);
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      ((Container)var6).add("Center", this.columns);
      ((Container)var4).add("West", var6);
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout(4, 1));
      ((Container)var7).add("West", new Label("Total Columns:", 0));
      this.listCount = new Label("0      ", 0);
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout(4, 1));
      ((Container)var8).add("West", this.listCount);
      ((Container)var8).add("Center", new Label(" ", 0));
      ((Container)var7).add("Center", var8);
      ((Container)var6).add("North", var7);
      this.addChoice = new JDPComboBox(var1, "", 10);
      this.addChoice.setEditable(false);
      this.addChoice.addItem("Add on a new line");
      this.addChoice.addItem("Append to line");
      this.addChoice.addItem("Append to line with Label");
      ((Container)var6).add("South", this.addChoice);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Construct the screen layout", var4, "North"));
      String[] var9 = new String[]{"Accept", "Reset"};
      int[] var10 = new int[]{5, 6};
      JDPButtons var11 = new JDPButtons(var1, var9, var10, JDPButtons.HORIZONTAL);
      if (var3.equals("Combo")) {
         this.gridPanel = new Panel();
         this.gridPanel.setLayout(new BorderLayout(1, 2));
         this.targetGrid = new JDPGridLayout();
         this.targetGrid.InitClass(var1, this.gridPanel, "Combo");
         this.gridPanel.add("Center", this.targetGrid);
         this.gridPanel.add("South", var11);
         this.centerMainPanel.add(this.centerTopWrapPanel);
         this.centerMainPanel.add(this.gridPanel);
      } else {
         this.centerMainPanel.add("Center", this.centerTopWrapPanel);
         this.centerMainPanel.add("South", var11);
      }

      this.popuppanel.addComponent(var11.button[0], "Accept Selections", "Accept selections and proceed to next screen");
      this.popuppanel.addComponent(var11.button[1], "Reset Selections", "Reset selections back to default settings");
      this.gParmObject = new Vector();
      this.gParmObject.addElement(super.moduleName + super.componentName);
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
