import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.util.Vector;

public class JDPScreenSettings extends JDPClassLayout {
   JDPSelectDSN targetDSN;
   JDPSelectColumns target;
   JDPLayoutMgr targetLayoutMgr;
   String moduleParameter;
   JDPSelectTable tableTarget;
   JDPScreenLayout targetScreen;
   Panel targetPanel;
   JDPPopupMessage popuppanel;
   JDPChoiceLayout thisChoicePanel;
   Panel centerMainPanel;
   Panel centerTopPanel;
   int[] columnIndexes;
   Panel cardPanel;
   Panel rowSizePanel;
   Label sizeLabel;
   JDPList columns;
   JDPComboBox fieldtype;
   TextField fieldsql;
   JDPComboBox includeinupdatesql;
   TextField mouseptrtext;
   TextField statusbartext;
   TextField fieldsize;
   TextField textarearows;
   JDPComboBox fieldeditable;
   JDPComboBox fieldlabelcolor;
   JDPComboBox fieldtextcolor;
   JDPComboBox fieldbackcolor;
   JDPComboBox fielddefault;
   JDPComboBox fieldrequired;
   TextField fielderrormsg;
   JDPComboBox fieldeditmask;
   TextField checkedvalue;
   TextField uncheckedvalue;
   TextField checkboxlabel;
   JDPComboBox useTabs;
   TextArea tabNames;
   String prevTabs = "";
   JDPComboBox lockingColumn;
   JDPRichText lockingText;
   Label listCount;
   String[] fieldType;
   String[] fieldSql;
   String[] includeInUpdateSql;
   String[] mousePtrText;
   String[] statusBarText;
   String[] textAreaRows;
   String[] fieldEditable;
   String[] fieldLabelColor;
   String[] fieldTextColor;
   String[] fieldBackColor;
   String[] fieldDefault;
   String[] fieldRequired;
   String[] fieldErrorMsg;
   String[] fieldEditMask;
   String[] checkedValue;
   String[] uncheckedValue;
   String[] checkboxLabel;
   String[] actualCompName;
   Vector gParmObject;
   int currentSelection = -1;
   JDPTabSelectPanel tabPanel;
   static String lockingTextString = "Select the Integer column that is to be used for the record locking mechanism.\n\n" + "When a row is selected from the table the current value of this Integer column is stored. " + "When an update or delete is made a check will be made to ensure that the row still has the " + "same value for this column. If not the update will fail and a prompt will be shown to ask the " + "user whether to update anyway or reload the record.\n\nIf the update is successful the column " + "value will be incremented thereby stopping some other user from accidently updating over the " + "changes without being aware of it.";

   void updateArrays() {
      if (this.currentSelection >= 0) {
         if (this.fieldSql[this.currentSelection].indexOf(".") > 0 && this.fieldSql[this.currentSelection].indexOf("a.") < 0 && (this.fieldtype.getSelectedItem().equals("JDPChoice") || this.fieldtype.getSelectedItem().equals("JDPComboBox") || this.fieldtype.getSelectedItem().equals("JDPSpinner"))) {
            this.fieldtype.select("TextField");
         }

         if (!this.fieldtype.getSelectedItem().equals(this.fieldType[this.currentSelection])) {
            this.retrieveColumns();
            if (this.targetScreen != null) {
               this.targetScreen.lastLine = -1;
            }
         }

         this.includeInUpdateSql[this.currentSelection] = this.includeinupdatesql.getSelectedItem();
         this.fieldType[this.currentSelection] = this.fieldtype.getSelectedItem();
         this.fieldSql[this.currentSelection] = this.fieldsql.getText();
         this.mousePtrText[this.currentSelection] = this.mouseptrtext.getText();
         this.statusBarText[this.currentSelection] = this.statusbartext.getText();
         this.target.columnLength[this.columnIndexes[this.currentSelection]] = this.fieldsize.getText();
         this.textAreaRows[this.currentSelection] = this.textarearows.getText();
         this.fieldEditable[this.currentSelection] = this.fieldeditable.getSelectedItem();
         this.fieldLabelColor[this.currentSelection] = this.fieldlabelcolor.getSelectedItem();
         this.fieldTextColor[this.currentSelection] = this.fieldtextcolor.getSelectedItem();
         this.fieldBackColor[this.currentSelection] = this.fieldbackcolor.getSelectedItem();
         this.fieldDefault[this.currentSelection] = this.fielddefault.getText();
         this.fieldRequired[this.currentSelection] = this.fieldrequired.getSelectedItem();
         this.fieldErrorMsg[this.currentSelection] = this.fielderrormsg.getText();
         this.fieldEditMask[this.currentSelection] = this.fieldeditmask.getText();
         this.checkedValue[this.currentSelection] = this.checkedvalue.getText();
         this.uncheckedValue[this.currentSelection] = this.uncheckedvalue.getText();
         this.checkboxLabel[this.currentSelection] = this.checkboxlabel.getText();
         if (!this.fieldType[this.currentSelection].equals("TextField") && !this.fieldType[this.currentSelection].equals("JDPSpinner") && !this.fieldType[this.currentSelection].equals("JDPDate")) {
            this.sizeLabel.setText("Columns:");
         } else {
            this.sizeLabel.setText("Field Size:");
         }

         this.thisChoicePanel.updateArrays(this.currentSelection);
         this.setChoicePanel(this.currentSelection);
         ((CardLayout)this.rowSizePanel.getLayout()).show(this.rowSizePanel, this.fieldType[this.currentSelection]);
         String var1 = this.fieldType[this.currentSelection];
         if (this.fieldType[this.currentSelection].equals("JDPComboBox") || this.fieldType[this.currentSelection].equals("RadioButtons")) {
            var1 = "JDPChoice";
         }

         ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, var1);
      }
   }

   void clearList() {
      this.columns.clear();
   }

   void loadList() {
      this.clearList();
      int var1 = 1;
      this.columnIndexes = new int[var1];
      this.fieldType = new String[var1];
      this.fieldSql = new String[var1];
      this.includeInUpdateSql = new String[var1];
      this.mousePtrText = new String[var1];
      this.statusBarText = new String[var1];
      this.textAreaRows = new String[var1];
      this.fieldEditable = new String[var1];
      this.fieldLabelColor = new String[var1];
      this.fieldTextColor = new String[var1];
      this.fieldBackColor = new String[var1];
      this.fieldDefault = new String[var1];
      this.fieldRequired = new String[var1];
      this.fieldErrorMsg = new String[var1];
      this.fieldEditMask = new String[var1];
      this.checkedValue = new String[var1];
      this.uncheckedValue = new String[var1];
      this.checkboxLabel = new String[var1];
      this.actualCompName = new String[var1];
      if (this.target != null && this.target.columnName != null && this.target.columns.getSelectedIndexes().length != 0) {
         String[] var2 = this.target.columns.getSelectedItems();
         int[] var3 = this.target.columns.getSelectedIndexes();
         var1 = 0;
         if (this.moduleParameter.equals("Combo")) {
            for(int var4 = 0; var4 < var2.length; ++var4) {
               if (var2[var4].indexOf(".") > 0 && var2[var4].indexOf("a.") < 0 || this.moduleParameter.equals("Combo") && this.target.keys.isSelected(this.target.keys.getItem(var2[var4]))) {
                  ++var1;
               }
            }
         } else {
            var1 = var2.length;
         }

         this.columnIndexes = new int[var1];
         this.fieldType = new String[var1];
         this.fieldSql = new String[var1];
         this.includeInUpdateSql = new String[var1];
         this.mousePtrText = new String[var1];
         this.statusBarText = new String[var1];
         this.textAreaRows = new String[var1];
         this.fieldEditable = new String[var1];
         this.fieldLabelColor = new String[var1];
         this.fieldTextColor = new String[var1];
         this.fieldBackColor = new String[var1];
         this.fieldDefault = new String[var1];
         this.fieldRequired = new String[var1];
         this.fieldErrorMsg = new String[var1];
         this.fieldEditMask = new String[var1];
         this.checkedValue = new String[var1];
         this.uncheckedValue = new String[var1];
         this.checkboxLabel = new String[var1];
         this.actualCompName = new String[var1];
         this.thisChoicePanel.initList(var1);
         this.lockingColumn.clear();
         this.lockingColumn.addItem("");
         int var9 = 0;

         for(int var5 = 0; var5 < var2.length; ++var5) {
            if (this.moduleParameter.equals("Combo") && var2[var5].indexOf(".") > 0 && var2[var5].indexOf("a.") < 0 || this.moduleParameter.equals("Combo") && this.target.keys.isSelected(this.target.keys.getItem(var2[var5])) || !this.moduleParameter.equals("Combo")) {
               this.columnIndexes[var9] = var3[var5];
               this.fieldType[var9] = "TextField";
               this.fieldSql[var9] = var2[var5];
               this.includeInUpdateSql[var9] = "Yes";
               if (this.target.useRemarks.getSelectedItem().equals("Yes") && !this.target.columnRemarks[var5].equals("")) {
                  this.mousePtrText[var9] = this.target.columnRemarks[var5];
               } else {
                  this.mousePtrText[var9] = super.user.u.makeLabel(var2[var5]);
               }

               this.statusBarText[var9] = "";
               int var6 = var3[var5];
               int var7 = 12;
               if (var6 < this.target.columnDatatype.length) {
                  var7 = this.target.columnDatatype[var6];
               }

               this.textAreaRows[var9] = "3";
               this.fieldEditable[var9] = "Yes";
               this.fieldRequired[var9] = "No";
               if (JDPUtils.isOdbcDate(var7)) {
                  this.fieldRequired[var9] = "Yes";
                  this.fieldType[var9] = "JDPDate";
               }

               if (this.fieldSql[var9].indexOf(".") > 0 && this.fieldSql[var9].indexOf("a.") < 0) {
                  this.fieldEditable[var9] = "No";
                  this.fieldRequired[var9] = "No";
               } else if (JDPUtils.isOdbcInt(var7)) {
                  this.lockingColumn.addItem(this.fieldSql[var9]);
               }

               this.fieldLabelColor[var9] = "Black";
               this.fieldTextColor[var9] = "Black";
               this.fieldBackColor[var9] = "White";
               this.fieldDefault[var9] = "";
               this.fieldErrorMsg[var9] = "";
               this.fieldEditMask[var9] = "";
               this.checkedValue[var9] = "Y";
               this.uncheckedValue[var9] = "N";
               this.checkboxLabel[var9] = this.mousePtrText[var9];
               this.actualCompName[var9] = "";
               this.columns.addItem(var2[var5], 8);
               this.thisChoicePanel.loadList(var9);
               ++var9;
            }
         }

         this.listCount.setText(Integer.toString(var9));
         this.lockingColumn.layoutChoice();
         this.thisChoicePanel.loadTableList();
      } else {
         if (super.componentName.equals("")) {
            super.user.mainmsg.setStatusMsg("You must first select a Table.", 5);
         }

      }
   }

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPScreenSettings" + super.componentName;
      this.tabNames.setText("");
      this.useTabs.select("No");
      String[] var3 = (String[])var1.restoreObject(this.fieldType, var2, "fieldType");
      String[] var4 = (String[])var1.restoreObject(this.fieldSql, var2, "fieldSql");
      String[] var5 = (String[])var1.restoreObject(this.includeInUpdateSql, var2, "includeInUpdateSql");
      String[] var6 = (String[])var1.restoreObject(this.mousePtrText, var2, "mousePtrText");
      String[] var7 = (String[])var1.restoreObject(this.statusBarText, var2, "statusBarText");
      String[] var8 = (String[])var1.restoreObject(this.textAreaRows, var2, "textAreaRows");
      String[] var9 = (String[])var1.restoreObject(this.fieldEditable, var2, "fieldEditable");
      String[] var10 = (String[])var1.restoreObject(this.fieldLabelColor, var2, "fieldLabelColor");
      String[] var11 = (String[])var1.restoreObject(this.fieldTextColor, var2, "fieldTextColor");
      String[] var12 = (String[])var1.restoreObject(this.fieldBackColor, var2, "fieldBackColor");
      String[] var13 = (String[])var1.restoreObject(this.fieldDefault, var2, "fieldDefault");
      String[] var14 = (String[])var1.restoreObject(this.fieldRequired, var2, "fieldRequired");
      String[] var15 = (String[])var1.restoreObject(this.fieldErrorMsg, var2, "fieldErrorMsg");
      String[] var16 = (String[])var1.restoreObject(this.fieldEditMask, var2, "fieldEditMask");
      String[] var17 = (String[])var1.restoreObject(this.checkedValue, var2, "checkedValue");
      String[] var18 = (String[])var1.restoreObject(this.uncheckedValue, var2, "uncheckedValue");
      String[] var19 = (String[])var1.restoreObject(this.checkboxLabel, var2, "checkboxLabel");
      String[] var20 = (String[])var1.restoreObject(this.actualCompName, var2, "actualCompName");
      var1.restoreObject(this.useTabs, var2, "useTabs");
      var1.restoreObject(this.tabNames, var2, "tabNames");
      var1.restoreObject(this.lockingColumn, var2, "lockingColumn");
      if (this.useTabs.getSelectedItem().equals("Yes")) {
         this.tabNames.enable();
      } else {
         this.tabNames.disable();
      }

      this.prevTabs = this.tabNames.getText();
      if (this.target.columnLength == null) {
         this.target.columnLength = new String[0];
      }

      String[] var21 = (String[])var1.restoreObject(this.target.columnLength, var2, "columnLength");
      if (var3 != null) {
         if (this.fieldType.length < var3.length) {
            this.fieldType = new String[var3.length];
         }

         if (this.fieldSql.length < var4.length) {
            this.fieldSql = new String[var4.length];
         }

         if (this.includeInUpdateSql.length < var5.length) {
            this.includeInUpdateSql = new String[var5.length];
         }

         if (this.mousePtrText.length < var6.length) {
            this.mousePtrText = new String[var6.length];
         }

         if (this.statusBarText.length < var7.length) {
            this.statusBarText = new String[var7.length];
         }

         if (this.textAreaRows.length < var8.length) {
            this.textAreaRows = new String[var8.length];
         }

         if (this.fieldEditable.length < var9.length) {
            this.fieldEditable = new String[var9.length];
         }

         if (this.fieldLabelColor.length < var10.length) {
            this.fieldLabelColor = new String[var10.length];
         }

         if (this.fieldTextColor.length < var11.length) {
            this.fieldTextColor = new String[var11.length];
         }

         if (this.fieldBackColor.length < var12.length) {
            this.fieldBackColor = new String[var12.length];
         }

         if (this.fieldDefault.length < var13.length) {
            this.fieldDefault = new String[var13.length];
         }

         if (this.fieldRequired.length < var14.length) {
            this.fieldRequired = new String[var14.length];
         }

         if (this.fieldErrorMsg.length < var15.length) {
            this.fieldErrorMsg = new String[var15.length];
         }

         if (this.fieldEditMask.length < var16.length) {
            this.fieldEditMask = new String[var16.length];
         }

         if (this.checkedValue.length < var17.length) {
            this.checkedValue = new String[var17.length];
         }

         if (this.uncheckedValue.length < var18.length) {
            this.uncheckedValue = new String[var18.length];
         }

         if (this.checkboxLabel.length < var19.length) {
            this.checkboxLabel = new String[var19.length];
         }

         if (this.actualCompName.length < var20.length) {
            this.actualCompName = new String[var20.length];
         }

         if (this.target.columnLength.length < var3.length) {
            this.target.columnLength = new String[var3.length];
         }

         for(int var22 = 0; var22 < var3.length; ++var22) {
            this.fieldType[var22] = var3[var22];
            this.fieldSql[var22] = var4[var22];
            this.includeInUpdateSql[var22] = var5[var22];
            this.mousePtrText[var22] = var6[var22];
            this.statusBarText[var22] = var7[var22];
            this.textAreaRows[var22] = var8[var22];
            this.fieldEditable[var22] = var9[var22];
            this.fieldLabelColor[var22] = var10[var22];
            this.fieldTextColor[var22] = var11[var22];
            this.fieldBackColor[var22] = var12[var22];
            this.fieldDefault[var22] = var13[var22];
            this.fieldRequired[var22] = var14[var22];
            this.fieldErrorMsg[var22] = var15[var22];
            this.fieldEditMask[var22] = var16[var22];
            this.checkedValue[var22] = var17[var22];
            this.uncheckedValue[var22] = var18[var22];
            this.checkboxLabel[var22] = var19[var22];
            this.actualCompName[var22] = var20[var22];
            if (var22 < var21.length) {
               this.target.columnLength[var22] = var21[var22];
            }

            if (this.fieldType[var22] != null && this.fieldType[var22].equals("Choice")) {
               this.fieldType[var22] = "JDPChoice";
            }
         }
      }

      this.thisChoicePanel.setComponentName(super.componentName);
      this.thisChoicePanel.restoreSelections();
      return true;
   }

   void clearFields() {
      this.fieldtype.select("TextField");
      this.fieldsql.setText("");
      this.includeinupdatesql.select("Yes");
      this.mouseptrtext.setText("");
      this.statusbartext.setText("");
      this.fieldsize.setText("");
      this.textarearows.setText("");
      this.fieldeditable.select("Yes");
      this.fieldlabelcolor.select("Black");
      this.fieldtextcolor.select("Black");
      this.fieldbackcolor.select("White");
      this.fielddefault.setText("");
      this.fieldrequired.select("Yes");
      this.fielderrormsg.setText("");
      this.fieldeditmask.setText("");
      this.checkedvalue.setText("Y");
      this.uncheckedvalue.setText("N");
      this.checkboxlabel.setText("N");
      this.thisChoicePanel.clearFields();
      ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, "TextField");
      ((CardLayout)this.rowSizePanel.getLayout()).show(this.rowSizePanel, "TextField");
   }

   void checkLockingColumns() {
      String var1 = this.lockingColumn.getSelectedItem();
      if (var1 != null && !var1.equals("")) {
         for(int var2 = 0; var2 < this.includeInUpdateSql.length; ++var2) {
            if (this.fieldSql[var2].equals(var1)) {
               this.includeInUpdateSql[var2] = "No";
            }
         }
      }

   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPScreenSettings" + super.componentName;
      var1.saveObject(this.fieldType, var2, "fieldType");
      var1.saveObject(this.fieldSql, var2, "fieldSql");
      var1.saveObject(this.includeInUpdateSql, var2, "includeInUpdateSql");
      var1.saveObject(this.mousePtrText, var2, "mousePtrText");
      var1.saveObject(this.statusBarText, var2, "statusBarText");
      var1.saveObject(this.textAreaRows, var2, "textAreaRows");
      var1.saveObject(this.fieldEditable, var2, "fieldEditable");
      var1.saveObject(this.fieldLabelColor, var2, "fieldLabelColor");
      var1.saveObject(this.fieldTextColor, var2, "fieldTextColor");
      var1.saveObject(this.fieldBackColor, var2, "fieldBackColor");
      var1.saveObject(this.fieldDefault, var2, "fieldDefault");
      var1.saveObject(this.fieldRequired, var2, "fieldRequired");
      var1.saveObject(this.fieldErrorMsg, var2, "fieldErrorMsg");
      var1.saveObject(this.fieldEditMask, var2, "fieldEditMask");
      var1.saveObject(this.checkedValue, var2, "checkedValue");
      var1.saveObject(this.uncheckedValue, var2, "uncheckedValue");
      var1.saveObject(this.checkboxLabel, var2, "checkboxLabel");
      var1.saveObject(this.actualCompName, var2, "actualCompName");
      var1.saveObject(this.useTabs, var2, "useTabs");
      var1.saveObject(this.tabNames, var2, "tabNames");
      var1.saveObject(this.lockingColumn, var2, "lockingColumn");
      var1.saveObject(this.target.columnLength, var2, "columnLength");
      this.thisChoicePanel.setComponentName(super.componentName);
      this.thisChoicePanel.saveSelections();
      return true;
   }

   void refresh() {
      this.clearFields();
      this.currentSelection = -1;
      this.retrieveColumns();
      this.loadList();
      this.restoreSelections();
   }

   void retrieveColumns() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               this.target = (JDPSelectColumns)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("SelectTable" + super.componentName) == 0) {
               this.tableTarget = (JDPSelectTable)var2.elementAt(1);
            }

            if (((String)var2.elementAt(0)).compareTo("ScreenLayout" + super.componentName) == 0) {
               this.targetScreen = (JDPScreenLayout)var2.elementAt(1);
            }
         }

         if (super.user.gParm.elementAt(var1) instanceof JDPLayoutMgr && !super.componentName.equals("")) {
            this.targetLayoutMgr = (JDPLayoutMgr)super.user.gParm.elementAt(var1);
         }
      }

      this.thisChoicePanel.retrieveColumns();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (var1.target.equals(this.mouseptrtext)) {
                  super.user.u.cursor(this.statusbartext);
                  return true;
               }

               if (var1.target.equals(this.statusbartext)) {
                  super.user.u.cursor(this.fieldlabelcolor);
                  return true;
               }

               if (var1.target.equals(this.fieldlabelcolor)) {
                  super.user.u.cursor(this.fieldtextcolor);
                  return true;
               }

               if (var1.target.equals(this.fieldtextcolor)) {
                  super.user.u.cursor(this.fieldbackcolor);
                  return true;
               }

               if (var1.target.equals(this.fieldbackcolor)) {
                  super.user.u.cursor(this.fieldsql);
                  return true;
               }

               if (var1.target.equals(this.fieldsql)) {
                  super.user.u.cursor(this.includeinupdatesql);
                  return true;
               }

               if (var1.target.equals(this.includeinupdatesql)) {
                  super.user.u.cursor(this.mouseptrtext);
                  return true;
               }

               if (this.fieldsize.isVisible()) {
                  if (var1.target.equals(this.fieldtype)) {
                     super.user.u.cursor(this.fieldsize);
                     return true;
                  }

                  if (this.textarearows.isVisible()) {
                     if (var1.target.equals(this.fieldsize)) {
                        super.user.u.cursor(this.textarearows);
                        return true;
                     }

                     if (var1.target.equals(this.textarearows)) {
                        super.user.u.cursor(this.fieldeditable);
                        return true;
                     }
                  } else if (var1.target.equals(this.fieldsize)) {
                     super.user.u.cursor(this.fieldeditable);
                     return true;
                  }

                  if (var1.target.equals(this.fieldeditable)) {
                     super.user.u.cursor(this.fieldlabelcolor);
                     return true;
                  }

                  if (var1.target.equals(this.fielddefault)) {
                     super.user.u.cursor(this.fieldrequired);
                     return true;
                  }

                  if (var1.target.equals(this.fieldrequired)) {
                     super.user.u.cursor(this.fielderrormsg);
                     return true;
                  }

                  if (var1.target.equals(this.fielderrormsg)) {
                     super.user.u.cursor(this.fieldeditmask);
                     return true;
                  }

                  if (var1.target.equals(this.fieldeditmask)) {
                     super.user.u.cursor(this.fieldtype);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.fieldtype)) {
                     super.user.u.cursor(this.checkedvalue);
                     return true;
                  }

                  if (var1.target.equals(this.checkedvalue)) {
                     super.user.u.cursor(this.uncheckedvalue);
                     return true;
                  }

                  if (var1.target.equals(this.uncheckedvalue)) {
                     super.user.u.cursor(this.checkboxlabel);
                     return true;
                  }

                  if (var1.target.equals(this.checkboxlabel)) {
                     super.user.u.cursor(this.fieldtype);
                     return true;
                  }
               }

               if (var1.target.equals(this.useTabs)) {
                  super.user.u.cursor(this.tabNames);
                  return true;
               }

               if (var1.target.equals(this.tabNames)) {
                  super.user.u.cursor(this.useTabs);
                  return true;
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPList) {
               this.updateArrays();
               if (var1.target.equals(this.columns)) {
                  int var3 = (Integer)var1.arg;
                  this.loadItem(var3);
                  this.currentSelection = var3;
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target instanceof TextField) {
               this.updateArrays();
               return true;
            } else if (var1.target instanceof TextArea) {
               this.updateArrays();
               return true;
            } else if (var1.target instanceof JDPComboBox) {
               if (var1.target.equals(this.useTabs)) {
                  if (this.useTabs.getSelectedItem().equals("Yes")) {
                     this.tabNames.setText("Tab 1\nTab 2");
                     this.tabNames.enable();
                  } else {
                     this.tabNames.setText("");
                     this.tabNames.disable();
                  }

                  this.retrieveColumns();
               }

               if (var1.target.equals(this.lockingColumn)) {
                  this.checkLockingColumns();
               }

               this.updateArrays();
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Accept") == 0) {
                     this.updateArrays();
                     this.checkLockingColumns();
                     this.saveSelections();
                     this.retrieveColumns();
                     if (this.targetScreen != null && !this.prevTabs.equals(this.tabNames.getText())) {
                        this.targetScreen.setupTabs();
                        this.targetScreen.resetSelections();
                     }

                     this.prevTabs = this.tabNames.getText();
                     if (this.targetScreen != null && this.targetScreen.lastLine < 0) {
                        this.targetScreen.refresh();
                     }

                     super.user.mainmsg.setStatusMsg("Selections accepted.", 10);
                     if (super.componentName.equals("")) {
                        super.user.jdpMenuPanel.loadNextTab();
                     } else {
                        this.tabPanel = JDPUtils.getTabPanel(this);
                        if (this.tabPanel != null) {
                           this.tabPanel.loadNextTab();
                        }
                     }

                     return true;
                  }

                  if (var2.trim().compareTo("Reset") == 0) {
                     this.loadList();
                     return true;
                  }
               }

               return true;
            }
         default:
            return false;
      }
   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPScreenSettings" + super.componentName;
      var1.removeObject(this.fieldType, var2, "fieldType");
      var1.removeObject(this.fieldSql, var2, "fieldSql");
      var1.removeObject(this.includeInUpdateSql, var2, "includeInUpdateSql");
      var1.removeObject(this.mousePtrText, var2, "mousePtrText");
      var1.removeObject(this.statusBarText, var2, "statusBarText");
      var1.removeObject(this.textAreaRows, var2, "textAreaRows");
      var1.removeObject(this.fieldEditable, var2, "fieldEditable");
      var1.removeObject(this.fieldLabelColor, var2, "fieldLabelColor");
      var1.removeObject(this.fieldTextColor, var2, "fieldTextColor");
      var1.removeObject(this.fieldBackColor, var2, "fieldBackColor");
      var1.removeObject(this.fieldDefault, var2, "fieldDefault");
      var1.removeObject(this.fieldRequired, var2, "fieldRequired");
      var1.removeObject(this.fieldErrorMsg, var2, "fieldErrorMsg");
      var1.removeObject(this.fieldEditMask, var2, "fieldEditMask");
      var1.removeObject(this.checkedValue, var2, "checkedValue");
      var1.removeObject(this.uncheckedValue, var2, "uncheckedValue");
      var1.removeObject(this.checkboxLabel, var2, "checkboxLabel");
      var1.removeObject(this.actualCompName, var2, "actualCompName");
      var1.removeObject(this.useTabs, var2, "useTabs");
      var1.removeObject(this.tabNames, var2, "tabNames");
      var1.removeObject(this.lockingColumn, var2, "lockingColumn");
      this.thisChoicePanel.setComponentName(super.componentName);
      this.thisChoicePanel.removeSelections();
      return true;
   }

   void setChoicePanel(int var1) {
      this.thisChoicePanel.setDisplayType(this.fieldType[var1]);
   }

   void loadItem(int var1) {
      this.fieldtype.select(this.fieldType[var1]);
      this.fieldsql.setText(this.fieldSql[var1]);
      this.includeinupdatesql.select(this.includeInUpdateSql[var1]);
      this.mouseptrtext.setText(this.mousePtrText[var1]);
      this.statusbartext.setText(this.statusBarText[var1]);
      this.fieldsize.setText(this.target.columnLength[this.columnIndexes[var1]]);
      this.textarearows.setText(this.textAreaRows[var1]);
      this.fieldeditable.select(this.fieldEditable[var1]);
      this.fieldeditable.enable();
      this.fieldtype.enable();
      this.fielddefault.enable();
      this.fieldrequired.select(this.fieldRequired[var1]);
      this.fieldrequired.enable();
      this.fielderrormsg.enable();
      this.fieldeditmask.clear();
      if (JDPUtils.isOdbcInt(this.target.columnDatatype[this.columnIndexes[var1]])) {
         this.fieldeditmask.addItem("999,999,999,999");
         this.fieldeditmask.addItem("$999,999,999,999");
         this.fieldeditmask.addItem("999.999.999.999");
         this.fieldeditmask.addItem("$999.999.999.999");
         this.fieldeditmask.addItem("99%");
      }

      if (JDPUtils.isOdbcFloat(this.target.columnDatatype[this.columnIndexes[var1]])) {
         this.fieldeditmask.addItem("999,999,999,999.00");
         this.fieldeditmask.addItem("$999,999,999,999.00");
         this.fieldeditmask.addItem("999.999.999.999,00");
         this.fieldeditmask.addItem("$999.999.999.999,00");
         this.fieldeditmask.addItem("99.00%");
         this.fieldeditmask.addItem("99,00%");
      }

      if (JDPUtils.isOdbcChar(this.target.columnDatatype[this.columnIndexes[var1]])) {
         this.fieldeditmask.addItem("___-___-____");
         this.fieldeditmask.addItem("(___)___-____");
      }

      if (this.fieldSql[var1].indexOf(".") > 0 && this.fieldSql[var1].indexOf("a.") < 0 || this.target.columnIsIdentity[this.columnIndexes[var1]]) {
         this.fieldeditable.disable();
         this.fieldeditable.select("No");
         this.fielddefault.disable();
         this.fieldrequired.disable();
         this.fieldrequired.select("No");
         this.fielderrormsg.disable();
         if (this.fieldtype.getSelectedItem().equals("JDPChoice") || this.fieldtype.getSelectedItem().equals("JDPComboBox") || this.fieldtype.getSelectedItem().equals("JDPSpinner")) {
            this.fieldType[var1] = "TextField";
         }

         this.fieldtype.select(this.fieldType[var1]);
      }

      this.fieldlabelcolor.select(this.fieldLabelColor[var1]);
      this.fieldtextcolor.select(this.fieldTextColor[var1]);
      this.fieldbackcolor.select(this.fieldBackColor[var1]);
      this.fielddefault.clear();
      this.fielddefault.addItem("");
      this.fielddefault.setText(this.fieldDefault[var1]);
      this.fielderrormsg.setText(this.fieldErrorMsg[var1]);
      this.fieldeditmask.setText(this.fieldEditMask[var1]);
      this.checkedvalue.setText(this.checkedValue[var1]);
      this.uncheckedvalue.setText(this.uncheckedValue[var1]);
      this.checkboxlabel.setText(this.checkboxLabel[var1]);
      if (this.fieldType[var1].equals("JDPChoice") || this.fieldType[var1].equals("JDPComboBox") || this.fieldType[var1].equals("JDPSpinner") || this.fieldType[var1].equals("JDPDate")) {
         this.fieldrequired.select("No");
      }

      if (!this.fieldType[var1].equals("TextField") && !this.fieldType[var1].equals("JDPSpinner") && !this.fieldType[var1].equals("JDPDate")) {
         this.sizeLabel.setText("Columns:");
      } else {
         this.sizeLabel.setText("Field Size:");
      }

      this.setChoicePanel(var1);
      this.thisChoicePanel.loadItem(var1);
      ((CardLayout)this.rowSizePanel.getLayout()).show(this.rowSizePanel, this.fieldType[var1]);
      String var2 = this.fieldType[var1];
      if (this.fieldType[var1].equals("JDPComboBox") || this.fieldType[var1].equals("RadioButtons")) {
         var2 = "JDPChoice";
      }

      ((CardLayout)this.cardPanel.getLayout()).show(this.cardPanel, var2);
      this.centerTopPanel.layout();
      this.centerMainPanel.layout();
      this.centerMainPanel.paintAll(this.centerMainPanel.getGraphics());
      this.centerTopPanel.paintAll(this.centerMainPanel.getGraphics());
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.targetPanel = var2;
      this.moduleParameter = var3;
      super.moduleName = "ScreenSettings";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
         this.moduleParameter = "";
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      this.centerMainPanel = new Panel();
      this.centerMainPanel.setLayout(new BorderLayout());
      this.centerTopPanel = new Panel();
      this.centerTopPanel.setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      Panel var7 = new Panel();
      ((Container)var7).setLayout(new BorderLayout());
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new JDPRowLayout(1, 1));
      Panel var10 = new Panel();
      ((Container)var10).setLayout(new BorderLayout());
      Panel var11 = new Panel();
      ((Container)var11).setLayout(new JDPRowLayout(1, 1));
      Panel var12 = new Panel();
      ((Container)var12).setLayout(new JDPRowLayout(1, 1));
      this.cardPanel = new Panel();
      this.cardPanel.setLayout(new CardLayout());
      this.rowSizePanel = new Panel();
      this.rowSizePanel.setLayout(new CardLayout());
      String[] var14 = new String[]{"General", "Field Type", "Layout", "Record Locking"};
      Panel[] var15 = new Panel[]{this.centerTopPanel, var6, var7, var8};
      JDPTabSelectPanel var13 = new JDPTabSelectPanel(var1, var14, var15, "North");
      this.fieldtype = new JDPComboBox(var1, "", 15);
      this.fieldtype.setEditable(false);
      this.fieldtype.addItem("TextField");
      this.fieldtype.addItem("TextArea");
      this.fieldtype.addItem("JDPChoice");
      this.fieldtype.addItem("JDPComboBox");
      this.fieldtype.addItem("RadioButtons");
      this.fieldtype.addItem("Checkbox");
      this.fieldtype.addItem("JDPSpinner");
      this.fieldtype.addItem("JDPDate");
      this.fieldsql = new TextField("", 25);
      this.mouseptrtext = new TextField("", 25);
      this.statusbartext = new TextField("", 40);
      this.includeinupdatesql = new JDPComboBox(var1, "", 5);
      this.includeinupdatesql.setEditable(false);
      this.includeinupdatesql.addItem("Yes");
      this.includeinupdatesql.addItem("No");
      this.fieldsize = new TextField("", 6);
      this.textarearows = new TextField("", 6);
      this.fieldeditable = new JDPComboBox(var1, "", 5);
      this.fieldeditable.setEditable(false);
      this.fieldeditable.addItem("Yes");
      this.fieldeditable.addItem("No");
      this.fieldlabelcolor = new JDPComboBox(var1, "", 10);
      this.fieldlabelcolor.setEditable(false);
      this.fieldlabelcolor.addItem("Black");
      this.fieldlabelcolor.addItem("Gray");
      this.fieldlabelcolor.addItem("Blue");
      this.fieldlabelcolor.addItem("Cyan");
      this.fieldlabelcolor.addItem("DarkGray");
      this.fieldlabelcolor.addItem("Green");
      this.fieldlabelcolor.addItem("LightGray");
      this.fieldlabelcolor.addItem("Magenta");
      this.fieldlabelcolor.addItem("Orange");
      this.fieldlabelcolor.addItem("Pink");
      this.fieldlabelcolor.addItem("Red");
      this.fieldlabelcolor.addItem("White");
      this.fieldlabelcolor.addItem("Yellow");
      this.fieldtextcolor = new JDPComboBox(var1, "", 10);
      this.fieldtextcolor.setEditable(false);
      this.fieldtextcolor.addItem("Black");
      this.fieldtextcolor.addItem("Gray");
      this.fieldtextcolor.addItem("Blue");
      this.fieldtextcolor.addItem("Cyan");
      this.fieldtextcolor.addItem("DarkGray");
      this.fieldtextcolor.addItem("Green");
      this.fieldtextcolor.addItem("LightGray");
      this.fieldtextcolor.addItem("Magenta");
      this.fieldtextcolor.addItem("Orange");
      this.fieldtextcolor.addItem("Pink");
      this.fieldtextcolor.addItem("Red");
      this.fieldtextcolor.addItem("White");
      this.fieldtextcolor.addItem("Yellow");
      this.fieldbackcolor = new JDPComboBox(var1, "", 10);
      this.fieldbackcolor.setEditable(false);
      this.fieldbackcolor.addItem("Black");
      this.fieldbackcolor.addItem("Gray");
      this.fieldbackcolor.addItem("Blue");
      this.fieldbackcolor.addItem("Cyan");
      this.fieldbackcolor.addItem("DarkGray");
      this.fieldbackcolor.addItem("Green");
      this.fieldbackcolor.addItem("LightGray");
      this.fieldbackcolor.addItem("Magenta");
      this.fieldbackcolor.addItem("Orange");
      this.fieldbackcolor.addItem("Pink");
      this.fieldbackcolor.addItem("Red");
      this.fieldbackcolor.addItem("White");
      this.fieldbackcolor.addItem("Yellow");
      this.fielddefault = new JDPComboBox(var1, "", 25);
      this.fieldrequired = new JDPComboBox(var1, "", 5);
      this.fieldrequired.setEditable(false);
      this.fieldrequired.addItem("Yes");
      this.fieldrequired.addItem("No");
      this.fielderrormsg = new TextField("", 25);
      this.fieldeditmask = new JDPComboBox(var1, "", 25);
      this.checkedvalue = new TextField("Y", 5);
      this.uncheckedvalue = new TextField("N", 5);
      this.checkboxlabel = new TextField("", 15);
      JDPScrollPanel var16 = new JDPScrollPanel();
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "Mouse pointer text:"));
      ((Container)var16).add("Right", this.mouseptrtext);
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "Status bar text:"));
      ((Container)var16).add("Right", this.statusbartext);
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "Label Color:"));
      ((Container)var16).add("Right", this.fieldlabelcolor);
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "Text Color:"));
      ((Container)var16).add("Right", this.fieldtextcolor);
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "Text Background Color:"));
      ((Container)var16).add("Right", this.fieldbackcolor);
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "SQL Select:"));
      ((Container)var16).add("Right", this.fieldsql);
      ((Container)var16).add("Left", new JDPWrapLabel(var1, "Include in update SQL:"));
      ((Container)var16).add("Right", this.includeinupdatesql);
      this.centerTopPanel.add("Center", new JDPChiselFramePanel(var1, "General Attributes", var16, "North"));
      this.sizeLabel = new Label("Field Size:         ", 0);
      this.sizeLabel.setFont(var1.boldFont);
      this.rowSizePanel.add("TextField", new Panel());
      Panel var17 = new Panel();
      ((Container)var17).setLayout(new JDPLineLayout(1));
      ((Container)var17).add("Left", new JDPWrapLabel(var1, "Field Rows:"));
      ((Container)var17).add("Left", this.textarearows);
      this.rowSizePanel.add("TextArea", var17);
      this.rowSizePanel.add("JDPChoice", new Panel());
      this.rowSizePanel.add("JDPComboBox", new Panel());
      this.rowSizePanel.add("Checkbox", new Panel());
      this.rowSizePanel.add("JDPSpinner", new Panel());
      this.rowSizePanel.add("JDPDate", new Panel());
      ((Container)var9).add("Left", this.sizeLabel);
      Panel var18 = new Panel();
      ((Container)var18).setLayout(new JDPLineLayout(1));
      ((Container)var18).add("Left", this.fieldsize);
      ((Container)var18).add("Left", this.rowSizePanel);
      ((Container)var9).add("Right", var18);
      JDPScrollPanel var19 = new JDPScrollPanel();
      ((Container)var19).add("Left", new JDPWrapLabel(var1, "Field Type:"));
      ((Container)var19).add("Right", this.fieldtype);
      ((Container)var6).add("North", var19);
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Editable:"));
      ((Container)var9).add("Right", this.fieldeditable);
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Default value:   "));
      ((Container)var9).add("Right", this.fielddefault);
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Entry required:   "));
      ((Container)var9).add("Right", this.fieldrequired);
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Error message:   "));
      ((Container)var9).add("Right", this.fielderrormsg);
      ((Container)var9).add("Left", new JDPWrapLabel(var1, "Edit mask:   "));
      ((Container)var9).add("Right", this.fieldeditmask);
      ((Container)var11).add("Left", new JDPWrapLabel(var1, "Database value for checked:   "));
      ((Container)var11).add("Right", this.checkedvalue);
      ((Container)var11).add("Left", new JDPWrapLabel(var1, "Database value for unchecked:   "));
      ((Container)var11).add("Right", this.uncheckedvalue);
      ((Container)var11).add("Left", new JDPWrapLabel(var1, "Checkbox Label:   "));
      ((Container)var11).add("Right", this.checkboxlabel);
      this.thisChoicePanel = new JDPChoiceLayout();
      String var20 = var3;
      if (super.thisBranch.compType.startsWith("JDPWiz")) {
         var20 = var3 + ":SS1";
      }

      this.thisChoicePanel.InitClass(var1, var2, var20);
      this.cardPanel.add("TextField", var9);
      this.cardPanel.add("JDPChoice", this.thisChoicePanel);
      this.cardPanel.add("Checkbox", var11);
      this.cardPanel.add("JDPDate", new Panel());
      this.cardPanel.add("JDPSpinner", new Panel());
      ((Container)var6).add("Center", new JDPChiselFramePanel(var1, "Field Attributes", this.cardPanel, "North"));
      this.useTabs = new JDPComboBox(var1, "", 5);
      this.useTabs.setEditable(false);
      this.useTabs.addItem("No");
      this.useTabs.addItem("Yes");
      this.tabNames = new TextArea("", 6, 30);
      this.tabNames.disable();
      JDPScrollPanel var21 = new JDPScrollPanel();
      ((Container)var21).add("Left", new JDPWrapLabel(var1, "Use tabs to lay out screen:"));
      ((Container)var21).add("Right", this.useTabs);
      ((Container)var21).add("Left", new JDPWrapLabel(var1, "Enter tab names:"));
      ((Container)var21).add("Right", this.tabNames);
      ((Container)var7).add("Center", new JDPChiselFramePanel(var1, "Screen Layout Settings", var21, "North"));
      Panel var22 = new Panel();
      ((Container)var22).setLayout(new BorderLayout());
      JDPScrollPanel var23 = new JDPScrollPanel();
      ((Container)var23).add("Left", new JDPWrapLabel(var1, "Record Locking Column:"));
      this.lockingColumn = new JDPComboBox(var1, "", 15);
      this.lockingColumn.setEditable(false);
      ((Container)var23).add("Right", this.lockingColumn);
      ((Container)var22).add("North", var23);
      this.lockingText = new JDPRichText(var1);
      this.lockingText.setText(lockingTextString);
      this.lockingText.setEditable(false);
      ((Container)var22).add("Center", this.lockingText);
      ((Container)var8).add("Center", new JDPChiselFramePanel(var1, "Record Locking Settings", var22, "North"));
      this.centerMainPanel.add("Center", var13);
      String[] var24 = new String[]{"Accept", "Reset"};
      int[] var25 = new int[]{5, 6};
      JDPButtons var26 = new JDPButtons(var1, var24, var25, JDPButtons.HORIZONTAL);
      this.centerMainPanel.add("South", var26);
      this.popuppanel.addComponent(var26.button[0], "Accept Selections", "Accept selections and proceed to next screen");
      this.popuppanel.addComponent(var26.button[1], "Reset Selections", "Reset selections back to default settings");
      ((Container)var4).add("Center", this.centerMainPanel);
      this.columns = new JDPList(var1);
      this.columns.setMinWidth(160);
      Panel var27 = new Panel();
      ((Container)var27).setLayout(new BorderLayout());
      ((Container)var27).add("Center", this.columns);
      ((Container)var4).add("West", var27);
      Panel var28 = new Panel();
      ((Container)var28).setLayout(new BorderLayout(4, 1));
      ((Container)var28).add("West", new Label("Columns:", 0));
      this.listCount = new Label("0      ", 0);
      Panel var29 = new Panel();
      ((Container)var29).setLayout(new BorderLayout(4, 1));
      ((Container)var29).add("West", this.listCount);
      ((Container)var29).add("Center", new Label(" ", 0));
      ((Container)var28).add("Center", var29);
      ((Container)var27).add("North", var28);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Screen Field Settings", var4, "North"));
      this.gParmObject = new Vector();
      this.gParmObject.addElement(super.moduleName + super.componentName);
      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      ((CardLayout)this.rowSizePanel.getLayout()).show(this.rowSizePanel, this.fieldtype.getSelectedItem());
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
