import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSelectTable extends JDPClassLayout {
   JDPSelectDSN targetDSN;
   JDPChoice tableTypes;
   JDPList tables;
   JDPList stables;
   JDPList temptables;
   TextField datasource;
   TextField connectstring;
   String prevconnectstring;
   TextField qualifier;
   TextField owner;
   TextField tablename;
   TextField tabletype;
   TextField remarks;
   TextField alias;
   Label listCount;
   JDPComboBox join1;
   JDPComboBox compare;
   JDPComboBox join2;
   JDPList joinConditions;
   Panel selectPanel;
   JDPScrollPanel joinPanel;
   JDPPopupMessage popuppanel;
   String prevDSNString = "";
   String prevTableString;
   String prevTypes = "";
   JDPTextGrid tableContents;
   String[] tableQualifier;
   String[] tableOwner;
   String[] tableName;
   String[] tableType;
   String[] tableRemarks;
   String[] tableAlias;
   String[] stableAlias;
   String[] ctableQualifier;
   String[] ctableOwner;
   String[] ctableName;
   String[] columnName;
   int[] columnDatatype;
   String[] columnTypename;
   String[] columnPrecision;
   String[] columnLength;
   String[] columnScale;
   String[] columnRadix;
   String[] columnNullable;
   String[] columnRemarks;
   String lastAcceptedTableString = "";
   Vector gParmObject;
   String moduleParameter;
   JDPTabSelectPanel tabPanel;

   boolean restoreSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPSelectTable" + super.componentName;

      for(int var3 = 0; var3 < this.tables.countItems(); ++var3) {
         this.tables.deselect(var3);
      }

      for(int var7 = 0; var7 < this.stables.countItems(); ++var7) {
         this.stables.deselect(var7);
      }

      String var8 = this.tableTypes.getSelectedItem();
      var1.restoreObject(this.tableTypes, var2, "tableTypes");
      if (this.tableTypes.getSelectedItem().equals(var8)) {
         this.loadList();
      }

      if (this.tables.countItems() > 0) {
         var1.restoreObject(this.tables, var2, "tables");
      }

      if (this.stables.countItems() > 0) {
         var1.restoreObject(this.stables, var2, "stables");
      }

      this.resetAlias();

      for(int var4 = 0; var4 < this.joinConditions.countItems(); ++var4) {
         this.joinConditions.deselect(var4);
      }

      this.joinConditions.clear();
      var1.restoreObject(this.joinConditions, var2, "joinConditions", 1);
      String var9 = "";
      if (this.tables.getSelectedIndex() >= 0) {
         var9 = var9 + this.tables.getSelectedItem();
      }

      String[] var5 = this.stables.getSelectedItems();

      for(int var6 = 0; var6 < var5.length; ++var6) {
         var9 = var9 + var5[var6];
      }

      if (!var9.equals("")) {
         this.lastAcceptedTableString = var9;
      }

      return true;
   }

   void clearList() {
      this.tables.clear();
      this.stables.clear();
   }

   void loadList() {
      String var1 = this.targetDSN.datasource.getText().trim() + this.targetDSN.userid.getText() + this.targetDSN.password.getText();
      if (!var1.equals(this.prevDSNString) || !this.prevTypes.equals(this.tableTypes.getSelectedItem())) {
         this.prevDSNString = var1;
         this.prevTypes = this.tableTypes.getSelectedItem();
         int var3 = 0;
         JDPJagg var5 = new JDPJagg(super.user.jaggPath);
         String var6 = var5.getSEP();
         int var7 = 0;
         String var9 = "";
         this.clearList();
         this.clearFields();
         this.datasource.getText();
         if (this.targetDSN != null && !this.targetDSN.datasource.getText().equals("")) {
            if (((Component)this).isShowing()) {
               super.user.mainmsg.setStatusMsg("Loading Table definitions, please wait...", 0);
            }

            super.user.jaggSQL.getDSN();
            super.user.jaggSQL.getCSTR();
            var5.loadSettings(this.targetDSN);
            var5.setFCTN("SQLTables");
            var5.setMRW("100000");
            var7 = (byte)100;
            this.tableQualifier = new String[var7];
            this.tableOwner = new String[var7];
            String[] var10 = new String[var7];
            this.tableType = new String[var7];
            this.tableRemarks = new String[var7];
            this.tableAlias = new String[var7];
            this.stableAlias = new String[var7];
            String var11 = this.tableTypes.getSelectedKey();
            if (!JDPJagg.useJaggServer) {
               var11 = var11.replace(';', ',');
            }

            int var12 = 0;
            var5.setFCTNP(";;;" + var11 + ";");
            Vector var4 = new Vector();
            var3 = var5.execSQL(var9, var4);
            if (var3 == -1) {
               if (((Component)this).isShowing()) {
                  super.user.mainmsg.setStatusMsg("Could not connect to datasource. Please check the Connect String.", 20);
               }

               this.tabPanel = JDPUtils.getTabPanel(this);
               if (this.tabPanel != null) {
                  this.tabPanel.loadPrevTab();
               }

            } else {
               if (super.user.DEBUG) {
                  System.out.println("JDPSelectTable/loadList COL: " + Integer.toString(var5.getColumnCount()));
               }

               var5.getColumnCount();
               var7 = var5.getRowCount();
               this.tableQualifier = new String[var7];
               this.tableOwner = new String[var7];
               var10 = new String[var7];
               this.tableType = new String[var7];
               this.tableRemarks = new String[var7];
               this.tableAlias = new String[var7];
               this.stableAlias = new String[var7];

               for(int var13 = 0; var13 < var7; ++var13) {
                  String var8 = (String)var4.elementAt(var13);
                  if (var8 != null && var8.trim().compareTo("") != 0) {
                     StringTokenizer var2 = new StringTokenizer(var8, var6);
                     this.tableQualifier[var12] = var2.nextToken().trim();
                     this.tableOwner[var12] = var2.nextToken().trim();
                     if (this.tableOwner[var12].length() > 0) {
                        var10[var12] = this.tableOwner[var12] + "." + var2.nextToken().trim();
                     } else {
                        var10[var12] = var2.nextToken().trim();
                     }

                     this.tableType[var12] = var2.nextToken().trim();
                     this.tableRemarks[var12] = var2.nextToken().trim();
                     if (var10[var12].indexOf(" ") >= 0) {
                        var10[var12] = "`" + var10[var12] + "`";
                     }

                     this.tables.addItem(var10[var12], 1);
                     this.stables.addItem(var10[var12], 1);
                     ++var12;
                  }
               }

               this.tableName = new String[var12];
               System.arraycopy(var10, 0, this.tableName, 0, var12);
               if (((Component)this).isShowing()) {
                  super.user.mainmsg.clearStatusMsg();
               }

            }
         }
      }
   }

   void loadJoinCriteria() {
      this.join1.clear();
      this.join2.clear();
      if (this.stables.getSelectedIndexes().length != 0) {
         if (this.moduleParameter.compareTo("JDPTemplateMaint") != 0) {
            if (this.tables.getSelectedIndex() < 0) {
               return;
            }

            String var1 = this.tables.getSelectedItem();

            for(int var2 = 0; var2 < this.ctableName.length; ++var2) {
               if (this.ctableName[var2].equals(var1)) {
                  if (this.columnName[var2].indexOf(" ") < 0 && this.columnName[var2].indexOf("#") < 0) {
                     this.join1.addItem("a." + this.columnName[var2].trim());
                     this.join2.addItem("a." + this.columnName[var2].trim());
                  } else {
                     this.join1.addItem("a.`" + this.columnName[var2].trim() + "`");
                     this.join2.addItem("a.`" + this.columnName[var2].trim() + "`");
                  }
               }
            }
         }

         int[] var5 = this.stables.getSelectedIndexes();

         for(int var6 = 0; var6 < var5.length; ++var6) {
            String var3 = this.stables.getItem(var5[var6]);

            for(int var4 = 0; var4 < this.ctableName.length; ++var4) {
               if (this.ctableName[var4].equals(var3)) {
                  if (this.columnName[var4].indexOf(" ") < 0 && this.columnName[var4].indexOf("#") < 0) {
                     this.join1.addItem(this.stableAlias[var5[var6]] + "." + this.columnName[var4].trim());
                     this.join2.addItem(this.stableAlias[var5[var6]] + "." + this.columnName[var4].trim());
                  } else {
                     this.join1.addItem(this.stableAlias[var5[var6]] + ".`" + this.columnName[var4].trim() + "`");
                     this.join2.addItem(this.stableAlias[var5[var6]] + ".`" + this.columnName[var4].trim() + "`");
                  }
               }
            }
         }

      }
   }

   void clearFields() {
      this.qualifier.setText("");
      this.owner.setText("");
      this.tablename.setText("");
      this.tabletype.setText("");
      this.remarks.setText("");
   }

   void setNewTable() {
      String var1 = "";
      if (this.tables.getSelectedIndex() >= 0) {
         var1 = var1 + this.tables.getSelectedItem();
      }

      String[] var2 = this.stables.getSelectedItems();

      for(int var3 = 0; var3 < var2.length; ++var3) {
         var1 = var1 + var2[var3];
      }

      if (!this.lastAcceptedTableString.equals("") && !var1.equals(this.lastAcceptedTableString)) {
         for(int var5 = 2; var5 < super.thisBranch.relatedComps.length; ++var5) {
            ((JDPClassLayout)super.thisBranch.relatedComps[var5]).removeSelections();
         }
      }

      this.lastAcceptedTableString = var1;

      for(int var6 = 0; var6 < super.user.gParm.size(); ++var6) {
         if (super.user.gParm.elementAt(var6) instanceof Vector) {
            Vector var4 = (Vector)super.user.gParm.elementAt(var6);
            if (((String)var4.elementAt(0)).compareTo("SelectColumns" + super.componentName) == 0) {
               ((JDPClassLayout)var4.elementAt(1)).refresh();
            }
         }
      }

      if (((Component)this).isShowing()) {
         super.user.mainmsg.setStatusMsg("Selection accepted.", 5);
      }

   }

   void restoreTypeSelection() {
      JDPSaveProps var1 = super.user.saveProperties;
      if (super.user.prevProperties != null) {
         var1 = super.user.prevProperties;
      }

      String var2 = "JDPSelectTable" + super.componentName;
      this.tableTypes.getSelectedItem();
      var1.restoreObject(this.tableTypes, var2, "tableTypes");
   }

   void loadColumns() {
      int var2 = 0;
      new Vector();
      JDPJagg var4 = new JDPJagg(super.user.jaggPath);
      String var5 = var4.getSEP();
      var4.setKeepConnectionOpen(true);
      short var6 = 0;
      String var8 = "";
      if (this.tables.countItems() > 0) {
         int var9 = 0;
         String var10 = "";
         String[] var11 = new String[50];
         String[] var12 = new String[50];
         if (this.tables.getSelectedIndex() >= 0) {
            var12[var9] = this.tableQualifier[this.tables.getSelectedIndex()];
            var11[var9++] = this.tables.getSelectedItem();
            var10 = var10 + this.tables.getSelectedItem();
         }

         String[] var13 = this.stables.getSelectedItems();
         int[] var14 = this.stables.getSelectedIndexes();

         for(int var15 = 0; var15 < var13.length; ++var15) {
            var12[var9] = this.tableQualifier[var14[var15]];
            var11[var9++] = var13[var15];
            var10 = var10 + var13[var15];
         }

         if (this.prevTableString == null || !var10.equals(this.prevTableString)) {
            if (((Component)this).isShowing()) {
               super.user.mainmsg.setStatusMsg("Loading Column definitions, please wait...", 0);
            }

            this.prevTableString = var10;
            var4.loadSettings(this.targetDSN);
            var4.setFCTN("SQLColumns");
            var4.setMRW("100000");
            var6 = 2000;
            this.ctableQualifier = new String[var6];
            this.ctableOwner = new String[var6];
            String[] var24 = new String[var6];
            String[] var16 = new String[var6];
            this.columnDatatype = new int[var6];
            this.columnTypename = new String[var6];
            this.columnPrecision = new String[var6];
            this.columnLength = new String[var6];
            this.columnScale = new String[var6];
            this.columnRadix = new String[var6];
            this.columnNullable = new String[var6];
            this.columnRemarks = new String[var6];
            int var17 = 0;

            for(int var18 = 0; var18 < var9; ++var18) {
               String var19 = ";;" + var11[var18] + ";;";
               int var20 = var11[var18].indexOf(".");
               if (var20 >= 0) {
                  var19 = ";" + var11[var18].substring(0, var20) + ";" + var11[var18].substring(var20 + 1) + ";;";
               }

               var4.setFCTNP(var19);
               Vector var3 = new Vector();
               var2 = var4.execSQL(var8, var3);
               if (var2 == -1) {
                  super.user.u.setSqlMessage(var4, var8);
                  return;
               }

               var4.getColumnCount();

               for(int var21 = 0; var21 < var2; ++var21) {
                  String var7 = (String)var3.elementAt(var21);
                  if (var7 != null && var7.trim().compareTo("") != 0) {
                     StringTokenizer var1 = new StringTokenizer(var7, var5);
                     if (var1.hasMoreTokens()) {
                        this.ctableQualifier[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.ctableOwner[var17] = var1.nextToken().trim();
                     }

                     if (this.ctableOwner[var17].length() > 0) {
                        if (var1.hasMoreTokens()) {
                           var24[var17] = this.ctableOwner[var17] + "." + var1.nextToken().trim();
                        }
                     } else if (var1.hasMoreTokens()) {
                        var24[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        var24[var17] = var11[var18];
                     }

                     if (var1.hasMoreTokens()) {
                        var16[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnDatatype[var17] = Integer.parseInt(var1.nextToken().trim());
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnTypename[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnPrecision[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnLength[var17] = Integer.toString(Integer.parseInt(var1.nextToken().trim()) + 2);
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnScale[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnRadix[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnNullable[var17] = var1.nextToken().trim();
                     }

                     if (var1.hasMoreTokens()) {
                        this.columnRemarks[var17] = var1.nextToken().trim();
                     }

                     ++var17;
                  }
               }
            }

            this.ctableName = new String[var17];
            System.arraycopy(var24, 0, this.ctableName, 0, var17);
            this.columnName = new String[var17];
            System.arraycopy(var16, 0, this.columnName, 0, var17);
            var4.setKeepConnectionOpen(false);
            if (((Component)this).isShowing()) {
               super.user.mainmsg.clearStatusMsg();
            }

         }
      }
   }

   void resetAlias() {
      this.loadColumns();
      String var1 = "bcdefghijklmnopqrstuvwxyz";
      if (this.moduleParameter.compareTo("JDPTemplateMaint") == 0) {
         var1 = "a" + var1;
      }

      boolean var2 = false;
      if (this.moduleParameter.compareTo("JDPTemplateMaint") != 0 && this.tables.getSelectedIndex() < 0) {
         var2 = true;
      } else {
         if (this.moduleParameter.compareTo("JDPTemplateMaint") != 0) {
            this.tableAlias[this.tables.getSelectedIndex()] = "a";
         }

         int[] var3 = this.stables.getSelectedIndexes();

         for(int var4 = 0; var4 < var3.length; ++var4) {
            if (this.stableAlias[var3[var4]] != null && !this.stableAlias[var3[var4]].equals(var1.substring(var4, var4 + 1))) {
               var2 = true;
            }

            this.stableAlias[var3[var4]] = var1.substring(var4, var4 + 1);
         }
      }

      if (var2) {
         this.joinConditions.clear();
      }

      this.loadJoinCriteria();
   }

   boolean saveSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPSelectTable" + super.componentName;
      var1.saveObject(this.tableTypes, var2, "tableTypes");
      var1.saveObject(this.tables, var2, "tables");
      var1.saveObject(this.stables, var2, "stables");
      var1.saveObject(this.joinConditions, var2, "joinConditions", 1);
      return true;
   }

   void refresh() {
      this.retrieveDSN();
      this.restoreTypeSelection();
      this.loadList();
      this.restoreSelections();
      if (super.componentName.indexOf("Search") >= 0 && ((Component)this).isShowing()) {
         super.user.mainmsg.setStatusMsg("Please select the same tables as those you selected for your Result List.", 30);
      }

   }

   boolean removeSelections() {
      JDPSaveProps var1 = super.user.saveProperties;
      String var2 = "JDPSelectTable" + super.componentName;
      var1.removeObject(this.tableTypes, var2, "tableTypes");
      var1.removeObject(this.tables, var2, "tables");
      var1.removeObject(this.stables, var2, "stables");
      var1.removeObject(this.joinConditions, var2, "joinConditions");
      return true;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target instanceof JDPList) {
               this.resetAlias();
               if (var1.target.equals(this.tables)) {
                  this.loadItem(this.tables.getSelectedIndex());
                  if (this.tableAlias[this.tables.getSelectedIndex()] != null) {
                     this.alias.setText(this.tableAlias[this.tables.getSelectedIndex()]);
                  }
               } else {
                  int var6 = (Integer)var1.arg;
                  this.loadItem(var6);
                  if (this.stableAlias[var6] != null) {
                     this.alias.setText(this.stableAlias[var6]);
                  }
               }

               return true;
            }

            return false;
         case 1001:
            if (var1.target.equals(this.tableTypes)) {
               this.loadList();
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Accept") == 0) {
                     if (this.tables.getSelectedIndexes().length == 0) {
                        super.user.mainmsg.setStatusMsg("You must select a primary table.", 7);
                        return true;
                     }

                     if (this.stables.getSelectedIndexes().length > 0 && this.joinConditions.countItems() == 0) {
                        super.user.mainmsg.setStatusMsg("You have selected more than one table but have not defined a join condition.", 13);
                        return true;
                     }

                     this.setNewTable();
                     this.saveSelections();
                     if (super.componentName.equals("")) {
                        super.user.jdpMenuPanel.loadNextTab();
                     } else {
                        this.tabPanel = JDPUtils.getTabPanel(this);
                        if (this.tabPanel != null) {
                           this.tabPanel.loadNextTab();
                        }
                     }

                     return true;
                  }

                  if (var2.trim().compareTo("Reset") == 0) {
                     if (this.tables.getSelectedIndex() >= 0) {
                        this.tables.deselect(this.tables.getSelectedIndex());
                     }

                     for(int var9 = 0; var9 < this.stables.countItems(); ++var9) {
                        this.stables.deselect(var9);
                     }

                     this.joinConditions.clear();
                     this.resetAlias();
                     return true;
                  }

                  if (var2.trim().compareTo("Add") == 0) {
                     if (this.join1.getSelectedItem() != null && this.join2.getSelectedItem() != null) {
                        String var3 = this.join1.getSelectedItem();
                        String var4 = this.compare.getSelectedKey();
                        if (var4.indexOf("*") > 0 && this.stables.getSelectedIndexes().length != 1) {
                           super.user.mainmsg.setStatusMsg("You must select one and only one secondary table when performing an outer join.", 8);
                           return true;
                        }

                        if (var4.indexOf("*") > 0) {
                           for(int var5 = 0; var5 < this.joinConditions.countItems(); ++var5) {
                              if (this.joinConditions.getItem(var5).indexOf("*") > 0) {
                                 super.user.mainmsg.setStatusMsg("You may only select one outer join condition.", 8);
                                 return true;
                              }
                           }
                        }

                        var3 = var3 + var4;
                        var3 = var3 + this.join2.getSelectedItem();
                        this.joinConditions.addItem(var3);
                     }

                     return true;
                  }

                  if (var2.trim().compareTo("Remove") == 0) {
                     if (this.joinConditions.getSelectedIndex() >= 0) {
                        this.joinConditions.delItem(this.joinConditions.getSelectedIndex());
                     }

                     return true;
                  }
               }

               return false;
            }
         default:
            return false;
      }
   }

   void loadItem(int var1) {
      this.qualifier.setText(this.tableQualifier[var1]);
      this.owner.setText(this.tableOwner[var1]);
      this.tablename.setText(this.tableName[var1]);
      this.tabletype.setText(this.tableType[var1]);
      this.remarks.setText(this.tableRemarks[var1]);
   }

   void retrieveDSN() {
      for(int var1 = 0; var1 < super.user.gParm.size(); ++var1) {
         if (super.user.gParm.elementAt(var1) instanceof Vector) {
            Vector var2 = (Vector)super.user.gParm.elementAt(var1);
            if (this.moduleParameter.compareTo("JDPTemplateMaint") != 0) {
               if (((String)var2.elementAt(0)).compareTo("SelectDSN" + super.componentName) == 0) {
                  this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
                  this.datasource.setText(this.targetDSN.datasource.getText());
                  this.connectstring.setText(this.targetDSN.connectstring.getText());
               }
            } else if (((String)var2.elementAt(0)).compareTo("SelectDSNTemplate") == 0) {
               this.targetDSN = (JDPSelectDSN)var2.elementAt(3);
               this.datasource.setText(this.targetDSN.datasource.getText());
               this.connectstring.setText(this.targetDSN.connectstring.getText());
            }
         }
      }

   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.moduleParameter = var3;
      super.moduleName = "SelectTable";
      if (var3.startsWith("JDPLayoutMgr:")) {
         super.componentName = var3.substring(13);
         var3 = "";
         this.moduleParameter = "";
      }

      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      this.tableTypes = new JDPChoice(var1);
      this.tableTypes.addItem("All Types", "TABLE;VIEW;SYSTEM TABLE;GLOBAL TEMPORARY;LOCAL TEMPORARY;ALIAS;SYNONYM");
      this.tableTypes.addItem("All Tables", "TABLE;VIEW;SYSTEM TABLE");
      this.tableTypes.addItem("Tables and Views", "TABLE;VIEW");
      this.tableTypes.addItem("Tables", "TABLE");
      this.tableTypes.addItem("Views", "VIEW");
      this.tableTypes.addItem("System Tables", "SYSTEM TABLE");
      this.tableTypes.addItem("Global Temporarys", "GLOBAL TEMPORARY");
      this.tableTypes.addItem("Local Temporarys", "LOCAL TEMPORARY");
      this.tableTypes.addItem("Aliases", "ALIAS");
      this.tableTypes.addItem("Synonyms", "SYNONYM");
      this.tableTypes.select(2);
      this.datasource = new TextField("", 20);
      this.connectstring = new TextField("", 40);
      this.qualifier = new TextField("", 25);
      this.owner = new TextField("", 20);
      this.tablename = new TextField("", 20);
      this.tabletype = new TextField("", 20);
      this.remarks = new TextField("", 25);
      this.alias = new TextField("", 3);
      this.datasource.setEditable(false);
      this.qualifier.setEditable(false);
      this.owner.setEditable(false);
      this.tablename.setEditable(false);
      this.tabletype.setEditable(false);
      this.remarks.setEditable(false);
      this.alias.setEditable(false);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Selected Data Source:"));
      ((Container)var7).add("Right", this.datasource);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "DataBase/Qualifier:"));
      ((Container)var7).add("Right", this.qualifier);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Owner:"));
      ((Container)var7).add("Right", this.owner);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Table Name:"));
      ((Container)var7).add("Right", this.tablename);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Table Type:"));
      ((Container)var7).add("Right", this.tabletype);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Remarks:"));
      ((Container)var7).add("Right", this.remarks);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Table alias:"));
      ((Container)var7).add("Right", this.alias);
      Panel var8 = new Panel();
      ((Container)var8).setLayout(new BorderLayout());
      ((Container)var8).add("Center", var7);
      this.joinPanel = new JDPScrollPanel();
      Panel var9 = new Panel();
      ((Container)var9).setLayout(new BorderLayout());
      this.selectPanel = new Panel();
      this.selectPanel.setLayout(new GridLayout(1, 3));
      ((Container)var9).add("North", this.selectPanel);
      this.join1 = new JDPComboBox(var1, "", 15);
      this.compare = new JDPComboBox(var1, "", 15);
      this.join2 = new JDPComboBox(var1, "", 15);
      this.join1.setEditable(false);
      this.compare.setEditable(false);
      this.join2.setEditable(false);
      this.joinPanel.add("Left", new JDPWrapLabel(var1, "Table Join Criteria:"));
      this.joinPanel.add("Left", var9);
      this.joinPanel.add("Right", new Panel());
      this.joinPanel.add("Right", new Panel());
      this.selectPanel.add(this.join1);
      this.selectPanel.add(this.compare);
      this.compare.addItem("Equals", " = ");
      this.compare.addItem("Not Equal", " NOT = ");
      this.compare.addItem("Left Outer Join", " *= ");
      this.compare.addItem("Right Outer Join", " =* ");
      this.selectPanel.add(this.join2);
      this.popuppanel.addComponent(this.join1, "Join columns", "Choose the column by which to join Primary and Secondary tables");
      this.popuppanel.addComponent(this.compare, "Join operator", "Choose the operator by which to join Primary and Secondary tables");
      this.popuppanel.addComponent(this.join2, "Join columns", "Choose the column by which to join Primary and Secondary tables");
      this.joinConditions = new JDPList(var1);
      this.joinConditions.setMinHeight(70);
      ((Container)var9).add("South", this.joinConditions);
      this.popuppanel.addComponent(this.joinConditions, "Join criteria", "Choose the criteria by which to join Primary and Secondary tables");
      String[] var10 = new String[]{"Add", "Remove"};
      int[] var11 = new int[]{7, 8};
      String[] var12 = new String[]{"Table Join Definition", "Table Details"};
      Panel[] var13 = new Panel[]{this.joinPanel, var8};
      if (var3.compareTo("JDPTemplateMaint") != 0) {
         JDPTabSelectPanel var14 = new JDPTabSelectPanel(var1, var12, var13, "North");
         ((Container)var6).add("Center", var14);
      } else {
         ((Container)var6).add("Center", this.joinPanel);
      }

      JDPButtons var18 = new JDPButtons(var1, var10, var11, JDPButtons.HORIZONTAL);
      this.joinPanel.add("Left", var18);
      this.popuppanel.addComponent(var18.button[0], "Add join condition", "Add the current join condition to the list of join conditions");
      this.popuppanel.addComponent(var18.button[1], "Remove join condition", "Remove the selected join condition from the list");
      if (var3.compareTo("JDPTemplateMaint") != 0) {
         String[] var15 = new String[]{"Accept", "Reset"};
         int[] var16 = new int[]{5, 6};
         JDPButtons var17 = new JDPButtons(var1, var15, var16, JDPButtons.HORIZONTAL);
         ((Container)var6).add("South", var17);
         this.popuppanel.addComponent(var17.button[0], "Accept Selections", "Accept selections and proceed to selecting table columns");
         this.popuppanel.addComponent(var17.button[1], "Reset Selections", "Reset selections back to default settings");
      }

      ((Container)var4).add("Center", var6);
      this.tables = new JDPList(var1);
      this.tables.setMinWidth(160);
      this.stables = new JDPList(var1);
      this.stables.allowMultipleSelections(true);
      this.stables.setMinWidth(160);
      this.stables.setMinHeight(150);
      Panel var19 = new Panel();
      ((Container)var19).setLayout(new BorderLayout());
      ((Container)var19).add("North", this.tableTypes);
      Panel var20 = new Panel();
      ((Container)var20).setLayout(new BorderLayout());
      ((Container)var19).add("Center", var20);
      ((Container)var4).add("West", var19);
      if (var3.compareTo("JDPTemplateMaint") != 0) {
         ((Container)var20).add("North", new JDPWrapLabel(var1, "Primary Table:"));
         ((Container)var20).add("Center", this.tables);
         Panel var21 = new Panel();
         ((Container)var21).setLayout(new BorderLayout());
         ((Container)var21).add("North", new JDPWrapLabel(var1, "Secondary Tables:"));
         ((Container)var21).add("South", this.stables);
         ((Container)var20).add("South", var21);
         ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Select a Table", var4, "North"));
         this.popuppanel.addComponent(this.tables, "Primary tables", "Choose the Primary table over which to build your new module");
         this.popuppanel.addComponent(this.stables, "Secondary tables", "Choose 1 or many tables to join with the Primary table (optional)");
      } else {
         ((Container)var20).add("Center", this.stables);
         ((Container)this).add("Center", var4);
         this.popuppanel.addComponent(this.stables, "Select tables", "Choose the tables that contain the required data");
      }

      this.retrieveDSN();
      this.gParmObject = new Vector();
      if (var3.compareTo("JDPTemplateMaint") != 0) {
         this.gParmObject.addElement(super.moduleName + super.componentName);
      } else {
         this.gParmObject.addElement("SelectTableTemplate");
      }

      this.gParmObject.addElement(this);
      var1.gParm.addElement(this.gParmObject);
      if (var3.compareTo("JDPTemplateMaint") != 0) {
      }

      ((Component)var2).paintAll(((Component)var2).getGraphics());
      if (super.componentName.equals("")) {
         new JDPPanelLoader("JDPSelectColumns");
      }

   }
}
