import java.awt.Component;
import java.awt.Event;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;
import java.util.Vector;

public class JDPServerListener extends Thread {
   JDPUser user;
   Vector listenerRequestNames;
   Vector listeners;

   void registerRequest(String var1, int var2, String var3) {
      for(int var4 = this.listenerRequestNames.indexOf(var1); var4 >= 0; var4 = this.listenerRequestNames.indexOf(var1, var4 + 1)) {
         this.sendEvent(var1, var2, var3, (Component)this.listeners.elementAt(var4));
      }

   }

   public JDPServerListener(JDPUser var1) {
      this.user = var1;
      this.listenerRequestNames = new Vector();
      this.listeners = new Vector();
      ((Thread)this).start();
   }

   public synchronized void registerForRequest(String var1, Component var2) {
      this.listenerRequestNames.addElement(var1);
      this.listeners.addElement(var2);
   }

   public synchronized void deregisterRequest(Component var1) {
      for(int var2 = this.listeners.indexOf(var1); var2 >= 0; var2 = this.listeners.indexOf(var1)) {
         this.listeners.removeElementAt(var2);
         this.listenerRequestNames.removeElementAt(var2);
      }

   }

   public void run() {
      try {
         ServerSocket var1 = new ServerSocket(4900);

         while(true) {
            try {
               Socket var2 = var1.accept();
               this.processConnection(var2);
            } catch (Exception var4) {
               ((Throwable)var4).printStackTrace();
            }
         }
      } catch (Exception var5) {
      }
   }

   void sendEvent(String var1, int var2, String var3, Component var4) {
      Event var5 = new Event(this, (new Date()).getTime(), var2, 0, 0, 0, 0, var1 + "|" + var3);
      var4.postEvent(var5);
   }

   void processConnection(Socket var1) {
      new JDPServerListenerCxn(this.user, this, var1);
   }
}
