import java.awt.Event;
import java.util.StringTokenizer;

public class JDPServerSender {
   JDPUser user;
   JDPJagg jaggSQL;
   int[] userid;
   String[] inetAddress;
   String[] jdpSystem;
   long[] idleFor;

   public String[] getIPAddresses() {
      return this.inetAddress;
   }

   public long getIdleFor(int var1) {
      return this.idleFor != null && var1 < this.idleFor.length ? this.idleFor[var1] : -1L;
   }

   public String getJDPSystem(int var1) {
      return this.jdpSystem != null && var1 < this.jdpSystem.length ? this.jdpSystem[var1] : null;
   }

   public JDPServerSender(JDPUser var1) {
      this.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
   }

   public JDPServerSender(JDPJagg var1) {
      this.jaggSQL = var1;
   }

   public boolean getConnectedClients() {
      String var1 = this.jaggSQL.getSEP();
      String var2 = (String)this.jaggSQL.invoke("JDPJaggUserMgr", "getUsersIPAddresses");
      if (var2 == null) {
         return false;
      } else {
         StringTokenizer var3 = new StringTokenizer(var2, var1);
         int var4 = var3.countTokens() / 4;
         this.userid = new int[var4];
         this.inetAddress = new String[var4];
         this.jdpSystem = new String[var4];
         this.idleFor = new long[var4];

         for(int var5 = 0; var3.hasMoreTokens(); ++var5) {
            this.userid[var5] = Integer.parseInt(var3.nextToken().trim());
            this.inetAddress[var5] = var3.nextToken().trim();
            this.jdpSystem[var5] = var3.nextToken().trim();
            this.idleFor[var5] = Long.valueOf(var3.nextToken().trim());
         }

         return true;
      }
   }

   public boolean sendEventToClient(String var1, String var2, Event var3) {
      return this.jaggSQL.sendEventToClient(var1, var2, var3);
   }

   public int getUserid(int var1) {
      return this.userid != null && var1 < this.userid.length ? this.userid[var1] : -1;
   }

   public int getTotalConnectedUsers() {
      return this.userid != null ? this.userid.length : 0;
   }

   public String getIPAddress(int var1) {
      return this.inetAddress != null && var1 < this.inetAddress.length ? this.inetAddress[var1] : null;
   }
}
