import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSetupNDS {
   JDPUser user;
   float oldVersion;
   float newVersion;

   public boolean createTables() {
      if (this.user.loginMessage != null) {
         this.user.loginMessage.setStatusMsg("Creating NDS Layouts...", 0);
      }

      this.user.jaggSQL.setFCTN("NDSexecSQL");
      if (this.user.cust != null) {
         this.user.jaggSQL.setFCTNP(this.user.cust.username + ";" + this.user.cust.password + ";");
      }

      String var1 = "CREATE TABLE JDesignerPro System (JDP:JDPSystem char, Description char, JDP:versionnum char, JDP:bfontname char, JDP:bfontsize int, JDP:pfontname char, JDP:pfontsize int, JDP:jlanguage char, JDP:country char, JDP:dateformat char)";
      Vector var2 = new Vector();
      this.user.jaggSQL.execSQL(var1, var2);
      var1 = "CREATE TABLE JDesignerPro Menu (JDP:menuname char) parent=JDesignerPro System";
      var2 = new Vector();
      this.user.jaggSQL.execSQL(var1, var2);
      var1 = "CREATE LEAF TABLE JDesignerPro Menu Option (JDP:menunum int, JDP:menutype char, JDP:menuobject char, JDP:menuparm char, JDP:menudesc char, JDP:menutxtclr char, JDP:menutabclr char, JDP:menustat char) parent=JDesignerPro Menu";
      var2 = new Vector();
      this.user.jaggSQL.execSQL(var1, var2);
      return true;
   }

   public boolean createDefaultGroups() {
      if (this.user.loginMessage != null) {
         this.user.loginMessage.setStatusMsg("Creating NDS Entries...", 0);
      }

      this.user.jaggSQL.setFCTN("NDSexecSQL");
      if (this.user.cust != null) {
         this.user.jaggSQL.setFCTNP(this.user.cust.username + ";" + this.user.cust.password + ";");
         String var1 = "INSERT INTO Group (CN, Description, Member) VALUES(JDPAdmin, JDPAdmin, " + this.user.cust.username + ")";
         Vector var2 = new Vector();
         this.user.jaggSQL.execSQL(var1, var2);
      }

      this.user.jaggSQL.setFCTN("");
      return true;
   }

   public boolean createDefaultEntries() {
      if (this.user.loginMessage != null) {
         this.user.loginMessage.setStatusMsg("Creating NDS Entries...", 0);
      }

      this.user.jaggSQL.setFCTN("");
      this.user.jaggSQL.setFCTNP("");
      String var1 = "SELECT JDPSystemD, JDPSystem, versionnum, bfontname, bfontsize, pfontname, pfontsize, jlanguage, country, dateformat " + "FROM JDPSystemDef " + "ORDER BY JDPSystem";
      Vector var2 = new Vector();
      int var4 = this.user.jaggSQL.execSQL(var1, var2);
      if (var4 > 0) {
         this.user.jaggSQL.setFCTN("NDSexecSQL");
         if (this.user.cust != null) {
            this.user.jaggSQL.setFCTNP(this.user.cust.username + ";" + this.user.cust.password + ";");
         }

         for(int var5 = 0; var5 < var2.size(); ++var5) {
            StringTokenizer var6 = new StringTokenizer((String)var2.elementAt(var5), this.user.jaggSQL.getSEP());
            String var7 = var6.nextToken().trim();
            String var8 = var6.nextToken().trim();
            var1 = "INSERT INTO JDesignerPro System (OU, JDP:JDPSystem, Description, JDP:versionnum, JDP:bfontname, JDP:bfontsize, JDP:pfontname, JDP:pfontsize, JDP:jlanguage, JDP:country, JDP:dateformat) " + "VALUES ('" + var8 + var7 + "', " + "'" + var8 + "', " + "'" + var7 + "', " + "'" + var6.nextToken().trim() + "', " + "'" + var6.nextToken().trim() + "', " + "" + var6.nextToken().trim() + ", " + "'" + var6.nextToken().trim() + "', " + "" + var6.nextToken().trim() + ", " + "'" + var6.nextToken().trim() + "', " + "'" + var6.nextToken().trim() + "', " + "'" + var6.nextToken().trim() + "')";
            Vector var3 = new Vector();
            this.user.jaggSQL.execSQL(var1, var3);
         }
      }

      this.user.jaggSQL.setFCTN("");
      this.user.jaggSQL.setFCTNP("");
      var1 = "SELECT DISTINCT a.menuname, b.JDPSystem, b.JDPSystemD " + "FROM JDPMenu a, JDPSystemDef b " + "WHERE a.JDPSystem = b.JDPSystem " + "ORDER BY b.JDPSystem, a.menuname";
      var2 = new Vector();
      var4 = this.user.jaggSQL.execSQL(var1, var2);
      if (var4 > 0) {
         this.user.jaggSQL.setFCTN("NDSexecSQL");
         if (this.user.cust != null) {
            this.user.jaggSQL.setFCTNP(this.user.cust.username + ";" + this.user.cust.password + ";");
         }

         for(int var29 = 0; var29 < var2.size(); ++var29) {
            StringTokenizer var40 = new StringTokenizer((String)var2.elementAt(var29), this.user.jaggSQL.getSEP());
            String var42 = var40.nextToken().trim();
            var1 = "INSERT INTO JDesignerPro Menu (OU, JDP:menuname, Description) " + "VALUES ('" + var42 + "','" + var42 + "','" + var42 + "') parent=" + this.user.u.replace(var40.nextToken().trim() + var40.nextToken().trim(), " ", "") + "";
            Vector var23 = new Vector();
            this.user.jaggSQL.execSQL(var1, var23);
         }
      }

      this.user.jaggSQL.setFCTN("");
      this.user.jaggSQL.setFCTNP("");
      var1 = "SELECT a.menudesc, a.menunum, a.menutype, a.menuobject, a.menuparm, a.menutxtclr, a.menutabclr, a.menustatus, a.menuauth1, a.menuauth2, a.menuauth3, a.menuauth4, a.menuauth5, b.JDPSystem, b.JDPSystemD, a.menuname " + "FROM JDPMenu a, JDPSystemDef b " + "WHERE a.JDPSystem = b.JDPSystem " + "ORDER BY b.JDPSystem, a.menuname, a.menunum";
      var2 = new Vector();
      var4 = this.user.jaggSQL.execSQL(var1, var2);
      if (var4 > 0) {
         this.user.jaggSQL.setFCTN("NDSexecSQL");
         if (this.user.cust != null) {
            this.user.jaggSQL.setFCTNP(this.user.cust.username + ";" + this.user.cust.password + ";");
         }

         for(int var41 = 0; var41 < var2.size(); ++var41) {
            StringTokenizer var43 = new StringTokenizer((String)var2.elementAt(var41), this.user.jaggSQL.getSEP());
            String var45 = var43.nextToken().trim();
            if (!var45.startsWith("User Menu") && !var45.startsWith("User System") && !var45.startsWith("User Billing")) {
               String var9 = var43.nextToken().trim();
               var1 = "INSERT INTO JDesignerPro Menu Option (OU, JDP:menunum, JDP:menutype, JDP:menuobject, JDP:menuparm, JDP:menudesc, Description, JDP:menutxtclr, JDP:menutabclr, JDP:menustat, `ACL:[Entry Rights]`) " + "VALUES (" + var9 + var45 + ", " + "" + var9 + ", " + "'" + var43.nextToken().trim() + "', " + "'" + var43.nextToken().trim() + "', " + "'" + var43.nextToken().trim() + "', " + "'" + var45 + "', " + "'" + var45 + "', " + "'" + var43.nextToken().trim() + "', " + "'" + var43.nextToken().trim() + "', " + "'" + var43.nextToken().trim() + "', ";
               String var30 = var43.nextToken();
               var30 = var30 + var43.nextToken();
               var30 = var30 + var43.nextToken();
               var30 = var30 + var43.nextToken();
               var30 = var30 + var43.nextToken();
               if (var30.indexOf("ADMIN") >= 0) {
                  var1 = var1 + "'JDPAdmin'";
               } else {
                  var1 = var1 + "''";
               }

               var1 = var1 + ") parent=" + this.user.u.replace(var43.nextToken().trim() + var43.nextToken().trim(), " ", "") + "\\" + this.user.u.replace(var43.nextToken().trim(), " ", "");
               Vector var24 = new Vector();
               var4 = this.user.jaggSQL.execSQL(var1, var24);
               if (var4 != 1) {
                  var43 = new StringTokenizer((String)var2.elementAt(var41), this.user.jaggSQL.getSEP());
                  var45 = var43.nextToken().trim();
                  var9 = var43.nextToken().trim();
                  var1 = "UPDATE JDesignerPro Menu Option SET JDP:menutype = '" + var43.nextToken().trim() + "'," + "JDP:menuobject = '" + var43.nextToken().trim() + "'," + "JDP:menuparm = '" + var43.nextToken().trim() + "'," + "JDP:menudesc = '" + var45 + "'," + "Description = '" + var45 + "'," + "JDP:menutxtclr = '" + var43.nextToken().trim() + "'," + "JDP:menutabclr = '" + var43.nextToken().trim() + "'," + "JDP:menustat = '" + var43.nextToken().trim() + "'," + "`ACL:[Entry Rights]` = ";
                  var30 = var43.nextToken();
                  var30 = var30 + var43.nextToken();
                  var30 = var30 + var43.nextToken();
                  var30 = var30 + var43.nextToken();
                  var30 = var30 + var43.nextToken();
                  if (var30.indexOf("ADMIN") >= 0) {
                     var1 = var1 + "'JDPAdmin'";
                  } else {
                     var1 = var1 + "''";
                  }

                  var1 = var1 + " WHERE JDP:menunum = " + var9;
                  var1 = var1 + " parent=" + this.user.u.replace(var43.nextToken().trim() + var43.nextToken().trim(), " ", "") + "\\" + this.user.u.replace(var43.nextToken().trim(), " ", "");
                  var24 = new Vector();
                  this.user.jaggSQL.execSQL(var1, var24);
               }
            }
         }
      }

      this.user.jaggSQL.setFCTN("");
      return true;
   }

   JDPSetupNDS(JDPUser var1, float var2, float var3) {
      this.user = var1;
      this.oldVersion = var2;
      this.newVersion = var3;
      if (var1.JDesignerPro.NDSPath != null) {
         if (this.createTables()) {
            this.createDefaultGroups();
            this.createDefaultEntries();
         }

         this.updateSystemVersion();
      }

      var1.jaggSQL.setFCTN("");
      var1.jaggSQL.setFCTNP("");
   }

   public boolean updateSystemVersion() {
      String var1 = "SELECT versionnum " + "FROM JDPSystemDef " + "WHERE JDPSystem = '" + this.user.JDesignerPro.JDPSystem.trim() + "'";
      Vector var2 = new Vector();
      int var3 = this.user.jaggSQL.execSQL(var1, var2);
      if (var3 > 0) {
         this.user.jaggSQL.setFCTN("NDSexecSQL");
         if (this.user.cust != null) {
            this.user.jaggSQL.setFCTNP(this.user.cust.username + ";" + this.user.cust.password + ";");
         }

         StringTokenizer var4 = new StringTokenizer((String)var2.elementAt(0), this.user.jaggSQL.getSEP());
         var1 = "UPDATE JDesignerPro System SET JDP:versionnum = '" + var4.nextToken().trim() + "' WHERE JDP:JDPSystem = '" + this.user.JDesignerPro.JDPSystem.trim() + "'";
         var2 = new Vector();
         this.user.jaggSQL.setFCTN("NDSexecSQL");
         this.user.jaggSQL.execSQL(var1, var2);
         this.user.jaggSQL.setFCTN("");
      }

      return true;
   }
}
