import java.util.Date;
import java.util.Vector;

public class JDPSetupSvr {
   JDPUser user;
   String sourcetype;

   void startEnterpriseServer() {
      this.user.loginMessage.setStatusMsg("Starting Enterprise Server...", 0);
      this.user.jaggSQL.invoke("JDPSubsystemMgr", "start");
   }

   boolean createServerTables() {
      String var2 = this.user.u.getDataSourceType(this.user.jaggSQL);
      this.sourcetype = var2;
      if (var2 == null) {
         return false;
      } else {
         String var3 = "text";
         String var4 = "date";
         String var5 = "float";
         String var6 = "int";
         String var7 = "int";
         String var8 = " NULL";
         if (var2.indexOf(JDPJagg.MSSQLSERVER) < 0 && var2.indexOf(JDPJagg.SYBASE) < 0 && var2.indexOf(JDPJagg.SYBASE10) < 0 && var2.indexOf(JDPJagg.ANYWHERE) < 0) {
            if (var2.indexOf(JDPJagg.FOXPRO) >= 0) {
               var5 = "int";
               var8 = "";
               var3 = "memo";
            } else if (var2.indexOf(JDPJagg.ORACLE) < 0 && var2.indexOf(JDPJagg.POLITE) < 0) {
               if (var2.indexOf(JDPJagg.DB2) >= 0 || var2.indexOf(JDPJagg.SOLIDSERVER) >= 0) {
                  var3 = "long varchar";
                  var5 = "decimal";
                  var8 = "";
               }
            } else {
               var3 = "long";
               var5 = "decimal";
            }
         } else {
            var3 = "text";
            var4 = "datetime";
            var5 = "decimal";
            var7 = "numeric";
         }

         if (var2.indexOf(JDPJagg.LOTUS) >= 0) {
            var3 = "long varchar";
            var5 = "decimal";
            var6 = "integer";
            var7 = "integer";
         }

         if (var2.indexOf(JDPJagg.INFORMIX) >= 0) {
            var3 = "varchar(255)";
            var5 = "decimal";
            var6 = "integer";
            var7 = "integer";
            var8 = "";
         }

         if (var2.indexOf(JDPJagg.CLOUDSCAPE) >= 0) {
            var8 = "";
            var3 = "varchar(" + Integer.toString(Integer.MAX_VALUE) + ")";
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPEvent")) {
            String var1 = "CREATE TABLE JDPEvent (" + "JDPSystem char (5) ," + "EventName char (30) ," + "EventDesc char (70) ," + "EventType char (1) ," + "Frequency char (1) ," + "FreqInt " + var6 + " ," + "FreqDays char (7) ," + "FreqStDay " + var6 + " ," + "FreqWeek " + var6 + " ," + "FreqWeekDy " + var6 + " ," + "StartDate " + var4 + " ," + "StartTime " + var7 + " ," + "EndDate " + var4 + " ," + "EndTime " + var7 + " ," + "RepFreq " + var6 + " ," + "RepFreqUOM char (1) ," + "NextRunTim " + var7 + " ," + "Status char (1) ," + "ObjectType char (1) ," + "Object char (100) ," + "ObjectParm char (250) ," + "ObjectCons char (250) ," + "JobQueue char (30) , " + "JobPriorty " + var6 + " , " + "QuePriorty " + var6 + " , " + "JobHeld char (1) , " + "NotifyUser " + var6 + " ," + "NotifyVia char (1) ," + "NotifyOn char (1) ," + "LogEvent char (1)  ," + "ActualStrt " + var7 + "  ," + "ActualEnd " + var7 + " , " + "lastStatus char (1) " + ")";
            this.user.loginMessage.setStatusMsg("Creating Events table...", 0);
            if (this.runSQL(var1) == -1) {
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPEvtTy")) {
            String var9 = "CREATE TABLE JDPEvtTy (" + "EventType char (1) ," + "TypeDesc char (70) )";
            this.user.loginMessage.setStatusMsg("Creating Event Type table...", 0);
            if (this.runSQL(var9) == -1) {
               return false;
            }

            var9 = "INSERT INTO JDPEvtTy VALUES('O', 'One Time')";
            this.runSQL(var9);
            var9 = "INSERT INTO JDPEvtTy VALUES('R', 'Recurring')";
            this.runSQL(var9);
            var9 = "INSERT INTO JDPEvtTy VALUES('D', 'On Demand')";
            this.runSQL(var9);
            var9 = "INSERT INTO JDPEvtTy VALUES('T', 'Triggered')";
            this.runSQL(var9);
            var9 = "INSERT INTO JDPEvtTy VALUES('A', 'Auto Start')";
            this.runSQL(var9);
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPEvtLo")) {
            this.user.loginMessage.setStatusMsg("Creating Event Log table...", 0);
            String var15 = "CREATE TABLE JDPEvtLo\t(" + "EventId " + var7 + " ,\t" + "JDPSystem char (5) , " + "EventName char (30) ,\t" + "EvtSource char (30) ,\t" + "Category char (30) ,\t" + "UserName char (30) ,\t" + "Computer char (70) ,\t" + "QueueDate " + var4 + " ,\t" + "QueueTime " + var7 + " ,\t" + "JobQueue char (30) ,\t" + "SubSystem char (30) ,\t" + "StartDate " + var4 + " ," + "StartTime " + var7 + " ," + "EndDate " + var4 + " ," + "EndTime " + var7 + " ," + "ObjectType char (1) ," + "Object char (100) ," + "ObjectParm char (250) ," + "ObjectCons char (250) ," + "Notified " + var6 + " ,\t" + "NotifyVia char (1) ,\t" + "TotalTime " + var7 + " ,\t" + "FinalSts " + var6 + " ,\t" + "EventLog " + var3 + " ) ";
            if (this.runSQL(var15) == -1) {
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPJobs")) {
            this.user.loginMessage.setStatusMsg("Creating Jobs table...", 0);
            String var16 = "CREATE TABLE JDPJobs\t(" + "JDPSystem char (5) , " + "StreamName char (30) ,\t" + "StreamDesc char (70) ,\t" + "LastStatus char (1) ,\t" + "LastEntry " + var6 + " ,\t" + "Restart char (1) ,\t" + "ActualStrt " + var4 + " ,\t" + "StartTime " + var7 + " , " + "ActualEnd " + var4 + " ,\t" + "EndTime " + var7 + " ) ";
            if (this.runSQL(var16) == -1) {
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPJobEn")) {
            this.user.loginMessage.setStatusMsg("Creating Job Entry table...", 0);
            String var17 = "CREATE TABLE JDPJobEn\t(" + "JDPSystem char (5) , " + "StreamName char (30) ,\t" + "Entry " + var6 + " ,\t" + "ObjectType char (1) ,\t" + "Object char (100) ,\t" + "ObjectParm char (250) ,\t" + "ObjectCons char (250) ," + "Duration " + var7 + " ,\t" + "LastStatus char (1) , " + "StopIfFail char (1) , " + "LastJobLog " + var3 + ") ";
            if (this.runSQL(var17) == -1) {
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPSubs")) {
            this.user.loginMessage.setStatusMsg("Creating SubSystem table...", 0);
            String var18 = "CREATE TABLE JDPSubs\t(" + "SubSysName char (30) , " + "SubSysDesc char (70) ,\t" + "maxJobs " + var6 + " ,\t" + "priority " + var6 + " ,\t" + "SubSysHeld char (1) " + ") ";
            if (this.runSQL(var18) == -1) {
               return false;
            }

            var18 = "INSERT INTO JDPSubs VALUES('SIMMED', 'Immediate Execution Subsystem', " + "0, " + Integer.toString(5) + ", 'N')";
            this.runSQL(var18);
            var18 = "INSERT INTO JDPSubs VALUES('SBATCH', 'Batch Execution Subsystem', " + "3, " + Integer.toString(5) + ", 'N')";
            this.runSQL(var18);
            var18 = "INSERT INTO JDPSubs VALUES('SSYSTEM', 'System Subsystem', " + "10, " + Integer.toString(5) + ", 'N')";
            this.runSQL(var18);
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPQueue")) {
            this.user.loginMessage.setStatusMsg("Creating Job Queue table...", 0);
            String var22 = "CREATE TABLE JDPQueue\t(" + "QueueName char (30) , " + "QueueDesc char (70) ,\t" + "SubSysName char (30) ,\t" + "QueueHeld char (1) " + ") ";
            if (this.runSQL(var22) == -1) {
               return false;
            }

            var22 = "INSERT INTO JDPQueue VALUES('QIMMED', 'Immediate Execution Job Queue', " + "'SIMMED', 'N')";
            this.runSQL(var22);
            var22 = "INSERT INTO JDPQueue VALUES('QBATCH', 'Batch Execution Job Queue', " + "'SBATCH', 'N')";
            this.runSQL(var22);
            var22 = "INSERT INTO JDPQueue VALUES('QSYSTEM', 'System Job Queue', " + "'SSYSTEM', 'N')";
            this.runSQL(var22);
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPJobA")) {
            this.user.loginMessage.setStatusMsg("Creating Active Job table...", 0);
            String var26 = "CREATE TABLE JDPJobA\t(" + "JDPSystem char (5) ," + "JobName char (30) , " + "JobNumber " + var7 + " , " + "EventType char (1) ,\t" + "JobOwner char (30) ,\t" + "QueueName char (30) ,\t" + "SubSysName char (30) ,\t" + "JobStatus " + var6 + " , " + "JobPriorty " + var6 + " ,\t" + "QuePriorty " + var6 + " , " + "ObjectType char (1) ,\t" + "Object char (100) ,\t" + "ObjectParm char (250) ,\t" + "ObjectCons char (250) ," + "NotifyUser " + var6 + " ," + "NotifyVia char (1) ," + "NotifyOn char (1) ," + "LogEvent char (1)  ," + "QueueDate " + var4 + " ,\t" + "QueueTime " + var7 + " ,\t" + "StartDate " + var4 + " ," + "StartTime " + var7 + " ," + "EndDate " + var4 + " " + var8 + ", " + "EndTime " + var7 + " ," + "JobLog " + var3 + " ) ";
            if (this.runSQL(var26) == -1) {
               return false;
            }
         }

         if (!JDPUtils.check4Table(this.user.jaggSQL, this.sourcetype, "JDPJobNo")) {
            this.user.loginMessage.setStatusMsg("Creating Job Number table...", 0);
            String var27 = "CREATE TABLE JDPJobNo\t(" + "NextJobNum " + var7 + ") ";
            if (this.runSQL(var27) == -1) {
               this.user.u.setSqlMessage(this.user.jaggSQL, var27);
            }

            var27 = "INSERT INTO JDPJobNo VALUES(0)";
            this.runSQL(var27);
            this.createIndexes();
         }

         return true;
      }
   }

   int runSQL(String var1) {
      Vector var2 = new Vector();
      int var3 = this.user.jaggSQL.execSQL(var1, var2);
      if (var3 == -1) {
         this.user.u.setSqlMessage(this.user.jaggSQL, var1);
      }

      return var3;
   }

   public JDPSetupSvr(JDPUser var1) {
      this.user = var1;
      if (var1.JDPSystem.equals("01001")) {
         this.createServerTables();
         this.startEnterpriseServer();
         this.createPurgeEvent();
      }

      this.createMenuOptions();
   }

   void createIndexes() {
      this.user.loginMessage.setStatusMsg("Creating Indexes...", 0);
      String var1 = "CREATE UNIQUE INDEX JDPEvtIx ON JDPEvent " + "(JDPSystem, EventName)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPEvtTx ON JDPEvtTy " + "(EventType)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPEvtLx ON JDPEvtLo " + "(EventId)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPJobsx ON JDPJobs " + "(JDPSystem,StreamName)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPJobEx ON JDPJobEn " + "(JDPSystem,StreamName,Entry)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPSubsx ON JDPSubs " + "(SubSysName)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPQueux ON JDPQueue " + "(QueueName)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPJobAx ON JDPJobA " + "(JDPSystem,JobName,JobNumber)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPJobA1 ON JDPJobA " + "(JobNumber)";
      this.runSQL(var1);
   }

   void createMenuOptions() {
      this.user.loginMessage.setStatusMsg("Creating Enterprise Server Menu...", 0);
      this.createMenuOption("Main", 19, "M", "Enterprise Server", "JDPServer", "", "ADMIN");
      this.createMenuOption("JDPServer", 0, "P", "Help", "JDPHelpBrowser", "Docs/jdpentsvrmnu.htm", "*ALL");
      this.createMenuOption("JDPServer", 1, "P", "Server Manager", "JDPServerConsole", "", "*ALL");
      this.createMenuOption("JDPServer", 2, "P", "Job Log Inquiry", "JDPJobLogInquiry", "", "*ALL");
      this.createMenuOption("JDPServer", 3, "P", "Event Maintenance", "JDPEventMaintenance", "", "*ALL");
      this.createMenuOption("JDPServer", 4, "P", "Job Stream Maintenance", "JDPJobStreamMaint", "", "*ALL");
   }

   void createMenuOption(String var1, int var2, String var3, String var4, String var5, String var6, String var7) {
      String var8 = Integer.toString(var2);
      String var9 = "SELECT menuname FROM JDPMenu WHERE JDPSystem = '" + this.user.JDPSystem + "' AND menuname = '" + var1 + "' AND menunum = " + var8;
      if (this.runSQL(var9) < 1) {
         var9 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','" + var1 + "'," + var8 + "," + "'" + var3 + "','" + var5 + "','" + var6 + "', " + "'" + var4 + "'," + "'A'," + "'Black', " + "'LightGray'," + "'" + var7 + "','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var9);
      }

   }

   public void createPurgeEvent() {
      this.user.loginMessage.setStatusMsg("Creating default jobs...", 0);
      String var1 = "SELECT EVENTNAME " + "FROM JDPEVENT " + "WHERE JDPSYSTEM = '01001' " + "AND OBJECTTYPE = 'C' " + "AND OBJECT = 'JDPPurgeJobLog' ";
      int var2 = this.runSQL(var1);
      if (var2 == 0) {
         var1 = "INSERT INTO JDPEVENT " + "(JDPSYSTEM, " + "EVENTNAME, " + "EVENTDESC, " + "EVENTTYPE, " + "FREQUENCY, " + "FREQINT, " + "FREQDAYS, " + "FREQSTDAY, " + "FREQWEEK, " + "FREQWEEKDY, " + "STARTDATE, " + "STARTTIME, " + "ENDDATE, " + "ENDTIME, " + "REPFREQ, " + "REPFREQUOM, " + "NEXTRUNTIM, " + "STATUS, " + "OBJECTTYPE, " + "OBJECT, " + "OBJECTPARM, " + "OBJECTCONS, " + "JOBQUEUE, " + "JOBPRIORTY, " + "QUEPRIORTY, " + "JOBHELD, " + "NOTIFYUSER, " + "NOTIFYVIA, " + "NOTIFYON, " + "LOGEVENT, " + "ACTUALSTRT, " + "ACTUALEND, " + "LASTSTATUS)" + "VALUES ('01001', " + "'Purge Job Logs', " + "'Purge Job Logs older than 10 days', " + "'R', " + "'D', " + "1, " + "'NNNNNNN', " + "1, " + "0, " + "0, " + JDPDate.formatForSql(new Date(), this.sourcetype) + ", " + "32400000, " + JDPDate.formatForSql(new Date(0L), this.sourcetype) + ", " + "0, " + "1, " + "'H', " + "0, " + "'Y', " + "'C', " + "'JDPPurgeJobLog', " + "'JDPSubsystemMgr,JDPJob,10', " + "'(JDPSubsystemMgr,JDPJob,int)', " + "'QBATCH', " + "5, " + "5, " + "'N', " + "-1, " + "'P', " + "'F', " + "'B', " + "0, 0, ' ')";
         this.runSQL(var1);
      }

   }
}
