import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Date;

public class JDPSpinner extends Panel {
   JDPButton upButton;
   JDPButton downButton;
   TextField text;
   int lastValue;
   int minValue = -99999999;
   int maxValue = 99999999;
   Font currentFont;
   Color fgColor;
   Color bgColor;

   public void setValue(int var1) {
      if (var1 > this.maxValue) {
         var1 = this.maxValue;
      }

      if (var1 < this.minValue) {
         var1 = this.minValue;
      }

      this.text.setText(Integer.toString(var1));
   }

   public void setBackground(Color var1) {
      this.text.setBackground(var1);
      if (!var1.equals(Color.white)) {
         this.upButton.setBackground(var1);
      }

      if (!var1.equals(Color.white)) {
         this.downButton.setBackground(var1);
      }

   }

   public Color getBackground() {
      if (this.bgColor != null) {
         return this.bgColor;
      } else {
         Container var1 = ((Component)this).getParent();
         return var1 != null ? ((Component)var1).getBackground() : null;
      }
   }

   public int getValue() {
      String var1 = this.text.getText();
      int var2 = 0;

      try {
         var2 = Integer.parseInt(var1);
      } catch (Exception var3) {
      }

      return var2;
   }

   public void setMinValue(int var1) {
      if (this.getValue() < var1) {
         this.setValue(var1);
      }

      this.minValue = var1;
   }

   public int getMinValue() {
      return this.minValue;
   }

   public void setEditable(boolean var1) {
      this.text.setEditable(var1);
   }

   public boolean getEditable() {
      return this.text.isEditable();
   }

   public void setMaxValue(int var1) {
      if (this.getValue() > var1) {
         this.setValue(var1);
      }

      this.maxValue = var1;
   }

   public void setFont(Font var1) {
      this.currentFont = var1;
      this.text.setFont(var1);
   }

   public Font getFont() {
      if (this.currentFont != null) {
         return this.currentFont;
      } else {
         Container var1 = ((Component)this).getParent();
         return var1 != null ? ((Component)var1).getFont() : null;
      }
   }

   public int getMaxValue() {
      return this.maxValue;
   }

   public void enable() {
      this.setEnabled(true);
   }

   public void disable() {
      this.setEnabled(false);
   }

   public JDPSpinner() {
      this.initSpinner((JDPUser)null, "", 20);
   }

   public JDPSpinner(JDPUser var1) {
      this.initSpinner(var1, "", 20);
   }

   public JDPSpinner(JDPUser var1, int var2) {
      this.initSpinner(var1, "", var2);
   }

   public JDPSpinner(JDPUser var1, String var2, int var3) {
      this.initSpinner(var1, var2, var3);
   }

   void initSpinner(JDPUser var1, String var2, int var3) {
      this.upButton = new JDPButton(3);
      this.downButton = new JDPButton(4);
      this.text = new TextField(var2, var3);
      ((Container)this).setLayout(new BorderLayout());
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new GridLayout(2, 1));
      this.upButton = new JDPButton(3);
      this.downButton = new JDPButton(4);
      ((Container)var4).add(this.upButton);
      ((Container)var4).add(this.downButton);
      ((Container)this).add("East", var4);
      ((Container)this).add("Center", this.text);
   }

   public int getColumns() {
      return this.text.getColumns();
   }

   public boolean handleEvent(Event var1) {
      if (var1.target.equals(this)) {
         return false;
      } else if (var1.target instanceof Button) {
         return true;
      } else {
         switch (var1.id) {
            case 1001:
               if (var1.target.equals(this.upButton)) {
                  this.setValue(this.getValue() + 1);
                  Event var4 = new Event(this, (new Date()).getTime(), 1001, 0, 0, 1004, 0, new Integer(this.getValue()));
                  ((Component)this).postEvent(var4);
                  return true;
               } else {
                  if (var1.target.equals(this.downButton)) {
                     this.setValue(this.getValue() - 1);
                     Event var2 = new Event(this, (new Date()).getTime(), 1001, 0, 0, 1005, 0, new Integer(this.getValue()));
                     ((Component)this).postEvent(var2);
                     return true;
                  }

                  var1.target = this;
                  ((Component)this).postEvent(var1);
                  return true;
               }
            default:
               var1.target = this;
               super.handleEvent(var1);

               try {
                  int var5 = Integer.parseInt(this.text.getText());
                  this.lastValue = var5;
               } catch (Exception var3) {
                  this.setValue(this.lastValue);
               }

               return false;
         }
      }
   }

   public void setForeground(Color var1) {
      this.fgColor = var1;
      this.text.setForeground(var1);
      this.upButton.setForeground(var1);
      this.downButton.setForeground(var1);
   }

   public Color getForeground() {
      if (this.fgColor != null) {
         return this.fgColor;
      } else {
         Container var1 = ((Component)this).getParent();
         return var1 != null ? ((Component)var1).getForeground() : null;
      }
   }

   public void setEnabled(boolean var1) {
      if (var1) {
         this.text.enable();
         this.upButton.enable();
         this.downButton.enable();
      } else {
         this.text.disable();
         this.upButton.disable();
         this.downButton.disable();
      }
   }

   public boolean getEnabled() {
      return this.text.isEnabled();
   }

   public void setText(String var1) {
      try {
         this.setValue(Integer.parseInt(var1));
      } catch (Exception var2) {
      }
   }

   public String getText() {
      return this.text.getText();
   }
}
