import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.TextField;
import java.io.PrintStream;

public class JDPStatusMessage extends Panel {
   JDPUser user;
   PrintStream serverResponse;
   String statusMessage = "";
   String infoMessage = "";
   // $FF: renamed from: p JDPStatusMessageThread
   JDPStatusMessageThread field_0;
   Image offscreen;
   Dimension offscreensize;
   Graphics offgraphics;
   TextField message;
   TextField eastMessage;
   TextField dummy;
   String jobName;
   Font msgFont;
   Font infoFont;
   Component comp;
   // $FF: renamed from: NL java.lang.String
   static String field_1 = "\u0002";
   static String EOT = "\u0001";

   public JDPStatusMessage(JDPUser var1) {
      this.user = var1;
      ((Container)this).setLayout(new BorderLayout());
      if (var1 != null) {
         this.message = new TextField("", 2000);
      } else {
         this.message = new TextField("", 40);
      }

      this.eastMessage = new TextField("", 21);
      this.message.setEditable(false);
      this.eastMessage.setEditable(false);
      this.msgFont = new Font("Helvetica", 1, 11);
      this.infoFont = new Font("Helvetica", 0, 11);
      this.message.setFont(this.msgFont);
      this.eastMessage.setFont(this.msgFont);
      if (var1 != null) {
         ((Container)this).add("East", this.eastMessage);
      }

      ((Container)this).add("Center", this.message);
      this.dummy = new TextField("", 10);
      this.dummy.requestFocus();
   }

   public JDPStatusMessage(JDPUser var1, PrintStream var2, String var3) {
      this.user = var1;
      this.serverResponse = var2;
      this.jobName = var3;
   }

   public void clearStatusMsg() {
      this.statusMessage = "";
      this.message.setText("");
      ((Container)this).layout();
      ((Component)this).paintAll(((Component)this).getGraphics());
      if (this.comp != null) {
         this.comp.hide();
      }

      this.clearInfoMsg();
   }

   private void writeLn(String var1) throws Exception {
      this.writeLn(var1, -1);
   }

   private void writeLn(String var1, int var2) throws Exception {
      if (var1 != null && var1.length() != 0) {
         if (var2 >= 0) {
            var1 = Integer.toString(var2) + "\u0003" + var1;
         }

         int var3 = var1.length();

         for(int var4 = 0; var4 < var3; ++var4) {
            this.serverResponse.write(var1.charAt(var4));
         }

      } else {
         this.serverResponse.write(32);
      }
   }

   public void setStatusMsg(String var1, int var2) {
      if (JDPLang.p != null) {
         if (var1.equals("Accessing database...")) {
            var1 = JDPLang.get("Message0");
         }

         if (var1.equals("Multiple records found - first match only displayed.")) {
            var1 = JDPLang.get("Message1");
         }

         if (var1.equals("Requested entry does not exist.")) {
            var1 = JDPLang.get("Message2");
         }

         if (var1.equals("You must first make a selection")) {
            var1 = JDPLang.get("Message3");
         }

         if (var1.equals("Record successfully added.")) {
            var1 = JDPLang.get("Message4");
         }

         if (var1.equals("Record successfully removed.")) {
            var1 = JDPLang.get("Message5");
         }

         if (var1.equals("Record successfully updated.")) {
            var1 = JDPLang.get("Message6");
         }

         if (var1.equals("No records found that match the selected criteria")) {
            var1 = JDPLang.get("Message10");
         }
      }

      if (this.serverResponse != null) {
         var1 = this.jobName + ": " + var1;

         try {
            this.writeLn(var1, var2);
            this.writeLn(field_1);
         } catch (Exception var5) {
            ((Throwable)var5).printStackTrace();
         }
      } else {
         if (this.field_0 != null) {
            this.field_0.stop();
            this.field_0 = null;
            if (this.comp != null) {
               this.comp.hide();
            }
         }

         this.statusMessage = var1;
         this.message.setText(var1);
         this.message.setFont(this.msgFont);
         ((Container)this).layout();
         ((Component)this).paintAll(((Component)this).getGraphics());
         if (var2 > 0) {
            this.field_0 = new JDPStatusMessageThread(this, var2);
            this.field_0.start();
         }

      }
   }

   void setStatusMsg(String var1, int var2, int var3, Component var4) {
      if (this.statusMessage.equals("")) {
         if (this.comp != null && this.comp != var4) {
            this.comp.hide();
         }

         this.comp = var4;
         if (var3 > 0) {
            if (this.getStatusMsg().equals("") || this.getStatusMsg().equals(this.infoMessage) && !this.getStatusMsg().equals(var1)) {
               this.infoMessage = var1;
               if (this.field_0 != null && var1.equals(this.getStatusMsg())) {
                  this.waitMore(var2);
                  return;
               }

               if (this.field_0 != null) {
                  this.field_0.stop();
               }

               this.field_0 = new JDPStatusMessageThread(this, var2, var3, var4);
               this.field_0.start();
               return;
            }
         } else if (this.infoMessage == null || !this.infoMessage.equals(var1)) {
            this.infoMessage = var1;
            this.message.setFont(this.infoFont);
            this.message.setText(this.infoMessage);
            ((Container)this).layout();
            ((Component)this).paintAll(((Component)this).getGraphics());
         }

      }
   }

   public void setPercent(int var1) {
      if (var1 < 0) {
         ((Container)this).add("East", this.eastMessage);
         ((Container)this).layout();
      } else {
         if (var1 == 0) {
            ((Container)this).remove(this.eastMessage);
            this.eastMessage.size();
            ((Container)this).layout();
         }

      }
   }

   void clearPopupMsg() {
      if (this.statusMessage.equals("")) {
         this.message.setText("");
         ((Container)this).layout();
         ((Component)this).paintAll(((Component)this).getGraphics());
      }

      if (this.comp != null) {
         this.comp.hide();
      }

      this.infoMessage = "";
      if (this.statusMessage.equals("")) {
         if (this.field_0 != null) {
            this.field_0.stop();
         }

         this.field_0 = null;
      }

   }

   public String getStatusMsg() {
      return this.message.getText();
   }

   void clearInfoMsg() {
      this.infoMessage = "";
      if (this.statusMessage.equals("")) {
         if (this.field_0 != null) {
            this.field_0.stop();
         }

         this.field_0 = null;
      }

   }

   public boolean isStatusMsg() {
      return this.message.getText().length() > 0;
   }

   void waitMore(int var1) {
      if (this.statusMessage.equals("") && this.field_0 != null) {
         this.field_0.waitAgain = var1;

         try {
            if (this.field_0 != null) {
               this.field_0.interruptThread();
               return;
            }
         } catch (Exception var2) {
         }
      }

   }

   void setInfoMsg(String var1, int var2) {
      this.setStatusMsg(var1, 0, var2, (Component)null);
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 1004:
            if ((var1.target.equals(this.message) || var1.target.equals(this.eastMessage)) && this.user != null && this.user.jdpMenuPanel != null) {
               this.user.jdpMenuPanel.requestFocus();
               return true;
            }
         default:
            return false;
      }
   }
}
