import java.awt.Component;
import java.awt.Container;

class JDPStatusMessageThread extends Thread {
   JDPStatusMessage target;
   int clearAfter = 10;
   int waitFor = -1;
   Component comp;
   int waitAgain;

   public JDPStatusMessageThread(JDPStatusMessage var1, int var2) {
      this.target = var1;
      this.clearAfter = var2;
      this.waitFor = -1;
      this.comp = null;
   }

   public JDPStatusMessageThread(JDPStatusMessage var1, int var2, int var3, Component var4) {
      this.target = var1;
      this.waitFor = var2;
      this.clearAfter = var3;
      this.comp = var4;
   }

   public void run() {
      if (this.waitFor >= 0) {
         if (this.target.statusMessage.equals("") && (this.comp == null || this.comp != null && this.comp.isEnabled())) {
            this.target.message.setFont(this.target.infoFont);
            this.target.message.setText(this.target.infoMessage);
            this.target.layout();
            this.target.paintAll(this.target.getGraphics());
         }

         while(this.waitFor > 0) {
            try {
               if (this.waitFor > 199) {
                  Thread.sleep((long)this.waitFor);
               } else {
                  Thread.sleep((long)(this.waitFor * 1000));
               }
            } catch (InterruptedException var3) {
            }

            this.waitFor = this.waitAgain;
            this.waitAgain = 0;
         }

         if (this.comp != null && this.comp.isEnabled()) {
            if (this.target.statusMessage.equals("")) {
               this.target.message.setFont(this.target.infoFont);
               this.target.message.setText(this.target.infoMessage);
               this.target.layout();
               this.target.paintAll(this.target.getGraphics());
            }

            if (this.comp instanceof JDPPopupMessage) {
               if (((JDPPopupMessage)this.comp).popupMessage.length() > 0) {
                  this.comp.show();
               } else {
                  this.comp.hide();
               }
            } else {
               this.comp.show();
            }

            Container var1 = this.comp.getParent();
            if (System.getProperty("java.vendor").startsWith("Netscape") && System.getProperty("os.name").equals("SunOS")) {
               var1.remove(this.comp);
               var1.add(this.comp);
               this.comp.show();
            }
         }
      }

      try {
         if (this.clearAfter > 999) {
            Thread.sleep((long)this.clearAfter);
         } else {
            Thread.sleep((long)(this.clearAfter * 1000));
         }
      } catch (InterruptedException var2) {
      }

      if (this.comp != null) {
         this.comp.hide();
      }

      this.target.clearStatusMsg();
   }

   void interruptThread() {
      ((Thread)this).interrupt();
   }
}
