import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;

public class JDPSubmitJob extends Thread {
   PrintStream serverResponse;
   JDPUser user;
   JDPSaveProps params;
   String jobName;
   Object targetClass;
   String Parameters;

   public JDPSubmitJob(JDPUser var1, JDPJagg var2, String var3, JDPSaveProps var4, Object var5) {
      this.user = var1;
      this.jobName = var3;
      this.targetClass = var5;
      var4.saveObject("jaggPath", var1.jaggPath);
      var4.saveObject("userjaggDSN", var1.jaggSQL.getDSN());
      var4.saveObject("userjaggCSTR", var1.jaggSQL.getCSTR());
      var4.saveObject("userjdbcDriver", var1.jaggSQL.getJdbcDriver());
      var4.saveObject("userjdbcPrefix", var1.jaggSQL.getJdbcPrefix());
      var4.saveObject("userjdbcSuffix", var1.jaggSQL.getJdbcSuffix());
      var4.saveObject("userjdbcUserid", var1.jaggSQL.getUID());
      var4.saveObject("userjdbcPassword", var1.jaggSQL.getPWD());
      var4.saveObject("userjaggPort", var1.jaggSQL.getPort());
      if (var2 != null) {
         var4.saveObject("jaggDSN", var2.getDSN());
         var4.saveObject("jaggCSTR", var2.getCSTR());
         var4.saveObject("jdbcDriver", var2.getJdbcDriver());
         var4.saveObject("jdbcPrefix", var2.getJdbcPrefix());
         var4.saveObject("jdbcSuffix", var2.getJdbcSuffix());
         var4.saveObject("jdbcUserid", var2.getUID());
         var4.saveObject("jdbcPassword", var2.getPWD());
      }

      ByteArrayOutputStream var6 = new ByteArrayOutputStream();
      var4.p.save((OutputStream)var6, var3);
      this.Parameters = var6.toString();
      if (!JDPJagg.useJaggServer) {
         var1.mainmsg.setStatusMsg("Jobs can only be submitted when running JaggServer", 15);
      } else {
         ((Thread)this).start();
      }
   }

   public void run() {
      JDPJagg var1 = new JDPJagg(this.user.jaggPath);
      var1.loadSettings(this.user);
      var1.setFCTN("ServerJob");
      var1.setFCTNP(this.jobName);
      var1.remoteJob(this.Parameters, this.user.mainmsg, this.targetClass);
   }
}
