import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.Panel;
import java.awt.TextArea;
import java.util.Date;
import java.util.StringTokenizer;

public class JDPSubsystemMaint extends JDPClassLayout {
   JDPUser user;
   JDPJagg jaggSQL;
   JDPPopupMessage popuppanel;
   JDPMaskEdit JDPMaskEditMain;
   String moduleParameter;
   Panel Main;
   JDPPopupMenu PopupMenu1;
   JDPChiselFramePanel ChiselPanel1;
   Panel Panel1;
   JDPButtons JDPButtons1;
   JDPSplitPanel SplitPanel1;
   JDPTextGrid GridPanel1;
   TextArea jobLog;
   JDPMessageDialog MessageBox1;
   Thread thisThread;
   JDPJagg jaggSQL1;
   boolean loading = false;
   boolean firsttime = true;
   long waitSeconds = 60L;
   boolean jobLogShowing = true;
   boolean creatingNewSubsystem = false;

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      this.user = var1;
      this.moduleParameter = var3;
      super.targetPanel = var2;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      ((Container)this).setLayout(new BorderLayout());
      this.popuppanel = new JDPPopupMessage(var1, this);
      ((Container)this).add(this.popuppanel);
      this.JDPMaskEditMain = new JDPMaskEdit();
      this.Main = new Panel();
      this.PopupMenu1 = new JDPPopupMenu(var1.getJDPUser(), this.Main);
      this.ChiselPanel1 = new JDPChiselFramePanel(var1, "Active Jobs Display");
      this.Panel1 = new Panel();
      String[] var4 = new String[]{"Refresh", "Hide Job Log"};
      int[] var5 = new int[]{JDPButton.getIconValue("Undo"), JDPButton.getIconValue("Delete")};
      this.JDPButtons1 = new JDPButtons(var1, var4, var5, JDPButtons.getAlignmentValue("Horizontal"));
      this.SplitPanel1 = new JDPSplitPanel(var1);
      this.GridPanel1 = new JDPTextGrid(var1);
      this.jobLog = new TextArea("", 3, 20);
      this.MessageBox1 = new JDPMessageDialog(var1, this);
      this.Main.setLayout(new BorderLayout());
      ((Container)this).add("Center", this.Main);
      this.Main.add("West", this.PopupMenu1);
      this.Main.add("Center", this.ChiselPanel1);
      this.ChiselPanel1.add("Center", this.Panel1);
      this.Panel1.setLayout(new BorderLayout());
      this.Panel1.add("South", this.JDPButtons1);
      this.Panel1.add("Center", this.SplitPanel1);
      this.SplitPanel1.add("Left", this.GridPanel1);
      this.SplitPanel1.add("Left", this.jobLog);
      this.SplitPanel1.setLeftPercentage(50.0F);
      this.SplitPanel1.setTopPercentage(75.0F);
      this.GridPanel1.setBackground(var1.u._cvtcolor("LightGray"));
      this.popuppanel.addComponent(this.GridPanel1, "", "Click on a Subsystem, Job or the panel for Options.");
      this.GridPanel1.setTableDimensions(9, 50);
      this.GridPanel1.setColumnHeader(0, "Subsystem|     Job Name");
      this.GridPanel1.setColumnHeader(1, " |Job Number");
      this.GridPanel1.setColumnHeader(2, "Status|");
      this.GridPanel1.setColumnHeader(3, "Max Jobs|Owner");
      this.GridPanel1.setColumnHeader(4, "Priority|");
      this.GridPanel1.setColumnHeader(5, " |Type");
      this.GridPanel1.setColumnHeader(6, " |Started");
      this.GridPanel1.setColumnHeader(7, " |Elapsed");
      this.GridPanel1.setColumnHeader(8, " |System");
      this.GridPanel1.setColumnWidth(0, 135);
      this.GridPanel1.setColumnWidth(1, 80);
      this.GridPanel1.setColumnWidth(2, 50);
      this.GridPanel1.setColumnWidth(3, 102);
      this.GridPanel1.setColumnWidth(4, 45);
      this.GridPanel1.setColumnWidth(5, 80);
      this.GridPanel1.setColumnWidth(6, 105);
      this.GridPanel1.setColumnWidth(7, 90);
      this.GridPanel1.setColumnWidth(8, 50);
      this.GridPanel1.setColumnHeaderHeight(24);
      this.jobLog.setBackground(var1.u._cvtcolor("LightGray"));
      this.jobLog.setEditable(false);
      this.MessageBox1.setTitle("Confirm");
      this.MessageBox1.setButtonCount(2);
      this.MessageBox1.setButtonIcon(0, 8);
      this.MessageBox1.setButtonIcon(1, 6);
      this.MessageBox1.setButtonText(0, "Delete");
      this.MessageBox1.setButtonText(1, "Cancel");
      var1.gParm.addElement(this);
      this.InitComponents();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 701:
            if (var1.target.equals(this.GridPanel1)) {
               if (!this.PopupMenu1LoadMenu()) {
                  return true;
               }

               this.PopupMenu1.display(var1.x, var1.y);
               return true;
            }

            return false;
         case 1001:
            if (var1.target.equals(this.PopupMenu1)) {
               this.PopupMenu1HandleSelection();
               return true;
            } else if (var1.target.equals(this.JDPButtons1.button[0])) {
               this.LoadGridWithSubsystemData();
               this.refreshJobLog();
               return true;
            } else {
               if (var1.target.equals(this.JDPButtons1.button[1])) {
                  this.setJobLogVisible(false);
                  return true;
               }

               return false;
            }
         case 1005:
            if (var1.target.equals(this.GridPanel1)) {
               if (this.creatingNewSubsystem && this.GridPanel1.getCurrentColumn() != 0) {
                  if (!this.GridPanel1.getText(0, this.GridPanel1.getCurrentRow()).equals("")) {
                     this.GridPanel1CreateNewSubsystem();
                  } else {
                     this.creatingNewSubsystem = false;
                  }

                  return true;
               }

               if (this.creatingNewSubsystem) {
                  this.GridPanel1.setCursorInThisCell(0, this.GridPanel1.getCurrentRow());
                  this.GridPanel1.requestFocus();
                  return true;
               }

               return true;
            }

            return false;
         default:
            return false;
      }
   }

   public void InitComponents() {
      this.setJobLogVisible(false);
      this.jaggSQL.setKeepConnectionOpen(false);
      this.GridPanel1.setGridColor(Color.white);
      this.LoadGridWithSubsystemData();
      this.thisThread = new Thread(this);
      this.thisThread.start();
      this.jaggSQL1 = new JDPJagg(this.user.jaggPath);
      this.jaggSQL1.loadSettings(this.user);
   }

   public boolean LoadGridWithSubsystemData() {
      if (this.loading) {
         return false;
      } else {
         this.loading = true;
         String var1 = this.jaggSQL.getSEP();
         this.jaggSQL.loadSettings(this.user);
         this.creatingNewSubsystem = false;
         if (this.user.mainmsg.getStatusMsg().equals("")) {
            this.user.mainmsg.setStatusMsg("Refreshing...", 0);
         }

         this.jaggSQL.setKeepConnectionOpen(true);
         String var2 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "getSubsystems");
         if (var2 == null) {
            this.ResetGridSize(9, 10);
            this.user.mainmsg.setStatusMsg("Enterprise Server has not yet started.", 10);
            this.loading = false;
            return false;
         } else {
            StringTokenizer var3 = new StringTokenizer(var2, var1);
            int var4 = var3.countTokens() / 5;
            String[] var5 = new String[var4];
            String[] var6 = new String[var4];
            int[] var7 = new int[var4];
            boolean[] var8 = new boolean[var4];
            int[] var9 = new int[var4];

            for(int var10 = 0; var3.hasMoreTokens(); ++var10) {
               var5[var10] = var3.nextToken().trim();
               var6[var10] = var3.nextToken().trim();
               var7[var10] = Integer.parseInt(var3.nextToken().trim());
               var8[var10] = var3.nextToken().trim().equals("Y");
               var9[var10] = Integer.parseInt(var3.nextToken().trim());
            }

            String var11 = (String)this.jaggSQL.invoke("JDPSubsystemMgr", "getActiveJobs");
            this.jaggSQL.setKeepConnectionOpen(false);
            int var12 = 0;
            String[] var13 = new String[var12];
            String[] var14 = new String[var12];
            String[] var15 = new String[var12];
            int[] var16 = new int[var12];
            String[] var17 = new String[var12];
            String[] var18 = new String[var12];
            Date[] var19 = new Date[var12];
            int[] var20 = new int[var12];
            int[] var21 = new int[var12];
            long[] var22 = new long[var12];
            if (var11 != null) {
               var3 = new StringTokenizer(var11, var1);
               var12 = var3.countTokens() / 10;
               var13 = new String[var12];
               var14 = new String[var12];
               var15 = new String[var12];
               var16 = new int[var12];
               var17 = new String[var12];
               var18 = new String[var12];
               var19 = new Date[var12];
               var20 = new int[var12];
               var21 = new int[var12];
               var22 = new long[var12];

               for(int var43 = 0; var3.hasMoreTokens(); ++var43) {
                  var13[var43] = var3.nextToken().trim();
                  var14[var43] = var3.nextToken().trim();
                  var15[var43] = var3.nextToken().trim();
                  var16[var43] = Integer.parseInt(var3.nextToken().trim());
                  var17[var43] = var3.nextToken().trim();
                  var18[var43] = var3.nextToken().trim();
                  var19[var43] = new Date(Long.valueOf(var3.nextToken().trim()));
                  var20[var43] = Integer.parseInt(var3.nextToken().trim());
                  var21[var43] = Integer.parseInt(var3.nextToken().trim());
                  var22[var43] = Long.valueOf(var3.nextToken().trim());
               }
            }

            int var23 = var5.length * 2 + var13.length + 2;
            this.ResetGridSize(9, var23);
            int var24 = 0;

            for(int var25 = 0; var25 < var5.length; ++var25) {
               this.GridPanel1.setCellFont(0, var24, this.user.boldFont);
               this.GridPanel1.setText(var5[var25], 0, var24);
               this.GridPanel1.setText(var8[var25] ? "Held" : "Active", 2, var24);
               this.GridPanel1.setCellFont(3, var24, this.user.boldFont);
               this.GridPanel1.setText(var7[var25] > 0 ? Integer.toString(var7[var25]) : "*NOMAX", 3, var24);
               this.GridPanel1.setText(Integer.toString(var9[var25]), 4, var24);

               for(int var26 = 0; var26 < var13.length; ++var26) {
                  if (var14[var26].equals(var5[var25])) {
                     ++var24;
                     this.GridPanel1.setCellFont(0, var24, this.user.plainFont);
                     this.GridPanel1.setText("     " + var13[var26], 0, var24);
                     this.GridPanel1.setText(Integer.toString(var16[var26]), 1, var24);
                     this.GridPanel1.setText(var20[var26] == 4 ? "Active" : "Held", 2, var24);
                     this.GridPanel1.setText(var17[var26], 3, var24);
                     this.GridPanel1.setText(Integer.toString(var21[var26]), 4, var24);
                     this.GridPanel1.setText(var18[var26], 5, var24);
                     String var27 = JDPDate.format(var19[var26]);
                     int var28 = var19[var26].getHours();
                     String var29 = "AM";
                     if (var28 > 11) {
                        var29 = "PM";
                     }

                     if (var28 > 12) {
                        var28 -= 12;
                     }

                     if (var28 == 0) {
                        var28 = 12;
                     }

                     var27 = var27 + " " + Integer.toString(var28);
                     String var30 = Integer.toString(var19[var26].getMinutes());
                     if (var30.length() == 1) {
                        var30 = "0" + var30;
                     }

                     var27 = var27 + ":" + var30 + " " + var29;
                     this.GridPanel1.setText(var27, 6, var24);
                     long var31 = var22[var26] - var19[var26].getTime();
                     long var33 = var31 / 86400000L;
                     long var35 = (var31 - var33 * 24L * 3600000L) / 3600000L;
                     long var37 = (var31 - var33 * 24L * 3600000L - var35 * 3600000L) / 60000L;
                     long var39 = (var31 - var33 * 24L * 3600000L - var35 * 3600000L - var37 * 60000L) / 1000L;
                     String var41 = "";
                     if (var33 > 0L) {
                        var41 = var41 + Long.toString(var33) + "d ";
                     }

                     if (var35 > 0L) {
                        var41 = var41 + Long.toString(var35) + "h ";
                     }

                     var41 = var41 + Long.toString(var37) + "m " + Long.toString(var39) + "s";
                     this.GridPanel1.setText(var41, 7, var24);
                     this.GridPanel1.setText(var15[var26], 8, var24);
                  }
               }

               var24 += 2;
            }

            if (this.user.mainmsg.getStatusMsg().equals("Refreshing...")) {
               this.user.mainmsg.clearStatusMsg();
            }

            this.user.JDesignerPro.gc();
            this.loading = false;
            return true;
         }
      }
   }

   public void ResetGridSize(int var1, int var2) {
      this.GridPanel1.setTableDimensions(var1, var2);
      this.GridPanel1.setGridColor(Color.white);

      for(int var3 = 0; var3 < var2; ++var3) {
         this.GridPanel1.setCellEnabled(0, var3, false);
      }

      for(int var4 = 1; var4 < var1; ++var4) {
         this.GridPanel1.setColumnEnabled(var4, false);
      }

      for(int var5 = 0; var5 < var2; ++var5) {
         this.GridPanel1.setRowHeader(var5, "");
      }

      if (this.firsttime) {
         Graphics var6 = super.targetPanel.getGraphics();
         int var7 = 2 * this.user.u.StringHeight(var6) - 2;
         if (var7 > 0) {
            this.GridPanel1.setColumnHeaderHeight(var7);
         }

         int var8 = this.user.u.StringWidth(this.user.mainmsg.message.getGraphics(), "O");
         int var9 = this.user.u.StringWidth(var6, "O");
         float var10 = (float)var9 / (float)var8;
         if (var10 != 1.0F && var10 != 0.0F) {
            for(int var11 = 0; var11 < var1; ++var11) {
               this.GridPanel1.setColumnWidth(var11, (int)((float)this.GridPanel1.getColumnWidth(var11) * var10));
            }
         }

         if (var10 != 0.0F) {
            this.firsttime = false;
         }
      }

   }

   public void run() {
      while(true) {
         try {
            for(; this.waitSeconds > 0L; Thread.sleep(this.waitSeconds * 1000L)) {
               if (((Component)this).isShowing() && this.LoadGridWithSubsystemData()) {
                  this.refreshJobLog();
               }
            }

            Thread.sleep(600000L);
         } catch (Exception var1) {
         }
      }
   }

   public void setJobLogVisible(boolean var1) {
      if (var1) {
         if (!this.jobLogShowing) {
            this.jobLog.show();
            this.SplitPanel1.layout();
            this.SplitPanel1.paintAll(this.SplitPanel1.getGraphics());
            this.jobLogShowing = true;
            this.JDPButtons1.button[1].show();
            this.JDPButtons1.layout();
            this.JDPButtons1.paintAll(this.JDPButtons1.getGraphics());
         }
      } else if (this.jobLogShowing) {
         this.jobLog.hide();
         this.SplitPanel1.layout();
         this.SplitPanel1.paintAll(this.SplitPanel1.getGraphics());
         this.jobLogShowing = false;
         this.JDPButtons1.button[1].hide();
         this.JDPButtons1.layout();
         this.JDPButtons1.paintAll(this.JDPButtons1.getGraphics());
      }
   }

   public void MainMethod() {
   }

   public void refreshJobLog() {
      if (this.jobLog.isVisible()) {
         String var1 = this.GridPanel1.getText(1, this.GridPanel1.getCurrentRow());

         try {
            Integer.parseInt(var1);
            String[] var2 = new String[]{"int"};
            String[] var3 = new String[]{var1};
            this.user.mainmsg.setStatusMsg("Refreshing Job Log...", 0);
            String var4 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "getJobLog", var2, var3);
            this.jobLog.setText("");
            if (var4 != null) {
               this.jobLog.setText(var4);
            }

            this.user.mainmsg.clearStatusMsg();
         } catch (Exception var5) {
         }
      }
   }

   public void locateAndLoadJob(int var1) {
      String var2 = Integer.toString(var1);

      for(int var3 = 0; var3 < this.GridPanel1.getTableRows(); ++var3) {
         if (this.GridPanel1.getText(1, var3) != null && this.GridPanel1.getText(1, var3).equals(var2)) {
            this.GridPanel1.resetSelections();
            this.GridPanel1.setRowSelected(var3, true);
            return;
         }
      }

   }

   public boolean PopupMenu1LoadMenu() {
      String var1 = this.GridPanel1.getText(0, this.GridPanel1.getCurrentRow());
      this.PopupMenu1.clear();
      if (var1.equals("")) {
         return false;
      } else {
         this.GridPanel1.setRowSelected(this.GridPanel1.getCurrentRow(), true);
         if (!var1.startsWith("   ")) {
            if (this.GridPanel1.getText(2, this.GridPanel1.getCurrentRow()).equals("Active")) {
               this.PopupMenu1.addEntry("Hold");
            } else {
               this.PopupMenu1.addEntry("Release");
            }

            this.PopupMenu1.addEntry("");
            if (var1.equals("SSYSTEM")) {
               String[] var2 = new String[]{"Start", "JDPScheduler"};
               this.PopupMenu1.addEntry(var2);
               var2[1] = "JDPNotificationMgr";
               this.PopupMenu1.addEntry(var2);
            }

            String[] var4 = new String[]{"Refresh Every", "10 Seconds"};
            this.PopupMenu1.addEntry(var4);
            var4[1] = "30 Seconds";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "Minute";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "5 Minutes";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "10 Minutes";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "30 Minutes";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "Hour";
            this.PopupMenu1.addEntry(var4);
            this.PopupMenu1.addEntry("");
            var4[0] = "Set Maximum Jobs";
            var4[1] = "*NOMAX";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "1";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "2";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "3";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "4";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "5";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "10";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "20";
            this.PopupMenu1.addEntry(var4);
            var4[1] = "50";
            this.PopupMenu1.addEntry(var4);
            var4[0] = "Set Priority";

            for(int var3 = 10; var3 >= 1; --var3) {
               var4[1] = Integer.toString(var3);
               this.PopupMenu1.addEntry(var4);
            }

            this.PopupMenu1.addEntry("");
            this.PopupMenu1.addEntry("Create New...");
            if (!var1.equals("SSYSTEM") && !var1.equals("SIMMED") && !var1.equals("SBATCH")) {
               this.PopupMenu1.addEntry("Delete");
            }
         } else {
            if (var1.indexOf("JDPSubsystemMgr") < 0 && var1.indexOf("JaggServer") < 0) {
               if (this.GridPanel1.getText(2, this.GridPanel1.getCurrentRow()).equals("Active")) {
                  this.PopupMenu1.addEntry("Hold");
               } else {
                  this.PopupMenu1.addEntry("Release");
               }

               this.PopupMenu1.addEntry("Kill");
               this.PopupMenu1.addEntry("");
            }

            this.PopupMenu1.addEntry("Display Job Log");
            this.PopupMenu1.addEntry("");
            String[] var5 = new String[]{"Set Priority", ""};

            for(int var6 = 10; var6 >= 1; --var6) {
               var5[1] = Integer.toString(var6);
               this.PopupMenu1.addEntry(var5);
            }
         }

         return true;
      }
   }

   public void PopupMenu1HandleSelection() {
      String var1 = null;
      String var2 = this.PopupMenu1.getSelectedMenu(0);
      String var3 = "";
      if (this.PopupMenu1.getCurrentMenuLvl() == 1) {
         var3 = this.PopupMenu1.getSelectedMenu(1);
      }

      String var4 = "java.lang.String";
      if (var2.equals("Refresh Every")) {
         if (var3.equals("10 Seconds")) {
            this.waitSeconds = 10L;
         } else if (var3.equals("30 Seconds")) {
            this.waitSeconds = 30L;
         } else if (var3.equals("Minute")) {
            this.waitSeconds = 60L;
         } else if (var3.equals("5 Minutes")) {
            this.waitSeconds = 300L;
         } else if (var3.equals("10 Minutes")) {
            this.waitSeconds = 600L;
         } else if (var3.equals("30 Minutes")) {
            this.waitSeconds = 1800L;
         } else if (var3.equals("Hour")) {
            this.waitSeconds = 3600L;
         }

         this.thisThread.interrupt();
      } else {
         String var5 = this.GridPanel1.getText(0, this.GridPanel1.getCurrentRow());
         if (!var5.startsWith("   ")) {
            if (var2.equals("Start")) {
               this.user.mainmsg.setStatusMsg("Attempting to start " + var3 + "...", 0);
               String[] var6 = new String[]{var4, var4};
               String[] var7 = new String[]{var5, var3};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "startSystemJob", var6, var7);
            }

            if (var2.equals("Set Maximum Jobs")) {
               String[] var10 = new String[]{var4, "int"};
               if (var3.equals("*NOMAX")) {
                  var3 = "0";
               }

               String[] var18 = new String[]{var5, var3};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setMaxJobs", var10, var18);
            }

            if (var2.equals("Set Priority")) {
               String[] var11 = new String[]{var4, "int"};
               String[] var19 = new String[]{var5, var3};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setSubsystemPriority", var11, var19);
            }

            if (var2.equals("Hold")) {
               String[] var12 = new String[]{var4, "boolean"};
               String[] var20 = new String[]{var5, "true"};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setSubsystemHeld", var12, var20);
            }

            if (var2.equals("Release")) {
               String[] var13 = new String[]{var4, "boolean"};
               String[] var21 = new String[]{var5, "false"};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setSubsystemHeld", var13, var21);
            }

            if (var2.equals("Delete")) {
               this.MessageBox1.setMessage("Confirm removal of subsystem " + var5 + ".");
               this.MessageBox1.display();
               if (this.MessageBox1.getPressedButton() == 0) {
                  this.user.mainmsg.setStatusMsg("Removing subsystem...", 0);
                  String[] var14 = new String[]{var4};
                  String[] var22 = new String[]{var5};
                  var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "removeSubsystem", var14, var22);
               }
            }

            if (var2.equals("Create New...")) {
               this.creatingNewSubsystem = true;
               int var15 = 0;
               this.GridPanel1.resetSelections();

               while(var15 < this.GridPanel1.getTableRows() && (!this.GridPanel1.getText(0, var15).equals("") || !this.GridPanel1.getText(0, var15 + 1).equals(""))) {
                  ++var15;
               }

               ++var15;
               this.user.mainmsg.setStatusMsg("Enter the name of the new Subsystem.", 10);
               this.GridPanel1.setCellFont(0, var15, this.user.boldFont);
               this.GridPanel1.setCellEnabled(0, var15, true);
               this.GridPanel1.setCursorInThisCell(0, var15);
               this.GridPanel1.requestFocus();
               return;
            }
         } else {
            String var17 = this.GridPanel1.getText(1, this.GridPanel1.getCurrentRow());
            if (var2.equals("Set Priority")) {
               String[] var23 = new String[]{"int", "int", var4};
               String[] var8 = new String[]{var17, var3, this.user.cust.getUsername()};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setJobPriority", var23, var8);
            }

            if (var2.equals("Hold")) {
               String[] var24 = new String[]{"int", "boolean", var4};
               String[] var28 = new String[]{var17, "true", this.user.cust.getUsername()};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setJobHeld", var24, var28);
            }

            if (var2.equals("Release")) {
               String[] var25 = new String[]{"int", "boolean", var4};
               String[] var29 = new String[]{var17, "false", this.user.cust.getUsername()};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "setJobHeld", var25, var29);
            }

            if (var2.equals("Kill")) {
               String[] var26 = new String[]{"int", var4};
               String[] var30 = new String[]{var17, this.user.cust.getUsername()};
               var1 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "killJob", var26, var30);
            }

            if (var2.equals("Display Job Log")) {
               this.jobLog.setText("");
               String[] var27 = new String[]{"int"};
               String[] var31 = new String[]{var17};
               String var9 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "getJobLog", var27, var31);
               if (var9 != null) {
                  this.jobLog.setText(var9);
               }

               this.setJobLogVisible(true);
            }
         }

         if (var1 != null) {
            this.user.mainmsg.setStatusMsg(var1, 15);
         } else {
            this.user.mainmsg.clearStatusMsg();
         }

         this.LoadGridWithSubsystemData();
      }
   }

   public void GridPanel1CreateNewSubsystem() {
      String var1 = null;

      for(int var2 = 0; var2 < this.GridPanel1.getTableRows(); ++var2) {
         if (this.GridPanel1.getCellEnabled(0, var2)) {
            var1 = this.GridPanel1.getText(0, var2).toUpperCase().trim();
            if (var1.length() == 0) {
               var1 = null;
            } else {
               var1 = this.user.u.replace(var1, "'", "''");
            }
         }
      }

      if (var1 != null) {
         this.user.mainmsg.setStatusMsg("Creating new subsystem...", 0);
         String[] var3 = new String[]{"java.lang.String"};
         String[] var4 = new String[]{var1};
         String var5 = (String)this.jaggSQL1.invoke("JDPSubsystemMgr", "createSubsystem", var3, var4);
         if (var5 != null) {
            this.user.mainmsg.setStatusMsg(var5, 10);
         } else {
            this.user.mainmsg.clearStatusMsg();
         }
      }

      this.LoadGridWithSubsystemData();
   }
}
