import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPSystemMaint extends JDPClassLayout {
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   boolean deleteRequested;
   JDPPopupMessage popuppanel;
   JDPJagg jaggSQL;
   TextField JDPSystem;
   TextField JDPSystemDesc;
   TextField versionnum;
   TextField boldfontname;
   TextField boldfontsize;
   TextField plainfontname;
   TextField plainfontsize;
   JDPChoice languageCountry;
   JDPComboBox dateFormat;
   String pfromWhereClause;

   void newSearch() {
      String var1 = this.pfromWhereClause + " AND " + this.jdpWhereClause.whereClause;
      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
   }

   void clearFields() {
      this.JDPSystem.setText("");
      this.JDPSystemDesc.setText("");
      this.versionnum.setText("");
      this.boldfontname.setText("");
      this.boldfontsize.setText("");
      this.plainfontname.setText("");
      this.plainfontsize.setText("");
      this.languageCountry.select(0);
      this.dateFormat.select(0);
   }

   void loadData() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      String var6;
      if (super.user.JDesignerPro.NDSPath != null) {
         var6 = "SELECT JDP:JDPSystem," + "Description," + "JDP:versionnum," + "JDP:bfontname," + "JDP:bfontsize," + "JDP:pfontname," + "JDP:pfontsize, " + "JDP:jlanguage, " + "JDP:country, " + "JDP:dateformat FROM JDesignerPro System WHERE JDP:JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
      } else {
         var6 = "SELECT JDPSystem," + "JDPSystemD," + "versionnum," + "bfontname," + "bfontsize," + "pfontname," + "pfontsize, " + "jlanguage, " + "country, " + "dateformat FROM JDPSystemDef WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
      }

      if (super.user.DEBUG) {
         System.out.println("loadData SQL: " + var6);
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var2 = this.jaggSQL.execSQL(var6, var3);
      if (super.user.DEBUG) {
         System.out.println("loadData CNT: " + Integer.toString(var2));
      }

      if (var2 == -1) {
         super.user.u.setSqlMessage(this.jaggSQL, var6);
      } else if (var2 == 1) {
         String var5 = (String)var3.elementAt(0);
         if (var5 != null && var5.trim().compareTo("") != 0) {
            StringTokenizer var1 = new StringTokenizer(var5);
            this.JDPSystem.setText(var1.nextToken(var4).trim());
            this.JDPSystemDesc.setText(var1.nextToken(var4).trim());
            this.versionnum.setText(var1.nextToken(var4).trim());
            this.boldfontname.setText(var1.nextToken(var4).trim());
            this.boldfontsize.setText(var1.nextToken(var4).trim());
            this.plainfontname.setText(var1.nextToken(var4).trim());
            this.plainfontsize.setText(var1.nextToken(var4).trim());
            this.languageCountry.select(var1.nextToken(var4).trim() + var1.nextToken(var4).trim());
            this.dateFormat.setText(var1.nextToken(var4).trim());
         }

         super.user.mainmsg.clearStatusMsg();
      } else {
         super.user.mainmsg.setStatusMsg("Requested entry does not exist.", 10);
         this.clearFields();
      }
   }

   boolean saveData() {
      int var1 = 0;
      Vector var2 = new Vector();
      this.jaggSQL.getSEP();
      String var3 = "";
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      if (this.itemIndex < 0) {
         super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
         return false;
      } else {
         String var4 = this.languageCountry.getSelectedItem() + "    ";
         String var5 = var4.substring(0, 2).toLowerCase().trim();
         String var6 = var4.substring(2, 4).toUpperCase().trim();
         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         if (this.insertRequested) {
            if (super.user.JDesignerPro.NDSPath != null) {
               var3 = "INSERT INTO JDesignerPro System (OU, JDP:JDPSystem, " + "Description, " + "JDP:versionnum, " + "JDP:bfontname, " + "JDP:bfontsize, " + "JDP:pfontname, " + "JDP:pfontsize, " + "JDP:jlanguage, " + "JDP:country, " + "JDP:dateformat) VALUES(" + this.JDPSystem.getText() + this.JDPSystemDesc.getText() + ", " + "'" + this.JDPSystem.getText() + "', " + "'" + this.JDPSystemDesc.getText() + "', " + "'" + this.versionnum.getText() + "', " + "'" + this.boldfontname.getText() + "', " + "" + this.boldfontsize.getText() + ", " + "'" + this.plainfontname.getText() + "', " + "" + this.plainfontsize.getText() + ", " + "'" + var5 + "', " + "'" + var6 + "', " + "'" + this.dateFormat.getText() + "')";
               this.jaggSQL.execSQL(var3, var2);
               var3 = "INSERT INTO JDesignerPro Menu (OU, JDP:menuname, Description) " + "VALUES('Main','Main','Main') parent=" + this.JDPSystem.getText() + this.JDPSystemDesc.getText();
               this.jaggSQL.execSQL(var3, var2);
               var3 = "INSERT INTO JDesignerPro Menu Option (JDP:menunum,JDP:menutype,JDP:menuobject,JDP:menuparm,JDP:menudesc,Description,JDP:menustat,JDP:menutxtclr, " + "JDP:menutabclr) " + "VALUES(1," + "'P','JDPMenuMaint','', " + "'Menu Maintenance'," + "'Menu Maintenance'," + "'A'," + "'Black', " + "'LightGray') parent=" + this.JDPSystem.getText() + this.JDPSystemDesc.getText() + "\\Main";
            } else {
               var3 = "INSERT INTO JDPSystemDef (JDPSystem, " + "JDPSystemD, " + "versionnum, " + "bfontname, " + "bfontsize, " + "pfontname, " + "pfontsize, " + "jlanguage, " + "country, " + "dateformat) VALUES('" + this.JDPSystem.getText() + "', " + "'" + this.JDPSystemDesc.getText() + "', " + "'" + this.versionnum.getText() + "', " + "'" + this.boldfontname.getText() + "', " + "" + this.boldfontsize.getText() + ", " + "'" + this.plainfontname.getText() + "', " + "" + this.plainfontsize.getText() + ", " + "'" + var5 + "', " + "'" + var6 + "', " + "'" + this.dateFormat.getText() + "')";
               this.jaggSQL.execSQL(var3, var2);
               var3 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.JDPSystem.getText() + "','Main',1," + "'P','JDPMenuMaint','', " + "'Menu Maintenance'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
            }
         } else if (this.deleteRequested) {
            if (super.user.JDesignerPro.NDSPath != null) {
               var3 = "DELETE FROM JDesignerPro System" + " WHERE JDP:JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
               this.jaggSQL.execSQL(var3, var2);
               var3 = "DELETE FROM JDesignerPro Menu" + " PARENT=" + this.JDPSystem.getText() + this.JDPSystemDesc.getText();
            } else {
               var3 = "DELETE FROM JDPSystemDef" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
               this.jaggSQL.execSQL(var3, var2);
               var3 = "DELETE FROM JDPMenu" + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
            }
         } else if (super.user.JDesignerPro.NDSPath != null) {
            var3 = "UPDATE JDesignerPro System SET JDP:JDPSystem = '" + this.JDPSystem.getText() + "', " + "Description = '" + this.JDPSystemDesc.getText() + "', " + "JDP:versionnum = '" + this.versionnum.getText() + "', " + "JDP:bfontname = '" + this.boldfontname.getText() + "', " + "JDP:bfontsize = " + this.boldfontsize.getText() + ", " + "JDP:pfontname = '" + this.plainfontname.getText() + "', " + "JDP:pfontsize = " + this.plainfontsize.getText() + ", " + "JDP:jlanguage = '" + var5 + "', " + "JDP:country = '" + var6 + "', " + "JDP:dateformat = '" + this.dateFormat.getText() + "' " + " WHERE JDP:JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
         } else {
            var3 = "UPDATE JDPSystemDef SET JDPSystem = '" + this.JDPSystem.getText() + "', " + "JDPSystemD = '" + this.JDPSystemDesc.getText() + "', " + "versionnum = '" + this.versionnum.getText() + "', " + "bfontname = '" + this.boldfontname.getText() + "', " + "bfontsize = " + this.boldfontsize.getText() + ", " + "pfontname = '" + this.plainfontname.getText() + "', " + "pfontsize = " + this.plainfontsize.getText() + ", " + "jlanguage = '" + var5 + "', " + "country = '" + var6 + "', " + "dateformat = '" + this.dateFormat.getText() + "' " + " WHERE JDPSystem='" + this.searchResults.recordKey0[this.itemIndex] + "'";
         }

         if (super.user.DEBUG) {
            System.out.println("saveData SQL: " + var3);
         }

         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var1 = this.jaggSQL.execSQL(var3, var2);
         if (super.user.DEBUG) {
            System.out.println("saveData CNT: " + Integer.toString(var1));
         }

         if (var1 == -1) {
            super.user.u.setSqlMessage(this.jaggSQL, var3);
            return false;
         } else {
            if (var1 >= 1) {
               if (this.insertRequested) {
                  super.user.mainmsg.setStatusMsg("Record successfully added.", 3);
               } else if (this.deleteRequested) {
                  super.user.mainmsg.setStatusMsg("Record successfully removed.", 3);
               } else {
                  super.user.mainmsg.setStatusMsg("Record successfully updated.", 3);
               }

               this.insertRequested = false;
               this.deleteRequested = false;
            } else {
               super.user.u.setSqlMessage(this.jaggSQL, var3);
            }

            return true;
         }
      }
   }

   public void getLanguages() {
      this.languageCountry.clear();
      this.jaggSQL.setFCTN("ListFiles");
      this.jaggSQL.setFCTNP(super.user.JDesignerPro.JDPDirectory + JDesignerPro.serverSeparator + "System" + JDesignerPro.serverSeparator + "Language;");
      Vector var1 = new Vector();
      this.jaggSQL.execSQL("", var1);

      for(int var4 = 0; var4 < var1.size(); ++var4) {
         StringTokenizer var3 = new StringTokenizer((String)var1.elementAt(var4), this.jaggSQL.getSEP());
         String var2 = var3.nextToken();
         if (var2.indexOf(".lang") > 0) {
            var2 = var2.substring(0, var2.indexOf(".lang"));
            this.languageCountry.addItem(var2);
         }
      }

      if (super.user.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
      } else {
         this.jaggSQL.setFCTN("");
      }

      this.jaggSQL.setFCTNP("");
   }

   boolean checkFields() {
      return true;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            this.deleteRequested = false;
            if (var1.key == 9) {
               if (var1.target.equals(this.JDPSystem)) {
                  super.user.u.cursor(this.JDPSystemDesc);
                  return true;
               }

               if (var1.target.equals(this.JDPSystemDesc)) {
                  super.user.u.cursor(this.boldfontname);
                  return true;
               }

               if (var1.target.equals(this.boldfontname)) {
                  super.user.u.cursor(this.boldfontsize);
                  return true;
               }

               if (var1.target.equals(this.boldfontsize)) {
                  super.user.u.cursor(this.plainfontname);
                  return true;
               }

               if (var1.target.equals(this.plainfontname)) {
                  super.user.u.cursor(this.plainfontsize);
                  return true;
               }

               if (var1.target.equals(this.plainfontsize)) {
                  super.user.u.cursor(this.languageCountry);
                  return true;
               }

               if (var1.target.equals(this.languageCountry)) {
                  super.user.u.cursor(this.dateFormat);
                  return true;
               }

               if (var1.target.equals(this.dateFormat)) {
                  super.user.u.cursor(this.JDPSystem);
                  return true;
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target instanceof JDPButton) {
               String var2 = (String)var1.arg;
               if (var2.trim().compareTo("Remove") == 0) {
                  if (!this.deleteRequested) {
                     super.user.mainmsg.setStatusMsg("Press the Remove button once more to confirm System removal", 20);
                     this.deleteRequested = true;
                  } else {
                     this.saveData();
                  }

                  return true;
               } else {
                  this.deleteRequested = false;
                  if (var2.trim().compareTo("Apply") == 0) {
                     if (this.checkFields()) {
                        this.saveData();
                     }

                     return true;
                  } else if (var2.trim().compareTo("Reset") == 0) {
                     this.loadData();
                     return true;
                  } else if (var2.trim().compareTo("New") == 0) {
                     this.insertRequested = true;
                     this.clearFields();
                     return true;
                  } else if (var2.trim().compareTo("Copy") == 0) {
                     this.insertRequested = true;
                     return true;
                  } else {
                     if (var2.trim().compareTo("Search") == 0) {
                        this.newSearch();
                        return true;
                     }

                     return true;
                  }
               }
            } else if (var1.target instanceof Button) {
               return true;
            } else {
               this.deleteRequested = false;
               if (var1.target.equals(this.searchResults.resultList)) {
                  this.loadData();
                  return true;
               } else {
                  if (var1.target instanceof Choice) {
                     return true;
                  }

                  if (var1.target instanceof TextField) {
                     this.checkFields();
                  }

                  return false;
               }
            }
         default:
            return false;
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      String var8 = "JDPSystem";
      this.pfromWhereClause = "FROM JDPSystemDef WHERE (1=1)";
      this.psortChoice = new String[2];
      this.psortChoice[0] = "JDPSystem";
      this.psortChoice[1] = "JDPSystemD";
      String[] var9 = new String[]{"System", "Description"};
      this.pdisplayChoice = this.psortChoice;
      String var10 = var9[0];
      boolean var11 = true;
      String var12 = "Total Systems:";
      this.JDPSystem = new TextField("", 5);
      this.JDPSystemDesc = new TextField("", 35);
      this.versionnum = new TextField("", 10);
      this.boldfontname = new TextField("", 10);
      this.boldfontsize = new TextField("", 4);
      this.plainfontname = new TextField("", 10);
      this.plainfontsize = new TextField("", 4);
      this.languageCountry = new JDPChoice();
      this.dateFormat = new JDPComboBox(var1, 15);
      this.dateFormat.addItem("mm/dd/yy");
      this.dateFormat.addItem("dd/mm/yy");
      this.dateFormat.addItem("yy/mm/dd");
      this.dateFormat.addItem("mm/dd/yyyy");
      this.dateFormat.addItem("dd/mm/yyyy");
      this.dateFormat.addItem("yyyy/mm/dd");
      this.dateFormat.addItem("mm-dd-yy");
      this.dateFormat.addItem("dd-mm-yy");
      this.dateFormat.addItem("yy-mm-dd");
      this.dateFormat.addItem("mm-dd-yyyy");
      this.dateFormat.addItem("dd-mm-yyyy");
      this.dateFormat.addItem("yyyy-mm-dd");
      this.dateFormat.addItem("mm.dd.yy");
      this.dateFormat.addItem("dd.mm.yy");
      this.dateFormat.addItem("yy.mm.dd");
      this.dateFormat.addItem("mm.dd.yyyy");
      this.dateFormat.addItem("dd.mm.yyyy");
      this.dateFormat.addItem("yyyy.mm.dd");
      this.getLanguages();
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "System:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Description:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Bold Font Name:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Bold Font Size:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Plain Font Name:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Plain Font Size:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Language/Country:"));
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Date format:"));
      ((Container)var7).add("Right", this.JDPSystem);
      ((Container)var7).add("Right", this.JDPSystemDesc);
      ((Container)var7).add("Right", this.boldfontname);
      ((Container)var7).add("Right", this.boldfontsize);
      ((Container)var7).add("Right", this.plainfontname);
      ((Container)var7).add("Right", this.plainfontsize);
      ((Container)var7).add("Right", this.languageCountry);
      ((Container)var7).add("Right", this.dateFormat);
      ((Container)var6).add("Center", var7);
      String[] var13 = new String[]{"Apply", "Reset", "Remove", "New", "Copy"};
      int[] var14 = new int[]{0, 6, 8, 9, 10};
      JDPButtons var15 = new JDPButtons(var1, var13, var14, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", var15);
      this.popuppanel.addComponent(var15.button[0], "Apply Changes", "Save changes to the database");
      this.popuppanel.addComponent(var15.button[1], "Undo Changes", "Undo changes by reloading the record");
      this.popuppanel.addComponent(var15.button[2], "Remove record", "Remove the current system from the database");
      this.popuppanel.addComponent(var15.button[3], "New System", "Create a new system");
      this.popuppanel.addComponent(var15.button[4], "Copy System", "Copy this system");
      ((Container)var4).add("Center", var6);
      String[] var16 = new String[]{"System", "Description"};
      String[] var17 = new String[]{"JDPSystem", "JDPSystemD"};
      if (var1.JDesignerPro.NDSPath != null) {
         var8 = "JDP:JDPSystem";
         this.pfromWhereClause = "FROM JDesignerPro System WHERE 1=1";
         this.psortChoice[0] = "JDP:JDPSystem";
         this.psortChoice[1] = "Description";
         var17[0] = "JDP:JDPSystem";
         var17[1] = "Description";
         this.jaggSQL.setFCTN("NDSexecSQL");
      }

      String[][] var18 = new String[2][8];
      var18[0][0] = "Begins with";
      var18[0][1] = "Contains";
      var18[1][0] = "Begins with";
      var18[1][1] = "Contains";
      String[][] var19 = new String[2][8];
      var19[0][0] = " like ";
      var19[0][1] = " like ";
      var19[1][0] = " like ";
      var19[1][1] = " like ";
      boolean[] var20 = new boolean[]{true, true};
      int[] var21 = new int[]{7, 52};
      this.jdpWhereClause = new JDPWhereClause(var1, var2, "JDPSystemMaint", true, var16[0], var16, var17, var18, var19, (String[][])null, (String[][])null, var21, var20);
      this.searchResults = new JDPSearchResults(var1, (Container)var2, false, this.jaggSQL, false, var8, (String[])null, this.pfromWhereClause, var9, this.psortChoice, this.pdisplayChoice, var10, var11, var12);
      this.searchResults.setIcon(4);
      Panel var22 = new Panel();
      ((Container)var22).setLayout(new BorderLayout());
      ((Container)var22).add("North", this.jdpWhereClause);
      ((Container)var22).add("Center", this.searchResults);
      ((Container)var4).add("West", var22);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "Maintain System Definitions", var4, "North"));
      this.searchResults.loadList();
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }
}
