import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.LayoutManager;
import java.awt.Panel;
import java.awt.Rectangle;
import java.awt.image.ImageObserver;

class JDPTabSelectSidePanel extends Panel {
   Image offscreen;
   Rectangle offscreensize;
   // $FF: renamed from: gr java.awt.Graphics
   Graphics field_0;
   JDPUser user;
   JDPTabSelectPanel target;
   String orientation;
   String taborientation;
   boolean edgeon;

   void clearEdge() {
      this.edgeon = false;
      ((Component)this).repaint();
   }

   public JDPTabSelectSidePanel(JDPUser var1, JDPTabSelectPanel var2, String var3, String var4) {
      this.user = var1;
      this.target = var2;
      this.orientation = var3;
      this.taborientation = var4;
      Rectangle var5 = ((Component)this).bounds();
      if (var3.equals("North")) {
         ((Container)this).setLayout((LayoutManager)null);
         ((Component)this).reshape(0, 0, var5.width, 2);
      }

      if (!var2.ismenu) {
         if (var3.equals("West")) {
            ((Container)this).setLayout((LayoutManager)null);
            ((Component)this).reshape(0, 0, 6, var5.height);
         }

         if (var3.equals("East")) {
            ((Container)this).setLayout((LayoutManager)null);
            ((Component)this).reshape(0, 0, 6, var5.height);
         }

         if (var3.equals("South")) {
            ((Container)this).setLayout((LayoutManager)null);
            ((Component)this).reshape(0, 0, var5.width, 6);
         }
      }

   }

   public void paint(Graphics var1) {
      this.update(var1);
   }

   void setEdge() {
      this.edgeon = true;
      ((Component)this).repaint();
   }

   public Dimension minimumSize() {
      Dimension var1 = new Dimension(6, 6);
      if (this.orientation.equals("North")) {
         var1 = new Dimension(6, 2);
      }

      return var1;
   }

   public void update(Graphics var1) {
      Rectangle var2 = ((Component)this).bounds();
      if (this.offscreen == null || var2.width != this.offscreensize.width || var2.height != this.offscreensize.height) {
         if (var2.width < 10) {
            var2.width = 10;
         }

         if (var2.height < 10) {
            var2.height = 10;
         }

         this.offscreen = ((Component)this).createImage(var2.width, var2.height);
         this.offscreensize = var2;
         this.field_0 = this.offscreen.getGraphics();
         this.field_0.setFont(((Component)this).getFont());
      }

      Color var3 = ((Component)this).getBackground();
      Color var4 = JDPUtils.brighter(var3);
      Color var5 = JDPUtils.darker(var3);
      Color var6 = JDPUtils.darker(var5);
      this.field_0.setColor(var3);
      this.field_0.fillRect(0, 0, var2.width, var2.height);
      this.field_0.setColor(Color.black);
      Rectangle var7 = ((Component)this).bounds();
      if (this.orientation.compareTo("East") == 0) {
         if (this.target.ismenu) {
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 5, 0, var7.width - 5, var7.height);
            this.field_0.setColor(Color.black);
            this.field_0.drawLine(var7.width - 4, 1, var7.width - 4, var7.height);
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 3, 3, var7.width - 3, var7.height);
            this.field_0.drawLine(var7.width - 2, 4, var7.width - 2, var7.height);
         } else {
            this.field_0.setColor(var5);
            this.field_0.drawLine(var7.width - 5, 0, var7.width - 5, var7.height);
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 4, 0, var7.width - 4, var7.height);
         }
      } else if (this.orientation.compareTo("West") == 0) {
         this.field_0.setColor(var4);
         this.field_0.drawLine(3, 0, 3, var7.height);
      } else if (this.orientation.compareTo("North") == 0) {
         this.field_0.setColor(var4);
         this.field_0.drawLine(3, 1, var7.width - 6, 1);
         this.field_0.drawLine(3, 1, 3, var7.height);
         if (this.edgeon) {
            this.field_0.drawLine(18, 1, 18, var7.height);
         }

         if (this.target.ismenu) {
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 5, 3, var7.width - 5, var7.height);
         } else {
            this.field_0.setColor(var5);
            this.field_0.drawLine(var7.width - 5, 3, var7.width - 5, var7.height);
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 4, 4, var7.width - 4, var7.height);
         }
      } else if (this.orientation.compareTo("South") == 0) {
         byte var8 = 0;
         if (this.taborientation.compareTo("West") == 0) {
            var8 = 14;
         }

         this.field_0.setColor(var4);
         this.field_0.drawLine(3 + var8, 0, 3 + var8, var7.height - 3);
         if (this.target.ismenu) {
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 5, 0, var7.width - 5, var7.height - 3);
            this.field_0.drawLine(4 + var8, var7.height - 4, var7.width - 6, var7.height - 4);
            this.field_0.setColor(Color.black);
            this.field_0.drawLine(3 + var8, var7.height - 3, var7.width - 5, var7.height - 3);
            this.field_0.drawLine(var7.width - 4, 0, var7.width - 4, var7.height - 3);
            this.field_0.setColor(var6);
            this.field_0.drawLine(8 + var8, var7.height - 2, var7.width - 4, var7.height - 2);
            this.field_0.drawLine(9 + var8, var7.height - 1, var7.width - 4, var7.height - 1);
            this.field_0.drawLine(var7.width - 3, 0, var7.width - 3, var7.height - 1);
            this.field_0.drawLine(var7.width - 2, 0, var7.width - 2, var7.height - 2);
         } else {
            this.field_0.setColor(var5);
            this.field_0.drawLine(var7.width - 5, 0, var7.width - 5, var7.height - 4);
            this.field_0.drawLine(4 + var8, var7.height - 4, var7.width - 6, var7.height - 4);
            this.field_0.setColor(var6);
            this.field_0.drawLine(var7.width - 4, 0, var7.width - 4, var7.height - 3);
            this.field_0.drawLine(3 + var8, var7.height - 3, var7.width - 5, var7.height - 3);
         }
      }

      var1.drawImage(this.offscreen, 0, 0, (ImageObserver)null);
   }

   public Dimension preferredSize() {
      return this.minimumSize();
   }

   public void layout() {
      ((Component)this).repaint();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 202:
            ((Component)this).repaint();
            return false;
         default:
            return false;
      }
   }
}
