import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPUserBill extends JDPClassLayout {
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   JDPPopupMessage popuppanel;
   TextField username;
   TextField firstname;
   TextField lastname;
   TextField userstatus;
   TextField cardnum;
   TextField cardexpiry;
   TextField cardname;
   String pfromWhereClause;

   void loadUser() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = super.user.jaggSQL.getSEP();
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      String var6 = this.searchResults.recordKey0[this.itemIndex];
      String var7 = "SELECT username,firstname,lastname,status,cardnum,cardexpiry,cardname " + "FROM JDPUser WHERE userid = " + var6;
      if (super.user.DEBUG) {
         System.out.println("JDPUserBill/loadUser SQL: " + var7);
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var2 = super.user.jaggSQL.execSQL(var7, var3);
      if (super.user.DEBUG) {
         System.out.println("JDPUserBill/loadUser CNT: " + Integer.toString(var2));
      }

      if (var2 == -1) {
         super.user.u.setSqlMessage(super.user.jaggSQL, var7);
      } else if (var2 == 1) {
         String var8 = "A";
         String var5 = (String)var3.elementAt(0);
         if (var5 != null && var5.trim().compareTo("") != 0) {
            StringTokenizer var1 = new StringTokenizer(var5);
            this.username.setText(var1.nextToken(var4).trim());
            this.firstname.setText(var1.nextToken(var4).trim());
            this.lastname.setText(var1.nextToken(var4).trim());
            var8 = var1.nextToken(var4).trim();
            this.cardnum.setText(var1.nextToken(var4).trim());
            this.cardexpiry.setText(var1.nextToken(var4).trim());
            this.cardname.setText(var1.nextToken(var4).trim());
         }

         if (var8.compareTo("A") == 0) {
            this.userstatus.setText("Active");
         }

         if (var8.compareTo("P") == 0) {
            this.userstatus.setText("Pending");
         }

         if (var8.compareTo("S") == 0) {
            this.userstatus.setText("Suspended");
         }

         if (var8.compareTo("C") == 0) {
            this.userstatus.setText("Cancelled");
         }

         if (var8.compareTo("X") == 0) {
            this.userstatus.setText("Deleted");
         }

         if (var8.compareTo("F") == 0) {
            this.userstatus.setText("Free");
         }

         if (var8.compareTo("G") == 0) {
            this.userstatus.setText("Guest");
         }

         super.user.mainmsg.clearStatusMsg();
      } else {
         super.user.mainmsg.setStatusMsg("Requested user does not exist.", 10);
         this.clearFields();
      }
   }

   void newSearch() {
      String var1 = this.pfromWhereClause + " AND " + this.jdpWhereClause.whereClause;
      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
   }

   void clearFields() {
      this.username.setText("");
      this.userstatus.setText("");
      this.firstname.setText("");
      this.lastname.setText("");
      this.cardnum.setText("");
      this.cardexpiry.setText("");
      this.cardname.setText("");
   }

   boolean saveUser() {
      int var1 = 0;
      Vector var2 = new Vector();
      super.user.jaggSQL.getSEP();
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      if (this.itemIndex < 0) {
         super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
         return false;
      } else {
         String var3 = this.searchResults.recordKey0[this.itemIndex];
         String var4 = "UPDATE JDPUser SET cardnum = '" + this.cardnum.getText() + "', " + "cardexpiry = '" + this.cardexpiry.getText() + "', " + "cardname = '" + this.cardname.getText() + "' " + "WHERE userid = " + var3;
         if (super.user.DEBUG) {
            System.out.println("JDPUserBill/saveUser SQL: " + var4);
         }

         super.user.mainmsg.setStatusMsg("Accessing database...", 0);
         var1 = super.user.jaggSQL.execSQL(var4, var2);
         if (super.user.DEBUG) {
            System.out.println("JDPUserBill/saveUser CNT: " + Integer.toString(var1));
         }

         if (var1 == -1) {
            super.user.u.setSqlMessage(super.user.jaggSQL, var4);
            return false;
         } else {
            if (var1 == 1) {
               super.user.mainmsg.setStatusMsg("Card details successfully updated.", 3);
            } else {
               super.user.mainmsg.setStatusMsg("Card details update failed", 10);
            }

            return true;
         }
      }
   }

   boolean validCard() {
      String var1 = this.cardnum.getText();
      if (!super.user.u.isnumeric(this.cardnum, super.user.mainmsg)) {
         return false;
      } else {
         long var2 = 0L;
         if (var1.length() != 13 && var1.length() != 15 && var1.length() != 16) {
            return false;
         } else {
            for(int var4 = 0; var4 < var1.length() - 1; ++var4) {
               int var5 = Integer.parseInt(var1.substring(var1.length() - var4 - 2, var1.length() - var4 - 1));
               if (var4 % 2 == 0) {
                  var5 *= 2;
                  if (var5 > 8) {
                     var5 = 1 + var5 - 10;
                  }
               }

               var2 += (long)var5;
            }

            String var8 = Long.toString(var2);
            var8 = var8.substring(var8.length() - 1);
            int var10 = 10 - Integer.parseInt(var8);
            String var6 = Integer.toString(var10).trim();
            var6 = var6.substring(var6.length() - 1);
            String var7 = var1.substring(var1.length() - 1);
            if (var7.compareTo(var6) != 0) {
               return false;
            } else {
               return true;
            }
         }
      }
   }

   boolean checkFields() {
      return this.userstatus.getText().compareTo("Active") != 0 || this.checkCard();
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (var1.target.equals(this.username)) {
                  super.user.u.cursor(this.cardnum);
                  return true;
               }

               if (var1.target.equals(this.firstname)) {
                  super.user.u.cursor(this.cardnum);
                  return true;
               }

               if (var1.target.equals(this.lastname)) {
                  super.user.u.cursor(this.cardnum);
                  return true;
               }

               if (var1.target.equals(this.userstatus)) {
                  super.user.u.cursor(this.cardnum);
                  return true;
               }

               if (var1.target.equals(this.cardnum)) {
                  super.user.u.cursor(this.cardexpiry);
                  return true;
               }

               if (var1.target.equals(this.cardexpiry)) {
                  super.user.u.cursor(this.cardname);
                  return true;
               }

               if (var1.target.equals(this.cardname)) {
                  super.user.u.cursor(this.cardnum);
                  return true;
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.searchResults.resultList)) {
               this.loadUser();
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Apply") == 0) {
                     if (this.checkFields()) {
                        this.saveUser();
                     }

                     return true;
                  }

                  if (var2.compareTo("Reset") == 0) {
                     this.loadUser();
                     return true;
                  }

                  if (var2.compareTo("Validate") == 0) {
                     this.checkCard();
                     return true;
                  }

                  if (var2.compareTo("Search") == 0) {
                     this.newSearch();
                     return true;
                  }
               }

               if (var1.target instanceof Choice) {
                  return true;
               }

               if (var1.target instanceof TextField) {
                  this.checkFields();
               }

               return false;
            }
         default:
            return false;
      }
   }

   boolean checkexpiry() {
      String var1 = this.cardexpiry.getText();
      if (!super.user.u.isnumeric(this.cardexpiry, super.user.mainmsg)) {
         return false;
      } else {
         if (var1.length() == 3) {
            var1 = "0" + var1;
         }

         if (var1.length() > 4) {
            var1 = var1.substring(0, 4);
         }

         int var2 = Integer.parseInt(var1.substring(0, 2));
         int var3 = Integer.parseInt(var1.substring(2, 4));
         String var5 = Integer.toString(var2);
         if (var5.length() == 1) {
            var5 = "0" + var5;
         }

         String var6 = Integer.toString(var3);
         if (var6.length() == 1) {
            var6 = "0" + var6;
         }

         if (var3 < 90) {
            (new StringBuffer()).append(var5).append("/28/20").append(var6).toString();
         } else {
            (new StringBuffer()).append(var5).append("/28/19").append(var6).toString();
         }

         if (var2 >= 1 && var2 <= 12) {
            if (var3 >= 0 && var3 <= 99) {
               Date var7 = new Date();

               Date var8;
               try {
                  var8 = new Date(var3, var2 - 1, 30);
               } catch (IllegalArgumentException var9) {
                  return false;
               }

               if (var8.before(var7)) {
                  super.user.mainmsg.setStatusMsg("Card has already expired.", 7);
                  return false;
               } else {
                  this.cardexpiry.setText(var5 + var6);
                  return true;
               }
            } else {
               super.user.mainmsg.setStatusMsg("Invalid Card Expiry year.", 7);
               return false;
            }
         } else {
            super.user.mainmsg.setStatusMsg("Invalid Card Expiry month.", 7);
            return false;
         }
      }
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      String var8 = "userid,username,firstname,lastname,status";
      this.pfromWhereClause = "FROM JDPUser WHERE (jdpsystem0 = '" + var1.JDPSystem + "' " + "OR jdpsystem1 = '" + var1.JDPSystem + "' " + "OR jdpsystem2 = '" + var1.JDPSystem + "' " + "OR jdpsystem3 = '" + var1.JDPSystem + "' " + "OR jdpsystem4 = '" + var1.JDPSystem + "' " + "OR jdpsystem5 = '" + var1.JDPSystem + "' " + "OR jdpsystem6 = '" + var1.JDPSystem + "' " + "OR jdpsystem7 = '" + var1.JDPSystem + "' " + "OR jdpsystem8 = '" + var1.JDPSystem + "' " + "OR jdpsystem9 = '" + var1.JDPSystem + "')";
      this.psortChoice = new String[5];
      this.psortChoice[0] = "username";
      this.psortChoice[1] = "cardnum";
      this.psortChoice[2] = "cardname";
      this.psortChoice[3] = "firstname";
      this.psortChoice[4] = "lastname";
      String[] var9 = new String[]{"Sort by User Name", "Sort by Card Number", "Sort by Card Name", "Sort by First Name", "Sort by Last Name"};
      this.pdisplayChoice = this.psortChoice;
      String var10 = var9[0];
      boolean var11 = true;
      String var12 = "Total Entries:";
      this.username = new TextField("", 20);
      this.firstname = new TextField("", 20);
      this.lastname = new TextField("", 20);
      this.userstatus = new TextField("", 10);
      this.cardnum = new TextField("", 20);
      this.cardexpiry = new TextField("", 5);
      this.cardname = new TextField("", 20);
      this.username.setEditable(false);
      this.firstname.setEditable(false);
      this.lastname.setEditable(false);
      this.userstatus.setEditable(false);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Username:"));
      ((Container)var7).add("Right", this.username);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "First Name:"));
      ((Container)var7).add("Right", this.firstname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Last Name:"));
      ((Container)var7).add("Right", this.lastname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Status:"));
      ((Container)var7).add("Right", this.userstatus);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Card Number:"));
      ((Container)var7).add("Right", this.cardnum);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Card Expiry:"));
      ((Container)var7).add("Right", this.cardexpiry);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Card Name:"));
      ((Container)var7).add("Right", this.cardname);
      ((Container)var6).add("Center", var7);
      String[] var13 = new String[]{"Apply", "Reset", "Validate"};
      int[] var14 = new int[]{0, 6, 11};
      JDPButtons var15 = new JDPButtons(var1, var13, var14, JDPButtons.HORIZONTAL);
      ((Container)var6).add("South", var15);
      this.popuppanel.addComponent(var15.button[0], "Apply Changes", "Save changes to the database");
      this.popuppanel.addComponent(var15.button[1], "Undo Changes", "Undo changes by reloading the record");
      this.popuppanel.addComponent(var15.button[2], "Validate card details", "Validate the card details");
      ((Container)var4).add("Center", var6);
      String[] var16 = new String[]{"Account Name", "Card Number", "Card Name", "Card Expiry", "First Name", "Last Name", "User Status"};
      String[] var17 = new String[]{"username", "cardnum", "cardname", "cardexpiry", "firstname", "lastname", "status"};
      String[][] var18 = new String[7][7];
      String[][] var19 = new String[7][7];
      boolean[] var20 = new boolean[7];
      int[] var21 = new int[7];
      int var22 = 0;

      do {
         var18[var22][0] = "Begins with";
         var18[var22][1] = "Contains";
         var19[var22][0] = " like ";
         var19[var22][1] = " like ";
         var20[var22] = true;
         var21[var22] = 20;
         ++var22;
      } while(var22 <= 5);

      var18[6][0] = "is Active";
      var18[6][1] = "is Pending";
      var18[6][2] = "is Suspended";
      var18[6][3] = "is Cancelled";
      var18[6][4] = "is Deleted";
      var18[6][5] = "is Free";
      var18[6][6] = "is a Guest";
      var19[6][0] = "='A'";
      var19[6][1] = "='P'";
      var19[6][2] = "='S'";
      var19[6][3] = "='C'";
      var19[6][4] = "='X'";
      var19[6][5] = "='F'";
      var19[6][6] = "='G'";
      var20[6] = false;
      var21[6] = 0;
      this.jdpWhereClause = new JDPWhereClause(var1, var2, "UserBill", true, var16[0], var16, var17, var18, var19, (String[][])null, (String[][])null, var21, var20);
      this.searchResults = new JDPSearchResults(var1, (Container)var2, false, var1.jaggSQL, false, var8, (String[])null, this.pfromWhereClause, var9, this.psortChoice, this.pdisplayChoice, var10, var11, var12);
      this.searchResults.setIcon(5);
      Panel var23 = new Panel();
      ((Container)var23).setLayout(new BorderLayout());
      ((Container)var23).add("North", this.jdpWhereClause);
      ((Container)var23).add("Center", this.searchResults);
      ((Container)var4).add("West", var23);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "User Billing Details", var4, "North"));
      this.searchResults.loadList();
      ((Component)var2).paintAll(((Component)var2).getGraphics());
   }

   boolean checkCard() {
      if (!this.validCard()) {
         super.user.mainmsg.setStatusMsg("Invalid credit card number.", 7);
         super.user.u.cursor(this.cardnum);
         return false;
      } else if (!this.checkexpiry()) {
         super.user.mainmsg.setStatusMsg("Credit card has expired.", 7);
         super.user.u.cursor(this.cardexpiry);
         return false;
      } else if (this.cardname.getText().trim().length() == 0) {
         super.user.mainmsg.setStatusMsg("Credit card name missing.", 7);
         super.user.u.cursor(this.cardname);
         return false;
      } else {
         super.user.mainmsg.setStatusMsg("Credit card details are valid.", 4);
         return true;
      }
   }
}
