import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Panel;
import java.awt.TextField;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPUserMaint extends JDPClassLayout {
   JDPJagg jaggSQL;
   JDPWhereClause jdpWhereClause;
   JDPSearchResults searchResults;
   String[] psortChoice;
   String[] pdisplayChoice;
   int itemIndex;
   boolean insertRequested;
   JDPPopupMessage popuppanel;
   TextField username;
   TextField password;
   TextField firstname;
   TextField lastname;
   JDPChoice userstatus;
   TextField address1;
   TextField address2;
   TextField city;
   TextField state;
   TextField zipcode;
   TextField country;
   TextField emailaddr;
   TextField phonenum;
   TextField alphsvcph;
   TextField alphpgrnum;
   JDPComboBox initmenu;
   String pfromWhereClause;
   String systemOU = "";

   void loadUser() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      this.insertRequested = false;
      this.itemIndex = this.searchResults.resultList.getSelectedIndex();
      String var6 = this.searchResults.recordKey0[this.itemIndex];
      String var7;
      if (super.user.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         var7 = "SELECT CN,`Given Name`,Surname,JDP:status,JDP:address1,JDP:address2,JDP:city," + "JDP:state,JDP:zipcode,JDP:country,`Email Address`,`Telephone Number',JDP:alphsvcph,JDP:alphpgrnum, JDP:initmenu " + "FROM User WHERE JDP:userid = " + var6;
      } else {
         var7 = "SELECT username,password,firstname,lastname,status,address1,address2,city," + "state,zipcode,country,emailaddr,phonenum,alphsvcph,alphpgrnum " + "FROM JDPUser WHERE userid = " + var6;
      }

      if (super.user.DEBUG) {
         System.out.println("JDPUserMaint/loadUser SQL: " + var7);
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var2 = this.jaggSQL.execSQL(var7, var3);
      if (super.user.DEBUG) {
         System.out.println("JDPUserMaint/loadUser CNT: " + Integer.toString(var2));
      }

      if (var2 == -1) {
         super.user.u.setSqlMessage(this.jaggSQL, var7);
      } else if (var2 == 1) {
         String var8 = "A";
         String var5 = (String)var3.elementAt(0);
         if (var5 != null && var5.trim().compareTo("") != 0) {
            StringTokenizer var1 = new StringTokenizer(var5);
            this.username.setText(var1.nextToken(var4).trim());
            if (super.user.JDesignerPro.NDSPath == null) {
               this.password.setText(var1.nextToken(var4).trim());
            }

            this.firstname.setText(var1.nextToken(var4).trim());
            this.lastname.setText(var1.nextToken(var4).trim());
            var8 = var1.nextToken(var4).trim();
            this.address1.setText(var1.nextToken(var4).trim());
            this.address2.setText(var1.nextToken(var4).trim());
            this.city.setText(var1.nextToken(var4).trim());
            this.state.setText(var1.nextToken(var4).trim());
            this.zipcode.setText(var1.nextToken(var4).trim());
            this.country.setText(var1.nextToken(var4).trim());
            String var9 = var1.nextToken(var4).trim();
            if (var9.indexOf(":") > 0) {
               var9 = var9.substring(var9.indexOf(":") + 1);
            }

            if (var9.indexOf(";") > 0) {
               var9 = var9.substring(var9.indexOf(";") + 1);
            }

            this.emailaddr.setText(var9);
            this.phonenum.setText(var1.nextToken(var4).trim());
            this.alphsvcph.setText(var1.nextToken(var4).trim());
            this.alphpgrnum.setText(var1.nextToken(var4).trim());
            if (super.user.JDesignerPro.NDSPath != null) {
               this.initmenu.setText(var1.nextToken(var4).trim());
            }
         }

         if (var8.compareTo("A") == 0) {
            this.userstatus.select("Active");
         }

         if (var8.compareTo("P") == 0) {
            this.userstatus.select("Pending");
         }

         if (var8.compareTo("S") == 0) {
            this.userstatus.select("Suspended");
         }

         if (var8.compareTo("C") == 0) {
            this.userstatus.select("Cancelled");
         }

         if (var8.compareTo("X") == 0) {
            this.userstatus.select("Deleted");
         }

         if (var8.compareTo("F") == 0) {
            this.userstatus.select("Free");
         }

         if (var8.compareTo("G") == 0) {
            this.userstatus.select("Guest");
         }

         super.user.mainmsg.clearStatusMsg();
      } else {
         super.user.mainmsg.setStatusMsg("Requested user does not exist.", 10);
         this.clearFields();
      }
   }

   void newSearch() {
      String var1 = this.pfromWhereClause + " AND " + this.jdpWhereClause.whereClause;
      this.searchResults.setFromWhereClause(var1);
      this.searchResults.clearList();
      this.searchResults.loadList();
   }

   void clearFields() {
      this.username.setText("");
      this.password.setText("");
      this.userstatus.select("Active");
      this.firstname.setText("");
      this.lastname.setText("");
      this.address1.setText("");
      this.address2.setText("");
      this.city.setText("");
      this.state.setText("");
      this.zipcode.setText("");
      this.country.setText("");
      this.emailaddr.setText("");
   }

   boolean saveUser() {
      int var2 = 0;
      Vector var3 = new Vector();
      String var4 = this.jaggSQL.getSEP();
      String var5 = "";
      String var6 = this.userstatus.getSelectedItem().substring(0, 1);
      if (this.userstatus.getSelectedItem().compareTo("Deleted") == 0) {
         var6 = "X";
      }

      String var7 = "";
      if (this.insertRequested) {
         if (super.user.JDesignerPro.NDSPath != null) {
            this.jaggSQL.setFCTN("NDSexecSQL");
            var7 = "INSERT INTO User (JDP:userid,CN,JDP:status,`Given Name`,Surname,JDP:address1," + "JDP:address2,JDP:city,JDP:state,JDP:zipcode,JDP:country,`Email Address`,`Telephone Number',JDP:alphsvcph,JDP:alphpgrnum,JDP:initmenu" + "JDP:winx1,JDP:winy1,JDP:winx2,JDP:winy2,JDP:totallogin) " + "VALUES(0,'" + this.username.getText() + "'," + "'" + var6 + "', " + "'" + this.firstname.getText() + "','" + this.lastname.getText() + "', " + "'" + this.address1.getText() + "','" + this.address2.getText() + "', " + "'" + this.city.getText() + "','" + this.state.getText() + "', " + "'" + this.zipcode.getText() + "','" + this.country.getText() + "', " + "'" + this.emailaddr.getText() + "','0;SMTP:" + this.phonenum.getText() + "','" + this.alphsvcph.getText() + "','" + this.alphpgrnum.getText() + "','" + this.initmenu.getText() + "'," + "0,0,640,480,0)";
         } else {
            var7 = "INSERT INTO JDPUser (userid,username,password,status,firstname,lastname,address1," + "address2,city,state,zipcode,country,emailaddr,phonenum,alphsvcph,alphpgrnum,jdpsystem0," + "winx1,winy1,winx2,winy2,totallogin) " + "VALUES(0,'" + this.username.getText() + "','" + this.password.getText().toLowerCase() + "'," + "'" + var6 + "', " + "'" + this.firstname.getText() + "','" + this.lastname.getText() + "', " + "'" + this.address1.getText() + "','" + this.address2.getText() + "', " + "'" + this.city.getText() + "','" + this.state.getText() + "', " + "'" + this.zipcode.getText() + "','" + this.country.getText() + "', " + "'" + this.emailaddr.getText() + "','" + this.phonenum.getText() + "','" + this.alphsvcph.getText() + "','" + this.alphpgrnum.getText() + "','" + super.user.JDPSystem + "'," + "0,0,640,480,0)";
         }
      } else {
         this.itemIndex = this.searchResults.resultList.getSelectedIndex();
         if (this.itemIndex < 0) {
            super.user.mainmsg.setStatusMsg("You must first make a selection", 5);
            return false;
         }

         var5 = this.searchResults.recordKey0[this.itemIndex];
         if (super.user.JDesignerPro.NDSPath != null) {
            this.jaggSQL.setFCTN("NDSexecSQL");
            var7 = "UPDATE User SET JDP:status = '" + var6 + "', " + "`Given Name` = '" + this.firstname.getText() + "', " + "Surname = '" + this.lastname.getText() + "',JDP:address1 = '" + this.address1.getText() + "', " + "JDP:address2 = '" + this.address2.getText() + "',JDP:city = '" + this.city.getText() + "', " + "JDP:state = '" + this.state.getText() + "',JDP:zipcode = '" + this.zipcode.getText() + "', " + "JDP:country = '" + this.country.getText() + "',`Email Address` = '0;SMTP:" + this.emailaddr.getText() + "', " + "`Telephone Number` = '" + this.phonenum.getText() + "', " + "JDP:alphsvcph = '" + this.alphsvcph.getText() + "', " + "JDP:alphpgrnum = '" + this.alphpgrnum.getText() + "', " + "JDP:initmenu = '" + this.initmenu.getText() + "' " + "WHERE JDP:userid = " + var5;
         } else {
            var7 = "UPDATE JDPUser SET username = '" + this.username.getText() + "', " + "status = '" + var6 + "', " + "password = '" + this.password.getText() + "',firstname = '" + this.firstname.getText() + "', " + "lastname = '" + this.lastname.getText() + "',address1 = '" + this.address1.getText() + "', " + "address2 = '" + this.address2.getText() + "',city = '" + this.city.getText() + "', " + "state = '" + this.state.getText() + "',zipcode = '" + this.zipcode.getText() + "', " + "country = '" + this.country.getText() + "',emailaddr = '" + this.emailaddr.getText() + "', " + "phonenum = '" + this.phonenum.getText() + "', " + "alphsvcph = '" + this.alphsvcph.getText() + "', " + "alphpgrnum = '" + this.alphpgrnum.getText() + "' " + "WHERE userid = " + var5;
         }
      }

      if (super.user.DEBUG) {
         System.out.println("JDPUserMaint/saveUser SQL: " + var7);
      }

      super.user.mainmsg.setStatusMsg("Accessing database...", 0);
      var2 = this.jaggSQL.execSQL(var7, var3);
      if (super.user.DEBUG) {
         System.out.println("JDPUserMaint/saveUser CNT: " + Integer.toString(var2));
      }

      if (var2 == -1) {
         super.user.u.setSqlMessage(this.jaggSQL, var7);
         return false;
      } else {
         if (var2 == 1) {
            if (this.insertRequested) {
               if (super.user.JDesignerPro.NDSPath != null) {
                  var7 = "SELECT JDP:userid FROM User WHERE JDP:userid = 1";
               } else {
                  var7 = "SELECT * FROM JDPUser WHERE userid < 1";
               }

               var3 = new Vector();
               var2 = this.jaggSQL.execSQL(var7, var3);
               if (var2 >= 1) {
                  if (super.user.JDesignerPro.NDSPath != null) {
                     var7 = "SELECT MAX(JDP:userid) FROM User";
                  } else {
                     var7 = "SELECT MAX(userid) FROM JDPUser";
                  }

                  var3 = new Vector();
                  var2 = this.jaggSQL.execSQL(var7, var3);
                  if (var2 == 1) {
                     StringTokenizer var1 = new StringTokenizer((String)var3.elementAt(0));
                     String var8 = var1.nextToken(var4).trim();
                     int var9 = var8.indexOf(".");
                     if (var9 >= 0) {
                        var8 = var8.substring(0, var9);
                     }

                     int var10 = Integer.parseInt(var8) + 1;
                     if (super.user.JDesignerPro.NDSPath != null) {
                        var7 = "UPDATE User SET JDP:userid = " + Integer.toString(var10) + " WHERE JDP:userid = 0";
                     } else {
                        var7 = "UPDATE JDPUser SET userid = " + Integer.toString(var10) + " WHERE userid = 0 OR userid is NULL";
                     }

                     var3 = new Vector();
                     this.jaggSQL.execSQL(var7, var3);
                  }
               }

               super.user.mainmsg.setStatusMsg("User successfully added.", 3);
            } else {
               super.user.mainmsg.setStatusMsg("User successfully updated.", 3);
            }

            this.insertRequested = false;
         } else {
            super.user.mainmsg.setStatusMsg("User update failed", 10);
         }

         return true;
      }
   }

   boolean CheckUsers() {
      super.user.mainmsg.setStatusMsg("Checking Licenses...", 0);
      String var2 = this.jaggSQL.getSEP();
      String var3;
      if (super.user.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         var3 = "SELECT COUNT(*) from JDPUser WHERE JDP:status = 'A' OR JDP:status = 'P' OR JDP:status = 'G' OR JDP:status = 'F')";
      } else {
         var3 = "SELECT count(*) from JDPUser WHERE status in ('A','P','G','F')";
      }

      Vector var4 = new Vector();
      this.jaggSQL.execSQL(var3, var4);
      StringTokenizer var1 = new StringTokenizer((String)var4.elementAt(0));
      String var5 = var1.nextToken(var2).trim();
      int var6 = var5.indexOf(".");
      if (var6 >= 0) {
         var5 = var5.substring(0, var6);
      }

      int var7 = Integer.parseInt(var5);
      super.user.mainmsg.clearStatusMsg();
      return var7 < JDesignerPro.JDPLicenses;
   }

   boolean checkFields() {
      return true;
   }

   public boolean handleEvent(Event var1) {
      switch (var1.id) {
         case 401:
            if (var1.key == 9) {
               if (super.user.JDesignerPro.NDSPath != null) {
                  if (var1.target.equals(this.username)) {
                     super.user.u.cursor(this.userstatus);
                     return true;
                  }
               } else {
                  if (var1.target.equals(this.username)) {
                     super.user.u.cursor(this.password);
                     return true;
                  }

                  if (var1.target.equals(this.password)) {
                     super.user.u.cursor(this.userstatus);
                     return true;
                  }
               }

               if (var1.target.equals(this.userstatus)) {
                  super.user.u.cursor(this.firstname);
                  return true;
               }

               if (var1.target.equals(this.firstname)) {
                  super.user.u.cursor(this.lastname);
                  return true;
               }

               if (var1.target.equals(this.lastname)) {
                  super.user.u.cursor(this.address1);
                  return true;
               }

               if (var1.target.equals(this.address1)) {
                  super.user.u.cursor(this.address2);
                  return true;
               }

               if (var1.target.equals(this.address2)) {
                  super.user.u.cursor(this.city);
                  return true;
               }

               if (var1.target.equals(this.city)) {
                  super.user.u.cursor(this.state);
                  return true;
               }

               if (var1.target.equals(this.state)) {
                  super.user.u.cursor(this.zipcode);
                  return true;
               }

               if (var1.target.equals(this.zipcode)) {
                  super.user.u.cursor(this.country);
                  return true;
               }

               if (var1.target.equals(this.country)) {
                  super.user.u.cursor(this.emailaddr);
                  return true;
               }

               if (var1.target.equals(this.emailaddr)) {
                  super.user.u.cursor(this.phonenum);
                  return true;
               }

               if (var1.target.equals(this.phonenum)) {
                  super.user.u.cursor(this.alphsvcph);
                  return true;
               }

               if (var1.target.equals(this.alphsvcph)) {
                  super.user.u.cursor(this.alphpgrnum);
                  return true;
               }

               if (var1.target.equals(this.alphpgrnum)) {
                  super.user.u.cursor(this.username);
                  return true;
               }

               return true;
            }

            return false;
         case 503:
         case 504:
         case 505:
            this.popuppanel.postEvent(var1);
            return false;
         case 1001:
            if (var1.target.equals(this.searchResults.resultList)) {
               this.loadUser();
               return true;
            } else {
               if (var1.target instanceof Button) {
                  String var2 = (String)var1.arg;
                  if (var2.trim().compareTo("Apply") == 0) {
                     if (this.checkFields()) {
                        this.saveUser();
                        this.newSearch();
                     }

                     return true;
                  }

                  if (var2.compareTo("Reset") == 0) {
                     this.loadUser();
                     return true;
                  }

                  if (var2.compareTo("Deactivate") == 0) {
                     this.userstatus.select("Deleted");
                     this.insertRequested = false;
                     if (this.saveUser()) {
                        this.clearFields();
                        this.newSearch();
                     }

                     return true;
                  }

                  if (var2.compareTo("New") == 0) {
                     if (this.CheckUsers()) {
                        this.insertRequested = true;
                        this.clearFields();
                     } else {
                        super.user.mainmsg.setStatusMsg("You must purchase extra user licences from BulletProof to add another user.", 10);
                     }

                     return true;
                  }

                  if (var2.compareTo("Search") == 0) {
                     this.newSearch();
                     return true;
                  }
               }

               if (var1.target instanceof JDPChoice) {
                  return true;
               }

               if (var1.target instanceof TextField) {
                  this.checkFields();
               }

               return false;
            }
         default:
            return false;
      }
   }

   void loadSystemOU() {
      String var1 = "SELECT OU FROM JDesignerPro System WHERE JDP:JDPSystem = '" + super.user.JDPSystem + "'";
      Vector var2 = new Vector();
      this.jaggSQL.execSQL(var1, var2);
      StringTokenizer var3 = new StringTokenizer((String)var2.elementAt(0));
      this.systemOU = var3.nextToken(this.jaggSQL.getSEP()).trim();
   }

   public void InitClass(JDPUser var1, Panel var2, String var3) {
      super.user = var1;
      this.jaggSQL = new JDPJagg(var1.jaggPath);
      this.jaggSQL.loadSettings(var1);
      ((Container)this).setLayout(new BorderLayout());
      ((Component)this).setFont(var1.plainFont);
      this.popuppanel = new JDPPopupMessage(var1, var2);
      ((Container)var2).add(this.popuppanel);
      Panel var4 = new Panel();
      ((Container)var4).setLayout(new BorderLayout());
      Panel var5 = new Panel();
      ((Container)var5).setLayout(new BorderLayout());
      Panel var6 = new Panel();
      ((Container)var6).setLayout(new BorderLayout());
      JDPScrollPanel var7 = new JDPScrollPanel();
      String var8 = "userid";
      if (var1.JDesignerPro.NDSPath != null) {
         this.pfromWhereClause = "FROM User WHERE 1=1";
         this.psortChoice = new String[4];
         this.psortChoice[0] = "CN";
         this.psortChoice[1] = "JDP:userid";
         this.psortChoice[2] = "`Given Name`";
         this.psortChoice[3] = "Surname";
         var8 = "JDP:userid";
      } else {
         this.pfromWhereClause = "FROM JDPUser WHERE (jdpsystem0 = '" + var1.JDPSystem + "' " + "OR jdpsystem1 = '" + var1.JDPSystem + "' " + "OR jdpsystem2 = '" + var1.JDPSystem + "' " + "OR jdpsystem3 = '" + var1.JDPSystem + "' " + "OR jdpsystem4 = '" + var1.JDPSystem + "' " + "OR jdpsystem5 = '" + var1.JDPSystem + "' " + "OR jdpsystem6 = '" + var1.JDPSystem + "' " + "OR jdpsystem7 = '" + var1.JDPSystem + "' " + "OR jdpsystem8 = '" + var1.JDPSystem + "' " + "OR jdpsystem9 = '" + var1.JDPSystem + "')";
         this.psortChoice = new String[4];
         this.psortChoice[0] = "username";
         this.psortChoice[1] = "userid";
         this.psortChoice[2] = "firstname";
         this.psortChoice[3] = "lastname";
      }

      String[] var9 = new String[]{"Sort by User Name", "Sort by User ID Number", "Sort by First Name", "Sort by Last Name"};
      this.pdisplayChoice = this.psortChoice;
      String var10 = var9[0];
      boolean var11 = true;
      String var12 = "Total Entries:";
      this.username = new TextField("", 20);
      this.password = new TextField("", 20);
      this.firstname = new TextField("", 20);
      this.lastname = new TextField("", 20);
      this.userstatus = new JDPChoice();
      this.userstatus.addItem("Active");
      this.userstatus.addItem("Pending");
      this.userstatus.addItem("Suspended");
      this.userstatus.addItem("Cancelled");
      this.userstatus.addItem("Deleted");
      this.userstatus.addItem("Free");
      this.userstatus.addItem("Guest");
      this.address1 = new TextField("", 35);
      this.address2 = new TextField("", 35);
      this.city = new TextField("", 20);
      this.state = new TextField("", 3);
      this.zipcode = new TextField("", 11);
      this.country = new TextField("", 15);
      this.emailaddr = new TextField("", 35);
      this.phonenum = new TextField("", 20);
      this.alphsvcph = new TextField("", 20);
      this.alphpgrnum = new TextField("", 20);
      this.initmenu = new JDPComboBox(var1, "", 20);
      this.jaggSQL.loadSettings(var1);
      if (var1.JDesignerPro.NDSPath != null) {
         this.jaggSQL.setFCTN("NDSexecSQL");
         this.loadSystemOU();
         this.initmenu.loadChoice(var1, this.jaggSQL, "b.JDP:menuname", "b.JDP:menuname", "JDesignerPro System a, JDesignerPro Menu b", "a.JDP:JDPSystem = '" + var1.JDPSystem + "'");
      }

      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Username:"));
      ((Container)var7).add("Right", this.username);
      if (var1.JDesignerPro.NDSPath == null) {
         ((Container)var7).add("Left", new JDPWrapLabel(var1, "Password:"));
         ((Container)var7).add("Right", this.password);
      }

      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Status:"));
      ((Container)var7).add("Right", this.userstatus);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "First Name:"));
      ((Container)var7).add("Right", this.firstname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Last Name:"));
      ((Container)var7).add("Right", this.lastname);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Address:"));
      ((Container)var7).add("Right", this.address1);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, ""));
      ((Container)var7).add("Right", this.address2);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "City/State/Zip:"));
      Panel var13 = new Panel();
      ((Container)var13).setLayout(new JDPLineLayout(1));
      ((Container)var13).add("Left", this.city);
      ((Container)var13).add("Left", this.state);
      ((Container)var13).add("Left", this.zipcode);
      ((Container)var7).add("Right", var13);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Country:"));
      ((Container)var7).add("Right", this.country);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Email Address:"));
      ((Container)var7).add("Right", this.emailaddr);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Phone Number:"));
      ((Container)var7).add("Right", this.phonenum);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "Alpha Provider:"));
      ((Container)var7).add("Right", this.alphsvcph);
      ((Container)var7).add("Left", new JDPWrapLabel(var1, "PIN Number:"));
      ((Container)var7).add("Right", this.alphpgrnum);
      if (var1.JDesignerPro.NDSPath != null) {
         ((Container)var7).add("Left", new JDPWrapLabel(var1, "Initial Menu:"));
         ((Container)var7).add("Right", this.initmenu);
      }

      ((Container)var6).add("Center", var7);
      if (var1.JDesignerPro.NDSPath != null) {
         String[] var14 = new String[]{"Apply", "Reset", "Deactivate"};
         int[] var15 = new int[]{0, 6, 8};
         JDPButtons var16 = new JDPButtons(var1, var14, var15, JDPButtons.HORIZONTAL);
         ((Container)var6).add("South", var16);
         this.popuppanel.addComponent(var16.button[0], "Apply Changes", "Save changes to the database");
         this.popuppanel.addComponent(var16.button[1], "Undo Changes", "Undo changes by reloading the record");
         this.popuppanel.addComponent(var16.button[2], "Deactivate", "Set the current user to deleted status");
      } else {
         String[] var22 = new String[]{"Apply", "Reset", "Deactivate", "New"};
         int[] var24 = new int[]{0, 6, 8, 9};
         JDPButtons var26 = new JDPButtons(var1, var22, var24, JDPButtons.HORIZONTAL);
         ((Container)var6).add("South", var26);
         this.popuppanel.addComponent(var26.button[0], "Apply Changes", "Save changes to the database");
         this.popuppanel.addComponent(var26.button[1], "Undo Changes", "Undo changes by reloading the record");
         this.popuppanel.addComponent(var26.button[2], "Deactivate", "Set the current user to deleted status");
         this.popuppanel.addComponent(var26.button[3], "New User", "Create a new user");
      }

      ((Container)var4).add("Center", var6);
      String[] var23 = new String[]{"Account Name", "First Name", "Last Name", "User Status"};
      String[] var25 = new String[4];
      if (var1.JDesignerPro.NDSPath != null) {
         var25[0] = "CN";
         var25[1] = "`Given Name`";
         var25[2] = "Surname";
         var25[3] = "JDP:status";
      } else {
         var25[0] = "username";
         var25[1] = "firstname";
         var25[2] = "lastname";
         var25[3] = "status";
      }

      String[][] var27 = new String[4][7];
      String[][] var17 = new String[4][7];
      boolean[] var18 = new boolean[4];
      int[] var19 = new int[4];
      int var20 = 0;

      do {
         var27[var20][0] = "Begins with";
         var27[var20][1] = "Contains";
         var17[var20][0] = " like ";
         var17[var20][1] = " like ";
         var18[var20] = true;
         var19[var20] = 20;
         ++var20;
      } while(var20 <= 2);

      var27[3][0] = "is Active";
      var27[3][1] = "is Pending";
      var27[3][2] = "is Suspended";
      var27[3][3] = "is Cancelled";
      var27[3][4] = "is Deleted";
      var27[3][5] = "is Free";
      var27[3][6] = "is a Guest";
      var17[3][0] = "='A'";
      var17[3][1] = "='P'";
      var17[3][2] = "='S'";
      var17[3][3] = "='C'";
      var17[3][4] = "='X'";
      var17[3][5] = "='F'";
      var17[3][6] = "='G'";
      var18[3] = false;
      var19[3] = 0;
      this.jdpWhereClause = new JDPWhereClause(var1, var2, "UserMaint", true, var23[0], var23, var25, var27, var17, (String[][])null, (String[][])null, var19, var18);
      this.searchResults = new JDPSearchResults(var1, (Container)var2, false, this.jaggSQL, false, var8, (String[])null, this.pfromWhereClause, var9, this.psortChoice, this.pdisplayChoice, var10, var11, var12);
      this.searchResults.setIcon(5);
      Panel var28 = new Panel();
      ((Container)var28).setLayout(new BorderLayout());
      ((Container)var28).add("North", this.jdpWhereClause);
      ((Container)var28).add("Center", this.searchResults);
      ((Container)var4).add("West", var28);
      ((Container)this).add("Center", new JDPChiselFramePanel(var1, "User Maintenance", var4, "North"));
      this.searchResults.loadList();
      ((Component)var2).paintAll(((Component)var2).getGraphics());
      Vector var21 = new Vector();
      var21.addElement("UserMaint");
      var21.addElement(this.searchResults);
      var1.gParm.addElement(var21);
   }
}
