import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.List;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.TextField;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.lang.reflect.Constructor;
import java.util.Date;
import java.util.Hashtable;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

public class JDPUtils {
   JDPUser user;
   JDPJagg jaggSQL;
   static final int BIT = -7;
   static final int TINYINT = -6;
   static final int SMALLINT = 5;
   static final int INTEGER = 4;
   static final int BIGINT = -5;
   static final int FLOAT = 6;
   static final int REAL = 7;
   static final int DOUBLE = 8;
   static final int NUMERIC = 2;
   static final int DECIMAL = 3;
   static final int CHAR = 1;
   static final int VARCHAR = 12;
   static final int LONGVARCHAR = -1;
   static final int FPDATE = 9;
   static final int DATETIME = 11;
   static final int DATE = 91;
   static final int TIME = 92;
   static final int TIMESTAMP = 93;
   static final int BINARY = -2;
   static final int VARBINARY = -3;
   static final int LONGVARBINARY = -4;
   static final int NULL = 0;
   private Properties progPaths;
   private Hashtable dataSourceTypes;
   private Font lastFont;
   // $FF: renamed from: fm java.awt.FontMetrics
   private FontMetrics field_0;
   private int[] widths;
   private static String tabString = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
   static final Color[] colorList;
   public static Color controlColor;
   public static int numColors;
   public static Color textHighlightText;
   public static Color textHighlight;
   private static double FACTOR;
   static Vector classNameVector;
   static Vector classVector;

   public String padr(String var1, int var2) {
      var1 = var1 + "                                                                         ";
      return var1.substring(0, var2);
   }

   public static boolean isOdbcInt(int var0) {
      switch (var0) {
         case -6:
         case -5:
         case 4:
         case 5:
            return true;
         default:
            return false;
      }
   }

   public static boolean isOdbcDate(int var0) {
      switch (var0) {
         case 9:
         case 11:
         case 91:
         case 93:
            return true;
         default:
            return false;
      }
   }

   public boolean isvalidDate(TextField var1, JDPStatusMessage var2) {
      return this.isvalidDate(var1, var2, JDPLang.get("Message11"));
   }

   public boolean isvalidDate(TextField var1, JDPStatusMessage var2, String var3) {
      Date var4 = JDPDate.unformat(((TextComponent)var1).getText());
      if (JDPDate.unformattedDateValid()) {
         ((TextComponent)var1).setText(JDPDate.format(var4));
         return true;
      } else {
         if (var3.equals("")) {
            var3 = JDPLang.get("Message11");
         }

         ((Component)var1).requestFocus();
         ((TextComponent)var1).selectAll();
         var2.setStatusMsg(var3, 10);
         return false;
      }
   }

   public static String sqlConvert(String var0, int var1, String var2) {
      if (isOdbcDate(var1)) {
         if (var2.indexOf(JDPJagg.VFOXPRO) >= 0) {
            var0 = "substr(dtos(" + var0 + "),1,4)+'/'+substr(dtos(" + var0 + "),5,2)+'/'+substr(dtos(" + var0 + "),7,2)";
         } else if (var2.indexOf(JDPJagg.FOXPRO) < 0) {
            if (var2.indexOf(JDPJagg.MSSQLSERVER) >= 0) {
               var0 = "CONVERT(char," + var0 + ",111)";
            } else if (var2.indexOf(JDPJagg.SYBASE) < 0 && var2.indexOf(JDPJagg.SYBASE10) < 0) {
               if (var2.indexOf(JDPJagg.ANYWHERE) >= 0) {
                  var0 = "CONVERT(char," + var0 + ",111)";
               } else if (var2.indexOf(JDPJagg.SOLIDSERVER) >= 0) {
                  var0 = "CONVERT_CHAR(" + var0 + ")";
               } else if (var2.indexOf(JDPJagg.ORACLE) < 0 && var2.indexOf(JDPJagg.POLITE) < 0) {
                  if (var2.indexOf(JDPJagg.ACCESS) >= 0) {
                     var0 = "format(" + var0 + ", 'yyyy/mm/dd')";
                  } else if (var2.indexOf(JDPJagg.DB2) >= 0) {
                     var0 = "CHAR(" + var0 + ")";
                  } else if (var2.indexOf(JDPJagg.CLOUDSCAPE) >= 0) {
                     var0 = "CAST(" + var0 + " as char(14))";
                  }
               } else {
                  var0 = "to_char(" + var0 + ", 'yyyy/mm/dd')";
               }
            } else {
               var0 = "CONVERT(char," + var0 + ",111)";
            }
         }
      }

      return var0;
   }

   public String padl(String var1, int var2) {
      int var3 = 0;
      var1 = "                                                                                  " + var1;
      var3 = var1.length() - var2;
      return var1.substring(var3, var3 + var2);
   }

   public boolean sqlRequiresChange(JDPJagg var1, int var2) {
      if (var2 == 0) {
         String var3 = this.getDataSourceType(var1);
         if (!var1.getFCTN().equals("NDSexecSQL") && var3 != null && (var3.indexOf(JDPJagg.ORACLE) >= 0 || var3.indexOf(JDPJagg.POLITE) >= 0 || var3.indexOf(JDPJagg.LOTUS) >= 0 || var3.indexOf(JDPJagg.DB2) >= 0 || var3.indexOf(JDPJagg.SYBASE) >= 0 || var3.indexOf(JDPJagg.INFORMIX) >= 0 || var3.indexOf(JDPJagg.CLOUDSCAPE) >= 0)) {
            return true;
         }
      }

      return false;
   }

   public static Color getControlColor() {
      return controlColor;
   }

   public static int getNumColors() {
      return numColors;
   }

   public static String tonum(String var0) {
      return var0 != null && !var0.equals("") ? var0 : "0";
   }

   public static String _cvtbcolor(Color var0) {
      if (var0 == null) {
         return "Black";
      } else if (var0.equals(Color.black)) {
         return "Black";
      } else if (var0.equals(Color.blue)) {
         return "Blue";
      } else if (var0.equals(Color.white)) {
         return "White";
      } else if (var0.equals(Color.yellow)) {
         return "Yellow";
      } else if (var0.equals(Color.magenta)) {
         return "Magenta";
      } else if (var0.equals(Color.pink)) {
         return "Pink";
      } else if (var0.equals(Color.magenta.darker())) {
         return "Purple";
      } else if (var0.equals(Color.cyan)) {
         return "Cyan";
      } else if (var0.equals(Color.darkGray)) {
         return "DarkGray";
      } else if (var0.equals(Color.gray)) {
         return "Gray";
      } else if (var0.equals(Color.green)) {
         return "Green";
      } else if (var0.equals(Color.lightGray)) {
         return "LightGray";
      } else if (var0.equals(Color.orange)) {
         return "Orange";
      } else {
         return var0.equals(Color.red) ? "Red" : "LightGray";
      }
   }

   public static void loadColors(List var0) {
      var0.addItem("Black");
      var0.addItem("Gray");
      var0.addItem("Blue");
      var0.addItem("Cyan");
      var0.addItem("DarkGray");
      var0.addItem("Green");
      var0.addItem("LightGray");
      var0.addItem("Magenta");
      var0.addItem("Orange");
      var0.addItem("Pink");
      var0.addItem("Red");
      var0.addItem("White");
      var0.addItem("Yellow");
   }

   public String fmtcomma(int var1) {
      String var2 = Integer.toString(var1);
      if (var1 > 999) {
         String var3 = "";
         int var4 = var2.length();

         for(int var5 = var2.length() - 3; var5 >= -3; var5 -= 3) {
            if (var5 < 0) {
               var5 = 0;
               var3 = "," + var2.substring(var5, var4) + var3;
               var4 = var5;
               var5 -= 3;
            } else {
               var3 = "," + var2.substring(var5, var4) + var3;
               var4 = var5;
            }
         }

         var2 = var3.substring(1, var3.length());
         if (var2.substring(0, 1).compareTo(",") == 0) {
            var2 = var2.substring(1, var2.length());
         }
      }

      return var2;
   }

   static boolean check4Table(JDPJagg var0, String var1, String var2) {
      var0.setFCTN("SQLTables");
      var0.setFCTNP(";;" + var2 + ";TABLE;");
      if (var1.indexOf(JDPJagg.ORACLE) >= 0 || var1.indexOf(JDPJagg.POSTGRES) >= 0 || var1.indexOf(JDPJagg.CLOUDSCAPE) >= 0) {
         var0.setFCTNP(";;" + var2.toUpperCase() + ";TABLE;");
      }

      Vector var3 = new Vector();
      int var4 = var0.execSQL("", var3);
      var0.setFCTN("");
      var0.setFCTNP("");
      if (var4 > 0) {
         return true;
      } else {
         if (var1.indexOf(JDPJagg.ORACLE) < 0 && var1.indexOf(JDPJagg.POSTGRES) < 0) {
            if (var2.length() > 8) {
               var0.setFCTN("SQLTables");
               var0.setFCTNP(";;" + var2.substring(0, 8) + ";TABLE;");
               var3 = new Vector();
               var4 = var0.execSQL("", var3);
               var0.setFCTN("");
               var0.setFCTNP("");
               if (var4 > 0) {
                  return true;
               }
            }
         } else {
            var0.setFCTN("SQLColumns");
            var0.setFCTNP(";;" + var2.toUpperCase() + ";;");
            var4 = var0.execSQL("", var3);
            var0.setFCTN("");
            var0.setFCTNP("");
            if (var4 > 0) {
               return true;
            }
         }

         return false;
      }
   }

   public static boolean isOdbcMemo(int var0) {
      switch (var0) {
         case -1:
            return true;
         default:
            return false;
      }
   }

   public static boolean isOdbcChar(int var0) {
      switch (var0) {
         case -1:
         case 1:
         case 12:
            return true;
         default:
            return false;
      }
   }

   public String[] getFileNames(String var1) {
      this.jaggSQL.setFCTN("ListFiles");
      this.jaggSQL.setFCTNP(var1 + ";");
      Vector var2 = new Vector();
      int var3 = this.jaggSQL.execSQL("", var2);
      Vector var4 = new Vector();
      if (var3 > 0) {
         for(int var7 = 0; var7 < var2.size(); ++var7) {
            StringTokenizer var8 = new StringTokenizer((String)var2.elementAt(var7), this.jaggSQL.getSEP());
            String var5 = var8.nextToken();
            String var6 = var8.nextToken();
            if (var6.equals("F")) {
               var4.addElement(var5);
            }
         }
      }

      String[] var9 = new String[var4.size()];

      for(int var10 = 0; var10 < var4.size(); ++var10) {
         var9[var10] = (String)var4.elementAt(var10);
      }

      this.jaggSQL.setFCTN("");
      this.jaggSQL.setFCTNP("");
      return var9;
   }

   public void cursor(Object var1) {
      if (var1 instanceof TextField) {
         TextField var2 = (TextField)var1;
         ((Component)var2).requestFocus();
         if (((TextComponent)var2).isEditable()) {
            ((TextComponent)var2).selectAll();
            return;
         }
      } else if (var1 instanceof JDPComboBox) {
         TextField var4 = ((JDPComboBox)var1).text;
         ((Component)var4).requestFocus();
         if (((TextComponent)var4).isEditable()) {
            ((TextComponent)var4).selectAll();
            return;
         }
      } else {
         if (var1 instanceof JDPChoice) {
            JDPComboBox var8 = ((JDPChoice)var1).thisChoice;
            JDPButton var3 = var8.downButton;
            ((Component)var3).requestFocus();
            return;
         }

         if (var1 instanceof Choice) {
            Choice var7 = (Choice)var1;
            ((Component)var7).requestFocus();
            return;
         }

         if (var1 instanceof TextArea) {
            TextArea var5 = (TextArea)var1;
            ((Component)var5).requestFocus();
            if (((TextComponent)var5).isEditable()) {
               return;
            }
         } else if (var1 instanceof Component) {
            Component var6 = (Component)var1;
            var6.requestFocus();
         }
      }

   }

   public String ntoa(float var1) {
      if (var1 == 0.0F) {
         return "0";
      } else {
         String var2 = "";
         if (var1 < 0.0F) {
            var2 = "-";
            var1 *= -1.0F;
         }

         int var3 = (int)var1;
         int var4 = Math.round((var1 - (float)var3) * 64.0F);

         int var5;
         for(var5 = 64; var4 % 2 == 0 && var4 > 0; var4 /= 2) {
            var5 /= 2;
         }

         String var6 = "";
         if (var3 != 0) {
            var6 = Integer.toString(var3) + " ";
         }

         String var7 = "";
         if (var4 != 0) {
            var7 = Integer.toString(var4) + "/" + Integer.toString(var5);
         } else {
            var6 = var6.trim();
         }

         return var2 + var6 + var7;
      }
   }

   public static Class getClass(String var0) {
      Class var1 = null;
      if (var0 == null) {
         return null;
      } else {
         if (var0.indexOf(" ") > 0) {
            var0 = var0.substring(0, var0.indexOf(" "));
         }

         if (var0.equals("int")) {
            return Integer.TYPE;
         } else if (var0.equals("boolean")) {
            return Boolean.TYPE;
         } else if (var0.equals("char")) {
            return Character.TYPE;
         } else if (var0.equals("byte")) {
            return Byte.TYPE;
         } else if (var0.equals("short")) {
            return Short.TYPE;
         } else if (var0.equals("long")) {
            return Long.TYPE;
         } else if (var0.equals("float")) {
            return Float.TYPE;
         } else if (var0.equals("double")) {
            return Double.TYPE;
         } else if (var0.equals("void")) {
            return Void.TYPE;
         } else {
            if (var0.equals("String")) {
               var0 = "java.lang.String";
            }

            if (var0.indexOf("[") > 0) {
               var0 = var0.substring(0, var0.indexOf("["));
            }

            if (var0.indexOf(" ") > 0) {
               var0 = var0.substring(0, var0.indexOf(" "));
            }

            if (var0.indexOf("@") > 0) {
               var0 = var0.substring(0, var0.indexOf("@"));
            }

            if (classNameVector == null) {
               classNameVector = new Vector();
               classVector = new Vector();
            }

            try {
               int var2 = classNameVector.indexOf(var0);
               if (var2 >= 0) {
                  var1 = (Class)classVector.elementAt(var2);
               } else {
                  var1 = Class.forName(var0);
                  classNameVector.addElement(var0);
                  classVector.addElement(var1);
               }
            } catch (Exception var4) {
               ((Throwable)var4).printStackTrace();
            }

            return var1;
         }
      }
   }

   public String getRelatedAppPath(String var1, String var2, boolean var3) {
      String var4 = this.user.JDesignerPro.JDPDirectory + "System" + JDesignerPro.serverSeparator + "ProgLocs.usr";
      JDPSaveProps var5 = new JDPSaveProps(this.user);
      if (this.progPaths == null) {
         var5.load(var4);
         this.progPaths = var5.getProperties();
      }

      String var6 = (String)this.progPaths.get(var1);
      if (var6 == null && !var3) {
         var1.substring(1);
         var6 = this.promptForAppPath(var2, var6, var1);
         if (var6 != null) {
            this.progPaths.put(var1, var6);
            var5.setProperties(this.progPaths);
            var5.save(var4);
         }
      }

      return var6;
   }

   String promptForAppPath(String var1, String var2, String var3) {
      JDPFileDialog var4;
      if (this.user.jdpMainWindow != null) {
         var4 = new JDPFileDialog(this.user, this.user.jdpMainWindow, var1);
      } else {
         var4 = new JDPFileDialog(this.user, var1);
      }

      JDPFilePicker var5 = var4.getFilePicker();
      var5.addFilter("Applications", "");
      var5.setMode(0);
      var5.setMultipleSelections(false);
      var5.loadFiles(JDesignerPro.serverSeparator, false);
      var4.display();
      if (!var5.getSelectedFile().equals("")) {
         var2 = var5.getSelectedFullPath();
      } else {
         var2 = null;
      }

      return var2;
   }

   public static void setColorFactor(double var0) {
      FACTOR = var0;
   }

   static String[] sqlDateConvert(int var0, String var1) {
      String[] var2 = new String[]{"", ""};
      if (isOdbcDate(var0)) {
         if (var1.indexOf(JDPJagg.VFOXPRO) >= 0) {
            var2[0] = "CTOD(";
            var2[1] = ")";
         } else if (var1.indexOf(JDPJagg.SYBASE) < 0 && var1.indexOf(JDPJagg.SYBASE10) < 0 && var1.indexOf(JDPJagg.ANYWHERE) < 0) {
            if (var1.indexOf(JDPJagg.SOLIDSERVER) >= 0) {
               var2[0] = "CONVERT_CHAR(";
               var2[1] = ")";
            } else if (var1.indexOf(JDPJagg.ORACLE) < 0 && var1.indexOf(JDPJagg.POLITE) < 0) {
               if (var1.indexOf(JDPJagg.RDB) >= 0) {
                  var2[0] = "cast(";
                  var2[1] = " as date vms)";
               } else if (var1.indexOf(JDPJagg.DB2) >= 0) {
                  var2[0] = "DATE(";
                  var2[1] = ")";
               } else if (var1.indexOf(JDPJagg.CLOUDSCAPE) >= 0) {
                  var2[0] = "DATE";
                  var2[1] = "";
               }
            } else {
               var2[0] = "to_date(";
               var2[1] = ", 'yyyy/mm/dd')";
            }
         }
      }

      String var3 = getFieldQuote(var0, var1);
      var2[0] = var2[0] + var3 + "\" + JDPDate.format(";
      if (var1.indexOf(JDPJagg.VFOXPRO) < 0 && var1.indexOf(JDPJagg.INFORMIX) < 0) {
         if (var1.indexOf(JDPJagg.RDB) >= 0) {
            var2[1] = ",\"yyyymmdd\") + \"" + var3 + var2[1];
         } else if (var1.indexOf(JDPJagg.ADABAS) < 0 && var1.indexOf(JDPJagg.DB2) < 0) {
            var2[1] = ") + \"" + var3 + var2[1];
         } else {
            var2[1] = ",\"yyyy-mm-dd\") + \"" + var3 + var2[1];
         }
      } else {
         var2[1] = ",\"mm/dd/yyyy\") + \"" + var3 + var2[1];
      }

      return var2;
   }

   public boolean writeToFile(String var1, String var2, String var3) {
      int var4 = 0;
      JDPJagg var5;
      if (this.user != null) {
         if (this.user.jaggPath != null) {
            var5 = new JDPJagg(this.user.jaggPath);
         } else {
            var5 = new JDPJagg(this.user.jaggSQL.getServer());
         }

         var5.setDSN(this.user.jaggDSN);
      } else {
         var5 = new JDPJagg(this.jaggSQL.getServer());
      }

      var5.setFCTN("WriteToFile");
      var5.setFCTNP(var1 + ";" + var3 + ";");
      Vector var6 = new Vector();
      int var7 = 1000;
      if (JDPJagg.useJaggServer) {
         var7 = 10000000;
      }

      while(var2.length() > 0) {
         String var8 = "";
         if (var2.length() > var7) {
            var8 = var2.substring(var7);
            var4 = var5.execSQL(var2.substring(0, var7), var6);
         } else {
            var4 = var5.execSQL(var2, var6);
         }

         if (var4 < 0) {
            if (this.user != null && this.user.mainmsg != null) {
               this.user.mainmsg.setStatusMsg("Write failed - trying again", 0);
            }

            var4 = var5.execSQL(var2, var6);
            if (var4 < 0) {
               if (this.user != null && this.user.mainmsg != null) {
                  this.user.mainmsg.setStatusMsg("Write failed - trying again", 0);
               }

               var4 = var5.execSQL(var2, var6);
               if (var4 < 0) {
                  System.out.println(var5.getError());
                  if (this.user != null && this.user.mainmsg != null) {
                     this.user.mainmsg.setStatusMsg("File already exists. Please use another name.", 15);
                  }
               } else if (this.user != null && this.user.mainmsg != null) {
                  this.user.mainmsg.setStatusMsg("Write successful - continuing...", 0);
               }
            } else if (this.user != null && this.user.mainmsg != null) {
               this.user.mainmsg.setStatusMsg("Write successful - continuing...", 0);
            }
         } else {
            for(int var9 = 0; var9 < var4; ++var9) {
               System.out.println((String)var6.elementAt(var9));
            }
         }

         var5.setFCTNP(var1 + ";a;");
         var2 = var8;
      }

      Object var10 = null;
      var5.setFCTN("");
      var5.setFCTNP("");
      if (var4 == 0) {
         return true;
      } else {
         return false;
      }
   }

   public static Color darker(Color var0) {
      return new Color(Math.max((int)((double)var0.getRed() * FACTOR * 0.84), 0), Math.max((int)((double)var0.getGreen() * FACTOR * 0.84), 0), Math.max((int)((double)var0.getBlue() * FACTOR * 0.84), 0));
   }

   public boolean ischaracter(Component var1, JDPStatusMessage var2) {
      return this.ischaracter(var1, var2, "Please enter a value");
   }

   public boolean ischaracter(Component var1, JDPStatusMessage var2, String var3) {
      if (var3.equals("")) {
         var3 = "Please enter a value";
      }

      String var4 = "";
      if (var1 instanceof TextField) {
         var4 = ((TextField)var1).getText().trim();
         ((TextField)var1).setText(var4);
      }

      if (var1 instanceof TextArea) {
         var4 = ((TextArea)var1).getText().trim();
         ((TextArea)var1).setText(var4);
      }

      if (var1 instanceof JDPComboBox) {
         var4 = ((JDPComboBox)var1).getText().trim();
         ((JDPComboBox)var1).setText(var4);
      }

      if (var4 != null && !var4.equals("")) {
         return true;
      } else {
         var2.setStatusMsg(var3, 10);
         var1.requestFocus();
         if (var1 instanceof TextField) {
            ((TextField)var1).selectAll();
         }

         if (var1 instanceof TextArea) {
            ((TextArea)var1).selectAll();
         }

         if (var1 instanceof JDPComboBox) {
            ((JDPComboBox)var1).text.selectAll();
         }

         return false;
      }
   }

   String strip(String var1) {
      if (var1 == null) {
         return null;
      } else {
         String var2 = var1.replace('.', '_');
         var2 = this.replace(var2, " ", "");
         var2 = this.replace(var2, "`", "");
         return var2;
      }
   }

   public int execSql(JDPStatusMessage var1, String var2, Vector var3) {
      return this.execSql(this.user.jaggSQL, var1, var2, var3);
   }

   public void setSqlMessage(JDPJagg var1, String var2) {
      if (this.user.mainmsg != null) {
         this.user.mainmsg.setStatusMsg("SQL failed... exact message follows. See Java console for details.", 3);
      }

      String var3 = var1.getError();
      int var4 = var3.lastIndexOf("]");
      System.out.println(var2);
      if (var4 > 0) {
         var3 = var3.substring(var4 + 1).trim();
      }

      if (this.user.mainmsg != null) {
         this.user.mainmsg.setStatusMsg(var3, 60);
      }

   }

   public int execSql(JDPJagg var1, JDPStatusMessage var2, String var3, Vector var4) {
      if (this.user.cust.status.compareTo("D") != 0 && this.user.cust.status.compareTo("G") != 0 || var3.indexOf("UPDATE") < 0 && var3.indexOf("INSERT") < 0 && var3.indexOf("DELETE") < 0) {
         var2.setStatusMsg("Accessing Database...", 0);
         Vector var5 = new Vector();
         String var8 = var1.getSEP();
         int var9 = var1.execSQL(var3, var5);
         if (var9 >= 0) {
            int var7 = var1.getRowCount();

            for(int var10 = 0; var10 < var7; ++var10) {
               String var6 = (String)var5.elementAt(var10);
               StringTokenizer var11 = new StringTokenizer(var6, var8);

               while(var11.hasMoreTokens()) {
                  var4.addElement(this.rtrim(var11.nextToken()));
               }
            }
         } else {
            var9 = -1;
         }

         if (var9 == -1) {
            this.setSqlMessage(var1, var3);
         }

         var2.clearStatusMsg();
         return var9;
      } else {
         var2.setStatusMsg("Updates are not permitted with this guest account. Sign up now for full access.", 10);
         return -1;
      }
   }

   public static JDPTabSelectPanel getTabPanel(Component var0) {
      Container var1;
      for(var1 = var0.getParent(); var1 != null && !(var1 instanceof JDPTabSelectPanel); var1 = ((Component)var1).getParent()) {
      }

      return var1 != null && var1 instanceof JDPTabSelectPanel ? (JDPTabSelectPanel)var1 : null;
   }

   public static void insertTabs(TextArea var0) {
      String var1 = ((TextComponent)var0).getText();
      if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
         var1 = replace(var1, "\n", "|\n", 100000);
      }

      int var2 = ((TextComponent)var0).getSelectionStart();
      if (var2 >= 2) {
         int var3;
         for(var3 = var2 - 2; var3 > 0 && var1.charAt(var3) != '\n'; --var3) {
         }

         if (var1.charAt(var3) == '\n') {
            ++var3;
         }

         int var4;
         for(var4 = 0; var3 < var2 && var1.charAt(var3) == '\t'; ++var4) {
            ++var3;
         }

         if (var1.charAt(var2 - 2) == '{') {
            ++var4;
         } else if (var1.charAt(var2 - 2) == '|' && var1.charAt(var2 - 3) == '{') {
            ++var4;
         }

         if (var4 > 0) {
            var1 = var1.substring(0, var2) + tabString.substring(0, var4) + var1.substring(var2);
            if (System.getProperty("java.version").startsWith("1.1") && System.getProperty("java.vendor").startsWith("Sun")) {
               var1 = replace(var1, "|\n", "\n", 100000);
            }

            ((TextComponent)var0).setText(var1);
            ((TextComponent)var0).setSelectionStart(var2 + var4);
            ((TextComponent)var0).setSelectionEnd(var2 + var4);
         }

      }
   }

   public JDPUtils(JDPUser var1) {
      this.user = var1;
      this.dataSourceTypes = new Hashtable();
      if (var1 != null) {
         if (var1.jaggPath != null) {
            this.jaggSQL = new JDPJagg(var1.jaggPath);
            return;
         }

         if (var1.jaggSQL != null) {
            this.jaggSQL = new JDPJagg(var1.jaggSQL.getServer());
         }
      }

   }

   public String rtrim(String var1) {
      if (var1.length() == 0) {
         return var1;
      } else if (var1.substring(0, 1).compareTo(" ") != 0) {
         return var1.trim();
      } else {
         int var2;
         for(var2 = var1.length() - 1; var2 >= 0 && var1.substring(var2, var2 + 1).compareTo(" ") == 0; --var2) {
         }

         return var2 < 0 ? "" : var1.substring(0, var2 + 1);
      }
   }

   public static Color brighter(Color var0) {
      return new Color(Math.min((int)((double)var0.getRed() * ((double)1.0F / FACTOR)), 255), Math.min((int)((double)var0.getGreen() * ((double)1.0F / FACTOR)), 255), Math.min((int)((double)var0.getBlue() * ((double)1.0F / FACTOR)), 255));
   }

   public float aton(String var1) {
      float var2;
      if (var1.indexOf("...") >= 0) {
         var2 = 0.0F;
      } else {
         float var4 = 1.0F;
         if (var1.indexOf("-") >= 0) {
            var4 = -1.0F;
            var1 = var1.replace('-', ' ');
         }

         var1 = var1.replace(',', ' ').trim();
         float var3 = -1.0F;
         int var5 = var1.lastIndexOf(" ");
         int var6 = var1.indexOf("/");
         if (var6 >= 0) {
            var3 = (float)Integer.parseInt(var1.substring(var5 + 1, var6)) / (float)Integer.parseInt(var1.substring(var6 + 1));
         }

         if (var5 >= 0) {
            var1 = var1.substring(0, var5);
            var2 = (float)Integer.parseInt(var1) + var3;
         } else if (var6 < 0) {
            var2 = (float)Integer.parseInt(var1);
         } else {
            var2 = var3;
         }

         var2 *= var4;
      }

      return var2;
   }

   public static Color getTextHighlight() {
      return textHighlight;
   }

   public int StringHeight(Graphics var1) {
      if (var1 == null) {
         return 0;
      } else {
         if (var1.getFont() != this.lastFont) {
            this.field_0 = var1.getFontMetrics();
            this.widths = this.field_0.getWidths();
            this.lastFont = var1.getFont();
         }

         return this.field_0.getHeight();
      }
   }

   public JDPTabSelectPanel getMenuPanel() {
      return this.user.getMenuPanel();
   }

   public static boolean isOdbcNum(int var0) {
      switch (var0) {
         case -6:
         case -5:
         case 2:
         case 3:
         case 4:
         case 5:
         case 6:
         case 7:
         case 8:
            return true;
         default:
            return false;
      }
   }

   boolean listSelect(List var1, String var2) {
      if (var1 == null) {
         return false;
      } else {
         for(int var3 = 0; var3 < var1.countItems(); ++var3) {
            if (var1.getItem(var3).equals(var2)) {
               var1.select(var3);
               return true;
            }
         }

         return false;
      }
   }

   public boolean isnumeric(Component var1, JDPStatusMessage var2) {
      return this.isnumeric(var1, var2, "Please enter a valid numeric value");
   }

   public boolean isnumeric(Component var1, JDPStatusMessage var2, String var3) {
      if (var3.equals("")) {
         var3 = "Please enter a valid numeric value";
      }

      if (var1 instanceof TextField) {
         TextField var4 = (TextField)var1;
         if (((TextComponent)var4).getText().equals("")) {
            ((TextComponent)var4).setText("0");
            return true;
         }

         try {
            long var5 = Long.parseLong(this.replace(((TextComponent)var4).getText(), ",", "").trim());
            ((TextComponent)var4).setText(Long.toString(var5));
         } catch (Exception var7) {
            var2.setStatusMsg(var3, 10);
            ((Component)var4).requestFocus();
            ((TextComponent)var4).selectAll();
            return false;
         }
      }

      return true;
   }

   String makeLabel(String var1) {
      if (var1 == null) {
         return null;
      } else {
         var1 = this.replace(var1, "`", "");
         if (var1.indexOf(".") > 0) {
            var1 = var1.substring(var1.indexOf(".") + 1);
         }

         var1 = var1.substring(0, 1).toUpperCase() + var1.substring(1).toLowerCase();
         int var2 = var1.indexOf("name");
         if (var2 > 0) {
            var1 = var1.substring(0, var2) + " " + var1.substring(var2, var2 + 1).toUpperCase() + var1.substring(var2 + 1).toLowerCase();
         }

         var2 = var1.indexOf("desc");
         if (var2 > 0) {
            var1 = var1.substring(0, var2) + " " + var1.substring(var2, var2 + 1).toUpperCase() + var1.substring(var2 + 1).toLowerCase();
         }

         var2 = var1.indexOf("_");
         if (var2 > 0 && var2 < var1.length() - 2) {
            var1 = var1.substring(0, var2) + " " + var1.substring(var2 + 1, var2 + 2).toUpperCase() + var1.substring(var2 + 2).toLowerCase();
         }

         var1 = this.replace(var1, "  ", " ");
         return var1;
      }
   }

   public static boolean isOdbcFloat(int var0) {
      switch (var0) {
         case 2:
         case 3:
         case 6:
         case 7:
         case 8:
            return true;
         case 4:
         case 5:
         default:
            return false;
      }
   }

   public String dateFormat(String var1, String var2, String var3, String var4) {
      var4 = this.replace(var4, "mm", var1);
      var4 = this.replace(var4, "dd", var2);
      var4 = this.replace(var4, "yy", var3);
      return var4;
   }

   public static Color getTextHighlightText() {
      return textHighlightText;
   }

   public String replace(String var1, String var2, String var3) {
      return replace(var1, var2, var3, 100000);
   }

   public static String replace(String var0, String var1, String var2, int var3) {
      if (var0 != null && var1 != null && var0.indexOf(var1) >= 0 && var0.length() >= var1.length() && var1.length() != 0) {
         int var4 = var0.length();
         int var5 = var2.length();
         int var6 = var1.length();
         char[] var7 = new char[0];
         int var9 = 0;
         int var10 = 0;

         for(int var8 = var0.indexOf(var1); var8 >= 0 && var3-- > 0; var8 = var0.indexOf(var1, var9)) {
            if (var10 + var8 - var9 > var7.length) {
               char[] var11 = new char[var7.length + (var8 - var9) * 2];
               System.arraycopy(var7, 0, var11, 0, var7.length);
               var7 = var11;
            }

            var0.getChars(var9, var8, var7, var10);
            var10 += var8 - var9;
            if (var10 + var5 > var7.length) {
               char[] var14 = new char[var7.length + var5 * 2];
               System.arraycopy(var7, 0, var14, 0, var7.length);
               var7 = var14;
            }

            var2.getChars(0, var5, var7, var10);
            var10 += var5;
            var9 = var8 + var6;
         }

         if (var10 + var4 > var7.length) {
            char[] var15 = new char[var7.length + var4 * 2];
            System.arraycopy(var7, 0, var15, 0, var7.length);
            var7 = var15;
         }

         var0.getChars(var9, var4, var7, var10);
         var10 += var4 - var9;
         return new String(var7, 0, var10);
      } else {
         return var0;
      }
   }

   public String getDataSourceType(JDPJagg var1) {
      String var2 = (String)this.dataSourceTypes.get(var1.getDSN());
      if (var2 != null) {
         return var2;
      } else {
         int var4 = 0;
         Vector var5 = new Vector();
         String var6 = var1.getSEP();
         int var7 = 0;
         String var9 = "";
         var1.setFCTN("SQLDriverName");
         var1.setFCTNP("");
         var4 = var1.execSQL(var9, var5);
         var1.setFCTN("");
         if (var4 == -1) {
            if (this.user != null) {
               this.user.u.setSqlMessage(var1, "SQLDriverName function failed");
            } else {
               System.out.println("SQLDriverName function failed");
            }

            return null;
         } else {
            var7 = var1.getRowCount();
            if (var7 > 0) {
               String var8 = (String)var5.elementAt(0);
               StringTokenizer var3 = new StringTokenizer(var8);
               String var10 = var3.nextToken(var6).trim();
               this.dataSourceTypes.put(var1.getDSN(), var10.toUpperCase());
               return var10.toUpperCase();
            } else {
               return null;
            }
         }
      }
   }

   public String str(float var1, int var2, int var3) {
      int var4 = 0;
      int var5 = (int)(var1 * 1000.0F);
      String var6 = "        " + Integer.toString(var5);
      String var8 = var6.substring(var6.length() - 3).replace(' ', '0');
      String var7;
      if (var8.compareTo("000") != 0) {
         var7 = var6.substring(0, var6.length() - 3) + "." + var8;
      } else {
         var7 = var6.substring(0, var6.length() - 3);
      }

      if (var7.indexOf(".") < 0 && var3 > 0) {
         var7 = var7 + ".";
      }

      if (var7.indexOf(".") >= 0) {
         var7 = "                   " + var7 + "000000000";
         var4 = var7.indexOf(".") - var2 + var3 + 1;
         if (var4 < 0) {
            var4 = 0;
         }
      } else {
         var7 = "                   " + var7;
         var4 = var7.length() - var2;
      }

      return var7.substring(var4, var4 + var2);
   }

   public static void loadODBCList(List var0) {
      var0.addItem("BigInt");
      var0.addItem("Binary");
      var0.addItem("Bit");
      var0.addItem("Char");
      var0.addItem("Date");
      var0.addItem("Decimal");
      var0.addItem("Double");
      var0.addItem("Float");
      var0.addItem("Integer");
      var0.addItem("LongVarBinary");
      var0.addItem("LongVarChar");
      var0.addItem("Numeric");
      var0.addItem("Real");
      var0.addItem("SmallInt");
      var0.addItem("Time");
      var0.addItem("TimeStamp");
      var0.addItem("TinyInt");
      var0.addItem("VarBinary");
      var0.addItem("VarChar");
   }

   public int StringWidth(Graphics var1, String var2) {
      if (var1 == null) {
         return 0;
      } else if (var2 != null && !var2.equals("")) {
         if (var1.getFont() != this.lastFont) {
            this.field_0 = var1.getFontMetrics();
            this.widths = this.field_0.getWidths();
            this.lastFont = var1.getFont();
         }

         return this.field_0 != null ? this.field_0.stringWidth(var2) : 0;
      } else {
         return 0;
      }
   }

   public static boolean isOdbcBinary(int var0) {
      switch (var0) {
         case -7:
         case -4:
         case -3:
         case -2:
            return true;
         case -6:
         case -5:
         default:
            return false;
      }
   }

   public Object getInstanceHandle(String var1, boolean var2) {
      Object var3 = null;
      String var4 = "";
      int var5 = 0;

      for(int var6 = 0; var6 < this.user.gParm.size(); ++var6) {
         if (this.user.gParm.elementAt(var6) != null) {
            var4 = this.user.gParm.elementAt(var6).toString();
            var5 = var4.indexOf("[");
            if (var5 >= 0) {
               var4 = var4.substring(0, var5);
            }

            if (var4.equals(var1)) {
               var3 = this.user.gParm.elementAt(var6);
               return var3;
            }
         }
      }

      if (var2 && this.getMenuPanel() != null && this.getMenuPanel().loadObject(var1)) {
         for(int var13 = 0; var13 < this.user.gParm.size(); ++var13) {
            if (this.user.gParm.elementAt(var13) != null) {
               var4 = this.user.gParm.elementAt(var13).toString();
               var5 = var4.indexOf("[");
               if (var5 >= 0) {
                  var4 = var4.substring(0, var5);
               }

               if (var4.equals(var1)) {
                  var3 = this.user.gParm.elementAt(var13);
                  return var3;
               }
            }
         }
      }

      return null;
   }

   public static Object createObject(Class var0, String var1) {
      if (var1 == null) {
         return null;
      } else {
         try {
            String var2 = var0.getName();
            if (var2.equals("java.lang.String") || var2.equals("String")) {
               return var1;
            }

            if (var2.equals("int")) {
               if (var1.equals("")) {
                  var1 = "0";
               }

               return new Integer(var1);
            }

            if (var2.equals("boolean")) {
               if (var1.equals("true")) {
                  return new Boolean(true);
               }

               return new Boolean(false);
            }

            if (var2.equals("char")) {
               return new Character(var1.charAt(0));
            }

            if (var2.equals("byte")) {
               return new Byte(var1);
            }

            if (var1.equals("")) {
               var1 = "0";
            }

            if (var2.equals("short")) {
               return new Short(var1);
            }

            if (var2.equals("long")) {
               return new Long(var1);
            }

            if (var2.equals("float")) {
               return new Float(var1);
            }

            if (var2.equals("double")) {
               return new Double(var1);
            }

            if (!System.getProperty("java.version").startsWith("1.0")) {
               Constructor[] var3 = var0.getConstructors();
               Object var4 = null;
               Object[] var5 = new Object[]{var1};

               for(int var6 = 0; var6 < var3.length; ++var6) {
                  Class[] var11 = var3[var6].getParameterTypes();
                  if (var11.length == 1) {
                     try {
                        Object var7 = var3[var6].newInstance(var5);
                        return var7;
                     } catch (Exception var9) {
                        ((Throwable)var9).printStackTrace();
                     }
                  }
               }
            }
         } catch (Exception var10) {
         }

         return null;
      }
   }

   public static String getFieldQuote(int var0, String var1) {
      if (isOdbcDate(var0) && var1.indexOf(JDPJagg.FOXPRO) >= 0) {
         return "#";
      } else {
         return !isOdbcChar(var0) && !isOdbcDate(var0) ? "" : "'";
      }
   }

   public Color _cvtcolor(String var1) {
      if (var1.compareTo("Black") == 0) {
         return Color.black;
      } else if (var1.compareTo("Blue") == 0) {
         return Color.blue;
      } else if (var1.compareTo("White") == 0) {
         return Color.white;
      } else if (var1.compareTo("Yellow") == 0) {
         return Color.yellow;
      } else if (var1.compareTo("Magenta") == 0) {
         return Color.magenta;
      } else if (var1.compareTo("Pink") == 0) {
         return Color.pink;
      } else if (var1.compareTo("Purple") == 0) {
         return Color.magenta.darker();
      } else if (var1.compareTo("Cyan") == 0) {
         return Color.cyan;
      } else if (var1.compareTo("DarkGray") == 0) {
         return Color.darkGray;
      } else if (var1.compareTo("Gray") == 0) {
         return Color.gray;
      } else if (var1.compareTo("Green") == 0) {
         return Color.green;
      } else if (var1.compareTo("LightGray") == 0) {
         Color var2 = getControlColor();
         return var2;
      } else if (var1.compareTo("Orange") == 0) {
         return Color.orange;
      } else {
         return var1.compareTo("Red") == 0 ? Color.red : Color.black;
      }
   }

   static {
      colorList = new Color[]{Color.blue, Color.cyan, Color.green, Color.magenta, Color.orange, Color.red, Color.white, Color.yellow, Color.pink, Color.black, Color.darkGray, Color.gray};
      controlColor = Color.lightGray;
      numColors = 8;
      textHighlightText = Color.white;
      textHighlight = Color.black;
      FACTOR = 0.7;
   }

   public static String setSpace(String var0) {
      return var0 != null && !var0.equals("") ? var0 : " ";
   }

   int listIndexOf(List var1, String var2) {
      if (var1 == null) {
         return -1;
      } else {
         for(int var3 = 0; var3 < var1.countItems(); ++var3) {
            if (var1.getItem(var3).equals(var2)) {
               return var3;
            }
         }

         return -1;
      }
   }

   public static int getODBCValue(String var0) {
      if (var0.equals("BigInt")) {
         return -5;
      } else if (var0.equals("Binary")) {
         return -2;
      } else if (var0.equals("Bit")) {
         return -7;
      } else if (var0.equals("Char")) {
         return 1;
      } else if (var0.equals("Date")) {
         return 91;
      } else if (var0.equals("Decimal")) {
         return 3;
      } else if (var0.equals("Double")) {
         return 8;
      } else if (var0.equals("Float")) {
         return 6;
      } else if (var0.equals("Integer")) {
         return 4;
      } else if (var0.equals("LongVarBinary")) {
         return -4;
      } else if (var0.equals("LongVarChar")) {
         return -1;
      } else if (var0.equals("Numeric")) {
         return 2;
      } else if (var0.equals("Real")) {
         return 7;
      } else if (var0.equals("SmallInt")) {
         return 5;
      } else if (var0.equals("Time")) {
         return 92;
      } else if (var0.equals("TimeStamp")) {
         return 93;
      } else if (var0.equals("TinyInt")) {
         return -6;
      } else if (var0.equals("VarBinary")) {
         return -3;
      } else {
         return var0.equals("VarChar") ? 12 : 1;
      }
   }

   public static String getODBCValue(int var0) {
      switch (var0) {
         case -7:
            return "Bit";
         case -6:
            return "TinyInt";
         case -5:
            return "BigInt";
         case -4:
            return "LongVarBinary";
         case -3:
            return "VarBinary";
         case -2:
            return "Binary";
         case -1:
            return "LongVarChar";
         case 1:
            return "Char";
         case 2:
            return "Numeric";
         case 3:
            return "Decimal";
         case 4:
            return "Integer";
         case 5:
            return "SmallInt";
         case 6:
            return "Float";
         case 7:
            return "Real";
         case 8:
            return "Double";
         case 9:
            return "Date";
         case 11:
            return "Date";
         case 12:
            return "VarChar";
         case 91:
            return "Date";
         case 92:
            return "Time";
         case 93:
            return "TimeStamp";
         default:
            return null;
      }
   }

   public static boolean isOdbcEqual(int var0, int var1) {
      switch (var0) {
         case -7:
         case -4:
         case -3:
         case -2:
            switch (var1) {
               case -7:
               case -4:
               case -3:
               case -2:
                  return true;
               case -6:
               case -5:
               default:
                  return false;
            }
         case -6:
         case -5:
         case 2:
         case 3:
         case 4:
         case 5:
         case 6:
         case 7:
         case 8:
            switch (var1) {
               case -6:
               case -5:
               case 2:
               case 3:
               case 4:
               case 5:
               case 6:
               case 7:
               case 8:
                  return true;
               default:
                  return false;
            }
         case -1:
         case 1:
         case 12:
            switch (var1) {
               case -1:
               case 1:
               case 12:
                  return true;
               default:
                  return false;
            }
         case 9:
         case 11:
         case 91:
         case 93:
            switch (var1) {
               case 9:
               case 11:
               case 91:
               case 93:
                  return true;
               default:
                  return false;
            }
         default:
            return false;
      }
   }

   public boolean isfloat(Component var1, JDPStatusMessage var2) {
      return this.isfloat(var1, var2, "Please enter a valid numeric value");
   }

   public boolean isfloat(Component var1, JDPStatusMessage var2, String var3) {
      if (var3.equals("")) {
         var3 = "Please enter a valid numeric value";
      }

      if (var1 instanceof TextField) {
         TextField var4 = (TextField)var1;
         if (((TextComponent)var4).getText().equals("")) {
            ((TextComponent)var4).setText("0");
            return true;
         }

         try {
            Float.valueOf(this.replace(((TextComponent)var4).getText(), ",", "").trim());
         } catch (Exception var5) {
            var2.setStatusMsg(var3, 10);
            ((Component)var4).requestFocus();
            ((TextComponent)var4).selectAll();
            return false;
         }
      }

      return true;
   }

   public String readFromFile(String var1) {
      if (JDesignerPro.executable) {
         try {
            var1 = this.replace(var1, "/", JDesignerPro.serverSeparator);
            var1 = this.replace(var1, "\\", JDesignerPro.serverSeparator);
            FileInputStream var19 = new FileInputStream(var1);
            InputStream var18 = (InputStream)var19;
            new DataInputStream(var18);
            byte[] var6 = new byte[16384];
            int var7 = 0;

            try {
               int var8;
               while((var8 = var18.read(var6, var7, var6.length - var7)) >= 0) {
                  var7 += var8;
                  if (var7 == var6.length) {
                     byte[] var9 = new byte[var7 * 2];
                     System.arraycopy(var6, 0, var9, 0, var7);
                     var6 = var9;
                  }
               }

               var18.close();
               String var17 = new String(var6, 0, 0, var7);
               if (this.user != null && this.user.mainmsg != null) {
                  this.user.mainmsg.clearStatusMsg();
               }

               return var17;
            } catch (Exception var11) {
               ((Throwable)var11).printStackTrace();
               if (this.user != null && this.user.mainmsg != null) {
                  this.user.mainmsg.setStatusMsg("Error occured while loading source file. Please try again.", 15);
               }

               return null;
            }
         } catch (Exception var12) {
            if (this.user != null && this.user.mainmsg != null) {
               this.user.mainmsg.setStatusMsg("Could not load source file or source file does not exist.", 15);
            }

            return null;
         }
      } else {
         var1 = this.replace(var1, "/", JDesignerPro.serverSeparator);
         var1 = this.replace(var1, "\\", JDesignerPro.serverSeparator);
         if (this.user != null) {
            if (this.user.jaggPath != null) {
               this.jaggSQL = new JDPJagg(this.user.jaggPath);
            } else {
               this.jaggSQL = new JDPJagg(this.user.jaggSQL.getServer());
            }

            this.jaggSQL.setDSN(this.user.jaggDSN);
         } else {
            this.jaggSQL = new JDPJagg(this.jaggSQL.getServer());
         }

         StringBuffer var2 = new StringBuffer();
         this.jaggSQL.setFCTN("ReadFromFile");
         this.jaggSQL.setFCTNP(var1 + ";r;");
         Vector var3 = new Vector();
         int var4 = this.jaggSQL.execSQL("", var3);

         for(int var5 = 0; var5 < var3.size(); ++var5) {
            var2.append((String)var3.elementAt(var5));
         }

         this.jaggSQL.setFCTN("");
         this.jaggSQL.setFCTNP("");
         return var4 == -1 ? null : var2.toString();
      }
   }
}
