import java.util.StringTokenizer;
import java.util.Vector;

public class JDPVersionUpdate {
   JDPUser user;
   float oldVersion;
   float newVersion;
   String dbtype = "";
   String memotype = "text";
   String datetype = "date";
   String floattype = "float";
   String inttype = "int";
   String nullstring = " NULL";
   String tempdate;

   boolean setupJDBCSources() {
      String var1 = "SELECT jdbcdriver,jdbcdirect FROM JDPDataSrc";
      Vector var2 = new Vector();
      int var3 = this.user.jaggSQL.execSQL(var1, var2);
      if (var3 > 0) {
         return true;
      } else {
         if (this.user.loginMessage != null) {
            this.user.loginMessage.setStatusMsg("Setting up JDBC datasources...", 0);
         }

         if (var3 < 0) {
            var1 = "DROP TABLE JDPDataSrc";
            var2 = new Vector();
            this.user.jaggSQL.execSQL(var1, var2);
            var1 = "CREATE TABLE JDPDataSrc (sourcename char(50), jdbcdriver char(100), jdbcprefix char(100), jdbcsuffix char(100), conparms char(100), sourcetype char(50), jdbcdirect char(3))";
            this.runSQL(var1);
         }

         var2 = new Vector();
         this.user.jaggSQL.setFCTNP("");
         var1 = "INSERT INTO JDPDataSrc (sourcename, jdbcdriver, jdbcprefix, jdbcsuffix, conparms, sourcetype, jdbcdirect) " + "VALUES('" + this.user.jaggSQL.getDSN() + "','" + this.user.jaggSQL.getJdbcDriver() + "','" + this.user.jaggSQL.getJdbcPrefix() + "','" + this.user.jaggSQL.getJdbcSuffix() + "','" + this.user.jaggSQL.getCSTR() + "','" + this.dbtype + "'," + "'No')";
         this.runSQL(var1);
         if (this.user.JDesignerPro.JDPJaggDir != null) {
            if (JDPJagg.useJaggServer) {
               this.user.jaggSQL.setFCTN("System");
               var1 = this.user.JDesignerPro.JDPJaggDir + "JDPJagg.exe SQLDataSources";
            } else {
               this.user.jaggSQL.setFCTN("SQLDataSources");
               var1 = "";
            }

            this.user.jaggSQL.execSQL(var1, var2);
         }

         String var5 = this.user.jaggSQL.getSEP();
         this.user.jaggSQL.setFCTN("");
         this.user.jaggSQL.setFCTNP("");

         for(int var6 = 0; var6 < var2.size(); ++var6) {
            String var7 = (String)var2.elementAt(var6);
            if (var7 != null && var7.trim().compareTo("") != 0) {
               StringTokenizer var4 = new StringTokenizer(var7);
               String var8 = var4.nextToken(var5).trim();
               String var9 = var4.nextToken(var5).trim();
               if (!var8.equals(this.user.jaggSQL.getDSN().trim())) {
                  var1 = "INSERT INTO JDPDataSrc (sourcename, jdbcdriver, jdbcprefix, jdbcsuffix, conparms, sourcetype, jdbcdirect) " + "VALUES('" + var8 + "','" + "sun.jdbc.odbc.JdbcOdbcDriver','" + "jdbc:odbc:','" + var8 + "'," + "'','" + var9 + "'," + "'No')";
                  this.runSQL(var1);
               }
            }
         }

         this.user.jaggSQL.loadJdbcDataSources();
         return true;
      }
   }

   boolean updateTo2_3() {
      String var1 = "UPDATE JDPMenu SET menuobject = 'JDPWelcome' WHERE menuname = 'Main' AND menuparm = 'Docs/JDesignerPro.htm' AND JDPSystem = '" + this.user.JDPSystem + "'";
      if (this.runSQL(var1) == 0) {
         var1 = "UPDATE JDPMenu SET menuobject = 'JDPWelcome' WHERE menuname = 'System' AND menuparm = 'Docs/JDPSystemMain.htm' AND JDPSystem = '" + this.user.JDPSystem + "'";
         this.runSQL(var1);
      }

      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPToolMain' AND menuobject = 'JDPScreenBuild' AND menuparm = '6 IDE' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPToolMain' AND menudesc = 'View Module' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      return true;
   }

   JDPVersionUpdate(JDPUser var1, float var2, float var3) {
      this.user = var1;
      this.oldVersion = var2;
      this.newVersion = var3;
      if (this.setProperties()) {
         var1.JDesignerPro.getServerPlatform();
         if (var3 == 0.0F) {
            this.updateSystemTable();
         } else {
            if (var2 < var3) {
               this.addToolMenu();
               this.updateMenuOptions();
               this.addAppBuilderMenu();
               this.addSamplesMenu();
            }

            if (var2 < 2.1F) {
               this.updateTo2_1();
            }

            if (var2 < 2.2F) {
               this.updateTo2_2();
            }

            if (var2 < 2.3F) {
               this.updateTo2_3();
               this.addSamplesMenu2_3();
            }

            if (var2 < 2.5F) {
               this.updateTo2_5();
            }

            if (var2 < 2.1F) {
               this.moveProjects();
            }

            if (var2 < var3) {
               this.updateObjectTrees(var2, var3);
               this.setupJDBCSources();
            }

            if (var3 == 0.0F) {
               this.updateSystemTable();
            }

            new JDPSetupJedi(var1);
            if (var2 < 3.0F) {
               new JDPSetupSvr(var1);
            }

            if (var2 < 3.0F) {
               this.addSamplesMenu3_0();
               this.updateTo3_0();
            }

            String var4 = "UPDATE JDPSystemDef SET versionnum = '" + JDesignerPro.actualversion.trim() + "' WHERE JDPSystem = '" + var1.JDesignerPro.JDPSystem.trim() + "'";
            Vector var5 = new Vector();
            if (var1.jaggSQL.execSQL(var4, var5) < 0) {
               var1.u.setSqlMessage(var1.jaggSQL, var4);
            }
         }
      }
   }

   int runSQL(String var1) {
      Vector var2 = new Vector();
      int var3 = this.user.jaggSQL.execSQL(var1, var2);
      if (var3 < 0) {
         System.out.println(var1);
         System.out.println("SQL Failed - Installation terminated");
         this.user.loginMessage.setStatusMsg("Update Failed - see Java Console", 30);
      }

      return var3;
   }

   boolean updateTo3_0() {
      if (this.user.loginMessage != null) {
         this.user.loginMessage.setStatusMsg("Updating Menus...", 0);
      }

      String var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPToolMain' AND menuobject = 'JDPSQLWizard'";
      Vector var2 = new Vector();
      if (this.user.jaggSQL.execSQL(var1, var2) <= 0) {
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPToolMain',11," + "'P','JDPSQLWizard','SQLOnly', " + "'SQL Interactive'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
      }

      if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPKeyWd")) {
         var1 = "CREATE TABLE JDPKeyWd " + "(keyword char(30), docindex char(200))";
         this.runSQL(var1);
      }

      if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPDocIx")) {
         var1 = "CREATE TABLE JDPDocIx " + "(docindex int, filename char(50), title char(200))";
         this.runSQL(var1);
      }

      var1 = "CREATE UNIQUE INDEX JDPSysDX ON JDPSystemDef " + "(JDPSystem)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPMenuX ON JDPMenu " + "(JDPSystem, menuname, menunum)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPMenuAX ON JDPMenuAuth " + "(JDPSystem, userid)";
      this.runSQL(var1);
      var1 = "CREATE UNIQUE INDEX JDPUserX ON JDPUser " + "(userid)";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuobject = 'JDPHelpBrowser' WHERE menuobject = 'JDPBrowserCtl' AND menuname = 'Main' AND menuparm = 'Docs/jdpmanual.htm' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuobject = 'JDPHelpBrowser' WHERE menuobject = 'JDPBrowserCtl' AND menuname = 'JDPAppBuilder' AND menudesc = 'Help' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuobject = 'JDPHelpBrowser' WHERE menuobject = 'JDPBrowserCtl' AND menuname = 'System' AND menudesc = 'Help' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuobject = 'JDPHelpBrowser' WHERE menuobject = 'JDPBrowser' AND menuname = 'JDPToolMain' AND menudesc = 'Help' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menudesc = 'Free Support' WHERE menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "' AND menuobject = 'JDPSupportApp'";
      this.runSQL(var1);
      if (JDPJagg.useJaggServer) {
         this.user.jaggPath = this.user.JDesignerPro.JDPJaggPath;
         this.user.loginMessage.setStatusMsg("Waiting for Enterprise Server to start...", 0);

         try {
            Thread.sleep(18000L);
         } catch (Exception var9) {
         }

         if (this.user.cust == null) {
            this.user.cust = new JDPCustomer();
         }

         String var3 = this.user.cust.username;
         this.user.cust.username = "JDPSubsystemMgr";
         JDPRMIConnection var4 = new JDPRMIConnection(this.user);
         String var5 = var4.submitJob("QIMMED", "Index Help Files", "C", "JDPIndexHelpText", "JDPSubsystemMgr,JDPJob", "JDPSubsystemMgr,JDPJob", 1, 5, false, -1, "", "", "F");

         for(int var6 = 0; var5 == null && var6++ < 6; var5 = var4.submitJob("QIMMED", "Index Help Files", "C", "JDPIndexHelpText", "JDPSubsystemMgr,JDPJob", "JDPSubsystemMgr,JDPJob", 1, 5, false, -1, "", "", "F")) {
            try {
               Thread.sleep(3000L);
            } catch (Exception var8) {
            }
         }

         this.user.cust.username = var3;
         if (var5 != null) {
            this.user.loginMessage.setStatusMsg("Help Text Indexing Job submitted...", 0);

            try {
               Thread.sleep(3000L);
            } catch (Exception var7) {
            }
         }
      }

      return true;
   }

   boolean addToolMenu() {
      String var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPToolMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      if (this.runSQL(var1) == 0) {
         if (this.user.loginMessage != null) {
            this.user.loginMessage.setStatusMsg("Updating Menus...", 0);
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','Main',21," + "'M','JDPToolMain','', " + "'Tools'," + "'A'," + "'Black', " + "'LightGray'," + "'ADMIN','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPToolMain',0," + "'P','JDPBrowser','Docs/JDPToolMain.htm', " + "'Help'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPToolMain',1," + "'P','JDPDatabaseMaint','', " + "'Database Maintenance'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }
      }

      return true;
   }

   boolean addAppBuilderMenu() {
      String var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "' AND menuobject = 'JDPLayoutMgr'";
      if (this.runSQL(var1) == 0) {
         if (this.user.loginMessage != null) {
            this.user.loginMessage.setStatusMsg("Updating Menus...", 0);
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','Main',18," + "'M','JDPAppBuilder','', " + "'Application Builder'," + "'A'," + "'Black', " + "'LightGray'," + "'ADMIN','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',0," + "'P','JDPBrowserCtl','Docs/JDPAppBuilderHelp.htm', " + "'Help'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',2," + "'P','JDPLayoutMgr','', " + "'Layout Manager'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }

         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',3," + "'B','','', " + "'View Finished Product'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         if (this.runSQL(var1) < 0) {
            return false;
         }
      }

      return true;
   }

   boolean addSamplesMenu() {
      String var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "' AND menuobject = 'JDPExamples'";
      if (this.runSQL(var1) == 0) {
         if (this.user.loginMessage != null) {
            this.user.loginMessage.setStatusMsg("Creating Examples Menu...", 0);
         }

         this.user.JDesignerPro.getServerPlatform();
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',30," + "'M','JDPExamples','', " + "'Examples'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
         this.createSampleMenu(0, "Alpha Paging Merge", "AlphaMerge", 2, true);
         this.createSampleMenu(0, "Simple Alpha Paging", "SimplePaging", 4, true);
         this.createSampleMenu(0, "Component DragDrop", "CompDragAndDrop", 6, false);
         this.createSampleMenu(0, "File DragDrop", "FileDragAndDrop", 8, false);
         this.createSampleMenu(0, "Tree DragDrop", "TreeDragAndDrop", 9, false);
         this.createSampleMenu(0, "Email Merge", "EmailMerge", 10, true);
         this.createSampleMenu(0, "Simple Email", "SimpleEmail", 12, false);
         this.createSampleMenu(0, "FilePicker", "FilePicker", 14, false);
         this.createSampleMenu(0, "Html Loader", "HtmlLoader", 16, true);
         this.createSampleMenu(0, "Instances", "SimpleInstance", 18, false);
         this.createSampleMenu(0, "Popup Menu", "PopupMenu", 20, false);
         this.createSampleMenu(0, "Tree Popup Menu", "TreePopupMenu", 22, false);
         this.createSampleMenu(0, "Sales Order Inq", "SalesOrder", 24, true);
         this.createSampleMenu(0, "Simple SQL", "SampleQuery", 26, true);
         this.createSampleMenu(0, "Search Panel", "SearchPanel", 28, true);
         this.createSampleMenu(0, "Server Command", "ServerCommand", 30, false);
         this.createSampleMenu(0, "SpreadSheet", "SpreadSheet", 32, false);
      }

      return true;
   }

   boolean createSampleMenu(int var1, String var2, String var3, int var4, boolean var5) {
      String var6 = "JDPExamples";
      if (var1 > 0) {
         var6 = var6 + Integer.toString(var1);
      }

      String var7 = "P";
      if (var2.indexOf(" Menu") >= 0 && var2.indexOf("Popup") < 0) {
         var7 = "M";
      }

      String var8 = Integer.toString(var4);
      if (!var5 || JDesignerPro.serverPlatform.startsWith("Windows")) {
         String var9 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','" + var6 + "'," + var8 + "," + "'" + var7 + "','" + var3 + "','', " + "'" + var2 + "'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var9);
      }

      return true;
   }

   boolean moveProjects() {
      if (this.user.loginMessage != null) {
         this.user.loginMessage.setStatusMsg("Moving Projects...", 0);
      }

      if (!JDPUtils.check4Table(this.user.jaggSQL, this.dbtype, "JDPClassDef")) {
         return true;
      } else {
         String var2 = this.user.jaggSQL.getSEP();
         String var3 = "SELECT owner,ClassName from JDPClassDef WHERE projtype = 'B' AND JDPSystem = '" + this.user.JDPSystem + "'";
         Vector var4 = new Vector();
         int var5 = this.user.jaggSQL.execSQL(var3, var4);
         this.user.jaggSQL.setFCTN("RenameFile");

         for(int var6 = 0; var6 < var5; ++var6) {
            this.user.loginMessage.setStatusMsg("Moving Builder Project " + Integer.toString(var6 + 1) + " of " + Integer.toString(var5) + "...", 0);
            StringTokenizer var1 = new StringTokenizer((String)var4.elementAt(var6), var2);
            String var7 = var1.nextToken().trim();
            String var8 = var1.nextToken().trim();
            String var9 = this.user.JDesignerPro.JDPDirectory + var8 + ".jdp;";
            var9 = var9 + this.user.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator;
            var9 = var9 + "Users" + JDesignerPro.serverSeparator;
            var9 = var9 + var7 + JDesignerPro.serverSeparator;
            var9 = var9 + var8 + ".jdp;";
            this.user.jaggSQL.setFCTNP(var9);
            Vector var10 = new Vector();
            this.user.jaggSQL.execSQL("", var10);
            var9 = this.user.JDesignerPro.JDPDirectory + var8 + ".java;";
            var9 = var9 + this.user.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator;
            var9 = var9 + "Users" + JDesignerPro.serverSeparator;
            var9 = var9 + var7 + JDesignerPro.serverSeparator;
            var9 = var9 + var8 + ".java;";
            this.user.jaggSQL.setFCTNP(var9);
            var10 = new Vector();
            this.user.jaggSQL.execSQL("", var10);
         }

         this.user.jaggSQL.setFCTN("");
         this.user.jaggSQL.setFCTNP("");
         var3 = "SELECT owner,ClassName from JDPClassDef WHERE projtype = 'W' AND JDPSystem = '" + this.user.JDPSystem + "'";
         var4 = new Vector();
         var5 = this.user.jaggSQL.execSQL(var3, var4);
         this.user.jaggSQL.setFCTN("RenameFile");

         for(int var15 = 0; var15 < var5; ++var15) {
            this.user.loginMessage.setStatusMsg("Moving Wizard Project " + Integer.toString(var15 + 1) + " of " + Integer.toString(var5) + "...", 0);
            StringTokenizer var11 = new StringTokenizer((String)var4.elementAt(var15), var2);
            var11.nextToken().trim();
            String var16 = var11.nextToken().trim();
            String var17 = this.user.JDesignerPro.JDPDirectory + var16 + ".jdp;";
            var17 = var17 + this.user.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator;
            var17 = var17 + "Wizard" + JDesignerPro.serverSeparator;
            var17 = var17 + var16 + ".jdp;";
            this.user.jaggSQL.setFCTNP(var17);
            Vector var34 = new Vector();
            this.user.jaggSQL.execSQL("", var34);
            var17 = this.user.JDesignerPro.JDPDirectory + var16 + ".java;";
            var17 = var17 + this.user.JDesignerPro.JDPDirectory + "Applications" + JDesignerPro.serverSeparator;
            var17 = var17 + "Wizard" + JDesignerPro.serverSeparator;
            var17 = var17 + var16 + ".java;";
            this.user.jaggSQL.setFCTNP(var17);
            var34 = new Vector();
            this.user.jaggSQL.execSQL("", var34);
         }

         return true;
      }
   }

   boolean addSamplesMenu2_3() {
      this.createSampleMenu(0, "Printing", "HtmlAndExcel", 34, true);
      this.createSampleMenu(0, "Printing and Email", "SimplePrinting", 36, false);
      this.createSampleMenu(0, "Sales Inquiry", "SalesInquiry", 37, true);
      this.createSampleMenu(0, "Dialogs", "DialogExample", 38, false);
      this.createSampleMenu(0, "EditMasks", "MaskEditDemo", 40, false);
      this.createSampleMenu(0, "Partial Key ResultList", "PartialKeyResultList", 42, true);
      return true;
   }

   boolean updateTo2_2() {
      String var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "' AND menuobject = 'JDPDeploymentMgr'";
      if (this.runSQL(var1) == 0) {
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',6," + "'P','JDPDeployment','', " + "'Deployment'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
      } else {
         var1 = "UPDATE JDPMenu SET menuobject = 'JDPDeployment', menudesc = 'Deployment' WHERE menuobject = 'JDPDeploymentMgr' AND JDPSystem = '" + this.user.JDPSystem + "'";
         this.runSQL(var1);
      }

      var1 = "UPDATE JDPMenu SET menudesc = 'Preview' WHERE menudesc = 'View Finished Product' AND menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuobject = 'JDPBrowserCtl' WHERE menuobject = 'JDPBrowser' AND menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND menuobject = 'JDPMenuAddOption' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND menuobject = 'JDPAddToHtml' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND menuobject = 'JDPDebugMgr' AND JDPSystem = '" + this.user.JDPSystem + "'";
      if (this.runSQL(var1) <= 0) {
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',4," + "'P','JDPDebugMgr','', " + "'Debugger'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
      }

      return true;
   }

   boolean addSamplesMenu3_0() {
      String var1 = "UPDATE JDPMenu " + "SET menunum = 11 " + "WHERE menuname = 'JDPExamples' " + "AND menunum = 9 " + "AND menuobject = 'SalesChartByStore' " + "AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu " + "SET menuname = 'JDPExamples1' " + "WHERE menuname = 'JDPExamples' " + "AND menunum <= 10 " + "AND menutype = 'P' " + "AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu " + "SET menuname = 'JDPExamples2', " + "menunum = menunum - 10 " + "WHERE menuname = 'JDPExamples' " + "AND menunum > 10 AND menunum <= 20 " + "AND menutype = 'P' " + "AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu " + "SET menuname = 'JDPExamples3', " + "menunum = menunum - 20 " + "WHERE menuname = 'JDPExamples' " + "AND menunum > 20 AND menunum <= 30 " + "AND menutype = 'P' " + "AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu " + "SET menuname = 'JDPExamples4', " + "menunum = menunum - 30 " + "WHERE menuname = 'JDPExamples' " + "AND menunum > 30 AND menunum <= 40 " + "AND menutype = 'P' " + "AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu " + "SET menuname = 'JDPExamples5', " + "menunum = menunum - 40 " + "WHERE menuname = 'JDPExamples' " + "AND menunum > 40 AND menunum <= 50 " + "AND menutype = 'P' " + "AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      this.createSampleMenu(0, "Example Menu1", "JDPExamples1", 1, false);
      this.createSampleMenu(0, "Example Menu2", "JDPExamples2", 2, false);
      this.createSampleMenu(0, "Example Menu3", "JDPExamples3", 3, false);
      this.createSampleMenu(0, "Example Menu4", "JDPExamples4", 4, false);
      this.createSampleMenu(0, "Example Menu5", "JDPExamples5", 5, false);
      this.createSampleMenu(0, "Server Side Menu", "JDPExamples10", 10, false);
      this.createSampleMenu(10, "Simple Server Push", "SimpleServerPush", 2, false);
      this.createSampleMenu(10, "Receive Server Push", "ReceiveServerPush", 4, false);
      this.createSampleMenu(10, "Next Available Number", "NextAvailableNum", 6, false);
      this.createSampleMenu(10, "Submit Server Job", "SubmitServerJob", 8, false);
      this.createSampleMenu(10, "Security Check", "SecurityCheck", 10, false);
      this.createSampleMenu(10, "Sales Report", "SalesReportClient", 12, true);
      return true;
   }

   boolean updateSystemTable() {
      String var1 = "DROP TABLE JDPTemp";
      new Vector();
      var1 = "CREATE TABLE JDPTemp (" + "JDPSystem char (5) ," + "JDPSystemD char (50) ," + "versionnum char (10) ," + "bfontname char (30) ," + "bfontsize " + this.inttype + " ," + "pfontname char (30) ," + "pfontsize " + this.inttype + ", " + "jlanguage char (2) ," + "country char (2), " + "dateformat char (20) )";
      this.runSQL(var1);
      var1 = "INSERT INTO JDPTemp (" + "JDPSystem, JDPSystemD, versionnum, bfontname, bfontsize, pfontname, pfontsize, jlanguage, country, dateformat) " + "SELECT JDPSystem, JDPSystemD, versionnum, bfontname, bfontsize, pfontname, pfontsize, 'en', '  ', 'mm/dd/yy' " + "FROM JDPSystemDef";
      this.runSQL(var1);
      var1 = "DROP TABLE JDPSystemDef";
      this.runSQL(var1);
      var1 = "CREATE TABLE JDPSystemDef (" + "JDPSystem char (5) ," + "JDPSystemD char (50) ," + "versionnum char (10) ," + "bfontname char (30) ," + "bfontsize " + this.inttype + " ," + "pfontname char (30) ," + "pfontsize " + this.inttype + ", " + "jlanguage char (2) ," + "country char (2), " + "dateformat char (20) )";
      this.runSQL(var1);
      var1 = "INSERT INTO JDPSystemDef (JDPSystem, JDPSystemD, versionnum, bfontname, bfontsize, pfontname, pfontsize, jlanguage, country, dateformat) " + "SELECT JDPSystem, JDPSystemD, versionnum, bfontname, bfontsize, pfontname, pfontsize, jlanguage, country, dateformat FROM JDPTemp";
      this.runSQL(var1);
      var1 = "DROP TABLE JDPTemp";
      this.runSQL(var1);
      return true;
   }

   void setupDeploymentManager() {
      new Vector();
   }

   boolean setProperties() {
      this.dbtype = this.user.u.getDataSourceType(this.user.jaggSQL);
      if (this.dbtype == null) {
         return false;
      } else {
         this.tempdate = "'01/01/90'";
         if (this.dbtype.indexOf(JDPJagg.MSSQLSERVER) >= 0) {
            this.memotype = "text";
            this.datetype = "datetime";
            this.floattype = "decimal";
         } else if (this.dbtype.indexOf(JDPJagg.SYBASE) < 0 && this.dbtype.indexOf(JDPJagg.SYBASE10) < 0) {
            if (this.dbtype.indexOf(JDPJagg.ANYWHERE) >= 0) {
               this.memotype = "text";
               this.datetype = "datetime";
               this.floattype = "decimal";
               this.tempdate = "DATE('1990-01-01')";
            } else if (this.dbtype.indexOf(JDPJagg.VFOXPRO) >= 0) {
               this.memotype = "memo";
               this.floattype = "int";
               this.nullstring = "";
               this.tempdate = "CTOD('01/01/90')";
            } else if (this.dbtype.indexOf(JDPJagg.FOXPRO) >= 0) {
               this.memotype = "memo";
               this.floattype = "int";
               this.nullstring = "";
            } else if (this.dbtype.indexOf(JDPJagg.ORACLE) >= 0) {
               this.memotype = "long";
               this.floattype = "decimal";
               this.tempdate = "to_date('01/01/90','mm/dd/yy')";
            } else if (this.dbtype.indexOf(JDPJagg.POLITE) >= 0) {
               this.memotype = "long";
               this.floattype = "decimal";
               this.tempdate = "to_date('01/01/90','mm/dd/yy')";
            } else if (this.dbtype.indexOf(JDPJagg.DB2) >= 0) {
               this.memotype = "long varchar";
               this.floattype = "decimal";
               this.tempdate = "DATE('1990-01-01')";
            }
         } else {
            this.memotype = "text";
            this.datetype = "datetime";
            this.floattype = "decimal";
         }

         if (this.dbtype.indexOf(JDPJagg.SOLIDSERVER) >= 0) {
            this.memotype = "long varchar";
            this.floattype = "decimal";
            this.tempdate = "'1990-01-01'";
         }

         if (this.dbtype.indexOf(JDPJagg.CLOUDSCAPE) >= 0) {
            this.tempdate = "DATE'1990-01-01'";
         }

         if (this.dbtype.indexOf(JDPJagg.INFORMIX) >= 0) {
            this.memotype = "varchar(255)";
            this.floattype = "decimal";
            this.tempdate = "'01/01/1990'";
         }

         return true;
      }
   }

   boolean updateMenuOptions() {
      String var1 = "UPDATE JDPMenu SET menuobject = 'JDPMenuAddOption' WHERE menuobject = 'JDPMenuMaint' AND menunum = 3 AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.user.loginMessage.setStatusMsg("Updating Menus...", 0);
      this.runSQL(var1);
      return true;
   }

   boolean updateTo2_1() {
      String var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND menunum = 1";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menudesc = 'Application Builder' WHERE menuname = 'Main' AND menuobject = 'JDPAppBuilder'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menudesc = 'Application Builder' WHERE menuname = 'JDPAppBuilder' AND menudesc = 'Layout Manager'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menunum = 10 WHERE menuname = 'JDPToolMain' AND menuobject = 'JDPDatabaseMaint'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuparm = 'Docs/JDPAppBuilderHelp.htm' WHERE menuname = 'JDPAppBuilder' AND menunum = 0";
      this.runSQL(var1);
      return true;
   }

   boolean updateObjectTrees(float var1, float var2) {
      this.user.jaggPath = this.user.jaggSQL.getServer();
      String var3 = JDesignerPro.serverSeparator;
      this.user.jaggSQL.setFCTN("ListFiles");
      this.user.jaggSQL.setFCTNP(this.user.JDesignerPro.JDPDirectory + "System" + var3 + "ObjectTrees;");
      Vector var4 = new Vector();
      this.user.jaggSQL.execSQL("", var4);
      this.user.mainmsg = new JDPStatusMessage(this.user);

      for(int var5 = 0; var5 < var4.size(); ++var5) {
         if (this.user.loginMessage != null) {
            this.user.loginMessage.setStatusMsg("Updating Object Tree " + Integer.toString(var5 + 1) + " of " + Integer.toString(var4.size()) + "...", 0);
         }

         StringTokenizer var6 = new StringTokenizer((String)var4.elementAt(var5), this.user.jaggSQL.getSEP());
         String var7 = var6.nextToken();
         var7 = this.user.JDesignerPro.JDPDirectory + "System" + var3 + "ObjectTrees" + var3 + var7;
         JDPSaveProps var8 = new JDPSaveProps(this.user);
         JDPTreePicker var10 = new JDPTreePicker(this.user);
         if (var8.load(var7)) {
            JDPTreeBranch var9 = new JDPTreeBranch();
            var9 = (JDPTreeBranch)var8.restoreObject(var9, "JDPComponentMaint", "ComponentTree", 0);
            var10.treeRoot = var9;
            String[] var11 = new String[]{"", "Data", "E Mail"};
            var10.removeBranch(var11);
            var11[2] = "Alpha Paging";
            var10.removeBranch(var11);
            JDPTreeBranch[] var12 = var10.getTreeBranch("Data");
            if (var10.getTreeBranch("ComboBox") == null) {
               var10.addNewBranch(var12[var12.length - 1], "ComboBox", 20, "Components", (String)null, "JDPComboBox");
            }

            if (var10.getTreeBranch("JDPTextField") == null) {
               var10.addNewBranch(var12[var12.length - 1], "JDPTextField", 15, "Components", (String)null, "JDPTextField");
            }

            var12 = var10.getTreeBranch("Extended");
            var12[var12.length - 1].leaves = new Vector();
            JDPTreeBranch var13 = var10.addNewBranch(var12[var12.length - 1], "Containers", 0, true, "Components", "Drop here to move this object to this Group", false);
            var10.addNewBranch(var13, "CardPanel", 2, "Components", (String)null, "JDPCardPanel");
            var10.addNewBranch(var13, "TabPanel", 25, "Components", (String)null, "JDPTabSelectPanel");
            var10.addNewBranch(var13, "ScrollPanel", 24, "Components", (String)null, "JDPScrollPanel");
            var10.addNewBranch(var13, "ChiselPanel", 16, "Components", (String)null, "JDPChiselFramePanel");
            var10.addNewBranch(var13, "SplitPanel", 24, "Components", (String)null, "JDPSplitPanel");
            var13 = var10.addNewBranch(var12[var12.length - 1], "Components", 0, true, "Components", "Drop here to move this object to this Group", false);
            var10.addNewBranch(var13, "JDPButton", 17, "Components", (String)null, "JDPButton");
            var10.addNewBranch(var13, "JDPButtons", 17, "Components", (String)null, "JDPButtons");
            var10.addNewBranch(var13, "Datebox", 37, "Components", (String)null, "JDPDate");
            var10.addNewBranch(var13, "Spinner", 31, "Components", (String)null, "JDPSpinner");
            var10.addNewBranch(var13, "Calendar", 37, "Components", (String)null, "JDPCalendarPicker");
            var10.addNewBranch(var13, "Popup Menu", 26, "Components", (String)null, "JDPPopupMenu");
            var10.addNewBranch(var13, "Grid Panel", 27, "Components", (String)null, "JDPTextGrid");
            var10.addNewBranch(var13, "Tree Structure", 26, "Components", (String)null, "JDPTreePicker");
            var10.addNewBranch(var13, "File Picker", 4, "Components", (String)null, "JDPFilePicker");
            var10.addNewBranch(var13, "HTML Panel", 13, "Components", (String)null, "JDPBrowser");
            var10.addNewBranch(var13, "HTML Browser", 13, "Components", (String)null, "JDPBrowserCtl");
            var10.addNewBranch(var13, "Image", 13, "Components", (String)null, "JDPImage");
            var10.addNewBranch(var13, "Progress Bar", 30, "Components", (String)null, "JDPProgressBar");
            var10.addNewBranch(var13, "Rich Text", 15, "Components", (String)null, "JDPRichText");
            var13 = var10.addNewBranch(var12[var12.length - 1], "Dialogs", 0, true, "Components", "Drop here to move this object to this Group", false);
            var10.addNewBranch(var13, "JDPDialog", 38, "Components", (String)null, "JDPDialog");
            var10.addNewBranch(var13, "MessageBox", 38, "Components", (String)null, "JDPMessageDialog");
            var13 = var10.addNewBranch(var12[var12.length - 1], "Other", 0, true, "Components", "Drop here to move this object to this Group", false);
            var10.addNewBranch(var13, "Popup Component", 20, "Components", (String)null, "JDPPopupComponent");
            var10.addNewBranch(var13, "DragAndDrop", 12, "Components", (String)null, "JDPDragItem");
            var12 = var10.getTreeBranch("Non Visual");
            if (var12 != null && var10.getTreeBranch("Mask Edit") == null) {
               var10.addNewBranch(var12[var12.length - 1], "Mask Edit", 15, "Components", (String)null, "JDPMaskEdit");
            }

            if (var12 != null && var10.getTreeBranch("Formatter") == null) {
               var10.addNewBranch(var12[var12.length - 1], "Formatter", 34, "Components", (String)null, "JDPFormatDoc");
            }

            var12 = var10.getTreeBranch("Wizards");
            if (var12 == null) {
               var10.addNewBranch(var10.treeRoot, "Wizards", 0, true, "Components", "Drop here to move this object to this Group", false);
               var12 = var10.getTreeBranch("Wizards");
               var12[var12.length - 2].leaves.insertElementAt(var12[var12.length - 1], 0);
               var12[var12.length - 2].leaves.removeElementAt(var12[var12.length - 2].leaves.size() - 1);
            }

            String[] var15 = new String[]{"Form", "Grid", "MasterDetail", "Report", "Chart", "Email", "AlphaPaging"};
            int[] var16 = new int[]{8, 27, 2, 34, 33, 35, 36};

            for(int var17 = 0; var17 < var15.length; ++var17) {
               if (var12 != null && var10.getTreeBranch(var15[var17]) == null) {
                  var10.addNewBranch(var12[var12.length - 1], var15[var17], var16[var17], "Components", (String)null, "JDPWiz" + this.user.u.replace(var15[var17], " ", ""));
               }
            }

            var12 = var10.getTreeBranch("Server Communication");
            if (var12 == null) {
               var13 = var10.addNewBranch(var10.treeRoot, "Server Communication", 0, true, "Components", "Drop here to move this object to this Group", false);
               JDPTreeBranch var14 = var10.addNewBranch(var13, "Server Push", 0, true, "Components", "Drop here to move this object to this Group", false);
               var10.addNewBranch(var14, "Message Receiver", 5, "Components", (String)null, "JDPServerListener");
               var10.addNewBranch(var14, "Message Sender", 36, "Components", (String)null, "JDPServerSender");
               var14 = var10.addNewBranch(var13, "Remote Method Invocation", 0, true, "Components", "Drop here to move this object to this Group", false);
               var10.addNewBranch(var14, "RMI Connection", 39, "Components", (String)null, "JDPRMIConnection");
            }

            var12 = var10.getTreeBranch("Custom Classes");
            if (var12 == null) {
               var13 = var10.addNewBranch(var10.treeRoot, "Custom Classes", 0, true, "Components", "Drop here to move this object to this Group", false);
               var10.addNewBranch(var13, "Screen2", 5, "Components", (String)null, "Screen2");
            }

            var12 = var10.getTreeBranch("Swing");
            if (var12 == null) {
               var13 = var10.addNewBranch(var10.treeRoot, "Swing", 0, true, "Components", "Drop here to move this object to this Group", false);
               var10.addNewBranch(var13, "JButton", -1, "Components", (String)null, "com.sun.java.swing.JButton");
               var10.addNewBranch(var13, "JCheckBox", -1, "Components", (String)null, "com.sun.java.swing.JCheckBox");
               var10.addNewBranch(var13, "JComboBox", -1, "Components", (String)null, "com.sun.java.swing.JComboBox");
               var10.addNewBranch(var13, "JEditorPane", -1, "Components", (String)null, "com.sun.java.swing.JEditorPane");
               var10.addNewBranch(var13, "JFrame", -1, "Components", (String)null, "com.sun.java.swing.JFrame");
               var10.addNewBranch(var13, "JLabel", -1, "Components", (String)null, "com.sun.java.swing.JLabel");
               var10.addNewBranch(var13, "JList", -1, "Components", (String)null, "com.sun.java.swing.JList");
               var10.addNewBranch(var13, "JMenu", -1, "Components", (String)null, "com.sun.java.swing.JMenu");
               var10.addNewBranch(var13, "JMenuBar", -1, "Components", (String)null, "com.sun.java.swing.JMenuBar");
               var10.addNewBranch(var13, "JMenuItem", -1, "Components", (String)null, "com.sun.java.swing.JMenuItem");
               var10.addNewBranch(var13, "JOptionPane", -1, "Components", (String)null, "com.sun.java.swing.JOptionPane");
               var10.addNewBranch(var13, "JPanel", -1, "Components", (String)null, "com.sun.java.swing.JPanel");
               var10.addNewBranch(var13, "JPasswordField", -1, "Components", (String)null, "com.sun.java.swing.JPasswordField");
               var10.addNewBranch(var13, "JPopupMenu", -1, "Components", (String)null, "com.sun.java.swing.JPopupMenu");
               var10.addNewBranch(var13, "JProgressBar", -1, "Components", (String)null, "com.sun.java.swing.JProgressBar");
               var10.addNewBranch(var13, "JRadioButton", -1, "Components", (String)null, "com.sun.java.swing.JRadioButton");
               var10.addNewBranch(var13, "JScrollBar", -1, "Components", (String)null, "com.sun.java.swing.JScrollBar");
               var10.addNewBranch(var13, "JSeparator", -1, "Components", (String)null, "com.sun.java.swing.JSeparator");
               var10.addNewBranch(var13, "JSlider", -1, "Components", (String)null, "com.sun.java.swing.JSlider");
               var10.addNewBranch(var13, "JSplitPane", -1, "Components", (String)null, "com.sun.java.swing.JSplitPane");
               var10.addNewBranch(var13, "JTabbedPane", -1, "Components", (String)null, "com.sun.java.swing.JTabbedPane");
               var10.addNewBranch(var13, "JTable", -1, "Components", (String)null, "com.sun.java.swing.JTable");
               var10.addNewBranch(var13, "JTextArea", -1, "Components", (String)null, "com.sun.java.swing.JTextArea");
               var10.addNewBranch(var13, "JTextField", -1, "Components", (String)null, "com.sun.java.swing.JTextField");
               var10.addNewBranch(var13, "JTextPane", -1, "Components", (String)null, "com.sun.java.swing.JTextPane");
               var10.addNewBranch(var13, "JToggleButton", -1, "Components", (String)null, "com.sun.java.swing.JToggleButton");
               var10.addNewBranch(var13, "JToolBar", -1, "Components", (String)null, "com.sun.java.swing.JToolBar");
               var10.addNewBranch(var13, "JTree", -1, "Components", (String)null, "com.sun.java.swing.JTree");
               var10.addNewBranch(var13, "JWindow", -1, "Components", (String)null, "com.sun.java.swing.JWindow");
               var10.addNewBranch(var13, "JScrollPane", -1, "Components", (String)null, "com.sun.java.swing.JScrollPane");
               var10.addNewBranch(var13, "JInternalFrame", -1, "Components", (String)null, "com.sun.java.swing.JInternalFrame");
               var10.addNewBranch(var13, "JApplet", -1, "Components", (String)null, "com.sun.java.swing.JApplet");
               var10.addNewBranch(var13, "JCheckBoxMenuItem", -1, "Components", (String)null, "com.sun.java.swing.JCheckBoxMenuItem");
               var10.addNewBranch(var13, "JRadioButtonMenuItem", -1, "Components", (String)null, "com.sun.java.swing.JRadioButtonMenuItem");
               var10.addNewBranch(var13, "JViewPort", -1, "Components", (String)null, "com.sun.java.swing.JViewPort");
               var10.addNewBranch(var13, "WindowsLookAndFeel", -1, "Components", (String)null, "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
               var10.addNewBranch(var13, "MetalLookAndFeel", -1, "Components", (String)null, "com.sun.java.swing.plaf.metal.MetalLookAndFeel");
               var10.addNewBranch(var13, "MotifLookAndFeel", -1, "Components", (String)null, "com.sun.java.swing.plaf.motif.MotifLookAndFeel");
               var10.addNewBranch(var13, "MultiLookAndFeel", -1, "Components", (String)null, "com.sun.java.swing.plaf.multi.MultiLookAndFeel");
            }

            var8.saveObject(var9, "JDPComponentMaint", "ComponentTree", 0);
            var8.save(var7);
         }
      }

      this.user.jaggSQL.setFCTN("");
      this.user.jaggSQL.setFCTNP("");
      if (this.user.loginMessage != null) {
         this.user.loginMessage.clearStatusMsg();
      }

      return true;
   }

   boolean updateTo2_5() {
      if (this.user.loginMessage != null) {
         this.user.loginMessage.setStatusMsg("Updating System tables...", 0);
      }

      String var1 = "SELECT dateformat FROM JDPSystemDef";
      Vector var2 = new Vector();
      if (this.user.jaggSQL.execSQL(var1, var2) < 0) {
         this.updateSystemTable();
      } else {
         var1 = "UPDATE JDPSystemDef SET jlanguage = 'en', country = '  ', dateformat = 'mm/dd/yy' WHERE jlanguage = '' OR jlanguage is null";
         this.runSQL(var1);
      }

      var1 = "SELECT * FROM JDPMenu WHERE JDPSystem = '" + this.user.JDPSystem + "' AND menuobject = 'JDPLanguageMaint'";
      var2 = new Vector();
      if (this.user.jaggSQL.execSQL(var1, var2) <= 0) {
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','System',6," + "'P','JDPLanguageMaint','', " + "'Languages'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
      }

      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JavaBuilder' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPLayoutMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPFormMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPGridMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPComboMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPReportMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPChartMain' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPFormFinish' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPGridFinish' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPComboFinish' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPReportFinish' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuname = 'JDPChartFinish' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "DELETE FROM JDPMenu WHERE menuobject = 'JavaBuilder' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "UPDATE JDPMenu SET menuobject = 'JDPBrowserCtl' WHERE menuobject = 'JDPBrowser' AND menuname = 'System' AND JDPSystem = '" + this.user.JDPSystem + "'";
      this.runSQL(var1);
      var1 = "SELECT * FROM JDPMenu WHERE menuname = 'Main' AND JDPSystem = '" + this.user.JDPSystem + "' AND menudesc = 'Manual'";
      if (this.runSQL(var1) == 0) {
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','Main',30," + "'P','JDPBrowserCtl','Docs/jdpmanual.htm', " + "'Manual'," + "'A'," + "'Black', " + "'LightGray'," + "'ADMIN','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
      }

      var1 = "SELECT * FROM JDPMenu WHERE menuname = 'JDPAppBuilder' AND JDPSystem = '" + this.user.JDPSystem + "' AND menuobject = 'JDPSupportApp'";
      if (this.runSQL(var1) == 0) {
         var1 = "INSERT INTO JDPMenu (JDPSystem,menuname,menunum,menutype,menuobject,menuparm,menudesc,menustatus,menutxtclr, " + "menutabclr,menuauth1,menuauth2,menuauth3,menuauth4,menuauth5,menulvl1, " + "menulvl2,menulvl3,menulvl4,menulvl5) " + "VALUES('" + this.user.JDPSystem + "','JDPAppBuilder',10," + "'P','JDPSupportApp','', " + "'Support'," + "'A'," + "'Black', " + "'LightGray'," + "'*ALL','', " + "'','', " + "'',0,0,0,0,0)";
         this.runSQL(var1);
      }

      this.createSampleMenu(0, "Author Inquiry", "AuthorInquiry", 1, true);
      this.createSampleMenu(0, "Employee Summary", "EmployeeSummary", 3, true);
      this.createSampleMenu(0, "Sales Detail", "SalesMasterDetail", 5, true);
      this.createSampleMenu(0, "Sales Report", "SalesSummaryReport", 7, true);
      this.createSampleMenu(0, "Sales Chart", "SalesChartByStore", 11, true);
      if (this.user.loginMessage != null) {
         this.user.loginMessage.clearStatusMsg();
      }

      return true;
   }
}
