import java.beans.BeanInfo;
import java.beans.EventSetDescriptor;
import java.beans.Introspector;
import java.beans.MethodDescriptor;
import java.beans.PropertyDescriptor;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.StringBufferInputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.net.InetAddress;
import java.net.Socket;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import sun.tools.javac.Main;

class JaggServerCxn extends Thread {
   private JaggServer server;
   static JDPJob jaggServerJob;
   JDPJaggUser user;
   Socket thisSocket;
   private BufferedOutputStream serverResponse;
   private BufferedInputStream serverRequest;
   String SERV = "";
   String FCTN = "";
   String FCTNP = "";
   String DSN = "";
   String CSTR = "";
   String OUT = "zero1";
   String SEP = "\u0003";
   String MRW = "";
   String UID = "";
   String PWD = "";
   // $FF: renamed from: DB java.lang.String
   String field_0 = "";
   String WSID = "";
   String SQL = "";
   // $FF: renamed from: K java.lang.String
   String field_1;
   String LSQL = "";
   String TOUT = "";
   String DLOG = "";
   String NULL = "space";
   String USER = "";
   String SYS = "";
   String jdbcDriver;
   String jdbcPrefix;
   String jdbcSuffix;
   String objectName;
   String jobName;
   String jobNumber;
   String methodName;
   long thisJdbcConnectionNum;
   boolean suspended;
   static long expiryDate;
   int[] insertType;
   Vector insertData;
   // $FF: renamed from: NL java.lang.String
   static String field_2 = "\u0002";
   static String EOT = "\u0001";
   private char[] lineBuffer;
   int totalCharsToRead;
   int totalCharsWritten;
   long requestNum;
   Date startDate;
   StringBuffer inLog;
   StringBuffer errLog;
   // $FF: renamed from: in java.io.BufferedInputStream
   BufferedInputStream field_3;
   BufferedInputStream err;
   BufferedInputStream thisStream;
   JaggServerCxn target;
   boolean monitorFinished;
   boolean captureSqlOutput;
   StringBuffer sqlCapture;

   public JaggServerCxn(JaggServer var1, Socket var2, long var3) {
      this.jdbcDriver = JaggServer.DEFAULTJDBC;
      this.jdbcPrefix = JaggServer.DEFAULTCXN;
      this.jdbcSuffix = "";
      this.thisJdbcConnectionNum = -1L;
      this.suspended = false;
      this.monitorFinished = false;
      this.captureSqlOutput = false;
      this.server = var1;
      this.thisSocket = var2;
      this.requestNum = var3;

      try {
         this.serverResponse = new BufferedOutputStream(this.thisSocket.getOutputStream());
         this.serverRequest = new BufferedInputStream(this.thisSocket.getInputStream());
         ((Thread)this).start();
      } catch (Exception var6) {
         ((Throwable)var6).printStackTrace();
      }
   }

   public JaggServerCxn(JaggServer var1, BufferedOutputStream var2, BufferedInputStream var3, long var4) {
      this.jdbcDriver = JaggServer.DEFAULTJDBC;
      this.jdbcPrefix = JaggServer.DEFAULTCXN;
      this.jdbcSuffix = "";
      this.thisJdbcConnectionNum = -1L;
      this.suspended = false;
      this.monitorFinished = false;
      this.captureSqlOutput = false;
      this.server = var1;
      this.requestNum = var4;
      this.thisSocket = null;
      this.serverResponse = var2;
      this.serverRequest = var3;
      ((Thread)this).start();
   }

   public JaggServerCxn(JaggServerCxn var1, BufferedInputStream var2) {
      this.jdbcDriver = JaggServer.DEFAULTJDBC;
      this.jdbcPrefix = JaggServer.DEFAULTCXN;
      this.jdbcSuffix = "";
      this.thisJdbcConnectionNum = -1L;
      this.suspended = false;
      this.monitorFinished = false;
      this.captureSqlOutput = false;
      this.target = var1;
      this.thisStream = var2;
      ((Thread)this).start();
   }

   public void run() {
      if (this.thisStream != null) {
         this.monitorActiveJob();
         this.monitorFinished = true;
      } else {
         try {
            String var1 = "";
            String var2 = "";

            while(!var2.startsWith("Close")) {
               int var3 = 0;
               char[] var4 = new char[10];

               for(int var5 = 0; var5 < 10; ++var5) {
                  int var6 = this.serverRequest.read();
                  var4[var3++] = (char)var6;
               }

               var1 = String.copyValueOf(var4, 0, var3).trim();
               this.totalCharsToRead = 0;
               this.totalCharsWritten = 0;

               try {
                  this.totalCharsToRead = Integer.parseInt(var1);
               } catch (Exception var8) {
               }

               if (this.totalCharsToRead <= 0) {
                  var2 = "Close";
               } else {
                  var4 = new char[this.totalCharsToRead];

                  for(var3 = 0; var3 < this.totalCharsToRead; ++var3) {
                     var4[var3] = (char)this.serverRequest.read();
                  }

                  var2 = String.copyValueOf(var4, 0, var3);
                  if (!var2.startsWith("Close") && this.processRequest(var2)) {
                     this.serverResponse.flush();
                     this.logUserFinishedAccess();
                  }
               }

               if (this.server.manager != null) {
                  this.server.manager.connectionMgr.deRegisterRequest(this);
               }
            }
         } catch (Exception var9) {
            try {
               this.writeLn("JAGG_RESULT_ROWS:0");
               this.writeLn(field_2);
               this.writeLn(EOT);
               this.serverResponse.flush();
            } catch (Exception var7) {
            }

            if (this.server.manager != null) {
               this.server.manager.connectionMgr.deRegisterRequest(this);
            }
         }

         if (this.user != null) {
            this.user.removeActiveRequest(this);
         }

         ((Thread)this).stop();
      }
   }

   private boolean processRequest(String var1) throws Exception {
      this.parseRequest(var1);
      if (!this.server.checkKey(this)) {
         if (this.thisSocket != null) {
            this.thisSocket.close();
         }

         return false;
      } else {
         if (this.server.manager != null) {
            this.server.manager.connectionMgr.registerRequest(this);
            this.logUserAccess();
         }

         if (this.FCTN.equals("ServerJob")) {
            this.JaggServerJob();
            return false;
         } else if (this.FCTN.equals("Logout")) {
            this.writeLn("JAGG_RESULT_ROWS:0");
            this.writeLn(field_2);
            this.writeLn(EOT);
            return true;
         } else if (this.FCTN.equals("Invoke")) {
            int var3 = this.InvokeMethod();
            this.writeLn("JAGG_RESULT_ROWS:" + Integer.toString(var3));
            this.writeLn(field_2);
            this.writeLn(EOT);
            return true;
         } else if (this.FCTN.equals("GetPlatform")) {
            this.writeLn(File.separator);
            this.writeLn(field_2);
            this.writeLn(System.getProperty("os.name"));
            this.writeLn(field_2);
            this.writeLn("JAGG_RESULT_ROWS:2");
            this.writeLn(field_2);
            this.writeLn(EOT);
            return true;
         } else if (!this.FCTN.equals("System") && !this.FCTN.equals("UnixDaysRemaining") && !this.FCTN.equals("WriteToFile") && !this.FCTN.equals("GetDrives") && !this.FCTN.equals("ListFiles") && !this.FCTN.equals("RenameFile") && !this.FCTN.equals("RemoveFiles") && !this.FCTN.equals("CreateFolder") && !this.FCTN.equals("ArchiveApp") && !this.FCTN.equals("CheckLicense") && !this.FCTN.equals("NDSexecSQL") && !this.FCTN.startsWith("JavaBean") && !this.FCTN.startsWith("JarCommand") && !this.FCTN.startsWith("JarListFiles")) {
            if (!this.FCTN.equals("ReadFromFile") && !this.FCTN.equals("GetStockData")) {
               this.runSql();
               return true;
            } else {
               this.specialFunction();
               return true;
            }
         } else {
            int var2 = this.specialFunction();
            this.writeLn("JAGG_RESULT_ROWS:" + Integer.toString(var2));
            this.writeLn(field_2);
            this.writeLn(EOT);
            return true;
         }
      }
   }

   void logUserAccess() {
      this.startDate = new Date();
      if (this.thisSocket != null) {
         try {
            this.user = this.server.manager.userMgr.getUser(this.thisSocket.getInetAddress(), Integer.parseInt(this.USER), this.SYS);
         } catch (Exception var1) {
            this.user = this.server.manager.userMgr.getUser((InetAddress)null, Integer.parseInt(this.USER), this.SYS);
         }
      } else {
         this.user = this.server.manager.userMgr.getUser((InetAddress)null, Integer.parseInt(this.USER), this.SYS);
      }

      this.USER = Integer.toString(this.user.getJDPUser());
      this.user.setLastConnectionStart(this.startDate);
      this.user.addActiveRequest(this);
      this.user.incrementTotalRequest();
      this.user.incrementBytesReceived((long)this.totalCharsToRead);
   }

   void logUserFinishedAccess() {
      if (this.user != null) {
         if (this.FCTN.equals("Logout")) {
            this.server.manager.userMgr.removeUser(this.user);
            return;
         }

         this.user.incrementBytesTransmitted((long)this.totalCharsWritten);
         this.user.setLastConnectionEnd(new Date());
         this.user.setLastConnectionDuration(this.user.getLastConnectionEnd().getTime() - this.startDate.getTime());
      }

   }

   private int specialFunction() {
      try {
         if (this.FCTN.equals("CheckLicense")) {
            int var4 = 0;
            var4 = this.server.checkLicense(this);
            return var4;
         }

         if (this.FCTN.equals("CheckDevelopers")) {
            int var1 = 0;
            var1 = this.server.checkDevelopers(this);
            return var1;
         }

         if (this.FCTN.equals("UnixDaysRemaining")) {
            return this.UnixDaysRemaining();
         }

         if (this.FCTN.equals("WriteToFile")) {
            return this.JaggWriteToFile();
         }

         if (this.FCTN.equals("ReadFromFile")) {
            return this.JaggReadFromFile();
         }

         if (this.FCTN.equals("GetDrives")) {
            return this.JaggGetDrives();
         }

         if (this.FCTN.equals("ListFiles")) {
            return this.JaggListFiles();
         }

         if (this.FCTN.equals("RenameFile")) {
            return this.JaggRenameFile();
         }

         if (this.FCTN.equals("RemoveFiles")) {
            return this.JaggRemoveFiles();
         }

         if (this.FCTN.equals("CreateFolder")) {
            return this.JaggCreateFolder();
         }

         if (this.FCTN.equals("ArchiveApp")) {
            return this.JaggArchiveApp();
         }

         if (this.FCTN.equals("JavaBeanGetParentClasses")) {
            return this.JavaBeanGetParentClasses();
         }

         if (this.FCTN.equals("JavaBeanGetConstructors")) {
            return this.JavaBeanGetConstructors();
         }

         if (this.FCTN.equals("JavaBeanGetMethods")) {
            return this.JavaBeanGetMethods();
         }

         if (this.FCTN.equals("JavaBeanGetParameterTypes")) {
            return this.JavaBeanGetParameterTypes();
         }

         if (this.FCTN.equals("JavaBeanGetProperties")) {
            return this.JavaBeanGetProperties();
         }

         if (this.FCTN.equals("JavaBeanGetEvents")) {
            return this.JavaBeanGetEvents();
         }

         if (this.FCTN.equals("JarCommand")) {
            return this.JarCommand();
         }

         if (this.FCTN.equals("JarListFiles")) {
            return this.JarListFiles();
         }

         if (this.FCTN.equals("System")) {
            return this.JaggExecCommand();
         }

         if (this.FCTN.startsWith("NDSexecSQL")) {
            return this.NDSexecSQL();
         }

         if (this.FCTN.equals("GetStockData")) {
            return this.JaggGetStockData();
         }
      } catch (Exception var2) {
         this.logException(var2);
      }

      return 0;
   }

   private void runSql() {
      int var1 = 0;
      Statement var2 = null;
      Vector var3 = null;
      Object var4 = null;
      Connection var5 = null;
      Object var6 = null;
      if (this.jdbcSuffix != null && !this.jdbcSuffix.equals("") || this.DSN != null && !this.DSN.equals("")) {
         if (this.jdbcDriver != null) {
            try {
               if (System.getProperty("java.vendor").startsWith("Microsoft") && this.jdbcDriver.equals("sun.jdbc.odbc.JdbcOdbcDriver")) {
                  this.jdbcDriver = "com.ms.jdbc.odbc.JdbcOdbcDriver";
               }

               Class.forName(this.jdbcDriver);
            } catch (Exception var22) {
               this.logException(var22);

               try {
                  this.writeLn("JAGG_ERROR:Failed to load JDBC Driver:" + this.jdbcDriver);
                  this.writeLn(field_2);
                  this.writeLn(EOT);
               } catch (Exception var15) {
               }

               var1 = -1;
               return;
            }
         }

         try {
            boolean var39 = false;
            int var41 = 0;

            while(!var39 && var41++ < 3) {
               if (this.CSTR.equals(this.DSN)) {
                  this.CSTR = "";
               }

               String var44 = "";
               if (this.CSTR.indexOf("DSN=") >= 0 && this.CSTR.indexOf("UID=") >= 0) {
                  var44 = this.CSTR;
               } else {
                  if (this.DSN.equals("")) {
                     var44 = "DSN=" + this.jdbcSuffix + ";";
                  } else {
                     var44 = "DSN=" + this.DSN + ";";
                  }

                  if (this.CSTR.indexOf("UID=") < 0) {
                     var44 = var44 + "UID=" + this.UID + ";";
                  }

                  if (this.CSTR.indexOf("PWD=") < 0) {
                     var44 = var44 + "PWD=" + this.PWD + ";";
                  }

                  var44 = var44 + this.CSTR;
               }

               var44 = var44.trim();
               if (var41 < 2) {
                  try {
                     if (this.jdbcSuffix != null && !this.jdbcSuffix.equals("")) {
                        var3 = this.getDbConnection(this.jdbcPrefix + this.jdbcSuffix, var44);
                     } else {
                        var3 = this.getDbConnection(this.server.connectionString + this.DSN, var44);
                     }
                  } catch (Exception var26) {
                  }
               } else if (this.jdbcSuffix != null && !this.jdbcSuffix.equals("")) {
                  var3 = this.getDbConnection(this.jdbcPrefix + this.jdbcSuffix, var44);
               } else {
                  var3 = this.getDbConnection(this.server.connectionString + this.DSN, var44);
               }

               try {
                  var5 = (Connection)var3.elementAt(2);
                  var5.setAutoCommit(true);
                  var2 = var5.createStatement();
                  var39 = true;
               } catch (Exception var27) {
                  if (var3 != null) {
                     var3.setElementAt("Close", 1);
                  }
               }
            }

            if (!this.MRW.equals("")) {
               try {
                  var2.setMaxRows(Integer.parseInt(this.MRW));
               } catch (Exception var21) {
               }
            }

            if (!this.TOUT.equals("")) {
               try {
                  var2.setQueryTimeout(Integer.parseInt(this.TOUT));
               } catch (Exception var20) {
               }
            }

            String var48 = this.SQL.toUpperCase();
            if (this.FCTN.equals("")) {
               boolean var50 = var2.execute(this.SQL);
               if (var50) {
                  ResultSet var60 = var2.getResultSet();
                  var1 = this.dispResultSet(var60);
                  if (this.LSQL != null && !this.LSQL.equals("")) {
                     var2.execute(this.LSQL);
                     this.LSQL = "";
                  }
               } else {
                  var1 = var2.getUpdateCount();
                  if (!var48.startsWith("UPDATE") && !var48.startsWith("INSERT") && !var48.startsWith("DELETE") && !var48.startsWith("SELECT") && var1 < 0) {
                     var1 = 0;
                  }
               }
            } else if (this.FCTN.equals("BINS")) {
               this.loadBulkData((String)null);

               try {
                  var5.prepareStatement(this.SQL.replace('#', ' '));

                  for(int var51 = 0; var51 < this.insertData.size(); ++var51) {
                     String[] var61 = (String[])this.insertData.elementAt(var51);
                     String var31 = this.SQL;

                     for(int var12 = 0; var12 < this.insertType.length; ++var12) {
                        int var13 = var31.indexOf("#?");
                        String var14 = "";
                        if (this.insertType[var12] == 1 || this.insertType[var12] == 12 || this.insertType[var12] == -1) {
                           var14 = "'";
                        }

                        var31 = var31.substring(0, var13) + var14 + var61[var12] + var14 + var31.substring(var13 + 2);
                     }

                     try {
                        var2.execute(var31);
                        var1 += var2.getUpdateCount();
                        if (!var48.startsWith("UPDATE") && !var48.startsWith("INSERT") && !var48.startsWith("DELETE") && !var48.startsWith("SELECT") && var1 < 0) {
                           var1 = 0;
                        }
                     } catch (Exception var19) {
                        String var69 = ((Throwable)var19).toString();
                        this.println(var69);
                        this.println(var31);
                     }
                  }
               } catch (Exception var25) {
                  System.out.println(this.SQL);
                  ((Throwable)var25).printStackTrace();
               }
            } else if (this.FCTN.equals("SQLDataSources")) {
               ResultSet var52 = var2.executeQuery("SELECT sourcename FROM JDPDataSrc");
               var1 = this.dispResultSet(var52);
               if (var1 < 0) {
                  var1 = 0;
               }
            } else if (this.FCTN.equals("SQLTables")) {
               String[] var53 = this.parseFCTNP(this.FCTNP);
               String[] var62 = new String[var53.length - 3];

               for(int var67 = 3; var67 < var53.length; ++var67) {
                  var62[var67 - 3] = var53[var67];
               }

               if (var53[2] == null) {
                  var53[2] = "%";
               }

               DatabaseMetaData var33 = var5.getMetaData();
               ResultSet var68 = var33.getTables(var53[0], var53[1], var53[2], var62);
               var1 = this.dispResultSet(var68);
            } else if (this.FCTN.equals("SQLDriverName")) {
               DatabaseMetaData var34 = var5.getMetaData();
               if (var34 == null) {
                  this.println("This JDBC driver does not support meta data calls and therefore may not be used with JDesignerPro");
                  var1 = -1;
               } else {
                  String var54 = var34.getDatabaseProductName();
                  if (var54 != null) {
                     this.writeLn(var54);
                     this.writeLn(field_2);
                     var1 = 1;
                  } else {
                     var1 = -1;
                  }
               }
            } else if (this.FCTN.equals("SQLColumns")) {
               String[] var55 = this.parseFCTNP(this.FCTNP);
               if (var55[2] == null) {
                  var55[2] = "%";
               }

               DatabaseMetaData var35 = var5.getMetaData();
               ResultSet var63 = var35.getColumns(var55[0], var55[1], var55[2], var55[3]);
               var1 = this.dispResultSet(var63);
            } else if (this.FCTN.equals("SQLPrimaryKeys")) {
               String[] var56 = this.parseFCTNP(this.FCTNP);
               if (var56[2] == null) {
                  var56[2] = "";
               }

               try {
                  DatabaseMetaData var36 = var5.getMetaData();
                  ResultSet var64 = var36.getPrimaryKeys(var56[0], var56[1], var56[2]);
                  var1 = this.dispResultSet(var64);
               } catch (Exception var18) {
                  var1 = 0;
               }
            } else if (this.FCTN.equals("getProcedures")) {
               DatabaseMetaData var37 = var5.getMetaData();
               if (var37 != null && var37.supportsStoredProcedures()) {
                  String[] var57 = this.parseFCTNP(this.FCTNP);
                  if (var57[2] == null) {
                     var57[2] = "%";
                  }

                  ResultSet var65 = var37.getProcedures(var57[0], var57[1], var57[2]);
                  var1 = this.dispResultSet(var65);
               } else {
                  var1 = 0;
               }
            } else if (this.FCTN.equals("getProcedureColumns")) {
               String[] var58 = this.parseFCTNP(this.FCTNP);
               if (var58[2] == null) {
                  var58[2] = "%";
               }

               DatabaseMetaData var38 = var5.getMetaData();
               ResultSet var66 = var38.getProcedureColumns(var58[0], var58[1], var58[2], var58[3]);
               var1 = this.dispResultSet(var66);
            } else if (this.FCTN.equals("CloseConnection")) {
               try {
                  var5.close();
                  this.server.dbConnection.removeElement(var3);
                  this.println("Closed connection to: " + (String)var3.elementAt(4));
                  var1 = 1;
               } catch (Exception var17) {
                  var1 = 0;
               }
            } else {
               var1 = this.specialFunction();
            }
         } catch (Exception var28) {
            Exception var7 = var28;

            try {
               String var8 = ((Throwable)var7).toString();
               if (var8.indexOf("Informix") >= 0 && var8.indexOf("Ambiguous column") >= 0) {
                  int var43 = this.SQL.toUpperCase().indexOf("ORDER BY");
                  if (var43 > 0) {
                     this.SQL = this.SQL.substring(0, var43);
                  }

                  boolean var49 = var2.execute(this.SQL);
                  if (var49) {
                     ResultSet var59 = var2.getResultSet();
                     var1 = this.dispResultSet(var59);
                  }
               } else {
                  if (var8.indexOf("Invalid object name") >= 0) {
                     if (var3 != null) {
                        var3.setElementAt("Close", 1);
                     }

                     var3 = null;
                  }

                  int var9 = var8.indexOf(":");
                  if (var9 > 0) {
                     var8 = var8.substring(var9 + 1);
                  } else if (var8.length() > 23) {
                     var8 = var8.substring(23);
                  }

                  String var10 = var8.toUpperCase();
                  if (var10.indexOf("CONNECTIONTRANSACT") >= 0 || var10.indexOf("Invalid object name") >= 0) {
                     this.println("Connection close requested");
                     if (var3 != null) {
                        var3.setElementAt("Close", 1);
                     }

                     var3 = null;
                  }

                  this.writeLn("JAGG_ERROR:" + var8);
                  this.writeLn(field_2);
                  this.writeLn(EOT);
                  this.logException(var7);
                  this.println(var8);
                  DatabaseMetaData var32 = var5.getMetaData();
                  if (var32 != null) {
                     String var11 = var32.getDatabaseProductName();
                     this.println("DBTYPE: " + var11);
                  }

                  if (this.FCTN.equals("BINS")) {
                     this.println(var4);
                  } else {
                     this.println(this.SQL);
                  }

                  var1 = -1;
               }
            } catch (Exception var24) {
               this.logException(var28);
            }
         }

         try {
            if (!this.FCTN.equals("ReadFromFile")) {
               this.writeLn("JAGG_RESULT_ROWS:");
               this.writeLn(Integer.toString(var1));
               this.writeLn(field_2);
               this.writeLn(EOT);
            }

            if (var2 != null) {
               var2.close();
            }

            if (var3 != null) {
               var3.setElementAt("Inactive", 1);
               Date var40 = new Date();
               long var42 = var40.getTime() / 1000L;
               var3.setElementAt(Long.toString(var42), 3);
               return;
            }
         } catch (Exception var16) {
            this.logException(var16);
         }

      } else {
         this.println("JAGG_ERROR:Datasource not specified for driver:" + this.jdbcDriver);
         this.println(this.SQL);
         this.println(this.FCTN);

         try {
            this.writeLn("JAGG_ERROR:Datasource not specified for driver:" + this.jdbcDriver);
            this.writeLn(field_2);
            this.writeLn(EOT);
         } catch (Exception var23) {
         }

         var1 = -1;
      }
   }

   private int dispResultSet(ResultSet var1) throws SQLException {
      int var2 = 0;
      ResultSetMetaData var3 = var1.getMetaData();

      try {
         int var4 = var3.getColumnCount();
         this.writeLn("JAGG_COLUMN_DEFS:");

         for(int var5 = 1; var5 <= var4; ++var5) {
            this.writeLn(this.SEP);
            this.writeLn(Integer.toString(var3.getColumnType(var5)));
         }

         this.writeLn(field_2);

         for(boolean var6 = var1.next(); var6; var6 = var1.next()) {
            for(int var7 = 1; var7 <= var4; ++var7) {
               if (var7 > 1) {
                  this.writeLn(this.SEP);
               }

               int var9 = var3.getColumnType(var7);
               String var8;
               if (var9 != 1 && var9 != 12 && var9 != -1) {
                  if (var9 != 4 && var9 != 5 && var9 != -6 && var9 != -5) {
                     if (var9 != 2 && var9 != 8) {
                        if (var9 == 91) {
                           java.sql.Date var16 = var1.getDate(var7);
                           if (var16 != null) {
                              var8 = Long.toString(((Date)var16).getTime());
                           } else {
                              var8 = "0";
                           }
                        } else if (var9 != 93 && var9 != 92) {
                           var8 = var1.getString(var7);
                        } else {
                           Timestamp var17 = var1.getTimestamp(var7);
                           if (var17 != null) {
                              var8 = Long.toString(((Date)var17).getTime());
                           } else {
                              var8 = "0";
                           }
                        }
                     } else {
                        String var10 = var1.getString(var7);
                        if (var10 != null) {
                           int var11 = var10.indexOf(".");
                           if (var11 > 0) {
                              double var12 = Double.valueOf(var10.substring(0, var11));
                              float var14 = Float.valueOf(var10);
                              if ((float)var12 == var14) {
                                 var8 = var10.substring(0, var10.indexOf("."));
                              } else {
                                 var8 = var10;
                              }
                           } else {
                              var8 = var10;
                           }
                        } else {
                           var8 = "0";
                        }
                     }
                  } else {
                     var8 = Integer.toString(var1.getInt(var7));
                  }
               } else {
                  var8 = var1.getString(var7);
               }

               this.writeLn(var8);
            }

            if (var4 > 0) {
               ++var2;
               this.writeLn(field_2);
            }
         }

         if (var1 != null) {
            var1.close();
         }
      } catch (Exception var15) {
         this.logException(var15);
      }

      return var2;
   }

   private int NDSexecSQL() {
      String var1 = "";
      if (this.FCTN.startsWith("NDSExecSQL:")) {
         var1 = this.FCTN.substring(11);
      }

      JDPNDSInterface var2 = this.getNDSInterface();
      if (var2 == null) {
         String var8 = "NDS Interface is not available.";

         try {
            this.writeLn("JAGG_ERROR:" + var8);
         } catch (Exception var6) {
            this.logException(var6);
         }

         this.println(var8);
         return -1;
      } else {
         int var3 = -1;
         Vector var4 = new Vector();
         if (var1.equals("")) {
            var3 = var2.execSQL(this.SQL, var4);
            if (var3 == -1 && var4.size() == 1) {
               var4.setElementAt("JAGG_ERROR:" + (String)var4.elementAt(0) + field_2, 0);
            }
         } else {
            String[] var5 = this.parseFCTNP(this.FCTNP);
            if (var1.equals("SQLTables")) {
               var3 = var2.getLayouts(var5[0], var4);
            } else if (var1.equals("SQLColumns")) {
               var3 = var2.getFields(var5[0], var5[1], var4);
            }
         }

         try {
            for(int var9 = 0; var9 < var4.size(); ++var9) {
               this.writeLn((String)var4.elementAt(var9));
            }
         } catch (Exception var7) {
            this.logException(var7);
         }

         this.releaseNDSInterface(var2);
         return var3;
      }
   }

   private JDPNDSInterface getNDSInterface() {
      if (this.server.NDSusername.equals("")) {
         String[] var1 = this.parseFCTNP(this.FCTNP);
         if (var1.length > 1 && var1[1] != null && !var1[1].equals("")) {
            this.server.NDSusername = var1[0];
            this.server.NDSpassword = var1[1];
            this.server.manager.savePrevJobNames();
         }
      }

      for(int var5 = 0; var5 < this.server.ndsInstances.size(); ++var5) {
         Vector var2 = (Vector)this.server.ndsInstances.elementAt(var5);
         if (((String)var2.elementAt(0)).equals(this.server.NDSusername + ";" + this.server.NDSpassword)) {
            String var3 = (String)var2.elementAt(1);
            if (var3.equals("Idle")) {
               var2.setElementAt("Active", 1);
               return (JDPNDSInterface)var2.elementAt(2);
            }
         }
      }

      if (this.server.manager.NDSPath != null) {
         try {
            JDPNDSInterface var6 = new JDPNDSInterface(this.server.manager, jaggServerJob, this.server.manager.NDSPath, this.server.NDSusername, this.server.NDSpassword);
            Vector var7 = new Vector();
            var7.addElement(this.server.NDSusername + ";" + this.server.NDSpassword);
            var7.addElement("Active");
            var7.addElement(var6);
            this.server.ndsInstances.addElement(var7);
            return var6;
         } catch (Exception var4) {
            this.println("Failed to create NDS Interface.");
            this.logException(var4);
         }
      }

      return null;
   }

   public void releaseNDSInterface(JDPNDSInterface var1) {
      for(int var2 = 0; var2 < this.server.ndsInstances.size(); ++var2) {
         Vector var3 = (Vector)this.server.ndsInstances.elementAt(var2);
         JDPNDSInterface var4 = (JDPNDSInterface)var3.elementAt(2);
         if (var4.equals(var1)) {
            var3.setElementAt("Idle", 1);
         }
      }

   }

   int UnixDaysRemaining() {
      if (this.server.UnixTrialDays == 0) {
         return 1;
      } else {
         try {
            if (expiryDate == 0L) {
               FileInputStream var9 = new FileInputStream("System" + File.separator + "System.cfg");
               byte[] var12 = new byte[var9.available()];
               var9.read(var12);

               for(int var3 = 0; var3 < var12.length; ++var3) {
                  var12[var3] = (byte)(var12[var3] - 15);
               }

               String var14 = new String(var12, 0);
               var9.close();
               expiryDate = Long.valueOf(var14);
            }

            long var10 = (new Date()).getTime() / 1000L;
            if (var10 > expiryDate) {
               return 0;
            } else {
               long var13 = (expiryDate - var10) / 86400L;
               if (var13 < 0L) {
                  var13 = 0L;
               }

               return (int)var13;
            }
         } catch (Exception var8) {
            try {
               FileOutputStream var1 = new FileOutputStream("System" + File.separator + "System.cfg");
               long var2 = (new Date()).getTime() / 1000L;
               var2 += (long)(this.server.UnixTrialDays * 24 * 60 * 60);
               String var4 = Long.toString(var2);
               byte[] var5 = new byte[var4.length()];
               var4.getBytes(0, var5.length, var5, 0);

               for(int var6 = 0; var6 < var5.length; ++var6) {
                  var5[var6] = (byte)(var5[var6] + 15);
               }

               var1.write(var5);
               var1.close();
               return this.server.UnixTrialDays;
            } catch (Exception var7) {
               return this.server.UnixTrialDays;
            }
         }
      }
   }

   int JaggWriteToFile() {
      String[] var1 = this.parseFCTNP(this.FCTNP);

      try {
         if (var1[0].lastIndexOf(File.separator) > 0) {
            String var2 = var1[0].substring(0, var1[0].lastIndexOf(File.separator));
            File var3 = new File(var2);
            var3.mkdirs();
         }

         FileOutputStream var7 = new FileOutputStream(var1[0]);
         int var8 = this.SQL.length();
         byte[] var4 = new byte[var8];
         this.SQL.getBytes(0, var8, var4, 0);
         var7.write(var4);
         var7.close();
         return 0;
      } catch (Exception var6) {
         this.println("Could not write to: " + var1[0]);
         this.logException(var6);

         try {
            this.writeLn("JAGG_ERROR:FILE_WRITE_FAILED");
            this.writeLn(field_2);
            this.writeLn(EOT);
         } catch (Exception var5) {
         }

         return -1;
      }
   }

   int JaggReadFromFile() {
      String[] var1 = this.parseFCTNP(this.FCTNP);

      try {
         FileInputStream var2 = new FileInputStream(var1[0]);
         int var3 = var2.available();
         byte[] var4 = new byte[var3];
         var2.read(var4, 0, var3);
         String var5 = new String(var4, 0);
         var2.close();
         this.writeLn(var5);
         this.writeLn("JAGG");
         this.writeLn("EOF");
         return 0;
      } catch (Exception var7) {
         this.println("Could not read from: " + var1[0]);

         try {
            this.writeLn("JAGG_ERROR:FILE_READ_FAILED");
            this.writeLn("JAGG");
            this.writeLn("EOF");
         } catch (Exception var6) {
         }

         return -1;
      }
   }

   int JaggGetDrives() {
      int var1 = 0;
      if (System.getProperty("os.name").toUpperCase().indexOf("WINDOW") >= 0) {
         String var3 = "CDEFGHIJKLMNOPQRSTUVWXYZ";

         for(int var4 = 0; var4 < var3.length(); ++var4) {
            File var2 = new File(var3.substring(var4, var4 + 1) + ":\\");
            if (var2.isDirectory()) {
               try {
                  this.writeLn(var3.substring(var4, var4 + 1) + ":" + field_2);
                  ++var1;
               } catch (Exception var7) {
               }
            }
         }
      } else if (System.getProperty("os.name").toUpperCase().indexOf("NETWARE") >= 0) {
         File var8 = new File("SYS:");
         if (var8.isDirectory()) {
            try {
               this.writeLn("SYS:" + field_2);
               ++var1;
            } catch (Exception var6) {
            }
         }
      } else {
         File var9 = new File("\\");
         if (var9.isDirectory()) {
            try {
               this.writeLn("\\" + field_2);
               ++var1;
            } catch (Exception var5) {
            }
         }
      }

      return var1;
   }

   int JaggListFiles() {
      String[] var2 = this.parseFCTNP(this.FCTNP);
      File var1;
      if (var2.length == 1) {
         var1 = new File(var2[0]);
      } else {
         if (var2.length != 2) {
            return 0;
         }

         var1 = new File(var2[0], var2[1]);
      }

      String[] var3 = var1.list();
      if (var3 == null) {
         return 0;
      } else {
         try {
            for(int var5 = 0; var5 < var3.length; ++var5) {
               File var4 = new File(var1, var3[var5]);
               if (var4.isDirectory()) {
                  this.writeLn(var3[var5] + this.SEP + "D" + this.SEP + Long.toString(var4.length()) + this.SEP + Long.toString(var4.lastModified()) + field_2);
               }
            }

            for(int var6 = 0; var6 < var3.length; ++var6) {
               File var8 = new File(var1, var3[var6]);
               if (!var8.isDirectory()) {
                  this.writeLn(var3[var6] + this.SEP + "F" + this.SEP + Long.toString(var8.length()) + this.SEP + Long.toString(var8.lastModified()) + field_2);
               }
            }
         } catch (Exception var7) {
         }

         return var3.length;
      }
   }

   int JavaBeanGetParentClasses() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         for(int var4 = 0; var4 < var1.length; ++var4) {
            int var3 = var1[var4].indexOf("[");
            if (var3 > 0) {
               var1[var4] = var1[var4].substring(0, var3);
            }

            Class var5 = null;
            if (var1[var4].equals("int")) {
               var5 = Integer.TYPE;
            }

            if (var1[var4].equals("boolean")) {
               var5 = Boolean.TYPE;
            }

            if (var1[var4].equals("char")) {
               var5 = Character.TYPE;
            }

            if (var1[var4].equals("byte")) {
               var5 = Byte.TYPE;
            }

            if (var1[var4].equals("short")) {
               var5 = Short.TYPE;
            }

            if (var1[var4].equals("long")) {
               var5 = Long.TYPE;
            }

            if (var1[var4].equals("float")) {
               var5 = Float.TYPE;
            }

            if (var1[var4].equals("double")) {
               var5 = Double.TYPE;
            }

            if (var1[var4].equals("void")) {
               var5 = Void.TYPE;
            }

            if (var5 == null) {
               var5 = Class.forName(var1[var4]);
            }

            this.writeLn(var1[var4]);

            while(var5 != null) {
               this.writeLn(this.SEP);
               this.writeLn(var5.getName());
               var5 = var5.getSuperclass();
            }

            ++var2;
            this.writeLn(field_2);
         }
      } catch (Exception var6) {
      }

      return var2;
   }

   int JavaBeanGetConstructors() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         for(int var4 = 0; var4 < var1.length; ++var4) {
            int var3 = var1[var4].indexOf("[");
            if (var3 > 0) {
               var1[var4] = var1[var4].substring(0, var3);
            }

            Class var5 = null;
            if (var1[var4].equals("int")) {
               var5 = Integer.TYPE;
            }

            if (var1[var4].equals("boolean")) {
               var5 = Boolean.TYPE;
            }

            if (var1[var4].equals("char")) {
               var5 = Character.TYPE;
            }

            if (var1[var4].equals("byte")) {
               var5 = Byte.TYPE;
            }

            if (var1[var4].equals("short")) {
               var5 = Short.TYPE;
            }

            if (var1[var4].equals("long")) {
               var5 = Long.TYPE;
            }

            if (var1[var4].equals("float")) {
               var5 = Float.TYPE;
            }

            if (var1[var4].equals("double")) {
               var5 = Double.TYPE;
            }

            if (var1[var4].equals("void")) {
               var5 = Void.TYPE;
            }

            if (var5 == null) {
               var5 = Class.forName(var1[var4]);
            }

            Constructor[] var6 = var5.getConstructors();

            for(int var7 = 0; var7 < var6.length; ++var7) {
               this.writeLn(var1[var4]);
               Class[] var8 = var6[var7].getParameterTypes();

               for(int var9 = 0; var9 < var8.length; ++var9) {
                  this.writeLn(this.SEP);
                  this.writeLn(var8[var9].getName());
               }

               this.writeLn(field_2);
               ++var2;
            }

            this.writeLn(" " + field_2);
         }
      } catch (Exception var10) {
      }

      return var2;
   }

   int JavaBeanGetMethods() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         for(int var6 = 1; var6 < var1.length; ++var6) {
            int var4 = var1[var6].indexOf("[");
            if (var4 > 0) {
               var1[var6] = var1[var6].substring(0, var4);
            }

            BeanInfo var3 = this.getBeanInfo(var1[0], var1[var6]);
            MethodDescriptor[] var7 = var3.getMethodDescriptors();

            for(int var8 = 0; var8 < var7.length; ++var8) {
               String var5 = var7[var8].getMethod().getDeclaringClass().getName();
               if (var5.equals(var1[var6])) {
                  this.writeLn(" " + this.SEP);
                  this.writeLn(var5);
                  this.writeLn(this.SEP);
                  this.writeLn(var7[var8].getMethod().getName());
                  this.writeLn(this.SEP);
                  this.writeLn(Integer.toString(var7[var8].getMethod().getModifiers()));
                  this.writeLn(this.SEP);
                  this.writeLn(var7[var8].getMethod().getReturnType().getName());
                  Class[] var9 = var7[var8].getMethod().getParameterTypes();

                  for(int var10 = 0; var10 < var9.length; ++var10) {
                     this.writeLn(this.SEP);
                     this.writeLn(var9[var10].getName());
                  }

                  this.writeLn(field_2);
                  ++var2;
               }
            }

            this.writeLn(" " + field_2);
         }
      } catch (Exception var11) {
         ((Throwable)var11).printStackTrace();
      }

      return var2;
   }

   int JavaBeanGetParameterTypes() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         for(int var5 = 2; var5 < var1.length; ++var5) {
            int var4 = var1[var5].indexOf("[");
            if (var4 > 0) {
               var1[var5] = var1[var5].substring(0, var4);
            }

            BeanInfo var3 = this.getBeanInfo(var1[0], var1[var5]);
            MethodDescriptor[] var6 = var3.getMethodDescriptors();

            for(int var7 = 0; var7 < var6.length; ++var7) {
               if (var1[1].equals("") || var1[1].equals(var6[var7].getMethod().getName())) {
                  this.writeLn(var1[var5]);
                  this.writeLn(this.SEP);
                  Class[] var8 = var6[var7].getMethod().getParameterTypes();
                  this.writeLn(var6[var7].getMethod().getName());

                  for(int var9 = 0; var9 < var8.length; ++var9) {
                     this.writeLn(this.SEP);
                     this.writeLn(var8[var9].getName());
                  }

                  this.writeLn(field_2);
                  ++var2;
               }
            }

            this.writeLn(" " + field_2);
         }
      } catch (Exception var10) {
      }

      return var2;
   }

   int JavaBeanGetProperties() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         for(int var5 = 1; var5 < var1.length; ++var5) {
            int var4 = var1[var5].indexOf("[");
            if (var4 > 0) {
               var1[var5] = var1[var5].substring(0, var4);
            }

            BeanInfo var3 = this.getBeanInfo(var1[0], var1[var5]);
            PropertyDescriptor[] var6 = var3.getPropertyDescriptors();

            for(int var7 = 0; var7 < var6.length; ++var7) {
               this.writeLn(var1[var5]);
               this.writeLn(this.SEP);
               this.writeLn(var6[var7].getName());
               this.writeLn(this.SEP);
               this.writeLn(var6[var7].getPropertyType().getName());
               this.writeLn(field_2);
               ++var2;
            }

            this.writeLn(" " + field_2);
         }
      } catch (Exception var8) {
      }

      return var2;
   }

   int JavaBeanGetEvents() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         for(int var5 = 1; var5 < var1.length; ++var5) {
            int var4 = var1[var5].indexOf("[");
            if (var4 > 0) {
               var1[var5] = var1[var5].substring(0, var4);
            }

            BeanInfo var3 = this.getBeanInfo(var1[0], var1[var5]);
            EventSetDescriptor[] var6 = var3.getEventSetDescriptors();
            var3.getMethodDescriptors();

            for(int var7 = 0; var7 < var6.length; ++var7) {
               this.writeLn(var1[var5]);
               this.writeLn(this.SEP);
               this.writeLn(var6[var7].getName());
               this.writeLn(this.SEP);
               this.writeLn(var6[var7].getAddListenerMethod().getName());
               Method[] var8 = var6[var7].getListenerMethods();

               for(int var9 = 0; var9 < var8.length; ++var9) {
                  this.writeLn(this.SEP);
                  this.writeLn(var8[var9].getName());
                  this.writeLn("(");
                  Class[] var10 = var8[var9].getParameterTypes();

                  for(int var11 = 0; var11 < var10.length; ++var11) {
                     if (var11 > 0) {
                        this.writeLn(", ");
                     }

                     if (var10[var11].getName().startsWith("java.awt.event.")) {
                        this.writeLn(var10[var11].getName().substring(15));
                     } else {
                        this.writeLn(var10[var11].getName());
                     }

                     if (var11 == 0) {
                        this.writeLn(" e");
                     } else {
                        this.writeLn(" p" + Integer.toString(var11));
                     }
                  }

                  this.writeLn(")");
               }

               this.writeLn(field_2);
               ++var2;
            }

            this.writeLn(" " + field_2);
         }
      } catch (Exception var12) {
         ((Throwable)var12).printStackTrace();
      }

      return var2;
   }

   BeanInfo getBeanInfo(String var1, String var2) throws Exception {
      int var3 = var1.indexOf("[");
      if (var3 > 0) {
         var1 = var1.substring(0, var3);
      }

      var3 = var2.indexOf("[");
      if (var3 > 0) {
         var2 = var2.substring(0, var3);
      }

      Class var4 = null;
      if (var2.equals("int")) {
         var4 = Integer.TYPE;
      }

      if (var2.equals("boolean")) {
         var4 = Boolean.TYPE;
      }

      if (var2.equals("char")) {
         var4 = Character.TYPE;
      }

      if (var2.equals("byte")) {
         var4 = Byte.TYPE;
      }

      if (var2.equals("short")) {
         var4 = Short.TYPE;
      }

      if (var2.equals("long")) {
         var4 = Long.TYPE;
      }

      if (var2.equals("float")) {
         var4 = Float.TYPE;
      }

      if (var2.equals("double")) {
         var4 = Double.TYPE;
      }

      if (var2.equals("void")) {
         var4 = Void.TYPE;
      }

      if (var4 == null) {
         var4 = Class.forName(var2);
      }

      if (var1.equals("*ALL")) {
         return Introspector.getBeanInfo(var4);
      } else if (var1.equals("*SUPER")) {
         return Introspector.getBeanInfo(var4, var4.getSuperclass());
      } else {
         Class var5 = null;
         if (var1.equals("int")) {
            var5 = Integer.TYPE;
         }

         if (var1.equals("boolean")) {
            var5 = Boolean.TYPE;
         }

         if (var1.equals("char")) {
            var5 = Character.TYPE;
         }

         if (var1.equals("byte")) {
            var5 = Byte.TYPE;
         }

         if (var1.equals("short")) {
            var5 = Short.TYPE;
         }

         if (var1.equals("long")) {
            var5 = Long.TYPE;
         }

         if (var1.equals("float")) {
            var5 = Float.TYPE;
         }

         if (var1.equals("double")) {
            var5 = Double.TYPE;
         }

         if (var1.equals("void")) {
            var5 = Void.TYPE;
         }

         if (var5 == null) {
            var5 = Class.forName(var1);
         }

         return Introspector.getBeanInfo(var4, var5);
      }
   }

   int JaggRenameFile() {
      String[] var1 = this.parseFCTNP(this.FCTNP);

      try {
         File var2 = new File(var1[0]);
         if (var1[1].lastIndexOf(File.separator) > 0) {
            String var3 = var1[1].substring(0, var1[1].lastIndexOf(File.separator));
            File var4 = new File(var3);
            var4.mkdirs();
         }

         File var6 = new File(var1[1]);
         if (var6.exists()) {
            var6.delete();
         }

         File var7 = new File(var1[1]);
         var2.renameTo(var7);
         return 1;
      } catch (Exception var5) {
         this.logException(var5);
         return 0;
      }
   }

   int JaggRemoveFiles() {
      String[] var2 = this.parseFCTNP(this.FCTNP);
      File var1 = new File(var2[0]);
      String[] var3 = var1.list();
      if (var3 == null) {
         return 0;
      } else {
         String var5 = var2[1];
         String var6 = var2[1];
         int var7 = var2[1].indexOf("*");
         if (var7 >= 0) {
            var5 = var2[1].substring(0, var7);
            var6 = var2[1].substring(var7 + 1);
         }

         try {
            for(int var8 = 0; var8 < var3.length; ++var8) {
               File var4 = new File(var1, var3[var8]);
               if (!var4.isDirectory() && var3[var8].startsWith(var5) && var3[var8].endsWith(var6)) {
                  var4.delete();
               }
            }

            return 1;
         } catch (Exception var9) {
            this.logException(var9);
            return 0;
         }
      }
   }

   int JaggCreateFolder() {
      String[] var1 = this.parseFCTNP(this.FCTNP);

      try {
         File var2 = new File(var1[0]);
         var2.mkdirs();
         return 1;
      } catch (Exception var3) {
         return 0;
      }
   }

   int JaggArchiveApp() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      Date var2 = new Date();
      String var3 = Integer.toString(var2.getYear() + 1900);
      String var4 = Integer.toString(var2.getMonth() + 1);
      if (var4.length() == 1) {
         var4 = "0" + var4;
      }

      String var5 = Integer.toString(var2.getDate());
      if (var5.length() == 1) {
         var5 = "0" + var5;
      }

      var3 = var3 + var4 + var5;
      String var6 = var1[1] + var3;
      int var7 = var1[1].indexOf(".");
      if (var7 >= 0) {
         var6 = var1[1].substring(0, var7) + var3 + var1[1].substring(var7);
      }

      File var8 = new File(var1[0], var1[1]);
      if (var8 != null && var8.length() > 0L) {
         File var9 = new File(var1[2]);
         var9.mkdirs();
         File var10 = new File(var1[2], var6);

         try {
            FileInputStream var11 = new FileInputStream(var8);
            FileOutputStream var12 = new FileOutputStream(var10);

            for(int var13 = var11.read(); var13 >= 0; var13 = var11.read()) {
               var12.write(var13);
            }

            var11.close();
            var12.close();
         } catch (Exception var20) {
         }
      }

      int var24 = 60;

      try {
         var24 = Integer.parseInt(var1[3]);
      } catch (Exception var19) {
      }

      Date var25 = new Date(var2.getYear(), var2.getMonth(), var2.getDate() - var24);
      String var26 = Integer.toString(var25.getYear() + 1900);
      var4 = Integer.toString(var25.getMonth() + 1);
      if (var4.length() == 1) {
         var4 = "0" + var4;
      }

      var5 = Integer.toString(var25.getDate());
      if (var5.length() == 1) {
         var5 = "0" + var5;
      }

      var26 = var26 + var4 + var5;
      String var28 = var1[1];
      String var29 = var1[1] + var26;
      if (var7 >= 0) {
         var28 = var1[1].substring(0, var7);
         var29 = var1[1].substring(0, var7) + var26 + var1[1].substring(var7);
      }

      File var14 = new File(var1[2]);
      String[] var15 = var14.list();

      for(int var16 = 0; var16 < var15.length; ++var16) {
         if (var15[var16].startsWith(var28) && var15[var16].compareTo(var29) < 0) {
            try {
               File var17 = new File(var14, var15[var16]);
               var17.delete();
            } catch (Exception var18) {
            }
         }
      }

      return 1;
   }

   int JaggExecCommand() {
      if (this.SQL.indexOf("javac.exe ") >= 0 || this.SQL.indexOf("javac ") >= 0) {
         int var1 = this.compileJavaClass(this.SQL);
         if (var1 >= 0) {
            return var1;
         }
      }

      int var13 = 0;
      String[] var2 = new String[]{this.SQL};
      this.field_3 = null;
      this.err = null;
      Object var3 = null;
      if (var3 == null) {
         char[] var10000 = new char[128];
      }

      try {
         Runtime var5 = Runtime.getRuntime();
         Process var6 = var5.exec(this.SQL);
         this.field_3 = new BufferedInputStream(var6.getInputStream());
         this.err = new BufferedInputStream(var6.getErrorStream());
         JaggServerCxn var7 = new JaggServerCxn(this, this.field_3);
         JaggServerCxn var8 = new JaggServerCxn(this, this.err);
         var13 = var6.waitFor();

         while(!var7.monitorFinished) {
            try {
               Thread.sleep(100L);
            } catch (Exception var11) {
            }
         }

         while(!var8.monitorFinished) {
            try {
               Thread.sleep(100L);
            } catch (Exception var10) {
            }
         }

         if (var7.inLog != null) {
            this.writeLn(var7.inLog.toString());
         }

         if (var8.errLog != null) {
            this.writeLn(var8.errLog.toString());
         }

         this.writeLn(field_2);
         ((Thread)var7).stop();
         ((Thread)var8).stop();
         this.field_3 = null;
         this.err = null;
         var6.destroy();
      } catch (Exception var12) {
         this.println("Could not execute the following command: " + this.SQL);
         this.logException(var12);

         try {
            this.writeLn("JAGG_ERROR:COMMAND_EXECUTION_FAILED");
            this.writeLn(field_2);
            this.writeLn(EOT);
         } catch (Exception var9) {
         }
      }

      return var13;
   }

   public void monitorActiveJob() {
      char[] var1 = null;
      char[] var2 = var1;
      if (var1 == null) {
         var2 = var1 = new char[128];
      }

      int var3 = var2.length;
      int var4 = 0;
      boolean var5 = false;

      try {
         for(int var8 = this.thisStream.read(); var8 > -1; var8 = this.thisStream.read()) {
            --var3;
            if (var3 < 0) {
               var2 = new char[var4 + 128];
               var3 = var2.length - var4 - 1;
               System.arraycopy(var1, 0, var2, 0, var4);
               var1 = var2;
            }

            var2[var4++] = (char)var8;
         }

         if (var4 > 0) {
            this.writeLog(String.copyValueOf(var2, 0, var4));
         }

         this.thisStream.close();
      } catch (Exception var7) {
         this.logException(var7);
      }
   }

   public void writeLog(String var1) {
      if (this.target != null) {
         if (this.thisStream == this.target.field_3) {
            if (this.inLog == null) {
               this.inLog = new StringBuffer();
            }

            this.inLog.append(var1);
            return;
         }

         if (this.errLog == null) {
            this.errLog = new StringBuffer();
         }

         this.errLog.append(var1);
      }

   }

   int JaggGetStockData() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      this.FCTN = "";
      int var2 = (new Date()).getDate();
      if (this.server.lastDate == 0 || this.server.lastDate != var2) {
         this.server.cusips = new Vector();
         this.server.cusipData = new Vector();
         System.gc();
         this.server.lastDate = var2;
      }

      String var3 = var1[0];
      int var4 = Integer.parseInt(var1[1]);
      int var5 = Integer.parseInt(var1[2]);
      int var6 = -1;

      for(int var7 = 0; var7 < this.server.cusips.size(); ++var7) {
         if (((String)this.server.cusips.elementAt(var7)).equals(var3)) {
            var6 = var7;
            break;
         }
      }

      if (var6 < 0) {
         var6 = this.loadNewStockData(var3);
      }

      try {
         if (var6 < 0) {
            this.writeLn("JAGG");
            this.writeLn("EOF");
            return 0;
         }

         this.loadTodayStockData(var3);
         this.writeLn(field_2);
         Vector var8 = (Vector)this.server.cusipData.elementAt(var6);
         String var9 = (String)var8.elementAt(3);
         this.writeLn(var9);
         this.writeLn("\u0004");
         String var10 = (String)var8.elementAt(1);
         int var11 = Integer.parseInt((String)var8.elementAt(2));
         int var12 = var10.charAt(1) * 256 + var10.charAt(0);
         StringBuffer var13 = new StringBuffer();
         byte var14 = 0;
         if (var12 == 1) {
            var14 = 15;
         } else if (var12 == 2) {
            var14 = 25;
         }

         var13.append(var10.substring(0, var14));
         var4 = var11 - var4 * var14;
         var5 = var11 - var5 * var14;
         if (var5 < var14) {
            var5 = var14;
         }

         if (var4 < var14) {
            var4 = var14;
         }

         var13.append(var10.substring(var5, var4));
         this.writeLn(var13.toString());
         this.writeLn("JAGG");
         this.writeLn("EOF");
      } catch (Exception var15) {
      }

      return 1;
   }

   synchronized int loadNewStockData(String var1) {
      int var2 = -1;
      String var3 = "d:\\wsweb\\active\\";
      if (var1.charAt(0) == 'A') {
         var3 = var3 + "usa";
      } else if (var1.charAt(0) == 'C') {
         var3 = var3 + "cda";
      } else if (var1.charAt(0) == 'X') {
         var3 = var3 + "inx";
      }

      var3 = var3 + "\\";
      var3 = var3 + var1.substring(1, 2) + "\\";
      var3 = var3 + var1.substring(2, 3) + "\\";
      var3 = var3 + var1.substring(3, 4) + "\\";
      var3 = var3 + var1.trim() + ".wsd";
      Object var4 = null;

      try {
         FileInputStream var5 = new FileInputStream(var3);
         int var6 = var5.available();
         byte[] var7 = new byte[var6];
         var6 = var5.read(var7, 0, var6);
         String var16 = new String(var7, 0);
         var5.close();
         var2 = this.server.cusips.size();
         this.server.cusips.addElement(var1);
         String var8 = "";
         Vector var9 = new Vector();
         var9.addElement(var8);
         var9.addElement(var16);
         var9.addElement(Integer.toString(var6));
         var9.addElement(this.loadStockSplitData(var1));
         this.server.cusipData.addElement(var9);
      } catch (Exception var10) {
      }

      return var2;
   }

   synchronized int loadTodayStockData(String var1) {
      String[] var2 = this.parseFCTNP(this.FCTNP);
      this.SQL = "SELECT ticker, name, date, openprice, high, low, last, volume FROM LastPrice WHERE cusip = '" + var1 + "'";
      this.LSQL = var2[3];
      this.runSql();
      return 1;
   }

   synchronized String loadStockSplitData(String var1) {
      this.SQL = "SELECT ExDate, DivRate, DivType, AF FROM Dividends WHERE CPointer = '" + var1 + "' AND DivType IN (2,3,4) ORDER BY ExDate";
      this.sqlCapture = new StringBuffer();
      this.captureSqlOutput = true;
      this.runSql();
      this.captureSqlOutput = false;
      return this.sqlCapture.toString();
   }

   int compileJavaClass(String var1) {
      String var2 = var1;
      int var3 = var1.indexOf("JDPJagg.exe System ");
      if (var3 >= 0) {
         var3 += 19;
         var2 = var1.substring(var3);
      }

      StringTokenizer var4 = new StringTokenizer(var2, " ");
      String[] var5 = new String[var4.countTokens() - 1];
      var4.nextToken();

      for(int var6 = 0; var4.hasMoreTokens(); var5[var6++] = var4.nextToken()) {
      }

      ByteArrayOutputStream var7 = new ByteArrayOutputStream();
      byte var8 = 1;

      try {
         Main var9 = new Main(var7, "javac");
         boolean var10 = var9.compile(var5);
         if (var10) {
            var8 = 0;
         }

         if (var3 >= 0) {
            this.SQL = var7.toString();
            this.FCTNP = "command.txt;w+;";
            this.JaggWriteToFile();
         } else {
            try {
               this.writeLn(var7.toString());
               this.writeLn(field_2);
            } catch (Exception var11) {
            }
         }

         return var8;
      } catch (Exception var12) {
         return -1;
      }
   }

   int JarListFiles() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      int var2 = 0;

      try {
         ZipFile var3 = new ZipFile(var1[0]);
         Enumeration var4 = var3.entries();

         while(var4.hasMoreElements()) {
            Object var5 = var4.nextElement();
            if (var5 instanceof ZipEntry) {
               this.writeLn(((ZipEntry)var5).getName() + field_2);
               ++var2;
            }
         }
      } catch (Exception var6) {
         ((Throwable)var6).printStackTrace();
         var2 = -1;
      }

      return var2;
   }

   int JarCommand() {
      String[] var1 = this.parseFCTNP(this.FCTNP);
      sun.tools.jar.Main var2 = new sun.tools.jar.Main(System.out, System.err, "jar");
      boolean var3 = var2.run(var1);
      byte var4 = 1;
      if (var3) {
         var4 = 0;
      }

      return var4;
   }

   int JaggServerJob() {
      new JDPPanelLoader(this.FCTNP, this.SQL, this.thisSocket);
      return 0;
   }

   int InvokeMethod() {
      String[] var1 = new String[0];
      String[] var2 = new String[0];

      try {
         Properties var3 = new Properties();
         StringBufferInputStream var21 = new StringBufferInputStream(this.SQL);
         var3.load(var21);
         this.objectName = (String)((Hashtable)var3).get("objectName");
         this.jobName = (String)((Hashtable)var3).get("jobName");
         this.jobNumber = (String)((Hashtable)var3).get("jobNumber");
         this.methodName = (String)((Hashtable)var3).get("methodName");
         int var22 = Integer.parseInt((String)((Hashtable)var3).get("parametersSize"));
         var1 = new String[var22];
         var2 = new String[var22];

         for(int var23 = 0; var23 < var2.length; ++var23) {
            var1[var23] = (String)((Hashtable)var3).get("paramTypes" + Integer.toString(var23));
            var2[var23] = (String)((Hashtable)var3).get("parameters" + Integer.toString(var23));
         }

         Object var7 = null;
         if (this.jobName != null) {
            var7 = this.server.manager.getJobForName(this.jobName);
            this.objectName = this.server.manager.getClassForName(this.jobName);
         } else if (this.jobNumber != null) {
            if (this.objectName == null) {
               var7 = this.server.manager.getJobForNumber(Integer.parseInt(this.jobNumber));
               this.objectName = this.server.manager.getClassForNumber(Integer.parseInt(this.jobNumber));
            } else if (this.objectName.equals("JDPJob")) {
               var7 = this.server.manager.getJob(Integer.parseInt(this.jobNumber));
            } else if (this.objectName.equals("JDPActiveJob")) {
               var7 = this.server.manager.getJob(Integer.parseInt(this.jobNumber)).getActiveJob();
            }
         } else if (this.objectName != null) {
            if (this.objectName.equals("JDPSubsystemMgr")) {
               var7 = this.server.manager;
            } else if (this.objectName.equals("JDPJobQueueMgr")) {
               var7 = this.server.manager.queueMgr;
            } else if (this.objectName.equals("JDPJaggCxnMgr")) {
               var7 = this.server.manager.connectionMgr;
            } else if (this.objectName.equals("JDPJaggUserMgr")) {
               var7 = this.server.manager.userMgr;
            } else {
               var7 = this.server.manager.getJobRunningClass(this.objectName);
            }
         }

         if (var7 != null && this.objectName != null) {
            Class[] var8 = new Class[var1.length];
            Object[] var9 = new Object[var1.length];

            for(int var10 = 0; var10 < var1.length; ++var10) {
               var8[var10] = JDPUtils.getClass(var1[var10]);
               var9[var10] = JDPUtils.createObject(var8[var10], var2[var10]);
            }

            Class var11 = JDPUtils.getClass(this.objectName);
            Method var12 = var11.getMethod(this.methodName, var8);
            Object var13 = var12.invoke(var7, var9);
            ((Hashtable)var3).clear();
            ((Hashtable)var3).put("returnType", var12.getReturnType().getName());
            if (var13 != null) {
               ((Hashtable)var3).put("returnVal", var13.toString());
            }

            ByteArrayOutputStream var14 = new ByteArrayOutputStream();
            var3.save(var14, "parameters");
            String var15 = var14.toString();
            this.writeLn(var15);
            this.writeLn(field_2);
            return 0;
         } else {
            this.println("Remote command failed.");
            if (this.jobName != null) {
               this.println("Could not find requested job name (" + this.jobName + ") on server on which to invoke method");
               this.writeLn("Could not find requested job name (" + this.jobName + ") on server on which to invoke method");
            } else if (this.jobNumber != null) {
               this.println("Could not find requested job number (" + this.jobNumber + ") on server on which to invoke method");
               this.writeLn("Could not find requested job number (" + this.jobNumber + ") on server on which to invoke method");
            } else {
               this.println("Could not find requested class (" + this.objectName + ") on server on which to invoke method");
               this.writeLn("Could not find requested class (" + this.objectName + ") on server on which to invoke method");
            }

            this.writeLn(field_2);
            return -1;
         }
      } catch (Exception var17) {
         this.println("Remote command failed.");
         this.println("Could not invoke " + this.methodName + " on class " + this.objectName);
         String var4 = "";

         for(int var5 = 0; var5 < var1.length; ++var5) {
            if (var5 > 0) {
               var4 = var4 + ",";
            }

            var4 = var4 + var1[var5];
         }

         this.println("Parameter types passed:  " + var4);
         var4 = "";

         for(int var6 = 0; var6 < var2.length; ++var6) {
            if (var6 > 0) {
               var4 = var4 + ",";
            }

            var4 = var4 + var2[var6];
         }

         this.println("Parameter values passed: " + var4);
         this.logException(var17);

         try {
            this.writeLn("Could not invoke " + this.methodName + " on class " + this.objectName);
            this.writeLn(field_2);
         } catch (Exception var16) {
         }

         return -1;
      }
   }

   private Vector getDbConnection(String var1, String var2) throws Exception {
      for(int var3 = 0; var3 < this.server.dbConnection.size(); ++var3) {
         Vector var4 = (Vector)this.server.dbConnection.elementAt(var3);
         if (((String)var4.elementAt(0)).equals(var1 + var2) && ((String)var4.elementAt(1)).equals("Inactive")) {
            var4.setElementAt("Active", 1);
            Date var5 = new Date();
            long var6 = var5.getTime() / 1000L;
            var4.setElementAt(Long.toString(var6), 3);
            long var8 = (Long)var4.elementAt(5) + 1L;
            var4.setElementAt(new Long(var8), 5);
            this.thisJdbcConnectionNum = (Long)var4.elementAt(6);
            return var4;
         }
      }

      Properties var12 = new Properties();
      StringTokenizer var13 = new StringTokenizer(var2, ";");
      int var14 = var13.countTokens();

      for(int var7 = 0; var7 < var14; ++var7) {
         String var15 = var13.nextToken();
         int var9 = var15.indexOf("=");
         if (var9 >= 0) {
            String var10 = var15.substring(0, var9);
            if (var10.equals("UID")) {
               var10 = "user";
            }

            if (var10.equals("PWD")) {
               var10 = "password";
            }

            if (var9 > 0) {
               ((Hashtable)var12).put(var10, var15.substring(var9 + 1));
            }
         }
      }

      Vector var16 = new Vector();
      var16.addElement(var1 + var2);
      var16.addElement("Active");
      this.println("Attempting connection to: " + var1);
      var16.addElement(DriverManager.getConnection(var1, var12));
      Date var17 = new Date();
      long var18 = var17.getTime() / 1000L;
      var16.addElement(Long.toString(var18));
      var16.addElement(var1);
      var16.addElement(new Long(1L));
      this.thisJdbcConnectionNum = this.server.nextConnectionNum;
      var16.addElement(new Long((long)(this.server.nextConnectionNum++)));
      this.server.dbConnection.addElement(var16);
      this.println("Opened new connection to: " + var1);
      return var16;
   }

   void writeLn(String var1) throws Exception {
      if (this.captureSqlOutput) {
         this.sqlCapture.append(var1);
      } else if (var1 != null && var1.length() != 0) {
         int var2 = var1.length();
         this.totalCharsWritten += var2;
         byte[] var3 = new byte[var2];
         var1.getBytes(0, var2, var3, 0);

         try {
            this.serverResponse.write(var3);
         } catch (Exception var4) {
         }
      } else {
         if (this.NULL.equals("space")) {
            this.serverResponse.write(32);
         }

         if (this.NULL.equals("")) {
            this.writeLn("NULL");
         }

         if (this.NULL.equals("null")) {
            this.writeLn("null");
         }

      }
   }

   void formatCSTR() {
      this.CSTR = "UID=" + this.UID + ";PWD=" + this.PWD + ";";
      if (!this.field_0.equals("")) {
         this.CSTR = this.CSTR + "DATABASE=" + this.field_0 + ";";
      }

   }

   void parseCSTR(String var1) {
      StringTokenizer var2 = new StringTokenizer(var1, ";");
      int var3 = var2.countTokens();

      for(int var4 = 0; var4 < var3; ++var4) {
         String var5 = var2.nextToken();
         if (var5.startsWith("DSN=")) {
            this.DSN = var5.substring(4);
         }

         if (var5.startsWith("UID=")) {
            this.UID = var5.substring(4);
         }

         if (var5.startsWith("PWD=")) {
            this.PWD = var5.substring(4);
         }

         if (var5.startsWith("DB=")) {
            this.field_0 = var5.substring(2);
         }

         if (var5.startsWith("WSID=")) {
            this.WSID = var5.substring(5);
         }
      }

   }

   void parseRequest(String var1) throws Exception {
      int var3 = var1.indexOf("\u0002SQL=");
      StringTokenizer var2;
      if (var3 >= 0) {
         this.SQL = var1.substring(var3 + 5, var1.length() - 1);
         var2 = new StringTokenizer(var1.substring(0, var3), "\u0002");
      } else {
         var2 = new StringTokenizer(var1, "\u0002");
      }

      this.SERV = "";
      this.DSN = "";
      this.CSTR = "";
      this.MRW = "";
      this.FCTN = "";
      this.FCTNP = "";
      this.field_1 = "";
      this.SEP = "\u0003";
      this.UID = "";
      this.PWD = "";
      this.field_0 = "";
      this.WSID = "";
      this.LSQL = "";
      this.TOUT = "";
      this.DLOG = "";
      this.NULL = "space";
      this.jdbcDriver = JaggServer.DEFAULTJDBC;
      this.jdbcPrefix = JaggServer.DEFAULTCXN;
      this.jdbcSuffix = "";
      int var4 = var2.countTokens();

      for(int var5 = 0; var5 < var4; ++var5) {
         String var6 = var2.nextToken();
         if (var6.startsWith("SERV=")) {
            this.SERV = var6.substring(5);
         }

         if (var6.startsWith("DSN=")) {
            this.DSN = var6.substring(4);
         }

         if (var6.startsWith("CSTR=")) {
            this.CSTR = var6.substring(5);
         }

         if (var6.startsWith("MRW=")) {
            this.MRW = var6.substring(4);
         }

         if (var6.startsWith("FCTN=")) {
            this.FCTN = var6.substring(5);
         }

         if (var6.startsWith("FCTNP=")) {
            this.FCTNP = var6.substring(6);
         }

         if (var6.startsWith("K=")) {
            this.field_1 = var6.substring(2);
         }

         if (var6.startsWith("SEP=")) {
            this.SEP = var6.substring(4);
         }

         if (var6.startsWith("UID=")) {
            this.UID = var6.substring(4);
         }

         if (var6.startsWith("PWD=")) {
            this.PWD = var6.substring(4);
         }

         if (var6.startsWith("DB=")) {
            this.field_0 = var6.substring(2);
         }

         if (var6.startsWith("WSID=")) {
            this.WSID = var6.substring(5);
         }

         if (var6.startsWith("LSQL=")) {
            this.LSQL = var6.substring(5);
         }

         if (var6.startsWith("TOUT=")) {
            this.TOUT = var6.substring(5);
         }

         if (var6.startsWith("DLOG=")) {
            this.DLOG = var6.substring(5);
         }

         if (var6.startsWith("NULL=")) {
            this.NULL = var6.substring(5);
         }

         if (var6.startsWith("USER=")) {
            this.USER = var6.substring(5);
         }

         if (var6.startsWith("SYS=")) {
            this.SYS = var6.substring(4);
         }

         if (var6.startsWith("jdbcDriver=")) {
            this.jdbcDriver = var6.substring(11).trim();
         }

         if (var6.startsWith("jdbcPrefix=")) {
            this.jdbcPrefix = var6.substring(11).trim();
         }

         if (var6.startsWith("jdbcSuffix=")) {
            this.jdbcSuffix = var6.substring(11).trim();
         }

         if (var6.startsWith("BINS=")) {
            this.loadBulkData(var6.substring(5));
         }
      }

      if (this.CSTR.length() == 0) {
         this.formatCSTR();
      }

   }

   String[] parseFCTNP(String var1) {
      String[] var2 = new String[100];
      int var3 = 0;

      for(int var4 = var1.indexOf(";"); var4 >= 0; var4 = var1.indexOf(";")) {
         if (var4 > 0) {
            var2[var3] = var1.substring(0, var4);
         }

         ++var3;
         var1 = var1.substring(var4 + 1);
      }

      String[] var5 = new String[var3];
      System.arraycopy(var2, 0, var5, 0, var3);
      return var5;
   }

   private void loadBulkData(String var1) throws Exception {
      int var2 = 0;
      boolean var3 = false;
      char[] var8 = this.lineBuffer;
      if (var8 == null) {
         var8 = this.lineBuffer = new char[128];
      }

      int var9 = 0;
      var8 = new char[20000];
      int var10 = var8.length;

      try {
         for(int var11 = this.serverRequest.read(); var11 != 1; var11 = this.serverRequest.read()) {
            --var10;
            if (var10 < 0) {
               this.lineBuffer = var8;
               var8 = new char[var9 + 20000];
               var10 = var8.length - var9 - 1;
               System.arraycopy(this.lineBuffer, 0, var8, 0, var9);
               this.lineBuffer = null;
            }

            var8[var9++] = (char)var11;
         }

         if (var9 == 0) {
            return;
         }

         var1 = String.copyValueOf(var8, 0, var9);
      } catch (Exception var12) {
         this.logException(var12);
      }

      StringTokenizer var6 = new StringTokenizer(var1, "\u0003");
      StringTokenizer var5 = new StringTokenizer(var6.nextToken(), "\u0004");
      int var4 = var5.countTokens();

      for(this.insertType = new int[var4]; var5.hasMoreTokens(); this.insertType[var2++] = Integer.parseInt(var5.nextToken())) {
      }

      this.insertData = new Vector();

      while(var6.hasMoreTokens()) {
         var5 = new StringTokenizer(var6.nextToken(), "\u0004");
         String[] var7 = new String[var4];

         for(int var13 = 0; var5.hasMoreTokens(); var7[var13++] = var5.nextToken()) {
         }

         this.insertData.addElement(var7);
      }

   }

   void println(Object var1) {
      if (jaggServerJob != null) {
         jaggServerJob.appendJobLog(var1.toString());
      } else {
         System.out.println(var1);
      }
   }

   void logException(Exception var1) {
      if (jaggServerJob != null) {
         jaggServerJob.logException(var1);
      } else {
         ((Throwable)var1).printStackTrace();
      }
   }
}
