import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class SalesReportSessionBean {
   JDPJagg jaggSQL;
   JDPSubsystemMgr manager;
   String[][] reportData;
   JDPJob thisJob;
   JDPUtils utils;

   public SalesReportSessionBean(JDPSubsystemMgr var1, JDPJob var2, String var3, String var4, String var5) {
      this.manager = var1;
      this.thisJob = var2;
      var2.setInstance(this);
      this.jaggSQL = new JDPJagg(var1.JDPJaggPath);
      this.utils = new JDPUtils((JDPUser)null);
      this.utils.jaggSQL = this.jaggSQL;
      var2.appendJobLog("Job started on " + (new Date()).toString());

      try {
         if (this.retrieveReportData() > 0) {
            String var6 = this.constructReport();
            this.sendEmail(var3, var4, var5, var6, "Sales Report");
         } else {
            var2.appendJobLog("Failed to retrieve any reportable data.");
         }
      } catch (Exception var7) {
         var2.logException(var7);
      }

      var2.appendJobLog("Job completed on " + (new Date()).toString());
   }

   public String constructReport() {
      StringBuffer var1 = new StringBuffer();
      var1.append("SALES REPORT");
      var1.append("\n\n");
      var1.append(this.utils.padr("Store", 25));
      var1.append(this.utils.padr("Date", 12));
      var1.append(this.utils.padr("Order Num", 15));
      var1.append(this.utils.padr("Title ID", 12));
      var1.append(this.utils.padr("Quantity", 10));
      var1.append("\n");
      var1.append(this.utils.padr("=====", 25));
      var1.append(this.utils.padr("====", 12));
      var1.append(this.utils.padr("=========", 15));
      var1.append(this.utils.padr("========", 12));
      var1.append(this.utils.padr("========", 10));
      var1.append("\n");
      var1.append("\n");
      String var2 = "";
      String var3 = "";
      String var4 = "";
      String var5 = "";
      String var6 = "";
      String var7 = "";
      String var8 = "";
      String var9 = "";
      int var10 = 0;
      int var11 = 0;

      for(int var12 = 0; var12 < this.reportData.length; ++var12) {
         var2 = this.reportData[var12][4];
         var3 = this.reportData[var12][1];
         var4 = this.reportData[var12][0];
         var5 = this.reportData[var12][3];
         var6 = this.reportData[var12][2];
         if (!var7.equals(var2)) {
            if (!var7.equals("")) {
               var1.append(this.utils.padr("", 64));
               var1.append(this.utils.padl(Integer.toString(var10), 8));
               var1.append("\n\n");
               var10 = 0;
            }

            var1.append(this.utils.padr(var2, 25));
         } else {
            var1.append(this.utils.padr("", 25));
         }

         if (var7.equals(var2) && var8.equals(var3)) {
            var1.append(this.utils.padr("", 12));
         } else {
            var1.append(this.utils.padr(JDPDate.format(Long.valueOf(var3)), 12));
         }

         if (var7.equals(var2) && var9.equals(var4)) {
            var1.append(this.utils.padr("", 15));
         } else {
            var1.append(this.utils.padr(var4, 15));
         }

         var1.append(this.utils.padr(var5, 12));
         var1.append(this.utils.padl(var6, 8));
         var1.append("\n");
         var10 += Integer.parseInt(var6);
         var11 += Integer.parseInt(var6);
         var7 = var2;
         var8 = var3;
         var9 = var4;
      }

      var1.append(this.utils.padr("", 64));
      var1.append(this.utils.padl(Integer.toString(var10), 8));
      var1.append("\n\n");
      var1.append(this.utils.padr("", 64));
      var1.append(this.utils.padl(Integer.toString(var11), 8));
      var1.append("\n\n");
      return var1.toString();
   }

   public int retrieveReportData() {
      this.jaggSQL.loadJdbcSettings("JDP Tutorial");
      this.jaggSQL.setUID("");
      this.jaggSQL.setPWD("");
      this.jaggSQL.setMRW("1000");
      this.jaggSQL.setTOUT("60");
      Vector var1 = new Vector();
      String var2 = "SELECT a.ord_num, a.ord_date, a.qty, a.title_id, b.stor_name FROM dbo_sales a, dbo_stores b WHERE a.stor_id = b.stor_id ";
      int var3 = this.jaggSQL.execSQL(var2, var1);
      if (var3 < 0) {
         this.thisJob.appendJobLog(this.jaggSQL.getError());
         return var3;
      } else {
         this.reportData = new String[var1.size()][5];

         for(int var5 = 0; var5 < var1.size(); ++var5) {
            StringTokenizer var4 = new StringTokenizer((String)var1.elementAt(var5), this.jaggSQL.getSEP());
            this.reportData[var5][0] = var4.nextToken();
            this.reportData[var5][1] = var4.nextToken();
            this.reportData[var5][2] = var4.nextToken();
            this.reportData[var5][3] = var4.nextToken();
            this.reportData[var5][4] = var4.nextToken();
         }

         return var3;
      }
   }

   public void sendEmail(String var1, String var2, String var3, String var4, String var5) {
      JDPSendMail var6 = new JDPSendMail(var1);
      if (var6.mailMessage(var2, var3, var5, var4, "")) {
         this.thisJob.appendJobLog("Report successfully sent to " + var2 + ".");
      } else {
         this.thisJob.appendJobLog("Failed to send report to " + var2 + ".");
      }

      var6.closePort();
   }
}
