package javax.ejb.deployment;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.lang.reflect.Method;
import java.security.Identity;

public class AccessControlEntry implements Serializable {
   private transient Method method;
   private Identity[] allowedIdentities;
   private SerializableMethod serializableMethod;

   public AccessControlEntry() {
   }

   public AccessControlEntry(Method var1) {
      this.method = var1;
   }

   public AccessControlEntry(Method var1, Identity[] var2) {
      this.method = var1;
      this.allowedIdentities = var2;
   }

   public Method getMethod() {
      return this.method;
   }

   public void setMethod(Method var1) {
      this.method = var1;
   }

   public Identity[] getAllowedIdentities() {
      return this.allowedIdentities;
   }

   public void setAllowedIdentities(Identity[] var1) {
      this.allowedIdentities = var1;
   }

   public Identity getAllowedIdentities(int var1) {
      return this.allowedIdentities[var1];
   }

   public void setAllowedIdentities(int var1, Identity var2) {
      if (this.allowedIdentities == null || var1 >= this.allowedIdentities.length) {
         Identity[] var3 = new Identity[var1 + 1];
         if (this.allowedIdentities != null) {
            for(int var4 = 0; var4 < this.allowedIdentities.length; ++var4) {
               var3[var4] = this.allowedIdentities[var4];
            }
         }

         this.allowedIdentities = var3;
      }

      this.allowedIdentities[var1] = var2;
   }

   private void writeObject(ObjectOutputStream var1) throws IOException {
      this.serializableMethod = new SerializableMethod(this.method);
      var1.defaultWriteObject();
   }

   private void readObject(ObjectInputStream var1) throws IOException, ClassNotFoundException {
      var1.defaultReadObject();
      this.method = this.serializableMethod.getMethod();
   }
}
