package javax.ejb.deployment;

import java.io.Serializable;
import java.util.Properties;
import javax.naming.Name;

public abstract class DeploymentDescriptor implements Serializable {
   private String enterpriseBean;
   private String remoteInterface;
   private String homeInterface;
   private ControlDescriptor[] controlDescriptors;
   private AccessControlEntry[] accessControlEntries;
   private Properties environment = new Properties();
   private boolean reentrant = false;
   private Name beanName;
   protected int versionNumber = 1;

   public String getEnterpriseBean() {
      return this.enterpriseBean;
   }

   public void setEnterpriseBean(String var1) {
      this.enterpriseBean = var1;
   }

   public String getHomeInterface() {
      return this.homeInterface;
   }

   public void setHomeInterface(String var1) {
      this.homeInterface = var1;
   }

   public String getRemoteInterface() {
      return this.remoteInterface;
   }

   public void setRemoteInterface(String var1) {
      this.remoteInterface = var1;
   }

   public Name getBeanName() {
      return this.beanName;
   }

   public void setBeanName(Name var1) {
      this.beanName = var1;
   }

   public Properties getEnvironmentProperties() {
      return this.environment;
   }

   public void setEnvironmentProperties(Properties var1) {
      this.environment = var1;
   }

   public AccessControlEntry[] getAccessControlEntries() {
      return this.accessControlEntries;
   }

   public void setAccessControlEntries(AccessControlEntry[] var1) {
      this.accessControlEntries = var1;
   }

   public AccessControlEntry getAccessControlEntries(int var1) {
      return this.accessControlEntries[var1];
   }

   public void setAccessControlEntries(int var1, AccessControlEntry var2) {
      if (this.accessControlEntries == null || var1 >= this.accessControlEntries.length) {
         AccessControlEntry[] var3 = new AccessControlEntry[var1 + 1];
         if (this.accessControlEntries != null) {
            for(int var4 = 0; var4 < this.accessControlEntries.length; ++var4) {
               var3[var4] = this.accessControlEntries[var4];
            }
         }

         this.accessControlEntries = var3;
      }

      this.accessControlEntries[var1] = var2;
   }

   public ControlDescriptor[] getControlDescriptors() {
      return this.controlDescriptors;
   }

   public void setControlDescriptors(ControlDescriptor[] var1) {
      this.controlDescriptors = var1;
   }

   public ControlDescriptor getControlDescriptors(int var1) {
      return this.controlDescriptors[var1];
   }

   public void setControlDescriptors(int var1, ControlDescriptor var2) {
      if (this.controlDescriptors == null || var1 >= this.controlDescriptors.length) {
         ControlDescriptor[] var3 = new ControlDescriptor[var1 + 1];
         if (this.controlDescriptors != null) {
            for(int var4 = 0; var4 < this.controlDescriptors.length; ++var4) {
               var3[var4] = this.controlDescriptors[var4];
            }
         }

         this.controlDescriptors = var3;
      }

      this.controlDescriptors[var1] = var2;
   }

   public boolean isReentrant() {
      return this.reentrant;
   }

   public boolean getReentrant() {
      return this.isReentrant();
   }

   public void setReentrant(boolean var1) {
      if (this instanceof SessionDescriptor) {
         throw new IllegalArgumentException("Session bean cannot be re-entrant");
      } else {
         this.reentrant = var1;
      }
   }
}
