package javax.ejb.deployment;

import java.io.InvalidClassException;
import java.io.Serializable;
import java.lang.reflect.Method;

class SerializableMethod implements Serializable {
   private boolean isNull;
   private Class cls;
   private String methodSignature;

   SerializableMethod(Method var1) {
      if (var1 == null) {
         this.isNull = true;
      } else {
         this.isNull = false;
         this.cls = var1.getDeclaringClass();
         this.methodSignature = this.getSignature(var1);
      }
   }

   Method getMethod() throws InvalidClassException {
      if (this.isNull) {
         return null;
      } else {
         Method[] var1 = this.cls.getMethods();

         for(int var2 = 0; var2 < var1.length; ++var2) {
            if (this.getSignature(var1[var2]).equals(this.methodSignature)) {
               return var1[var2];
            }
         }

         throw new InvalidClassException(this.cls.getName(), "method signature not found: " + this.methodSignature);
      }
   }

   private String getSignature(Method var1) {
      String var2 = var1.getName();
      var2 = var2 + "(";
      Class[] var3 = var1.getParameterTypes();

      for(int var4 = 0; var4 < var3.length; ++var4) {
         var2 = var2 + var3[var4].getName();
         if (var4 < var3.length - 1) {
            var2 = var2 + ",";
         }
      }

      var2 = var2 + ")";
      return var2;
   }
}
