package oracle.jdbc.dbaccess;

import java.io.IOException;
import java.sql.SQLException;
import java.util.Properties;

public interface DBAccess {
   byte IS_SELECT = 0;
   byte IS_PLSQL_BLOCK = 1;
   byte IS_OTHER = 2;

   DBConversion logon(String var1, String var2, String var3, Properties var4) throws SQLException, IOException;

   void logoff() throws SQLException, IOException;

   void commit() throws SQLException, IOException;

   void rollback() throws SQLException, IOException;

   void setAutoCommit(boolean var1) throws SQLException, IOException;

   DBStatement open() throws SQLException, IOException;

   void closeQuery(DBStatement var1) throws SQLException, IOException;

   void close(DBStatement var1) throws SQLException, IOException;

   DBColumn[] describe(DBStatement var1) throws SQLException, IOException;

   DBColumn[] parseExecuteDescribe(DBStatement var1, byte[] var2, DBType[] var3, DBData[] var4) throws SQLException, IOException;

   int executeFetch(DBStatement var1, byte var2, DBType[] var3, DBData[] var4, int var5, DBType[] var6, DBData[] var7, int var8) throws SQLException, IOException;

   int parseExecuteFetch(DBStatement var1, byte var2, byte[] var3, DBType[] var4, DBData[] var5, int var6, DBType[] var7, DBData[] var8, int var9) throws SQLException, IOException;

   int fetch(DBStatement var1, DBType[] var2, DBData[] var3, int var4) throws SQLException, IOException;

   int read(DBStatement var1, byte[] var2, int var3) throws SQLException, IOException;

   byte[] getVersion() throws SQLException, IOException;

   int getDefaultPrefetch();

   int getDefaultStreamChunkSize();

   void cancel() throws SQLException, IOException;

   DBStatement RefCursorBytesToDBStatement(byte[] var1) throws SQLException, IOException;

   byte[] DBStatementToRefCursorBytes(DBStatement var1) throws SQLException, IOException;

   int getRefCursorBytesSize() throws SQLException;

   void setWaitandAutoRollback(DBStatement var1, int var2, int var3) throws SQLException;
}
