package oracle.jdbc.dbaccess;

public class DBColumn {
   public String name;
   public int type;
   public int max_length;
   public boolean nullable;
   public int precision;
   public int scale;
   public int flags;
   public int contflag;
   public int total_elems;

   public DBColumn() {
   }

   private DBColumn(String name, int type, int precision, int scale) {
      this.name = name;
      this.type = type;
      this.precision = precision;
      this.scale = scale;
      this.contflag = 0;
      this.total_elems = 0;
      this.flags = 0;
      this.nullable = false;
      switch (type) {
         case 1:
            this.max_length = 2000;
            break;
         case 2:
         case 6:
            this.max_length = 22;
            break;
         case 8:
            this.max_length = 0;
            break;
         case 11:
            this.max_length = 128;
            break;
         case 12:
            this.max_length = 7;
            break;
         case 23:
            this.max_length = 255;
            break;
         case 24:
            this.max_length = 0;
            break;
         case 96:
            this.max_length = 255;
            break;
         case 102:
            this.max_length = 10;
      }

   }

   public DBColumn(String name, boolean nullable, int type, int flags, int precision, int scale, int max_len, int total_elems, int contflag) {
      this.name = name;
      this.nullable = nullable;
      this.type = type;
      this.max_length = max_len;
      this.precision = precision;
      this.scale = scale;
      this.contflag = contflag;
      this.total_elems = total_elems;
      this.flags = flags;
   }

   public String getColumnName() {
      return this.name;
   }

   public int getColumnType() {
      return this.type;
   }

   public int getColumnSize() {
      return this.max_length;
   }
}
