package oracle.jdbc.dbaccess;

import java.io.InputStream;
import java.math.BigDecimal;
import java.sql.Date;
import java.sql.SQLException;
import java.sql.Time;
import java.sql.Timestamp;

public interface DBConversion {
   short ASCII_CHARSET = 1;
   short ISO_LATIN_1_CHARSET = 31;
   short UNICODE_1_CHARSET = 870;
   short UNICODE_2_CHARSET = 871;

   short getCharacterSet();

   byte[] StringToCharBytes(String var1) throws SQLException;

   String CharBytesToString(byte[] var1, int var2) throws SQLException;

   byte[] StringToWorkbench(String var1);

   int StringToWorkbench(String var1, byte[] var2, int var3);

   byte[] StringToNetworkRep(String var1) throws SQLException;

   byte[] BigDecimalToNumberBytes(BigDecimal var1) throws SQLException;

   BigDecimal NumberBytesToBigDecimal(byte[] var1, int var2) throws SQLException;

   byte NumberBytesToByte(byte[] var1, int var2) throws SQLException;

   byte[] ByteToNumberBytes(byte var1);

   short NumberBytesToShort(byte[] var1, int var2) throws SQLException;

   byte[] ShortToNumberBytes(short var1);

   int NumberBytesToInt(byte[] var1, int var2) throws SQLException;

   byte[] IntToNumberBytes(int var1);

   long NumberBytesToLong(byte[] var1, int var2) throws SQLException;

   byte[] LongToNumberBytes(long var1);

   float NumberBytesToFloat(byte[] var1, int var2);

   byte[] FloatToNumberBytes(float var1);

   double NumberBytesToDouble(byte[] var1, int var2);

   byte[] DoubleToNumberBytes(double var1) throws SQLException;

   byte[] BooleanToNumberBytes(boolean var1);

   boolean NumberBytesToBoolean(byte[] var1, int var2) throws SQLException;

   Date DateBytesToDate(byte[] var1, int var2);

   byte[] DateToDateBytes(Date var1);

   Time DateBytesToTime(byte[] var1, int var2);

   byte[] TimeToDateBytes(Time var1);

   Timestamp DateBytesToTimestamp(byte[] var1, int var2);

   byte[] TimestampToDateBytes(Timestamp var1);

   int requestLength(int var1, int var2);

   InputStream ConvertStream(InputStream var1, int var2);

   int CHARBytesToJavaChars(byte[] var1, int var2, char[] var3) throws SQLException;

   int JavaCharsToCHARBytes(char[] var1, int var2, byte[] var3) throws SQLException;

   int JavaCharsToAsciiBytes(char[] var1, int var2, byte[] var3);

   int JavaCharsToUnicodeBytes(char[] var1, int var2, byte[] var3);

   int RAWBytesToHexChars(byte[] var1, int var2, char[] var3);

   int UnicodeBytesToJavaChars(byte[] var1, int var2, char[] var3);

   int AsciiBytesToJavaChars(byte[] var1, int var2, char[] var3);
}
