package oracle.jdbc.dbaccess;

import java.sql.SQLException;

public class DBData {
   public DBItem[] items;

   public DBData(int row_num) {
      this.items = new DBItem[row_num];
   }

   public DBData(int row_num, DBType dbtype) {
      this.items = new DBItem[row_num];

      for(int row_index = 0; row_index < row_num; ++row_index) {
         this.items[row_index] = new DBItem(dbtype.max_length);
      }

   }

   public DBItem getItem(int rank) throws SQLException {
      if (rank >= 0 && rank < this.items.length) {
         return this.items[rank];
      } else {
         DBError.check_error(-46, "getItem");
         return null;
      }
   }
}
