package oracle.jdbc.dbaccess;

public class DBType {
   public int type;
   public int max_length;
   public boolean is_stream;
   public static final int CHAR = 96;
   public static final int VARCHAR = 1;
   public static final int LONG = 8;
   public static final int NUMBER = 2;
   public static final int VARNUM = 6;
   public static final int RAW = 23;
   public static final int LONG_RAW = 24;
   public static final int ROWID = 11;
   public static final int RESULT_SET = 102;
   public static final int DATE = 12;
   public static final int BLOB = 113;
   public static final int CLOB = 112;
   public static final int BFILE = 114;
   public static final int CFILE = 115;

   public void setFields(int type) {
      this.is_stream = false;
      switch (type) {
         case 1:
            this.max_length = 2000;
            break;
         case 2:
         case 6:
            this.max_length = 22;
            break;
         case 8:
            this.max_length = Integer.MAX_VALUE;
            this.is_stream = true;
            break;
         case 11:
            this.max_length = 128;
            break;
         case 12:
            this.max_length = 7;
            break;
         case 23:
            this.max_length = 255;
            break;
         case 24:
            this.max_length = Integer.MAX_VALUE;
            this.is_stream = true;
            break;
         case 96:
            this.max_length = 255;
            break;
         case 102:
            this.max_length = 0;
            break;
         case 112:
         case 113:
            this.max_length = 86;
            break;
         case 114:
         case 115:
            this.max_length = 530;
      }

   }

   public DBType(int type, int max_size, boolean is_stream) {
      this.type = type;
      this.setFields(type);
      if (!is_stream) {
         this.max_length = Math.min(max_size, this.max_length);
      } else {
         this.max_length = max_size;
      }

      this.is_stream = is_stream;
   }

   public DBType(int type) {
      this.type = type;
      this.setFields(type);
   }

   public DBType(int type, int max_size) {
      this.type = type;
      this.setFields(type);
      if (type == 102) {
         this.max_length = max_size;
      } else {
         this.max_length = Math.min(max_size, this.max_length);
      }

   }

   public DBType() {
      this.type = 0;
      this.max_length = 0;
   }
}
