package oracle.jdbc.oci7;

import java.sql.DriverManager;
import java.sql.SQLException;

public class OCIDBException extends SQLException {
   private String SQLState;
   private int vendorCode;
   private OCIDBException next;

   public OCIDBException(String reason, String SQLState, int vendorCode) {
      super(reason);
      this.SQLState = SQLState;
      this.vendorCode = vendorCode;
      if (DriverManager.getLogStream() != null) {
         DriverManager.println("SQLException: SQLState(" + SQLState + ") vendor code(" + vendorCode + ")");
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
      }

   }

   public OCIDBException(String reason, String SQLState) {
      super(reason);
      this.SQLState = SQLState;
      this.vendorCode = 0;
      if (DriverManager.getLogStream() != null) {
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
         DriverManager.println("SQLException: SQLState(" + SQLState + ")");
      }

   }

   public OCIDBException(String reason) {
      super(reason);
      this.SQLState = null;
      this.vendorCode = 0;
      if (DriverManager.getLogStream() != null) {
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
      }

   }

   public OCIDBException() {
      this.SQLState = null;
      this.vendorCode = 0;
      if (DriverManager.getLogStream() != null) {
         ((Throwable)this).printStackTrace(DriverManager.getLogStream());
      }

   }

   public String getSQLState() {
      return this.SQLState;
   }

   public int getErrorCode() {
      return this.vendorCode;
   }

   public SQLException getNextException() {
      return this.next;
   }

   public synchronized void setNextException(OCIDBException ex) {
      OCIDBException theEnd;
      for(theEnd = this; theEnd.next != null; theEnd = theEnd.next) {
      }

      theEnd.next = ex;
   }
}
