package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBData;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.dbaccess.DBType;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class Oall7 extends TTIfun {
   private final boolean DEBUG = false;
   private boolean plsql = false;
   private DBType[] bindTypes;
   private byte[] bindArgs;
   TTIrxd rxd;
   public static final int PARSE = 1;
   public static final int BIND = 8;
   public static final int DEFINE = 16;
   public static final int EXECUTE = 32;
   public static final int FETCH = 64;
   public static final int CANCEL = 128;
   public static final int COMMIT = 256;
   public static final int EXACTFE = 512;
   public static final int SNDIOV = 1024;
   public static final int NOPLSQL = 32768;
   public int rowsProcessed;
   boolean streamingOn = false;
   private final int OACSIZE = 23;
   private long options;
   private int cursor;
   private byte[] sqlStmt = new byte[0];
   private byte[] dbLink = new byte[0];
   private long[] inVector = new long[0];
   private long[] outVector = new long[0];
   private boolean outVecO2U = false;
   private int outVecRet;
   private boolean outVecRetO2U = false;
   private DBType[] inTypes;
   private DBData[] inValues;
   private DBType[] outTypes;
   private DBData[] outValues;
   private int inDepth;
   private int outDepth;
   private final int metaDataSize = 64;
   private int ptrDataSize;

   public Oall7(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv, long options, int cursor, byte[] sqlStmt, DBType[] inTypes, DBData[] inValues, int inDepth, DBType[] outTypes, DBData[] outValues, int outDepth) throws IOException, SQLException {
      super(types, sqlnet, conv);
      if (sqlStmt == null) {
         DBError.check_error((short)203);
      }

      this.inTypes = inTypes != null ? inTypes : new DBType[0];
      this.outTypes = outTypes != null ? outTypes : new DBType[0];
      this.inValues = inValues != null ? inValues : new DBData[0];
      this.outValues = outValues != null ? outValues : new DBData[0];
      this.inDepth = this.inValues.length == 0 ? 0 : inDepth;
      this.outDepth = this.outValues.length == 0 ? 0 : outDepth;
      this.options = options;
      if ((options & 1024L) > 0L) {
         this.plsql = true;
         this.bindTypes = this.createBindTypesArray();
      }

      this.cursor = cursor;
      this.sqlStmt = sqlStmt;
      super.ttcCode = 3;
      super.funCode = 71;
      this.inVector = new long[7];
      this.inVector[0] = 1L;
      if (outDepth == 0 && (options & 32L) > 0L && (options & 64L) == 0L) {
         this.inVector[1] = 1L;
      } else {
         this.inVector[1] = (long)outDepth;
      }

      this.outVecO2U = true;
      this.outVecRetO2U = false;
      this.outVector = new long[2];
      super.seqNumber = 0;
      int itemsBytes = 0;
      this.ptrDataSize = sqlStmt.length + this.dbLink.length + this.inVector.length + this.outVector.length + this.inTypes.length * 23 + this.outTypes.length * 23 + itemsBytes + 200;
      ((TTIMsg)this).initBuffers(66, this.ptrDataSize);
      this.marshal();
   }

   private DBType[] createBindTypesArray() throws SQLException {
      boolean inOutBinds = false;
      boolean inBinds = false;
      boolean outBinds = false;
      int numBinds = 0;
      if (this.inTypes.length > 0) {
         numBinds = this.inTypes.length;
      }

      if (this.outTypes.length > 0 && this.outTypes.length > numBinds) {
         numBinds = this.outTypes.length;
      }

      DBType[] bindTypes = new DBType[numBinds];
      this.bindArgs = new byte[numBinds];

      for(int i = 0; i < numBinds; ++i) {
         this.bindArgs[i] = 0;
         if (i < this.inTypes.length && this.inTypes[i] == null && i < this.outTypes.length && this.outTypes[i] == null) {
            DBError.check_error((short)207);
         }

         if (i < this.outTypes.length && this.outTypes[i] != null) {
            if (this.outValues == null || this.outValues[i] == null) {
               DBError.check_error((short)207);
            }

            byte[] var10000 = this.bindArgs;
            var10000[i] = (byte)(var10000[i] | 16);
            bindTypes[i] = this.outTypes[i];
         }

         if (i < this.inTypes.length && this.inTypes[i] != null) {
            if (this.inValues[i] == null) {
               DBError.check_error((short)207);
            }

            byte[] var7 = this.bindArgs;
            var7[i] = (byte)(var7[i] | 32);
            if (bindTypes[i] == null) {
               bindTypes[i] = this.inTypes[i];
            }
         }
      }

      return bindTypes;
   }

   public void receive() throws SQLException, IOException {
      boolean rpaProcessed = false;
      boolean rxhProcessed = false;
      boolean iovProcessed = false;
      this.rowsProcessed = 0;

      while(true) {
         byte code = ((TTIMsg)this).unmarshalSB1();
         switch (code) {
            case 4:
               TTIoer oer = new TTIoer(super.types, super.sqlnet, super.conv);
               oer.unmarshal();
               this.rowsProcessed = oer.getCurRowNumber();
               if (oer.getRetCode() != 1403) {
                  oer.processError();
               }

               return;
            case 6:
               if (rxhProcessed) {
                  DBError.check_error((short)20);
               }

               TTIrxh rxh = new TTIrxh(super.types, super.sqlnet, super.conv);
               rxh.unmarshal();
               if (rxh.uacBufLength > 0) {
                  DBError.check_error((short)40);
               }

               rxhProcessed = true;
               break;
            case 7:
               if (!rxhProcessed && !iovProcessed) {
                  DBError.check_error((short)1);
               }

               if (!this.rxd.unmarshal()) {
                  this.streamingOn = true;
                  return;
               }
               break;
            case 8:
               if (rpaProcessed) {
                  DBError.check_error((short)1);
               }

               this.outVecRet = ((TTIMsg)this).unmarshalUB2();

               for(int i = 0; i < this.outVecRet; ++i) {
                  this.outVector[i] = ((TTIMsg)this).unmarshalUB4();
               }

               rpaProcessed = true;
               break;
            case 11:
               TTIiov iov = new TTIiov(super.types, super.sqlnet, super.conv);
               iov.unmarshal();
               iov.validateBinds(this.bindArgs);
               iov.processRXD(this.inTypes, this.inValues, this.inDepth);
               iovProcessed = true;
               break;
            default:
               DBError.check_error((short)1);
         }
      }
   }

   private int getItemsValueLength(DBData[] data, int depth) {
      int bytes = 0;
      if (data != null && depth >= 1) {
         for(int i = 0; i < data.length; ++i) {
            for(int j = 0; j < depth; ++j) {
               bytes += data[i].items[j].data_size;
               ++bytes;
            }

            ++bytes;
         }

         return bytes;
      } else {
         return bytes;
      }
   }

   private void marshal() throws IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB1((short)super.funCode, false);
      ((TTIMsg)this).marshalUB1((short)super.seqNumber, false);
      ((TTIMsg)this).marshalUB4(this.options, false);
      ((TTIMsg)this).marshalSWORD(this.cursor, false);
      ((TTIMsg)this).marshalB1Array(this.sqlStmt, true);
      ((TTIMsg)this).marshalSB4(this.sqlStmt.length, false);
      ((TTIMsg)this).marshalB1Array(this.dbLink, true);
      ((TTIMsg)this).marshalSB4(this.dbLink.length, false);
      ((TTIMsg)this).marshalUB4Array(this.inVector, true);
      ((TTIMsg)this).marshalSB4(this.inVector.length, false);
      ((TTIMsg)this).marshalO2U(this.outVecO2U);
      ((TTIMsg)this).marshalSB4(this.outVecO2U ? this.outVector.length : 0, false);
      ((TTIMsg)this).marshalO2U(this.outVecRetO2U);
      if (this.plsql) {
         ((TTIMsg)this).marshalOACArray(new DBType[0], true);
         ((TTIMsg)this).marshalSWORD(0, false);
         ((TTIMsg)this).marshalOACArray(this.bindTypes, true);
         ((TTIMsg)this).marshalSWORD(this.bindTypes.length, false);
      } else {
         ((TTIMsg)this).marshalOACArray(this.outTypes, true);
         ((TTIMsg)this).marshalSWORD(this.outTypes.length, false);
         ((TTIMsg)this).marshalOACArray(this.inTypes, true);
         ((TTIMsg)this).marshalSWORD(this.inTypes.length, false);
      }

      ((TTIMsg)this).send();
      this.rxd = new TTIrxd(super.types, super.sqlnet, super.conv, this.inTypes, this.inValues, this.inDepth, this.outTypes, this.outValues, this.outDepth);
      if (!this.plsql) {
         this.rxd.marshal();
      }

   }

   public boolean getColumnsUptoNextSream() throws SQLException, IOException {
      this.streamingOn = false;
      if (!this.rxd.unmarshal()) {
         this.streamingOn = true;
      } else {
         this.receive();
      }

      return this.streamingOn;
   }
}
