package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBColumn;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class Odscrarr extends TTIfun {
   private static final boolean DEBUG = false;
   private int cursor_id;
   private int startpos = 1;
   public static final int HSTITEMS = 32;
   public static final int M_IDEN = 30;
   public static final int NBL = 960;
   public int totalColumns;
   public int numuds;
   private TTIuds[] uds;
   private String[] colnames;
   private int totalretlen;
   private int colOffset;
   private boolean numitemsO2U = false;
   private boolean udsarrayO2U = false;
   private boolean numudsO2U = false;
   private boolean colnameO2U = false;
   private boolean lencolsO2U = false;
   private final int metaDataSize = 40;
   private final int ptrDataSize = 4;

   public Odscrarr(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv, TTCStatement stmt, int offset) throws IOException, SQLException {
      super(types, sqlnet, conv);
      this.cursor_id = stmt.getCursor();
      this.colOffset = offset;
      super.ttcCode = 3;
      super.funCode = 43;
      super.seqNumber = 0;
      this.numitemsO2U = true;
      this.udsarrayO2U = true;
      this.numudsO2U = true;
      this.colnameO2U = true;
      this.lencolsO2U = true;
      ((TTIMsg)this).initBuffers(42, 4);
      this.marshal();
   }

   public DBColumn[] receive(DBColumn[] dbcols) throws SQLException, IOException {
      boolean descinfo_read = false;

      while(!descinfo_read) {
         byte code = ((TTIMsg)this).unmarshalSB1();
         switch (code) {
            case 4:
               TTIoer oer = new TTIoer(super.types, super.sqlnet, super.conv);
               oer.unmarshal();
               oer.processError();
               descinfo_read = true;
            case 9:
               descinfo_read = true;
               break;
            case 8:
               this.totalColumns = ((TTIMsg)this).unmarshalUB2();
               this.numuds = ((TTIMsg)this).unmarshalUB2();
               this.uds = new TTIuds[this.totalColumns];
               if (dbcols == null) {
                  dbcols = new DBColumn[this.totalColumns];
               }

               for(int i = 0; i < this.numuds; ++i) {
                  this.uds[i] = new TTIuds(super.types, super.sqlnet, super.conv);
                  this.uds[i].unmarshal();
               }

               this.totalretlen = ((TTIMsg)this).unmarshalUB2();
               if (this.totalretlen > 960) {
                  DBError.check_error((short)107);
               }

               byte[] encodedColnames = ((TTIMsg)this).unmarshalNBytes(this.totalretlen);
               this.decodeColnames(encodedColnames);
               this.fillupDBcols(dbcols);
         }
      }

      return dbcols;
   }

   private void decodeColnames(byte[] encodedstr) throws SQLException {
      this.colnames = new String[this.numuds];
      int j = 0;

      for(int i = 0; i < this.numuds; ++i) {
         int col_len = 0;

         byte[] colnameInbytes;
         for(colnameInbytes = new byte[this.uds[i].udscnl]; col_len != this.uds[i].udscnl; colnameInbytes[col_len++] = encodedstr[j++]) {
            if ((char)encodedstr[j] == '\'') {
               ++j;
            }
         }

         ++j;
         this.colnames[i] = super.conv.CharBytesToString(colnameInbytes, this.uds[i].udscnl);
         byte[] var6 = null;
      }

   }

   public void fillupDBcols(DBColumn[] dbcols) {
      for(int i = 0; i < this.numuds; ++i) {
         dbcols[this.colOffset + i] = new DBColumn(this.colnames[i], this.uds[i].udsnull, this.uds[i].udsoac.oacdty, this.uds[i].udsoac.oacflg, this.uds[i].udsoac.oacpre, this.uds[i].udsoac.oacscl, this.uds[i].udsoac.oacmxl, this.uds[i].udsoac.oacmal, this.uds[i].udsoac.oacfl2);
      }

   }

   private void marshal() throws IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB1((short)super.funCode, false);
      ((TTIMsg)this).marshalUB1((short)super.seqNumber, false);
      ((TTIMsg)this).marshalSWORD(this.cursor_id, false);
      ((TTIMsg)this).marshalSWORD(this.colOffset + this.startpos, false);
      ((TTIMsg)this).marshalO2U(this.numitemsO2U);
      ((TTIMsg)this).marshalO2U(this.udsarrayO2U);
      ((TTIMsg)this).marshalSWORD(32, false);
      ((TTIMsg)this).marshalO2U(this.numudsO2U);
      ((TTIMsg)this).marshalO2U(this.colnameO2U);
      ((TTIMsg)this).marshalSWORD(960, false);
      ((TTIMsg)this).marshalO2U(this.lencolsO2U);
   }
}
