package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class Oopen extends TTIfun {
   private static final boolean DEBUG = false;
   private boolean cidO2U = false;
   private int cid;
   private long opesiz;
   private final int metaDataSize = 6;
   private final int ptrDataSize = 4;

   public Oopen(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) throws IOException, SQLException {
      super(types, sqlnet, conv);
      super.ttcCode = 3;
      super.funCode = 2;
      super.seqNumber = 0;
      this.cidO2U = true;
      ((TTIMsg)this).initBuffers(8, 4);
      this.marshal();
   }

   public int receive() throws SQLException, IOException {
      boolean read_completed = false;

      while(!read_completed) {
         byte code = ((TTIMsg)this).unmarshalSB1();
         switch (code) {
            case 4:
               TTIoer oer = new TTIoer(super.types, super.sqlnet, super.conv);
               oer.unmarshal();
               oer.processError();
               read_completed = true;
               break;
            case 8:
               this.cid = ((TTIMsg)this).unmarshalSWORD();
               break;
            case 9:
               read_completed = true;
         }
      }

      return this.cid;
   }

   private void marshal() throws IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB1((short)super.funCode, false);
      ((TTIMsg)this).marshalUB1((short)super.seqNumber, false);
      ((TTIMsg)this).marshalO2U(this.cidO2U);
      ((TTIMsg)this).marshalUWORD(this.opesiz, false);
   }
}
