package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class Oversion extends TTIfun {
   private final boolean DEBUG = false;
   private byte[] rdbmsVersion = new byte[]{78, 111, 116, 32, 100, 101, 116, 101, 114, 109, 105, 110, 101, 100, 32, 121, 101, 116};
   private boolean rdbmsVersionO2U = false;
   private int bufLen = 256;
   private boolean retVerLenO2U = false;
   private int retVerLen;
   private boolean retVerNumO2U = false;
   private long retVerNum;
   private final int metaDataSize = 10;
   private final int ptrDataSize;

   public Oversion(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) throws IOException, SQLException {
      super(types, sqlnet, conv);
      super.ttcCode = 3;
      super.funCode = 59;
      super.seqNumber = 0;
      ((TTIMsg)this).initBuffers(12, 0);
      this.rdbmsVersionO2U = true;
      this.retVerLenO2U = true;
      this.retVerNumO2U = true;
      this.marshal();
   }

   public void receive() throws SQLException, IOException {
      boolean rpaProcessed = false;

      while(true) {
         byte code = ((TTIMsg)this).unmarshalSB1();
         switch (code) {
            case 4:
               TTIoer oer = new TTIoer(super.types, super.sqlnet, super.conv);
               oer.unmarshal();
               oer.processError();
               return;
            case 8:
               if (rpaProcessed) {
                  DBError.check_error((short)1);
               }

               this.retVerLen = ((TTIMsg)this).unmarshalUB2();
               this.rdbmsVersion = ((TTIMsg)this).unmarshalNBytes(this.retVerLen);
               this.retVerNum = ((TTIMsg)this).unmarshalUB4();
               rpaProcessed = true;
               break;
            case 9:
               return;
            default:
               DBError.check_error((short)1);
         }
      }
   }

   public byte[] getVersion() {
      return this.rdbmsVersion;
   }

   public long getVersionNumber() {
      return this.retVerNum;
   }

   private void marshal() throws IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB1((short)super.funCode, false);
      ((TTIMsg)this).marshalUB1((short)super.seqNumber, false);
      ((TTIMsg)this).marshalO2U(this.rdbmsVersionO2U);
      ((TTIMsg)this).marshalSWORD(this.bufLen, false);
      ((TTIMsg)this).marshalO2U(this.retVerLenO2U);
      ((TTIMsg)this).marshalO2U(this.retVerNumO2U);
   }
}
