package oracle.jdbc.ttc7;

import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;

public class TTCTypeRep {
   public static final byte NATIVE = 0;
   public static final byte UNIVERSAL = 1;
   public static final byte LSB = 2;
   public static final byte MAXREP = 3;
   // $FF: renamed from: B1 byte
   public static final byte field_0 = 0;
   // $FF: renamed from: B2 byte
   public static final byte field_1 = 1;
   // $FF: renamed from: B4 byte
   public static final byte field_2 = 2;
   public static final byte PTR = 3;
   public static final byte MAXTYPE = 3;
   public byte[] rep = new byte[4];
   private final byte NUMREPS = 4;

   public TTCTypeRep() {
      this.rep[0] = 0;

      for(int i = 1; i < 4; ++i) {
         this.rep[i] = 1;
      }

   }

   public void setRep(byte type, byte rep) throws SQLException {
      if (type < 0 || type > 3 || rep > 3) {
         DBError.check_error((short)100);
      }

      this.rep[type] = rep;
   }

   public byte getRep(byte type) throws SQLException {
      if (type < 0 || type > 3) {
         DBError.check_error((short)101);
      }

      return this.rep[type];
   }
}
