package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class TTIdty extends TTIMsg {
   private final boolean DEBUG = false;
   private final boolean DEBUG2 = false;
   private short cliRIN = 1;
   private short cliROUT = 1;
   private byte cliFlags;
   private final int NUMTYPES = 107;
   private final int metaDataSize = 433;
   private byte[] typeReps = new byte[]{1, 1, 1, 0, 2, 2, 10, 0, 8, 8, 1, 0, 12, 12, 10, 0, 23, 23, 1, 0, 24, 24, 1, 0, 25, 25, 1, 0, 26, 26, 1, 0, 27, 27, 1, 0, 28, 28, 1, 0, 29, 29, 1, 0, 30, 30, 1, 0, 31, 31, 1, 0, 32, 32, 1, 0, 33, 33, 1, 0, 10, 10, 1, 0, 11, 11, 1, 0, 34, 34, 1, 0, 35, 35, 1, 0, 36, 36, 1, 0, 37, 37, 1, 0, 38, 38, 1, 0, 40, 40, 1, 0, 41, 41, 1, 0, 42, 42, 1, 0, 43, 43, 1, 0, 44, 44, 1, 0, 45, 45, 1, 0, 46, 46, 1, 0, 47, 47, 1, 0, 48, 48, 1, 0, 49, 49, 1, 0, 50, 50, 1, 0, 51, 51, 1, 0, 52, 52, 1, 0, 53, 53, 1, 0, 54, 54, 1, 0, 55, 55, 1, 0, 56, 56, 1, 0, 57, 57, 1, 0, 58, 58, 1, 0, 59, 59, 1, 0, 60, 60, 1, 0, 61, 61, 1, 0, 62, 62, 1, 0, 63, 63, 1, 0, 64, 64, 1, 0, 65, 65, 1, 0, 66, 66, 1, 0, 67, 67, 1, 0, 71, 71, 1, 0, 72, 72, 1, 0, 73, 73, 1, 0, 75, 75, 1, 0, 77, 77, 1, 0, 78, 78, 1, 0, 79, 79, 1, 0, 80, 80, 1, 0, 81, 81, 1, 0, 82, 82, 1, 0, 83, 83, 1, 0, 84, 84, 1, 0, 85, 85, 1, 0, 86, 86, 1, 0, 87, 87, 1, 0, 89, 89, 1, 0, 90, 90, 1, 0, 92, 92, 1, 0, 93, 93, 1, 0, 98, 98, 1, 0, 99, 99, 1, 0, 103, 103, 1, 0, 3, 2, 10, 0, 4, 2, 10, 0, 5, 1, 1, 0, 6, 2, 10, 0, 7, 2, 10, 0, 9, 1, 1, 0, 13, 0, 14, 0, 15, 23, 1, 0, 16, 0, 17, 0, 18, 0, 19, 0, 20, 0, 21, 0, 22, 0, 39, 93, 1, 0, 68, 2, 10, 0, 69, 0, 70, 0, 74, 0, 76, 0, 88, 0, 91, 2, 10, 0, 94, 1, 1, 0, 95, 23, 1, 0, 96, 96, 1, 0, 97, 96, 1, 0, 100, 0, 101, 0, 102, 102, 1, 0, 104, 0, 105, 0, 106, 106, 1, 0, 107, 0, 0};

   public TTIdty(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv, short charSet, byte flags) throws SQLException, IOException {
      super(types, sqlnet, conv);
      ((TTIMsg)this).initBuffers(433, 0);
      super.ttcCode = 2;
      this.cliRIN = this.cliROUT = charSet;
      this.cliFlags = flags;
      this.marshal();
   }

   public void receive() throws SQLException, IOException {
      if (((TTIMsg)this).unmarshalSB1() != 2) {
         DBError.check_error((short)1);
      }

      if (!this.validTypeReps()) {
         DBError.check_error((short)104);
      }

      this.setBasicTypes(super.types);
   }

   private boolean validTypeReps() throws SQLException, IOException {
      int i = 0;
      boolean type = true;
      boolean pair = false;
      int pairCount = 0;
      int zerosCount = 0;

      do {
         byte b = (byte)((TTIMsg)this).unmarshalUB1();
         zerosCount = b == 0 ? zerosCount + 1 : 0;
         ++i;
      } while(zerosCount < 2);

      return true;
   }

   private void setBasicTypes(TTCTypeRep types) throws SQLException {
      types.setRep((byte)0, (byte)0);
      types.setRep((byte)1, (byte)1);
      types.setRep((byte)2, (byte)1);
      types.setRep((byte)3, (byte)1);
   }

   private void marshal() throws SQLException, IOException {
      ((TTIMsg)this).marshalUB1((short)super.ttcCode, false);
      ((TTIMsg)this).marshalUB2(this.cliRIN, false);
      ((TTIMsg)this).marshalUB2(this.cliROUT, false);
      ((TTIMsg)this).marshalUB1((short)this.cliFlags, false);
      ((TTIMsg)this).marshalB1Array(this.typeReps, false);
   }
}
