package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBData;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.dbaccess.DBType;
import oracle.jdbc.oracore.JavaConversion;
import oracle.sqlnet.SQLnet;

public class TTIiov extends TTIMsg {
   private final boolean DEBUG = false;
   protected TTIrxh rxh;
   protected TTIrxd rxd;
   protected TTCTypeRep types;
   protected SQLnet sqlnet;
   private byte bindtype;
   private byte[] iovector;
   private int bindcnt;
   private int inbinds;
   private int outbinds;
   public static final byte BV_IN_V = 32;
   public static final byte BV_OUT_V = 16;

   public TTIiov(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) {
      super(types, sqlnet, conv);
      this.types = types;
      this.sqlnet = sqlnet;
      this.rxh = new TTIrxh(types, sqlnet, conv);
      ((TTIMsg)this).initInBuffers();
   }

   public void validateBinds(byte[] bindArgs) throws SQLException, IOException {
      if (bindArgs == null) {
         if (this.iovector.length <= 0) {
            return;
         }

         ((TTIMsg)this).reset();
         DBError.check_error((short)209);
      }

      if (this.iovector.length != bindArgs.length) {
         ((TTIMsg)this).reset();
         DBError.check_error((short)209);
      }

      for(int i = 0; i < bindArgs.length; ++i) {
         if (bindArgs[i] != this.iovector[i]) {
            ((TTIMsg)this).reset();
            DBError.check_error((short)209);
         }
      }

   }

   public void processRXD(DBType[] inTypes, DBData[] inValues, int inDepth) throws IOException {
      if (this.inbinds > 0) {
         this.rxd = new TTIrxd(this.types, this.sqlnet, super.conv, inTypes, inValues, 1, new DBType[0], new DBData[0], 0);
         this.rxd.marshal();
      }

   }

   public void unmarshal() throws IOException, SQLException {
      this.rxh.unmarshal();
      this.bindcnt = this.rxh.numRqsts;
      this.iovector = new byte[this.bindcnt];

      for(int i = 0; i < this.bindcnt; ++i) {
         if ((this.bindtype = ((TTIMsg)this).unmarshalSB1()) == 0) {
            DBError.check_error((short)1);
         }

         if ((this.bindtype & 32) > 0) {
            byte[] var10000 = this.iovector;
            var10000[i] = (byte)(var10000[i] | 32);
            ++this.inbinds;
         }

         if ((this.bindtype & 16) > 0) {
            byte[] var2 = this.iovector;
            var2[i] = (byte)(var2[i] | 16);
            ++this.outbinds;
         }
      }

   }
}
