package oracle.jdbc.ttc7;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.oracore.JavaConversion;
import oracle.jdbc.util.RepConversion;
import oracle.sqlnet.SQLnet;

public class TTIrxh extends TTIMsg {
   private final boolean DEBUG = false;
   public short flags;
   public short numRqsts;
   public int iterNum;
   public int numItersThisTime;
   public int uacBufLength;
   private static final byte FU2O = 1;
   private static final byte FEOR = 2;
   private static final byte PLSV = 4;

   public TTIrxh(TTCTypeRep types, SQLnet sqlnet, JavaConversion conv) {
      super(types, sqlnet, conv);
      ((TTIMsg)this).initInBuffers();
   }

   public void unmarshal() throws SQLException, IOException {
      this.flags = ((TTIMsg)this).unmarshalUB1();
      this.numRqsts = ((TTIMsg)this).unmarshalUB1();
      this.iterNum = ((TTIMsg)this).unmarshalUB2();
      this.numItersThisTime = ((TTIMsg)this).unmarshalUB2();
      this.uacBufLength = ((TTIMsg)this).unmarshalUB2();
   }

   public void print() {
      System.out.println("-------- RXH attribute information ------- ");
      System.out.println("  Flags                   0x:" + new String(RepConversion.toHex(this.flags), 0));
      if ((this.flags & 1) == 1) {
         System.out.println("       UserToOracle Function  ");
      }

      if ((this.flags & 2) == 2) {
         System.out.println("       This is the End of Row");
      }

      if ((this.flags & 4) == 4) {
         System.out.println("       Vector for PLSQL vars is following");
      }

      System.out.println("  Flags                     :" + this.flags);
      System.out.println("  Number of Requests        :" + this.numRqsts);
      System.out.println("  Iteration Number          :" + this.iterNum);
      System.out.println("  Num. Iterations this time :" + this.numItersThisTime);
      System.out.println("  UAC bufffer length        :" + this.uacBufLength);
   }
}
