package oracle.jdbc.util;

public class TokenizedString {
   private int MAXNUMELEMENTS = 256;
   private final int MAXELEMENTLENGTH = 256;
   private char token;
   private String str;
   private String[] elements;
   private int numElements;
   private int[] tokenArray;
   private int tokenCount;

   public TokenizedString(char token, String str) {
      this.elements = new String[this.MAXNUMELEMENTS];
      this.tokenArray = new int[this.MAXNUMELEMENTS];
      this.token = token;
      this.str = str;
      this.splitString();
   }

   private void splitString() {
      char[] buf = new char[256];
      int strLen = this.str.length();
      int elementOffset = 0;

      for(int i = 0; i < strLen; ++i) {
         if (this.str.charAt(i) == this.token) {
            this.tokenArray[this.tokenCount++] = i;
            this.elements[this.numElements++] = new String(buf, 0, elementOffset);
            elementOffset = 0;
         } else {
            buf[elementOffset++] = this.str.charAt(i);
         }
      }

      if (this.tokenArray[this.tokenCount] < strLen) {
         this.elements[this.numElements++] = new String(buf, 0, elementOffset);
      }

   }

   public String getElement(int element) {
      return element > this.MAXNUMELEMENTS ? null : this.elements[element];
   }

   public int getNumElements() {
      return this.numElements;
   }

   public int getNumTokens() {
      return this.tokenCount;
   }

   public void printInfo() {
      System.out.println("String passed --> " + this.str);
      System.out.println("Token used is '" + this.token + "'");
      System.out.println("Number of tokens  :" + this.tokenCount);
      System.out.println("Number of elements:" + this.numElements);

      for(int i = 0; i < this.numElements; ++i) {
         System.out.println("Element " + i + " : " + this.elements[i]);
      }

   }
}
