package oracle.sqlnet;

public class NVNavigator {
   public NVPair findNVPairRecurse(NVPair nvp, String name) {
      if (nvp != null && !name.equalsIgnoreCase(nvp.getName())) {
         if (nvp.getRHSType() == NVPair.RHS_ATOM) {
            return null;
         } else {
            for(int i = 0; i < nvp.getListSize(); ++i) {
               NVPair child = this.findNVPairRecurse(nvp.getListElement(i), name);
               if (child != null) {
                  return child;
               }
            }

            return null;
         }
      } else {
         return nvp;
      }
   }

   public NVPair findNVPair(NVPair nvp, String name) {
      if (nvp != null && nvp.getRHSType() == NVPair.RHS_LIST) {
         for(int i = 0; i < nvp.getListSize(); ++i) {
            NVPair child = nvp.getListElement(i);
            if (name.equalsIgnoreCase(child.getName())) {
               return child;
            }
         }

         return null;
      } else {
         return null;
      }
   }

   public NVPair findNVPair(NVPair nvp, String[] names) {
      NVPair current = nvp;

      for(int i = 0; i < names.length; ++i) {
         current = this.findNVPair(current, names[i]);
         if (current == null) {
            return null;
         }
      }

      return current;
   }
}
