package oracle.sqlnet;

import java.io.IOException;

public class SQLnetBufferedInputStream implements SQLnetDef {
   // $FF: renamed from: in oracle.sqlnet.SQLnetInputStream
   protected SQLnetInputStream field_0;
   protected SQLnetBufferedOutputStream bout;
   protected byte[] buf;
   protected int count;
   protected int pos;

   public SQLnetBufferedInputStream(SQLnetInputStream in, SQLnetBufferedOutputStream bout, int size) {
      this.field_0 = in;
      this.bout = bout;
      this.buf = new byte[size];
      this.pos = 10;
   }

   private void fill() throws IOException {
      if (this.bout.count > 10) {
         this.bout.flush();
      }

      int n = this.field_0.read(this.buf, this.buf.length);
      this.count = n <= 0 ? 0 : n;
      this.pos = 10;
   }

   public synchronized int read() throws IOException {
      byte[] temp = new byte[1];
      return this.read(temp) < 0 ? -1 : temp[0] & 255;
   }

   public synchronized int read(byte[] b) throws IOException {
      return this.read(b, 0, b.length);
   }

   public synchronized int read(byte[] b, int off, int len) throws IOException {
      int avail = this.count - this.pos;
      if (avail <= 0) {
         this.fill();
         avail = this.count - this.pos;
         if (avail <= 0) {
            return -1;
         }
      }

      int cnt = avail < len ? avail : len;
      System.arraycopy(this.buf, this.pos, b, off, cnt);
      this.pos += cnt;
      return cnt;
   }

   public synchronized int available() throws IOException {
      return this.count - this.pos + this.field_0.available();
   }
}
