package oracle.sqlnet;

import java.io.IOException;

public class SQLnetPacket implements SQLnetDef {
   private byte[] packet;

   SQLnetPacket(byte[] packet) {
      this.packet = packet;
   }

   public void setPacket(byte[] packet) {
      this.packet = packet;
   }

   public int getType() {
      return this.packet[4];
   }

   public int getSduSize() {
      int sduSize = this.packet[12] & 255;
      sduSize <<= 8;
      sduSize |= this.packet[13] & 255;
      return sduSize;
   }

   public int getTduSize() {
      int tduSize = this.packet[12] & 255;
      tduSize <<= 8;
      tduSize |= this.packet[13] & 255;
      return tduSize;
   }

   public String getDataString(SQLnetInputStream in) throws IOException {
      int dataLen = 0;
      int dataOff = 0;
      switch (this.getType()) {
         case 2:
            dataOff = this.packet[20] & 255;
            dataOff <<= 8;
            dataOff |= this.packet[21] & 255;
            dataLen = this.packet[18] & 255;
            dataLen <<= 8;
            dataLen |= this.packet[19] & 255;
         case 3:
         default:
            break;
         case 4:
            dataOff = this.packet[12] & 255;
            dataOff = 12;
            dataOff |= this.packet[13] & 255;
            dataLen = this.packet[10] & 255;
            dataLen <<= 8;
            dataLen |= this.packet[11] & 255;
            break;
         case 5:
            dataOff = 10;
            dataLen = this.packet[8] & 255;
            dataLen <<= 8;
            dataLen |= this.packet[9] & 255;
      }

      if (dataLen <= 0) {
         return new String();
      } else {
         int pakLen = this.packet[0] & 255;
         pakLen <<= 8;
         pakLen |= this.packet[1] & 255;
         if (pakLen > dataOff) {
            return new String(this.packet, 0, dataOff, dataLen);
         } else {
            byte[] b = new byte[dataLen];
            in.readConnectData(b);
            return new String(b, 0, 0, b.length);
         }
      }
   }

   public byte markerData() {
      return this.packet[10];
   }
}
